// ============================================================================
// Name:        class.i
// Version:     2.8.12.34
// Purpose:     Prototypes of wxWidgets classes for wxBasic.
// Author:      Ralf Peters, David Cuny
//
// TODO:
// %enum - %endenum
// %if: wxMedia..., wxPower..., wxDataView, wxEVT_HOTKEY, wxWave
// NativeFormat in wxDataFormat under GTK
// ============================================================================
// Ralf Peters 2012-02/03: updated for UNICODE
// Ralf Peters 2012-09: updated for x64

%{
//'wx' prefix causes scanner to think it's a pointer
// typedef'ing it fixes that
typedef wxCoord coord;

// For cases where it's really a unsigned char*, so the scanner
// doesn't think it's a string
typedef unsigned char uchar;
%}

// String constants
%str wxALL_FILES_PATTERN
%str wxALL_FILES

// Put this stuff in order...

%num wxNOT_FOUND

%num wxBIG_ENDIAN
%num wxLITTLE_ENDIAN
%num wxPDP_ENDIAN
%num wxBYTE_ORDER

//%num wxED_CLIENT_MARGIN
//%num wxED_BUTTONS_BOTTOM
//%num wxED_BUTTONS_RIGHT
//%num wxED_STATIC_LINE
//%num wxEXT_DIALOG_STYLE

%num wxTB_3DBUTTONS

%num wxTB_FLAT
%num wxTB_DOCKABLE
%num wxTB_HORIZONTAL
%num wxTB_VERTICAL
%num wxTB_TEXT
%num wxTB_NOICONS
%num wxTB_NODIVIDER
%num wxTB_NOALIGN
%num wxTB_HORZ_LAYOUT
%num wxTB_HORZ_TEXT
%num wxTB_NO_TOOLTIPS
%num wxTB_BOTTOM
%num wxTB_RIGHT

b%num wxMB_DOCKABLE
%num wxMENU_TEAROFF
%num wxCOLOURED
%num wxFIXED_LENGTH
%num wxLB_SORT
%num wxLB_SINGLE
%num wxLB_MULTIPLE
%num wxLB_EXTENDED
%num wxLB_OWNERDRAW
%num wxLB_NEEDED_SB
%num wxLB_ALWAYS_SB
%num wxLB_HSCROLL
%num wxLB_INT_HEIGHT

%num wxPROCESS_ENTER
%num wxPASSWORD

%num wxCB_SIMPLE
%num wxCB_SORT
%num wxCB_READONLY
%num wxCB_DROPDOWN

%num wxRA_LEFTTORIGHT
%num wxRA_TOPTOBOTTOM
%num wxRA_SPECIFY_COLS
%num wxRA_SPECIFY_ROWS
%num wxRA_HORIZONTAL
%num wxRA_VERTICAL
%num wxRA_USE_CHECKBOX

%num wxRB_GROUP
%num wxRB_SINGLE
%num wxRB_USE_CHECKBOX

%num wxGA_HORIZONTAL
%num wxGA_VERTICAL
%num wxGA_PROGRESSBAR
%num wxGA_SMOOTH
%num wxSL_HORIZONTAL
%num wxSL_VERTICAL
%num wxSL_NOTIFY_DRAG
%num wxSL_AUTOTICKS
%num wxSL_LABELS
%num wxSL_LEFT
%num wxSL_TOP
%num wxSL_RIGHT
%num wxSL_BOTTOM
%num wxSL_BOTH
%num wxSL_SELRANGE

%num wxSB_HORIZONTAL
%num wxSB_VERTICAL

%num wxBU_AUTODRAW
%num wxBU_NOAUTODRAW
%num wxBU_LEFT
%num wxBU_TOP
%num wxBU_RIGHT
%num wxBU_BOTTOM

%num wxTR_EDIT_LABELS
%num wxTR_NO_BUTTONS
%num wxTR_HAS_BUTTONS
%num wxTR_NO_LINES
%num wxTR_FULL_ROW_HIGHLIGHT
%num wxTR_LINES_AT_ROOT
%num wxTR_HIDE_ROOT
%num wxTR_ROW_LINES
%num wxTR_HAS_VARIABLE_ROW_HEIGHT
%num wxTR_SINGLE
%num wxTR_MULTIPLE
%num wxTR_EXTENDED
%num wxTR_DEFAULT_STYLE

%num wxLC_VRULES
%num wxLC_HRULES
%num wxLC_ICON
%num wxLC_SMALL_ICON
%num wxLC_LIST
%num wxLC_REPORT
%num wxLC_ALIGN_TOP
%num wxLC_ALIGN_LEFT
%num wxLC_AUTOARRANGE
%num wxLC_USER_TEXT
%num wxLC_EDIT_LABELS
%num wxLC_NO_HEADER
%num wxLC_NO_SORT_HEADER
%num wxLC_SINGLE_SEL
%num wxLC_SORT_ASCENDING
%num wxLC_SORT_DESCENDING
%num wxLC_MASK_TYPE
%num wxLC_MASK_ALIGN
%num wxLC_MASK_SORT

%num wxSP_HORIZONTAL
%num wxSP_VERTICAL
%num wxSP_ARROW_KEYS
%num wxSP_WRAP

%num wxSP_NOBORDER
%num wxSP_NOSASH
%num wxSP_PERMIT_UNSPLIT
%num wxSP_LIVE_UPDATE
%num wxSP_3DSASH
%num wxSP_3DBORDER
%num wxSP_NO_XP_THEME
%num wxSP_BORDER
%num wxSP_3D
%num wxSP_SASH_AQUA
%num wxSP_FULLSASH

%num wxTC_RIGHTJUSTIFY
%num wxTC_FIXEDWIDTH
%num wxTC_TOP
%num wxTC_LEFT
%num wxTC_RIGHT
&num wxTC_BOTTOM
%num wxTC_MULTILINE
%num wxTC_OWNERDRAW

%num wxNB_TOP
%num wxNB_LEFT
%num wxNB_RIGHT
%num wxNB_BOTTOM
%num wxNB_FIXEDWIDTH
%num wxNB_MULTILINE
%num wxNB_NOPAGETHEME
%num wxNB_FLAT

%num wxST_SIZEGRIP
%num wxST_NO_AUTORESIZE
%num wxST_DOTS_MIDDLE
%num wxST_DOTS_END

%num wxBI_EXPAND

%num wxHW_SCROLLBAR_NEVER
%num wxHW_SCROLLBAR_AUTO
%num wxHW_NO_SELECTION
%num wxCAL_SUNDAY_FIRST
%num wxCAL_MONDAY_FIRST
%num wxCAL_SHOW_HOLIDAYS
%num wxCAL_NO_YEAR_CHANGE
%num wxCAL_NO_MONTH_CHANGE

// Standard menu events
%num wxID_NONE
%num wxID_SEPARATOR
%num wxID_ANY
%num wxID_LOWEST

%num wxID_OPEN
%num wxID_CLOSE
%num wxID_NEW
%num wxID_SAVE
%num wxID_SAVEAS
%num wxID_REVERT
%num wxID_EXIT
%num wxID_UNDO
%num wxID_REDO
%num wxID_HELP
%num wxID_PRINT
%num wxID_PRINT_SETUP
%num wxID_PAGE_SETUP
%num wxID_PREVIEW
%num wxID_ABOUT
%num wxID_HELP_CONTENTS
%num wxID_HELP_INDEX
%num wxID_HELP_SEARCH
%num wxID_HELP_COMMANDS
%num wxID_HELP_PROCEDURES
%num wxID_HELP_CONTEXT
%num wxID_CLOSE_ALL
%num wxID_PREFERENCES

%num wxID_EDIT
%num wxID_CUT
%num wxID_COPY
%num wxID_PASTE
%num wxID_CLEAR
%num wxID_FIND
%num wxID_DUPLICATE
%num wxID_SELECTALL
%num wxID_DELETE
%num wxID_REPLACE
%num wxID_REPLACE_ALL
%num wxID_PROPERTIES

%num wxID_VIEW_DETAILS
%num wxID_VIEW_LARGEICONS
%num wxID_VIEW_SMALLICONS
%num wxID_VIEW_LIST
%num wxID_VIEW_SORTDATE
%num wxID_VIEW_SORTNAME
%num wxID_VIEW_SORTSIZE
%num wxID_VIEW_SORTTYPE

%num wxID_FILE
%num wxID_FILE1
%num wxID_FILE2
%num wxID_FILE3
%num wxID_FILE4
%num wxID_FILE5
%num wxID_FILE6
%num wxID_FILE7
%num wxID_FILE8
%num wxID_FILE9

// Standard responses
%num wxID_OK
%num wxID_CANCEL
%num wxID_APPLY
%num wxID_YES
%num wxID_NO
%num wxID_STATIC
%num wxID_FORWARD
%num wxID_BACKWARD
%num wxID_DEFAULT
%num wxID_MORE
%num wxID_SETUP
%num wxID_RESET
%num wxID_CONTEXT_HELP
%num wxID_YESTOALL
%num wxID_NOTOALL
%num wxID_ABORT
%num wxID_RETRY
%num wxID_IGNORE
%num wxID_ADD
%num wxID_REMOVE

%num wxID_UP
%num wxID_DOWN
%num wxID_HOME
%num wxID_REFRESH
%num wxID_STOP
%num wxID_INDEX

%num wxID_BOLD
%num wxID_ITALIC
%num wxID_JUSTIFY_CENTER
%num wxID_JUSTIFY_FILL
%num wxID_JUSTIFY_RIGHT
%num wxID_JUSTIFY_LEFT
%num wxID_UNDERLINE
%num wxID_INDENT
%num wxID_UNINDENT
%num wxID_ZOOM_100
%num wxID_ZOOM_FIT
%num wxID_ZOOM_IN
%num wxID_ZOOM_OUT
%num wxID_UNDELETE
%num wxID_REVERT_TO_SAVED

%num wxID_SYSTEM_MENU
%num wxID_CLOSE_FRAME
%num wxID_MOVE_FRAME
%num wxID_RESIZE_FRAME
%num wxID_MAXIMIZE_FRAME
%num wxID_ICONIZE_FRAME
%num wxID_RESTORE_FRAME

%num wxID_FILEDLGG
%num wxID_HIGHEST

%num wxHT_NOWHERE

%num wxHT_SCROLLBAR_FIRST
%num wxHT_SCROLLBAR_ARROW_LINE_1
%num wxHT_SCROLLBAR_ARROW_LINE_2
%num wxHT_SCROLLBAR_ARROW_PAGE_1
%num wxHT_SCROLLBAR_ARROW_PAGE_2
%num wxHT_SCROLLBAR_THUMB
%num wxHT_SCROLLBAR_BAR_1
%num wxHT_SCROLLBAR_BAR_2
%num wxHT_SCROLLBAR_LAST

%num wxHT_WINDOW_OUTSIDE
%num wxHT_WINDOW_INSIDE
%num wxHT_WINDOW_VERT_SCROLLBAR
%num wxHT_WINDOW_HORZ_SCROLLBAR
%num wxHT_WINDOW_CORNER

%num wxHT_MAX

%enum wxItemKind
%num wxITEM_NORMAL
%num wxITEM_SEPARATOR
%num wxITEM_CHECK
%num wxITEM_RADIO
%num wxITEM_MAX

//ACK
%num wxSIZE_AUTO_WIDTH
%num wxSIZE_AUTO_HEIGHT
%num wxSIZE_AUTO
%num wxSIZE_USE_EXISTING
%num wxSIZE_ALLOW_MINUS_ONE
%num wxSIZE_NO_ADJUSTMENTS
%num wxSIZE_FORCE

%num wxDEFAULT
%num wxDECORATIVE
%num wxROMAN
%num wxSCRIPT
%num wxSWISS
%num wxMODERN
%num wxTELETYPE
%num wxVARIABLE
%num wxFIXED
%num wxNORMAL
%num wxLIGHT
%num wxBOLD
%num wxITALIC
%num wxSLANT

%num wxSOLID
%num wxDOT
%num wxLONG_DASH
%num wxSHORT_DASH
%num wxDOT_DASH
%num wxUSER_DASH
%num wxTRANSPARENT
%num wxSTIPPLE_MASK_OPAQUE
%num wxSTIPPLE_MASK
%num wxSTIPPLE

%num wxBDIAGONAL_HATCH
%num wxCROSSDIAG_HATCH
%num wxFDIAGONAL_HATCH
%num wxCROSS_HATCH
%num wxHORIZONTAL_HATCH
%num wxVERTICAL_HATCH
%num wxFIRST_HATCH
%num wxLAST_HATCH

%num wxJOIN_BEVEL
%num wxJOIN_MITER
%num wxJOIN_ROUND
%num wxCAP_ROUND
%num wxCAP_PROJECTING
%num wxCAP_BUTT

%num wxCLEAR
%num wxXOR
%num wxINVERT
%num wxOR_REVERSE
%num wxAND_REVERSE
%num wxCOPY
%num wxAND
%num wxAND_INVERT
%num wxNO_OP
%num wxNOR
%num wxEQUIV
%num wxSRC_INVERT
%num wxOR_INVERT
%num wxNAND
%num wxOR
%num wxSET

%num wxROP_BLACK
%num wxROP_XORPEN
%num wxROP_NOT
%num wxROP_MERGEPENNOT
%num wxROP_MASKPENNOT
%num wxROP_COPYPEN
%num wxROP_MASKPEN
%num wxROP_MASKNOTPEN
%num wxROP_NOP
%num wxROP_NOTMERGEPEN
%num wxROP_NOTXORPEN
%num wxROP_NOTCOPYPEN
%num wxROP_MERGENOTPEN
%num wxROP_NOTMASKPEN
%num wxROP_MERGEPEN
%num wxROP_WHITE

%num wxBLIT_BLACKNESS
%num wxBLIT_SRCINVERT
%num wxBLIT_DSTINVERT
%num wxBLIT_00DD0228
%num wxBLIT_SRCERASE
%num wxBLIT_SRCCOPY
%num wxBLIT_SRCAND
%num wxBLIT_00220326
%num wxBLIT_00AA0029
%num wxBLIT_NOTSRCERASE
%num wxBLIT_00990066
%num wxBLIT_NOTSCRCOPY
%num wxBLIT_MERGEPAINT
%num wxBLIT_007700E6
%num wxBLIT_SRCPAINT
%num wxBLIT_WHITENESS

%num wxFLOOD_SURFACE
%num wxFLOOD_BORDER

%num wxODDEVEN_RULE
%num wxWINDING_RULE

%num wxTOOL_TOP
%num wxTOOL_BOTTOM
%num wxTOOL_LEFT
%num wxTOOL_RIGHT

%num wxDF_INVALID
%num wxDF_TEXT
%num wxDF_BITMAP
%num wxDF_METAFILE
%num wxDF_SYLK
%num wxDF_DIF
%num wxDF_TIFF
%num wxDF_OEMTEXT
%num wxDF_DIB
%num wxDF_PALETTE
%num wxDF_PENDATA
%num wxDF_RIFF
%num wxDF_WAVE
%num wxDF_UNICODETEXT
%num wxDF_ENHMETAFILE
%num wxDF_FILENAME
%num wxDF_LOCALE
%num wxDF_PRIVATE
%num wxDF_HTML
%num wxDF_MAX

// Command events

// More events
%num wxHF_TOOLBAR
%num wxHF_FLAT_TOOLBAR
%num wxHF_CONTENTS
%num wxHF_INDEX
%num wxHF_SEARCH
%num wxHF_BOOKMARKS
%num wxHF_OPEN_FILES
%num wxHF_PRINT
%num wxHF_MERGE_BOOKS
%num wxHF_ICONS_BOOK
%num wxHF_ICONS_FOLDER
%num wxHF_ICONS_BOOK_CHAPTER
%num wxHF_DEFAULT_STYLE

// keycodes
%num WXK_BACK
%num WXK_TAB
%num WXK_RETURN
%num WXK_ESCAPE
%num WXK_SPACE
%num WXK_DELETE

%num WXK_START
%num WXK_LBUTTON
%num WXK_RBUTTON
%num WXK_CANCEL
%num WXK_MBUTTON
%num WXK_CLEAR
%num WXK_SHIFT
%num WXK_ALT
%num WXK_CONTROL
%num WXK_MENU
%num WXK_PAUSE
%num WXK_CAPITAL
// prior and next no longer used, valid until 2.6
%num WXK_PRIOR
%num WXK_NEXT
%num WXK_END
%num WXK_HOME
%num WXK_LEFT
%num WXK_UP
%num WXK_RIGHT
%num WXK_DOWN
%num WXK_SELECT
%num WXK_PRINT
%num WXK_EXECUTE
%num WXK_SNAPSHOT
%num WXK_INSERT
%num WXK_HELP
%num WXK_NUMPAD0
%num WXK_NUMPAD1
%num WXK_NUMPAD2
%num WXK_NUMPAD3
%num WXK_NUMPAD4
%num WXK_NUMPAD5
%num WXK_NUMPAD6
%num WXK_NUMPAD7
%num WXK_NUMPAD8
%num WXK_NUMPAD9
%num WXK_MULTIPLY
%num WXK_ADD
%num WXK_SEPARATOR
%num WXK_SUBTRACT
%num WXK_DECIMAL
%num WXK_DIVIDE
%num WXK_F1
%num WXK_F2
%num WXK_F3
%num WXK_F4
%num WXK_F5
%num WXK_F6
%num WXK_F7
%num WXK_F8
%num WXK_F9
%num WXK_F10
%num WXK_F11
%num WXK_F12
%num WXK_F13
%num WXK_F14
%num WXK_F15
%num WXK_F16
%num WXK_F17
%num WXK_F18
%num WXK_F19
%num WXK_F20
%num WXK_F21
%num WXK_F22
%num WXK_F23
%num WXK_F24
%num WXK_NUMLOCK
%num WXK_SCROLL
%num WXK_PAGEUP
%num WXK_PAGEDOWN
%num WXK_NUMPAD_SPACE
%num WXK_NUMPAD_TAB
%num WXK_NUMPAD_ENTER
%num WXK_NUMPAD_F1
%num WXK_NUMPAD_F2
%num WXK_NUMPAD_F3
%num WXK_NUMPAD_F4
%num WXK_NUMPAD_HOME
%num WXK_NUMPAD_LEFT
%num WXK_NUMPAD_UP
%num WXK_NUMPAD_RIGHT
%num WXK_NUMPAD_DOWN
%num WXK_NUMPAD_PAGEUP
%num WXK_NUMPAD_PAGEDOWN
// prior and next valid until 2.6
%num WXK_NUMPAD_PRIOR
%num WXK_NUMPAD_NEXT
%num WXK_NUMPAD_END
%num WXK_NUMPAD_BEGIN
%num WXK_NUMPAD_INSERT
%num WXK_NUMPAD_DELETE
%num WXK_NUMPAD_EQUAL
%num WXK_NUMPAD_MULTIPLY
%num WXK_NUMPAD_ADD
%num WXK_NUMPAD_SEPARATOR
%num WXK_NUMPAD_SUBTRACT
%num WXK_NUMPAD_DECIMAL
%num WXK_NUMPAD_DIVIDE

%num WXK_WINDOWS_LEFT
%num WXK_WINDOWS_RIGHT
%num WXK_WINDOWS_MENU
%num WXK_COMMAND

%num WXK_SPECIAL1
%num WXK_SPECIAL2
%num WXK_SPECIAL3
%num WXK_SPECIAL4
%num WXK_SPECIAL5
%num WXK_SPECIAL6
%num WXK_SPECIAL7
%num WXK_SPECIAL8
%num WXK_SPECIAL9
%num WXK_SPECIAL10
%num WXK_SPECIAL11
%num WXK_SPECIAL12
%num WXK_SPECIAL13
%num WXK_SPECIAL14
%num WXK_SPECIAL15
%num WXK_SPECIAL16
%num WXK_SPECIAL17
%num WXK_SPECIAL18
%num WXK_SPECIAL19
%num WXK_SPECIAL20

%num wxMOD_NONE
%num wxMOD_ALT
%num wxMOD_CONTROL
%num wxMOD_ALTGR
%num wxMOD_SHIFT
%num wxMOD_META
%num wxMOD_WIN
%num wxMOD_CMD
%num wxMOD_ALL

%num wxMM_TEXT
%num wxMM_LOMETRIC
%num wxMM_HIMETRIC
%num wxMM_LOENGLISH
%num wxMM_HIENGLISH
%num wxMM_TWIPS
%num wxMM_ISOTROPIC
%num wxMM_ANISOTROPIC
%num wxMM_POINTS
%num wxMM_METRIC

%num wxPAPER_NONE
%num wxPAPER_LETTER
%num wxPAPER_LEGAL
%num wxPAPER_A4
%num wxPAPER_CSHEET
%num wxPAPER_DSHEET
%num wxPAPER_ESHEET
%num wxPAPER_LETTERSMALL
%num wxPAPER_TABLOID
%num wxPAPER_LEDGER
%num wxPAPER_STATEMENT
%num wxPAPER_EXECUTIVE
%num wxPAPER_A3
%num wxPAPER_A4SMALL
%num wxPAPER_A5
%num wxPAPER_B4
%num wxPAPER_B5
%num wxPAPER_FOLIO
%num wxPAPER_QUARTO
%num wxPAPER_10X14
%num wxPAPER_11X17
%num wxPAPER_NOTE
%num wxPAPER_ENV_9
%num wxPAPER_ENV_10
%num wxPAPER_ENV_11
%num wxPAPER_ENV_12
%num wxPAPER_ENV_14
%num wxPAPER_ENV_DL
%num wxPAPER_ENV_C5
%num wxPAPER_ENV_C3
%num wxPAPER_ENV_C4
%num wxPAPER_ENV_C6
%num wxPAPER_ENV_C65
%num wxPAPER_ENV_B4
%num wxPAPER_ENV_B5
%num wxPAPER_ENV_B6
%num wxPAPER_ENV_ITALY
%num wxPAPER_ENV_MONARCH
%num wxPAPER_ENV_PERSONAL
%num wxPAPER_FANFOLD_US
%num wxPAPER_FANFOLD_STD_GERMAN
%num wxPAPER_FANFOLD_LGL_GERMAN
%num wxPAPER_ISO_B4
%num wxPAPER_JAPANESE_POSTCARD
%num wxPAPER_9X11
%num wxPAPER_10X11
%num wxPAPER_15X11
%num wxPAPER_ENV_INVITE
%num wxPAPER_LETTER_EXTRA
%num wxPAPER_LEGAL_EXTRA
%num wxPAPER_TABLOID_EXTRA
%num wxPAPER_A4_EXTRA
%num wxPAPER_LETTER_TRANSVERSE
%num wxPAPER_A4_TRANSVERSE
%num wxPAPER_LETTER_EXTRA_TRANSVERSE
%num wxPAPER_A_PLUS
%num wxPAPER_B_PLUS
%num wxPAPER_LETTER_PLUS
%num wxPAPER_A4_PLUS
%num wxPAPER_A5_TRANSVERSE
%num wxPAPER_B5_TRANSVERSE
%num wxPAPER_A3_EXTRA
%num wxPAPER_A5_EXTRA
%num wxPAPER_B5_EXTRA
%num wxPAPER_A2
%num wxPAPER_A3_TRANSVERSE
%num wxPAPER_A3_EXTRA_TRANSVERSE
%num wxPAPER_DBL_JAPANESE_POSTCARD
%num wxPAPER_A6
%num wxPAPER_JENV_KAKU2
%num wxPAPER_JENV_KAKU3
%num wxPAPER_JENV_CHOU3
%num wxPAPER_JENV_CHOU4
%num wxPAPER_LETTER_ROTATED
%num wxPAPER_A3_ROTATED
%num wxPAPER_A4_ROTATED
%num wxPAPER_A5_ROTATED
%num wxPAPER_B4_JIS_ROTATED
%num wxPAPER_B5_JIS_ROTATED
%num wxPAPER_JAPANESE_POSTCARD_ROTATED
%num wxPAPER_DBL_JAPANESE_POSTCARD_ROTATED
%num wxPAPER_A6_ROTATED
%num wxPAPER_JENV_KAKU2_ROTATED
%num wxPAPER_JENV_KAKU3_ROTATED
%num wxPAPER_JENV_CHOU3_ROTATED
%num wxPAPER_JENV_CHOU4_ROTATED
%num wxPAPER_B6_JIS
%num wxPAPER_B6_JIS_ROTATED
%num wxPAPER_12X11
%num wxPAPER_JENV_YOU4
%num wxPAPER_JENV_YOU4_ROTATED
%num wxPAPER_P16K
%num wxPAPER_P32K
%num wxPAPER_P32KBIG
%num wxPAPER_PENV_1
%num wxPAPER_PENV_2
%num wxPAPER_PENV_3
%num wxPAPER_PENV_4
%num wxPAPER_PENV_5
%num wxPAPER_PENV_6
%num wxPAPER_PENV_7
%num wxPAPER_PENV_8
%num wxPAPER_PENV_9
%num wxPAPER_PENV_10
%num wxPAPER_P16K_ROTATED
%num wxPAPER_P32K_ROTATED
%num wxPAPER_P32KBIG_ROTATED
%num wxPAPER_PENV_1_ROTATED
%num wxPAPER_PENV_2_ROTATED
%num wxPAPER_PENV_3_ROTATED
%num wxPAPER_PENV_4_ROTATED
%num wxPAPER_PENV_5_ROTATED
%num wxPAPER_PENV_6_ROTATED
%num wxPAPER_PENV_7_ROTATED
%num wxPAPER_PENV_8_ROTATED
%num wxPAPER_PENV_9_ROTATED
%num wxPAPER_PENV_10_ROTATED

%num wxDUPLEX_SIMPLEX
%num wxDUPLEX_HORIZONTAL
%num wxDUPLEX_VERTICAL
%num wxPRINT_MODE_NONE
%num wxPRINT_MODE_PREVIEW
%num wxPRINT_MODE_FILE
%num wxPRINT_MODE_PRINTER
%num wxPRINT_MODE_STREAM

%num wxPORTRAIT
%num wxLANDSCAPE
%num wxPRINT_QUALITY_HIGH
%num wxPRINT_QUALITY_MEDIUM
%num wxPRINT_QUALITY_LOW
%num wxPRINT_QUALITY_DRAFT

%num wxUPDATE_UI_NONE
%num wxUPDATE_UI_RECURSE
%num wxUPDATE_UI_FROMIDLE

// enums, not classes
%enum wxDirection
%enum wxOrientation
%enum wxAlignment
%enum wxStretch
%enum wxBorder
%enum wxBackgroundStyle
%enum wxHitTest
%enum wxKeyCode
%enum wxKeyModifier

%enum wxDateTime::WeekDay
%enum wxDateTime::Country
%enum wxDateTime::Month
wxDateTime::Calendar
%enum wxEdge
%enum wxGrid::wxGridSelectionModes
%enum wxLayoutAlignment
%enum wxLayoutOrientation
%enum wxRelationship
%enum wxSashEdgePosition
%enum wxSocketNotify
%enum wxTreeItemIcon
%enum wxPaperSize
%enum wxPrintQuality
%enum wxDuplexMode
%enum wxListColumnFormat
%enum wxFile::OpenMode
%enum wxPathFormat
%enum wxPathNormalize
%enum wxPrinterError

// typedefs
%typedef wxNotebookPage wxWindow
%typedef wxCoord coord
//%typedef wxDateTime_t time_t
%typedef TimeZone double
%typedef wxUint32 unsigned int
// RP: be carefull with this, turned off 2012-02-07
// %typedef wxChar char
%typedef wxFileOffset off_t
// %typedef wxFileOffset __int64
// RP: Borland Compiler does not support long file offset, use this instead
//%typedef wxFileOffset long
//%typedef wxLongLong __int64

// struct
%struct wxResourceTable

// defined so pointers can be flagged
//%class wxAcceleratorTable
//%class wxArray not really exists
///////////////////////////////////////////////////////////////////////////////
// abstract wxArray
%include <wx/dynarray.h>
//void Alloc(size_t count)
//void Clear()
//size_t Count() const
//void Empty()
//size_t GetCount() const
//bool IsEmpty() const
//RemoveAt(size_t index, size_t count = 1)
//void SetCount(size_t count, T defval = T(0))
//void Shrink()

%class %delete wxArrayInt
wxArrayInt()
void Empty()
void Clear()
void Alloc(size_t nCount)
void Shrink()
size_t GetCount() const
bool IsEmpty() const
size_t Count() const
int Item(size_t nIndex) const
int Last() const
void Add(const int i, size_t copies = 1)
int Index(const int i, bool bFromEnd = false)
void Insert(const int i, size_t n, size_t copies = 1)
void SetCount(size_t count)
void Remove(const int i)
void RemoveAt(size_t index, size_t count = 1)

%class %delete wxArrayTreeItemIds
wxArrayTreeItemIds()
void Empty()
void Clear()
void Alloc(size_t nCount)
void Shrink()
size_t GetCount() const
bool IsEmpty() const
size_t Count() const
long Item(size_t nIndex) const
//void* Last() const
//void Add(void*)
//int Index(void*, bool bFromEnd = false)
//void Insert(void *, size_t n)
void SetCount(size_t count)
//void Remove(void*)
void RemoveAt(size_t index, size_t count = 1)

%class %delete wxCalendarDateAttr
    %include "wx/calctrl.h"
%class %delete wxCaret
    %include "wx/caret.h"
//%class wxClassInfo
//%class wxDateSpan
%class wxMenuItemList
//%class wxObjectRefData
// Fix: class probably can't be used...
// %class wxPlotCurve
// %class wxRegion
// %class wxSizer
// Fix: Undefined symbol 'wxToolBarTool'
// %class wxToolBarTool
//%class wxTreeItemData
//%class wxTreeItemId
%class wxValidator
//%class wxWindowList
%not(gtk) %class wxMetafile
        %include "wx/metafile.h"
%class %delete wxMask
%class wxMemoryBuffer
%class wxNodeBase
    %include "wx/list.h"
//%class wxSockAddress
//    %include "wx/socket.h"

%class %delete wxIconBundle
%class wxStdDialogButtonSizer
%class wxHtmlListBox
%class wxCommand

///////////////////////////////////////////////////////////////////////////////
// some helpers for tables
///////////////////////////////////////////////////////////////////////////////

%{
int GetTableCount(wVariant* v)
{
	int count;
	int i;
	wGrow *table;
	wTableElement *item;

	/* check if we got the correct type */
	if (v->dataType != W_TYPE_TABLE) {
		wErrorThrow( W_ERROR_CONVERT, "Expected an Table, not a %s", wDataTypeName[v->dataType] );
	}

	/* get the count */
	table = v->value.table;
	for(i = 2; i <= W_HASHTABLE_SIZE; i++)
	{
		item = (wTableElement *)wGrowGet( table, i );
		if(item == NULL)
			break;
	}
	count = i - 2;

	return count;
}

// fill an const char* [] based upon a table
void FillCharArray(const char** data, wGrow *table, int count)
{
	int i;
	wTableElement *item;

	for(i = 2; i < count + 2; i++) /* BUGFIX */
	{
		item = (wTableElement *)wGrowGet( table, i );
		const char* s = wVariantToChar( &(item->value), 0, 0 );
		data[i - 2] = s;
	}
}

// Create an int* based upon list values
int* MakeIntArray(wGrow* list)
{
	int* data = NULL;
	wVariant* item;
	int i;

	if(list->count)
		data = new int [list->count];
	if(data == NULL)
		return NULL;
	for(i = 1; i <= list->count; i++)
	{
		item = (wVariant *)wGrowGet( list, i );
		int n = (int) wVariantGetNumber( item );
		data[i - 1] = n;
	}
	return data;
}
%}

///////////////////////////////////////////////////////////////////////////////
// not really classes, but i'm sticking them here for convenience
///////////////////////////////////////////////////////////////////////////////

%include "wx/tipdlg.h"
%include "wx/filedlg.h"
%include "wx/colordlg.h"
%include "wx/textdlg.h"
%include "wx/choicdlg.h"
%include "wx/msgdlg.h"
%include "wx/tipdlg.h"
%include <wx/numdlg.h>

%builtin wxString wxFileSelector(const wxString& message, const wxString& default_path = wxT(""), const wxString& default_filename = wxT(""), const wxString& default_extension = wxT(""), const wxString& wildcard = wxT("*.*"), int flags = 0, wxWindow *parent = NULL, int x = -1, int y = -1)
%builtin %alias wxGetColorFromUser wxColour wxGetColourFromUser(wxWindow *parent, const wxColour& colInit)
%builtin long wxGetNumberFromUser( const wxString& message, const wxString& prompt, const wxString& caption, long value, long min = 0, long max = 100, wxWindow *parent = NULL, const wxPoint& pos = wxDefaultPosition)
%builtin wxString wxGetPasswordFromUser(const wxString& message, const wxString& caption = wxT("Input text"), const wxString& default_value = wxT(""), wxWindow *parent = NULL)
%builtin wxString wxGetTextFromUser(const wxString& message, const wxString& caption = wxT("Input text"), const wxString& default_value = wxT(""), wxWindow *parent = NULL, int x = -1, int y = -1, bool centre = TRUE)

// Fix: don't support multiple selections yet
// TODO: needs wrapper
// int wxGetMultipleChoice(const wxString& message, const wxString& caption, int n, const wxString& choices[], int nsel, int *selection, wxWindow *parent = NULL, int x = -1, int y = -1, bool centre = TRUE, int width=150, int height=200)
// wxString wxGetSingleChoice(const wxString& message, const wxString& caption, int n, const wxString& choices[], wxWindow *parent = NULL, int x = -1, int y = -1, bool centre = TRUE, int width=150, int height=200)
// int wxGetSingleChoiceIndex(const wxString& message, const wxString& caption, int n, const wxString& choices[], wxWindow *parent = NULL, int x = -1, int y = -1, bool centre = TRUE, int width=150, int height=200)

%builtin int wxMessageBox(const wxString& message, const wxString& caption = _("Message"), int style = wxOK | wxCENTRE, wxWindow *parent = NULL, int x = -1, int y = -1)
%num wxYES
%num wxOK
%num wxNO
%num wxYES_NO
%num wxCANCEL
%num wxNO_DEFAULT
%num wxYES_DEFAULT
%num wxICON_EXCLAMATION
%num wxICON_HAND
%num wxICON_WARNING
%num wxICON_ERROR
%num wxICON_QUESTION
%num wxICON_INFORMATION
%num wxICON_STOP
%num wxICON_ASTERISK
%num wxICON_MASK

%num wxFORWARD
%num wxBACKWARD
%num wxRESET
%num wxHELP
%num wxMORE
%num wxSETUP

%num wxBG_STYLE_SYSTEM
%num wxBG_STYLE_COLOUR
%num wxBG_STYLE_CUSTOM

// Utility programs
%include "wx/utils.h"
// %include "wx/dde.h"
%include "wx/app.h"
%include "wx/window.h"

// Can't type correctly
// %builtin wxIconOrCursor wxDROP_ICON(const char *name)
%builtin long wxNewId()
%builtin void wxRegisterId(long id)
//RP
%builtin long wxGetCurrentId()
%builtin void wxBeginBusyCursor(const wxCursor *cursor = wxHOURGLASS_CURSOR)
%builtin void wxBell()
//%builtin wxObject * wxCreateDynamicObject(const wxString& className)
// Obsolete
// %builtin void wxDDECleanUp()
// %builtin void wxDDEInitialize()
// Can't handle ...
// %builtin void wxDebugMsg(const wxString& fmt, ...)
%{
    void DisplaySize()
    {
        int width, height;
        wxDisplaySize( &width, &height );
        wStackPushInteger( (wInteger)width );
        wStackPushInteger( (wInteger)height );
    }
%}
%builtin %rename wxDisplaySize void DisplaySize()


%builtin void wxEnableTopLevelWindows(bool enable = TRUE)
// Don't use
// %builtin void wxEntry(HANDLE hInstance, HANDLE hPrevInstance, const wxString& commandLine, int cmdShow, bool enterLoop = TRUE)
%builtin void wxEndBusyCursor()
//%builtin void wxError(const wxString& msg, const wxString& title = "wxWindows Internal Error")

%num wxEXEC_ASYNC
%num wxEXEC_SYNC
%num wxEXEC_NOHIDE
%num wxEXEC_MAKE_GROUP_LEADER
%num wxEXEC_NODISABLE

%builtin %rename wxExecuteProcess long wxExecute(const wxString& command, bool sync = FALSE, wxProcess *callback = NULL)
%builtin long wxExecute(const wxString& command, int flags = wxEXEC_ASYNC, wxProcess *process = NULL)
%if(win) %builtin bool wxExecuteDDE(const wxString& ddeServer, const wxString& ddeTopic, const wxString& ddeCommand)

%builtin void wxExit()
//%builtin void wxFatalError(const wxString& msg, const wxString& title = "wxWindows Fatal Error")
%builtin int wxFindMenuItemId(wxFrame *frame, const wxString& menuString, const wxString& itemString)
%builtin wxWindow * wxFindWindowByLabel(const wxString& label, wxWindow *parent=NULL)
%builtin wxWindow * wxFindWindowByName(const wxString& name, wxWindow *parent=NULL)
%builtin wxWindow * wxFindWindowAtPoint(const wxPoint& pt)
%builtin wxWindow * wxFindWindowAtPointer(wxPoint& pt)
// Windows only
// wxWindow * wxGetActiveWindow()
// X only
// wxString wxGetDisplayName()
%builtin wxString wxGetHomeDir()
// not supported under Mac
// long wxGetFreeMemory()
%builtin wxPoint wxGetMousePosition()
%builtin wxString wxGetOsDescription()
// %builtin int wxGetOsVersion(int *major = NULL, int *minor = NULL)
%{
    void GetOsVersion()
    {
        int major, minor;
        wxGetOsVersion( &major, &minor );
        wStackPushInteger( (wInteger)major );
        wStackPushInteger( (wInteger)minor );
    }
%}
%builtin %rename wxGetOsVersion void GetOsVersion()

%num wxUNKNOWN_PLATFORM
//%num wxCURSES
//%num wxXVIEW_X
//%num wxMOTIF_X
//%num wxCOSE_X
//%num wxNEXTSTEP
//%num wxBEOS
//%num wxGTK
//%num wxGTK_WIN32
//%num wxGTK_OS2
//%num wxGTK_BEOS
//%num wxGEOS
//%num wxOS2_PM
//%num wxWINDOWS
//%num wxPENWINDOWS
//%num wxWINDOWS_NT
//%num wxWIN32S
//%num wxWIN95
//%num wxWIN386
//%num wxMGL_UNIX
//%num wxMGL_X
//%num wxMGL_WIN32
//%num wxMGL_OS2
//%num wxWINDOWS_OS2
//%num wxUNIX

// FIX: Could not find a match for 'wxGetResource(wxString,wxString,wxString,wxString)' in function builtin_wxGetResource()
// %builtin bool wxGetResource(const wxString& section, const wxString& entry, const wxString& *value, const wxString& file = NULL)

//%builtin bool wxHandleFatalExceptions(bool doIt = TRUE)
// FIX: need to defined wxKillError class first...
// int wxKill(long pid, int sig = wxSIGTERM, wxKillError *rc = NULL)
// should probably do automatically...
// Fix: Call to undefined function 'wxInitAllImageHandlers' in function builtin_wxInitAllImageHandlers()
// %builtin void wxInitAllImageHandlers()
%builtin bool wxIsBusy()
// Windows only
// wxString wxLoadUserResource(const wxString& resourceName, const wxString& resourceType=wxT("TEXT"))
%builtin wxString wxNow()
// Obsolete
// void wxPostDelete(wxObject *object)
%builtin void wxPostEvent(wxEvtHandler *dest, wxEvent& event)
//%builtin void wxFlushEvents()
%builtin bool wxSafeYield(wxWindow* win = NULL, bool onlyIfNeeded = false)
// X only
// void wxSetDisplayName(const wxString& displayName)
//%builtin bool wxShell(const wxString& command = NULL)
//%builtin void wxSleep(int secs)
// Macros, doesn't work...
// %builtin char wxToLower(char ch)
// %builtin char wxToUpper(char ch)
// Obsolete
// void wxTrace(const wxString& fmt, ...)
// void wxTraceLevel(int level, const wxString& fmt, ...)
%builtin void wxTrap()
//%builtin void wxUsleep(unsigned long milliseconds)
// Fix: need to flag that it uses resources
// %builtin bool wxWriteResource(const wxString& section, const wxString& entry, const wxString& value, const wxString& file = NULL)
%builtin bool wxYield()
%builtin void wxWakeUpIdle()

///////////////////////////////////////////////////////////////////////////////
// wxDisplay

%include <wx/display.h>
%class %delete wxArrayVideoModes
%class %delete wxDisplay
%struct wxVideoMode
//%ptr wxDefaultVideoMode
wxDisplay(unsigned int index = 0)
//void ~wxDisplay()
bool  ChangeMode(const wxVideoMode& mode = wxDefaultVideoMode)
wxRect   GetClientArea() const
static unsigned  GetCount()
wxVideoMode  GetCurrentMode() const
//int  GetDepth() const
static int GetFromPoint(const wxPoint& pt)
static int GetFromWindow(wxWindow* win)
wxRect   GetGeometry() const
wxArrayVideoModes  GetModes(const wxVideoMode& mode = wxDefaultVideoMode) const
wxString   GetName() const
bool  IsPrimary()

%builtin %rename wxDisplay_GetCount unsigned wxDisplay::GetCount()
%builtin %rename wxDisplay_GetFromPoint int wxDisplay::GetFromPoint(const wxPoint& pt)
%builtin %rename wxDisplay_GetFromWindow int wxDisplay::GetFromWindow(wxWindow* win)

///////////////////////////////////////////////////////////////////////////////
// Environment access functions from utils.h

%include <wx/utils.h>

// %builtin bool wxGetEnv(const wxString& var, wxString *value);
// returns value through arglist, so needs a wrapper
%{
    wxString builtin_getEnvValue( const wxString& var )
    {
        wxString value;
        wxGetEnv(var, &value);
        return value;
    }
%}
//%builtin %alias wxGetEnvValue wxString builtin_getEnvValue( const wxString& var )
%builtin %alias wxGetEnv wxString builtin_getEnvValue( const wxString& var )

// Hack: changed wxChar to wxString
%builtin bool wxSetEnv(const wxString& var, const wxChar *value);
//%builtin bool wxSetEnv(const wxString& var, const wxString *value)
%builtin bool wxUnsetEnv(const wxString& var)

//@@@ RP
%builtin bool wxIsPlatformLittleEndian()
%builtin bool wxIsPlatform64Bit()
%builtin wxString wxGetDataDir()
%builtin bool wxGetKeyState(wxKeyCode key)
%builtin bool wxSetDetectableAutoRepeat( bool flag )
%builtin int wxHexToDec(const wxString& buf)
%builtin wxString wxDecToHex(int dec)

// ==============================
// Class: wxMouseState

%class %delete wxMouseState
wxMouseState()
wxCoord     GetX()
wxCoord     GetY()
bool        LeftDown()
bool        MiddleDown()
bool        RightDown()
bool        ControlDown()
bool        ShiftDown()
bool        AltDown()
bool        MetaDown()
bool        CmdDown()
void        SetX(wxCoord x)
void        SetY(wxCoord y)
void        SetLeftDown(bool down)
void        SetMiddleDown(bool down)
void        SetRightDown(bool down)
void        SetControlDown(bool down)
void        SetShiftDown(bool down)
void        SetAltDown(bool down)
void        SetMetaDown(bool down)

%builtin wxMouseState wxGetMouseState()
//RP: deprecated
//%str wxFloatToStringStr
//%str wxDoubleToStringStr

%enum wxSignal
  %num wxSIGNONE
  %num wxSIGHUP
  %num wxSIGINT
  %num wxSIGQUIT
  %num wxSIGILL
  %num wxSIGTRAP
  %num wxSIGABRT
  %num wxSIGIOT
  %num wxSIGEMT
  %num wxSIGFPE
  %num wxSIGKILL
  %num wxSIGBUS
  %num wxSIGSEGV
  %num wxSIGSYS
  %num wxSIGPIPE
  %num wxSIGALRM
  %num wxSIGTERM

%enum wxKillError
  %num wxKILL_OK
  %num wxKILL_BAD_SIGNAL
  %num wxKILL_ACCESS_DENIED
  %num wxKILL_NO_PROCESS
  %num wxKILL_ERROR

%enum wxKillFlags
  %num wxKILL_NOCHILDREN
  %num wxKILL_CHILDREN

%enum wxShutdownFlags
  %num wxSHUTDOWN_POWEROFF
  %num wxSHUTDOWN_REBOOT

%builtin bool wxShutdown(wxShutdownFlags wFlags)
%typedef wxKillError int
//int wxKill(long pid, wxSignal sig = wxSIGTERM, wxKillError *rc = NULL, int flags = wxKILL_NOCHILDREN)
%{
int builtin_wxKill()
{
	int flags = (wTheCall->parmCount > 3 ? (int)wStackPopInteger() : wxKILL_NOCHILDREN);
	int *rc = (wTheCall->parmCount > 2 ? (int *)wStackPopObjectPtr( NULL ) : NULL);
	wxSignal sig = (wTheCall->parmCount > 1 ? (wxSignal)wStackPopInteger() : wxSIGTERM);
	long pid = (long)wStackPopInteger();
	int returns = wxKill(pid, (wxSignal)sig, (wxKillError*) rc, flags);
	wWrapDerefArgs();
	return returns;
	//wStackPushInteger( (wInteger)returns);
}
%}
%builtin %alias wxKill int builtin_wxKill()

%builtin bool wxShell(const wxString& command = wxEmptyString)
//%builtin bool wxShell(const wxString& command, wxArrayString& output)
%builtin void wxSleep(int nSecs)
%builtin void wxMilliSleep(unsigned long milliseconds)
%builtin void wxMicroSleep(unsigned long microseconds)
%builtin unsigned long wxGetProcessId()
//RP: what is wxMemorySize?
//%builtin wxMemorySize wxGetFreeMemory()
%not(gcc) %builtin bool wxHandleFatalExceptions(bool doit = true)

%num wxBROWSER_NEW_WINDOW

%builtin bool wxLaunchDefaultBrowser(const wxString& url, int flags = 0)
%builtin wxString wxGetEmailAddress()
%builtin wxString wxGetHostName()
%builtin wxString wxGetFullHostName()
%builtin wxString wxGetUserId()
%builtin wxString wxGetUserName()
//defined somewhere else
//%builtin wxString wxGetHomeDir()
//%builtin const wxChar* wxGetHomeDir(wxString *pstr)
//RP: this is wxChar*
%builtin wxString wxGetUserHome(const wxString& user = wxEmptyString)
%typedef wxDiskspaceSize_t wxLongLong
%typedef wxDiskspaceSize_t long
//RP: yes, we need a wrapper TODO
//%builtin bool wxGetDiskSpace(const wxString& path, wxDiskspaceSize_t *pTotal = NULL, wxDiskspaceSize_t *pFree = NULL)

///////////////////////////////////////////////////////////////////////////////
// File utility functions

// file functions

%include <wx/utils.h>
%include <wx/docview.h>

%builtin bool wxDirExists(const wxString& dirname)
//%builtin void wxDos2UnixFilename(wxChar *s)
%builtin bool wxFileExists(const wxString& filename)
%builtin time_t wxFileModificationTime(const wxString& filename)

// these two are obsolete. use wxFileName::SplitPath instead
%builtin wxString wxFileNameFromPath(const wxString& path)
// char * wxFileNameFromPath(char *path)
//%builtin wxString wxFindFirstFile(const char* spec, int flags = 0)
%builtin wxString wxFindFirstFile(const wxString& spec, int flags = 0)
%builtin wxString wxFindNextFile()
// FIXME: needs wrapper to pass values back
// %builtin bool wxGetDiskSpace(const wxString& path, wxLongLong *total = NULL, wxLongLong *free = NULL)
%builtin wxString wxGetOSDirectory()
%builtin bool wxIsAbsolutePath(const wxString& filename)
%builtin wxString wxPathOnly(const wxString& path)
// %builtin void wxUnix2DosFilename(const wxString& s)
//deprecated
//%builtin void wxUnix2DosFilename(const char *s)
%builtin bool wxConcatFiles(const wxString& file1, const wxString& file2, const wxString& file3)
%builtin bool wxCopyFile(const wxString& file1, const wxString& file2, bool overwrite = TRUE)
%builtin wxString wxGetCwd()
//Deprecated
//%builtin wxString wxGetWorkingDirectory(char *buf=NULL, int sz=1000)
// These two are obsolete, use wxFileName::CreateTempFileName instead
// char * wxGetTempFileName(const wxString& prefix, char *buf=NULL)
%builtin bool wxGetTempFileName(const wxString& prefix, wxString& buf)
%builtin bool wxIsWild(const wxString& pattern)
%builtin bool wxMatchWild(const wxString& pattern, const wxString& text, bool dot_special)
%builtin bool wxMkdir(const wxString& dir, int perm = 0777)
%builtin bool wxRemoveFile(const wxString& file)
%builtin bool wxRenameFile(const wxString& file1, const wxString& file2)
%builtin bool wxRmdir(const wxString& dir, int flags=0)
%builtin bool wxSetWorkingDirectory(const wxString& dir)
// NB: This function is obsolete, please use wxFileName::SplitPath instead.
// %builtin void wxSplitPath(const char * fullname, wxString * path, wxString * name, wxString * ext)
// FIXME: can't handle ostream or istream datatypes
// %builtin bool wxTransferFileToStream(const wxString& filename, ostream& stream)
// %builtin bool wxTransferStreamToFile(istream& stream const wxString& filename)


///////////////////////////////////////////////////////////////////////////////
// NON-GUI CLASSES
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
// wxRegEx

%include <wx/regex.h>
  %num wxRE_EXTENDED
//#ifdef wxHAS_REGEX_ADVANCED
  //%num wxRE_ADVANCED
//#endif
  %num wxRE_BASIC
  %num wxRE_ICASE
  %num wxRE_NOSUB
  %num wxRE_NEWLINE
  %num wxRE_DEFAULT

  %num wxRE_NOTBOL
  %num wxRE_NOTEOL
%class %delete wxRegEx
%ctor wxRegExNoCreate()
%ctor wxRegExEmpty()
wxRegEx(const wxString& expr, int flags = wxRE_DEFAULT)
// ~wxRegEx()
bool Compile(const wxString& pattern, int flags = wxRE_DEFAULT)
bool IsValid() const
wxString GetMatch(const wxString& text, size_t index = 0) const
size_t GetMatchCount() const
bool Matches(const wxString& text, int flags = 0) const
%{
	// bool GetMatch(size_t* start, size_t* len, size_t index = 0) const
	void wxRegEx_GetMatchData()
	{
		size_t index = (wTheCall->parmCount > 0 ? (size_t)wStackPopInteger() : 0);
		size_t start;
		size_t len;

		int ok = (int) ((wxRegEx *)(wTheCall->self->ptr))->GetMatch(&start, &len, index);
		wWrapDerefArgs();
		wStackPushInteger( (wInteger) ok );
		wStackPushInteger( (wInteger) start );
		wStackPushInteger( (wInteger) len );
	}

	// int Replace(wxString& text, const wxString& replacement, size_t maxMatches = 0) const
	void wxRegEx_Replace() {
		size_t maxMatches = (wTheCall->parmCount > 2 ? (size_t)wStackPopInteger() : 0);
		wxString replacement = wxString(wStackPopChar(), *wxConvCurrent);
		wxString text = wxString(wStackPopChar(), *wxConvCurrent);
		int returns = ((wxRegEx *)(wTheCall->self->ptr))->Replace(&text, replacement, maxMatches);
		wWrapDerefArgs();
		wStackPushInteger( (wInteger)returns);
		wStackPushChar( (char *)(text.char_str()), W_TRUE );
	}

	//int ReplaceAll(wxString* text, const wxString& replacement) const
	void wxRegEx_ReplaceAll() {
		wxString replacement = wxString(wStackPopChar(), *wxConvCurrent);
		wxString text = wxString(wStackPopChar(), *wxConvCurrent);
		int returns = ((wxRegEx *)(wTheCall->self->ptr))->ReplaceAll(&text, replacement);
		wWrapDerefArgs();
		wStackPushInteger( (wInteger)returns);
		wStackPushChar( (char *)(text.char_str()), W_TRUE );
	}

	//int ReplaceFirst(wxString* text, const wxString& replacement) const
	void wxRegEx_ReplaceFirst() {
		wxString replacement = wxString(wStackPopChar(), *wxConvCurrent);
		wxString text = wxString(wStackPopChar(), *wxConvCurrent);
		int returns = ((wxRegEx *)(wTheCall->self->ptr))->ReplaceFirst(&text, replacement);
		wWrapDerefArgs();
		wStackPushInteger( (wInteger)returns);
		wStackPushChar( (char *)(text.char_str()), W_TRUE );
	}

%}
%method GetMatchData wxRegEx_GetMatchData(size_t index = 0) const
%method Replace wxRegEx_Replace(wxString& text, const wxString& replacement, size_t maxMatches = 0) const
%method ReplaceAll wxRegEx_ReplaceAll(wxString* text, const wxString& replacement) const
%method ReplaceFirst wxRegEx_ReplaceFirst(wxString* text, const wxString& replacement) const

///////////////////////////////////////////////////////////////////////////////
// wxSingleInstanceChecker

%include <wx/snglinst.h>
%class %delete wxSingleInstanceChecker
%ctor wxSingleInstanceCheckerNoCreate()
wxSingleInstanceChecker(const wxString& name, const wxString& path = wxEmptyString)
bool Create(const wxString& name, const wxString& path = wxEmptyString)
bool IsAnotherRunning() const
// ~wxSingleInstanceChecker()

///////////////////////////////////////////////////////////////////////////////
// wxStopWatch

%include <wx/stopwatch.h>
%class %delete wxStopWatch
wxStopWatch()
void Pause()
void Resume()
void Start(long milliseconds = 0)
long Time() const

///////////////////////////////////////////////////////////////////////////////
// wxSystemOptions

%include <wx/sysopt.h>
%class wxSystemOptions, wxObject
wxSystemOptions()
wxString  GetOption(const wxString& name) const
int GetOptionInt(const wxString& name) const
bool HasOption(const wxString& name) const
bool IsFalse(const wxString& name) const
void SetOption(const wxString& name, const wxString& value)
%rename SetOptionInt void SetOption(const wxString& name, int value)

%builtin %rename wxSystemOptions_SetOption void  wxSystemOptions::SetOption(const wxString& name, const wxString& value)
%builtin %rename wxSystemOptions_SetOptionInt void  wxSystemOptions::SetOption(const wxString& name, int value)
%builtin %rename wxSystemOptions_GetOption wxString wxSystemOptions::GetOption(const wxString& name)
%builtin %rename wxSystemOptions_GetOptionInt int wxSystemOptions::GetOptionInt(const wxString& name)
%builtin %rename wxSystemOptions_HasOption bool wxSystemOptions::HasOption(const wxString& name)
%builtin %rename wxSystemOptions_IsFalse bool wxSystemOptions::IsFalse(const wxString& name)

///////////////////////////////////////////////////////////////////////////////
// wxSystemSettings

%include <wx/settings.h>

// index in GetColour
%enum wxSystemColour
%num wxSYS_COLOUR_SCROLLBAR
%num wxSYS_COLOUR_BACKGROUND
%num wxSYS_COLOUR_ACTIVECAPTION
%num wxSYS_COLOUR_INACTIVECAPTION
%num wxSYS_COLOUR_MENU
%num wxSYS_COLOUR_WINDOW
%num wxSYS_COLOUR_WINDOWFRAME
%num wxSYS_COLOUR_MENUTEXT
%num wxSYS_COLOUR_WINDOWTEXT
%num wxSYS_COLOUR_CAPTIONTEXT
%num wxSYS_COLOUR_ACTIVEBORDER
%num wxSYS_COLOUR_INACTIVEBORDER
%num wxSYS_COLOUR_APPWORKSPACE
%num wxSYS_COLOUR_HIGHLIGHT
%num wxSYS_COLOUR_HIGHLIGHTTEXT
%num wxSYS_COLOUR_BTNFACE
%num wxSYS_COLOUR_BTNSHADOW
%num wxSYS_COLOUR_GRAYTEXT
%num wxSYS_COLOUR_BTNTEXT
%num wxSYS_COLOUR_INACTIVECAPTIONTEXT
%num wxSYS_COLOUR_BTNHIGHLIGHT
%num wxSYS_COLOUR_3DDKSHADOW
%num wxSYS_COLOUR_3DLIGHT
%num wxSYS_COLOUR_INFOTEXT
%num wxSYS_COLOUR_INFOBK
%num wxSYS_COLOUR_DESKTOP
%num wxSYS_COLOUR_3DFACE
%num wxSYS_COLOUR_3DSHADOW
%num wxSYS_COLOUR_3DHIGHLIGHT
%num wxSYS_COLOUR_3DHILIGHT
%num wxSYS_COLOUR_BTNHILIGHT

// index of GetFont
%enum wxSystemFont
%num wxSYS_OEM_FIXED_FONT
%num wxSYS_ANSI_FIXED_FONT
%num wxSYS_ANSI_VAR_FONT
%num wxSYS_SYSTEM_FONT
%num wxSYS_DEVICE_DEFAULT_FONT
%num wxSYS_DEFAULT_GUI_FONT

// index of GetMetric
%enum wxSystemMetric
%num wxSYS_MOUSE_BUTTONS
%num wxSYS_BORDER_X
%num wxSYS_BORDER_Y
%num wxSYS_CURSOR_X
%num wxSYS_CURSOR_Y
%num wxSYS_DCLICK_X
%num wxSYS_DCLICK_Y
%num wxSYS_DRAG_X
%num wxSYS_DRAG_Y
%num wxSYS_EDGE_X
%num wxSYS_EDGE_Y
%num wxSYS_HSCROLL_ARROW_X
%num wxSYS_HSCROLL_ARROW_Y
%num wxSYS_HTHUMB_X
%num wxSYS_ICON_X
%num wxSYS_ICON_Y
%num wxSYS_ICONSPACING_X
%num wxSYS_ICONSPACING_Y
%num wxSYS_WINDOWMIN_X
%num wxSYS_WINDOWMIN_Y
%num wxSYS_SCREEN_X
%num wxSYS_SCREEN_Y
%num wxSYS_FRAMESIZE_X
%num wxSYS_FRAMESIZE_Y
%num wxSYS_SMALLICON_X
%num wxSYS_SMALLICON_Y
%num wxSYS_HSCROLL_Y
%num wxSYS_VSCROLL_X
%num wxSYS_VSCROLL_ARROW_X
%num wxSYS_VSCROLL_ARROW_Y
%num wxSYS_VTHUMB_Y
%num wxSYS_CAPTION_Y
%num wxSYS_MENU_Y
%num wxSYS_NETWORK_PRESENT
%num wxSYS_PENWINDOWS_PRESENT
%num wxSYS_SHOW_SOUNDS
%num wxSYS_SWAP_BUTTONS

// return of GetScreenType
%enum wxSystemScreenType
%num wxSYS_SCREEN_NONE
%num wxSYS_SCREEN_TINY
%num wxSYS_SCREEN_PDA
%num wxSYS_SCREEN_SMALL
%num wxSYS_SCREEN_DESKTOP

%class wxSystemSettings, wxObject
wxSystemSettings()
static wxColour  GetColour(wxSystemColour index)
static wxFont  GetFont(wxSystemFont index)
static int GetMetric(wxSystemMetric index, wxWindow* win = NULL)
static wxSystemScreenType GetScreenType()

%builtin %rename wxSystemSettings_GetColour wxColour wxSystemSettings::GetColour(wxSystemColour index)
%builtin %rename wxSystemSettings_GetFont wxFont wxSystemSettings::GetFont(wxSystemFont index)
%builtin %rename wxSystemSettings_GetMetric int wxSystemSettings::GetMetric(wxSystemMetric index, wxWindow* win = NULL)
%builtin %rename wxSystemSettings_GetScreenType wxSystemScreenType wxSystemSettings::GetScreenType()

// #########################################################
// log.h

%include <wx/log.h>

%typedef wxLogLevel unsigned long
%typedef wxTraceMask unsigned long

%class %delete wxLog

%num wxTraceMemAlloc
%num wxTraceMessages
%num wxTraceResAlloc
%num wxTraceRefCount
%if(win) %num wxTraceOleCalls

%str wxTRACE_MemAlloc
%str wxTRACE_Messages
%str wxTRACE_ResAlloc
%str wxTRACE_RefCount

%if(win) %str wxTRACE_OleCalls

%num wxLOG_FatalError
%num wxLOG_Error
%num wxLOG_Warning
%num wxLOG_Message
%num wxLOG_Status
%num wxLOG_Info
%num wxLOG_Debug
%num wxLOG_Trace
%num wxLOG_Progress
%num wxLOG_User
%num wxLOG_Max


static bool IsEnabled()
static bool EnableLogging(bool doIt = true)
static void AddTraceMask(const wxString& mask)
static void ClearTraceMasks()
static const wxArrayString GetTraceMasks()
//const char * 
//static void OnLog(wxLogLevel  level, wxString& message) // OnLog as a third time_t t
static wxLog *  GetActiveTarget()
static wxLog *  SetActiveTarget(wxLog *  logtarget)
static void Suspend()
static void Resume()
//virtual void DoLog(wxLogLevel level, const wxChar *msg, time_t timestamp)
//virtual void DoLogString(const wxChar *msg, time_t timestamp)
static void DontCreateOnDemand()
virtual void Flush()
static void FlushActive()
static void SetVerbose(bool  verbose = true)
static bool GetVerbose()
static void SetLogLevel(wxLogLevel  logLevel)
static wxLogLevel GetLogLevel()
static void SetRepetitionCounting(bool  repetCounting = true)
static bool GetRepetitionCounting()
//const char *
void SetTimestamp(const wxString&  format)
//static const char*
static wxString GetTimestamp() const
static void SetTraceMask(wxTraceMask  mask)
static bool IsAllowedTraceMask(const wxChar *mask)
static void RemoveTraceMask(const wxString& mask)

%builtin %rename wxLog_IsEnabled bool wxLog::IsEnabled()
%builtin %rename wxLog_EnableLogging bool wxLog::EnableLogging(bool doIt = true)
%builtin %rename wxLog_AddTraceMask void wxLog::AddTraceMask(const wxString& mask)
%builtin %rename wxLog_ClearTraceMasks void wxLog::ClearTraceMasks()
%builtin %rename wxLog_GetTraceMasks const wxArrayString wxLog::GetTraceMasks()
//const char * 
//%builtin %rename wxLog_OnLog void wxLog::OnLog(wxLogLevel level, wxString& message)
%builtin %rename wxLog_GetActiveTarget wxLog * wxLog::GetActiveTarget()
%builtin %rename wxLog_SetActiveTarget wxLog * wxLog::SetActiveTarget(wxLog *  logtarget)
%builtin %rename wxLog_Suspend void wxLog::Suspend()
%builtin %rename wxLog_Resume void wxLog::Resume()
%builtin %rename wxLog_DontCreateOnDemand void wxLog::DontCreateOnDemand()
%builtin %rename wxLog_FlushActive void wxLog::FlushActive()
%builtin %rename wxLog_SetVerbose void wxLog::SetVerbose(bool  verbose = true)
%builtin %rename wxLog_GetVerbose bool wxLog::GetVerbose()
%builtin %rename wxLog_SetLogLevel void wxLog::SetLogLevel(wxLogLevel  logLevel)
%builtin %rename wxLog_GetLogLevel wxLogLevel wxLog::GetLogLevel()
%builtin %rename wxLog_SetRepetitionCounting void wxLog::SetRepetitionCounting(bool  repetCounting = true)
%builtin %rename wxLog_GetRepetitionCounting bool wxLog::GetRepetitionCounting()
// const char*
%builtin %rename wxLog_GetTimestamp const wxString wxLog::GetTimestamp()
%builtin %rename wxLog_SetTraceMask void wxLog::SetTraceMask(wxTraceMask  mask)
%builtin %rename wxLog_IsAllowedTraceMask bool wxLog::IsAllowedTraceMask(const wxChar *mask)
%builtin %rename wxLog_RemoveTraceMask void wxLog::RemoveTraceMask(const wxString& mask)

///////////////////////////////////////////////////////////////////////////////
// wxLogStderr

%class wxLogStderr, wxLog
wxLogStderr(FILE *fp = NULL)

///////////////////////////////////////////////////////////////////////////////
// wxLogNull
%class wxLogNull, wxLog
wxLogNull()

///////////////////////////////////////////////////////////////////////////////
// wxLogChain

%include <wx/log.h>
%class wxLogChain, wxLog
wxLogChain(wxLog *logger)
void DetachOldLog()
wxLog *  GetOldLog() const
bool IsPassingMessages() const
void PassMessages(bool passMessages)
void SetLog(wxLog *logger)

///////////////////////////////////////////////////////////////////////////////
// wxLogPassThrough

%include <wx/log.h>
%class wxLogPassThrough, wxLogChain

///////////////////////////////////////////////////////////////////////////////

%builtin unsigned long wxSysErrorCode()
%builtin wxString wxSysErrorMsg(unsigned long nErrCode = 0)

///////////////////////////////////////////////////////////////////////////////
// wxLogGui

%include <wx/log.h>
%class wxLogGui, wxLog
wxLogGui()

///////////////////////////////////////////////////////////////////////////////
// wxLogStream

//%include <wx/log.h>
//%class wxLogStream, wxLog
//wxLogStream(std::ostream *ostr = NULL)

///////////////////////////////////////////////////////////////////////////////
// wxLogTextCtrl

%include <wx/log.h>
%class wxLogTextCtrl, wxLog
wxLogTextCtrl(wxTextCtrl *textctrl)

///////////////////////////////////////////////////////////////////////////////
// wxLogWindow

%include <wx/log.h>
%class wxLogWindow, wxLogPassThrough
wxLogWindow(wxFrame *parent, const wxChar *title, bool show = true, bool passToOld = true)
void Show(bool show = true)
wxFrame *  GetFrame() const
//virtual void OnFrameCreate(wxFrame *frame)
//virtual bool OnFrameClose(wxFrame *frame)
//virtual void OnFrameDelete(wxFrame *frame)

///////////////////////////////////////////////////////////////////////////////
// wxFontEnumerator

%class wxFontEnumerator
%include "wx/fontenum.h"

%enum wxFontEncoding
  %num wxFONTENCODING_SYSTEM
  %num wxFONTENCODING_DEFAULT
  %num wxFONTENCODING_ISO8859_1
  %num wxFONTENCODING_ISO8859_2
  %num wxFONTENCODING_ISO8859_3
  %num wxFONTENCODING_ISO8859_4
  %num wxFONTENCODING_ISO8859_5
  %num wxFONTENCODING_ISO8859_6
  %num wxFONTENCODING_ISO8859_7
  %num wxFONTENCODING_ISO8859_8
  %num wxFONTENCODING_ISO8859_9
  %num wxFONTENCODING_ISO8859_10
  %num wxFONTENCODING_ISO8859_11
  %num wxFONTENCODING_ISO8859_12
  %num wxFONTENCODING_ISO8859_13
  %num wxFONTENCODING_ISO8859_14
  %num wxFONTENCODING_ISO8859_15
  %num wxFONTENCODING_ISO8859_MAX
  %num wxFONTENCODING_KOI8
  %num wxFONTENCODING_KOI8_U
  %num wxFONTENCODING_ALTERNATIVE
  %num wxFONTENCODING_BULGARIAN
  %num wxFONTENCODING_CP437
  %num wxFONTENCODING_CP850
  %num wxFONTENCODING_CP852
  %num wxFONTENCODING_CP855
  %num wxFONTENCODING_CP866
  %num wxFONTENCODING_CP874
  %num wxFONTENCODING_CP932
  %num wxFONTENCODING_CP936
  %num wxFONTENCODING_CP949
  %num wxFONTENCODING_CP950
  %num wxFONTENCODING_CP1250
  %num wxFONTENCODING_CP1251
  %num wxFONTENCODING_CP1252
  %num wxFONTENCODING_CP1253
  %num wxFONTENCODING_CP1254
  %num wxFONTENCODING_CP1255
  %num wxFONTENCODING_CP1256
  %num wxFONTENCODING_CP1257
  %num wxFONTENCODING_CP12_MAX
  %num wxFONTENCODING_UTF7
  %num wxFONTENCODING_UTF8
  %num wxFONTENCODING_EUC_JP
  %num wxFONTENCODING_UTF16BE
  %num wxFONTENCODING_UTF16LE
  %num wxFONTENCODING_UTF32BE
  %num wxFONTENCODING_UTF32LE
  %num wxFONTENCODING_MACROMAN
  %num wxFONTENCODING_MACJAPANESE
  %num wxFONTENCODING_MACCHINESETRAD
  %num wxFONTENCODING_MACKOREAN
  %num wxFONTENCODING_MACARABIC
  %num wxFONTENCODING_MACHEBREW
  %num wxFONTENCODING_MACGREEK
  %num wxFONTENCODING_MACCYRILLIC
  %num wxFONTENCODING_MACDEVANAGARI
  %num wxFONTENCODING_MACGURMUKHI
  %num wxFONTENCODING_MACGUJARATI
  %num wxFONTENCODING_MACORIYA
  %num wxFONTENCODING_MACBENGALI
  %num wxFONTENCODING_MACTAMIL
  %num wxFONTENCODING_MACTELUGU
  %num wxFONTENCODING_MACKANNADA
  %num wxFONTENCODING_MACMALAJALAM
  %num wxFONTENCODING_MACSINHALESE
  %num wxFONTENCODING_MACBURMESE
  %num wxFONTENCODING_MACKHMER
  %num wxFONTENCODING_MACTHAI
  %num wxFONTENCODING_MACLAOTIAN
  %num wxFONTENCODING_MACGEORGIAN
  %num wxFONTENCODING_MACARMENIAN
  %num wxFONTENCODING_MACCHINESESIMP
  %num wxFONTENCODING_MACTIBETAN
  %num wxFONTENCODING_MACMONGOLIAN
  %num wxFONTENCODING_MACETHIOPIC
  %num wxFONTENCODING_MACCENTRALEUR
  %num wxFONTENCODING_MACVIATNAMESE
  %num wxFONTENCODING_MACARABICEXT
  %num wxFONTENCODING_MACSYMBOL
  %num wxFONTENCODING_MACDINGBATS
  %num wxFONTENCODING_MACTURKISH
  %num wxFONTENCODING_MACCROATIAN
  %num wxFONTENCODING_MACICELANDIC
  %num wxFONTENCODING_MACROMANIAN
  %num wxFONTENCODING_MACCELTIC
  %num wxFONTENCODING_MACGAELIC
  %num wxFONTENCODING_MACKEYBOARD
  %num wxFONTENCODING_MAX
  %num wxFONTENCODING_MACMIN
  %num wxFONTENCODING_MACMAX
  %num wxFONTENCODING_UTF16
  %num wxFONTENCODING_UTF32
  %num wxFONTENCODING_UNICODE
  %num wxFONTENCODING_GB2312
  %num wxFONTENCODING_BIG5
  %num wxFONTENCODING_SHIFT_JIS

wxFontEnumerator()
virtual bool EnumerateFacenames(wxFontEncoding encoding = wxFONTENCODING_SYSTEM, bool fixedWidthOnly = false)
virtual bool EnumerateEncodings(const wxString& facename = wxEmptyString)
//virtual bool OnFacename(const wxString& WXUNUSED(facename))
//virtual bool OnFontEncoding(const wxString& WXUNUSED(facename), const wxString& WXUNUSED(encoding))
static wxArrayString GetFacenames(wxFontEncoding encoding = wxFONTENCODING_SYSTEM, bool fixedWidthOnly = false)
static wxArrayString GetEncodings(const wxString& facename = wxEmptyString)
static bool IsValidFacename(const wxString &str)

%builtin %rename wxFontEnumerator_GetFacenames wxArrayString wxFontEnumerator::GetFacenames(wxFontEncoding encoding = wxFONTENCODING_SYSTEM, bool fixedWidthOnly = false)
%builtin %rename wxFontEnumerator_GetEncodings wxArrayString wxFontEnumerator::GetEncodings(const wxString& facename = wxEmptyString)
%builtin %rename wxFontEnumerator_IsValidFacename bool wxFontEnumerator::IsValidFacename(const wxString &str)

///////////////////////////////////////////////////////////////////////////////
// wxFontList

%include <wx/gdicmn.h>
%class wxFontList, wxList
wxFontList()
wxFont *  FindOrCreateFont(int point_size, int family, int style, int weight, bool underline = false, const wxString& facename = wxT(""), wxFontEncoding encoding = wxFONTENCODING_DEFAULT)

///////////////////////////////////////////////////////////////////////////////
// wxFontMapper

%include <wx/fontmap.h>
%class wxFontMapper
wxFontMapper()
// ~wxFontMapper()
wxFontEncoding CharsetToEncoding(const wxString& charset, bool interactive = true)
static wxFontMapper *  Get()
// static const wxChar** GetAllEncodingNames(wxFontEncoding encoding)
// needs wrapper
//bool GetAltForEncoding(wxFontEncoding encoding, wxNativeEncodingInfo* info, const wxString& facename = wxEmptyString, bool interactive = true)
static wxFontEncoding GetEncoding(size_t n)
static wxString  GetEncodingDescription(wxFontEncoding encoding)
static wxFontEncoding GetEncodingFromName(const wxString& encoding)
static wxString  GetEncodingName(wxFontEncoding encoding)
static size_t GetSupportedEncodingsCount()
bool IsEncodingAvailable(wxFontEncoding encoding, const wxString& facename = wxEmptyString)
void SetDialogParent(wxWindow* parent)
void SetDialogTitle(const wxString& title)
static wxFontMapper *  Set(wxFontMapper *mapper)
//void SetConfig(wxConfigBase* config)
void SetConfigPath(const wxString& prefix)

%builtin %rename wxFontMapper_Get wxFontMapper * wxFontMapper::Get()
//%builtin %rename wxFontMapper_GetAllEncodingNames const wxChar** wxFontMapper::GetAllEncodingNames(wxFontEncoding encoding)
%builtin %rename wxFontMapper_GetEncoding wxFontEncoding wxFontMapper::GetEncoding(size_t n)
%builtin %rename wxFontMapper_GetEncodingDescription wxString wxFontMapper::GetEncodingDescription(wxFontEncoding encoding)
%builtin %rename wxFontMapper_GetEncodingFromName wxFontEncoding wxFontMapper::GetEncodingFromName(const wxString& encoding)
%builtin %rename wxFontMapper_GetEncodingName wxString wxFontMapper::GetEncodingName(wxFontEncoding encoding)
%builtin %rename wxFontMapper_GetSupportedEncodingsCount size_t wxFontMapper::GetSupportedEncodingsCount()
%builtin %rename wxFontMapper_Set wxFontMapper * wxFontMapper::Set(wxFontMapper *mapper)

// #########################################################
// string conversion

%include <wx/strconv.h>
%class wxMBConv
const wxWCharBuffer cMB2WX(const char *psz)
wxMBConv *Clone() const

%ptr wxConvCurrent
%ptr wxConvUI
%ptr wxConvFileName
%ptr &wxConvLibc
%ptr &wxConvUTF7
%ptr &wxConvUTF8

%class wxCSConv, wxMBConv

wxCSConv(const wxChar *charset)
%ctor wxCSConvFromFontEncoding(wxFontEncoding encoding)
%ctor wxCSConvCopy(const wxCSConv& conv)
//virtual ~wxCSConv();
virtual size_t ToWChar(wchar_t *dst, size_t dstLen, const char *src, size_t srcLen = wxNO_LEN) const
virtual size_t FromWChar(char *dst, size_t dstLen, const wchar_t *src, size_t srcLen = wxNO_LEN) const
virtual size_t MB2WC(wchar_t *outputBuf, const char *psz, size_t outputSize) const
virtual size_t WC2MB(char *outputBuf, const wchar_t *psz, size_t outputSize) const
virtual size_t GetMBNulLen() const
virtual wxMBConv *Clone() const
void Clear()
bool IsOk() const

%ptr &wxConvISO8859_1
%ptr &wxConvLocal

%class wxWCharBuffer
%builtin wxString wxSafeConvertMB2WX(const char *s)

%class wxMBConvUTF16
%class wxMBConvUTF32
%class wxMBConvUTF7
%class wxMBConvUTF8

// #########################################################
// ffile.h

%include <wx/ffile.h>

%typedef wxFileOffset off_t
%enum wxSeekMode
%enum wxFileKind

// ==============================
// Class: wxFFile

%include <wx/ffile.h>

%class wxFFile

%enum  wxFileKind
  %num wxFILE_KIND_UNKNOWN
  %num wxFILE_KIND_DISK
  %num wxFILE_KIND_TERMINAL
  %num wxFILE_KIND_PIPE

wxFFile(const wxChar *filename, const wxChar *mode = wxT("r"))
%ctor wxFFileNoOpen()
%ctor wxFFileByFILE(FILE *lfp)
bool Open(const wxChar *filename, const wxChar *mode = wxT("r"))
bool Close()
void Attach(FILE *lfp, const wxString& name = wxEmptyString)
void Detach()
FILE *fp() const
// TODO: needs wrapper
//bool ReadAll(wxString *str, const wxMBConv& conv = wxConvAuto())
//bool ReadAll(wxString* str)
size_t Read(void *pBuf, size_t nCount)
%rename WriteData size_t Write(const void *pBuf, size_t nCount)
//bool Write(const wxString& s, const wxMBConv& conv = wxConvAuto())
bool Write(const wxString& s)
bool Flush()
%not(gtk) bool Seek(wxFileOffset ofs, wxSeekMode mode = wxFromStart)
%not(gtk) bool SeekEnd(wxFileOffset ofs = 0)
wxFileOffset Tell() const
wxFileOffset Length() const
bool IsOpened() const
bool Eof() const
bool Error() const
const wxString& GetName() const
wxFileKind GetKind() const

///////////////////////////////////////////////////////////////////////////////
// wxFile

%class %delete wxFile
%include "wx/file.h"

//wxFile()
wxFile(const wxChar* filename, wxFile::OpenMode mode = wxFile::read)
%ctor wxFileById(int fd)
%ctor wxFileNoOpen()
static bool Access(const wxChar * name, wxFile::OpenMode mode)
void Attach(int fd)
void Close()
bool Create(const wxChar *szFileName, bool bOverwrite = false, int access = wxS_DEFAULT)
void Detach()
int fd() const
bool Eof() const
static bool Exists(const wxChar* filename)
bool Flush()
bool IsOpened() const
off_t Length() const
//bool Open(const char* filename, wxFile::OpenMode mode = wxFile::read)
bool Open(const wxChar *szFileName, wxFile::OpenMode mode = wxFile::read, int access = wxS_DEFAULT)
off_t Read(void* buffer, off_t count)
%not(gtk) off_t Seek(off_t ofs, wxSeekMode mode = wxFromStart)
%not(gtk) off_t SeekEnd(off_t ofs = 0)
off_t Tell() const
//size_t Write(const void* buffer, off_t count)
// FIXME: wxMBConv is not defined
//bool Write(const wxString& s, wxMBConv& conv = wxConvLibc)
//size_t Write(const void *pBuf, size_t nCount)
//bool Write(const wxString& s, const wxMBConv& conv = wxConvUTF8)
bool Write(const wxString& s)
bool Error() const
wxFileKind GetKind() const

%num wxS_IRUSR
%num wxS_IWUSR
%num wxS_IXUSR
%num wxS_IRGRP
%num wxS_IWGRP
%num wxS_IXGRP
%num wxS_IROTH
%num wxS_IWOTH
%num wxS_IXOTH
%num wxS_DEFAULT

%builtin %rename wxFile_Access bool wxFile::Access(const wxChar * name, wxFile::OpenMode mode)
%builtin %rename wxFile_Exists bool wxFile::Exists(const wxChar* filename)

///////////////////////////////////////////////////////////////////////////////
// wxFSFile

%include <wx/filesys.h>
%class %delete wxFSFile, wxObject

wxFSFile(wxInputStream *stream, const wxString& loc, const wxString& mimetype, const wxString& anchor, wxDateTime modif)
wxInputStream* DetachStream()
const wxString&  GetAnchor() const
const wxString&  GetLocation() const
const wxString&  GetMimeType() const
wxDateTime  GetModificationTime() const
wxInputStream*  GetStream() const
void SetStream(wxInputStream *stream)

// ==============================
// Class: wxTempFile

%class %delete wxTempFile
%ctor wxTempFileNoOpen()
wxTempFile(const wxString& strName)
bool Open(const wxString& strName)
bool IsOpened() const
wxFileOffset Length() const
%not(gtk) wxFileOffset Seek(wxFileOffset ofs, wxSeekMode mode = wxFromStart)
wxFileOffset Tell() const
%rename WriteData bool Write(const void *p, size_t n)
//bool Write(const wxString& str, const wxMBConv& conv = wxConvUTF8)
bool Write(const wxString& str)
bool Commit()
void Discard()

///////////////////////////////////////////////////////////////////////////////
// wxTextFile

%include <wx/textfile.h>
%enum  wxTextFileType
  %num wxTextFileType_None
  %num wxTextFileType_Unix
  %num wxTextFileType_Dos
  %num wxTextFileType_Mac
%class wxTextFile
%ctor wxTextFileEmpty()
wxTextFile(const wxString& strFile)
// ~wxTextFile() const
void AddLine(const wxString& str, wxTextFileType type = wxTextBuffer::typeDefault) const
bool Close() const
bool Create() const
bool Exists() const
bool IsOpened() const
size_t GetLineCount() const
wxString&  GetLine(size_t n) const
size_t GetCurrentLine() const
void GoToLine(size_t n) const
bool Eof() const
static const wxChar* GetEOL(wxTextFileType type = wxTextBuffer::typeDefault) const
wxString&  GetFirstLine() const
wxString&  GetNextLine()
wxString&  GetPrevLine()
wxString&  GetLastLine()
wxTextFileType GetLineType(size_t n) const
wxTextFileType GuessType() const
const wxChar* GetName() const
void InsertLine(const wxString& str, size_t n, wxTextFileType type = wxTextBuffer::typeDefault) const
bool Open(wxMBConv& conv = wxConvUTF8) const
void RemoveLine(size_t n) const
void Clear() const
bool Write(wxTextFileType typeNew = wxTextFileType_None, wxMBConv& conv = wxConvUTF8) const

// %builtin %rename wxTextFile_GetEOL const char* wxTextFile::GetEOL(wxTextFileType type = wxTextBuffer::typeDefault) const

///////////////////////////////////////////////////////////////////////////////
// wxFileName

%include "wx/list.h"

%class %delete wxFileName

%enum  wxPathFormat
  %num wxPATH_NATIVE
  %num wxPATH_UNIX
  %num wxPATH_BEOS
  %num wxPATH_MAC
  %num wxPATH_DOS
  %num wxPATH_WIN
  %num wxPATH_OS2
  %num wxPATH_VMS
  %num wxPATH_MAX

wxFileName(const wxString& fullpath, wxPathFormat format = wxPATH_NATIVE)
%ctor wxFileNameEmpty()
%ctor wxFileNameCopy(const wxFileName& filename)
//wxFileName(const wxString& path, const wxString& name, wxPathFormat format = wxPATH_NATIVE)
//wxFileName(const wxString& path, const wxString& name, const wxString& ext, wxPathFormat format = wxPATH_NATIVE)
//wxFileName(const wxString& volume, const wxString& path, const wxString& name, const wxString& ext, wxPathFormat format = wxPATH_NATIVE)

void AppendDir(const wxString& dir)
void Assign(const wxFileName& filepath)
// FIXME: create aliases
//void Assign(const wxString& fullpath, wxPathFormat format = wxPATH_NATIVE)
//void Assign(const wxString& volume, const wxString& path, const wxString& name, const wxString& ext, wxPathFormat format = wxPATH_NATIVE)
//void Assign(const wxString& path, const wxString& name, wxPathFormat format = wxPATH_NATIVE)
//void Assign(const wxString& path, const wxString& name, const wxString& ext, wxPathFormat format = wxPATH_NATIVE)
void AssignCwd(const wxString& volume = wxT(""))
void AssignDir(const wxString& dir, wxPathFormat format = wxPATH_NATIVE)
void AssignHomeDir()
void AssignTempFileName(const wxString& prefix, wxFile *fileTemp = NULL)
void Clear()
static wxString CreateTempFileName(const wxString& prefix, wxFile *fileTemp = NULL)
bool DirExists()
// FIXME: alias
//bool DirExists(const wxString& dir)
wxFileName DirName(const wxString& dir)
bool FileExists()
// FIXME: alias
//bool FileExists(const wxString& file)
wxFileName FileName(const wxString& file)
wxString GetCwd(const wxString& volume = wxT(""))
size_t GetDirCount() const
// FIXME: string arrays not supported yet
// TODO: needs wrapper
const wxArrayString& GetDirs() const
wxString GetExt() const
wxPathFormat GetFormat(wxPathFormat format = wxPATH_NATIVE)
wxString GetFullName() const
wxString GetFullPath(wxPathFormat format = wxPATH_NATIVE) const
wxString GetHomeDir()
wxString GetLongPath() const
wxDateTime GetModificationTime() const
wxString GetName() const
wxString GetPath(int flags = 0, wxPathFormat format = wxPATH_NATIVE) const
//wxChar GetPathSeparator(wxPathFormat format = wxPATH_NATIVE)
wxString GetPathSeparators(wxPathFormat format = wxPATH_NATIVE)
wxString GetShortPath() const
bool GetTimes(wxDateTime* dtAccess, wxDateTime* dtMod, wxDateTime* dtCreate) const
wxString GetVolume() const
wxString GetVolumeSeparator(wxPathFormat format = wxPATH_NATIVE)
bool HasExt() const
bool HasName() const
bool HasVolume() const
void InsertDir(int before, const wxString& dir)
bool IsAbsolute(wxPathFormat format = wxPATH_NATIVE)
bool IsCaseSensitive(wxPathFormat format = wxPATH_NATIVE)
bool IsOk() const
bool IsPathSeparator(wxChar ch, wxPathFormat format = wxPATH_NATIVE)
bool IsRelative(wxPathFormat format = wxPATH_NATIVE)
bool IsDir() const
bool MakeAbsolute(const wxString& cwd = wxEmptyString, wxPathFormat format = wxPATH_NATIVE)
bool MakeRelativeTo(const wxString& pathBase = wxT(""), wxPathFormat format = wxPATH_NATIVE)
bool Mkdir(int perm = 0777, int flags = 0)
// FIXME: alias
// static bool Mkdir(const wxString& dir, int perm = 0777, int flags = 0)
bool Normalize(int flags = wxPATH_NORM_ALL, const wxString& cwd = wxEmptyString, wxPathFormat format = wxPATH_NATIVE)
void PrependDir(const wxString& dir)
void RemoveDir(int pos)
bool Rmdir()
// FIXME: alias
//static bool Rmdir(const wxString& dir)
bool SameAs(const wxFileName& filepath, wxPathFormat format = wxPATH_NATIVE) const
bool SetCwd()
// FIXME: alias
%rename SetCwdString static bool SetCwd(const wxString& cwd)
void SetExt(const wxString& ext)
void SetFullName(const wxString& fullname)
void SetName(const wxString& name)
bool SetTimes(const wxDateTime* dtAccess, const wxDateTime* dtMod, const wxDateTime* dtCreate)
void SetVolume(const wxString& volume)
// FIXME: these need wrappers, because they return values back via pointers
//static void SplitPath(const wxString& fullpath, wxString* volume, wxString* path, wxString* name, wxString* ext, wxPathFormat format = wxPATH_NATIVE)
// static void SplitPath(const wxString& fullpath, wxString* path, wxString* name, wxString* ext, wxPathFormat format = wxPATH_NATIVE)
bool Touch()

//void SetClearExt()
static wxString  GetForbiddenChars(wxPathFormat format = wxPATH_NATIVE)
static wxString  GetPathTerminators(wxPathFormat format = wxPATH_NATIVE)
wxString  GetPathWithSep(wxPathFormat format = wxPATH_NATIVE) const
//TODO wxULongLong
//wxULongLong GetSize() const
wxString  GetHumanReadableSize(const wxString& failmsg = _("Not available"), int precision = 1) const
static wxString  GetTempDir()
bool IsDirReadable() const
bool IsDirWritable() const
bool IsFileExecutable() const
bool IsFileReadable() const
bool IsFileWritable() const
//TOOD: needs wrapper
//%if(mac) static bool MacFindDefaultTypeAndCreator(const wxString& ext, wxUint32* type, wxUint32* creator)
//%if(mac) static void MacRegisterDefaultTypeAndCreator(const wxString& ext, wxUint32 type, wxUint32 creator)
%if(mac) bool MacSetDefaultTypeAndCreator()
void RemoveLastDir()
void SetEmptyExt()
//FIXME: needs wrapper
//static void SplitVolume(const wxString& fullpath, wxString* volume, wxString* path, wxPathFormat format = wxPATH_NATIVE)

// enum wxPathNormalize
%num wxPATH_NORM_ENV_VARS
%num wxPATH_NORM_DOTS
%num wxPATH_NORM_TILDE
%num wxPATH_NORM_CASE
%num wxPATH_NORM_ABSOLUTE
%num wxPATH_NORM_LONG
%num wxPATH_NORM_ALL

// for GetPath
%num wxPATH_GET_VOLUME
%num wxPATH_GET_SEPARATOR
%num wxPATH_MKDIR_FULL

///////////////////////////////////////////////////////////////////////////////
// wxMimeTypesManager

%include <wx/mimetype.h>

%class wxMimeTypesManager
wxMimeTypesManager()
// ~wxMimeTypesManager()
//void AddFallbacks(const wxFileTypeInfo *fallbacks)
wxFileType*  GetFileTypeFromExtension(const wxString& extension)
wxFileType*  GetFileTypeFromMimeType(const wxString& mimeType)
bool IsOfType(const wxString& mimeType, const wxString& wildcard)
bool ReadMailcap(const wxString& filename, bool fallback = false)
bool ReadMimeTypes(const wxString& filename)

%ptr wxTheMimeTypesManager

///////////////////////////////////////////////////////////////////////////////
// wxIconLocation

%include <wx/iconloc.h>
%class wxIconLocation
%if(win) wxIconLocation(const wxString& filename = wxT(""), int num = 0)
%not(win) wxIconLocation(const wxString& filename = wxT(""))
bool IsOk() const
void SetFileName(const wxString& filename)
const wxString& GetFileName()
%if(win) void SetIndex(int num)
%if(win) int GetIndex() const

///////////////////////////////////////////////////////////////////////////////
// wxFileType

%include <wx/mimetype.h>

MessageParameters

%class wxFileType::MessageParameters
wxFileType::MessageParameters(const wxString& filename, const wxString& mimetype = wxT(""))
const wxString& GetFileName() const
const wxString& GetMimeType() const

%class wxFileType
//wxFileType()
// ~wxFileType()

%{
	// bool GetMimeTypes(wxArrayString& mimeTypes)
	void wxFileType_GetMimeTypes()
	{
		wxArrayString* mimeTypes = new wxArrayString;
		//wxArrayString *mimeTypes = (wxArrayString *)wStackPopObjectPtr( _wxArrayString );

		int ok = (int) ((wxFileType*)(wTheCall->self->ptr))->GetMimeTypes(*mimeTypes);

		wWrapDerefArgs();
		wStackPushInteger( (wInteger) ok );
		wWrapPushObject( _wxArrayString, W_TRUE, (void *)mimeTypes );
	}
	
	// bool GetExtensions(wxArrayString& extensions)
	void wxFileType_GetExtensions()
	{
		wxArrayString* extensions = new wxArrayString;
		//wxArrayString *extensions = (wxArrayString *)wStackPopObjectPtr( _wxArrayString );

		int ok = (int) ((wxFileType*)(wTheCall->self->ptr))->GetExtensions(*extensions);

		wWrapDerefArgs();
		wStackPushInteger( (wInteger) ok );
		wWrapPushObject( _wxArrayString, W_TRUE, (void *)extensions );
	}

	//bool GetIcon(wxIconLocation * iconLoc)
	void wxFileType_GetIcon()
	{
		wxIconLocation* iconLoc = new wxIconLocation;

		int ok = (int) ((wxFileType*)(wTheCall->self->ptr))->GetIcon(iconLoc);

		wWrapDerefArgs();
		wStackPushInteger( (wInteger) ok );
		wWrapPushObject( _wxIconLocation, W_TRUE, (void *)iconLoc );
	}

	//bool GetDescription(wxString* desc)
	void wxFileType_GetDescription()
	{
		wxString* desc = new wxString;

		int ok = (int) ((wxFileType*)(wTheCall->self->ptr))->GetDescription(desc);

		wWrapDerefArgs();
		wStackPushInteger( (wInteger) ok );
		wWrapPushObject( _wxString, W_TRUE, (void *)desc );
	}

	//bool GetPrintCommand(wxString* command,MessageParameters& params)
	void wxFileType_GetPrintCommand()
	{
		wxString* command = new wxString;
		wxFileType::MessageParameters* params = (wxFileType::MessageParameters*)wStackPopObjectPtr( _wxFileType_MessageParameters );

		int ok = (int) ((wxFileType*)(wTheCall->self->ptr))->GetPrintCommand(command, *params);

		wWrapDerefArgs();
		wStackPushInteger( (wInteger) ok );
		wWrapPushObject( _wxString, W_TRUE, (void *)command );
	}

%}

%method GetMimeTypes wxFileType_GetMimeTypes()
%method GetExtensions wxFileType_GetExtensions()
%method GetIcon wxFileType_GetIcon()
%method GetDescription() wxFileType_GetDescription()
%method GetPrintCommand() wxFileType_GetPrintCommand()

wxString GetOpenCommand(const wxString& filename) const

static wxString ExpandCommand(const wxString& command, wxFileType::MessageParameters& params)

%builtin %rename wxFileType_ExpandCommand wxString wxFileType::ExpandCommand(const wxString& command, wxFileType::MessageParameters& params)

///////////////////////////////////////////////////////////////////////////////
// wxPathList

%include <wx/filefn.h>
%class wxPathList, wxArrayString
wxPathList()
void AddEnvList(const wxString& env_variable)
bool Add(const wxString& path)
bool EnsureFileAccessible(const wxString& filename)
wxString  FindAbsoluteValidPath(const wxString& file) const
wxString  FindValidPath(const wxString& file) const

///////////////////////////////////////////////////////////////////////////////
// wxFileSystemHandler

%include <wx/filesys.h>
%class wxFileSystemHandler, wxObject
// Abstract class
//wxFileSystemHandler()
virtual bool CanOpen(const wxString& location)
// protected
//wxString  GetAnchor(const wxString& location) const
//wxString  GetLeftLocation(const wxString& location) const
//wxString  GetMimeTypeFromExt(const wxString& location)
//wxString  GetProtocol(const wxString& location) const
//wxString  GetRightLocation(const wxString& location) const
virtual wxString  FindFirst(const wxString& wildcard, int flags = 0)
virtual wxString  FindNext()
virtual wxFSFile*  OpenFile(wxFileSystem& fs, const wxString& location)

// ==============================
// Class: wxLocalFSHandler

%class wxLocalFSHandler, wxFileSystemHandler
virtual bool CanOpen(const wxString& location)
virtual wxFSFile* OpenFile(wxFileSystem& fs, const wxString& location)
virtual wxString FindFirst(const wxString& spec, int flags = 0)
virtual wxString FindNext()
static void Chroot(const wxString& root)

%builtin %rename wxLocalFSHandler_Chroot void wxLocalFSHandler::Chroot(const wxString& root)

// ==============================
// wxMemoryFSHandlerBase

%include <wx/fs_mem.h>

%class wxMemoryFSHandler, wxFileSystemHandler
wxMemoryFSHandler()
void AddFile(const wxString& filename, const wxString& textdata)
%rename AddFileFromBinary void AddFile(const wxString& filename, const void *binarydata, size_t size)
void AddFileWithMimeType(const wxString& filename, const wxString& textdata, const wxString& mimetype)
%rename AddFileWithMimeTypeFromBinary void AddFileWithMimeType(const wxString& filename, const void *binarydata, size_t size, const wxString& mimetype)
void RemoveFile(const wxString& filename)
bool CanOpen(const wxString& location)
wxFSFile* OpenFile(wxFileSystem& fs, const wxString& location)
wxString FindFirst(const wxString& spec, int flags = 0)
wxString FindNext()
%rename AddImageFile void AddFile(const wxString& filename, const wxImage& image, long type)
%rename AddBitmapFile void AddFile(const wxString& filename, const wxBitmap& bitmap, long type)

%builtin %rename wxMemoryFSHandler_AddFile void wxMemoryFSHandler::AddFile(const wxString& filename, const wxString& textdata)
%builtin %rename wxMemoryFSHandler_AddFileFromBinary void wxMemoryFSHandler::AddFile(const wxString& filename, const void *binarydata, size_t size)
%builtin %rename wxMemoryFSHandler_AddFileWithMimeType void wxMemoryFSHandler::AddFileWithMimeType(const wxString& filename, const wxString& textdata, const wxString& mimetype)
%builtin %rename wxMemoryFSHandler_AddFileWithMimeTypeFromBinary void wxMemoryFSHandler::AddFileWithMimeType(const wxString& filename, const void *binarydata, size_t size, const wxString& mimetype)
%builtin %rename wxMemoryFSHandler_RemoveFile void wxMemoryFSHandler::RemoveFile(const wxString& filename)
%builtin %rename wxMemoryFSHandler_AddImageFile void wxMemoryFSHandler::AddFile(const wxString& filename, const wxImage& image, long type)
%builtin %rename wxMemoryFSHandler_AddBitmapFile void wxMemoryFSHandler::AddFile(const wxString& filename, const wxBitmap& bitmap, long type)

%include <wx/fs_arc.h>
%class wxArchiveFSHandler, wxFileSystemHandler
wxArchiveFSHandler()

%include <wx/fs_filter.h>
%class wxFilterFSHandler, wxFileSystemHandler
wxFilterFSHandler()

%include <wx/fs_inet.h>
%class wxInternetFSHandler, wxFileSystemHandler
wxInternetFSHandler()

// ==============================
// Class: wxFileSystem

%class %delete wxFileSystem, wxObject

%num wxFS_READ
%num wxFS_SEEKABLE

wxFileSystem()
static void AddHandler(wxFileSystemHandler *handler)
static bool HasHandlerForPath(const wxString & location)
void ChangePathTo(const wxString& location, bool is_dir = false)
wxString  GetPath()
static wxString  FileNameToURL(const wxFileName& filename)
//RP wxString* and wxString& doesn't work well
//bool FindFileInPath(wxString* str, const wxChar* path, const wxChar* file)
wxString  FindFirst(const wxString& wildcard, int flags = 0)
wxString  FindNext()
wxFSFile*  OpenFile(const wxString& location, int flags = wxFS_READ)
static wxFileName URLToFileName(const wxString& url)

%builtin %rename wxFileSystem_AddHandler void wxFileSystem::AddHandler(wxFileSystemHandler *handler)
%builtin %rename wxFileSystem_HasHandlerForPath bool wxFileSystem::HasHandlerForPath(const wxString & location)
%builtin %rename wxFileSystem_FileNameToURL wxString wxFileSystem::FileNameToURL(const wxFileName& filename)
%builtin %rename wxFileSystem_URLToFileName wxFileName wxFileSystem::URLToFileName(const wxString& url)

// #########################################################
// confbase.h

%include <wx/confbase.h>

%num wxCONFIG_CASE_SENSITIVE
%num wxUSE_CONFIG_NATIVE

%num wxCONFIG_USE_LOCAL_FILE
%num wxCONFIG_USE_GLOBAL_FILE
%num wxCONFIG_USE_RELATIVE_PATH
%num wxCONFIG_USE_NO_ESCAPE_CHARACTERS
%num wxCONFIG_USE_SUBDIR

// ==============================
// Class: wxConfigBase

%typedef EntryType int

%class %delete wxConfigBase
static wxConfigBase *Set(wxConfigBase *pConfig)
static wxConfigBase *Get(bool createOnDemand = true)
static wxConfigBase *Create()
static void DontCreateOnDemand()
//wxConfigBase(const wxString& appName = wxEmptyString, const wxString& vendorName = wxEmptyString, const wxString& localFilename = wxEmptyString, const wxString& globalFilename = wxEmptyString, long style = 0)
virtual void SetPath(const wxString& strPath)
virtual const wxString& GetPath() const
virtual bool GetFirstGroup(wxString& str, long& lIndex) const
virtual bool GetNextGroup (wxString& str, long& lIndex) const
virtual bool GetFirstEntry(wxString& str, long& lIndex) const
virtual bool GetNextEntry (wxString& str, long& lIndex) const
virtual size_t GetNumberOfEntries(bool bRecursive = false) const
virtual size_t GetNumberOfGroups(bool bRecursive = false) const
virtual bool HasGroup(const wxString& strName) const
virtual bool HasEntry(const wxString& strName) const
bool Exists(const wxString& strName) const
virtual EntryType GetEntryType(const wxString& name) const

//bool Read(const wxString& key, wxString *pStr) const
//bool Read(const wxString& key, wxString *pStr, const wxString& defVal) const
//bool Read(const wxString& key, long *pl) const
//bool Read(const wxString& key, long *pl, long defVal) const
//bool Read(const wxString& key, int *pi) const
//bool Read(const wxString& key, int *pi, int defVal) const
//bool Read(const wxString& key, double* val) const
//bool Read(const wxString& key, double* val, double defVal) const
//bool Read(const wxString& key, bool* val) const
//bool Read(const wxString& key, bool* val, bool defVal) const
wxString Read(const wxString& key, const wxString& defVal = wxEmptyString) const
//long Read(const wxString& key, long defVal) const

bool Write(const wxString& key, const wxString& value)
//bool Write(const wxString& key, long value)
//bool Write(const wxString& key, int value)
//bool Write(const wxString& key, double value)
//bool Write(const wxString& key, bool value)
//bool Write(const wxString& key, const wxChar *value)

virtual bool Flush(bool bCurrentOnly = false)
virtual bool RenameEntry(const wxString& oldName, const wxString& newName)
virtual bool RenameGroup(const wxString& oldName, const wxString& newName)
virtual bool DeleteEntry(const wxString& key, bool bDeleteGroupIfEmpty = true)
virtual bool DeleteGroup(const wxString& key)
virtual bool DeleteAll()
bool IsExpandingEnvVars() const
void SetExpandEnvVars(bool bDoIt = true)
void SetRecordDefaults(bool bDoIt = true)
bool IsRecordingDefaults() const
wxString ExpandEnvVars(const wxString& str) const
wxString GetAppName() const
wxString GetVendorName() const
void SetAppName(const wxString& appName)
void SetVendorName(const wxString& vendorName)
void SetStyle(long style)
long GetStyle() const

%builtin %rename wxConfigBase_Create wxConfigBase * wxConfigBase::Create()
%builtin %rename wxConfigBase_Get wxConfigBase * wxConfigBase::Get(bool CreateOnDemand = true)
%builtin %rename wxConfigBase_Set wxConfigBase * wxConfigBase::Set(wxConfigBase *pConfig)

// ==============================
// Class: wxFileConfig

%include <wx/fileconf.h>

%class %delete wxFileConfig, wxConfigBase
static wxString GetGlobalFileName(const wxChar *szFile)
static wxString GetLocalFileName(const wxChar *szFile)
wxFileConfig(const wxString& appName = wxEmptyString, const wxString& vendorName = wxEmptyString, const wxString& localFilename = wxEmptyString, const wxString& globalFilename = wxEmptyString, long style = wxCONFIG_USE_LOCAL_FILE | wxCONFIG_USE_GLOBAL_FILE)
//, const wxMBConv& conv = wxConvAuto())
%ctor wxFileConfigStream(wxInputStream &inStream) //, const wxMBConv& conv = wxConvAuto())
void SetUmask(int mode)
virtual void SetPath(const wxString& strPath)
virtual const wxString& GetPath() const
virtual bool GetFirstGroup(wxString& str, long& lIndex) const
virtual bool GetNextGroup (wxString& str, long& lIndex) const
virtual bool GetFirstEntry(wxString& str, long& lIndex) const
virtual bool GetNextEntry (wxString& str, long& lIndex) const
virtual size_t GetNumberOfEntries(bool bRecursive = false) const
virtual size_t GetNumberOfGroups(bool bRecursive = false) const
virtual bool HasGroup(const wxString& strName) const
virtual bool HasEntry(const wxString& strName) const
virtual bool Flush(bool bCurrentOnly = false)
virtual bool RenameEntry(const wxString& oldName, const wxString& newName)
virtual bool RenameGroup(const wxString& oldName, const wxString& newName)
virtual bool DeleteEntry(const wxString& key, bool bGroupIfEmptyAlso = true)
virtual bool DeleteGroup(const wxString& szKey)
virtual bool DeleteAll()
//virtual bool Save(wxOutputStream& os, const wxMBConv& conv = wxConvAuto())
//wxFileConfigLineList *LineListAppend(const wxString& str)
//wxFileConfigLineList *LineListInsert(const wxString& str, wxFileConfigLineList *pLine);
bool      LineListIsEmpty()

// #########################################################
// regconf.h

// ===============wx/stdpaths===============
// Class: wxRegConfig

%if(win) %class wxRegConfig, wxConfigBase
%include <wx/msw/regconf.h>
wxRegConfig(const wxString& appName = wxEmptyString, const wxString& vendorName = wxEmptyString, const wxString& localFilename = wxEmptyString, const wxString& globalFilename = wxEmptyString, long style = wxCONFIG_USE_GLOBAL_FILE)
virtual void SetPath(const wxString& strPath)
virtual const wxString& GetPath() const
virtual bool GetFirstGroup(wxString& str, long& lIndex) const
virtual bool GetNextGroup (wxString& str, long& lIndex) const
virtual bool GetFirstEntry(wxString& str, long& lIndex) const
virtual bool GetNextEntry (wxString& str, long& lIndex) const
virtual bool HasGroup(const wxString& strName) const
virtual bool HasEntry(const wxString& strName) const
virtual EntryType GetEntryType(const wxString& name) const
virtual size_t GetNumberOfEntries(bool bRecursive = false) const
virtual size_t GetNumberOfGroups(bool bRecursive = false) const
virtual bool Flush(bool bCurrentOnly = false)
virtual bool RenameEntry(const wxString& oldName, const wxString& newName)
virtual bool RenameGroup(const wxString& oldName, const wxString& newName)
virtual bool DeleteEntry(const wxString& key, bool bGroupIfEmptyAlso = true)
virtual bool DeleteGroup(const wxString& key)
virtual bool DeleteAll()

// #########################################################
// stdpaths.h

// ==============================
// Class: wxStandardPaths

%class wxStandardPathsBase
%include <wx/stdpaths.h>

//void SetInstallPrefix(const wxString& prefix)
//wxString GetInstallPrefix() const
virtual wxString GetResourcesDir() const
//wxChar *
%not(mac) wxString GetLocalizedResourcesDir(const wxString& lang)
//, ResourceCat category = wxStandardPathsBase::ResourceCat_None) const
virtual wxString GetTempDir() const
virtual wxString GetExecutablePath() const
virtual wxString GetConfigDir() const
virtual wxString GetUserConfigDir() const
virtual wxString GetDataDir() const
virtual wxString GetLocalDataDir() const
virtual wxString GetUserDataDir() const
virtual wxString GetPluginsDir() const
virtual wxString GetDocumentsDir() const
virtual wxString GetUserLocalDataDir() const

%builtin %rename wxStandardPaths_Get wxStandardPathsBase& wxStandardPaths::Get()

%num %rename wxStandardPathsBase_ResourceCat_None wxStandardPathsBase::ResourceCat_None
%num %rename wxStandardPathsBase_ResourceCat_Messages wxStandardPathsBase::ResourceCat_Messages
%num %rename wxStandardPathsBase_ResourceCat_Max wxStandardPathsBase::ResourceCat_Max

///////////////////////////////////////////////////////////////////////////////
// wxLocale

%class %delete wxLocale
%include "wx/intl.h"
%include "wx/html/htmlpars.h"

wxLocale()
// replaced all "const char*" with "wxString"
bool AddCatalog(const wxString& szDomain)
void AddCatalogLookupPathPrefix(const wxString& prefix)
// FIXME: needs custom wrapper for wxLanguageInfo structure
// static void AddLanguage(const wxLanguageInfo& info)
wxString GetCanonicalName() const
int GetLanguage() const
// FIXME: needs custom wrapper for wxLanguageInfo structure
// static wxLanguageInfo * GetLanguageInfo(int lang) const
const wxString GetLocale() const
const wxString GetName() const
const wxChar *GetString(const wxChar *szOrigString, const wxChar *szDomain = NULL) const
%rename GetStringPlural const wxChar *GetString(const wxChar *szOrigString,const wxChar *szOrigString2, size_t n, const wxChar *szDomain = NULL) const
wxString GetSysName() const
static wxFontEncoding GetSystemEncoding() const
static wxString GetSystemEncodingName() const
static int GetSystemLanguage() const
bool Init(int language = wxLANGUAGE_DEFAULT, int flags = wxLOCALE_LOAD_DEFAULT | wxLOCALE_CONV_ENCODING)
bool IsLoaded(const wxString& domain) const
bool IsOk() const

//static wxLanguageInfo * FindLanguageInfo(const wxString& locale)
static wxString  GetLanguageName(int lang) const
wxString  GetHeaderValue(const wxChar* szHeader, const wxChar* szDomain = NULL) const
static bool IsAvailable(int lang)

//%builtin %rename wxLocale_AddLanguage void wxLocale::AddLanguage(const wxLanguageInfo& info)
//%builtin %rename wxLocale_FindLanguageInfo wxLanguageInfo * wxLocale::FindLanguageInfo(const wxString& locale)
//%builtin %rename wxLocale_GetLanguageInfo wxLanguageInfo * wxLocale::GetLanguageInfo(int lang) const
%builtin %rename wxLocale_GetLanguageName wxString wxLocale::GetLanguageName(int lang) const
%builtin %rename wxLocale_GetSystemEncoding wxFontEncoding wxLocale::GetSystemEncoding() const
%builtin %rename wxLocale_GetSystemEncodingName wxString wxLocale::GetSystemEncodingName() const
%builtin %rename wxLocale_GetSystemLanguage int wxLocale::GetSystemLanguage() const
%builtin %rename wxLocale_IsAvailable bool wxLocale::IsAvailable(int lang)
//these not exactly, but more usable translated
%builtin const wxString wxGetTranslation(const wxChar* str, const wxChar* domain = NULL)
%{
	const wxString BaseConvert(const wxString& sNum, char BaseIn, char BaseOut)
	{
		// Binary      = Basis 2
		// Oktal       = Basis 8
		// Dezimal     = Basis 10
		// Hexadezimal = Basis 16

		int i, j;
		char ch;
		int chVal;
		wxString s(sNum);
		wxString sRes;
		double nTotal = 0.0;
		int nRemainder = 0;

		s = s.Trim(true);
		s = s.Trim(false);

		if(s.IsEmpty() || BaseIn < 2 || BaseIn > 36 || BaseOut < 1 || BaseOut > 36)
			return wxT(""); // Error
		s.MakeUpper();

		j = s.Len();
		for(i = 0; i < (int) s.Len(); i++)
		{
			j--;
			ch = s.GetChar(i);
			chVal = 0;
			if(ch > 64 && ch < 91)
				chVal = ch - 55;
			if(chVal == 0)
			{
				if(ch < 48 || ch > 57)
					return wxT(""); // Error
				else
					chVal = (int) (ch - 48);
			}
			if(chVal < 0 || chVal > BaseIn - 1)
				return wxT(""); // Error
			nTotal = nTotal + (chVal * (pow((double)BaseIn, j)));
		}

		do
		{
			// nBaseOut = (double) BaseOut;
			nRemainder = (int) (nTotal - (int) (nTotal / BaseOut) * BaseOut);
			nTotal = (nTotal - nRemainder) / BaseOut;
			if(nRemainder >= 10)
			{
				ch = (char) (nRemainder + 55);
				s = (wxChar) ch;
			}
			else
			{
				ch = nRemainder;
				s.Printf(wxT("%d"), ch);
			}
			sRes = s + sRes;
		} while(nTotal > 0);

		return sRes;
	}

	const wxString cs(const wxString& sz, const wxChar* domain = NULL)
	{
		wxString s;

		s = wxGetTranslation(sz, domain);
		int i;
		wxString sHex;
		int nChar;

#ifdef __WXMAC__
		s.Replace(wxT("=E4"), wxT("&auml;")); //ae
		s.Replace(wxT("=FC"), wxT("&uuml;")); //ue
		s.Replace(wxT("=F6"), wxT("&ouml;")); //oe
		s.Replace(wxT("=C4"), wxT("&Auml;")); //Ae
		s.Replace(wxT("=DC"), wxT("&Uuml;")); //Ue
		s.Replace(wxT("=D6"), wxT("&Ouml;")); //Oe
		s.Replace(wxT("=DF"), wxT("&szlig;")); //Sz
		s.Replace(wxT("=A9"), wxT("&copy;")); //Copyright
#endif
		i = 0;
		while(i < (int) s.Len())
		{
			if(s.GetChar(i) == wxT('=') && s.GetChar(i + 1) != wxT(' '))
			{
				long l;
				sHex = s.Mid(i + 1, 2);
				BaseConvert(sHex, 16, 10).ToLong(&l);
				nChar = (int) l;
				if(nChar)
					s = s.Left(i) + (wxChar) nChar + s.Mid(i + 3);
			}
			else if(s.GetChar(i) == wxT('_'))
				s.SetChar(i, ' ');
			i++;
		}
		
		// handle html replacements like &uuml; 
		wxHtmlEntitiesParser parser;
		s = parser.Parse(s);

		return s;
	}
%}
%builtin %rename _ const wxString cs(const wxString& sz, const wxChar* domain = NULL)
%builtin %rename wxPLURAL const wxString wxGetTranslation(const wxChar* sz1, const wxChar* sz2, size_t n, const wxChar* domain = NULL)

%num wxLOCALE_LOAD_DEFAULT
%num wxLOCALE_CONV_ENCODING

%num  wxLANGUAGE_DEFAULT
%num wxLANGUAGE_UNKNOWN
%num wxLANGUAGE_USER_DEFINED
%num wxLANGUAGE_ABKHAZIAN
%num wxLANGUAGE_AFAR
%num wxLANGUAGE_AFRIKAANS
%num wxLANGUAGE_ALBANIAN
%num wxLANGUAGE_AMHARIC
%num wxLANGUAGE_ARABIC
%num wxLANGUAGE_ARABIC_ALGERIA
%num wxLANGUAGE_ARABIC_BAHRAIN
%num wxLANGUAGE_ARABIC_EGYPT
%num wxLANGUAGE_ARABIC_IRAQ
%num wxLANGUAGE_ARABIC_JORDAN
%num wxLANGUAGE_ARABIC_KUWAIT
%num wxLANGUAGE_ARABIC_LEBANON
%num wxLANGUAGE_ARABIC_LIBYA
%num wxLANGUAGE_ARABIC_MOROCCO
%num wxLANGUAGE_ARABIC_OMAN
%num wxLANGUAGE_ARABIC_QATAR
%num wxLANGUAGE_ARABIC_SAUDI_ARABIA
%num wxLANGUAGE_ARABIC_SUDAN
%num wxLANGUAGE_ARABIC_SYRIA
%num wxLANGUAGE_ARABIC_TUNISIA
%num wxLANGUAGE_ARABIC_UAE
%num wxLANGUAGE_ARABIC_YEMEN
%num wxLANGUAGE_ARMENIAN
%num wxLANGUAGE_ASSAMESE
%num wxLANGUAGE_AYMARA
%num wxLANGUAGE_AZERI
%num wxLANGUAGE_AZERI_CYRILLIC
%num wxLANGUAGE_AZERI_LATIN
%num wxLANGUAGE_BASHKIR
%num wxLANGUAGE_BASQUE
%num wxLANGUAGE_BELARUSIAN
%num wxLANGUAGE_BENGALI
%num wxLANGUAGE_BHUTANI
%num wxLANGUAGE_BIHARI
%num wxLANGUAGE_BISLAMA
%num wxLANGUAGE_BRETON
%num wxLANGUAGE_BULGARIAN
%num wxLANGUAGE_BURMESE
%num wxLANGUAGE_CAMBODIAN
%num wxLANGUAGE_CATALAN
%num wxLANGUAGE_CHINESE
%num wxLANGUAGE_CHINESE_SIMPLIFIED
%num wxLANGUAGE_CHINESE_TRADITIONAL
%num wxLANGUAGE_CHINESE_HONGKONG
%num wxLANGUAGE_CHINESE_MACAU
%num wxLANGUAGE_CHINESE_SINGAPORE
%num wxLANGUAGE_CHINESE_TAIWAN
%num wxLANGUAGE_CORSICAN
%num wxLANGUAGE_CROATIAN
%num wxLANGUAGE_CZECH
%num wxLANGUAGE_DANISH
%num wxLANGUAGE_DUTCH
%num wxLANGUAGE_DUTCH_BELGIAN
%num wxLANGUAGE_ENGLISH
%num wxLANGUAGE_ENGLISH_UK
%num wxLANGUAGE_ENGLISH_US
%num wxLANGUAGE_ENGLISH_AUSTRALIA
%num wxLANGUAGE_ENGLISH_BELIZE
%num wxLANGUAGE_ENGLISH_BOTSWANA
%num wxLANGUAGE_ENGLISH_CANADA
%num wxLANGUAGE_ENGLISH_CARIBBEAN
%num wxLANGUAGE_ENGLISH_DENMARK
%num wxLANGUAGE_ENGLISH_EIRE
%num wxLANGUAGE_ENGLISH_JAMAICA
%num wxLANGUAGE_ENGLISH_NEW_ZEALAND
%num wxLANGUAGE_ENGLISH_PHILIPPINES
%num wxLANGUAGE_ENGLISH_SOUTH_AFRICA
%num wxLANGUAGE_ENGLISH_TRINIDAD
%num wxLANGUAGE_ENGLISH_ZIMBABWE
%num wxLANGUAGE_ESPERANTO
%num wxLANGUAGE_ESTONIAN
%num wxLANGUAGE_FAEROESE
%num wxLANGUAGE_FARSI
%num wxLANGUAGE_FIJI
%num wxLANGUAGE_FINNISH
%num wxLANGUAGE_FRENCH
%num wxLANGUAGE_FRENCH_BELGIAN
%num wxLANGUAGE_FRENCH_CANADIAN
%num wxLANGUAGE_FRENCH_LUXEMBOURG
%num wxLANGUAGE_FRENCH_MONACO
%num wxLANGUAGE_FRENCH_SWISS
%num wxLANGUAGE_FRISIAN
%num wxLANGUAGE_GALICIAN
%num wxLANGUAGE_GEORGIAN
%num wxLANGUAGE_GERMAN
%num wxLANGUAGE_GERMAN_AUSTRIAN
%num wxLANGUAGE_GERMAN_BELGIUM
%num wxLANGUAGE_GERMAN_LIECHTENSTEIN
%num wxLANGUAGE_GERMAN_LUXEMBOURG
%num wxLANGUAGE_GERMAN_SWISS
%num wxLANGUAGE_GREEK
%num wxLANGUAGE_GREENLANDIC
%num wxLANGUAGE_GUARANI
%num wxLANGUAGE_GUJARATI
%num wxLANGUAGE_HAUSA
%num wxLANGUAGE_HEBREW
%num wxLANGUAGE_HINDI
%num wxLANGUAGE_HUNGARIAN
%num wxLANGUAGE_ICELANDIC
%num wxLANGUAGE_INDONESIAN
%num wxLANGUAGE_INTERLINGUA
%num wxLANGUAGE_INTERLINGUE
%num wxLANGUAGE_INUKTITUT
%num wxLANGUAGE_INUPIAK
%num wxLANGUAGE_IRISH
%num wxLANGUAGE_ITALIAN
%num wxLANGUAGE_ITALIAN_SWISS
%num wxLANGUAGE_JAPANESE
%num wxLANGUAGE_JAVANESE
%num wxLANGUAGE_KANNADA
%num wxLANGUAGE_KASHMIRI
%num wxLANGUAGE_KASHMIRI_INDIA
%num wxLANGUAGE_KAZAKH
%num wxLANGUAGE_KERNEWEK
%num wxLANGUAGE_KINYARWANDA
%num wxLANGUAGE_KIRGHIZ
%num wxLANGUAGE_KIRUNDI
%num wxLANGUAGE_KONKANI
%num wxLANGUAGE_KOREAN
%num wxLANGUAGE_KURDISH
%num wxLANGUAGE_LAOTHIAN
%num wxLANGUAGE_LATIN
%num wxLANGUAGE_LATVIAN
%num wxLANGUAGE_LINGALA
%num wxLANGUAGE_LITHUANIAN
%num wxLANGUAGE_MACEDONIAN
%num wxLANGUAGE_MALAGASY
%num wxLANGUAGE_MALAY
%num wxLANGUAGE_MALAYALAM
%num wxLANGUAGE_MALAY_BRUNEI_DARUSSALAM
%num wxLANGUAGE_MALAY_MALAYSIA
%num wxLANGUAGE_MALTESE
%num wxLANGUAGE_MANIPURI
%num wxLANGUAGE_MAORI
%num wxLANGUAGE_MARATHI
%num wxLANGUAGE_MOLDAVIAN
%num wxLANGUAGE_MONGOLIAN
%num wxLANGUAGE_NAURU
%num wxLANGUAGE_NEPALI
%num wxLANGUAGE_NEPALI_INDIA
%num wxLANGUAGE_NORWEGIAN_BOKMAL
%num wxLANGUAGE_NORWEGIAN_NYNORSK
%num wxLANGUAGE_OCCITAN
%num wxLANGUAGE_ORIYA
%num wxLANGUAGE_OROMO
%num wxLANGUAGE_PASHTO
%num wxLANGUAGE_POLISH
%num wxLANGUAGE_PORTUGUESE
%num wxLANGUAGE_PORTUGUESE_BRAZILIAN
%num wxLANGUAGE_PUNJABI
%num wxLANGUAGE_QUECHUA
%num wxLANGUAGE_RHAETO_ROMANCE
%num wxLANGUAGE_ROMANIAN
%num wxLANGUAGE_RUSSIAN
%num wxLANGUAGE_RUSSIAN_UKRAINE
%num wxLANGUAGE_SAMOAN
%num wxLANGUAGE_SANGHO
%num wxLANGUAGE_SANSKRIT
%num wxLANGUAGE_SCOTS_GAELIC
%num wxLANGUAGE_SERBIAN
%num wxLANGUAGE_SERBIAN_CYRILLIC
%num wxLANGUAGE_SERBIAN_LATIN
%num wxLANGUAGE_SERBO_CROATIAN
%num wxLANGUAGE_SESOTHO
%num wxLANGUAGE_SETSWANA
%num wxLANGUAGE_SHONA
%num wxLANGUAGE_SINDHI
%num wxLANGUAGE_SINHALESE
%num wxLANGUAGE_SISWATI
%num wxLANGUAGE_SLOVAK
%num wxLANGUAGE_SLOVENIAN
%num wxLANGUAGE_SOMALI
%num wxLANGUAGE_SPANISH
%num wxLANGUAGE_SPANISH_ARGENTINA
%num wxLANGUAGE_SPANISH_BOLIVIA
%num wxLANGUAGE_SPANISH_CHILE
%num wxLANGUAGE_SPANISH_COLOMBIA
%num wxLANGUAGE_SPANISH_COSTA_RICA
%num wxLANGUAGE_SPANISH_DOMINICAN_REPUBLIC
%num wxLANGUAGE_SPANISH_ECUADOR
%num wxLANGUAGE_SPANISH_EL_SALVADOR
%num wxLANGUAGE_SPANISH_GUATEMALA
%num wxLANGUAGE_SPANISH_HONDURAS
%num wxLANGUAGE_SPANISH_MEXICAN
%num wxLANGUAGE_SPANISH_MODERN
%num wxLANGUAGE_SPANISH_NICARAGUA
%num wxLANGUAGE_SPANISH_PANAMA
%num wxLANGUAGE_SPANISH_PARAGUAY
%num wxLANGUAGE_SPANISH_PERU
%num wxLANGUAGE_SPANISH_PUERTO_RICO
%num wxLANGUAGE_SPANISH_URUGUAY
%num wxLANGUAGE_SPANISH_US
%num wxLANGUAGE_SPANISH_VENEZUELA
%num wxLANGUAGE_SUNDANESE
%num wxLANGUAGE_SWAHILI
%num wxLANGUAGE_SWEDISH
%num wxLANGUAGE_SWEDISH_FINLAND
%num wxLANGUAGE_TAGALOG
%num wxLANGUAGE_TAJIK
%num wxLANGUAGE_TAMIL
%num wxLANGUAGE_TATAR
%num wxLANGUAGE_TELUGU
%num wxLANGUAGE_THAI
%num wxLANGUAGE_TIBETAN
%num wxLANGUAGE_TIGRINYA
%num wxLANGUAGE_TONGA
%num wxLANGUAGE_TSONGA
%num wxLANGUAGE_TURKISH
%num wxLANGUAGE_TURKMEN
%num wxLANGUAGE_TWI
%num wxLANGUAGE_UIGHUR
%num wxLANGUAGE_UKRAINIAN
%num wxLANGUAGE_URDU
%num wxLANGUAGE_URDU_INDIA
%num wxLANGUAGE_URDU_PAKISTAN
%num wxLANGUAGE_UZBEK
%num wxLANGUAGE_UZBEK_CYRILLIC
%num wxLANGUAGE_UZBEK_LATIN
%num wxLANGUAGE_VIETNAMESE
%num wxLANGUAGE_VOLAPUK
%num wxLANGUAGE_WELSH
%num wxLANGUAGE_WOLOF
%num wxLANGUAGE_XHOSA
%num wxLANGUAGE_YIDDISH
%num wxLANGUAGE_YORUBA
%num wxLANGUAGE_ZHUANG
%num wxLANGUAGE_ZULU

///////////////////////////////////////////////////////////////////////////////
// wxObject

// ==============================
// Class: wxClassInfo

//RP: can not handle wxObjectConstructorFn
//%typedef wxObject *(*wxObjectConstructorFn)(void)

%class wxClassInfo
//wxClassInfo( const wxChar *className, const wxClassInfo *baseInfo1, const wxClassInfo *baseInfo2, int size, wxObjectConstructorFn ctor )
wxObject *CreateObject() const
bool IsDynamic() const
const wxChar       *GetClassName() const
const wxChar       *GetBaseClassName1() const
const wxChar       *GetBaseClassName2() const
const wxClassInfo  *GetBaseClass1() const
const wxClassInfo  *GetBaseClass2() const
int                 GetSize() const
//wxObjectConstructorFn      GetConstructor() const
static const wxClassInfo  *GetFirst()
const wxClassInfo         *GetNext() const
static wxClassInfo        *FindClass(const wxChar *className)
bool IsKindOf(const wxClassInfo *info) const
const wxChar            *m_className
int                      m_objectSize
//wxObjectConstructorFn    m_objectConstructor
const wxClassInfo       *m_baseInfo1
const wxClassInfo       *m_baseInfo2
static wxClassInfo      *sm_first
wxClassInfo             *m_next
static wxHashTable      *sm_classTable

// RP change param from (const wxChar* name) to (const wxString& name)
%builtin wxObject *wxCreateDynamicObject(const wxString& name)
%builtin %rename wxClassInfo_FindClass wxClassInfo * wxClassInfo::FindClass(const wxString& name)
//%builtin %rename wxClassInfo_InitializeClasses void wxClassInfo::InitializeClasses()

// ==============================
// Class: wxObjectRefData

%class wxObjectRefData
wxObjectRefData()
int GetRefCount() const

%class %delete wxObject
wxObject()
* m_refData
wxClassInfo * GetClassInfo()
wxObjectRefData* GetRefData() const
bool IsKindOf(wxClassInfo *info)
void Ref(const wxObject& clone)
void SetRefData(wxObjectRefData* data)
void UnRef()
void UnShare()
bool IsSameAs(const wxObject& o) const

///////////////////////////////////////////////////////////////////////////////
// wxNode

%class wxNode
%include "wx/list.h"

wxNodeBase* GetPrevious()
wxNodeBase* GetNext()
// Fixed: changed void* to wxObject*
// void SetData(void *data)
void SetData( wxObject *data )
wxObject* GetData()
// FIX! 'int wxNodeBase::IndexOf() const' is protected
// int IndexOf()


///////////////////////////////////////////////////////////////////////////////
// wxList

%class %delete wxList, wxObject
%include "wx/list.h"

wxList()
%ctor wxListKey(unsigned int key_type)
// wxList(int n, wxObject *objects[])
// wxList(wxObject *object, ...)
wxNode * Append(wxObject *object)
%rename AppendNumericKey wxNode * Append(long key, wxObject *object)
%rename AppendStringKey wxNode * Append(const wxString& key, wxObject *object)
void Clear()
void DeleteContents(bool destroy)
bool DeleteNode(wxNode *node)
bool DeleteObject(wxObject *object)
%rename FindNumericKey wxNode * Find(long key)
%rename FindStringKey wxNode * Find(const wxString& key)
size_t GetCount() const
wxNode * GetFirst()
wxNode * GetLast()
int IndexOf(wxObject* obj )
wxNode * Insert(wxObject *object)
%rename InsertAt wxNode * Insert(size_t position, wxObject *object)
%rename InsertBefore wxNode * Insert(wxNode *node, wxObject *object)
bool IsEmpty() const
wxNode * Item(size_t index) const
// Deprecated, use Find
// wxNode * Member(wxObject *object)
// Deprecated, use GetCount
// wxNode * Nth(int n)
// Fix: Can't implement
// void Sort(wxSortCompareFunction compfunc)

///////////////////////////////////////////////////////////////////////////////
// wxWindowList
//

%class wxWindowList, wxList

///////////////////////////////////////////////////////////////////////////////
// Class: wxArrayString

%include <wx/arrstr.h>

%class %delete wxArrayString
wxArrayString()
void Empty()
void Clear()
void Alloc(size_t nCount)
void Shrink()
size_t GetCount() const
bool IsEmpty() const
size_t Count() const
wxString& Item(size_t nIndex) const
wxString& Last() const
size_t Add(const wxString& str, size_t nInsert = 1)
int Index(const wxString& sz, bool bCase = true, bool bFromEnd = false)
void Insert(const wxString& str, size_t uiIndex, size_t nInsert = 1)
void SetCount(size_t count)
void Remove(const wxString& sz)
void RemoveAt(size_t nIndex, size_t nRemove = 1)
void Sort(bool reverseOrder = false)
//void Sort(CompareFunction compareFunction)
//void Sort(CompareFunction2 compareFunction)

///////////////////////////////////////////////////////////////////////////////
// Class: wxSortedArrayString

%class %delete wxSortedArrayString, wxArrayString
wxSortedArrayString()
%ctor wxCopySortedArrayString(const wxArrayString& array)

///////////////////////////////////////////////////////////////////////////////
// wxDataFormat
//

%include <wx/dataobj.h>

%class %delete wxDataFormat
%typedef NativeFormat unsigned short

wxDataFormat(const wxChar *format)
wxString  GetId() const
%if(win) NativeFormat GetType() const
void SetId(const wxChar *format)
%if(win) void SetType(NativeFormat format)

///////////////////////////////////////////////////////////////////////////////
// wxTipProvider
//

%class wxTipProvider
%include "wx/tipdlg.h"
// Can't create: abstract class
// wxTipProvider(size_t currentTip)
wxString GetTip()
size_t GetCurrentTip() const

// Not class methods, but related
%builtin bool wxShowTip(wxWindow *parent, wxTipProvider *tipProvider, bool showAtStartup = TRUE)
%builtin wxTipProvider * wxCreateFileTipProvider(const wxString& filename, size_t currentTip)

///////////////////////////////////////////////////////////////////////////////
// wxPoint

%class %delete wxPoint
wxPoint(int x, int y)
int x
int y
%{
    void wxPoint_Get()
    {
        int x, y;
        x = ((wxPoint *)wTheCall->self->ptr)->x;
        y = ((wxPoint *)wTheCall->self->ptr)->y;
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
    }

    void wxPoint_GetX()
    {
        int x;
        x = ((wxPoint *)wTheCall->self->ptr)->x;
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }
    void wxPoint_GetY()
    {
        int y;
        y = ((wxPoint *)wTheCall->self->ptr)->y;
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }
%}
%method Get wxPoint_Get()
%method GetX wxPoint_GetX()
%method GetY wxPoint_GetY()

// alias wxDefaultPosition
%{
    #define __wxDefaultPosition &wxDefaultPosition
%}
%ptr %alias wxDefaultPosition __wxDefaultPosition

///////////////////////////////////////////////////////////////////////////////
// wxRect

%class %delete wxRect

//wxRect()
wxRect(int x, int y, int width, int height)

// alternate constructors
%ctor wxRectFromPoints(const wxPoint& topLeft, const wxPoint& bottomRight)
%ctor wxRectFromPointAndSize(const wxPoint& pos, const wxSize& size)

int x
int y
int height

void Deflate(wxCoord dx, wxCoord dy)
%rename DeflateDiff void Deflate(wxCoord diff)
%rename DeflateDxDy wxRect Deflate(wxCoord dx, wxCoord dy) const

int GetBottom() const
int GetHeight() const
int GetLeft() const
wxPoint GetPosition() const
int GetRight() const
wxSize GetSize() const
int GetTop() const
int GetWidth() const
int GetX() const
int GetY() const
void Inflate(wxCoord dx, wxCoord dy)
%rename InflateDiff void Inflate(wxCoord diff)
%rename InflateDxDy wxRect Inflate(wxCoord dx, wxCoord dy) const
//Deprecated: use Contains
//bool Inside(int x, int y) const
bool Intersects(const wxRect& rect) const
%rename OffsetDxDy void Offset(wxCoord dx, wxCoord dy)
%rename OffsetPoint void Offset(const wxPoint& pt)
void SetHeight(int height)
void SetWidth(int width)
void SetX(int x)
void SetY(int y)

%rename CenterIn wxRect  CentreIn(const wxRect& r, int dir = wxBOTH) const
bool Contains(int x, int y) const
wxPoint  GetTopLeft() const
wxPoint  GetTopRight() const
wxPoint  GetBottomLeft() const
wxPoint  GetBottomRight() const
wxRect  Intersect(const wxRect& rect) const
bool IsEmpty() const
void SetSize(const wxSize& s)
wxRect  Union(const wxRect& rect) const


///////////////////////////////////////////////////////////////////////////////
// wxSize

%class %delete wxSize
wxSize(int width, int height)
int GetWidth() const
int GetHeight() const
void Set(int width, int height)
void SetHeight(int height)
void SetWidth(int width)

// alias __wxDefaultSize
%{
    #define __wxDefaultSize &wxDefaultSize
%}
%ptr %alias wxDefaultSize __wxDefaultSize

void DecBy(const wxSize& size)
void DecTo(const wxSize& size)
bool IsFullySpecified() const
void IncBy(const wxSize& size)
void IncTo(const wxSize& size)
wxSize&  Scale(float xscale, float yscale)
void SetDefaults(const wxSize& sizeDefault)

///////////////////////////////////////////////////////////////////////////////
// wxRegion

%include <wx/region.h>

%class %delete wxRegion, wxGDIObject
%enum wxRegionContain
  %num wxOutRegion
  %num wxPartRegion
  %num wxInRegion

wxRegion()
//~wxRegion()
void Clear()
//TODO: wrapper
wxRegionContain Contains(long& x, long& y) const
wxBitmap  ConvertToBitmap() const
//TODO: wrapper
void GetBox(wxCoord& x, wxCoord& y, wxCoord& width, wxCoord& height) const
bool Intersect(wxCoord x, wxCoord y, wxCoord width, wxCoord height)
bool IsEmpty() const
bool IsEqual(const wxRegion& region) const
bool Subtract(const wxRect& rect)
bool Offset(wxCoord x, wxCoord y)
bool Union(wxCoord x, wxCoord y, wxCoord width, wxCoord height)
bool Xor(wxCoord x, wxCoord y, wxCoord width, wxCoord height)

///////////////////////////////////////////////////////////////////////////////
// wxBusyCursor

%include <wx/utils.h>
%class %delete wxBusyCursor
wxBusyCursor(const wxCursor* cursor = wxHOURGLASS_CURSOR)
// ~wxBusyCursor()

///////////////////////////////////////////////////////////////////////////////
// wxBusyInfo

%include <wx/busyinfo.h>
%class %delete wxBusyInfo
wxBusyInfo(const wxString& msg, wxWindow* parent = NULL)
// ~wxBusyInfo()

///////////////////////////////////////////////////////////////////////////////
// wxColourData

%class %delete wxColourData, wxObject
%include "wx/cmndata.h"

wxColourData()
%ctor wxColorData()
bool GetChooseFull() const
%alias GetColor wxColour& GetColour() const
%alias GetCustomColor wxColour GetCustomColour(int i) const
void SetChooseFull(const bool flag)
%alias SetColor void SetColour(const wxColour& colour)
%alias SetCustomColor void SetCustomColour(int i, const wxColour& colour)


///////////////////////////////////////////////////////////////////////////////
// wxColour

%class %delete wxColour, wxObject
%include "wx/colour.h"

wxColour(const unsigned char red, const unsigned char green, const unsigned char blue)
%ctor wxColor(const unsigned char red, const unsigned char green, const unsigned char blue)
%ctor wxColorFromName(const wxString& colourName)

%ctor wxColourCopy(const wxColour& colour)

unsigned char Blue() const
unsigned char Green() const
unsigned char Red() const
unsigned char Alpha() const
wxString  GetAsString(long flags) const
bool IsOk() const
bool Ok() const
%not(mac) long GetPixel() const
void Set(const unsigned char red, const unsigned char green, const unsigned char blue)

%ptr wxBLACK
%ptr wxWHITE
%ptr wxRED
%ptr wxBLUE
%ptr wxGREEN
%ptr wxCYAN
%ptr wxLIGHT_GREY
%ptr wxNullColour

///////////////////////////////////////////////////////////////////////////////
// wxColourDatabase

%include <wx/gdicmn.h>
%class %delete wxColourDatabase
wxColourDatabase()
void AddColour(const wxString& colourName, const wxColour&colour)
wxColour  Find(const wxString& colourName)
wxString  FindName(const wxColour& colour) const

///////////////////////////////////////////////////////////////////////////////
// wxSound

%include <wx/sound.h>

%if wxUSE_SOUND

%class %delete wxSound, wxObject
%ctor wxSoundNoCreate()
wxSound(const wxString& fileName, bool isResource = false)
// ~wxSound()
bool Create(const wxString& fileName, bool isResource = false)
bool IsOk() const
//documented, but...
//static bool IsPlaying() const
bool Play(unsigned  flags = wxSOUND_ASYNC) const
static void Stop()

//documented, but...
//%builtin %rename wxSound_IsPlaying bool wxSound::IsPlaying() const
%builtin %rename wxSound_Stop void wxSound::Stop()

%endif //wxUSE_SOUND

///////////////////////////////////////////////////////////////////////////////
// wxWave

// This is deprecated, use wxSound instead

%if(false) %class wxWave, wxObject
%include "wx/wave.h"

wxWave()
ctor %wxWaveFromFile(const wxString& fileName, bool isResource = FALSE)
bool Create(const wxString& fileName, bool isResource = FALSE)
bool IsOk() const
bool Play(bool async = TRUE, bool looped = FALSE) const

// #########################################################
// power.h

// Class: wxPowerEvent
%if(win) %class wxPowerEvent, wxEvent

%include <wx/power.h>

%enum wxPowerType
  %num wxPOWER_SOCKET
  %num wxPOWER_BATTERY
  %num wxPOWER_UNKNOWN

%enum wxBatteryState
  %num wxBATTERY_NORMAL_STATE
  %num wxBATTERY_LOW_STATE
  %num wxBATTERY_CRITICAL_STATE
  %num wxBATTERY_SHUTDOWN_STATE
  %num wxBATTERY_UNKNOWN_STATE

//%num wxHAS_POWER_EVENTS

// ==============================
// Class: wxPowerEvent

wxPowerEvent(wxEventType evtType)
void Veto()
bool IsVetoed() const
%not(bcc) virtual wxEvent *Clone() const

%if(win) %event wxEVT_POWER_SUSPENDING
%if(win) %event wxEVT_POWER_SUSPENDED
%if(win) %event wxEVT_POWER_SUSPEND_CANCEL
%if(win) %event wxEVT_POWER_RESUME

%builtin wxPowerType wxGetPowerType()
%builtin wxBatteryState wxGetBatteryState()

///////////////////////////////////////////////////////////////////////////////
// GDI CLASSES
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
// wxGDIObject

%class %delete wxGDIObject, wxObject
wxGDIObject()


///////////////////////////////////////////////////////////////////////////////
// wxPen

%class %delete wxPen, wxGDIObject
%include <wx/pen.h>

wxPen()
int GetCap() const
wxColour& GetColour() const
// FIX!
// int GetDashes(wxDash** dashes) const
int GetJoin() const
%if(win) wxBitmap* GetStipple() const
int GetStyle() const
int GetWidth() const
bool IsOk() const
bool Ok() const
void SetCap(int capStyle)
%alias SetColor void SetColour(wxColour& colour)
%rename SetColourString %alias SetColorString void SetColour(const wxString& colourName)
%rename SetColourRGB %alias SetColorRGB void SetColour(int red, int green, int blue)
// FIX - need to add wxDash...
//void SetDashes(int nb_dashes, const wxDash *dash)
void SetJoin(int join_style)
// Fixed, missing const
// void SetStipple(const wxBitmap* stipple)
void SetStyle(int style)
void SetWidth(int width)

// alternate constructors
%ctor wxPenFromColour(const wxColour& colour, int width, int style)
%ctor wxPenFromColor(const wxColour& colour, int width, int style)
%ctor wxPenFromColourName(const wxString& colourName, int width, int style)
%ctor wxPenFromColorName(const wxString& colourName, int width, int style)
%if(win) %ctor wxPenFromBitmap(const wxBitmap& stipple, int width)
%ctor wxPenCopy(const wxPen& pen)

%ptr wxRED_PEN
%ptr wxCYAN_PEN
%ptr wxGREEN_PEN
%ptr wxBLACK_PEN
%ptr wxWHITE_PEN
%ptr wxTRANSPARENT_PEN
%ptr wxBLACK_DASHED_PEN
%ptr wxGREY_PEN
%ptr wxMEDIUM_GREY_PEN
%ptr wxLIGHT_GREY_PEN

%ptr wxNullPen


///////////////////////////////////////////////////////////////////////////////
// wxPalette

%class %delete wxPalette, wxGDIObject
%include "wx/palette.h"

// Fix: these look like strings
// wxPalette(int n, const unsigned char* red, const unsigned char* green, const unsigned char* blue)
wxPalette(int n, const uchar* red, const uchar* green, const uchar* blue)

// bool Create(int n, const unsigned char* red, const unsigned char* green, const unsigned char* blue)
bool Create(int n, const uchar* red, const uchar* green, const uchar* blue)
int GetPixel(const unsigned char red, const unsigned char green, const unsigned char blue) const

// bool GetRGB(int pixel, const unsigned char* red, const unsigned char* green, const unsigned char* blue) const
int GetColoursCount() const
bool IsOk() const
bool Ok() const


///////////////////////////////////////////////////////////////////////////////
// wxBrush

%class %delete wxBrush, wxGDIObject
%include "wx/brush.h"

wxBrush(const wxColour& colour, int style)
%ctor wxBrushFromColourName(const wxString& colourName, int style)
%ctor wxBrushFromColorName(const wxString& colourName, int style)
%ctor wxBrushFromBitmap(const wxBitmap& stippleBitmap)
%ctor wxBrushCopy(const wxBrush& brush)
// Fixed: removed void
%alias GetColor wxColour GetColour() const
wxBitmap * GetStipple() const
int GetStyle() const
bool IsHatch() const
bool IsOk() const
bool Ok() const
// alias...
%alias SetColor void SetColour(wxColour& colour)
%rename SetColourString %alias SetColorString void SetColour(const wxString& colourName)
%rename SetColourRGB %alias SetColorRGB void SetColour(const unsigned char red, const unsigned char green, const unsigned char blue)

void SetStipple(const wxBitmap& bitmap)
void SetStyle(int style)

// not supported
// wxBrush& operator =(const wxBrush& brush)
// bool operator ==(const wxBrush& brush)
// bool operator !=(const wxBrush& brush)


%ptr wxBLUE_BRUSH
%ptr wxGREEN_BRUSH
%ptr wxWHITE_BRUSH
%ptr wxBLACK_BRUSH
%ptr wxTRANSPARENT_BRUSH
%ptr wxCYAN_BRUSH
%ptr wxRED_BRUSH
%ptr wxGREY_BRUSH
%ptr wxMEDIUM_GREY_BRUSH
%ptr wxLIGHT_GREY_BRUSH

%ptr wxNullBrush

///////////////////////////////////////////////////////////////////////////////
// wxBrushList

%class wxBrushList, wxList
%include "wx/gdicmn.h"

// Fixed: removed void
wxBrushList()
// used internally
// void AddBrush(wxBrush *brush)

// need alias...
wxBrush * FindOrCreateBrush(const wxColour& colour, int style)
// wxBrush * FindOrCreateBrush(const wxString& colourName, int style)

// used internally...
// void RemoveBrush(wxBrush *brush)

///////////////////////////////////////////////////////////////////////////////
// wxFont

%class %delete wxFont, wxGDIObject
%include "wx/font.h"

%enum wxFontFamily
  %num wxFONTFAMILY_DEFAULT
  %num wxFONTFAMILY_DECORATIVE
  %num wxFONTFAMILY_ROMAN
  %num wxFONTFAMILY_SCRIPT
  %num wxFONTFAMILY_SWISS
  %num wxFONTFAMILY_MODERN
  %num wxFONTFAMILY_TELETYPE
  %num wxFONTFAMILY_MAX
  %num wxFONTFAMILY_UNKNOWN

%enum wxFontStyle
  %num wxFONTSTYLE_NORMAL
  %num wxFONTSTYLE_ITALIC
  %num wxFONTSTYLE_SLANT
  %num wxFONTSTYLE_MAX

%enum wxFontWeight
  %num wxFONTWEIGHT_NORMAL
  %num wxFONTWEIGHT_LIGHT
  %num wxFONTWEIGHT_BOLD
  %num wxFONTWEIGHT_MAX

%num wxFONTFLAG_DEFAULT
%num wxFONTFLAG_ITALIC
%num wxFONTFLAG_SLANT
%num wxFONTFLAG_LIGHT
%num wxFONTFLAG_BOLD
%num wxFONTFLAG_ANTIALIASED
%num wxFONTFLAG_NOT_ANTIALIASED
%num wxFONTFLAG_UNDERLINED
%num wxFONTFLAG_STRIKETHROUGH
%num wxFONTFLAG_MASK

wxFont(int pointSize, int family, int style, int weight, const bool underline = FALSE, const wxString& faceName = wxT(""), wxFontEncoding encoding = wxFONTENCODING_DEFAULT)
%ctor wxFontCopy(const wxFont& font)
%ctor wxFontEmpty()
%ctor wxFontDescription(const wxString& fontDesc)

static wxFontEncoding GetDefaultEncoding()
wxString GetFaceName() const
int GetFamily() const
// Fix: not found under wxGTK 2.3.1
// int GetFontId() const
int GetPointSize() const
int GetStyle() const
bool GetUnderlined() const
int GetWeight() const
static void SetDefaultEncoding(wxFontEncoding encoding)
void SetFaceName(const wxString& faceName)
void SetFamily(int family)
void SetPointSize(int pointSize)
void SetStyle(int style)
void SetUnderlined(const bool underlined)
void SetWeight(int weight)
bool IsFixedWidth() const
wxString  GetNativeFontInfoDesc() const
wxString  GetNativeFontInfoUserDesc()
bool IsOk() const
bool SetNativeFontInfo(const wxString& info)
bool SetNativeFontInfoUserDesc(const wxString& info)

%ptr wxNORMAL_FONT
%ptr wxSMALL_FONT
%ptr wxITALIC_FONT
%ptr wxSWISS_FONT
%ptr wxNullFont

%builtin %rename wxFont_GetDefaultEncoding wxFontEncoding wxFont::GetDefaultEncoding()
%builtin %rename wxFont_SetDefaultEncoding void wxFont::SetDefaultEncoding(wxFontEncoding encoding)

///////////////////////////////////////////////////////////////////////////////
// wxDC

#include "wx/intl.h"

%enum wxLayoutDirection
  %num wxLayout_Default
  %num wxLayout_LeftToRight
  %num wxLayout_RightToLeft

%include "wx/dc.h"

%class %delete wxDC, wxObject

// FIX: this is virtual in GTK, so can't be constructed
// %if(win) wxDC()
//Deprecated
//void BeginDrawing()
bool Blit(wxCoord xdest, wxCoord ydest, wxCoord width, wxCoord height, wxDC* source, wxCoord xsrc, wxCoord ysrc, int logicalFunc = wxCOPY, bool useMask = FALSE)
void CalcBoundingBox(wxCoord x, wxCoord y)
void Clear()
void CrossHair(wxCoord x, wxCoord y)
void DestroyClippingRegion()
wxCoord DeviceToLogicalX(wxCoord x)
wxCoord DeviceToLogicalXRel(wxCoord x)
wxCoord DeviceToLogicalY(wxCoord y)
wxCoord DeviceToLogicalYRel(wxCoord y)
// Fixed: prototype for parms 5 and 6 were double
void DrawArc(wxCoord x1, wxCoord y1, wxCoord x2, wxCoord y2, wxCoord xc, wxCoord yc)
void DrawBitmap(const wxBitmap& bitmap, wxCoord x, wxCoord y, bool transparent)

// Alias
void DrawCheckMark(wxCoord x, wxCoord y, wxCoord width, wxCoord height)
%rename DrawCheckMarkRect void DrawCheckMark(const wxRect &rect)

void DrawEllipse(wxCoord x, wxCoord y, wxCoord width, wxCoord height)
void DrawEllipticArc(wxCoord x, wxCoord y, wxCoord width, wxCoord height, double start, double end)
void DrawIcon(const wxIcon& icon, wxCoord x, wxCoord y)
void DrawLine(wxCoord x1, wxCoord y1, wxCoord x2, wxCoord y2)

// Alias
void DrawLines(int n, wxPoint points[], wxCoord xoffset = 0, wxCoord yoffset = 0)
%rename DrawLinesFromList void DrawLines(wxList *points, wxCoord xoffset = 0, wxCoord yoffset = 0)

// Alias
void DrawPolygon(int n, wxPoint points[], wxCoord xoffset = 0, wxCoord yoffset = 0, int fill_style = wxODDEVEN_RULE)
%rename DrawPolygonFromList void DrawPolygon(wxList *points, wxCoord xoffset = 0, wxCoord yoffset = 0, int fill_style = wxODDEVEN_RULE)

void DrawPoint(wxCoord x, wxCoord y)
void DrawRectangle(wxCoord x, wxCoord y, wxCoord width, wxCoord height)
void DrawRotatedText(const wxString& text, wxCoord x, wxCoord y, double angle)
void DrawRoundedRectangle(wxCoord x, wxCoord y, wxCoord width, wxCoord height, double radius = 20)

// Fix!
%rename DrawSplineFromList void DrawSpline(wxList *points)

void DrawText(const wxString& text, wxCoord x, wxCoord y)
void EndDoc()
//Deprecated
//void EndDrawing()
void EndPage()
void FloodFill(wxCoord x, wxCoord y, const wxColour& colour, int style=wxFLOOD_SURFACE)

// alias
wxBrush& GetBackground()
// const wxBrush& GetBackground() const

int GetBackgroundMode() const

// alias
wxBrush& GetBrush()
// const wxBrush& GetBrush() const

wxCoord GetCharHeight()
wxCoord GetCharWidth()
// void GetClippingBox(wxCoord *x, wxCoord *y, wxCoord *width, wxCoord *height)
%{
    void wxDC_GetClippingBox()
    {
        wxCoord x, y, width, height;
        ((wxDC *)wTheCall->self->ptr)->GetClippingBox(&x, &y, &width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
        wStackPushInteger( (wInteger)width );
        wStackPushInteger( (wInteger)height );
    }

    void wxDC_GetClippingBoxX()
    {
        wxCoord x, y, width, height;
        ((wxDC *)wTheCall->self->ptr)->GetClippingBox(&x, &y, &width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }

    void wxDC_GetClippingBoxY()
    {
        wxCoord x, y, width, height;
        ((wxDC *)wTheCall->self->ptr)->GetClippingBox(&x, &y, &width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }

    void wxDC_GetClippingBoxWidth()
    {
        wxCoord x, y, width, height;
        ((wxDC *)wTheCall->self->ptr)->GetClippingBox(&x, &y, &width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)width );
    }

    void wxDC_GetClippingBoxHeight()
    {
        wxCoord x, y, width, height;
        ((wxDC *)wTheCall->self->ptr)->GetClippingBox(&x, &y, &width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)height );
    }

%}
%method GetPixelBox         wxDC_GetClippingBox()
%method GetPixelBoxX        wxDC_GetClippingBoxX()
%method GetPixelBoxY        wxDC_GetClippingBoxY()
%method GetPixelBoxWidth    wxDC_GetClippingBoxWidth()
%method GetPixelBoxHeight   wxDC_GetClippingBoxHeight()

wxFont& GetFont()
int GetLogicalFunction()
int GetMapMode()
//bool GetOptimization()

wxPen& GetPen()
// const wxPen& GetPen() const
// bool GetPixel(wxCoord x, wxCoord y, wxColour *colour)
%{
    void wxDC_GetPixel()
    {
        wxCoord y = wStackPopInteger();
        wxCoord x = wStackPopInteger();
        wxColour *returns = new wxColour;
        ((wxDC *)wTheCall->self->ptr)->GetPixel(x, y, returns);
        wWrapDerefArgs();
        wWrapPushObject( _wxColour, W_TRUE, (void *)returns );
    }
%}
%method GetPixel wxDC_GetPixel(wxCoord x, wxCoord y)


// void GetSize(wxCoord *width, wxCoord *height)
// wxPython note: In place of a single overloaded method name, wxPython implements the following methods:
//        GetSize()  Returns a wxSize
//        GetSizeTuple()  Returns a 2-tuple (width, height)

%{
    void wxDC_GetSize()
    {
        int x, y;
        // call GetSize
        ((wxDC *)wTheCall->self->ptr)->GetSize(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
    }
    void wxDC_GetSizeX()
    {
        int x, y;
        // call GetSize
        ((wxDC *)wTheCall->self->ptr)->GetSize(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }

    void wxDC_GetSizeY()
    {
        int x, y;
        // call GetSize
        ((wxDC *)wTheCall->self->ptr)->GetSize(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }
%}
%method GetSize     wxDC_GetSize()
%method GetSizeX    wxDC_GetSizeX()
%method GetSizeY    wxDC_GetSizeY()

const wxColour& GetTextBackground() const

// void GetTextExtent(const wxString& string, wxCoord *w, wxCoord *h, wxCoord *descent = NULL, wxCoord *externalLeading = NULL, wxFont *font = NULL)
// wxPython note: The following methods are implemented in wxPython:
//        GetTextExtent(string)  Returns a 2-tuple, (width, height)
//        GetFullTextExtent(string, font=NULL)  Returns a 4-tuple, (width, height, descent, externalLeading)

%{
    void wxDC_GetTextExtentWidth()
    {
        // returned parameters
        wxCoord w, h, descent, externalLeading;

        // wxFont *font = NULL
        wxFont *font = (wTheCall->parmCount > 1 ? (wxFont *)wStackPopObjectPtr( _wxFont) : NULL);

        // const wxString& string
        wxString string(wStackPopChar(), *wxConvCurrent);

        // call GetTextExtent
        ((wxDC *)wTheCall->self->ptr)->GetTextExtent(string, &w, &h, &descent, &externalLeading, font);
        wWrapDerefArgs();

        // return the width
        wStackPushInteger( (wInteger)w );
    }

    void wxDC_GetTextExtentHeight()
    {
        // returned parameters
        wxCoord w, h, descent, externalLeading;

        // wxFont *font = NULL
        wxFont *font = (wTheCall->parmCount > 1 ? (wxFont *)wStackPopObjectPtr( _wxFont) : NULL);

        // const wxString& string
        wxString string(wStackPopChar(), *wxConvCurrent);

        // call GetTextExtent
        ((wxDC *)wTheCall->self->ptr)->GetTextExtent(string, &w, &h, &descent, &externalLeading, font);
        wWrapDerefArgs();

        // return the height
        wStackPushInteger( (wInteger)h );
    }

    void wxDC_GetTextExtentDescent()
    {
        // returned parameters
        wxCoord w, h, descent, externalLeading;

        // wxFont *font = NULL
        wxFont *font = (wTheCall->parmCount > 1 ? (wxFont *)wStackPopObjectPtr( _wxFont) : NULL);

        // const wxString& string
        wxString string(wStackPopChar(), *wxConvCurrent);

        // call GetTextExtent
        ((wxDC *)wTheCall->self->ptr)->GetTextExtent(string, &w, &h, &descent, &externalLeading, font);
        wWrapDerefArgs();

        // return the descent
        wStackPushInteger( (wInteger)descent );
    }

    void wxDC_GetTextExtentExternalLeading()
    {
        // returned parameters
        wxCoord w, h, descent, externalLeading;

        // wxFont *font = NULL
        wxFont *font = (wTheCall->parmCount > 1 ? (wxFont *)wStackPopObjectPtr( _wxFont) : NULL);

        // const wxString& string
        wxString string(wStackPopChar(), *wxConvCurrent);

        // call GetTextExtent
        ((wxDC *)wTheCall->self->ptr)->GetTextExtent(string, &w, &h, &descent, &externalLeading, font);
        wWrapDerefArgs();

        // return the external leading
        wStackPushInteger( (wInteger)externalLeading );
    }

%}
%method GetTextExtentWidth              wxDC_GetTextExtentWidth( const wxString& string, wxFont *font = NULL )
%method GetTextExtentHeight             wxDC_GetTextExtentHeight( const wxString& string, wxFont *font = NULL )
%method GetTextExtentDescent            wxDC_GetTextExtentDescent( const wxString& string, wxFont *font = NULL )
%method GetTextExtentExternalLeading    wxDC_GetTextExtentExternalLeading( const wxString& string, wxFont *font = NULL )

// alias...
wxColour& GetTextForeground()
// const wxColour& GetTextForeground() const

// void GetUserScale(double *x, double *y)
%{
    void wxDC_GetUserScale()
    {
        double x, y;
        ((wxDC *)wTheCall->self->ptr)->GetUserScale(&x, &y);
        wWrapDerefArgs();
        wStackPushNumber( (wNumber)x );
        wStackPushNumber( (wNumber)y );
    }

    void wxDC_GetUserScaleX()
    {
        double x, y;
        ((wxDC *)wTheCall->self->ptr)->GetUserScale(&x, &y);
        wWrapDerefArgs();
        wStackPushNumber( (wNumber)x );
    }

    void wxDC_GetUserScaleY()
    {
        double x, y;
        ((wxDC *)wTheCall->self->ptr)->GetUserScale(&x, &y);
        wWrapDerefArgs();
        wStackPushNumber( (wNumber)y );
    }
%}
%method GetUserScale    wxDC_GetUserScale()
%method GetUserScaleX   wxDC_GetUserScaleX()
%method GetUserScaleY   wxDC_GetUserScaleY()


wxCoord LogicalToDeviceX(wxCoord x)
wxCoord LogicalToDeviceXRel(wxCoord x)
wxCoord LogicalToDeviceY(wxCoord y)
wxCoord LogicalToDeviceYRel(wxCoord y)
wxCoord MaxX()
wxCoord MaxY()
wxCoord MinX()
wxCoord MinY()
bool Ok()
void ResetBoundingBox()
void SetDeviceOrigin(wxCoord x, wxCoord y)
void SetBackground(const wxBrush& brush)
void SetBackgroundMode(int mode)

// alias...
%rename SetClippingRegionXY void SetClippingRegion(wxCoord x, wxCoord y, wxCoord width, wxCoord height)
void SetClippingRegion(const wxRegion& region)

void SetPalette(const wxPalette& palette)
void SetBrush(const wxBrush& brush)
void SetFont(const wxFont& font)
// Fixed: was int int
// void SetMapMode(int unit)
//void SetOptimization(bool optimize)
void SetPen(const wxPen& pen)
void SetTextBackground(const wxColour& colour)
void SetTextForeground(const wxColour& colour)
void SetUserScale(double xScale, double yScale)
bool StartDoc(const wxString& message)
// Fixed: was bool, should have been void
void StartPage()

virtual void ComputeScaleAndOrigin()
void DrawCircle(wxCoord x, wxCoord y, wxCoord radius)
virtual void DrawLabel(const wxString& text, const wxBitmap& image, const wxRect& rect, int alignment = wxALIGN_LEFT | wxALIGN_TOP, int indexAccel = -1, wxRect *rectBounding = NULL)
void DrawPolyPolygon(int n, int count[], wxPoint points[], wxCoord xoffset = 0, wxCoord yoffset = 0,  int fill_style = wxODDEVEN_RULE)
wxLayoutDirection GetLayoutDirection() const
void GetMultiLineTextExtent(const wxString& string, wxCoord *w,  wxCoord *h, wxCoord *heightLine = NULL, wxFont *font = NULL) const
// TODO: needs wrapper
bool GetPartialTextExtents(const wxString&  text,  wxArrayInt& widths) const
wxSize  GetPPI() const
void GetSizeMM(wxCoord *width, wxCoord *height) const
void GradientFillConcentric(const wxRect& rect, const wxColour& initialColour, const wxColour& destColour)
void GradientFillLinear(const wxRect& rect, const wxColour& initialColour, const wxColour& destColour, wxDirection nDirection = wxEAST)
void SetAxisOrientation(bool xLeftRight, bool yBottomUp)
void SetLayoutDirection(wxLayoutDirection dir)
void SetLogicalFunction(int function)

///////////////////////////////////////////////////////////////////////////////
// wxDCClipper

%include <wx/dc.h>
%class wxDCClipper
wxDCClipper(wxDC& dc, const wxRegion& r)

///////////////////////////////////////////////////////////////////////////////
// wxMemoryDC

%class %delete wxMemoryDC, wxDC
%include "wx/dcmemory.h"

wxMemoryDC()
// Error: missing void
void SelectObject(wxBitmap& bitmap)
void SelectObjectAsSource(const wxBitmap& bitmap)

///////////////////////////////////////////////////////////////////////////////
// wxMetafileDC

// FIX: not in GTK
%not(gtk) %class wxMetafileDC, wxDC
%include "wx/metafile.h"

wxMetafileDC(const wxString& filename = wxT(""))
wxMetafile * Close()

///////////////////////////////////////////////////////////////////////////////
// wxBufferedDC

%not(gtk) %class wxBufferedDC, wxMemoryDC
%include <wx/dcbuffer.h>
wxBufferedDC()
void Init(wxDC *dc, const wxSize& area, int style = wxBUFFER_CLIENT_AREA)

///////////////////////////////////////////////////////////////////////////////
// wxBufferedPaintDC

%not(gtk) %class wxBufferedPaintDC, wxBufferedDC
%include <wx/dcbuffer.h>
wxBufferedPaintDC(wxWindow *window, wxBitmap& buffer, int style = wxBUFFER_CLIENT_AREA)

///////////////////////////////////////////////////////////////////////////////
// wxPrintout

%class wxPrintout, wxObject
%include "wx/print.h"

// FIXME: can't create - abstract class
//wxPrintout(const wxString& title = "Printout")
wxDC * GetDC()

//void GetPageInfo(int *minPage, int *maxPage, int *pageFrom, int *pageTo)
//void GetPageSizeMM(int *w, int *h)
//void GetPageSizePixels(int *w, int *h)
//void GetPPIPrinter(int *w, int *h)
//void GetPPIScreen(int *w, int *h)

%{
    void wxPrintout_GetPageInfo()
    {
        int minPage, maxPage, pageFrom, pageTo;
        ((wxPrintout *)wTheCall->self->ptr)->GetPageInfo(&minPage, &maxPage, &pageFrom, &pageTo);
		wWrapDerefArgs();
        wStackPushInteger( (wInteger)minPage );
        wStackPushInteger( (wInteger)maxPage );
        wStackPushInteger( (wInteger)pageFrom );
        wStackPushInteger( (wInteger)pageTo );
    }

    void wxPrintout_GetPageSizeMM()
    {
        int w, h;
        ((wxPrintout *)wTheCall->self->ptr)->GetPageSizeMM(&w, &h);
		wWrapDerefArgs();
        wStackPushInteger( (wInteger)w );
        wStackPushInteger( (wInteger)h );
    }

    void wxPrintout_GetPageSizePixels()
    {
        int w, h;
        ((wxPrintout *)wTheCall->self->ptr)->GetPageSizePixels(&w, &h);
		wWrapDerefArgs();
        wStackPushInteger( (wInteger)w );
        wStackPushInteger( (wInteger)h );
    }

    void wxPrintout_GetPPIPrinter()
    {
        int w, h;
        ((wxPrintout *)wTheCall->self->ptr)->GetPPIPrinter(&w, &h);
		wWrapDerefArgs();
        wStackPushInteger( (wInteger)w );
        wStackPushInteger( (wInteger)h );
    }

    void wxPrintout_GetPPIScreen()
    {
        int w, h;
        ((wxPrintout *)wTheCall->self->ptr)->GetPPIScreen(&w, &h);
		wWrapDerefArgs();
        wStackPushInteger( (wInteger)w );
        wStackPushInteger( (wInteger)h );
    }
%}

%method GetPageInfo         wxPrintout_GetPageInfo()
%method GetPageSizeMM 		wxPrintout_GetPageSizeMM()
%method GetPageSizePixels 	wxPrintout_GetPageSizePixels()
%method GetPPIPrinter 		wxPrintout_GetPPIPrinter()
%method GetPPIScreen 		wxPrintout_GetPPIScreen()

wxString GetTitle()
bool HasPage(int pageNum)
bool IsPreview()
//bool OnBeginDocument(int startPage, int endPage)
//void OnEndDocument()
//void OnBeginPrinting()
//void OnEndPrinting()
//void OnPreparePrinting()
//bool OnPrintPage(int pageNum)

wxRect  GetPaperRectPixels()
void FitThisSizeToPaper(const wxSize& imageSize)
void FitThisSizeToPage(const wxSize& imageSize)
void FitThisSizeToPageMargins(const wxSize& imageSize, const wxPageSetupDialogData& pageSetupData)
void MapScreenSizeToPaper()
void MapScreenSizeToPage()
void MapScreenSizeToPageMargins(const wxPageSetupDialogData& pageSetupData)
void MapScreenSizeToDevice()
wxRect  GetLogicalPaperRect()
wxRect  GetLogicalPageRect()
wxRect  GetLogicalPageMarginsRect(const wxPageSetupDialogData& pageSetupData)
void SetLogicalOrigin(wxCoord x, wxCoord y)
void OffsetLogicalOrigin(wxCoord xoff, wxCoord yoff)

///////////////////////////////////////////////////////////////////////////////
// wxPrinter

%class %delete wxPrinter, wxObject
%include "wx/print.h"

wxPrinter(wxPrintDialogData* data = NULL)
void CreateAbortWindow(wxWindow* parent, wxPrintout* printout)
bool GetAbort()
static wxPrinterError GetLastError()
wxPrintDialogData& GetPrintDialogData()
bool Print(wxWindow *parent, wxPrintout *printout, bool prompt=true)
wxDC* PrintDialog(wxWindow *parent)
void ReportError(wxWindow *parent, wxPrintout *printout, const wxString& message)
bool Setup(wxWindow *parent)

%builtin %rename wxPrinter_GetLastError wxPrinterError wxPrinter::GetLastError()

%num wxPRINTER_NO_ERROR
%num wxPRINTER_CANCELLED
%num wxPRINTER_ERROR

///////////////////////////////////////////////////////////////////////////////
// wxPrintDialogData

%class %delete wxPrintDialogData, wxObject
%include "wx/cmndata.h"

wxPrintDialogData()
// wxPrintDialogData(wxPrintDialogData& dialogData)
//wxPrintDialogData(wxPrintData& printData)
void EnableHelp(bool flag)
void EnablePageNumbers(bool flag)
void EnablePrintToFile(bool flag)
void EnableSelection(bool flag)
bool GetAllPages() const
bool GetCollate() const
int GetFromPage() const
int GetMaxPage() const
int GetMinPage() const
int GetNoCopies() const
wxPrintData& GetPrintData()
bool GetPrintToFile() const
bool GetSelection() const
int GetToPage() const
bool IsOk() const
bool Ok() const
void SetCollate(bool flag)
void SetFromPage(int page)
void SetMaxPage(int page)
void SetMinPage(int page)
void SetNoCopies(int n)
void SetPrintData(const wxPrintData& printData)
void SetPrintToFile(bool flag)
void SetSelection(bool flag)
//void SetSetupDialog(bool flag)
void SetToPage(int page)


///////////////////////////////////////////////////////////////////////////////
// wxPrintData

%include "wx/cmndata.h"
%class %delete wxPrintData, wxObject

%enum  wxPrintBin
  %num wxPRINTBIN_DEFAULT
  %num wxPRINTBIN_ONLYONE
  %num wxPRINTBIN_LOWER
  %num wxPRINTBIN_MIDDLE
  %num wxPRINTBIN_MANUAL
  %num wxPRINTBIN_ENVELOPE
  %num wxPRINTBIN_ENVMANUAL
  %num wxPRINTBIN_AUTO
  %num wxPRINTBIN_TRACTOR
  %num wxPRINTBIN_SMALLFMT
  %num wxPRINTBIN_LARGEFMT
  %num wxPRINTBIN_LARGECAPACITY
  %num wxPRINTBIN_CASSETTE
  %num wxPRINTBIN_FORMSOURCE
  %num wxPRINTBIN_USER

wxPrintData()
%ctor wxPrintDataCopy(const wxPrintData& data)
bool GetCollate() const
bool GetColour() const
wxDuplexMode GetDuplex() const
int GetNoCopies() const
int GetOrientation() const
wxPaperSize GetPaperId() const
const wxString& GetPrinterName() const
wxPrintQuality GetQuality() const
wxPrintBin GetBin() const
bool IsOk() const
void SetBin(wxPrintBin flag)
bool Ok() const
void SetCollate(bool flag)
%alias SetColor void SetColour(bool flag)
void SetDuplex(wxDuplexMode mode)
void SetNoCopies(int n)
void SetOrientation(int orientation)
void SetPaperId(wxPaperSize paperId)
void SetPrinterName(const wxString& printerName)
void SetQuality(wxPrintQuality quality)

///////////////////////////////////////////////////////////////////////////////
// wxPostScriptDC

// FIX! not recognized? why?
%if(false) %class wxPostScriptDC, wxDC
%include "wx/dcps.h"

wxPostScriptDC(const wxPrintData& printData)
static void SetResolution(int ppi)
static int GetResolution()

///////////////////////////////////////////////////////////////////////////////
// wxPrinterDC

// FIX: not declared for GTK
%if(win) %class wxPrinterDC, wxDC
%include "wx/dcprint.h"

wxPrinterDC(const wxPrintData& printData)

///////////////////////////////////////////////////////////////////////////////
// wxWindowDC

%class %delete wxWindowDC, wxDC
%include "wx/dcclient.h"

wxWindowDC(wxWindow* window)

///////////////////////////////////////////////////////////////////////////////
// wxClientDC

%class %delete wxClientDC, wxWindowDC
%include "wx/dcclient.h"

wxClientDC(wxWindow* window)

///////////////////////////////////////////////////////////////////////////////
// wxPaintDC

%class %delete wxPaintDC, wxWindowDC
%include "wx/dcclient.h"

wxPaintDC(wxWindow* window)

///////////////////////////////////////////////////////////////////////////////
// wxScreenDC

%class %delete wxScreenDC, wxDC
%include "wx/dcscreen.h"

wxScreenDC()

// need alias...
bool StartDrawingOnTop(wxWindow* window)
%rename StartDrawingOnTopRect bool StartDrawingOnTop(wxRect* rect = NULL)

bool EndDrawingOnTop()


///////////////////////////////////////////////////////////////////////////////
// wxBitmap

%include "wx/bitmap.h"

//%typedef WXHDC void*
//%typedef WXHBITMAP void*

//wxDIB not always declared
//%class wxDIB
//%class wxBitmapRefData
//%class wxPixelDataBase

%enum wxBitmapType

%class %delete wxBitmap, wxGDIObject

// FIX: missing in GTK, different prototypes
//%if(win) wxBitmap(void* data, int type, int width, int height, int depth = -1)

%ctor wxBitmapCopy(const wxBitmap& bitmap)

// Not supported
// wxBitmap(const char bits[], int width, int height, int depth = 1)
// wxBitmap(const char* const* data)
// wxBitmap(char** data)
// wxBitmap(const void* data, long type, int width, int height, int depth = 1)

// wxPython note: Constructors supported by wxPython are:
//        wxBitmap(name, flag)  Loads a bitmap from a file
//        wxBitmapFromData(data, type, width, height, depth=1)  Creates a bitmap from the given data, which can be of arbitrary type.
//        wxNoRefBitmap(name, flag)  This one won't own the reference, so Python won't call the destructor, this is good for toolbars and such where the parent will manage the bitmap.
//        wxEmptyBitmap(width, height, depth = -1)

%ctor wxEmptyBitmap( int width, int height, int depth = -1)
%if(win) %ctor wxEmptyBitmapDC(int width, int height, const wxDC& dc)
%ctor wxBitmapFromFile( const wxString& name, long type = wxBITMAP_TYPE_BMP_RESOURCE)
%ctor wxBitmapFromImage(const wxImage& image, int depth = -1)
%if(win) %ctor wxBitmapFromImageDC(const wxImage& image, const wxDC& dc)
%ctor wxBitmapFromIcon(const wxIcon& icon)
%{
// %ctor wxBitmapFromXPM(const char* const* bits)
void wxBitmap_new() {
	int count;
	int i;
	wVariant *v;
	const char **xpmData = NULL;
	wxBitmap *returns = NULL;
	wGrow *table;

	/* get source object */
	v = wStackPop();
	count = GetTableCount(v);
	table = v->value.table;

	if(count > 0)
		xpmData = new const char *[count + 1];
	if(xpmData != NULL)
	{
		FillCharArray(xpmData, table, count);
		returns = new wxBitmap(xpmData);
		for(i = 0; i < count; i++)
		{
			wFree((void*) xpmData[i]);
			xpmData[i] = NULL;
		}
		delete xpmData;
	}
	/* deref the object */
	wVariantDeref( v );
	if(returns == NULL)
		returns = new wxBitmap(wxNullBitmap);

	wWrapDerefArgs();
	wWrapSetThis( _wxBitmap, (void *)returns );
}

%}
%method new wxBitmap_new(const char* const* bits)

// FIX: Missing from GTK
%if(win) static void AddHandler(wxBitmapHandler* handler)
%if(win) static void CleanUpHandlers()
virtual bool Create(int width, int height, int depth = -1)
%if(win) %rename CreateDC bool Create(int width, int height, const wxDC& dc)
%if(win) %rename CreateFromData bool Create(const void* data, long type, int width, int height, int depth = 1)

// TODO: fix, and alias...
// static wxBitmapHandler* FindHandler(const wxString& name)
// static wxBitmapHandler* FindHandler(const wxString& extension, long bitmapType)
// static wxBitmapHandler* FindHandler(long bitmapType)

int GetDepth() const
// FIX: Missing from GTK
%if(win) static wxList& GetHandlers()
int GetHeight() const
wxPalette* GetPalette() const
wxMask* GetMask() const
%if(win) wxBitmap GetMaskBitmap() const
int GetWidth() const
wxImage ConvertToImage() const
wxBitmap GetSubBitmap(const wxRect &rect) const
//wxBitmap GetSubBitmapOfHDC( const wxRect& rect, WXHDC hdc ) const
bool CopyFromIcon(const wxIcon& icon)
%if(win) bool CopyFromCursor(const wxCursor& cursor)
//bool CopyFromDIB(const wxDIB& dib)
// FIX: missing in GTK
%if(win) static void InitStandardHandlers()
%if(win) static void InsertHandler(wxBitmapHandler* handler)
bool LoadFile(const wxString& name, wxBitmapType type = wxBITMAP_TYPE_BMP_RESOURCE)
bool IsOk() const
bool Ok() const
// FIX: Missing in GTK
%if(win) static bool RemoveHandler(const wxString& name)
bool SaveFile(const wxString& name, wxBitmapType type, wxPalette* palette = NULL)
void SetDepth(int depth)
void SetHeight(int height)
void SetMask(wxMask* mask)
// Fix: 'SetOk' is not a member of 'wxBitmap'
// void SetOk(int isOk)
// FIX: Missing in GTK
%if(win) void SetPalette(const wxPalette& palette)
void SetWidth(int width)

//wxBitmapRefData *GetBitmapData() const
//void *GetRawData(wxPixelDataBase& data, int bpp)
//void UngetRawData(wxPixelDataBase& data)
bool HasAlpha() const
void UseAlpha()
//void SetHBITMAP(WXHBITMAP bmp)
//WXHBITMAP GetHBITMAP() const
// these are only available in debugger mode
//%not(gcc) void SetSelectedInto(wxDC *dc)
//%not(gcc) wxDC *GetSelectedInto() const

// not supported
// wxBitmap& operator =(const wxBitmap& bitmap)
// bool operator ==(const wxBitmap& bitmap)
// bool operator !=(const wxBitmap& bitmap)

%ptr wxNullBitmap

%num wxBITMAP_TYPE_INVALID
%num wxBITMAP_TYPE_BMP
%num wxBITMAP_TYPE_BMP_RESOURCE
%num wxBITMAP_TYPE_RESOURCE
%num wxBITMAP_TYPE_ICO
%num wxBITMAP_TYPE_ICO_RESOURCE
%num wxBITMAP_TYPE_CUR
%num wxBITMAP_TYPE_CUR_RESOURCE
%num wxBITMAP_TYPE_XBM
%num wxBITMAP_TYPE_XBM_DATA
%num wxBITMAP_TYPE_XPM
%num wxBITMAP_TYPE_XPM_DATA
%num wxBITMAP_TYPE_TIF
%num wxBITMAP_TYPE_TIF_RESOURCE
%num wxBITMAP_TYPE_GIF
%num wxBITMAP_TYPE_GIF_RESOURCE
%num wxBITMAP_TYPE_PNG
%num wxBITMAP_TYPE_PNG_RESOURCE
%num wxBITMAP_TYPE_JPEG
%num wxBITMAP_TYPE_JPEG_RESOURCE
%num wxBITMAP_TYPE_PNM
%num wxBITMAP_TYPE_PNM_RESOURCE
%num wxBITMAP_TYPE_PCX
%num wxBITMAP_TYPE_PCX_RESOURCE
%num wxBITMAP_TYPE_PICT
%num wxBITMAP_TYPE_PICT_RESOURCE
%num wxBITMAP_TYPE_ICON
%num wxBITMAP_TYPE_ICON_RESOURCE
%num wxBITMAP_TYPE_MACCURSOR
%num wxBITMAP_TYPE_MACCURSOR_RESOURCE
%num wxBITMAP_TYPE_ANY


///////////////////////////////////////////////////////////////////////////////
// wxIcon

%include <wx/icon.h>
%class %delete wxIcon, wxBitmap

//it's %enum in GTK
//%typedef wxBitmapType int

//wxIcon()
%ctor wxIconEmpty()
%ctor wxIconCopy(const wxIcon& icon)
//wxIcon(void* data, int type, int width, int height, int depth = -1)
//wxIcon(const char bits[], int width, int height, int depth = 1)
// doesn't exists but is documented?
//%ctor wxEmptyIcon(int width, int height, int depth = -1)
//wxIcon(char** bits)
// Icon from XPM Data - load from table like wxBitmapFromXPM
//%ctor wxIconFromXPM(const char** bits)
%{
void wxIcon_new() {
	int count;
	int i;
	wVariant *v;
	const char **xpmData = NULL;
	wxIcon *returns = NULL;
	wGrow *table;

	/* get source object */
	v = wStackPop();
	count = GetTableCount(v);
	table = v->value.table;

	if(count > 0)
		xpmData = new const char *[count + 1];
	if(xpmData != NULL)
	{
		FillCharArray(xpmData, table, count);
		returns = new wxIcon(xpmData);
		for(i = 0; i < count; i++)
		{
			wFree((void*) xpmData[i]);
			xpmData[i] = NULL;
		}
		delete xpmData;
	}
	/* deref the object */
	wVariantDeref( v );
	if(returns == NULL)
		returns = new wxIcon(wxNullIcon);

	wWrapDerefArgs();
	wWrapSetThis( _wxIcon, (void *)returns );
}

%}
%method new wxIcon_new( char** xpmData )

%ctor wxIconFromFile(const wxString& name, wxBitmapType type, int desiredWidth = -1, int desiredHeight = -1)
%ctor wxIconFromLocation(const wxIconLocation& loc)

void CopyFromBitmap(const wxBitmap& bmp)
//~wxIcon()
int GetDepth() const
int GetHeight() const
int GetWidth() const
bool LoadFile(const wxString& name, wxBitmapType type)
bool IsOk() const
void SetDepth(int depth)
void SetHeight(int height)
void SetWidth(int width)

%ptr wxNullIcon

///////////////////////////////////////////////////////////////////////////////
// wxImage

%include "wx/image.h"

%class wxImageHistogram

%if(win) %class wxBitmapHandler
%if(win) %class wxGDIImageHandler

%class %delete wxImageHandler
// wxImageHandler() // abstract class
// ~wxImageHandler()
const wxString&  GetName() const
const wxString&  GetExtension() const
int GetImageCount(wxInputStream& stream)
long GetType() const
const wxString&  GetMimeType() const
bool LoadFile(wxImage* image, wxInputStream& stream, bool verbose=true, int index=0)
bool SaveFile(wxImage* image, wxOutputStream& stream)
void SetName(const wxString& name)
void SetExtension(const wxString& extension)
void SetMimeType(const wxString& mimetype)
void SetType(long type)

%class %delete wxBMPHandler, wxImageHandler
wxBMPHandler()
%class %delete wxICOHandler, wxBMPHandler
wxICOHandler()
%class %delete wxCURHandler, wxICOHandler
wxCURHandler()
%class %delete wxANIHandler, wxCURHandler
wxANIHandler()

%class %delete wxPNGHandler, wxImageHandler
wxPNGHandler()
%class %delete wxGIFHandler, wxImageHandler
wxGIFHandler()
%class %delete wxPCXHandler, wxImageHandler
wxPCXHandler()
%class %delete wxJPEGHandler, wxImageHandler
wxJPEGHandler()
%class %delete wxTGAHandler, wxImageHandler
wxTGAHandler()
%class %delete wxTIFFHandler, wxImageHandler
wxTIFFHandler()
%class %delete wxPNMHandler, wxImageHandler
wxPNMHandler()
%class %delete wxXPMHandler, wxImageHandler
wxXPMHandler()
//%if(wxUSE_IFF) %class %delete wxIFFHandler, wxImageHandler
//wxIFFHandler()

%class %delete wxImage, wxObject

//wxImage(const wxImage& image)
%ctor wxImageCopy(const wxImage& image)
%ctor wxEmptyImage()
%ctor wxImageFromBitmap(const wxBitmap& bitmap)
%ctor wxImageEmpty(int width, int height, bool clear = true)
%ctor wxImageFromData(int width, int height, uchar* data, bool static_data=FALSE)
%ctor wxImageFromFile(const wxString& name, long type = wxBITMAP_TYPE_ANY, int index = -1)
%ctor wxImageFromMIME( const wxString& name, const wxString& mimetype, int index = -1 )

%ctor wxImageFromStream(wxInputStream& stream, long type = wxBITMAP_TYPE_ANY, int index = -1)
//%ctor wxImageFromStream( wxInputStream& stream, const wxString& mimetype, int index = -1 )
%{
void wxImage_new() {
	int count;
	int i;
	wVariant *v;
	const char **xpmData = NULL;
	wxImage *returns = NULL;
	wGrow *table;

	/* get source object */
	v = wStackPop();
	count = GetTableCount(v);
	table = v->value.table;

	if(count > 0)
		xpmData = new const char *[count + 1];
	if(xpmData != NULL)
	{
		FillCharArray(xpmData, table, count);
		returns = new wxImage(xpmData);
		for(i = 0; i < count; i++)
		{
			wFree((void*) xpmData[i]);
			xpmData[i] = NULL;
		}
		delete xpmData;
	}
	/* deref the object */
	wVariantDeref( v );
	if(returns == NULL)
		returns = new wxImage(wxNullImage);

	wWrapDerefArgs();
	wWrapSetThis( _wxImage, (void *)returns );
}

%}
%method new wxImage_new( char** xpmData )

static void AddHandler(wxImageHandler* handler)
static void CleanUpHandlers()
//wxBitmap ConvertToBitmap() const
wxImage Copy() const
// FIX: doesn't seem to be handling bool correctly
// bool Create(int width, int height)
void Destroy()
//static wxImageHandler* FindHandler(const wxString& name)
//static wxImageHandler* FindHandler(const wxString& extension, long imageType)
//static wxImageHandler* FindHandler(long imageType)
//static wxImageHandler* FindHandlerMime(const wxString& mimetype)
uchar* GetData() const
static wxList& GetHandlers()
int GetHeight() const
unsigned char GetMaskBlue() const
unsigned char GetMaskGreen() const
unsigned char GetMaskRed() const
wxImage GetSubImage(const wxRect& rect) const
int GetWidth() const
static void InitStandardHandlers()
static void InsertHandler(wxImageHandler* handler)
bool LoadFile(const wxString& name, long type = wxBITMAP_TYPE_ANY, int index = -1)
%rename LoadMimeFile bool LoadFile(const wxString& name, const wxString& mimetype, int index = -1)
%rename LoadStreamFile bool LoadFile(wxInputStream& stream, long type, int index = -1)
%rename LoadMimeStreamFile bool LoadFile(wxInputStream& stream, const wxString& mimetype, int index = -1)
bool Ok() const
bool IsOk() const
static bool RemoveHandler(const wxString& name)
bool SaveFile(const wxString& name, int type)
%rename SaveMimeFile bool SaveFile(const wxString& name, const wxString& mimetype)
%rename SaveStreamFile bool SaveFile(wxOutputStream& stream, int type)
%rename SaveMimeStreamFile bool SaveFile(wxOutputStream& stream, const wxString& mimetype)

void SetData(uchar* data, bool static_data=false)
%rename SetDataAndSize void SetData( uchar *data, int new_width, int new_height, bool static_data=false )

void SetMask(bool hasMask = TRUE)
%alias SetMaskColor void SetMaskColour(unsigned char red, unsigned char blue, unsigned char green)
bool HasMask() const
bool HasPalette() const
const wxPalette& GetPalette() const
void SetPalette(const wxPalette& palette)

void SetOption(const wxString& name, const wxString& value)
%rename SetOptionString void SetOption(const wxString& name, const wxString& value)
%rename SetOptionInt void SetOption(const wxString& name, int value)
wxString GetOption(const wxString& name) const
int GetOptionInt(const wxString& name) const
bool HasOption(const wxString& name) const
unsigned long CountColours( unsigned long stopafter = -1 ) const
unsigned long ComputeHistogram( wxImageHistogram &h ) const
void RotateHue(double angle)

wxImage Size( const wxSize& size, const wxPoint& pos, int r = -1, int g = -1, int b = -1 ) const
void Paste( const wxImage &image, int x, int y )
wxImage Scale( int width, int height, int quality = wxIMAGE_QUALITY_NORMAL ) const
wxImage ResampleBox(int width, int height) const
wxImage ResampleBicubic(int width, int height) const
wxImage Blur(int radius)
wxImage BlurHorizontal(int radius)
wxImage BlurVertical(int radius)
wxImage ShrinkBy( int xFactor , int yFactor ) const
wxImage& Rescale( int width, int height, int quality = wxIMAGE_QUALITY_NORMAL )
wxImage& Resize( const wxSize& size, const wxPoint& pos,int r = -1, int g = -1, int b = -1 )
wxImage Rotate(double angle, const wxPoint & centre_of_rotation, bool interpolating = true, wxPoint * offset_after_rotation = NULL) const
wxImage Rotate90( bool clockwise = true ) const
wxImage Mirror( bool horizontally = true ) const
void Replace( unsigned char r1, unsigned char g1, unsigned char b1, unsigned char r2, unsigned char g2, unsigned char b2 )
wxImage ConvertToGreyscale( double lr = 0.299, double lg = 0.587, double lb = 0.114 ) const
wxImage ConvertToMono( unsigned char r, unsigned char g, unsigned char b ) const
void SetRGB( int x, int y, unsigned char r, unsigned char g, unsigned char b )
%rename SetRGBRect void SetRGB( const wxRect& rect, unsigned char r, unsigned char g, unsigned char b )
unsigned char GetRed( int x, int y ) const
unsigned char GetGreen( int x, int y ) const
unsigned char GetBlue( int x, int y ) const
void SetAlpha(int x, int y, unsigned char alpha)
%rename GetAlphaXY unsigned char GetAlpha(int x, int y) const
bool FindFirstUnusedColour( unsigned char *r, unsigned char *g, unsigned char *b, unsigned char startR = 1, unsigned char startG = 0, unsigned char startB = 0 ) const
bool SetMaskFromImage(const wxImage & mask, unsigned char mr, unsigned char mg, unsigned char mb)
bool ConvertAlphaToMask(unsigned char threshold = wxIMAGE_ALPHA_THRESHOLD)
bool ConvertColourToAlpha( unsigned char r, unsigned char g, unsigned char b )
static bool CanRead( const wxString& name )
static int GetImageCount( const wxString& name, long type = wxBITMAP_TYPE_ANY )

unsigned char *GetAlpha() const
bool HasAlpha() const
%rename SetAlphaChar void SetAlpha(unsigned char *alpha = NULL, bool static_data=false)
void InitAlpha()
bool IsTransparent(int x, int y, unsigned char threshold = wxIMAGE_ALPHA_THRESHOLD) const
//void SetMaskColour( unsigned char r, unsigned char g, unsigned char b )
bool GetOrFindMaskColour( unsigned char *r, unsigned char *g, unsigned char *b ) const

%builtin %rename wxImage_AddHandler void wxImage::AddHandler(wxImageHandler* handler)
%builtin %rename wxImage_CleanUpHandlers void wxImage::CleanUpHandlers()
%builtin %rename wxImage_FindHandler wxImageHandler* wxImage::FindHandler(const wxString& name)
%builtin %rename wxImage_GetImageExtWildcard wxString wxImage::GetImageExtWildcard()
%builtin %rename wxImage_GetImageCount int wxImage::GetImageCount(const wxString& filename, long type = wxBITMAP_TYPE_ANY)
%builtin %rename wxImage_GetHandlers wxList& wxImage::GetHandlers()
%builtin %rename wxImage_InitStandardHandlers void wxImage::InitStandardHandlers()
%builtin %rename wxImage_InsertHandler void wxImage::InsertHandler(wxImageHandler* handler)
%builtin %rename wxImage_RemoveHandler bool wxImage::RemoveHandler(const wxString& name)

// class in class not supported
//static HSVValue RGBtoHSV(const RGBValue& rgb)
//static RGBValue HSVtoRGB(const HSVValue& hsv)

%ptr wxNullImage

///////////////////////////////////////////////////////////////////////////////
// wxImageList


%class %delete wxImageList, wxObject
%include "wx/imaglist.h"

%ctor wxImageListEmpty()
wxImageList(int width, int height, const bool mask = true, int initialCount = 1)
int Add(const wxBitmap& bitmap, const wxBitmap& mask = wxNullBitmap)
%rename AddWithColourMask int Add(const wxBitmap& bitmap, const wxColour& maskColour)
%rename AddIcon int Add(const wxIcon& icon)
bool Create(int width, int height, const bool mask = TRUE, int initialCount = 1)
bool Draw(int index, wxDC& dc, int x, int y, int flags = wxIMAGELIST_DRAW_NORMAL, const bool solidBackground = FALSE)

%num wxIMAGELIST_DRAW_NORMAL
%num wxIMAGELIST_DRAW_TRANSPARENT
%num wxIMAGELIST_DRAW_SELECTED
%num wxIMAGELIST_DRAW_FOCUSED

int GetImageCount() const
// bool GetSize(int index, int& width, int& height) const
%{
    void wxImageList_GetSize()
    {
        int index = wStackPopInteger();
        int width, height;
        ((wxImageList *)wTheCall->self->ptr)->GetSize(index, width, height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)width );
        wStackPushInteger( (wInteger)height );
    }
    void wxImageList_GetSizeWidth()
    {
        int index = wStackPopInteger();
        int width, height;
        ((wxImageList *)wTheCall->self->ptr)->GetSize(index, width, height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)width );
    }
    void wxImageList_GetSizeHeight()
    {
        int index = wStackPopInteger();
        int width, height;
        ((wxImageList *)wTheCall->self->ptr)->GetSize(index, width, height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)height );
    }
%}
%method GetSize wxImageList_GetSize(int index)
%method GetSizeWidth wxImageList_GetSizeWidth(int index)
%method GetSizeHeight wxImageList_GetSizeHeight(int index)

bool Remove(int index)
bool RemoveAll()
%if(win) bool Replace(int index, const wxBitmap& bitmap, const wxBitmap& mask = wxNullBitmap)
%rename ReplaceIcon bool Replace(int index, const wxIcon& icon)
wxBitmap  GetBitmap(int index) const
wxIcon  GetIcon(int index) const


// #########################################################
// artprov.h

%include <wx/artprov.h>

%typedef wxArtClient wxString
%typedef wxArtID wxString

// ==============================
// Class: wxArtProvider

%str wxART_TOOLBAR
%str wxART_MENU
%str wxART_FRAME_ICON

%str wxART_CMN_DIALOG
%str wxART_HELP_BROWSER
%str wxART_MESSAGE_BOX
%str wxART_BUTTON

%str wxART_OTHER

%str wxART_ADD_BOOKMARK
%str wxART_DEL_BOOKMARK
%str wxART_HELP_SIDE_PANEL
%str wxART_HELP_SETTINGS
%str wxART_HELP_BOOK
%str wxART_HELP_FOLDER
%str wxART_HELP_PAGE
%str wxART_GO_BACK
%str wxART_GO_FORWARD
%str wxART_GO_UP
%str wxART_GO_DOWN
%str wxART_GO_TO_PARENT
%str wxART_GO_HOME
%str wxART_FILE_OPEN
%str wxART_FILE_SAVE
%str wxART_FILE_SAVE_AS
%str wxART_PRINT
%str wxART_HELP
%str wxART_TIP
%str wxART_REPORT_VIEW
%str wxART_LIST_VIEW
%str wxART_NEW_DIR
%str wxART_HARDDISK
%str wxART_FLOPPY
%str wxART_CDROM
%str wxART_REMOVABLE
%str wxART_FOLDER
%str wxART_FOLDER_OPEN
%str wxART_GO_DIR_UP
%str wxART_EXECUTABLE_FILE
%str wxART_NORMAL_FILE
%str wxART_TICK_MARK
%str wxART_CROSS_MARK
%str wxART_ERROR
%str wxART_QUESTION
%str wxART_WARNING
%str wxART_INFORMATION
%str wxART_MISSING_IMAGE

%str wxART_COPY
%str wxART_CUT
%str wxART_PASTE
%str wxART_DELETE
%str wxART_NEW

%str wxART_UNDO
%str wxART_REDO

%str wxART_QUIT

%str wxART_FIND
%str wxART_FIND_AND_REPLACE

%class wxArtProvider, wxObject
static void Push(wxArtProvider *provider)
static void Insert(wxArtProvider *provider)
static bool Pop()
static bool Remove(wxArtProvider *provider)
static bool Delete(wxArtProvider *provider)
static wxBitmap GetBitmap(const wxArtID& id, const wxArtClient& client = wxART_OTHER, const wxSize& size = wxDefaultSize)
static wxIcon GetIcon(const wxArtID& id, const wxArtClient& client = wxART_OTHER, const wxSize& size = wxDefaultSize)
static wxSize GetSizeHint(const wxArtClient& client, bool platform_depen = false)

%builtin %rename wxArtProvider_Delete bool wxArtProvider::Delete(wxArtProvider* provider)
%builtin %rename wxArtProvider_GetBitmap wxBitmap wxArtProvider::GetBitmap(const wxArtID& id, const wxArtClient& client = wxART_OTHER, const wxSize& size = wxDefaultSize)
%builtin %rename wxArtProvider_GetIcon wxIcon wxArtProvider::GetIcon(const wxArtID& id, const wxArtClient& client = wxART_OTHER, const wxSize& size = wxDefaultSize)
%builtin %rename wxArtProvider_Insert void wxArtProvider::Insert(wxArtProvider* provider)
%builtin %rename wxArtProvider_Pop bool wxArtProvider::Pop()
%builtin %rename wxArtProvider_Push void wxArtProvider::Push(wxArtProvider* provider)
%builtin %rename wxArtProvider_Remove bool wxArtProvider::Remove(wxArtProvider* provider)

///////////////////////////////////////////////////////////////////////////////
// wxCursor

%include "wx/cursor.h"

%class %delete wxCursor, wxBitmap

// don't use wxCursor(const wxString& name, ...); as it is just on Windows valid
wxCursor()
%ctor wxCursorFromId(int cursorId)
%ctor wxStockCursor(int cursorId)
%ctor wxCursorFromImage(const wxImage& image)
%ctor wxCursorCopy(const wxCursor& cursor)

%ptr wxSTANDARD_CURSOR
%ptr wxHOURGLASS_CURSOR
%ptr wxCROSS_CURSOR
%ptr wxNullCursor

%num wxCURSOR_NONE
%num wxCURSOR_ARROW
%num wxCURSOR_BULLSEYE
%num wxCURSOR_CHAR
%num wxCURSOR_CROSS
%num wxCURSOR_HAND
%num wxCURSOR_IBEAM
%num wxCURSOR_LEFT_BUTTON
%num wxCURSOR_MAGNIFIER
%num wxCURSOR_MIDDLE_BUTTON
%num wxCURSOR_NO_ENTRY
%num wxCURSOR_PAINT_BRUSH
%num wxCURSOR_PENCIL
%num wxCURSOR_POINT_LEFT
%num wxCURSOR_POINT_RIGHT
%num wxCURSOR_QUESTION_ARROW
%num wxCURSOR_RIGHT_BUTTON
%num wxCURSOR_SIZENESW
%num wxCURSOR_SIZENS
%num wxCURSOR_SIZENWSE
%num wxCURSOR_SIZEWE
%num wxCURSOR_SIZING
%num wxCURSOR_SPRAYCAN
%num wxCURSOR_WAIT
%num wxCURSOR_WATCH
%num wxCURSOR_BLANK
%num wxCURSOR_ARROWWAIT
%num wxCURSOR_MAX

bool IsOk() const
bool Ok() const

///////////////////////////////////////////////////////////////////////////////
// Data Types
///////////////////////////////////////////////////////////////////////////////

// #########################################################
// string.h

// RP: replaced some "char*" and "wxChar*" to "wxString&"
%include <wx/string.h>

%class wxCharBuffer

%class %delete wxString
%num wxSTRING_MAXLEN
// alias wxEmptyString
//%{
//    #define __wxEmptyString ""
//%}
//%str %alias wxEmptyString __wxEmptyString
%struct wxStringData
//%typedef wxCharBuffer wxString

wxString(const wxString& stringSrc = wxEmptyString)
// w/o (, size_t nLength = npos)
%if(unicode) %ctor wxStringConv(const char *psz, const wxMBConv& conv)
size_t Len() const
bool IsEmpty() const
wxString& Truncate(size_t uiLen)
void Empty()
void Clear()
bool IsAscii() const
bool IsNumber() const
bool IsWord() const
wxChar  GetChar(size_t n) const
void  SetChar(size_t n, wxChar ch)
const wxChar* c_str() const
//const wxString c_str() const
const wxChar* wx_str()  const
//const wxString wx_str()  const
const wxChar* GetData() const
//const wxString GetData() const
static wxString FromAscii(const char *ascii)
const char* ToAscii() const
static wxString FromUTF8(const char *utf8)
//static wxString FromUTF8(const char *utf8, size_t len)
const wxCharBuffer utf8_str() const
const wxCharBuffer ToUTF8() const
static wxString From8BitData(const char *data)
const char * To8BitData() const
const char * mb_str() const
%{
    void wxString_SetValue()
    {
        wxString value = wxString(wStackPopChar(), *wxConvCurrent);
        wxString* s = (wxString *) wTheCall->self->ptr;
        *s = value;
        wWrapDerefArgs();
    }
%}
%method SetValue wxString_SetValue(const wxString& value)

wxString& Append(const wxString& s)
wxString& Prepend(const wxString& str)
int Cmp(const wxString& s) const
int CmpNoCase(const wxString& s)
bool IsSameAs(const wxString& psz, bool compareWithCase = true) const
wxString Mid(size_t nFirst, size_t nCount = wxSTRING_MAXLEN) const
wxString Left(size_t nCount) const
wxString Right(size_t nCount) const
wxString BeforeFirst(wxChar ch) const
wxString BeforeLast(wxChar ch) const
wxString AfterFirst(wxChar ch) const
wxString AfterLast(wxChar ch) const
wxString& MakeUpper()
wxString Upper() const
wxString& MakeLower()
wxString Lower() const
wxString& Trim(bool bFromRight = true)
wxString& Pad(size_t nCount, wxChar chPad = wxT(' '), bool bFromRight = true)
%rename FindChar int Find(wxChar ch, bool bFromEnd = false) const
int Find(const wxString& pszSub) const
size_t Replace(const wxString& szOld, const wxString& szNew, bool bReplaceAll = true)
bool Matches(const wxString& szMask) const
//RP: Need wrappers
//bool ToLong(long *val, int base = 10) const
//bool ToULong(unsigned long *val, int base = 10) const
//bool ToLongLong(wxLongLong_t *val, int base = 10) const
//bool ToULongLong(wxULongLong_t *val, int base = 10) const
//bool ToDouble(double *val) const
//int Printf(const wxChar *pszFormat, ...)
//int PrintfV(const wxChar* pszFormat, va_list argptr)
//static wxString Format(const wxChar *pszFormat, ...)
//static wxString FormatV(const wxChar *pszFormat, va_list argptr)
// count chars - wxWidget version 1 compatibility function
int Freq(wxChar ch) const

bool Contains(const wxString& str) const
int First(wxChar c)
size_t Index(wxChar ch) const
bool IsNull() const
wxChar Last() const
size_t Length() const
void LowerCase()
wxString&  Remove(size_t pos)
wxString&  RemoveLast()
void Shrink()
//FIXME: wxString* = NULL can't be handled
//bool StartsWith(const wxChar *prefix, wxString *rest = NULL) const
//bool EndsWith(const wxChar *suffix, wxString *rest = NULL) const
wxString  SubString(size_t from, size_t to) const
void UngetWriteBuf()
void UpperCase()

//%builtin %rename wxString_Format wxString wxString::Format(const wxChar *format, ...)
//%builtin %rename wxString_FormatV wxString wxString::FormatV(const wxChar *format, va_list argptr)
%builtin %rename wxString_From8BitData wxString wxString::From8BitData(const char* buf)
%builtin %rename wxString_FromAscii wxString wxString::FromAscii(const char* s)
%builtin %rename wxString_FromUTF8 wxString wxString::FromUTF8(const char* s)

// #########################################################
// tokenzr.h

%include <wx/tokenzr.h>

%str wxDEFAULT_DELIMITERS

%enum wxStringTokenizerMode
  %num wxTOKEN_INVALID
  %num wxTOKEN_DEFAULT
  %num wxTOKEN_RET_EMPTY
  %num wxTOKEN_RET_EMPTY_ALL
  %num wxTOKEN_RET_DELIMS
  %num wxTOKEN_STRTOK

// ==============================
// Class: wxStringTokenizer

%class %delete wxStringTokenizer, wxObject
//wxStringTokenizer()
wxStringTokenizer(const wxString& str, const wxString& delims = wxDEFAULT_DELIMITERS, wxStringTokenizerMode mode = wxTOKEN_DEFAULT)
void SetString(const wxString& str, const wxString& delims = wxDEFAULT_DELIMITERS, wxStringTokenizerMode mode = wxTOKEN_DEFAULT)
void Reinit(const wxString& str)
size_t CountTokens() const
bool HasMoreTokens() const
wxString GetNextToken()
wxChar GetLastDelimiter() const
wxString GetString() const
size_t GetPosition() const
wxStringTokenizerMode GetMode() const
bool AllowEmpty() const
wxString NextToken()
//void SetString(const wxString& to_tokenize, const wxString& delims, bool ret_delim)
//wxStringTokenizer(const wxString& to_tokenize, const wxString& delims, bool ret_delim)

// #########################################################
// variant.h

%include <wx/variant.h>

// ==============================
// Class: wxVariantData

//%class wxVariantData, wxObject
//wxVariantData()
//virtual bool Eq(wxVariantData& data) const
//virtual bool Write(wxSTD ostream& str) const
//virtual bool Write(wxString& str) const
//virtual bool Read(wxSTD istream& str)
//virtual bool Read(wxString& str)
//virtual wxString GetType() const
//virtual wxClassInfo* GetValueClassInfo()
//void IncRef()
//void DecRef()
//int GetRefCount() const

// ==============================
// Class: wxVariant

%class wxVariant, wxObject
wxVariant()
//wxVariant(const wxVariant& variant)
//wxVariant(wxVariantData* data, const wxString& name = wxEmptyString)
%ctor wxVariantDouble(double val, const wxString& name = wxEmptyString)

%ctor wxVariantLong(long val, const wxString& name = wxEmptyString)
%ctor wxVariantInteger(int val, const wxString& name = wxEmptyString)
%ctor wxVariantShort(short val, const wxString& name = wxEmptyString)

%ctor wxVariantBool(bool val, const wxString& name = wxEmptyString)

%ctor wxVariantDateTime(const wxDateTime& val, const wxString& name = wxEmptyString)
//wxVariant(const DATE_STRUCT* valptr, const wxString& name = wxEmptyString)
//wxVariant(const TIME_STRUCT* valptr, const wxString& name = wxEmptyString)
//wxVariant(const TIMESTAMP_STRUCT* valptr, const wxString& name = wxEmptyString)

%ctor wxVariantString(const wxString& val, const wxString& name = wxEmptyString)
%ctor wxVariantChars(const wxChar* val, const wxString& name = wxEmptyString)

%ctor wxVariantArrayString(const wxArrayString& val, const wxString& name = wxEmptyString)
%ctor wxVariantChar(wxChar val, const wxString& name = wxEmptyString)

%ctor wxVariantPtr(void* ptr, const wxString& name = wxEmptyString)

%ctor wxVariantList(const wxList& val, const wxString& name = wxEmptyString)
%ctor wxVariantObject(wxObject* ptr, const wxString& name = wxEmptyString)

void SetName(const wxString& name)
const wxString& GetName() const
bool IsNull() const
//wxVariantData* GetData() const
//void SetData(wxVariantData* data)
void Ref(const wxVariant& clone)
void UnRef()
void MakeNull()
void Clear()
wxString GetType() const
bool IsType(const wxString& type) const
bool IsValueKindOf(const wxClassInfo* type) const
wxString MakeString() const
double GetReal() const
double GetDouble() const
long GetInteger() const
long GetLong() const
bool GetBool() const
wxDateTime GetDateTime() const
wxString GetString() const
wxChar GetChar() const
wxArrayString GetArrayString() const
void* GetVoidPtr() const
wxObject* GetWxObjectPtr() const
//FIXME: Wrapper needed
//wxVariant operator[] (size_t idx) const
//wxVariant& operator[] (size_t idx)
wxList& GetList() const
size_t GetCount() const
void NullList()
void Append(const wxVariant& value)
void Insert(const wxVariant& value)
bool Member(const wxVariant& value) const
bool Delete(size_t item)
void ClearList()
//bool Convert(long* value) const
//bool Convert(bool* value) const
//bool Convert(double* value) const
//bool Convert(wxString* value) const
//bool Convert(wxChar* value) const
//bool Convert(wxDateTime* value) const

// %num wxGetVariantCast

///////////////////////////////////////////////////////////////////////////////
// wxDateTime

// #########################################################
// datetime.h

%include <wx/datetime.h>

%num WX_TIME_BASE_OFFSET
%typedef wxDateTime_t unsigned short
//%typedef Tm wxDateTime::Tm

// ==============================
// Class: wxDateTime

%class %delete wxDateTime

%ptr wxDefaultDateTimeFormat
%ptr wxDefaultTimeSpanFormat
// const wxDateTime - how can we handle this?
//%ptr wxDefaultDateTime
//%ptr wxInvalidDateTime

// Bugfix: removed all const TimeZone tz = wxDateTime::Local
//wxDateTime()
wxDateTime(wxDateTime_t day, wxDateTime::Month month, int year = wxDateTime::Inv_Year, wxDateTime_t hour = 0, wxDateTime_t minute = 0, wxDateTime_t second = 0, wxDateTime_t millisec = 0)
// FIXME: these ctor declarations are wrong
// %ctor wxDateTimeFromTimeT wxDateTime(time_t timet)
// %ctor wxDateTimeFromJDN wxDateTime(double jdn)
// %ctor wxDateTimeFromHMS wxDateTime(wxDateTime_t hour, wxDateTime_t minute = 0, wxDateTime_t second = 0, wxDateTime_t millisec = 0)
// FIXME: "month should be optional"  Hrm?
// %ctor wxDateTimeFromDMYwxDateTime& wxDateTime(wxDateTime_t day, wxDateTime::Month month = wxDateTime::Inv_Month, int wxDateTime::Inv_Year, wxDateTime_t hour = 0, wxDateTime_t minute = 0, wxDateTime_t second = 0, wxDateTime_t millisec = 0)
//RP this are the current declarations
//inline wxDateTime(time_t timet)
//inline wxDateTime(const struct tm& tm)
//inline wxDateTime(const Tm& tm)
//inline wxDateTime(double jdn)
//inline wxDateTime(wxDateTime_t hour, wxDateTime_t minute = 0, wxDateTime_t second = 0, wxDateTime_t millisec = 0)
//inline wxDateTime(wxDateTime_t day, Month month, int year = Inv_Year, wxDateTime_t hour = 0, wxDateTime_t minute = 0, wxDateTime_t second = 0, wxDateTime_t millisec = 0)
//wxDateTime(const wxLongLong& time)
wxDateTime& SetToCurrent()
%rename SetTimeT wxDateTime& Set(time_t timet)
%rename SetJDN wxDateTime& Set(double jdn)
%rename SetHMS wxDateTime& Set(wxDateTime_t hour, wxDateTime_t minute = 0, wxDateTime_t second = 0, wxDateTime_t millisec = 0)
wxDateTime& Set(wxDateTime_t day, wxDateTime::Month month = wxDateTime::Inv_Month, int year = wxDateTime::Inv_Year, wxDateTime_t hour = 0, wxDateTime_t minute = 0, wxDateTime_t second = 0, wxDateTime_t millisec = 0)
wxDateTime& ResetTime()
wxDateTime GetDateOnly() const
wxDateTime& SetYear(int year)
wxDateTime& SetMonth(wxDateTime::Month month)
wxDateTime& SetDay(wxDateTime_t day)
wxDateTime& SetHour(wxDateTime_t hour)
wxDateTime& SetMinute(wxDateTime_t minute)
wxDateTime& SetSecond(wxDateTime_t second)
wxDateTime& SetMillisecond(wxDateTime_t millisecond)
wxDateTime& SetToWeekDayInSameWeek(wxDateTime::WeekDay weekday, wxDateTime::WeekFlags flags = wxDateTime::Monday_First)
wxDateTime GetWeekDayInSameWeek(wxDateTime::WeekDay weekday, wxDateTime::WeekFlags flags = wxDateTime::Monday_First) const
wxDateTime& SetToNextWeekDay(wxDateTime::WeekDay weekday)
wxDateTime GetNextWeekDay(wxDateTime::WeekDay weekday) const
wxDateTime& SetToPrevWeekDay(wxDateTime::WeekDay weekday)
wxDateTime GetPrevWeekDay(wxDateTime::WeekDay weekday) const
bool SetToWeekDay(wxDateTime::WeekDay weekday, int n = 1, wxDateTime::Month month = wxDateTime::Inv_Month, int year = wxDateTime::Inv_Year)
wxDateTime GetWeekDay(wxDateTime::WeekDay weekday, int n = 1, wxDateTime::Month month = wxDateTime::Inv_Month, int year = wxDateTime::Inv_Year) const
bool SetToLastWeekDay(wxDateTime::WeekDay weekday, wxDateTime::Month month = wxDateTime::Inv_Month, int year = wxDateTime::Inv_Year)
static wxDateTime SetToWeekOfYear(int year, wxDateTime_t numWeek, wxDateTime::WeekDay weekday = wxDateTime::Mon)
wxDateTime GetLastWeekDay(wxDateTime::WeekDay weekday, wxDateTime::Month month = wxDateTime::Inv_Month, int year = wxDateTime::Inv_Year)

//Deprecated
//bool SetToTheWeek(wxDateTime_t numWeek, wxDateTime::WeekDay weekday = wxDateTime::Mon, wxDateTime::WeekFlags flags = wxDateTime::Monday_First)
//wxDateTime GetWeek(wxDateTime_t numWeek, wxDateTime::WeekDay weekday = wxDateTime::Mon, wxDateTime::WeekFlags flags = wxDateTime::Monday_First) const

wxDateTime& SetToLastMonthDay(wxDateTime::Month month = wxDateTime::Inv_Month, int year = wxDateTime::Inv_Year)
wxDateTime GetLastMonthDay(wxDateTime::Month month = wxDateTime::Inv_Month, int year = wxDateTime::Inv_Year) const
wxDateTime& SetToYearDay(wxDateTime_t yday)
wxDateTime GetYearDay(wxDateTime_t yday) const
double GetJulianDayNumber() const
double GetJDN() const
double GetModifiedJulianDayNumber() const
double GetMJD() const
double GetRataDie() const
wxDateTime ToTimezone(const TimeZone tz, bool noDST = FALSE) const
wxDateTime& MakeTimezone(const TimeZone tz, bool noDST = FALSE)

wxDateTime FromTimezone(const TimeZone& tz, bool noDST = false) const
wxDateTime& MakeFromTimezone(const TimeZone& tz, bool noDST = false)
wxDateTime ToUTC(bool noDST = false) const
wxDateTime& MakeUTC(bool noDST = false)
wxDateTime ToGMT(bool noDST = false) const
wxDateTime& MakeGMT(bool noDST = false)
wxDateTime FromUTC(bool noDST = false) const
wxDateTime& MakeFromUTC(bool noDST = false)
int IsDST(wxDateTime::Country country = wxDateTime::Country_Default) const

bool IsValid() const
// FIXME: what's the problem here?
// Tm GetTm(const TimeZone tz = wxDateTime::Local) const
// Tm GetTm() const
time_t GetTicks() const

// const and & at the same time doesn't work
//int GetCentury(const TimeZone& tz = wxDateTime::Local) const
//int GetYear(const TimeZone tz = wxDateTime::Local) const
//int GetMonth(const TimeZone tz = wxDateTime::Local) const
//wxDateTime_t GetDay(const TimeZone tz = wxDateTime::Local) const
//wxDateTime_t GetHour(const TimeZone tz = wxDateTime::Local) const
//wxDateTime_t GetMinute(const TimeZone tz = wxDateTime::Local) const
//wxDateTime_t GetSecond(const TimeZone tz = wxDateTime::Local) const
//wxDateTime_t GetMillisecond(const TimeZone tz = wxDateTime::Local) const
//wxDateTime_t GetDayOfYear(const TimeZone tz = wxDateTime::Local) const
//wxDateTime_t GetWeekOfYear(wxDateTime::WeekFlags flags = wxDateTime::Monday_First, const TimeZone tz = wxDateTime::Local) const
//wxDateTime_t GetWeekOfMonth(wxDateTime::WeekFlags flags = wxDateTime::Monday_First, const TimeZone tz = wxDateTime::Local) const

// FIXME: doc don't show wxPython name
%rename GetWeekDayTZ wxDateTime::WeekDay GetWeekDay() const
int GetCentury() const
int GetYear() const
int GetMonth() const
wxDateTime_t GetDay() const

wxDateTime_t GetHour() const
wxDateTime_t GetMinute() const
wxDateTime_t GetSecond() const
wxDateTime_t GetMillisecond() const
wxDateTime_t GetDayOfYear() const
wxDateTime_t GetWeekOfYear(wxDateTime::WeekFlags flags = wxDateTime::Monday_First) const
wxDateTime_t GetWeekOfMonth(wxDateTime::WeekFlags flags = wxDateTime::Monday_First) const
bool IsWorkDay(wxDateTime::Country country = wxDateTime::Country_Default) const
// FIXME: appears to be missing under MSW 2.4.2
// bool IsGregorianDate(wxDateTime::GregorianAdoption country = wxDateTime::Gr_Standard) const
wxDateTime& SetFromDOS(unsigned long ddt)
unsigned long GetAsDOS() const

bool IsEqualTo(const wxDateTime& datetime) const
bool IsEarlierThan(const wxDateTime& datetime) const
bool IsLaterThan(const wxDateTime& datetime) const
bool IsStrictlyBetween(const wxDateTime& t1, const wxDateTime& t2) const
bool IsBetween(const wxDateTime& t1, const wxDateTime& t2) const
bool IsSameDate(const wxDateTime& dt) const
bool IsSameTime(const wxDateTime& dt) const
bool IsEqualUpTo(const wxDateTime& dt, const wxTimeSpan& ts) const

%rename AddTS wxDateTime Add(const wxTimeSpan& diff) const
%rename SubtractTS wxDateTime Subtract(const wxTimeSpan& diff) const
%rename AddDS wxDateTime Add(const wxDateSpan& diff) const
%rename SubtractDS wxDateTime Subtract(const wxDateSpan& diff) const
wxTimeSpan Subtract(const wxDateTime& dt) const

//const wxChar * ParseRfc822Date(const wxChar* date)
//const wxChar * ParseFormat(const wxChar *date, const wxChar *format = wxT("%c"), const wxDateTime& dateDef = wxDefaultDateTime)
//const wxChar * ParseDateTime(const wxChar *datetime)
//const wxChar * ParseDate(const wxChar *date)
//const wxChar * ParseTime(const wxChar *time)
wxString ParseRfc822Date(const wxString& date)
wxString ParseFormat(const wxString& date, const wxString& format = wxT("%c"), const wxDateTime& dateDef = wxDefaultDateTime)
wxString ParseDateTime(const wxString& datetime)
wxString ParseDate(const wxString& date)
wxString ParseTime(const wxString& time)
// FIXME:
//wxString Format(const char *format = wxT("%c"), const TimeZone tz = wxDateTime::Local) const
wxString Format(const wxString& format = wxT("%c")) const
wxString FormatDate() const
wxString FormatTime() const
wxString FormatISODate() const
wxString FormatISOTime() const

// 2.8.12.28
//wxLongLong GetValue() const
//static time_t GetTimeNow()
//static struct tm *GetTmNow()
//static struct tm *GetTmNow(struct tm *tmstruct)

static int ConvertYearToBC(int year)
//TODO: need wrapper
//static void GetAmPmStrings(wxString *am, wxString *pm)
static wxDateTime  GetBeginDST(int year = wxDateTime::Inv_Year, wxDateTime::Country country = wxDateTime::Country_Default)
static wxDateTime::Country GetCountry()
static int GetCurrentYear(wxDateTime::Calendar cal = wxDateTime::Gregorian)
static wxDateTime::Month GetCurrentMonth(wxDateTime::Calendar cal = wxDateTime::Gregorian)
static wxDateTime  GetEndDST(int year = wxDateTime::Inv_Year, wxDateTime::Country country = wxDateTime::Country_Default)
static wxString  GetMonthName(wxDateTime::Month month, wxDateTime::NameFlags flags = wxDateTime::Name_Full)
static wxDateTime_t GetNumberOfDays(int year, wxDateTime::Calendar cal = wxDateTime::Gregorian)
static wxString  GetWeekDayName(wxDateTime::WeekDay weekday, wxDateTime::NameFlags flags = wxDateTime::Name_Full)
static bool IsLeapYear(int year = wxDateTime::Inv_Year, wxDateTime::Calendar cal = wxDateTime::Gregorian)
static bool IsWestEuropeanCountry(wxDateTime::Country country = wxDateTime::Country_Default)
static bool IsDSTApplicable(int year = wxDateTime::Inv_Year, wxDateTime::Country country = wxDateTime::Country_Default)
static wxDateTime  Now()
static void SetCountry(wxDateTime::Country country)
static wxDateTime  Today()
static wxDateTime  UNow()

// these are static, and not really class members
%builtin %rename wxDateTime_GetCountry static wxDateTime::Country wxDateTime::GetCountry()
%builtin %rename wxDateTime_SetCountry void wxDateTime::SetCountry(wxDateTime::Country country)
%builtin %rename wxDateTime_IsWestEuropeanCountry static bool wxDateTime::IsWestEuropeanCountry(wxDateTime::Country country = wxDateTime::Country_Default)
%builtin %rename wxDateTime_ConvertYearToBC static int wxDateTime::ConvertYearToBC(int year)
%builtin %rename wxDateTime_GetCurrentYear static int wxDateTime::GetCurrentYear(wxDateTime::Calendar cal = wxDateTime::Gregorian)
%builtin %rename wxDateTime_GetCurrentMonth static int wxDateTime::GetCurrentMonth(wxDateTime::Calendar cal = wxDateTime::Gregorian)
%builtin %rename wxDateTime_IsLeapYear static bool wxDateTime::IsLeapYear(int year = wxDateTime::Inv_Year, wxDateTime::Calendar cal = wxDateTime::Gregorian)
%builtin %rename wxDateTime_GetCentury static int wxDateTime::GetCentury(int year = wxDateTime::Inv_Year)
%builtin %rename wxDateTime_GetNumberOfDaysInYear static wxDateTime_t wxDateTime::GetNumberOfDays(int year, wxDateTime::Calendar cal = wxDateTime::Gregorian)
%builtin %rename wxDateTime_GetNumberOfDaysInMonth static wxDateTime_t wxDateTime::GetNumberOfDays(wxDateTime::Month month, int year = wxDateTime::Inv_Year, wxDateTime::Calendar cal = wxDateTime::Gregorian)
%if(win) %builtin %rename wxDateTime_GetMonthName static wxString wxDateTime::GetMonthName(int month, wxDateTime::NameFlags flags = wxDateTime::Name_Full)
%builtin %rename wxDateTime_GetWeekDayName static wxString wxDateTime::GetWeekDayName(wxDateTime::WeekDay weekday, wxDateTime::NameFlags flags = wxDateTime::Name_Full)
// FIXME: need to create wrappers for GetAmPmStrings
// %builtin %rename wxDateTime_GetAmPmStrings static void wxDateTime::GetAmPmStrings(wxString *am, wxString *pm)
%builtin %rename wxDateTime_IsDSTApplicable static bool wxDateTime::IsDSTApplicable(int year = wxDateTime::Inv_Year, wxDateTime::Country country = wxDateTime::Country_Default)
%builtin %rename wxDateTime_GetBeginDST static wxDateTime wxDateTime::GetBeginDST(int year = wxDateTime::Inv_Year, wxDateTime::Country country = wxDateTime::Country_Default)
%builtin %rename wxDateTime_GetEndDST static wxDateTime wxDateTime::GetEndDST(int year = wxDateTime::Inv_Year, wxDateTime::Country country = wxDateTime::Country_Default)
%builtin %rename wxDateTime_wxDateTime static wxDateTime wxDateTime::Now()
%builtin %rename wxDateTime_Now static wxDateTime wxDateTime::Now()
%builtin %rename wxDateTime_Today static wxDateTime wxDateTime::Today()
%builtin %rename wxDateTime_UNow static wxDateTime wxDateTime::UNow()


%num %rename wxTZ_Local wxDateTime::Local
%num %rename wxTZ_GMT_1 wxDateTime::GMT_1
%num %rename wxTZ_GMT_2 wxDateTime::GMT_2
%num %rename wxTZ_GMT_3 wxDateTime::GMT_3
%num %rename wxTZ_GMT_4 wxDateTime::GMT_4
%num %rename wxTZ_GMT_5 wxDateTime::GMT_5
%num %rename wxTZ_GMT_6 wxDateTime::GMT_6
%num %rename wxTZ_GMT_7 wxDateTime::GMT_7
%num %rename wxTZ_GMT_8 wxDateTime::GMT_8
%num %rename wxTZ_GMT_9 wxDateTime::GMT_9
%num %rename wxTZ_GMT_10 wxDateTime::GMT_10
%num %rename wxTZ_GMT_11 wxDateTime::GMT_11
%num %rename wxTZ_GMT_12 wxDateTime::GMT_12
%num %rename wxTZ_GMT0 wxDateTime::GMT0
%num %rename wxTZ_GMT1 wxDateTime::GMT1
%num %rename wxTZ_GMT2 wxDateTime::GMT2
%num %rename wxTZ_GMT3 wxDateTime::GMT3
%num %rename wxTZ_GMT4 wxDateTime::GMT4
%num %rename wxTZ_GMT5 wxDateTime::GMT5
%num %rename wxTZ_GMT6 wxDateTime::GMT6
%num %rename wxTZ_GMT7 wxDateTime::GMT7
%num %rename wxTZ_GMT8 wxDateTime::GMT8
%num %rename wxTZ_GMT9 wxDateTime::GMT9
%num %rename wxTZ_GMT10 wxDateTime::GMT10
%num %rename wxTZ_GMT11 wxDateTime::GMT11
%num %rename wxTZ_GMT12 wxDateTime::GMT12

%num %rename wxTZ_WET wxDateTime::WET
%num %rename wxTZ_WESTT wxDateTime::WEST
%num %rename wxTZ_CET wxDateTime::CET
%num %rename wxTZ_CEST wxDateTime::CEST
%num %rename wxTZ_EET wxDateTime::EET
%num %rename wxTZ_EEST wxDateTime::EEST
%num %rename wxTZ_MSK wxDateTime::MSK
%num %rename wxTZ_MSD wxDateTime::MSD

%num %rename wxTZ_AST wxDateTime::AST
%num %rename wxTZ_ADT wxDateTime::ADT
%num %rename wxTZ_EST wxDateTime::EST
%num %rename wxTZ_EDT wxDateTime::EDT
%num %rename wxTZ_CST wxDateTime::CST
%num %rename wxTZ_CDT wxDateTime::CDT
%num %rename wxTZ_MST wxDateTime::MST
%num %rename wxTZ_MDTT wxDateTime::MDT
%num %rename wxTZ_PST wxDateTime::PST
%num %rename wxTZ_PDT wxDateTime::PDT
%num %rename wxTZ_HST wxDateTime::HST
%num %rename wxTZ_SKST wxDateTime::AKST
%num %rename wxTZ_AKDT wxDateTime::AKST
%num %rename wxTZ_A_WST wxDateTime::A_WST
%num %rename wxTZ_A_CST wxDateTime::A_CST
%num %rename wxTZ_A_EST wxDateTime::A_EST
%num %rename wxTZ_A_ESST wxDateTime::A_ESST
//%not(gcc) %num %rename wxTZ_NZST wxDateTime::TZ::NZST
//%not(gcc) %num %rename wxTZ_NZDT wxDateTime::TZ::NZDT
//%not(gcc) %num %rename wxTZ_UTC wxDateTime::TZ::UTC

//%not(gcc) %num %rename wxDateTime_Calendar_Gregorian wxDateTime::Calendar::Gregorian
//%not(gcc) %num %rename wxDateTime_Calendar_Julian wxDateTime::Calendar::Julian

%num %rename wxTZ_NZST 25
%num %rename wxTZ_NZDT 26
%num %rename wxTZ_UTC 13

%num %rename wxDateTime_Calendar_Gregorian 0
%num %rename wxDateTime_Calendar_Julian 1

%num %rename wxDateTime_Jan wxDateTime::Jan
%num %rename wxDateTime_Feb wxDateTime::Feb
%num %rename wxDateTime_Mar wxDateTime::Mar
%num %rename wxDateTime_Apr wxDateTime::Apr
%num %rename wxDateTime_May wxDateTime::May
%num %rename wxDateTime_Jun wxDateTime::Jun
%num %rename wxDateTime_Jul wxDateTime::Jul
%num %rename wxDateTime_Aug wxDateTime::Aug
%num %rename wxDateTime_Sep wxDateTime::Sep
%num %rename wxDateTime_Oct wxDateTime::Oct
%num %rename wxDateTime_Nov wxDateTime::Nov
%num %rename wxDateTime_Dec wxDateTime::Dec
%num %rename wxDateTime_Inv_Month wxDateTime::Inv_Month

%num %rename wxDateTime_Sun wxDateTime::Sun
%num %rename wxDateTime_Mon wxDateTime::Mon
%num %rename wxDateTime_Tue wxDateTime::Tue
%num %rename wxDateTime_Wed wxDateTime::Wed
%num %rename wxDateTime_Thu wxDateTime::Thu
%num %rename wxDateTime_Fri wxDateTime::Fri
%num %rename wxDateTime_Sat wxDateTime::Sat
%num %rename wxDateTime_Inv_WeekDay wxDateTime::Inv_WeekDay

%num %rename wxDateTime_Inv_Year wxDateTime::Inv_Year

%num %rename wxDateTime_Name_Full wxDateTime::Name_Full
%num %rename wxDateTime_Name_Abbr wxDateTime::Name_Abbr

%num %rename wxDateTime_Gregorian wxDateTime::Gregorian
%num %rename wxDateTime_Julian wxDateTime::Julian

%num %rename wxDateTime_Unknown wxDateTime::Country_Unknown
%num %rename wxDateTime_Default wxDateTime::Country_Default
//%num %rename wxDateTime_WesternEurope_Start wxDateTime::Country_WesternEurope_Start
%num %rename wxDateTime_EEC wxDateTime::Country_EEC
%num %rename wxDateTime_France wxDateTime::France
%num %rename wxDateTime_Germany wxDateTime::Germany
%num %rename wxDateTime_UK wxDateTime::UK

//%not(gcc) %num %rename wxDateTime_WesternEurope_End wxDateTime::Country::Country_WesternEurope_End

%num %rename wxDateTime_Russia wxDateTime::Russia
%num %rename wxDateTime_USA wxDateTime::USA

%num %rename wxDateTime_Default_First wxDateTime::Default_First
%num %rename wxDateTime_Monday_First wxDateTime::Monday_First
%num %rename wxDateTime_Sunday_First wxDateTime::Monday_First

//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Unknown wxDateTime::GregorianAdoption::Gr_Unknown
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Standard wxDateTime::GregorianAdoption::Gr_Standard
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Alaska wxDateTime::GregorianAdoption::Gr_Alaska
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Albania wxDateTime::GregorianAdoption::Gr_Albania
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Austria wxDateTime::GregorianAdoption::Gr_Austria
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Austria_Brixen wxDateTime::GregorianAdoption::Gr_Austria_Brixen
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Austria_Salzburg wxDateTime::GregorianAdoption::Gr_Austria_Salzburg
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Austria_Tyrol wxDateTime::GregorianAdoption::Gr_Austria_Tyrol
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Austria_Carinthia wxDateTime::GregorianAdoption::Gr_Austria_Carinthia
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Austria_Styria wxDateTime::GregorianAdoption::Gr_Austria_Styria
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Belgium wxDateTime::GregorianAdoption::Gr_Belgium
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Bulgaria wxDateTime::GregorianAdoption::Gr_Bulgaria
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Bulgaria_1 wxDateTime::GregorianAdoption::Gr_Bulgaria_1
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Bulgaria_2 wxDateTime::GregorianAdoption::Gr_Bulgaria_2
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Bulgaria_3 wxDateTime::GregorianAdoption::Gr_Bulgaria_3
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Canada wxDateTime::GregorianAdoption::Gr_Canada
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_China wxDateTime::GregorianAdoption::Gr_China
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_China_1 wxDateTime::GregorianAdoption::Gr_China_1
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_China_2 wxDateTime::GregorianAdoption::Gr_China_2
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Czechoslovakia wxDateTime::GregorianAdoption::Gr_Czechoslovakia
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Denmark wxDateTime::GregorianAdoption::Gr_Denmark
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Egypt wxDateTime::GregorianAdoption::Gr_Egypt
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Estonia wxDateTime::GregorianAdoption::Gr_Estonia
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Finland wxDateTime::GregorianAdoption::Gr_Finland
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_France wxDateTime::GregorianAdoption::Gr_France
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_France_Alsace wxDateTime::GregorianAdoption::Gr_France_Alsace
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_France_Lorraine wxDateTime::GregorianAdoption::Gr_France_Lorraine
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_France_Strasbourg wxDateTime::GregorianAdoption::Gr_France_Strasbourg
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Germany wxDateTime::GregorianAdoption::Gr_Germany
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Germany_Catholic wxDateTime::GregorianAdoption::Gr_Germany_Catholic
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Germany_Prussia wxDateTime::GregorianAdoption::Gr_Germany_Prussia
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Germany_Protestant wxDateTime::GregorianAdoption::Gr_Germany_Protestant
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_GreatBritain wxDateTime::GregorianAdoption::Gr_GreatBritain
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Greece wxDateTime::GregorianAdoption::Gr_Greece
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Hungary wxDateTime::GregorianAdoption::Gr_Hungary
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Ireland wxDateTime::GregorianAdoption::Gr_Ireland
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Italy wxDateTime::GregorianAdoption::Gr_Italy
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Japan wxDateTime::GregorianAdoption::Gr_Japan
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Japan_1 wxDateTime::GregorianAdoption::Gr_Japan_1
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Japan_2 wxDateTime::GregorianAdoption::Gr_Japan_2
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Japan_3 wxDateTime::GregorianAdoption::Gr_Japan_3
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Latvia wxDateTime::GregorianAdoption::Gr_Latvia
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Lithuania wxDateTime::GregorianAdoption::Gr_Lithuania
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Luxemburg wxDateTime::GregorianAdoption::Gr_Luxemburg
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Netherlands wxDateTime::GregorianAdoption::Gr_Netherlands
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Netherlands_Groningen wxDateTime::GregorianAdoption::Gr_Netherlands_Groningen
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Netherlands_Gelderland wxDateTime::GregorianAdoption::Gr_Netherlands_Gelderland
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Netherlands_Utrecht wxDateTime::GregorianAdoption::Gr_Netherlands_Utrecht
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Netherlands_Friesland wxDateTime::GregorianAdoption::Gr_Netherlands_Friesland
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Norway wxDateTime::GregorianAdoption::Gr_Norway
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Poland wxDateTime::GregorianAdoption::Gr_Poland
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Portugal wxDateTime::GregorianAdoption::Gr_Portugal
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Romania wxDateTime::GregorianAdoption::Gr_Romania
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Russia wxDateTime::GregorianAdoption::Gr_Russia
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Scotland wxDateTime::GregorianAdoption::Gr_Scotland
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Spain wxDateTime::GregorianAdoption::Gr_Spain
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Sweden wxDateTime::GregorianAdoption::Gr_Sweden
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Switzerland wxDateTime::GregorianAdoption::Gr_Switzerland
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Switzerland_Catholic wxDateTime::GregorianAdoption::Gr_Switzerland_Catholic
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Switzerland_Protestant wxDateTime::GregorianAdoption::Gr_Switzerland_Protestant
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Turkey wxDateTime::GregorianAdoption::Gr_Turkey
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_USA wxDateTime::GregorianAdoption::Gr_USA
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Wales wxDateTime::GregorianAdoption::Gr_Wales
//%not(gcc) %num %rename wxDateTime_GregorianAdoption_Gr_Yugoslavia wxDateTime::GregorianAdoption::Gr_Yugoslavia

// ==============================
// Class: wxTimeSpan

%class %delete wxTimeSpan
//wxTimeSpan()
%if(bcc) wxTimeSpan(long hours, long minutes = 0)
%not(bcc) wxTimeSpan(long hours, long minutes = 0, wxLongLong seconds = 0, wxLongLong milliseconds = 0)
//wxTimeSpan(const wxLongLong& diff)
static wxTimeSpan Milliseconds(wxLongLong ms)
static wxTimeSpan Millisecond()
static wxTimeSpan Seconds(wxLongLong sec)
static wxTimeSpan Second()
static wxTimeSpan Minutes(long min)
static wxTimeSpan Minute()
static wxTimeSpan Hours(long hours)
static wxTimeSpan Hour()
static wxTimeSpan Days(long days)
static wxTimeSpan Day()
static wxTimeSpan Weeks(long days)
static wxTimeSpan Week()
//inline wxTimeSpan Add(const wxTimeSpan& diff) const
wxTimeSpan& Add(const wxTimeSpan& diff)
//inline wxTimeSpan Subtract(const wxTimeSpan& diff) const
wxTimeSpan& Subtract(const wxTimeSpan& diff)
//inline wxTimeSpan Multiply(int n) const
wxTimeSpan& Multiply(int n)
wxTimeSpan Negate() const
wxTimeSpan& Neg()
wxTimeSpan Abs() const
bool IsNull() const
bool IsPositive() const
bool IsNegative() const
bool IsEqualTo(const wxTimeSpan& ts) const
bool IsLongerThan(const wxTimeSpan& ts) const
bool IsShorterThan(const wxTimeSpan& t) const
int GetWeeks() const
int GetDays() const
int GetHours() const
int GetMinutes() const
// 2.8.12.28
//wxLongLong GetSeconds() const
//wxLongLong GetMilliseconds() const
wxString Format(const wxChar *format = wxDefaultTimeSpanFormat) const
//wxLongLong GetValue() const

%builtin %rename wxTimeSpan_Milliseconds static wxTimeSpan wxTimeSpan::Milliseconds(wxLongLong ms)
%builtin %rename wxTimeSpan_Millisecond wxTimeSpan wxTimeSpan::Millisecond()
%builtin %rename wxTimeSpan_Seconds wxTimeSpan wxTimeSpan::Seconds(wxLongLong sec)
%builtin %rename wxTimeSpan_Second wxTimeSpan wxTimeSpan::Second()
%builtin %rename wxTimeSpan_Minutes wxTimeSpan wxTimeSpan::Minutes(long min)
%builtin %rename wxTimeSpan_Minute wxTimeSpan wxTimeSpan::Minute()
%builtin %rename wxTimeSpan_Hours wxTimeSpan wxTimeSpan::Hours(long hours)
%builtin %rename wxTimeSpan_Hour wxTimeSpan wxTimeSpan::Hour()
%builtin %rename wxTimeSpan_Days wxTimeSpan wxTimeSpan::Days(long days)
%builtin %rename wxTimeSpan_Day wxTimeSpan wxTimeSpan::Day()
%builtin %rename wxTimeSpan_Weeks wxTimeSpan wxTimeSpan::Weeks(long days)
%builtin %rename wxTimeSpan_Week wxTimeSpan wxTimeSpan::Week()

// ==============================
// Class: wxDateSpan

%class %delete wxDateSpan
wxDateSpan(int years = 0, int months = 0, int weeks = 0, int days = 0)
static wxDateSpan Days(int days)
static wxDateSpan Day()
static wxDateSpan Weeks(int weeks)
static wxDateSpan Week()
static wxDateSpan Months(int mon)
static wxDateSpan Month()
static wxDateSpan Years(int years)
static wxDateSpan Year()
wxDateSpan& SetYears(int n)
wxDateSpan& SetMonths(int n)
wxDateSpan& SetWeeks(int n)
wxDateSpan& SetDays(int n)
int GetYears() const
int GetMonths() const
int GetWeeks() const
int GetDays() const
int GetTotalDays() const
//inline wxDateSpan Add(const wxDateSpan& other) const
wxDateSpan& Add(const wxDateSpan& other)
//inline wxDateSpan Subtract(const wxDateSpan& other) const
wxDateSpan& Subtract(const wxDateSpan& other)
wxDateSpan Negate() const
wxDateSpan& Neg()
//inline wxDateSpan Multiply(int factor) const
wxDateSpan& Multiply(int factor)

%builtin %rename wxDateSpan_Days wxDateSpan wxDateSpan::Days(int days)
%builtin %rename wxDateSpan_Day wxDateSpan wxDateSpan::Day()
%builtin %rename wxDateSpan_Weeks wxDateSpan wxDateSpan::Weeks(int weeks)
%builtin %rename wxDateSpan_Week wxDateSpan wxDateSpan::Week()
%builtin %rename wxDateSpan_Months wxDateSpan wxDateSpan::Months(int mon)
%builtin %rename wxDateSpan_Month wxDateSpan wxDateSpan::Month()
%builtin %rename wxDateSpan_Years wxDateSpan wxDateSpan::Years(int years)
%builtin %rename wxDateSpan_Year wxDateSpan wxDateSpan::Year()

// ==============================
// Class: wxDateTimeHolidayAuthority

// abstract class
%class wxDateTimeHolidayAuthority
static bool IsHoliday(const wxDateTime& dt)
//FIXME: needs a wrapper
// TODO: needs wrapper
//static size_t GetHolidaysInRange(const wxDateTime& dtStart, const wxDateTime& dtEnd, wxDateTimeArray& holidays)
static void ClearAllAuthorities()
static void AddAuthority(wxDateTimeHolidayAuthority *auth)

%builtin %rename wxDateTimeHolidayAuthority_IsHoliday bool wxDateTimeHolidayAuthority::IsHoliday(const wxDateTime& dt)
//FIXME: needs a wrapper
//%builtin %rename wxDateTimeHolidayAuthority_GetHolidaysInRange size_t wxDateTimeHolidayAuthority::GetHolidaysInRange(const wxDateTime& dtStart, const wxDateTime& dtEnd, wxDateTimeArray& holidays)
%builtin %rename wxDateTimeHolidayAuthority_ClearAllAuthorities void wxDateTimeHolidayAuthority::ClearAllAuthorities()
%builtin %rename wxDateTimeHolidayAuthority_AddAuthority void wxDateTimeHolidayAuthority::AddAuthority(wxDateTimeHolidayAuthority *auth)

// ==============================
// Class: wxDateTimeWorkDays

%class %delete wxDateTimeWorkDays, wxDateTimeHolidayAuthority

// %num MILLISECONDS_PER_DAY

%not(gcc) %builtin void wxNextMonth(wxDateTime::Month& m)
%not(gcc) %builtin void wxPrevMonth(wxDateTime::Month& m)
%not(gcc) %builtin void wxNextWDay(wxDateTime::WeekDay& wd)
%not(gcc) %builtin void wxPrevWDay(wxDateTime::WeekDay& wd)

///////////////////////////////////////////////////////////////////////////////
// APPLICATION BASE and EVENT HANDLING BASE
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// wxEvtHandler
//
// event handling is *not* accessible like this through wxScript

//RP this class is enabled further down

//%class wxEvtHandler, wxObject
//wxEvtHandler()
// virtual void AddPendingEvent(wxEvent& event)
// void Connect(int id, wxEventType eventType, wxObjectEventFunction function, wxObject* userData = NULL)
// bool Disconnect(int id, wxEventType eventType = wxEVT_NULL, wxObjectEventFunction function = NULL, wxObject* userData = NULL)
// void* GetClientData()
// bool GetEvtHandlerEnabled()
// wxEvtHandler* GetNextHandler()
// wxEvtHandler* GetPreviousHandler()
// virtual bool ProcessEvent(wxEvent& event)
// bool SearchEventTable(wxEventTable& table, wxEvent& event)
// void SetClientData(void* data)
// void SetEvtHandlerEnabled(bool enabled)
// void SetNextHandler(wxEvtHandler* handler)
// void SetPreviousHandler(wxEvtHandler* handler)

///////////////////////////////////////////////////////////////////////////////
// wxApp

// #########################################################
// cmdline.h

%include <wx/cmdline.h>

%num wxCMD_LINE_OPTION_MANDATORY
%num wxCMD_LINE_PARAM_OPTIONAL
%num wxCMD_LINE_PARAM_MULTIPLE
%num wxCMD_LINE_OPTION_HELP
%num wxCMD_LINE_NEEDS_SEPARATOR

%enum wxCmdLineParamType
  %num wxCMD_LINE_VAL_STRING
  %num wxCMD_LINE_VAL_NUMBER
  %num wxCMD_LINE_VAL_DATE
  %num wxCMD_LINE_VAL_NONE

%enum wxCmdLineEntryType
  %num wxCMD_LINE_SWITCH
  %num wxCMD_LINE_OPTION
  %num wxCMD_LINE_PARAM
  %num wxCMD_LINE_NONE

%struct wxCmdLineEntryDesc

// ==============================
// Class: wxCmdLineParser

%class wxCmdLineParser
wxCmdLineParser()
//wxCmdLineParser(int argc, char **argv)
//wxCmdLineParser(int argc, wxChar **argv)
//wxCmdLineParser(const wxString& cmdline)
//wxCmdLineParser(const wxCmdLineEntryDesc *desc)
//wxCmdLineParser(const wxCmdLineEntryDesc *desc, int argc, char **argv)
//wxCmdLineParser(const wxCmdLineEntryDesc *desc, int argc, wxChar **argv)
//wxCmdLineParser(const wxCmdLineEntryDesc *desc, const wxString& cmdline)
void SetCmdLine(int argc, char **argv)
//void SetCmdLine(int argc, wxChar **argv)
//void SetCmdLine(const wxString& cmdline)
void SetSwitchChars(const wxString& switchChars)
void EnableLongOptions(bool enable = true)
void DisableLongOptions()
bool AreLongOptionsEnabled()
void SetLogo(const wxString& logo)
void SetDesc(const wxCmdLineEntryDesc *desc)
void AddSwitch(const wxString& name, const wxString& lng = wxEmptyString, const wxString& desc = wxEmptyString, int flags = 0)
void AddOption(const wxString& name, const wxString& lng = wxEmptyString, const wxString& desc = wxEmptyString, wxCmdLineParamType type = wxCMD_LINE_VAL_STRING, int flags = 0)
void AddParam(const wxString& desc = wxEmptyString, wxCmdLineParamType type = wxCMD_LINE_VAL_STRING, int flags = 0)
int Parse(bool showUsage = true)
void Usage()
bool Found(const wxString& name) const
//bool Found(const wxString& name, wxString *value) const
//bool Found(const wxString& name, long *value) const
//bool Found(const wxString& name, wxDateTime *value) const
size_t GetParamCount() const
wxString GetParam(size_t n = 0u) const
void Reset()
static wxArrayString ConvertStringToArgs(const wxChar *cmdline)
//%struct wxCmdLineParser::wxCmdLineParserData

// ==============================
// Class: wxEvtHandler

%class %delete wxEvtHandler, wxObject
wxEvtHandler()
wxEvtHandler *GetNextHandler() const
wxEvtHandler *GetPreviousHandler() const
void SetNextHandler(wxEvtHandler *handler)
void SetPreviousHandler(wxEvtHandler *handler)
void SetEvtHandlerEnabled(bool enabled)
bool GetEvtHandlerEnabled() const
virtual bool ProcessEvent(wxEvent& event)
void AddPendingEvent(wxEvent& event)
void ProcessPendingEvents()
bool ProcessThreadEvent(wxEvent& event)
//void Connect(int winid, int lastId, int eventType, wxObjectEventFunction func, wxObject *userData = (wxObject *) NULL,wxEvtHandler *eventSink = (wxEvtHandler *) NULL)
// -> void Connect(int winid, int lastId, int eventType, wxObjectEventFunction func, wxObject *userData = NULL,wxEvtHandler *eventSink =  NULL)
//void Connect(int winid, int eventType, wxObjectEventFunction func, wxObject *userData = (wxObject *) NULL, wxEvtHandler *eventSink = (wxEvtHandler *) NULL)
//void Connect(int eventType, wxObjectEventFunction func,  wxObject *userData = (wxObject *) NULL, wxEvtHandler *eventSink = (wxEvtHandler *) NULL)
//bool Disconnect(int winid, int lastId, wxEventType eventType, wxObjectEventFunction func = NULL, wxObject *userData = (wxObject *) NULL, wxEvtHandler *eventSink = (wxEvtHandler *) NULL)
// -> bool Disconnect(int winid, int lastId, wxEventType eventType, wxObjectEventFunction func = NULL, wxObject *userData = NULL, wxEvtHandler *eventSink = NULL)
//bool Disconnect(int winid = wxID_ANY, wxEventType eventType = wxEVT_NULL, wxObjectEventFunction func = NULL, wxObject *userData = (wxObject *) NULL, wxEvtHandler *eventSink = (wxEvtHandler *) NULL)
//bool Disconnect(wxEventType eventType, wxObjectEventFunction func, wxObject *userData = (wxObject *) NULL, 	wxEvtHandler *eventSink = (wxEvtHandler *) NULL)
wxList* GetDynamicEventTable() const
void SetClientObject( wxClientData *data )
wxClientData *GetClientObject() const
void SetClientData( void *data )
void *GetClientData() const
static bool ProcessEventIfMatches(const wxEventTableEntryBase& tableEntry, wxEvtHandler *handler, wxEvent& event)
virtual bool SearchEventTable(wxEventTable& table, wxEvent& event)
bool SearchDynamicEventTable( wxEvent& event )
void ClearEventLocker()
void ClearEventHashTable()

%typedef wxSysColourChangedEventFunction wxSysColourChangedFunction
%typedef wxDisplayChangedEventFunction wxDisplayChangedFunction
// deprecated
//%num wxEVT_SCROLL_ENDSCROLL
//%alias EVT_COMMAND_SCROLL_ENDSCROLL EVT_COMMAND_SCROLL_CHANGED(winid, func)
//%alias EVT_SCROLL_ENDSCROLL EVT_SCROLL_CHANGED(func)

%builtin wxList *wxPendingEvents
%builtin wxCriticalSection *wxPendingEventsLocker
%builtin wxWindow* wxFindFocusDescendant(wxWindow* ancestor)

// #########################################################
// process.h

%include <wx/process.h>

%num wxPROCESS_DEFAULT
%num wxPROCESS_REDIRECT

// ==============================
// Class: wxProcess

%class %delete wxProcess, wxEvtHandler
static wxKillError Kill(int pid, wxSignal sig = wxSIGTERM, int flags = wxKILL_NOCHILDREN)
static bool Exists(int pid)
static wxProcess *Open(const wxString& cmd, int flags = wxEXEC_ASYNC)
wxProcess(wxEvtHandler *parent = NULL, int nId = wxID_ANY)
%ctor wxProcessWithFlags(int flags)
long GetPid() const
//virtual void OnTerminate(int pid, int status)
void Redirect()
bool IsRedirected() const
void Detach()
wxInputStream *GetInputStream() const
wxInputStream *GetErrorStream() const
wxOutputStream *GetOutputStream() const
void CloseOutput()
bool IsInputOpened() const
bool IsInputAvailable() const
bool IsErrorAvailable() const
void SetPipeStreams(wxInputStream *outStream, wxOutputStream *inStream, wxInputStream *errStream)

%builtin %rename wxProcess_Kill wxKillError wxProcess::Kill(int pid, wxSignal signal = wxSIGNONE, int flags = wxKILL_NOCHILDREN)
%builtin %rename wxProcess_Exists bool wxProcess::Exists(int pid)
%builtin %rename wxProcess_Open wxProcess * wxProcess::Open(const wxString& cmd, int flags = wxEXEC_ASYNC)

// #########################################################
// app.h

%include <wx/app.h>

//%struct wxVideoMode

%num wxPRINT_WINDOWS
%num wxPRINT_POSTSCRIPT

// ==============================
// Class: wxAppConsole

%class wxAppConsole, wxEvtHandler
//wxAppConsole()
//virtual bool Initialize(int& argc, wxChar **argv)
//virtual bool CallOnInit()
//virtual bool OnInit()
//virtual bool OnInitGui()
//virtual int OnRun()
//virtual int OnExit()
//virtual void CleanUp()
//virtual void OnFatalException()
virtual void Exit()
wxString GetAppName() const
void SetAppName(const wxString& name)
wxString GetClassName() const
void SetClassName(const wxString& name)
const wxString& GetVendorName() const
void SetVendorName(const wxString& name)
//virtual void OnInitCmdLine(wxCmdLineParser& parser)
//virtual bool OnCmdLineParsed(wxCmdLineParser& parser)
//virtual bool OnCmdLineHelp(wxCmdLineParser& parser)
//virtual bool OnCmdLineError(wxCmdLineParser& parser)
//wxAppTraits *GetTraits()
virtual int FilterEvent(wxEvent& event)
//virtual void HandleEvent(wxEvtHandler *handler, wxEventFunction func, wxEvent& event) const
virtual void OnUnhandledException()
virtual void ProcessPendingEvents()
virtual bool Yield(bool onlyIfNeeded = false)
virtual void WakeUpIdle()
static bool IsMainLoopRunning()
//virtual void OnAssertFailure(const wxChar *file, int line, const wxChar *func, const wxChar *cond, const wxChar *msg)
//virtual void OnAssert(const wxChar *file, int line, const wxChar *cond, const wxChar *msg)
static bool CheckBuildOptions(const char *optionsSignature, const char *componentName)
//static void SetInitializerFunction(wxAppInitializerFunction fn)
//static wxAppInitializerFunction GetInitializerFunction()
static wxAppConsole *GetInstance()
static void SetInstance(wxAppConsole *app)
int      argc
wxChar **argv

//%class wxApp, wxEvtHandler
%class wxApp, wxAppConsole
//int argc
//char ** argv
static bool IsMainLoopRunning()
virtual int MainLoop()
virtual void Exit()
virtual void ExitMainLoop()
virtual bool Pending()
virtual bool Dispatch()
virtual bool Yield(bool onlyIfNeeded = false)
virtual bool ProcessIdle()
virtual bool SendIdleEvents(wxWindow* win, wxIdleEvent& event)
//virtual bool OnExceptionInMainLoop()
virtual bool IsActive() const
void SetTopWindow(wxWindow *win)
virtual wxWindow *GetTopWindow() const
void SetExitOnFrameDelete(bool flag)
bool GetExitOnFrameDelete() const
// only in framebuffer wxWin ports usable
//virtual wxVideoMode GetDisplayMode() const
virtual bool SetDisplayMode(const wxVideoMode& info)
void SetUseBestVisual( bool flag, bool forceTrueColour = false )
bool GetUseBestVisual() const
virtual void SetPrintMode(int mode)
int GetPrintMode() const
virtual wxLayoutDirection GetLayoutDirection() const
virtual bool OnCmdLineParsed(wxCmdLineParser& parser)
virtual void OnInitCmdLine(wxCmdLineParser& parser)
virtual void SetActive(bool isActive, wxWindow *lastFocus)
//void OnIdle(wxIdleEvent& event)

//virtual wxLog*  CreateLogTarget()
//virtual wxAppTraits *  CreateTraits()
int FilterEvent(wxEvent& event)
wxString  GetAppName() const
wxString  GetClassName() const
static wxAppConsole * GetInstance()
//virtual wxWindow *  GetTopWindow() const
//wxAppTraits *  GetTraits()
wxString  GetVendorName() const
//bool ProcessMessage(WXMSG *msg)
void SetAppName(const wxString& name)
void SetClassName(const wxString& name)
static void SetInstance(wxAppConsole* app)
void SetVendorName(const wxString& name)

%builtin %rename wxApp_GetInstance wxAppConsole * wxApp::GetInstance()
%builtin %rename wxApp_IsMainLoopRunning bool wxApp::IsMainLoopRunning()
%builtin %rename wxApp_SetInstance void wxApp::SetInstance(wxAppConsole* app)

%ptr wxTheApp

///////////////////////////////////////////////////////////////////////////////
// wxToolTip

%include <wx/tooltip.h>
%class %delete wxToolTip, wxObject
wxToolTip(const wxString& tip)
static void Enable(bool flag)
static void SetDelay(long msecs)
void SetTip(const wxString& tip)
wxString  GetTip() const
wxWindow*  GetWindow() const

%builtin %rename wxToolTip_Enable void wxToolTip::Enable(bool flag)
%builtin %rename wxToolTip_SetDelay void wxToolTip::SetDelay(long msecs)

///////////////////////////////////////////////////////////////////////////////
// wxDropSource

%include <wx/dnd.h>
%enum  wxDragResult
  %num wxDragError
  %num wxDragNone
  %num wxDragCopy
  %num wxDragMove
  %num wxDragLink
  %num wxDragCancel
%class wxDropSource
// remove the 'const', it will be added by wrap.bas
%if(win) wxDropSource(wxWindow* win = NULL, wxCursor& cursorCopy = wxNullCursor, wxCursor& cursorMove = wxNullCursor, wxCursor& cursorStop = wxNullCursor)
//%if(gtk) wxDropSource( wxWindow *win = (wxWindow *)NULL, const wxIcon &copy = wxNullIcon, const wxIcon &move = wxNullIcon, const wxIcon &none = wxNullIcon)
%if(win) %ctor wxDropSourceWithData(wxDataObject& data, wxWindow* win = NULL, wxCursor& cursorCopy = wxNullCursor, wxCursor& cursorMove = wxNullCursor, wxCursor& cursorStop = wxNullCursor)
%if(gtk) wxDropSource(wxDataObject& data, wxWindow *win, const wxIcon &copy = wxNullIcon, const wxIcon &move = wxNullIcon, const wxIcon &none = wxNullIcon)
//virtual  ~wxDropSource()
void SetData(wxDataObject& data)
virtual wxDragResult DoDragDrop(int flags = wxDrag_CopyOnly)
wxDataObject *  GetDataObject()
virtual bool GiveFeedback(wxDragResult effect)
void SetCursor(wxDragResult res, const wxCursor& cursor)

///////////////////////////////////////////////////////////////////////////////
// wxDropTarget

%include <wx/dnd.h>
%class wxDropTarget
//Abstract class
//wxDropTarget(wxDataObject* data = NULL)
// ~wxDropTarget()
virtual void GetData()
virtual wxDragResult OnData(wxCoord x, wxCoord y, wxDragResult def)
virtual bool OnDrop(wxCoord x, wxCoord y)
virtual wxDragResult OnEnter(wxCoord x, wxCoord y, wxDragResult def)
virtual wxDragResult OnDragOver(wxCoord x, wxCoord y, wxDragResult def)
virtual void OnLeave()
void SetDataObject(wxDataObject* data)

///////////////////////////////////////////////////////////////////////////////
// wxFileDropTarget

%include <wx/dnd.h>
%class wxFileDropTarget, wxDropTarget
// Abstract class
//wxFileDropTarget()
virtual bool OnDrop(wxCoord x, wxCoord y)
virtual bool OnDropFiles(wxCoord x, wxCoord y, const wxArrayString& filenames)

///////////////////////////////////////////////////////////////////////////////
// wxDragImage

%include <wx/dragimag.h>
%class wxDragImage, wxObject
%ctor wxDragImageNoCreate()
// cursorHotspot param is depricated
wxDragImage(const wxBitmap& image, const wxCursor& cursor = wxNullCursor) //, const wxPoint& cursorHotspot = wxPoint(0, 0))
%ctor wxDragIcon(const wxIcon& image, const wxCursor& cursor = wxNullCursor) // , const wxPoint& cursorHotspot = wxPoint(0, 0))
%ctor wxDragString(const wxString& text, const wxCursor& cursor = wxNullCursor) //, const wxPoint& cursorHotspot = wxPoint(0, 0))
%ctor wxDragTreeItem(const wxTreeCtrl& treeCtrl, wxTreeItemId& id)
%ctor wxDragListItem(const wxListCtrl& treeCtrl, long id)

// commented methods are not really valid
bool BeginDrag(const wxPoint& hotspot, wxWindow* window, bool fullScreen = false, wxRect* rect = NULL)
//virtual bool DoDrawImage(wxDC& dc, const wxPoint& pos)
bool EndDrag()
//virtual wxRect  GetImageRect(const wxPoint& pos) const
bool Hide()
bool Move(const wxPoint& pt)
bool Show()
//bool UpdateBackingFromWindow(wxDC& windowDC, wxMemoryDC& destDC, const wxRect& sourceRect, const wxRect& destRect) const

// #########################################################
// accel.h

%include <wx/accel.h>

%class %delete wxAcceleratorTable

%num wxACCEL_NORMAL
%num wxACCEL_ALT
%num wxACCEL_CTRL
%num wxACCEL_SHIFT
%num wxACCEL_CMD

%ptr wxNullAcceleratorTable

///////////////////////////////////////////////////////////////////////////////
// WINDOWS BASE
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// wxWindow

// #########################################################
// window.h

//deprecated since 2.4
//%include <wx/msw/window.h>
//%num wxKEY_SHIFT
//%num wxKEY_CTRL

%include <wx/window.h>

%typedef wxWindowID int

//%num wxUSE_MENUS_NATIVE
%struct wxVisualAttributes

%enum wxWindowVariant
  %num wxWINDOW_VARIANT_NORMAL
  %num wxWINDOW_VARIANT_SMALL
  %num wxWINDOW_VARIANT_MINI
  %num wxWINDOW_VARIANT_LARGE
  %num wxWINDOW_VARIANT_MAX

%str wxWINDOW_DEFAULT_VARIANT
//FIXME
//%ptr wxTopLevelWindows
//%ptr wxPendingDelete

// ==============================
// Class: wxWindow

%class wxWindow, wxEvtHandler
wxWindow(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxPanelNameStr)
%ctor wxWindowNoCreate()
bool CreateBase(wxWindow *parent, wxWindowID winid, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxPanelNameStr)
bool Close( bool force = false )
virtual bool Destroy()
bool DestroyChildren()
bool IsBeingDeleted() const
virtual void SetLabel(const wxString& label)
virtual wxString GetLabel() const
virtual void SetName( const wxString &name )
virtual wxString GetName() const
void SetWindowVariant(wxWindowVariant variant)
wxWindowVariant GetWindowVariant() const
void SetId( wxWindowID winid )
wxWindowID GetId() const
virtual wxLayoutDirection GetLayoutDirection() const
virtual void SetLayoutDirection(wxLayoutDirection dir)
virtual wxCoord AdjustForLayoutDirection(wxCoord x, wxCoord width, wxCoord widthTotal) const
static int NewControlId()
static int NextControlId(int winid)
static int PrevControlId(int winid)
%rename SetSizeXYWH void SetSize( int x, int y, int width, int height, int sizeFlags = wxSIZE_AUTO )
//void SetSize( int width, int height )
%rename SetSizeXY virtual void SetSize(int width, int height)
void SetSize( const wxSize& size )
%rename SetSizeSize void SetSize( const wxSize& size )
//void SetSize(const wxRect& rect, int sizeFlags = wxSIZE_AUTO)
%rename SetSizeRect void SetSize(const wxRect& rect, int sizeFlags = wxSIZE_AUTO)
//void Move(int x, int y, int flags = wxSIZE_USE_EXISTING)
%rename MoveXY void Move(int x, int y, int flags = wxSIZE_USE_EXISTING)
// Keep both
void Move(const wxPoint& pt, int flags = wxSIZE_USE_EXISTING)
%rename MovePoint void Move(const wxPoint& pt, int flags = wxSIZE_USE_EXISTING)
void SetPosition(const wxPoint& pt)
virtual void Raise()
virtual void Lower()
//void SetClientSize( int width, int height )
%rename SetClientSizeXY void SetClientSize( int width, int height )
%rename SetClientSizeWH virtual void SetClientSize(int width, int height)
void SetClientSize( const wxSize& size )
//void SetClientSize(const wxRect& rect)
%rename SetClientSizeRect void SetClientSize(const wxRect& rect)

wxPoint GetPosition() const
//void GetPosition( int *x, int *y ) const
%{
    void wxWindow_GetPositionXY()
    {
        int x, y;
        ((wxWindow *)wTheCall->self->ptr)->GetPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
    }
    void wxWindow_GetPositionX()
    {
        int x, y;
        ((wxWindow *)wTheCall->self->ptr)->GetPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }

    void wxWindow_GetPositionY()
    {
        int x, y;
        ((wxWindow *)wTheCall->self->ptr)->GetPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }


%}
%method GetPositionXY   wxWindow_GetPositionXY()
%method GetPositionX    wxWindow_GetPositionX()
%method GetPositionY    wxWindow_GetPositionY()

wxPoint GetScreenPosition() const
//void GetScreenPosition(int *x, int *y) const
%{
    void wxWindow_GetScreenPositionXY()
    {
        int x, y;
        ((wxWindow *)wTheCall->self->ptr)->GetScreenPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
    }
    void wxWindow_GetScreenPositionX()
    {
        int x, y;
        ((wxWindow *)wTheCall->self->ptr)->GetScreenPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }

    void wxWindow_GetScreenPositionY()
    {
        int x, y;
        ((wxWindow *)wTheCall->self->ptr)->GetScreenPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }


%}
%method GetScreenPositionXY   wxWindow_GetScreenPositionXY()
%method GetScreenPositionX    wxWindow_GetScreenPositionX()
%method GetScreenPositionY    wxWindow_GetScreenPositionY()

wxSize GetSize() const
//void GetSize( int *w, int *h ) const
%{
    void wxWindow_GetSizeWH()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)width );
        wStackPushInteger( (wInteger)height );
    }

    void wxWindow_GetSizeWidth()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)width );
    }

    void wxWindow_GetSizeHeight()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)height );
    }


%}
%method GetSizeWH       wxWindow_GetSizeWH()
%method GetSizeWidth    wxWindow_GetSizeWidth()
%method GetSizeHeight   wxWindow_GetSizeHeight()

wxSize GetClientSize() const
//void GetClientSize( int *w, int *h ) const
%{
    void wxWindow_GetClientSizeWidth()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetClientSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)width );
    }

    void wxWindow_GetClientSizeHeight()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetClientSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)height );
    }

    void wxWindow_GetClientSizeWH()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetClientSize(&width, &height);
        wWrapDerefArgs();
		wStackPushInteger( (wInteger)width );
        wStackPushInteger( (wInteger)height );
    }

%}
%method GetClientSizeWH         wxWindow_GetClientSizeWH()
%method GetClientSizeWidth      wxWindow_GetClientSizeWidth()
%method GetClientSizeHeight     wxWindow_GetClientSizeHeight()

wxRect GetRect() const
wxRect GetScreenRect() const

virtual wxPoint GetClientAreaOrigin() const
wxRect GetClientRect() const
wxSize GetBestSize() const
//void GetBestSize(int *w, int *h) const
%{
    void wxWindow_GetBestSizeWidth()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetBestSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)width );
    }

    void wxWindow_GetBestSizeHeight()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetBestSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)height );
    }

    void wxWindow_GetBestSizeWH()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetBestSize(&width, &height);
        wWrapDerefArgs();
		wStackPushInteger( (wInteger)width );
        wStackPushInteger( (wInteger)height );
    }

%}
%method GetBestSizeWH         wxWindow_GetBestSizeWH()
%method GetBestSizeWidth      wxWindow_GetBestSizeWidth()
%method GetBestSizeHeight     wxWindow_GetBestSizeHeight()

void SetScrollHelper( wxScrollHelper *sh )
wxScrollHelper *GetScrollHelper()
void InvalidateBestSize()
void CacheBestSize(const wxSize& size) const
wxSize GetEffectiveMinSize() const
void SetInitialSize(const wxSize& size=wxDefaultSize)

void Centre(int dir = wxBOTH)
void Center(int dir = wxBOTH)
void CentreOnParent(int dir = wxBOTH)
void CenterOnParent(int dir = wxBOTH)

virtual void Fit()
virtual void FitInside()
%rename SetSizeHintsWH void SetSizeHints( int minW, int minH, int maxW = wxDefaultCoord, int maxH = wxDefaultCoord, int incW = wxDefaultCoord, int incH = wxDefaultCoord )
void SetSizeHints( const wxSize& minSize, const wxSize& maxSize=wxDefaultSize, const wxSize& incSize=wxDefaultSize)
virtual void DoSetSizeHints( int minW, int minH, int maxW, int maxH, int incW, int incH )
%rename SetVirtualSizeHintsWH void SetVirtualSizeHints( int minW, int minH, int maxW = wxDefaultCoord, int maxH = wxDefaultCoord )
void SetVirtualSizeHints( const wxSize& minSize, const wxSize& maxSize=wxDefaultSize)
virtual void SetMinSize(const wxSize& minSize)
virtual void SetMaxSize(const wxSize& maxSize)
virtual wxSize GetMinSize() const
virtual wxSize GetMaxSize() const
int GetMinWidth() const
int GetMinHeight() const
int GetMaxWidth() const
int GetMaxHeight() const
void SetVirtualSize( const wxSize &size )
//void SetVirtualSize( int x, int y )
%rename SetVirtualSizeXY void SetVirtualSize( int x, int y )
wxSize GetVirtualSize() const
// void GetVirtualSize( int *x, int *y ) const
%{
    void wxWindow_GetVirtualSizeWidth()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetVirtualSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)width );
    }

    void wxWindow_GetVirtualSizeHeight()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetVirtualSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)height );
    }

    void wxWindow_GetVirtualSizeWH()
    {
        int width, height;
        ((wxWindow *)wTheCall->self->ptr)->GetVirtualSize(&width, &height);
        wWrapDerefArgs();
		wStackPushInteger( (wInteger)width );
        wStackPushInteger( (wInteger)height );
    }

%}
%method GetVirtualSizeWH         wxWindow_GetVirtualSizeWH()
%method GetVirtualSizeWidth      wxWindow_GetVirtualSizeWidth()
%method GetVirtualSizeHeight     wxWindow_GetVirtualSizeHeight()

//virtual void DoSetVirtualSize( int x, int y )
//virtual wxSize DoGetVirtualSize() const
virtual wxSize GetBestVirtualSize() const
virtual wxSize GetWindowBorderSize() const
virtual bool Show( bool show = true )
bool Hide()
virtual bool Enable( bool enable = true )
bool Disable()
virtual bool IsShown() const
virtual bool IsEnabled() const
virtual bool IsShownOnScreen() const
virtual void SetWindowStyleFlag( long style )
virtual long GetWindowStyleFlag() const
void SetWindowStyle( long style )
long GetWindowStyle() const
bool HasFlag(int flag) const
virtual bool IsRetained() const
bool ToggleWindowStyle(int flag)
virtual void SetExtraStyle(long exStyle)
long GetExtraStyle() const
virtual void MakeModal(bool modal = true)
virtual void SetThemeEnabled(bool enableTheme)
virtual bool GetThemeEnabled() const
virtual void SetFocus()
virtual void SetFocusFromKbd()
static wxWindow *FindFocus()
//static wxWindow *DoFindFocus()
virtual bool AcceptsFocus() const
virtual bool AcceptsFocusFromKeyboard() const
virtual bool Navigate(int flags = wxNavigationKeyEvent::IsForward)
void MoveBeforeInTabOrder(wxWindow *win)
void MoveAfterInTabOrder(wxWindow *win)
//const wxWindowList& GetChildren() const
wxWindowList& GetChildren()
const wxWindowList& GetWindowChildren() const
wxWindow *GetParent() const
inline wxWindow *GetGrandParent() const
virtual bool IsTopLevel() const
void SetParent( wxWindow *parent )
virtual bool Reparent( wxWindow *newParent )
virtual void AddChild( wxWindow *child )
virtual void RemoveChild( wxWindow *child )
%rename FindWindowId wxWindow *FindWindow(long winid) const
wxWindow *FindWindow(const wxString& name) const
static wxWindow *FindWindowById( long winid, const wxWindow *parent = NULL )
static wxWindow *FindWindowByName( const wxString& name, const wxWindow *parent = NULL )
static wxWindow *FindWindowByLabel( const wxString& label, const wxWindow *parent = NULL )
wxEvtHandler *GetEventHandler() const
void SetEventHandler( wxEvtHandler *handler )
void PushEventHandler( wxEvtHandler *handler )
wxEvtHandler *PopEventHandler( bool deleteHandler = false )
bool RemoveEventHandler(wxEvtHandler *handler)
virtual void SetValidator( const wxValidator &validator )
virtual wxValidator *GetValidator()
virtual bool Validate()
virtual bool TransferDataToWindow()
virtual bool TransferDataFromWindow()
virtual void InitDialog()
%{
//virtual void SetAcceleratorTable( const wxAcceleratorTable& accel )
void wxWindow_SetAcceleratorTable()
{
	int count;
	int i;
	wVariant *v;
	wVariant *v2 = wVariantNew();
	wGrow *table;
	wGrow *subtable;
	wTableElement *item;

	/* get source object */
	v = wStackPop();
	count = GetTableCount(v);
	table = v->value.table;

	if(count > 0)
	{
		// xpmData = new const char *[count + 1];
		wxAcceleratorEntry* entries = new wxAcceleratorEntry[count];
		for(i = 0; i < count; i++)
		{
			int flags;
			int keyCode;
			int cmd;
			item = (wTableElement *)wGrowGet(table, i + 2);
			if(item->value.dataType != W_TYPE_TABLE)
				wErrorThrow( W_ERROR_CONVERT, "Expected an Table, not a %s", wDataTypeName[item->value.dataType] );
			subtable = item->value.value.table;
			// get flags
			item = (wTableElement *)wGrowGet( subtable, 2 );
			if(item == NULL)
				wErrorThrow( W_ERROR_ARGS, "Need Subtable with 3 elements" );
			wVariantCopy(v2, &item->value);
			wVariantCoerce(v2, W_TYPE_INTEGER);
			flags = v2->value.integer;
			// get keyCode
			item = (wTableElement *)wGrowGet( subtable, 3 );
			if(item == NULL)
				wErrorThrow( W_ERROR_ARGS, "Need Subtable with 3 elements" );
			wVariantCopy(v2, &item->value);
			wVariantCoerce(v2, W_TYPE_INTEGER);
			keyCode = v2->value.integer;
			// get cmd
			item = (wTableElement *)wGrowGet( subtable, 4 );
			if(item == NULL)
				wErrorThrow( W_ERROR_ARGS, "Need Subtable with 3 elements" );
			wVariantCopy(v2, &item->value);
			wVariantCoerce(v2, W_TYPE_INTEGER);
			cmd = v2->value.integer;
			wVariantDeref( v2 );

			entries[i].Set(flags, keyCode, cmd);
		}
		wxAcceleratorTable accel(count, entries);
		((wxWindow *)(wTheCall->self->ptr))->SetAcceleratorTable(accel);

		delete entries;
	}
	/* deref the object */
	wVariantFree( v2 );
	wVariantDeref( v );
	wWrapDerefArgs();
}
%}
%method SetAcceleratorTable wxWindow_SetAcceleratorTable(const table accel)

wxAcceleratorTable *GetAcceleratorTable()

%if(wxUSE_HOTKEY) bool RegisterHotKey(int hotkeyId, int modifiers, int keycode)
%if(wxUSE_HOTKEY) bool UnregisterHotKey(int hotkeyId)

//wxPoint ConvertDialogToPixels( const wxPoint& pt )
//wxSize ConvertDialogToPixels( const wxSize& sz )
//%rename ConvertDialogPointToPixels wxPoint ConvertDialogToPixels(const wxPoint& pt)
//%rename ConvertDialogSizeToPixels wxSize ConvertDialogToPixels(const wxSize& sz)
%rename ConvertDialogToPixelsPoint wxPoint ConvertDialogToPixels(const wxPoint& pt)
%rename ConvertDialogToPixelsSize wxSize ConvertDialogToPixels(const wxSize& sz)

//wxPoint ConvertPixelsToDialog( const wxPoint& pt )
//wxSize ConvertPixelsToDialog( const wxSize& sz )
%rename ConvertDialogPointToPixels wxPoint ConvertPixelsToDialog(const wxPoint& pt)
%rename ConvertDialogSizeToPixels wxSize ConvertPixelsToDialog(const wxSize& sz)
%rename ConvertPixelsToDialogPoint wxPoint ConvertPixelsToDialog(const wxPoint& pt)
%rename ConvertPixelsToDialogSize wxSize ConvertPixelsToDialog(const wxSize& sz)

virtual void WarpPointer(int x, int y)
void CaptureMouse()
void ReleaseMouse()
static wxWindow *GetCapture()
virtual bool HasCapture() const
virtual void Refresh( bool eraseBackground = true, const wxRect *rect = NULL )
void RefreshRect(const wxRect& rect, bool eraseBackground = true)
virtual void Update()
virtual void ClearBackground()
virtual void Freeze()
virtual void Thaw()
virtual bool IsFrozen() const
virtual void PrepareDC( wxDC & dc )
virtual bool IsDoubleBuffered() const
//const wxRegion& GetUpdateRegion() const
wxRegion& GetUpdateRegion()
wxRect GetUpdateClientRect() const

//virtual bool DoIsExposed( int x, int y ) const
//virtual bool DoIsExposed( int x, int y, int w, int h ) const
bool IsExposed( int x, int y ) const
//bool IsExposed( int x, int y, int w, int h ) const
%rename IsExposedXYWH bool IsExposed( int x, int y, int w, int h ) const
//bool IsExposed( const wxPoint& pt ) const
//bool IsExposed( const wxRect& rect ) const
%rename IsExposedPoint bool IsExposed(const wxPoint &pt) const
%rename IsExposedRect bool IsExposed(const wxRect &rect) const

virtual wxVisualAttributes GetDefaultAttributes() const
static wxVisualAttributes GetClassDefaultAttributes(wxWindowVariant variant = wxWINDOW_VARIANT_NORMAL)

//virtual bool SetBackgroundColour(const wxColour& colour)
%alias SetBackgroundColor virtual void SetBackgroundColour(const wxColour& colour)
//void SetOwnBackgroundColour(const wxColour& colour)
%alias SetOwnBackgroundColor void SetOwnBackgroundColour(const wxColour& colour)
//wxColour GetBackgroundColour() const
%alias GetBackgroundColor wxColour GetBackgroundColour() const
//bool InheritsBackgroundColour() const
%alias InheritsBackgroundColor bool InheritsBackgroundColour() const
bool UseBgCol() const
//virtual bool SetForegroundColour(const wxColour& colour)
%alias SetForegroundColor virtual bool SetForegroundColour(const wxColour& colour)
//void SetOwnForegroundColour(const wxColour& colour)
%alias SetOwnForegroundColor void SetOwnForegroundColour(const wxColour& colour)
//wxColour GetForegroundColour() const
%alias GetForegroundColor wxColour GetForegroundColour() const

virtual bool SetBackgroundStyle(wxBackgroundStyle style)
virtual wxBackgroundStyle GetBackgroundStyle() const
virtual bool HasTransparentBackground()
virtual bool SetFont(const wxFont& font)
void SetOwnFont(const wxFont& font)
wxFont GetFont() const
virtual bool SetCursor( const wxCursor &cursor )
const wxCursor& GetCursor() const
void SetCaret(wxCaret *caret)
wxCaret *GetCaret() const

virtual int GetCharHeight() const
virtual int GetCharWidth() const
//virtual void GetTextExtent(const wxString& string, int *x, int *y, int *descent = (int *) NULL, int *externalLeading = (int *) NULL, const wxFont *theFont = (const wxFont *) NULL)	const
%{
    void wxWindow_GetTextExtent()
    {
        // arg
        wxString string(wStackPopChar(), *wxConvCurrent);

        int x, y, descent, externalLeading;
        ((wxWindow *)wTheCall->self->ptr)->GetTextExtent(string, &x, &y, &descent, &externalLeading);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
        wStackPushInteger( (wInteger)descent );
        wStackPushInteger( (wInteger)externalLeading );
    }

    void wxWindow_GetTextExtentX()
    {
        // arg
        wxString string(wStackPopChar(), *wxConvCurrent);

        int x, y, descent, externalLeading;
        ((wxWindow *)wTheCall->self->ptr)->GetTextExtent(string, &x, &y, &descent, &externalLeading);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }

    void wxWindow_GetTextExtentY()
    {
        // arg
        wxString string(wStackPopChar(), *wxConvCurrent);
        int x, y, descent, externalLeading;
        ((wxWindow *)wTheCall->self->ptr)->GetTextExtent(string, &x, &y, &descent, &externalLeading);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }

    void wxWindow_GetTextExtentDescent()
    {
        // arg
        wxString string(wStackPopChar(), *wxConvCurrent);
        int x, y, descent, externalLeading;
        ((wxWindow *)wTheCall->self->ptr)->GetTextExtent(string, &x, &y, &descent, &externalLeading);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)descent );
    }

    void wxWindow_GetTextExtentExternalLeading()
    {
        // arg
        wxString string(wStackPopChar(), *wxConvCurrent);
        int x, y, descent, externalLeading;
        ((wxWindow *)wTheCall->self->ptr)->GetTextExtent(string, &x, &y, &descent, &externalLeading);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)externalLeading );
    }
%}
%method GetTextExtent                   wxWindow_GetTextExtent( const wxString &string)
%method GetTextExtentXY                 wxWindow_GetTextExtent( const wxString &string)
%method GetTextExtentX                  wxWindow_GetTextExtentX( const wxString &string)
%method GetTextExtentY                  wxWindow_GetTextExtentY( const wxString &string)
%method GetTextExtentDescent            wxWindow_GetTextExtentX( const wxString &string)
%method GetTextExtentExternalLeading    wxWindow_GetTextExtentX( const wxString &string)

//void ClientToScreen( int *x, int *y ) const
%{
    void wxWindow_ClientToScreen()
    {
        int x = wStackPopInteger();
        int y = wStackPopInteger();
        ((wxWindow *)wTheCall->self->ptr)->ClientToScreen(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
    }
    void wxWindow_ClientToScreenX()
    {
        int x = wStackPopInteger();
        int y = 0;
        ((wxWindow *)wTheCall->self->ptr)->ClientToScreen(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }
    void wxWindow_ClientToScreenY()
    {
        int x = 0;
        int y = wStackPopInteger();
        ((wxWindow *)wTheCall->self->ptr)->ClientToScreen(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }
%}

%method ClientToScreen wxWindow_ClientToScreen( int x, int y )
%method ClientToScreenXY wxWindow_ClientToScreen( int x, int y )
%method ClientToScreenX wxWindow_ClientToScreenX( int x )
%method ClientToScreenY wxWindow_ClientToScreenY( int y )

//void ScreenToClient( int *x, int *y ) const
%{
    void wxWindow_ScreenToClient()
    {
        int x = wStackPopInteger();
        int y = wStackPopInteger();
        ((wxWindow *)wTheCall->self->ptr)->ScreenToClient(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
    }
    void wxWindow_ScreenToClientX()
    {
        int x = wStackPopInteger();
        int y = 0;
        ((wxWindow *)wTheCall->self->ptr)->ScreenToClient(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }
    void wxWindow_ScreenToClientY()
    {
        int x = 0;
        int y = wStackPopInteger();
        ((wxWindow *)wTheCall->self->ptr)->ScreenToClient(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }
%}

%method ScreenToClient wxWindow_ScreenToClient( int x, int y )
%method ScreenToClientXY wxWindow_ScreenToClient( int x, int y )
%method ScreenToClientX wxWindow_ScreenToClientX( int x )
%method ScreenToClientY wxWindow_ScreenToClientY( int y )

//%rename ScreenToClientXY void ScreenToClient(int* x, int* y) const
//wxPoint ClientToScreen(const wxPoint& pt) const
%rename ClientToScreenPoint wxPoint ClientToScreen(const wxPoint& pt) const
%rename ScreenToClientPoint wxPoint ScreenToClient(const wxPoint& pt) const

//wxHitTest HitTest(wxCoord x, wxCoord y) const
%alias HitTextXY wxHitTest HitTest(wxCoord x, wxCoord y) const
//wxHitTest HitTest(const wxPoint& pt) const
%rename HitTestPoint wxHitTest HitTest(const wxPoint& pt) const
wxBorder GetBorder(long flags) const
//wxBorder GetBorder() const
virtual void UpdateWindowUI(long flags = wxUPDATE_UI_NONE)
//virtual void DoUpdateWindowUI(wxUpdateUIEvent& event)

//bool PopupMenu(wxMenu *menu, const wxPoint& pos = wxDefaultPosition)
%rename PopupMenuPoint bool PopupMenu(wxMenu *menu, const wxPoint& pos = wxDefaultPosition)
bool PopupMenu(wxMenu *menu, int x, int y)
%rename PopupMenuXY bool PopupMenu(wxMenu* menu, int x, int y)

virtual bool HasMultiplePages() const
bool HasScrollbar(int orient) const
virtual void SetScrollbar( int orient, int pos, int thumbvisible, int range, bool refresh = true )
virtual void SetScrollPos( int orient, int pos, bool refresh = true )
virtual int GetScrollPos( int orient ) const
virtual int GetScrollThumb( int orient ) const
virtual int GetScrollRange( int orient ) const
virtual void ScrollWindow( int dx, int dy, const wxRect* rect = NULL )
virtual bool ScrollLines(int lines)
virtual bool ScrollPages(int pages)
bool LineUp()
bool LineDown()
bool PageUp()
bool PageDown()
void SetHelpText(const wxString& text)
void SetHelpTextForId(const wxString& text)
virtual wxString GetHelpTextAtPoint(const wxPoint& pt, wxHelpEvent::Origin origin) const
wxString GetHelpText() const
void SetToolTip( const wxString &tip )
//void SetToolTip( wxToolTip *tip )
%rename SetToolTipToolTip void SetToolTip( wxToolTip *tip )
wxToolTip* GetToolTip() const
//TODO, recompile with wxUSE_TOOLTIPS
//wxString GetToolTipText() const
//inline void SetToolTip( const wxString & tip )
virtual void SetDropTarget( wxDropTarget *dropTarget )
virtual wxDropTarget *GetDropTarget() const
void SetConstraints( wxLayoutConstraints *constraints )
wxLayoutConstraints *GetConstraints() const
void UnsetConstraints(wxLayoutConstraints *c)
wxWindowList *GetConstraintsInvolvedIn() const
void AddConstraintReference(wxWindow *otherWin)
void RemoveConstraintReference(wxWindow *otherWin)
void DeleteRelatedConstraints()
void ResetConstraints()
virtual void SetConstraintSizes(bool recurse = true)
virtual bool LayoutPhase1(int *noChanges)
virtual bool LayoutPhase2(int *noChanges)
virtual bool DoPhase(int phase)
virtual void SetSizeConstraint(int x, int y, int w, int h)
virtual void MoveConstraint(int x, int y)
virtual void GetSizeConstraint(int *w, int *h) const
virtual void GetClientSizeConstraint(int *w, int *h) const
virtual void GetPositionConstraint(int *x, int *y) const
void SetAutoLayout( bool autoLayout )
bool GetAutoLayout() const
virtual bool Layout()
void SetSizer(wxSizer *sizer, bool deleteOld = true )
void SetSizerAndFit( wxSizer *sizer, bool deleteOld = true )
wxSizer *GetSizer() const
void SetContainingSizer(wxSizer* sizer)
wxSizer *GetContainingSizer() const
//FIXME, recompile with wxAccessible support
//virtual wxAccessible* CreateAccessible()
//void SetAccessible(wxAccessible* accessible)
//wxAccessible* GetAccessible()
//wxAccessible* GetOrCreateAccessible()
virtual bool SetTransparent(wxByte alpha)
virtual bool CanSetTransparent()
void OnSysColourChanged( wxSysColourChangedEvent& event )
void OnInitDialog( wxInitDialogEvent &event )
void OnMiddleClick( wxMouseEvent& event )
void OnHelp(wxHelpEvent& event)
virtual void OnInternalIdle()
//virtual WXWidget GetHandle() const
//virtual void AssociateHandle(WXWidget handle)
//virtual void DissociateHandle()
wxPalette GetPalette() const
void SetPalette(const wxPalette& pal)
bool HasCustomPalette() const
wxWindow *GetAncestorWithCustomPalette() const
virtual void InheritAttributes()
virtual bool ShouldInheritColours() const

// FIX: Missing in GTK
%if(win) virtual void DragAcceptFiles(bool accept)

// documented, but...
//void CenterOnScreen(int direction)
//void CentreOnScreen(int direction = wxBOTH)
wxSize  ClientToWindowSize(const wxSize& size)
// documented, but...
//wxSize  GetAdjustedBestSize() const
wxWindow *  GetNextSibling() const
wxWindow *  GetPrevSibling() const
// protected
//virtual void SetInitialBestSize(const wxSize& size)
virtual wxSize  WindowToClientSize(const wxSize& size)

%builtin %rename wxWindow_FindFocus wxWindow* wxWindow::FindFocus()
%builtin %rename wxWindow_FindWindowById wxWindow* wxWindow::FindWindowById(long id, wxWindow* parent = NULL)
%builtin %rename wxWindow_FindWindowByLabel wxWindow* wxWindow::FindWindowByLabel(const wxString& label, wxWindow* parent = NULL)
%builtin %rename wxWindow_FindWindowByName wxWindow* wxWindow::FindWindowByName(const wxString& name, wxWindow* parent = NULL)
%builtin %rename wxWindow_GetCapture wxWindow * wxWindow::GetCapture()
//%builtin %rename wxWindow_GetClassDefaultAttributes wxVisualAttributes wxWindow::GetClassDefaultAttributes(wxWindowVariant variant = wxWINDOW_VARIANT_NORMAL)

// FIXME
// virtual bool LoadFromResource(wxWindow* parent, const wxString& resourceName, const wxResourceTable* resourceTable = NULL)

// void OnActivate(wxActivateEvent& event)
// void OnChar(wxKeyEvent& event)
// void OnCharHook(wxKeyEvent& event)
// virtual void OnCommand(wxEvtHandler& object, wxCommandEvent& event)
// virtual bool OnClose()
// void OnCloseWindow(wxCloseEvent& event)
// void OnDropFiles(wxDropFilesEvent& event)
// void OnEraseBackground(wxEraseEvent& event)
// void OnKeyDown(wxKeyEvent& event)
// void OnKeyUp(wxKeyEvent& event)
// void OnKillFocus(wxFocusEvent& event)
// void OnIdle(wxIdleEvent& event)
// void OnInitDialog(wxInitDialogEvent& event)
// void OnMenuCommand(wxCommandEvent& event)
// void OnMenuHighlight(wxMenuEvent& event)
// void OnMouseEvent(wxMouseEvent& event)
// void OnMove(wxMoveEvent& event)
// void OnPaint(wxPaintEvent& event)
// void OnScroll(wxScrollWinEvent& event)
// void OnSetFocus(wxFocusEvent& event)
// void OnSize(wxSizeEvent& event)
// %alias OnSysColorChanged void OnSysColourChanged(wxOnSysColourChangedEvent& event)

// %num wxCENTER_FRAME
%num %alias wxCENTER_ON_SCREEN wxCENTRE_ON_SCREEN
%num wxVSCROLL
%num wxHSCROLL
%num wxCAPTION
// following num just for compatibiliy reason, see wxBORDER_xxx
%num wxDOUBLE_BORDER
%num wxSUNKEN_BORDER
%num wxRAISED_BORDER
%num wxBORDER
%num wxSIMPLE_BORDER
%num wxSTATIC_BORDER
%num wxTRANSPARENT_WINDOW
%num wxNO_BORDER

%num wxALWAYS_SHOW_SB
%num %alias wxUSER_COLORS wxUSER_COLOURS
%num wxNO_3D
%num wxCLIP_CHILDREN
%num wxCLIP_SIBLINGS
%num wxTAB_TRAVERSAL
%num wxWANTS_CHARS
%num wxRETAINED
%num wxBACKINGSTORE
%num wxNO_FULL_REPAINT_ON_RESIZE
%num wxWS_EX_VALIDATE_RECURSIVELY
%num wxWS_EX_BLOCK_EVENTS
%num wxWS_EX_TRANSIENT
%num wxWS_EX_THEMED_BACKGROUND
%num wxWS_EX_PROCESS_IDLE
%num wxWS_EX_PROCESS_UI_UPDATES
%num wxFRAME_EX_METAL
%num wxDIALOG_EX_METAL
%num wxWS_EX_CONTEXTHELP
%num wxFRAME_DRAWER

%num wxSTAY_ON_TOP
%num wxICONIZE
%num wxMINIMIZE
%num wxMAXIMIZE
%num wxCLOSE_BOX
%num wxSYSTEM_MENU
%num wxMINIMIZE_BOX
%num wxMAXIMIZE_BOX
%num wxTINY_CAPTION_HORIZ
%num wxTINY_CAPTION_VERT
%num wxRESIZE_BORDER
%num wxRESIZE_BOX
%num wxTHICK_FRAME
%num wxDIALOG_MODAL
%num wxDIALOG_MODELESS

%num wxDIALOG_NO_PARENT

%num wxFRAME_NO_TASKBAR
%num wxFRAME_TOOL_WINDOW

%num wxFRAME_FLOAT_ON_PARENT
%num wxFRAME_SHAPED
%num wxFRAME_EX_CONTEXTHELP
%num wxDIALOG_EX_CONTEXTHELP
%num wxFRAME_NO_WINDOW_MENU
%num wxDEFAULT_FRAME_STYLE
%num wxTOPLEVEL_EX_DIALOG
%num wxDEFAULT_DIALOG_STYLE

%num wxPOPUP_WINDOW
%num wxFULL_REPAINT_ON_RESIZE
%num wxWINDOW_STYLE_MASK

%num wxFULLSCREEN_NOMENUBAR
%num wxFULLSCREEN_NOTOOLBAR
%num wxFULLSCREEN_NOSTATUSBAR
%num wxFULLSCREEN_NOBORDER
%num wxFULLSCREEN_NOCAPTION
%num wxFULLSCREEN_ALL

%num wxUSER_ATTENTION_INFO
%num wxUSER_ATTENTION_ERROR

//%str wxFrameNameStr

%builtin wxWindow* wxGetTopLevelParent(wxWindow *win)

// #########################################################
// toplevel.h

%include <wx/toplevel.h>

// ==============================
// Class: wxTopLevelWindowBase

%class wxTopLevelWindow, wxWindow
wxTopLevelWindow(wxWindow *parent, wxWindowID winid, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = wxFrameNameStr)
virtual void Maximize(bool maximize = true)
virtual void Restore()
virtual void Iconize(bool iconize = true)
virtual bool IsMaximized() const
virtual bool IsAlwaysMaximized() const
virtual bool IsIconized() const
const wxIcon& GetIcon() const
//TODO: add wxIconBundle
//const wxIconBundle& GetIcons() const
virtual void SetIcon(const wxIcon& icon)
//TODO: add wxIconBundle
//virtual void SetIcons(const wxIconBundle& icons )
virtual bool ShowFullScreen(bool show, long style = wxFULLSCREEN_ALL)
virtual bool IsFullScreen() const
virtual void SetTitle(const wxString& title)
virtual wxString GetTitle() const
virtual bool EnableCloseButton(bool enable )
virtual bool SetShape(const wxRegion& region)
virtual void RequestUserAttention(int flags = wxUSER_ATTENTION_INFO)
virtual bool IsActive()
virtual bool ShouldPreventAppExit() const
//only at Smartphones
//virtual void SetLeftMenu(int id = wxID_ANY, const wxString& label = wxEmptyString, wxMenu *subMenu = NULL)
//virtual void SetRightMenu(int id = wxID_ANY, const wxString& label = wxEmptyString, wxMenu *subMenu = NULL)
void CentreOnScreen(int dir = wxBOTH)
void CenterOnScreen(int dir = wxBOTH)
//wxWindowBase
virtual void RemoveChild(wxWindow *child)
//wxWindow *GetDefaultItem() const
wxWindow *SetDefaultItem(wxWindow *win)
//wxWindow *GetTmpDefaultItem() const
wxWindow *SetTmpDefaultItem(wxWindow *win)
virtual bool Destroy()
virtual bool IsTopLevel() const
virtual bool IsVisible() const
void OnCloseWindow(wxCloseEvent& event)
void OnSize(wxSizeEvent& event)
virtual void GetRectForTopLevelChildren(int *x, int *y, int *w, int *h)
void OnActivate(wxActivateEvent &event)
virtual void DoUpdateWindowUI(wxUpdateUIEvent& event)
virtual void SetMinSize(const wxSize& minSize)
virtual void SetMaxSize(const wxSize& maxSize)
virtual void DoSetSizeHints( int minW, int minH, int maxW = wxDefaultCoord, int maxH = wxDefaultCoord, int incW = wxDefaultCoord, int incH = wxDefaultCoord )

virtual bool CanSetTransparent()
wxWindow *  GetDefaultItem() const
//virtual bool HandleSettingChange(WXWPARAM wParam, WXLPARAM lParam)
//bool IsUsingNativeDecorations() const
virtual void SetSizeHints(int minW, int minH, int maxW=-1, int maxH=-1, int incW=-1, int incH=-1)
virtual bool SetTransparent(int  alpha)
//void UseNativeDecorations(bool native = true)
//void UseNativeDecorationsByDefault(bool native = true)

///////////////////////////////////////////////////////////////////////////////
// wxPlotWindow

// It doesn't look like this can be easily wrapped, since
// the class wxPlotCurve would have to be derived in order
// to make it work.

%if(false) %class wxPlotWindow, wxScrolledWindow

wxPlotWindow(wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, int flags = wxPLOT_DEFAULT)
void Add(wxPlotCurve* curve)
size_t GetCount()
wxPlotCurve* GetAt(size_t n)
void SetCurrent(wxPlotCurve* current)
wxPlotCurve* GetCurrent()
void Delete(wxPlotCurve* curve)
void Move(wxPlotCurve* curve, int pixels_up)
void Enlarge(wxPlotCurve* curve, double factor)
void SetUnitsPerValue(double upv)
double GetUnitsPerValue()
void SetZoom(double zoom)
double GetZoom()
void RedrawEverything()
void RedrawXAxis()
void RedrawYAxis()
void SetScrollOnThumbRelease(bool onrelease = TRUE)
%alias SetEnlargeAroundWindowCenter void SetEnlargeAroundWindowCentre(bool aroundwindow = TRUE)

///////////////////////////////////////////////////////////////////////////////
// wxSashWindow

%class wxSashWindow, wxWindow
%include "wx/sashwin.h"

%ctor wxSashWindowNoCreate()
wxSashWindow(wxWindow *parent, wxWindowID id = -1, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSW_3D|wxCLIP_CHILDREN, const wxString& name = wxT("sashWindow"))

bool GetSashVisible(wxSashEdgePosition edge) const
int GetMaximumSizeX() const
int GetMaximumSizeY() const
int GetMinimumSizeX()
// Error: Extra parameter in call
// int GetMinimumSizeY(int min) const
int GetMinimumSizeY() const
bool HasBorder(wxSashEdgePosition edge) const
void SetMaximumSizeX(int min)
void SetMaximumSizeY(int min)
void SetMinimumSizeX(int min)
void SetMinimumSizeY(int min)
void SetSashVisible(wxSashEdgePosition edge, bool visible)
void SetSashBorder(wxSashEdgePosition edge, bool hasBorder)

%num  wxSASH_DRAG_NONE
%num  wxSASH_DRAG_DRAGGING
%num  wxSASH_DRAG_LEFT_DOWN
%num  wxSASH_TOP
%num  wxSASH_RIGHT
%num  wxSASH_BOTTOM
%num  wxSASH_LEFT
%num  wxSASH_NONE

///////////////////////////////////////////////////////////////////////////////
// wxSashLayoutWindow

%class wxSashLayoutWindow, wxSashWindow
%include "wx/laywin.h"

%ctor wxSashLayoutWindowNoCreate()
wxSashLayoutWindow(wxWindow *parent, wxWindowID id = -1, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSW_3D|wxCLIP_CHILDREN, const wxString& name = wxT("layoutWindow"))
bool Create(wxSashLayoutWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxCLIP_CHILDREN |  wxSW_3D, const wxString& name = wxT("layoutWindow"))
wxLayoutAlignment GetAlignment() const
wxLayoutOrientation GetOrientation() const
// void OnCalculateLayout(wxCalculateLayoutEvent& event)
// void OnQueryLayoutInfo(wxQueryLayoutInfoEvent& event)
void SetAlignment(wxLayoutAlignment alignment)
void SetDefaultSize(const wxSize& size)
void SetOrientation(wxLayoutOrientation orientation)

///////////////////////////////////////////////////////////////////////////////
// wxSashEvent

%include <wx/sashwin.h>
%enum  wxSashDragStatus
  %num wxSASH_STATUS_OK
  %num wxSASH_STATUS_OUT_OF_RANGE
%class %delete wxSashEvent, wxCommandEvent
wxSashEvent(int id = 0, wxSashEdgePosition edge = wxSASH_NONE)
wxSashEdgePosition GetEdge() const
wxRect  GetDragRect() const
wxSashDragStatus GetDragStatus() const

%event wxEVT_SASH_DRAGGED
// documented, but...
//%event wxEVT_SASH_DRAGGED_RANGE

///////////////////////////////////////////////////////////////////////////////
// MANAGED WINDOWS
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// wxPanel

%class wxPanel, wxWindow

wxPanel(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxTAB_TRAVERSAL, const wxString& name = wxT("panel"))
%ctor wxPanelNoCreate()
bool Create(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxTAB_TRAVERSAL, const wxString& name = wxT("panel"))
// FIXME: 2.3.2
// wxButton* GetDefaultItem() const
void InitDialog()
// %alias OnSysColorChanged void OnSysColourChanged(wxSysColourChangedEvent& event)
//void SetDefaultItem(wxButton *btn)
virtual void SetFocus()
virtual void SetFocusIgnoringChildren()

///////////////////////////////////////////////////////////////////////////////
// wxDialog

%class wxDialog, wxWindow
wxDialog(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_DIALOG_STYLE, const wxString& name = wxT("dialogBox"))
%ctor wxDialogNoCreate()
%alias Center void Centre(int direction = wxBOTH)
bool Create(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_DIALOG_STYLE, const wxString& name = wxT("dialogBox"))
void EndModal(int retCode)
int GetReturnCode()
wxString GetTitle() const
void Iconize(const bool iconize)
bool IsIconized() const
bool IsModal() const
// void OnCharHook(wxKeyEvent& event)
// void OnApply(wxCommandEvent& event)
// void OnCancel(wxCommandEvent& event)
// void OnOK(wxCommandEvent& event)
// %alias OnSysColorChanged void OnSysColourChanged(wxSysColourChangedEvent& event)
void SetModal(const bool flag)
void SetReturnCode(int retCode)
void SetTitle(const wxString& title)
bool Show(const bool show)
int ShowModal()

wxSizer*  CreateButtonSizer(long flags)
wxSizer*  CreateSeparatedButtonSizer(long flags)
wxStdDialogButtonSizer*  CreateStdDialogButtonSizer(long flags)
// documented, but not defined
// virtual bool DoOK()
int GetAffirmativeId() const
int GetEscapeId() const
// documented, but not defined
//wxToolBar*  GetToolBar() const
void SetAffirmativeId(int id)
void SetEscapeId(int id)
void SetIcon(const wxIcon& icon)
void SetIcons(const wxIconBundle& icons)

///////////////////////////////////////////////////////////////////////////////
// wxFrame

// #########################################################
// frame.h

%include <wx/frame.h>

//%str wxStatusLineNameStr
//%str wxToolBarNameStr

%class wxFrame, wxTopLevelWindow
//wxFrameBase()
wxFrame(wxWindow *parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = wxFrameNameStr)
%ctor wxFrameNoCreate()
virtual wxPoint GetClientAreaOrigin() const
virtual void SendSizeEvent()
virtual void SetMenuBar(wxMenuBar *menubar)
virtual wxMenuBar *GetMenuBar() const
bool ProcessCommand(int winid)
virtual wxStatusBar* CreateStatusBar(int number = 1, long style = wxST_SIZEGRIP|wxFULL_REPAINT_ON_RESIZE, wxWindowID winid = 0, const wxString& name = wxStatusLineNameStr)
//virtual wxStatusBar *OnCreateStatusBar(int number, long style, wxWindowID winid, const wxString& name)
virtual wxStatusBar *GetStatusBar() const
virtual void SetStatusBar(wxStatusBar *statBar)
virtual void SetStatusText(const wxString &text, int number = 0)

%{
// virtual void SetStatusWidths(int n, const int widths_field[])
void wxFrame_SetStatusWidths()
{
	wVariant* v;
	int * data = NULL;
	wGrow *list;

	/* get source object */
	v = wStackPop();
	list = v->value.list;

	data = MakeIntArray(list);
	if(data)
	{
		((wxFrame *)(wTheCall->self->ptr))->SetStatusWidths(list->count, data);
		delete data;
	}
	/* deref the object */
	wVariantDeref( v );
	wWrapDerefArgs();
}
%}
%method SetStatusWidths wxFrame_SetStatusWidths(int* widths)

void PushStatusText(const wxString &text, int number = 0)
void PopStatusText(int number = 0)
void SetStatusBarPane(int n)
int GetStatusBarPane() const
virtual wxToolBar* CreateToolBar(long style = -1, wxWindowID winid = wxID_ANY, const wxString& name = wxToolBarNameStr)
virtual wxToolBar *OnCreateToolBar(long style, wxWindowID winid, const wxString& name )
virtual wxToolBar *GetToolBar() const
virtual void SetToolBar(wxToolBar *toolbar)
void OnMenuOpen(wxMenuEvent& event)
void OnMenuClose(wxMenuEvent& event)
void OnMenuHighlight(wxMenuEvent& event)
virtual void DoMenuUpdates(wxMenu* menu = NULL)
virtual void UpdateWindowUI(long flags = wxUPDATE_UI_NONE)
virtual void OnInternalIdle()
virtual bool IsFullScreen() const
virtual void DoGiveHelp(const wxString& text, bool show)

//virtual wxStatusBar* OnCreateStatusBar(int number = 1, long style = wxST_SIZEGRIP, wxWindowID id = 0, const wxString& name = wxStatusLineNameStr)
bool Create(wxWindow *parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = wxFrameNameStr)
bool ShowFullScreen(bool show, long style = wxFULLSCREEN_ALL)
virtual void Raise()
void OnSysColourChanged(wxSysColourChangedEvent& event)
%if(win) static void UseNativeStatusBar(bool useNative)
%if(win) static bool UsesNativeStatusBar()
//WXHMENU GetWinMenu() const
//bool HandlePaint()
//bool HandleSize(int x, int y, WXUINT flag)
//bool HandleCommand(WXWORD id, WXWORD cmd, WXHWND control)
//bool HandleMenuSelect(WXWORD nItem, WXWORD nFlags, WXHMENU hMenu)
//bool HandleMenuLoop(const wxEventType& evtType, WXWORD isPopup)
//WXHWND GetToolTipCtrl() const
//void SetToolTipCtrl(WXHWND hwndTT)
//virtual void SendSizeEvent()
//virtual wxPoint GetClientAreaOrigin() const
//virtual bool MSWTranslateMessage(WXMSG *msg)
//virtual WXLRESULT MSWWindowProc(WXUINT message, WXWPARAM wParam, WXLPARAM lParam)

///////////////////////////////////////////////////////////////////////////////
// wxPreviewFrame

%include <wx/print.h>
%class wxPreviewFrame, wxFrame
wxPreviewFrame(wxPrintPreview* preview, wxWindow* parent, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = wxT("frame"))
// ~wxPreviewFrame()
void CreateControlBar()
void CreateCanvas()
void Initialize()
//void OnCloseWindow(wxCloseEvent& event)

///////////////////////////////////////////////////////////////////////////////
// wxPreviewCanvas

%include <wx/print.h>
%class wxPreviewCanvas, wxScrolledWindow
wxPreviewCanvas(wxPrintPreview* preview, wxWindow* parent, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("canvas"))
// ~wxPreviewCanvas()
//void OnPaint(wxPaintEvent& event)

///////////////////////////////////////////////////////////////////////////////
// wxPrintPreview

%include <wx/print.h>
%class wxPrintPreview, wxObject
wxPrintPreview(wxPrintout* printout, wxPrintout* printoutForPrinting, wxPrintData* data=NULL)
// ~wxPrinter()
wxPreviewCanvas*   GetCanvas()
int GetCurrentPage()
wxFrame *  GetFrame()
int GetMaxPage()
int GetMinPage()
wxPrintout *  GetPrintout()
wxPrintout *  GetPrintoutForPrinting()
bool Ok()
bool PaintPage(wxPreviewCanvas *canvas, wxDC& dc)
bool RenderPage(int pageNum)
void SetCanvas(wxPreviewCanvas* window)
void SetCurrentPage(int pageNum)
void SetFrame(wxFrame *frame)
void SetPrintout(wxPrintout *printout)
void SetZoom(int percent)

virtual bool DrawBlankPage(wxPreviewCanvas *canvas, wxDC& dc)
virtual void AdjustScrollbars(wxPreviewCanvas *canvas)
virtual int GetZoom() const

virtual bool Print(bool interactive)
virtual void DetermineScaling()

virtual wxPrintDialogData& GetPrintDialogData()

virtual bool IsOk() const
virtual void SetOk(bool ok)

///////////////////////////////////////////////////////////////////////////////
// wxMDIParentFrame

%class wxMDIParentFrame, wxFrame
wxMDIParentFrame(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE | wxVSCROLL | wxHSCROLL, const wxString& name = wxT("frame"))
%ctor wxMDIParentFrameNoCreate()
void ActivateNext()
void ActivatePrevious()
void ArrangeIcons()
void Cascade()
bool Create(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE | wxVSCROLL | wxHSCROLL, const wxString& name = wxT("frame"))
// virtual void GetClientSize(int* width, int* height) const
%{
    void wxMDIParentFrame_GetClientSize()
    {
        int width, height;
        ((wxMDIParentFrame *)wTheCall->self->ptr)->GetClientSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)width );
        wStackPushInteger( (wInteger)height );
    }

    void wxMDIParentFrame_GetClientSizeWidth()
    {
        int width, height;
        ((wxMDIParentFrame *)wTheCall->self->ptr)->GetClientSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)width );
    }

    void wxMDIParentFrame_GetClientSizeHeight()
    {
        int width, height;
        ((wxMDIParentFrame *)wTheCall->self->ptr)->GetClientSize(&width, &height);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)height );
    }

%}
%method GetClientSize       wxMDIParentFrame_GetClientSize()
%method GetClientSizeWidth  wxMDIParentFrame_GetClientSizeWidth()
%method GetClientSizeHeight wxMDIParentFrame_GetClientSizeHeight()

wxMDIChildFrame* GetActiveChild() const
wxMDIClientWindow* GetClientWindow() const
virtual wxWindow* GetToolBar() const
// FIX: Missing in GTK
%if(win) wxMenu* GetWindowMenu() const
// virtual wxMDIClientWindow* OnCreateClient()
// Decl error
// virtual void SetToolBar(wxWindow* toolbar)
virtual void SetToolBar(wxToolBar* toolbar)
// FIX: Missing in GTK
%if(win) void SetWindowMenu(wxMenu* menu)
void Tile()

///////////////////////////////////////////////////////////////////////////////
// wxMDIChildFrame

%class wxMDIChildFrame, wxFrame

wxMDIChildFrame(wxMDIParentFrame* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = wxT("frame"))
%ctor wxMDIChildFrameNoCreate()
void Activate()
// Decl error
//bool Create(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = wxT("frame"))
bool Create(wxMDIParentFrame* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = wxT("frame"))
// FIX: Missing in GTK - Maximize(bool) exists
%if(win) void Maximize()
void Restore()

///////////////////////////////////////////////////////////////////////////////
// wxMDIClientWindow

%include <wx/mdi.h>
%class wxMDIClientWindow, wxWindow
wxMDIClientWindow()
//~wxMDIClientWindow()
bool CreateClient(wxMDIParentFrame* parent, long style = 0)

///////////////////////////////////////////////////////////////////////////////
// wxMiniFrame

%class wxMiniFrame, wxFrame
%include "wx/minifram.h"
wxMiniFrame(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = wxT("frame"))
bool Create(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = wxT("frame"))

///////////////////////////////////////////////////////////////////////////////
// wxProgressDialog

%include <wx/progdlg.h>
%num wxPD_APP_MODAL
%num wxPD_AUTO_HIDE
%num wxPD_SMOOTH
%num wxPD_CAN_ABORT
%num wxPD_CAN_SKIP
%num wxPD_ELAPSED_TIME
%num wxPD_ESTIMATED_TIME
%num wxPD_REMAINING_TIME
%class wxProgressDialog, wxDialog
wxProgressDialog(const wxString& title, const wxString& message, int maximum = 100, wxWindow * parent = NULL, int style = wxPD_AUTO_HIDE | wxPD_APP_MODAL)
// ~wxProgressDialog()
void Resume()
virtual bool Update(int value, const wxString& newmsg = wxT(""), bool *skip = NULL)
virtual bool Pulse(const wxString& newmsg = wxT(""), bool *skip = NULL)

///////////////////////////////////////////////////////////////////////////////
// wxSymbolPickerDialog

%include <wx/richtext/richtextsymboldlg.h>
%class wxSymbolPickerDialog, wxDialog
%ctor wxSymbolPickerDialogNoCreate()
wxSymbolPickerDialog(const wxString& symbol, const wxString& initialFont, const wxString& normalTextFont, wxWindow* parent, wxWindowID id = wxID_ANY, const wxString& title = _("Symbols"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_DIALOG_STYLE|wxRESIZE_BORDER|wxCLOSE_BOX)
bool Create(const wxString& symbol, const wxString& initialFont, const wxString& normalTextFont, wxWindow* parent, wxWindowID id = wxID_ANY, const wxString& title = _("Symbols"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_DIALOG_STYLE|wxRESIZE_BORDER|wxCLOSE_BOX)

wxString  GetFontName() const
bool GetFromUnicode() const
wxString  GetNormalTextFontName() const
wxString  GetSymbol() const
int GetSymbolChar() const
bool HasSelection() const
void SetFontName(const wxString& value)
void SetFromUnicode(bool value)
void SetNormalTextFontName(const wxString& value)
void SetSymbol(const wxString& value)
void SetUnicodeMode(bool unicodeMode)
bool UseNormalFont() const

wxBitmap GetBitmapResource( const wxString& name )
wxIcon GetIconResource( const wxString& name )

%num %rename wxSymbolPickerDialog_ID_SYMBOLPICKERDIALOG wxSymbolPickerDialog::ID_SYMBOLPICKERDIALOG
%num %rename wxSymbolPickerDialog_ID_SYMBOLPICKERDIALOG_FONT wxSymbolPickerDialog::ID_SYMBOLPICKERDIALOG_FONT
%num %rename wxSymbolPickerDialog_ID_SYMBOLPICKERDIALOG_SUBSET wxSymbolPickerDialog::ID_SYMBOLPICKERDIALOG_SUBSET
%num %rename wxSymbolPickerDialog_ID_SYMBOLPICKERDIALOG_LISTCTRL wxSymbolPickerDialog::ID_SYMBOLPICKERDIALOG_LISTCTRL
%num %rename wxSymbolPickerDialog_ID_SYMBOLPICKERDIALOG_CHARACTERCODE wxSymbolPickerDialog::ID_SYMBOLPICKERDIALOG_CHARACTERCODE
%num %rename wxSymbolPickerDialog_ID_SYMBOLPICKERDIALOG_FROM wxSymbolPickerDialog::ID_SYMBOLPICKERDIALOG_FROM

///////////////////////////////////////////////////////////////////////////////
// wxWizard

// Can't use until wxWizardPage is fixed
// %class wxWizard, wxDialog
// %include "wx/wizard.h"

// static wxWizard* Create(wxWindow* parent, int id = -1, const wxString& title = wxEmptyString, const wxBitmap& bitmap = wxNullBitmap, const wxPoint& pos = wxDefaultPosition)
// bool RunWizard(wxWizardPage* firstPage)
// wxWizardPage* GetCurrentPage() const
// wxSize GetPageSize() const
// void SetPageSize(const wxSize& sizePage)

///////////////////////////////////////////////////////////////////////////////
// wxTabbedDialog deprecated; use wxNotebook instead
//

// %class wxTabbedDialog, wxDialog
// %include "wx/wxtab.h"
//
// wxTabbedDialog(wxWindow *parent, wxWindowID id, const wxString& title, const wxPoint& pos, const wxSize& size, long style=wxDEFAULT_DIALOG_STYLE, const wxString& name=wxT("dialogBox"))
// void SetTabView(wxTabView *view)
// wxTabView * GetTabView()

///////////////////////////////////////////////////////////////////////////////
// wxPropertySheetDialog

%include <wx/propdlg.h>

%class wxPropertySheetDialog, wxDialog
wxPropertySheetDialog(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_DIALOG_STYLE, const wxString& name = wxT("dialogBox"))
virtual void AddBookCtrl(wxSizer* sizer)
bool Create(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_DIALOG_STYLE, const wxString& name = wxT("dialogBox"))
virtual wxBookCtrlBase* CreateBookCtrl()
void CreateButtons(int flags=wxOK|wxCANCEL)
wxBookCtrlBase* GetBookCtrl() const
wxSizer*  GetInnerSizer() const
long GetSheetStyle() const
void LayoutDialog(int centreFlags=wxBOTH)
void SetBookCtrl(wxBookCtrlBase* bookCtrl)
//void SetInnerSizer(wxSizer* sizer)
void SetSheetStyle(long style)

///////////////////////////////////////////////////////////////////////////////
// MISCELLANEOUS WINDOWS
///////////////////////////////////////////////////////////////////////////////

// #########################################################
// scrolwin.h

%include <wx/scrolwin.h>

%num wxScrolledWindowStyle

// ==============================
// Class: wxScrollHelper

%class wxScrollHelper
wxScrollHelper(wxWindow *winToScroll)
virtual void SetScrollbars(int pixelsPerUnitX, int pixelsPerUnitY, int noUnitsX, int noUnitsY, int xPos = 0, int yPos = 0, bool noRefresh = false )
virtual void Scroll(int x, int y)
int GetScrollPageSize(int orient) const
void SetScrollPageSize(int orient, int pageSize)
int GetScrollLines( int orient ) const
void SetScrollRate( int xstep, int ystep )
virtual void GetScrollPixelsPerUnit(int *pixelsPerUnitX, int *pixelsPerUnitY) const
virtual void EnableScrolling(bool x_scrolling, bool y_scrolling)
virtual void GetViewStart(int *x, int *y) const
void SetScale(double xs, double ys)
double GetScaleX() const
double GetScaleY() const
//void CalcScrolledPosition(int x, int y, int *xx, int *yy) const
%{
    void wxScrollHelper_CalcScrolledPositionXY()
    {
		int yy;
		int xx;
		int y = wStackPopInteger();
		int x = wStackPopInteger();
		((wxScrollHelper *)(wTheCall->self->ptr))->CalcScrolledPosition(x, y, &xx, &yy);
		wWrapDerefArgs();
        wStackPushInteger( (wInteger)xx );
        wStackPushInteger( (wInteger)yy );
    }
%}
%method CalcScrolledPositionXY  wxScrollHelper_CalcScrolledPositionXY(int x, int y)

wxPoint CalcScrolledPosition(const wxPoint& pt) const
//void CalcUnscrolledPosition(int x, int y, int *xx, int *yy) const
%{
    void wxScrollHelper_CalcUnscrolledPositionXY()
    {
		int yy;
		int xx;
		int y = wStackPopInteger();
		int x = wStackPopInteger();
		((wxScrollHelper *)(wTheCall->self->ptr))->CalcUnscrolledPosition(x, y, &xx, &yy);
		wWrapDerefArgs();
        wStackPushInteger( (wInteger)xx );
        wStackPushInteger( (wInteger)yy );
    }
%}
%method CalcUnscrolledPositionXY  wxScrollHelper_CalcUnscrolledPositionXY(int x, int y)

wxPoint CalcUnscrolledPosition(const wxPoint& pt) const
//virtual void DoCalcScrolledPosition(int x, int y, int *xx, int *yy) const
//virtual void DoCalcUnscrolledPosition(int x, int y, int *xx, int *yy) const
virtual void AdjustScrollbars()
virtual int CalcScrollInc(wxScrollWinEvent& event)
virtual void SetTargetWindow(wxWindow *target)
virtual wxWindow *GetTargetWindow() const
void SetTargetRect(const wxRect& rect)
wxRect GetTargetRect() const
virtual void OnDraw(wxDC& dc)
virtual void DoPrepareDC(wxDC& dc)
bool IsAutoScrolling() const
void StopAutoScrolling()
virtual bool SendAutoScrollEvents(wxScrollWinEvent& event) const
void HandleOnScroll(wxScrollWinEvent& event)
void HandleOnSize(wxSizeEvent& event)
void HandleOnPaint(wxPaintEvent& event)
void HandleOnChar(wxKeyEvent& event)
void HandleOnMouseEnter(wxMouseEvent& event)
void HandleOnMouseLeave(wxMouseEvent& event)
void HandleOnMouseWheel(wxMouseEvent& event)
void OnScroll(wxScrollWinEvent& event)

///////////////////////////////////////////////////////////////////////////////
// wxScrolledWindow

%class wxScrolledWindow, wxPanel
wxScrolledWindow(wxWindow* parent, wxWindowID id = -1, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxHSCROLL | wxVSCROLL, const wxString& name = wxT("scrolledWindow"))
// void CalcScrolledPosition( int x, int y, int *xx, int *yy) const
%{
    void wxScrolledWindow_CalcScrolledPosition()
    {
        int y = wStackPopInteger();
        int x = wStackPopInteger();
        int xx, yy;
        ((wxScrolledWindow *)wTheCall->self->ptr)->CalcScrolledPosition(x, y, &xx, &yy);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)xx );
        wStackPushInteger( (wInteger)yy );
    }
%}
%method CalcScrolledPosition wxScrolledWindow_CalcScrolledPosition( int x, int y )


// void CalcUnscrolledPosition( int x, int y, int *xx, int *yy) const
%{
    void wxScrolledWindow_CalcUnscrolledPosition()
    {
        int y = wStackPopInteger();
        int x = wStackPopInteger();
        int xx, yy;
        ((wxScrolledWindow *)wTheCall->self->ptr)->CalcUnscrolledPosition(x, y, &xx, &yy);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)xx );
        wStackPushInteger( (wInteger)yy );
    }
%}
%method CalcUnscrolledPosition wxScrolledWindow_CalcUnscrolledPosition( int x, int y )


bool Create(wxWindow* parent, wxWindowID id = -1, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxHSCROLL | wxVSCROLL, const wxString& name = wxT("scrolledWindow"))
void EnableScrolling(const bool xScrolling, const bool yScrolling)
// void GetScrollPixelsPerUnit(int* xUnit, int* yUnit) const
%{
    void wxScrolledWindow_GetScrollPixelsPerUnit()
    {
        int xUnit, yUnit;
        ((wxScrolledWindow *)wTheCall->self->ptr)->GetScrollPixelsPerUnit(&xUnit, &yUnit);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)xUnit );
        wStackPushInteger( (wInteger)yUnit );
    }

    void wxScrolledWindow_GetScrollPixelsPerUnitX()
    {
        int xUnit, yUnit;
        ((wxScrolledWindow *)wTheCall->self->ptr)->GetScrollPixelsPerUnit(&xUnit, &yUnit);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)xUnit );
    }

    void wxScrolledWindow_GetScrollPixelsPerUnitY()
    {
        int xUnit, yUnit;
        ((wxScrolledWindow *)wTheCall->self->ptr)->GetScrollPixelsPerUnit(&xUnit, &yUnit);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)yUnit );
    }
%}
%method GetScrollPixelsPerUnit  wxScrolledWindow_GetScrollPixelsPerUnit()
%method GetScrollPixelsPerUnitX wxScrolledWindow_GetScrollPixelsPerUnitX()
%method GetScrollPixelsPerUnitY wxScrolledWindow_GetScrollPixelsPerUnitY()

// void GetVirtualSize(int* x, int* y) const
%{
    void wxScrolledWindow_GetVirtualSize()
    {
        int x, y;
        ((wxScrolledWindow *)wTheCall->self->ptr)->GetVirtualSize(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
    }

    void wxScrolledWindow_GetVirtualSizeX()
    {
        int x, y;
        ((wxScrolledWindow *)wTheCall->self->ptr)->GetVirtualSize(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }

    void wxScrolledWindow_GetVirtualSizeY()
    {
        int x, y;
        ((wxScrolledWindow *)wTheCall->self->ptr)->GetVirtualSize(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }
%}
%method GetVirtualSize      wxScrolledWindow_GetVirtualSize()
%method GetVirtualSizeX     wxScrolledWindow_GetVirtualSizeX()
%method GetVirtualSizeY     wxScrolledWindow_GetVirtualSizeY()

bool IsRetained() const
void PrepareDC(wxDC& dc)
// virtual void OnDraw(wxDC& dc)
void Scroll(int x, int y)
void SetScrollbars(int pixelsPerUnitX, int pixelsPerUnitY, int noUnitsX, int noUnitsY, int xPos = 0, int yPos = 0, bool noRefresh = FALSE)
void SetTargetWindow(wxWindow* window)
//void GetViewStart(int* x, int* y) const
%{
    void wxScrolledWindow_GetViewStart()
    {
        int x, y;
        ((wxScrolledWindow *)wTheCall->self->ptr)->GetViewStart(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
    }

    void wxScrolledWindow_GetViewStartX()
    {
        int x, y;
        ((wxScrolledWindow *)wTheCall->self->ptr)->GetViewStart(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }

    void wxScrolledWindow_GetViewStartY()
    {
        int x, y;
        ((wxScrolledWindow *)wTheCall->self->ptr)->GetViewStart(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }
%}
%method GetViewStart      wxScrolledWindow_GetViewStart()
%method GetViewStartX     wxScrolledWindow_GetViewStartX()
%method GetViewStartY     wxScrolledWindow_GetViewStartY()

void SetScrollRate(int xstep, int ystep)

///////////////////////////////////////////////////////////////////////////////
// wxVScrolledWindow

%include <wx/vscroll.h>

%class wxVScrolledWindow, wxPanel

///////////////////////////////////////////////////////////////////////////////
// wxSplitterWindow

%class wxSplitterWindow, wxWindow
%include "wx/splitter.h"

wxSplitterWindow(wxWindow* parent, wxWindowID id, const wxPoint& point = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style=wxSP_3D, const wxString& name = wxT("splitterWindow"))
%ctor wxSplitterWindowNoCreate()
// Error: int x, id = -1 missing
// bool Create(wxWindow* parent, wxWindowID id, int x, const wxPoint& point = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style=wxSP_3D, const wxString& name = wxT("splitterWindow"))
bool Create(wxWindow *parent, wxWindowID id = -1, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSP_3D|wxCLIP_CHILDREN, const wxString& name = wxT("splitter"))
int GetMinimumPaneSize() const
int GetSashPosition()
int GetSplitMode() const
wxWindow* GetWindow1() const
wxWindow* GetWindow2() const
void Initialize(wxWindow* window)
bool IsSplit() const
// virtual void OnDoubleClickSash(int x, int y)
// virtual void OnUnsplit(wxWindow* removed)
// virtual bool OnSashPositionChange(int newSashPosition)
bool ReplaceWindow(wxWindow * winOld, wxWindow * winNew)
void SetSashPosition(int position, const bool redraw = TRUE)
void SetMinimumPaneSize(int paneSize)
void SetSplitMode(int mode)
bool SplitHorizontally(wxWindow* window1, wxWindow* window2, int sashPosition = 0)
bool SplitVertically(wxWindow* window1, wxWindow* window2, int sashPosition = 0)
bool Unsplit(wxWindow* toRemove = NULL)

double GetSashGravity()
void SetSashGravity(double gravity)
void SetSashSize(int size)
void UpdateSize()

///////////////////////////////////////////////////////////////////////////////
// wxHtmlFilter

%include <wx/html/htmlfilt.h>

%class wxHtmlFilter, wxObject

//Abstract Class
//wxHtmlFilter()
bool CanRead(const wxFSFile& file)
wxString ReadFile(const wxFSFile& file)


///////////////////////////////////////////////////////////////////////////////
// wxHtmlWindow

%class wxHtmlWindow, wxScrolledWindow
%include "wx/html/htmlwin.h"

wxHtmlWindow(wxWindow *parent, wxWindowID id = -1, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxHW_SCROLLBAR_AUTO, const wxString& name = wxT("htmlWindow"))
%ctor wxHtmlWindowNoCreate()
static void AddFilter(wxHtmlFilter *filter)
bool AppendToPage(const wxString& source)
//wxHtmlContainerCell* GetInternalRepresentation() const
wxString GetOpenedAnchor()
wxString GetOpenedPage()
wxString GetOpenedPageTitle()
wxFrame* GetRelatedFrame() const
bool HistoryBack()
bool HistoryCanBack()
bool HistoryCanForward()
void HistoryClear()
bool HistoryForward()
// FIXME: wxFileName not implemented yet
// virtual bool LoadFile(const wxFileName& filename)
virtual bool LoadPage(const wxString& location)
// virtual void OnCellClicked(wxHtmlCell *cell, wxCoord x, wxCoord y, const wxMouseEvent& event)
// virtual void OnCellMouseHover(wxHtmlCell *cell, wxCoord x, wxCoord y)
// virtual void OnLinkClicked(const wxHtmlLinkInfo& link)
// virtual wxHtmlOpeningStatus OnOpeningURL(wxHtmlURLType type,const wxString& url, wxString *redirect)
// virtual void OnSetTitle(const wxString& title)
virtual void ReadCustomization(wxConfigBase *cfg, wxString path = wxEmptyString)
void SetBorders(int b)
void SetFonts(wxString normal_face, wxString fixed_face, const int *sizes = NULL)
bool SetPage(const wxString& source)
void SetRelatedFrame(wxFrame* frame, const wxString& format)
void SetRelatedStatusBar(int bar)
virtual void WriteCustomization(wxConfigBase *cfg, wxString path = wxEmptyString)

void SelectAll()
wxString  SelectionToText()
void SelectLine(const wxPoint& pos)
void SelectWord(const wxPoint& pos)
wxString  ToText()

// wxHtmlURL types
%enum wxHtmlURLType
%num wxHTML_URL_PAGE
%num wxHTML_URL_IMAGE
%num wxHTML_URL_OTHER

// wxHTML_REDIRECT
%num wxHTML_OPEN
%num wxHTML_BLOCK
%num wxHTML_REDIRECT

%builtin %rename wxHtmlWindow_AddFilter void wxHtmlWindow::AddFilter(wxHtmlFilter *filter)

///////////////////////////////////////////////////////////////////////////////
// wxHtmlCell

%include <wx/html/htmlcell.h>
%class wxHtmlCell, wxObject
wxHtmlCell()
//needs wrapper
//virtual bool AdjustPagebreak(int * pagebreak)
// wxHtmlRenderingInfo exists, but not documented
//virtual void Draw(wxDC& dc, int x, int y, int view_y1, int view_y2, wxHtmlRenderingInfo& info)
//virtual void DrawInvisible(wxDC& dc, int x, int y, wxHtmlRenderingInfo& info)
virtual const wxHtmlCell*  Find(int condition, const void* param)
int GetDescent() const
wxHtmlCell*  GetFirstChild()
int GetHeight() const
virtual wxString  GetId() const
virtual wxHtmlLinkInfo*  GetLink(int x = 0, int y = 0) const
// wxHtmlWindowInterface exists, but not documented
//virtual wxCursor  GetMouseCursor(wxHtmlWindowInterface* window)
wxHtmlCell*  GetNext() const
wxHtmlContainerCell*  GetParent() const
int GetPosX() const
int GetPosY() const
int GetWidth() const
virtual void Layout(int w)
//virtual bool ProcessMouseClick(wxHtmlWindowInterface* window, const wxPoint& pos, const wxMouseEvent& event)
void SetId(const wxString& id)
void SetLink(const wxHtmlLinkInfo& link)
void SetNext(wxHtmlCell *cell)
void SetParent(wxHtmlContainerCell *p)
void SetPos(int x, int y)

///////////////////////////////////////////////////////////////////////////////
// wxHtmlTag

%include <wx/html/htmltag.h>
%class wxHtmlTag, wxObject
//will never constructed!
//wxHtmlTag(wxHtmlTag *parent, const wxString& source,  int pos, int end_pos,  wxHtmlTagsCache* cache, wxHtmlEntitiesParser *entParser)
const wxString&  GetAllParams() const
int GetBeginPos() const
int GetEndPos1() const
int GetEndPos2() const
wxString  GetName() const
wxString  GetParam(const wxString& par, bool with_commas = false) const
bool GetParamAsColour(const wxString& par, wxColour *clr) const
bool GetParamAsInt(const wxString& par, int *value) const
bool HasEnding() const
bool HasParam(const wxString& par) const
//wxString  ScanParam(const wxString& par, const wxChar *format, void *value) const

///////////////////////////////////////////////////////////////////////////////
// wxHtmlContainerCell

%include <wx/html/htmlcell.h>
%class wxHtmlContainerCell, wxHtmlCell
wxHtmlContainerCell(wxHtmlContainerCell *parent)
int GetAlignHor() const
int GetAlignVer() const
wxColour  GetBackgroundColour()
int GetIndent(int ind) const
int GetIndentUnits(int ind) const
void InsertCell(wxHtmlCell *cell)
void SetAlign(const wxHtmlTag& tag)
void SetAlignHor(int al)
void SetAlignVer(int al)
void SetBackgroundColour(const wxColour& clr)
void SetBorder(const wxColour& clr1, const wxColour& clr2)
void SetIndent(int i, int what, int units = wxHTML_UNITS_PIXELS)
void SetMinHeight(int h, int align = wxHTML_ALIGN_TOP)
void SetWidthFloat(int w, int units)

///////////////////////////////////////////////////////////////////////////////
// wxHtmlLinkInfo

%include <wx/html/htmlcell.h>
%class wxHtmlLinkInfo, wxObject
%ctor wxHtmlLinkInfoEmpty()
wxHtmlLinkInfo(const wxString& href, const wxString& target = wxEmptyString)
const wxMouseEvent *  GetEvent()
const wxHtmlCell *  GetHtmlCell()
wxString  GetHref()
wxString  GetTarget()

///////////////////////////////////////////////////////////////////////////////
// wxHtmlLinkEvent

%include <wx/html/htmlwin.h>

%class %delete wxHtmlLinkEvent, wxCommandEvent
wxHtmlLinkEvent(int id, const wxHtmlLinkInfo & linkinfo)
const wxHtmlLinkInfo  GetLinkInfo() const

%event wxEVT_COMMAND_HTML_CELL_CLICKED
%event wxEVT_COMMAND_HTML_CELL_HOVER
%event wxEVT_COMMAND_HTML_LINK_CLICKED

///////////////////////////////////////////////////////////////////////////////
// wxHtmlEasyPrinting

%include <wx/html/htmprint.h>
%class wxHtmlEasyPrinting, wxObject
wxHtmlEasyPrinting(const wxString& name = _("Printing"), wxWindow* parentWindow = NULL)
wxWindow*  GetParentWindow() const
wxPrintData*  GetPrintData()
wxPageSetupDialogData*  GetPageSetupData()
bool PreviewFile(const wxString& htmlfile)
bool PreviewText(const wxString& htmltext, const wxString& basepath = wxEmptyString)
bool PrintFile(const wxString& htmlfile)
bool PrintText(const wxString& htmltext, const wxString& basepath = wxEmptyString)
void PageSetup()
%{
// void SetFonts(const wxString& normal_face, const wxString& fixed_face, const int *sizes = NULL)
void wxHtmlEasyPrinting_SetFonts()
{
	wVariant* v = NULL;
	int * data = NULL;
	wGrow *list;

	if(wTheCall->parmCount > 2)
	{
		/* get source object */
		v = wStackPop();
		list = v->value.list;
		/* this array must have exact 7 items! */
		data = MakeIntArray(list);
	}
	wxString fixed_face = wxString(wStackPopChar(), *wxConvCurrent);
	wxString normal_face = wxString(wStackPopChar(), *wxConvCurrent);

	((wxHtmlEasyPrinting *)(wTheCall->self->ptr))->SetFonts(normal_face, fixed_face, data);
	delete data;

	/* deref the object */
	if(v)
		wVariantDeref( v );
	wWrapDerefArgs();
}
%}
%method SetFonts wxHtmlEasyPrinting_SetFonts(const wxString& normal_face, const wxString& fixed_face, const int *sizes = NULL)
void SetStandardFonts(int size = -1, const wxString& normal_face = wxEmptyString, const wxString& fixed_face = wxEmptyString)
void SetHeader(const wxString& header, int pg = wxPAGE_ALL)
void SetFooter(const wxString& footer, int pg = wxPAGE_ALL)
void SetParentWindow(wxWindow* window)

///////////////////////////////////////////////////////////////////////////////
// wxHtmlPrintout

%include <wx/html/htmprint.h>
%class wxHtmlPrintout, wxPrintout
wxHtmlPrintout(const wxString& title = _("Printout"))
static void AddFilter(wxHtmlFilter* filter)

%{
// void SetFonts(const wxString& normal_face, const wxString& fixed_face, const int *sizes = NULL)
void wxHtmlPrintout_SetFonts()
{
	wVariant* v = NULL;
	int * data = NULL;
	wGrow *list;

	if(wTheCall->parmCount > 2)
	{
		/* get source object */
		v = wStackPop();
		list = v->value.list;
		/* this array must have exact 7 items! */
		data = MakeIntArray(list);
	}
	wxString fixed_face = wxString(wStackPopChar(), *wxConvCurrent);
	wxString normal_face = wxString(wStackPopChar(), *wxConvCurrent);

	((wxHtmlEasyPrinting *)(wTheCall->self->ptr))->SetFonts(normal_face, fixed_face, data);
	delete data;

	/* deref the object */
	if(v)
		wVariantDeref( v );
	wWrapDerefArgs();
}
%}
%method SetFonts wxHtmlPrintout_SetFonts(const wxString& normal_face, const wxString& fixed_face, const int *sizes = NULL)

void SetFooter(const wxString& footer, int pg = wxPAGE_ALL)
void SetHeader(const wxString& header, int pg = wxPAGE_ALL)
void SetHtmlFile(const wxString& htmlfile)
void SetHtmlText(const wxString& html, const wxString& basepath = wxEmptyString, bool isdir = true)
void SetMargins(float top = 25.2, float bottom = 25.2, float left = 25.2, float right = 25.2, float spaces = 5)

%builtin %rename wxHtmlPrintout_AddFilter void wxHtmlPrintout::AddFilter(wxHtmlFilter* filter)

///////////////////////////////////////////////////////////////////////////////
// wxHtmlTagHandler

%include <wx/html/htmlpars.h>
%class wxHtmlTagHandler, wxObject
//abstract class
//wxHtmlTagHandler()
virtual wxString  GetSupportedTags()
virtual bool HandleTag(const wxHtmlTag& tag)
//protected
//void ParseInner(const wxHtmlTag& tag)
virtual void SetParser(wxHtmlParser *parser)

///////////////////////////////////////////////////////////////////////////////
// wxHtmlParser

%include <wx/html/htmlpars.h>
%class wxHtmlParser, wxObject
// abstract class
//wxHtmlParser()
//void AddTag(const wxHtmlTag& tag)
virtual void AddTagHandler(wxHtmlTagHandler *handler)
//virtual void AddWord(const char* txt)
void DoParsing(int begin_pos, int end_pos)
virtual void DoneParser()
//wxFileSystem*  GetFS() const
virtual wxObject*  GetProduct()
wxString*  GetSource()
virtual void InitParser(const wxString& source)
virtual wxFSFile*  OpenURL(wxHtmlURLType type, const wxString& url)
wxObject*  Parse(const wxString& source)
void PushTagHandler(wxHtmlTagHandler* handler, const wxString& tags)
void PopTagHandler()
void SetFS(wxFileSystem *fs)
void StopParsing()

// #########################################################
// aboutdlg.h

%include <wx/aboutdlg.h>

// ==============================
// Class: wxAboutDialogInfo

%class %delete wxAboutDialogInfo
wxAboutDialogInfo()
void SetName(const wxString& name)
wxString GetName() const
void SetVersion(const wxString& version)
bool HasVersion() const
wxString GetVersion() const
void SetDescription(const wxString& desc)
bool HasDescription() const
wxString GetDescription() const
void SetCopyright(const wxString& copyright)
bool HasCopyright() const
wxString GetCopyright() const
void SetLicense(const wxString& licence)
bool HasLicence() const
wxString GetLicence() const
void SetIcon(const wxIcon& icon)
bool HasIcon() const
wxIcon GetIcon() const
void SetWebSite(const wxString& url, const wxString& desc = wxEmptyString)
bool HasWebSite() const
wxString GetWebSiteURL() const
wxString GetWebSiteDescription() const
void SetDevelopers(const wxArrayString& developers)
void AddDeveloper(const wxString& developer)
bool HasDevelopers() const
const wxArrayString& GetDevelopers() const
void SetDocWriters(const wxArrayString& docwriters)
void AddDocWriter(const wxString& docwriter)
bool HasDocWriters() const
const wxArrayString& GetDocWriters() const
void SetArtists(const wxArrayString& artists)
void AddArtist(const wxString& artist)
bool HasArtists() const
const wxArrayString& GetArtists() const
void SetTranslators(const wxArrayString& translators)
void AddTranslator(const wxString& translator)
bool HasTranslators() const
const wxArrayString& GetTranslators() const
bool IsSimple() const
wxString GetDescriptionAndCredits() const

%builtin void wxAboutBox(const wxAboutDialogInfo& info)

///////////////////////////////////////////////////////////////////////////////
// CONTROLS
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// wxControl

// #########################################################
// control.h

%include <wx/control.h>

// ==============================
// Class: wxControl: wxControlBase

%class wxControl, wxWindow
%ctor wxControlNoCreate()
wxControl(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxControlNameStr)
//bool Create(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxControlNameStr)
int GetAlignment() const
//static wxString GetLabelText(const wxString& label)
wxString GetLabelText() const
virtual bool ShouldInheritColours() const
virtual void Command(wxCommandEvent &event)
const wxString&  GetLabel() const
virtual void SetLabel( const wxString &label )
virtual bool SetFont(const wxFont& font)
virtual void DoUpdateWindowUI(wxUpdateUIEvent& event)
virtual wxVisualAttributes GetDefaultAttributes() const
static wxVisualAttributes GetClassDefaultAttributes(wxWindowVariant variant = wxWINDOW_VARIANT_NORMAL)
// following belongs to wxFrameBase instead of wxControl
%if(win) bool ProcessCommand(wxCommandEvent& event)
//TODO: wxArrayLong is missing
//const wxArrayLong& GetSubcontrols() const

///////////////////////////////////////////////////////////////////////////////
// wxControlWithItems

%include <wx/ctrlsub.h>

%class wxControlWithItems, wxControl
int Append(const wxString&  item)
void Clear()
void Delete(unsigned int n)
int FindString(const wxString& string, bool caseSensitive = false)
void * GetClientData(unsigned int n) const
wxClientData *  GetClientObject(unsigned int n) const
unsigned int GetCount() const
int GetSelection() const
wxString  GetString(unsigned int n) const
wxArrayString  GetStrings() const
wxString  GetStringSelection() const
int Insert(const wxString&  item, unsigned int pos)
bool IsEmpty() const
//replaced by GetCount
//int Number() const
void Select(int n)
void SetClientData(unsigned int n, void *data)
void SetClientObject(unsigned int n, wxClientData *data)
void SetSelection(int n)
void SetString(unsigned int n, const wxString&  string)
bool SetStringSelection(const wxString&  string)

///////////////////////////////////////////////////////////////////////////////
// wxTextCtrlBase

%class wxTextCtrlBase, wxControl

///////////////////////////////////////////////////////////////////////////////
// wxButton

%class wxButton, wxControl

%ctor wxButtonNoCreate()
wxButton(wxWindow *parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxButtonNameStr)
// Error: missing default validator
// bool Create(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator, const wxString& name = wxT("button"))
bool Create(wxWindow *parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxButtonNameStr)
wxString GetLabel() const
wxSize GetDefaultSize()
void SetDefault()
void SetLabel(const wxString& label)


///////////////////////////////////////////////////////////////////////////////
// wxBitmapButton

%class wxBitmapButton, wxButton

%ctor wxBitmapButtonNoCreate()
wxBitmapButton( wxWindow* parent, wxWindowID id, const wxBitmap& bitmap, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxBU_AUTODRAW, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("button"))
// Error: missing default validator
bool Create(wxWindow* parent, wxWindowID id, const wxBitmap& bitmap, const wxPoint& pos, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("button"))
wxBitmap& GetBitmapDisabled() const
wxBitmap& GetBitmapFocus() const
wxBitmap& GetBitmapLabel() const
wxBitmap& GetBitmapSelected() const
const wxBitmap&  GetBitmapHover()
void SetBitmapDisabled(const wxBitmap& bitmap)
void SetBitmapFocus(const wxBitmap& bitmap)
void SetBitmapLabel(const wxBitmap& bitmap)
void SetBitmapSelected(const wxBitmap& bitmap)
void SetBitmapHover(const wxBitmap& bitmap)

///////////////////////////////////////////////////////////////////////////////
// wxContextHelpButton

%include <wx/cshelp.h>
%class wxContextHelpButton, wxBitmapButton
//wxContextHelpButton()
wxContextHelpButton( wxWindow* parent, wxWindowID id = wxID_CONTEXT_HELP, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxBU_AUTODRAW)

///////////////////////////////////////////////////////////////////////////////
// wxToggleButton

%class wxToggleButton, wxControl
%include <wx/tglbtn.h>
%ctor wxToggleButtonNoCreate()
wxToggleButton(wxWindow *parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxCheckBoxNameStr)
// ~wxToggleButton()
bool Create(wxWindow *parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxCheckBoxNameStr)
bool GetValue() const
void SetValue(const bool state)

///////////////////////////////////////////////////////////////////////////////
// wxAnimation

%include <wx/animate.h>
%class %delete wxAnimation, wxGDIObject

%enum wxAnimationType
  %num wxANIMATION_TYPE_INVALID
  %num wxANIMATION_TYPE_GIF
  %num wxANIMATION_TYPE_ANI
  %num wxANIMATION_TYPE_ANY

wxAnimation()
%ctor wxAnimationCopy(const wxAnimation& anim)
//~wxAnimation()
int GetDelay(unsigned int i) const
unsigned int GetFrameCount() const
wxImage  GetFrame(unsigned int i) const
wxSize  GetSize() const
bool IsOk() const
bool Load(wxInputStream& stream, wxAnimationType type = wxANIMATION_TYPE_ANY)
bool LoadFile(const wxString& name, wxAnimationType type = wxANIMATION_TYPE_ANY)

///////////////////////////////////////////////////////////////////////////////
// wxAnimationCtrl

%include <wx/animate.h>
%num wxAC_DEFAULT_STYLE
%num wxAC_NO_AUTORESIZE
%class wxAnimationCtrl, wxControl
%ctor wxAnimationCtrlNoCreate()
wxAnimationCtrl(wxWindow *parent, wxWindowID id, const wxAnimation& anim, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxAC_DEFAULT_STYLE, const wxString& name = wxT("animationctrl"))
bool Create(wxWindow *parent, wxWindowID id, const wxAnimation& anim, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxAC_DEFAULT_STYLE, const wxString& name = wxT("animationctrl"))
wxAnimation  GetAnimation() const
wxBitmap  GetInactiveBitmap() const
bool IsPlaying() const
bool LoadFile(const wxString & file, wxAnimationType  animType = wxANIMATION_TYPE_ANY)
bool Play()
void SetAnimation(const wxAnimation & anim)
void SetInactiveBitmap(const wxBitmap& bmp)
void Stop()

///////////////////////////////////////////////////////////////////////////////
// wxCalendarCtrl

%include "wx/calctrl.h"

%typedef wxCalendarHitTestResult int

%class wxCalendarCtrl, wxControl

%enum wxCalendarHitTestResult
  %num wxCAL_HITTEST_NOWHERE
  %num wxCAL_HITTEST_HEADER
  %num wxCAL_HITTEST_DAY
  %num wxCAL_HITTEST_INCMONTH
  %num wxCAL_HITTEST_DECMONTH
  %num wxCAL_HITTEST_SURROUNDING_WEEK
%enum wxCalendarDateBorder
  %num wxCAL_BORDER_NONE
  %num wxCAL_BORDER_SQUARE
  %num wxCAL_BORDER_ROUND

%ctor wxCalendarCtrlNoCreate()
wxCalendarCtrl(wxWindow *parent, wxWindowID id, const wxDateTime& date = wxDefaultDateTime, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxCAL_SHOW_HOLIDAYS | wxWANTS_CHARS, const wxString& name = wxCalendarNameStr)
bool Create(wxWindow *parent, wxWindowID id, const wxDateTime& date = wxDefaultDateTime, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxCAL_SHOW_HOLIDAYS | wxWANTS_CHARS, const wxString& name = wxCalendarNameStr)

void SetDate(const wxDateTime& date)
const wxDateTime& GetDate() const
void EnableYearChange(bool enable = true)
void EnableMonthChange(bool enable = true)
void EnableHolidayDisplay(bool display = true)
bool SetLowerDateLimit(const wxDateTime& date = wxDefaultDateTime)
const wxDateTime& GetLowerDateLimit() const
bool SetUpperDateLimit(const wxDateTime& date = wxDefaultDateTime)
const wxDateTime& GetUpperDateLimit() const
bool SetDateRange(const wxDateTime& lowerdate = wxDefaultDateTime, const wxDateTime& upperdate = wxDefaultDateTime)

%alias SetHeaderColors void SetHeaderColours(const wxColour& colFg, const wxColour& colBg)
%alias GetHeaderColorFg const wxColour& GetHeaderColourFg() const
%alias GetHeaderColorBg const wxColour& GetHeaderColourBg() const
%alias SetHighlightColors void SetHighlightColours(const wxColour& colFg, const wxColour& colBg)
%alias GetHighlightColorFg const wxColour& GetHighlightColourFg() const
%alias GetHighlightColorBg const wxColour& GetHighlightColourBg() const
%alias SetHolidayColors void SetHolidayColours(const wxColour& colFg, const wxColour& colBg)
%alias GetHolidayColorFg const wxColour& GetHolidayColourFg() const
%alias GetHolidayColorBg const wxColour& GetHolidayColourBg() const
wxCalendarDateAttr * GetAttr(size_t day) const
void SetAttr(size_t day, wxCalendarDateAttr* attr)
void SetHoliday(size_t day)
void ResetAttr(size_t day)
//void OnSysColourChanged(wxSysColourChangedEvent& event)
wxControl *GetMonthControl() const
wxControl *GetYearControl() const

// Error: ???
// wxCalendarHitTestResult HitTest(const wxPoint& pos, wxDateTime* date = NULL, wxDateTime::WeekDay* wd = NULL)
wxCalendarHitTestResult HitTest(const wxPoint& pos, wxDateTime *date = NULL)

virtual bool Destroy()

%event wxEVT_CALENDAR_SEL_CHANGED
%event wxEVT_CALENDAR_DAY_CHANGED
%event wxEVT_CALENDAR_MONTH_CHANGED
%event wxEVT_CALENDAR_YEAR_CHANGED
%event wxEVT_CALENDAR_DOUBLECLICKED
%event wxEVT_CALENDAR_WEEKDAY_CLICKED

///////////////////////////////////////////////////////////////////////////////
// wxCalendarEvent

%include <wx/calctrl.h>
%class %delete wxCalendarEvent, wxDateEvent
wxDateTime::WeekDay GetWeekDay() const
void SetWeekDay(wxDateTime::WeekDay day)

// #########################################################
// datectrl.h

%include <wx/datectrl.h>

%num wxDP_DEFAULT
%num wxDP_SPIN
%num wxDP_DROPDOWN
%num wxDP_SHOWCENTURY
%num wxDP_ALLOWNONE

// ==============================
// Class: wxDatePickerCtrlBase

%class wxDatePickerCtrlBase, wxControl
virtual void SetValue(const wxDateTime& dt)
virtual wxDateTime GetValue() const
virtual void SetRange(const wxDateTime& dt1, const wxDateTime& dt2)
//TODO: wrapper
virtual bool GetRange(wxDateTime *dt1, wxDateTime *dt2) const

// %num wxHAS_NATIVE_DATEPICKCTRL

// ==============================
// Class: wxDatePickerCtrl

%class wxDatePickerCtrl, wxDatePickerCtrlBase
%ctor wxDatePickerCtrlNoCreate()
wxDatePickerCtrl(wxWindow *parent, wxWindowID id, const wxDateTime& date = wxDefaultDateTime, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDP_DEFAULT | wxDP_SHOWCENTURY, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxDatePickerCtrlNameStr)
bool Create(wxWindow *parent, wxWindowID id, const wxDateTime& date = wxDefaultDateTime, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDP_DEFAULT | wxDP_SHOWCENTURY, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxDatePickerCtrlNameStr)
void SetValue(const wxDateTime& date)
wxDateTime GetValue() const
//TODO: wrapper
bool GetRange(wxDateTime *dt1, wxDateTime *dt2) const
void SetRange(const wxDateTime &dt1, const wxDateTime &dt2)
//TODO: methods not found
//bool SetDateRange(const wxDateTime& lowerdate = wxDefaultDateTime, const wxDateTime& upperdate = wxDefaultDateTime)
//bool SetFormat(const wxChar *fmt)
//wxCalendarCtrl *GetCalendar() const
virtual bool Destroy()

// #########################################################
// dateevt.h

%include <wx/dateevt.h>

// ==============================
// Class: wxDateEvent

%class %delete wxDateEvent, wxCommandEvent
//wxDateEvent()
wxDateEvent(wxWindow *win, const wxDateTime& dt, wxEventType type)
const wxDateTime& GetDate() const
void SetDate(const wxDateTime &date)
%not(bcc) virtual wxEvent *Clone() const

%event wxEVT_DATE_CHANGED

///////////////////////////////////////////////////////////////////////////////
// wxCheckBox

%include <wx/checkbox.h>

%class wxCheckBox, wxControl
%num wxCHK_2STATE
%num wxCHK_3STATE
%num wxCHK_ALLOW_3RD_STATE_FOR_USER

%enum wxCheckBoxState
  %num wxCHK_UNCHECKED
  %num wxCHK_CHECKED
  %num wxCHK_UNDETERMINED

%ctor wxCheckBoxNoCreate()
wxCheckBox(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& val = wxDefaultValidator, const wxString& name = wxT("checkBox"))
bool Create(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& val = wxDefaultValidator, const wxString& name = wxT("checkBox"))
//~wxCheckBox()
wxCheckBoxState Get3StateValue() const
bool Is3rdStateAllowedForUser() const
bool Is3State() const
bool IsChecked() const
void Set3StateValue(const wxCheckBoxState state)

// Error: missing default validator
bool GetValue() const
void SetValue(const bool state)

///////////////////////////////////////////////////////////////////////////////
// wxChoice

%class wxChoice, wxControlWithItems

%ctor wxChoiceNoCreate()
wxChoice(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0, const wxString choices[] = NULL, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxChoiceNameStr)
// wxPython note: The wxChoice constructor in wxPython reduces the n and choices arguments
// are to a single argument, which is a list of strings.
void Append(const wxString& item)
void Clear()
// Error: missing validator
// bool Create(wxWindow *parent, wxWindowID id, const wxPoint& pos, const wxSize& size, int n, const wxString choices[], long style = 0, const wxString& name = wxT("choice"))
bool Create(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0, const wxString choices[] = NULL, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxChoiceNameStr)
int FindString(const wxString& string) const
int GetColumns() const
void* GetClientData(int n) const
int GetSelection() const
wxString GetString(int n) const
wxString GetStringSelection() const
int GetCurrentSelection() const
// FIXME: 2.3.3
// int Number() const
void SetClientData(int n, void* data)
void SetColumns(int n = 1)
void SetSelection(int n)
void SetStringSelection(const wxString& string)

///////////////////////////////////////////////////////////////////////////////
// wxComboBox

%include <wx/combobox.h>

%class wxComboBox, wxChoice

%ctor wxComboBoxNoCreate()
wxComboBox(wxWindow* parent, wxWindowID id, const wxString& value = wxT(""), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0, const wxString choices[] = NULL, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("comboBox"))
// wxPython note: The wxComboBox constructor in wxPython reduces the n and
// choices arguments are to a single argument, which is a list of strings.
void Append(const wxString& item)
void Clear()
// Error: missing default value for n, choices[]
bool Create(wxWindow* parent, wxWindowID id, const wxString& value = wxT(""), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0, const wxString choices[] = NULL, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("comboBox"))
void Copy()
void Cut()
void Delete(int n)
int FindString(const wxString& string)
void* GetClientData(int n) const
long GetInsertionPoint() const
long GetLastPosition() const
int GetSelection() const
wxString GetString(int n) const
wxString GetStringSelection() const
wxString GetValue() const
bool CanCopy() const
bool CanCut() const
bool CanPaste() const
bool CanRedo() const
bool CanUndo() const
int GetCurrentSelection() const
void Redo()
void Undo()
// FIXME: 2.3.2
// int Number() const
void Paste()
void Replace(long from, long to, const wxString& text)
void Remove(long from, long to)
void SetClientData(int n, void* data)
void SetInsertionPoint(long pos)
void SetInsertionPointEnd()
void SetSelection(int n)
%rename SetMark void SetSelection(long from, long to)
void SetValue(const wxString& text)

///////////////////////////////////////////////////////////////////////////////
// wxBitmapComboBox

%include <wx/bmpcbox.h>
%class wxBitmapComboBox, wxComboBox
%ctor wxBitmapComboBoxNoCreate()
wxBitmapComboBox(wxWindow* parent, wxWindowID id, const wxString& value, const wxPoint& pos, const wxSize& size, const wxArrayString& choices, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("comboBox"))
%ctor wxBitmapComboBoxArrayString(wxWindow* parent, wxWindowID id, const wxString& value, const wxPoint& pos, const wxSize& size, const wxArrayString& choices, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("comboBox"))
//~wxBitmapComboBox()
// FIXME: can't handle "const wxString choices[]"
//bool Create(wxWindow* parent, wxWindowID id, const wxString& value = wxT(""), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n, const wxString choices[], long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("comboBox"))
bool Create(wxWindow* parent, wxWindowID id, const wxString& value, const wxPoint& pos, const wxSize& size, const wxArrayString& choices, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("comboBox"))
int Append(const wxString&  item, const wxBitmap& bitmap = wxNullBitmap)
wxSize  GetBitmapSize() const
wxBitmap  GetItemBitmap(unsigned int n) const
int Insert(const wxString&  item, const wxBitmap& bitmap, unsigned int pos)
void SetItemBitmap(unsigned int n, const wxBitmap& bitmap)

///////////////////////////////////////////////////////////////////////////////
// wxComboCtrl

%include <wx/combo.h>

%class wxComboPopup

%class wxComboCtrl, wxControl

%ctor wxComboCtrlNoCreate()
wxComboCtrl(wxWindow* parent, wxWindowID id, const wxString& value = wxT(""), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("comboCtrl"))
// ~wxComboCtrl()
//virtual bool AnimateShow(const wxRect& rect, int flags)
bool Create(wxWindow* parent, wxWindowID id, const wxString& value = wxT(""), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("comboCtrl"))
void Copy()
void Cut()
//void DoSetPopupControl(wxComboPopup* popup)
//virtual void DoShowPopup(const wxRect& rect, int flags)
void EnablePopupAnimation(bool enable = true)
const wxBitmap&  GetBitmapDisabled() const
const wxBitmap&  GetBitmapHover() const
const wxBitmap&  GetBitmapNormal() const
const wxBitmap&  GetBitmapPressed() const
wxSize  GetButtonSize()
int GetCustomPaintWidth() const
static int GetFeatures()
long GetInsertionPoint() const
bool IsPopupWindowState(int state) const
long GetLastPosition() const
wxComboPopup*  GetPopupControl()
wxWindow*  GetPopupWindow() const
wxTextCtrl*  GetTextCtrl() const
wxCoord GetTextIndent() const
const wxRect&  GetTextRect() const
wxString  GetValue() const
void HidePopup()
bool IsPopupShown() const
void OnButtonClick()
void Paste()
void Remove(long from, long to)
void Replace(long from, long to, const wxString& value)
void SetButtonBitmaps(const wxBitmap& bmpNormal, bool pushButtonBg = false, const wxBitmap& bmpPressed = wxNullBitmap, const wxBitmap& bmpHover = wxNullBitmap, const wxBitmap& bmpDisabled = wxNullBitmap)
void SetButtonPosition(int width = -1, int height = -1, int side = wxRIGHT, int spacingX = 0)
void SetCustomPaintWidth(int width)
void SetInsertionPoint(long pos)
void SetInsertionPointEnd()
void SetPopupAnchor(int anchorSide)
void SetPopupControl(wxComboPopup* popup)
void SetPopupExtents(int extLeft, int extRight)
void SetPopupMaxHeight(int height)
void SetPopupMinWidth(int width)
void SetSelection(long from, long to)
void SetText(const wxString& value)
void SetTextIndent(int indent)
void SetValue(const wxString& value)
void SetValueWithEvent(const wxString& value, bool withEvent = true)
void ShowPopup()
void Undo()
void UseAltPopupWindow(bool enable = true)

%event wxCC_SPECIAL_DCLICK
%event wxCC_STD_BUTTON

///////////////////////////////////////////////////////////////////////////////
// wxGauge

%class wxGauge, wxControl

%ctor wxGaugeNoCreate()
wxGauge(wxWindow* parent, wxWindowID id, int range, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxGA_HORIZONTAL, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("gauge"))
bool Create(wxWindow* parent, wxWindowID id, int range, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxGA_HORIZONTAL, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("gauge"))
int GetBezelFace() const
int GetRange() const
int GetShadowWidth() const
int GetValue() const
void SetBezelFace(int width)
void SetRange(int range)
void SetShadowWidth(int width)
void SetValue(int pos)
bool IsVertical() const
void Pulse()

///////////////////////////////////////////////////////////////////////////////
// wxStaticBox

%class wxStaticBox, wxControl

%ctor wxStaticBoxNoCreate()
wxStaticBox(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("staticBox"))
bool Create(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("staticBox"))

///////////////////////////////////////////////////////////////////////////////
// wxStaticLine

%include <wx/statline.h>
%num wxLI_HORIZONTAL
%num wxLI_VERTICAL
%class wxStaticLine, wxControl
%ctor wxStaticLineNoCreate()
wxStaticLine(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxLI_HORIZONTAL, const wxString& name = wxT("staticLine"))
bool Create(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("staticLine"))
bool IsVertical() const
int GetDefaultSize()

///////////////////////////////////////////////////////////////////////////////
// wxListBox

%class wxListBox, wxControlWithItems

%ctor wxListBoxNoCreate()
wxListBox(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0, const wxString choices[] = NULL, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listBox"))
%ctor wxListBoxArrayString(wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, const wxArrayString& choices, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listBox"))
// wxPython note: The wxListBox constructor in wxPython reduces the n and
// choices arguments are to a single argument, which is a list of strings.
void Append(const wxString& item)
void Clear()
// Error: missing default value for n
bool Create(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0, const wxString choices[] = NULL, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listBox"))
void Delete(int n)
void Deselect(int n)
int FindString(const wxString& string)
void* GetClientData(int n) const
int GetCount() const
int GetSelection() const
//TODO: needs wrapper
int GetSelections(wxArrayInt& selections) const
// wxPython note: The wxPython version of this method takes no parameters and
// returns a tuple of the selected items.
wxString GetString(int n) const
wxString GetStringSelection() const
// Fix: Ambiguity between 'wxString::wxString(int)' and 'wxString::wxString(unsigned int)'
// void InsertItems(int nItems, const wxString items, int pos)
// wxPython note: The first two parameters are collapsed into a single parameter
// for wxPython, which is a list of strings.
// Deprecated, use GetCount instead
// int Number() const
//Deprecated!!! FIXME!
bool Selected(int n) const
// FIXME: deprecated?
// void Set(int n, const wxString* choices)
void SetClientData(int n, void* data)
void SetFirstItem(int n)
void SetSelection(int n, const bool select = TRUE)
void SetString(int n, const wxString& string)
void SetStringSelection(const wxString& string, const bool select = TRUE)
int HitTest(const wxPoint& point) const
bool IsSelected(int n) const

///////////////////////////////////////////////////////////////////////////////
// wxCheckListBox

%class wxCheckListBox, wxListBox
%include "wx/checklst.h"

%ctor wxCheckListBoxNoCreate()
wxCheckListBox(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0, const wxString choices[] = NULL, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listBox"))
%ctor wxCheckListBoxArrayString(wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, const wxArrayString& choices, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listBox"))
// wxPython note: The wxCheckListBox constructor in wxPython reduces the n and choices
// arguments are to a single argument, which is a list of strings.
void Check(int item, bool check = TRUE)
bool IsChecked(int item) const


///////////////////////////////////////////////////////////////////////////////
// wxListItem

%class %delete wxListItem, wxObject
%include "wx/listctrl.h"

wxListItem()
void Clear()
wxListColumnFormat GetAlign() const
wxColour GetBackgroundColour() const
int GetColumn() const
long GetData() const
wxFont GetFont() const
long GetId() const
int GetImage() const
long GetMask() const
long GetState() const
const wxString& GetText() const
wxColour GetTextColour() const
int GetWidth() const
void SetAlign(wxListColumnFormat align)
%alias SetBackgroundColor void SetBackgroundColour(const wxColour& colBack)
void SetColumn(int col)
void SetData(long data)
// void SetData(void* data)
void SetFont(const wxFont& font)
void SetId(long id)
void SetImage(int image)
void SetMask(long mask)
void SetState(long state)
void SetStateMask(long stateMask)
void SetText(const wxString& text)
%alias SetTextColor void SetTextColour(const wxColour& colText)
void SetWidth(int width)

%num wxLIST_MASK_STATE
%num wxLIST_MASK_TEXT
%num wxLIST_MASK_IMAGE
%num wxLIST_MASK_DATA
%num wxLIST_MASK_WIDTH
%num wxLIST_MASK_FORMAT

%num wxLIST_FORMAT_LEFT
%num wxLIST_FORMAT_RIGHT
%num wxLIST_FORMAT_CENTRE
%num %alias wxLIST_FORMAT_CENTER

// commented items are win32 only
// %num wxLIST_STATE_DONTCARE
// %num wxLIST_STATE_DROPHILITED
%num wxLIST_STATE_FOCUSED
%num wxLIST_STATE_SELECTED
// %num wxLIST_STATE_CUT


///////////////////////////////////////////////////////////////////////////////
// wxListCtrl

%include "wx/listctrl.h"

%class wxListCtrl, wxControl

wxListCtrl(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxLC_ICON, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listCtrl"))
%ctor wxListCtrlBoxNoCreate()
%ctor wxListCtrlNoCreate()

bool Arrange(int flag = wxLIST_ALIGN_DEFAULT)
void AssignImageList(wxImageList* imageList, int which)
void ClearAll()
bool Create(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxLC_ICON, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listCtrl"))
bool DeleteAllItems()
bool DeleteColumn(int col)
bool DeleteItem(long item)
void EditLabel(long item)
bool EnsureVisible(long item)
long FindItem(long start, const wxString& str, const bool partial = FALSE)
%rename FindItemData long FindItem(long start, long data)
%rename FindItemAtPos long FindItem(long start, const wxPoint& pt, int direction)
%{
	//bool GetColumn(int col, wxListItem& item) const
	void wxListCtrl_GetColumn()
	{
		int col = wStackPopInteger();
		wxListItem* item = (wxListItem*)wStackPopObjectPtr( _wxListItem);
		int b = ((wxListCtrl *)wTheCall->self->ptr)->GetColumn(col, *item);
		wWrapDerefArgs();
		wWrapPushObject( _wxListItem, W_TRUE, (void *)item );
		wStackPushInteger( (wInteger) b );
	}
%}
%method GetColumn wxListCtrl_GetColumn(int col, wxListItem& item) const
int GetColumnCount() const
int GetColumnWidth(int col) const
int GetCountPerPage() const
wxTextCtrl* GetEditControl() const
wxImageList* GetImageList(int which) const
bool GetItem(wxListItem& info) const
// The wxPython version of this method takes an integer parameter for the item ID,
// an optional integer for the column number, and returns the wxListItem object.
int GetItemCount() const
long GetItemData(long item) const
bool GetItemPosition(long item, wxPoint& pos) const

// The wxPython version of this method accepts only the item ID and returns the wxPoint.
// bool GetItemRect(long item, wxRect& rect, int code = wxLIST_RECT_BOUNDS) const
%{
	// bool GetItemRect(long item, wxRect& rect, int code = wxLIST_RECT_BOUNDS) const
    void wxListCtrl_GetItemRect()
    {
        int code = wStackPopInteger();
        long item = wStackPopInteger();

		// TODO: RP 2012-05-13, could be a bug, need = new wxRect ??!?
        wxRect *returns = new wxRect();
        ((wxListCtrl *)wTheCall->self->ptr)->GetItemRect(item,*returns,code);
        wWrapDerefArgs();
        wWrapPushObject( _wxRect, W_TRUE, (void *)returns );
    }
	// bool GetSubItemRect(long item, long subItem, wxRect& rect, int code = wxLIST_RECT_BOUNDS) const
    void wxListCtrl_GetSubItemRect()
    {
	int code = wStackPopInteger();
	long subItem = wStackPopInteger();
	long item = wStackPopInteger();

        wxRect *returns = new wxRect;
#ifdef __WXMSW__
        ((wxListCtrl *)wTheCall->self->ptr)->GetSubItemRect(item,subItem, *returns,code);
#endif
        wWrapDerefArgs();
#ifdef __WXMSW__
        wWrapPushObject( _wxRect, W_TRUE, (void *)returns );
#endif
    }

%}
%method GetItemRect wxListCtrl_GetItemRect(long item, int code)
%method GetSubItemRect wxListCtrl_GetSubItemRect(long item, long subItem, int code = wxLIST_RECT_BOUNDS)

%if(mac) void SetItemSpacing( int spacing, bool isSmall = false )
//int GetItemSpacing(bool isSmall) const
wxSize GetItemSpacing() const
int GetItemState(long item, long stateMask) const
wxString GetItemText(long item) const
// wxString GetStringItem(long index, int col)
%{
void wxListCtrl_GetStringItem() {
	int col = wStackPopInteger();
	long index = wStackPopInteger();
	wxListItem info;
	info.SetMask(wxLIST_MASK_TEXT);
	info.SetId(index);
	info.SetColumn(col);
	((wxListCtrl *)(wTheCall->self->ptr))->GetItem(info);
	wxString returns = info.GetText();
	wWrapDerefArgs();
	wStackPushChar( (char *)(returns.char_str()), W_TRUE );
}
%}
%method GetStringItem wxListCtrl_GetStringItem(long index, int col)
long GetNextItem(long item, int geometry = wxLIST_NEXT_ALL, int state = wxLIST_STATE_DONTCARE) const
int GetSelectedItemCount() const
%alias GetTextColor wxColour GetTextColour() const
long GetTopItem() const
long HitTest(const wxPoint& point, int& flags)
// wxPython note: A tuple of values is returned in the wxPython version of this method.
// The first value is the item id and the second is the flags value mentioned above.
long InsertColumn(long col, wxListItem& info)
%rename InsertColumnInfo long InsertColumn(long col, const wxString& heading, int format = wxLIST_FORMAT_LEFT, int width = -1)
long InsertItem(wxListItem& info)
%rename InsertStringItem long InsertItem(long index, const wxString& label)
%rename InsertImageItem long InsertItem(long index, int imageIndex)
%rename InsertImageStringItem long InsertItem(long index, const wxString& label, int imageIndex)
void RefreshItem(long item)
void RefreshItems(long itemFrom, long itemTo)
bool ScrollList(int dx, int dy)
%alias SetBackgroundColor void SetBackgroundColour(const wxColour& col)
bool SetColumn(int col, wxListItem& item)
bool SetColumnWidth(int col, int width)
void SetImageList(wxImageList* imageList, int which)
bool SetItem(wxListItem& info)
%rename SetStringItem long SetItem(long index, int col, const wxString& label, int imageId = -1)
void SetItemCount(long count)
bool SetItemData(long item, long data)
bool SetItemImage(long item, int image, int selImage)
bool SetItemPosition(long item, const wxPoint& pos)
bool SetItemState(long item, long state, long stateMask)
void SetItemText(long item, const wxString& text)
void SetSingleStyle(long style, const bool add = TRUE)
%alias SetTextColor void SetTextColour(const wxColour& col)
void SetWindowStyleFlag(long style)
// Fix: can't handle callbacks - Incompatible type conversion in function
// bool SortItems(wxListCtrlCompare fnSortCallBack, long data)
// wxPython uses the sortData parameter to pass the Python function to call, so it is not
// available for programmer use. Call SortItems with a reference to a callable object that
// expects two parameters.

wxFont  GetItemFont(long item) const
wxColour  GetItemTextColour(long item) const
wxRect  GetViewRect() const
// Protected, for good reason
//virtual wxListItemAttr *  OnGetItemAttr(long item) const
//virtual int OnGetItemImage(long item) const
//virtual int OnGetItemColumnImage(long item, long column) const
//virtual wxString  OnGetItemText(long item, long column) const
void SetItemBackgroundColour(long item, const wxColour& col)
void SetItemFont(long item, const wxFont& font)
bool SetItemPtrData(long item, wxUIntPtr data)
void SetItemTextColour(long item, const wxColour& col)

%num wxLIST_ALIGN_DEFAULT
%num wxLIST_ALIGN_LEFT
%num wxLIST_ALIGN_TOP
%num wxLIST_ALIGN_SNAP_TO_GRID

%num wxIMAGE_LIST_NORMAL
%num wxIMAGE_LIST_SMALL
%num wxIMAGE_LIST_STATE

%num wxLIST_NEXT_ABOVE
%num wxLIST_NEXT_ALL
%num wxLIST_NEXT_BELOW
%num wxLIST_NEXT_LEFT
%num wxLIST_NEXT_RIGHT

%num wxLIST_HITTEST_ABOVE
%num wxLIST_HITTEST_BELOW
%num wxLIST_HITTEST_NOWHERE
%num wxLIST_HITTEST_ONITEMICON
%num wxLIST_HITTEST_ONITEMLABEL
%num wxLIST_HITTEST_ONITEMRIGHT
%num wxLIST_HITTEST_ONITEMSTATEICON
%num wxLIST_HITTEST_TOLEFT
%num wxLIST_HITTEST_TORIGHT
%num wxLIST_HITTEST_ONITEM

///////////////////////////////////////////////////////////////////////////////
// wxListView

%include <wx/listctrl.h>
%class wxListView, wxListCtrl
%ctor wxListViewNoCreate()
wxListView( wxWindow *parent, wxWindowID winid = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxLC_REPORT, const wxValidator& validator = wxDefaultValidator, const wxString &name = wxListCtrlNameStr)

void ClearColumnImage(int col)
void Focus(long index)
long GetFirstSelected() const
long GetFocusedItem() const
long GetNextSelected(long item) const
bool IsSelected(long index) const
void Select(long n, bool on = true)
void SetColumnImage(int col, int image)

///////////////////////////////////////////////////////////////////////////////
// wxTextAttr

%include <wx/textctrl.h>
%enum  wxTextAttrAlignment
  %num wxTEXT_ALIGNMENT_DEFAULT
  %num wxTEXT_ALIGNMENT_LEFT
  %num wxTEXT_ALIGNMENT_CENTRE
  %num wxTEXT_ALIGNMENT_CENTER
  %num wxTEXT_ALIGNMENT_RIGHT
  %num wxTEXT_ALIGNMENT_JUSTIFIED

%num wxTEXT_ATTR_TEXT_COLOUR
%num wxTEXT_ATTR_BACKGROUND_COLOUR
%num wxTEXT_ATTR_FONT_FACE
%num wxTEXT_ATTR_FONT_SIZE
%num wxTEXT_ATTR_FONT_WEIGHT
%num wxTEXT_ATTR_FONT_ITALIC
%num wxTEXT_ATTR_FONT_UNDERLINE
%num wxTEXT_ATTR_FONT
%num wxTEXT_ATTR_ALIGNMENT
%num wxTEXT_ATTR_LEFT_INDENT
%num wxTEXT_ATTR_RIGHT_INDENT
%num wxTEXT_ATTR_TABS

%class %delete wxTextAttr
%ctor wxTextAttrEmpty()
wxTextAttr(const wxColour& colText, const wxColour& colBack = wxNullColour, const wxFont& font = wxNullFont, wxTextAttrAlignment alignment = wxTEXT_ALIGNMENT_DEFAULT)
wxTextAttrAlignment GetAlignment() const
const wxColour&  GetBackgroundColour() const
const wxFont&  GetFont() const
int GetLeftIndent() const
int GetLeftSubIndent() const
int GetRightIndent() const
const wxArrayInt& GetTabs() const
const wxColour&  GetTextColour() const
bool HasAlignment() const
bool HasBackgroundColour() const
bool HasFont() const
bool HasLeftIndent() const
bool HasRightIndent() const
bool HasTabs() const
bool HasTextColour() const
long GetFlags()
bool IsDefault() const
void Merge(const wxTextAttr& overlay)
void SetAlignment(wxTextAttrAlignment alignment)
void SetBackgroundColour(const wxColour& colour)
void SetFlags(long flags)
void SetFont(const wxFont& font)
void SetLeftIndent(int indent, int subIndent = 0)
void SetRightIndent(int indent)
void SetTabs(const wxArrayInt& tabs)
void SetTextColour(const wxColour& colour)

///////////////////////////////////////////////////////////////////////////////
// wxTextCtrl

%include <wx/textctrl.h>

// %class wxTextCtrl, streambuf
%class wxTextCtrl, wxControl

%typedef wxTextCoord long

%enum  wxTextCtrlHitTestResult
  %num wxTE_HT_UNKNOWN
  %num wxTE_HT_BEFORE
  %num wxTE_HT_ON_TEXT
  %num wxTE_HT_BELOW
  %num wxTE_HT_BEYOND

%ctor wxTextCtrlNoCreate()
wxTextCtrl(wxWindow *parent, wxWindowID id, const wxString& value = wxEmptyString, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxTextCtrlNameStr)

void AppendText(const wxString& text)
virtual bool CanCopy()
virtual bool CanCut()
virtual bool CanPaste()
virtual bool CanRedo()
virtual bool CanUndo()
virtual void Clear()
virtual void Copy()
// Error: missing default validator, pos
bool Create(wxWindow* parent, wxWindowID id, const wxString& value = wxT(""), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("text"))
virtual void Cut()
void DiscardEdits()
virtual long GetInsertionPoint() const
virtual long GetLastPosition() const
int GetLineLength(long lineNo) const
wxString GetLineText(long lineNo) const
int GetNumberOfLines() const
// virtual void GetSelection(long* from, long* to)
%{
    void wxTextCtrl_GetSelection()
    {
        long from, to;
        ((wxTextCtrl *)wTheCall->self->ptr)->GetSelection(&from, &to);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)from );
        wStackPushInteger( (wInteger)to );
    }

    void wxTextCtrl_GetSelectionFrom()
    {
        long from, to;
        ((wxTextCtrl *)wTheCall->self->ptr)->GetSelection(&from, &to);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)from );
    }

    void wxTextCtrl_GetSelectionTo()
    {
        long from, to;
        ((wxTextCtrl *)wTheCall->self->ptr)->GetSelection(&from, &to);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)to );
    }

%}
%method GetSelection        wxTextCtrl_GetSelection()
%method GetSelectionFrom    wxTextCtrl_GetSelectionFrom()
%method GetSelectionTo      wxTextCtrl_GetSelectionTo()

wxString GetValue() const
bool IsModified() const
bool LoadFile(const wxString& filename)
// void OnChar(wxKeyEvent& event)
// void OnDropFiles(wxDropFilesEvent& event)
virtual void Paste()
bool PositionToXY(long pos, long *x, long *y) const
// In Python, PositionToXY() returns a tuple containing the x and y values,
// so (x,y) = PositionToXY() is equivalent to the call described above.
virtual void Redo()
virtual void Remove(long from, long to)
virtual void Replace(long from, long to, const wxString& value)
bool SaveFile(const wxString& filename)
virtual void SetEditable(const bool editable)
virtual void SetInsertionPoint(long pos)
virtual void SetInsertionPointEnd()
virtual void SetSelection(long from, long to)
virtual void SetValue(const wxString& value)
void ShowPosition(long pos)
virtual void Undo()
void WriteText(const wxString& text)
long XYToPosition(long x, long y)

bool EmulateKeyPress(const wxKeyEvent& event)
const wxTextAttr&   GetDefaultStyle() const
virtual wxString  GetRange(long from, long to) const
virtual wxString  GetStringSelection()
bool GetStyle(long position, wxTextAttr& style)
//TODO: wxTextCoords needs wrappers
wxTextCtrlHitTestResult HitTest(const wxPoint& pt, wxTextCoord *col, wxTextCoord *row) const
bool IsEditable() const
bool IsEmpty() const
bool IsMultiLine() const
bool IsSingleLine() const
void MarkDirty()
bool SetDefaultStyle(const wxTextAttr& style)
virtual void SetMaxLength(unsigned long len)
void SetModified(bool modified)
bool SetStyle(long start, long end, const wxTextAttr& style)
virtual void ChangeValue(const wxString&  value)

// wxTextCtrl& operator <<(const wxString& s)
// wxTextCtrl& operator <<(int i)
// wxTextCtrl& operator <<(long i)
// wxTextCtrl& operator <<(float f)
// wxTextCtrl& operator <<(double d)
// wxTextCtrl& operator <<(char c)

%num wxTE_PROCESS_ENTER
%num wxTE_PROCESS_TAB
%num wxTE_MULTILINE
%num wxTE_PASSWORD
%num wxTE_READONLY
%num wxTE_RICH
%num wxTE_RICH2
%num wxTE_AUTO_URL
%num wxTE_NOHIDESEL
%num wxTE_LEFT
%num %alias wxTE_CENTER wxTE_CENTRE
%num wxTE_RIGHT
%num wxTE_DONTWRAP
%num wxTE_LINEWRAP
%num wxTE_WORDWRAP

///////////////////////////////////////////////////////////////////////////////
// wxSearchCtrl

%include <wx/srchctrl.h>
// just smartphones
//%num wxTE_CAPITALIZE
%class wxSearchCtrl, wxTextCtrl
%ctor wxSearchCtrlNoCreate()
wxSearchCtrl(wxWindow* parent, wxWindowID id, const wxString& value = wxT(""), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxSearchCtrlNameStr)
// ~wxSearchCtrl()
virtual void SetMenu(wxMenu*  menu)
virtual wxMenu*  GetMenu()
virtual void ShowSearchButton(bool  show)
virtual bool IsSearchButtonVisible()
virtual void ShowCancelButton(bool  show)
virtual bool IsCancelButtonVisible()

// TODO: Oops?
//%event wxEVT_SEARCHCTRL_SEARCH_BTN
//%event wxEVT_SEARCHCTRL_CANCEL_BTN

///////////////////////////////////////////////////////////////////////////////
// wxTreeItemId

%include <wx/treebase.h>
%class %delete wxTreeItemId
wxTreeItemId()
bool IsOk() const

///////////////////////////////////////////////////////////////////////////////
// wxTreeItemData

%include <wx/treectrl.h>
%class wxTreeItemData, wxClientData
wxTreeItemData()
//void ~wxTreeItemData()
const wxTreeItemId&  GetId()
void SetId(const wxTreeItemId& id)

///////////////////////////////////////////////////////////////////////////////
// wxTreeCtrl

%include "wx/treectrl.h"
%class wxTreeCtrl, wxControl

  %num wxTREE_HITTEST_ABOVE
  %num wxTREE_HITTEST_BELOW
  %num wxTREE_HITTEST_NOWHERE
  %num wxTREE_HITTEST_ONITEMBUTTON
  %num wxTREE_HITTEST_ONITEMICON
  %num wxTREE_HITTEST_ONITEMINDENT
  %num wxTREE_HITTEST_ONITEMLABEL
  %num wxTREE_HITTEST_ONITEMRIGHT
  %num wxTREE_HITTEST_ONITEMSTATEICON
  %num wxTREE_HITTEST_TOLEFT
  %num wxTREE_HITTEST_TORIGHT

%ctor wxTreeCtrlNoCreate()
wxTreeCtrl(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxTR_HAS_BUTTONS, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listCtrl"))
wxTreeItemId AddRoot(const wxString& text, int image = -1, int selImage = -1, wxTreeItemData* data = NULL)
wxTreeItemId AppendItem(const wxTreeItemId& parent, const wxString& text, int image = -1, int selImage = -1, wxTreeItemData* data = NULL)
void Collapse(const wxTreeItemId& item)
void CollapseAndReset(const wxTreeItemId& item)
// Error: should have been Create instead of wxTreeCtrl
// bool wxTreeCtrl(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxTR_HAS_BUTTONS, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listCtrl"))
bool Create(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxTR_HAS_BUTTONS, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listCtrl"))
void Delete(const wxTreeItemId& item)
void DeleteAllItems()
void EditLabel(const wxTreeItemId& item)
// FIX: Missing in GTK
%if(win) void EndEditLabel(const wxTreeItemId& item, bool cancelEdit)
void EnsureVisible(const wxTreeItemId& item)
void Expand(const wxTreeItemId& item)
// FIX: Missing in GTK
%if(win) bool GetBoundingRect(const wxTreeItemId& item, wxRect& rect, bool textOnly = FALSE) const
// The wxPython version of this method requires only the item and textOnly parameters.
// The return value is either a wxRect object or None.
size_t GetChildrenCount(const wxTreeItemId& item, bool recursively = TRUE) const
int GetCount() const
// Fix: Must take address of a memory location
// wxTextCtrl& GetEditControl() const
// wxTreeItemId GetFirstChild(const wxTreeItemId& item, long& cookie) const
// In wxPython the returned wxTreeItemId and the new cookie value are both returned as a
// tuple containing the two values.
%{
    void wxTreeCtrl_GetFirstChild()
    {
    // wxTreeItemIdValue cookie
    wxTreeItemIdValue cookie = (void *) wStackPopInteger();
    // const wxTreeItemId& item
    wxTreeItemId *item = (wxTreeItemId *)wStackPopObjectPtr( _wxTreeItemId);
    wxTreeItemId *returns = new wxTreeItemId(((wxTreeCtrl *)(wTheCall->self->ptr))->GetFirstChild(*item, cookie));
    wWrapDerefArgs();
    wWrapPushObject( _wxTreeItemId, W_TRUE, (void *)returns );
    wStackPushInteger( (wInteger)cookie );
    }
%}
%method GetFirstChild wxTreeCtrl_GetFirstChild(const wxTreeItemId& item, long cookie) const

wxTreeItemId GetFirstVisibleItem() const
wxImageList* GetImageList() const
int GetIndent() const
wxTreeItemData* GetItemData(const wxTreeItemId& item) const
// wxPython provides the following shortcut method:
//        GetPyData(item)  Returns the Python Object associated with
//                the wxTreeItemData for the given item Id.
// Fix: (Warning) Initializing wxTreeItemIcon with double
int GetItemImage(const wxTreeItemId& item, wxTreeItemIcon which = wxTreeItemIcon_Normal) const
wxString GetItemText(const wxTreeItemId& item) const
wxTreeItemId GetLastChild(const wxTreeItemId& item) const

// In wxPython the returned wxTreeItemId and the new cookie value are both returned as
// a tuple containing the two values.
// wxTreeItemId GetNextChild(const wxTreeItemId& item, long& cookie) const
%{
    void wxTreeCtrl_GetNextChild()
    {
    // wxTreeItemIdValue cookie
    wxTreeItemIdValue cookie = (void*) wStackPopInteger();
    // const wxTreeItemId& item
    wxTreeItemId *item = (wxTreeItemId *)wStackPopObjectPtr( _wxTreeItemId);
    // call GetNextChild
    // make a pointer via copy constructor
    wxTreeItemId *returns = new wxTreeItemId(((wxTreeCtrl *)(wTheCall->self->ptr))->GetNextChild(*item, cookie));
    wWrapDerefArgs();
    wWrapPushObject( _wxTreeItemId, W_TRUE, (void *)returns );
    wStackPushInteger( (wInteger) cookie );
    }
%}
%method GetNextChild wxTreeCtrl_GetNextChild(const wxTreeItemId& item, long cookie) const

wxTreeItemId GetNextSibling(const wxTreeItemId& item) const
wxTreeItemId GetNextVisible(const wxTreeItemId& item) const
wxTreeItemId GetItemParent(const wxTreeItemId& item) const
wxTreeItemId GetPrevSibling(const wxTreeItemId& item) const
wxTreeItemId GetPrevVisible(const wxTreeItemId& item) const
wxTreeItemId GetRootItem() const
//int GetItemSelectedImage(const wxTreeItemId& item) const
wxTreeItemId GetSelection() const
//TODO: wrappers
size_t GetSelections(wxArrayTreeItemIds& selection) const
// The wxPython version of this method accepts no parameters and returns a
// Python list of wxTreeItemIds.
wxImageList* GetStateImageList() const
wxTreeItemId HitTest(const wxPoint& point, int& flags)
// in wxPython both the wxTreeItemId and the flags are returned as a tuple.
wxTreeItemId InsertItem(const wxTreeItemId& parent, const wxTreeItemId& previous, const wxString& text, int image = -1, int selImage = -1, wxTreeItemData* data = NULL)
%rename InsertItemBefore wxTreeItemId InsertItem(const wxTreeItemId& parent, size_t before, const wxString& text, int image = -1, int selImage = -1, wxTreeItemData* data = NULL)
bool IsBold(const wxTreeItemId& item) const
bool IsExpanded(const wxTreeItemId& item) const
bool IsSelected(const wxTreeItemId& item) const
bool IsVisible(const wxTreeItemId& item) const
bool ItemHasChildren(const wxTreeItemId& item) const
// int OnCompareItems(const wxTreeItemId& item1, const wxTreeItemId& item2)
wxTreeItemId PrependItem(const wxTreeItemId& parent, const wxString& text, int image = -1, int selImage = -1, wxTreeItemData* data = NULL)
void ScrollTo(const wxTreeItemId& item)
// Fix: Not an allowed type
void SelectItem(const wxTreeItemId& item)
void SetIndent(int indent)
void SetImageList(wxImageList* imageList)
%alias SetItemBackgroundColor void SetItemBackgroundColour(const wxTreeItemId& item, const wxColour& col)
void SetItemBold(const wxTreeItemId& item, bool bold = TRUE)
void SetItemData(const wxTreeItemId& item, wxTreeItemData* data)
// wxPython provides the following shortcut method:
//        SetPyData(item, obj)  Associate the given Python Object with the wxTreeItemData
                for the given item Id.
void SetItemFont(const wxTreeItemId& item, const wxFont& font)
void SetItemHasChildren(const wxTreeItemId& item, bool hasChildren = TRUE)
// Fix: (warning) Initializing wxTreeItemIcon with double
void SetItemImage(const wxTreeItemId& item, int image, wxTreeItemIcon which = wxTreeItemIcon_Normal)
//void SetItemSelectedImage(const wxTreeItemId& item, int selImage)
void SetItemText(const wxTreeItemId& item, const wxString& text)
%alias SetItemTextColor void SetItemTextColour(const wxTreeItemId& item, const wxColour& col)
void SetStateImageList(wxImageList* imageList)
void SortChildren(const wxTreeItemId& item)
void Toggle(const wxTreeItemId& item)
void Unselect()
void UnselectAll()

//documented, but not available?
//void AssignButtonsImageList(wxImageList* imageList)
void AssignImageList(wxImageList* imageList)
void AssignStateImageList(wxImageList* imageList)
void CollapseAll()
void CollapseAllChildren(const wxTreeItemId& item)
void DeleteChildren(const wxTreeItemId& item)
void ExpandAll()
void ExpandAllChildren(const wxTreeItemId& item)
//documented, but...
//wxImageList*  GetButtonsImageList() const
wxColour  GetItemBackgroundColour(const wxTreeItemId& item) const
wxFont  GetItemFont(const wxTreeItemId& item) const
wxColour  GetItemTextColour(const wxTreeItemId& item) const
bool GetQuickBestSize() const
bool IsEmpty() const
//documented, but...
//void SetButtonsImageList(wxImageList* imageList)
void SetItemDropHighlight(const wxTreeItemId& item, bool highlight = true)
void SetQuickBestSize(bool quickBestSize)
void SetWindowStyle(long styles)
void ToggleItemSelection(const wxTreeItemId& item)
void UnselectItem(const wxTreeItemId& item)

///////////////////////////////////////////////////////////////////////////////
// wxScrollBar

%class wxScrollBar, wxControl

%ctor wxScrollBarNoCreate()
wxScrollBar(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSB_HORIZONTAL, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("scrollBar"))
bool Create(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSB_HORIZONTAL, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("scrollBar"))
int GetRange() const
int GetPageSize() const
int GetThumbPosition() const
// Error: 'GetThumbLength' is not a member of 'wxScrollBar'
// int GetThumbLength() const
void SetThumbPosition(int viewStart)
virtual void SetScrollbar(int position, int thumbSize, int range, int pageSize, const bool refresh = TRUE)
int GetThumbSize() const

///////////////////////////////////////////////////////////////////////////////
// wxSpinButton

%class wxSpinButton, wxControl

%ctor wxSpinButtonNoCreate()
wxSpinButton(wxWindow *parent, wxWindowID id = -1, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSP_VERTICAL | wxSP_ARROW_KEYS, const wxString& name = wxT("wxSpinButton"))
bool Create(wxWindow *parent, wxWindowID id = -1, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSP_VERTICAL | wxSP_ARROW_KEYS, const wxString& name = wxT("wxSpinButton"))
int GetMax() const
int GetMin() const
int GetValue() const
void SetRange(int min, int max)
void SetValue(int value)

///////////////////////////////////////////////////////////////////////////////
// wxSpinCtrl

%class wxSpinCtrl, wxControl

%ctor wxSpinCtrlNoCreate()
wxSpinCtrl(wxWindow* parent, wxWindowID id = -1, const wxString& value = wxEmptyString, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSP_ARROW_KEYS, int min = 0, int max = 100, int initial = 0, const wxString& name = wxT("wxSpinCtrl"))
bool Create(wxWindow* parent, wxWindowID id = -1, const wxString& value = wxEmptyString, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSP_ARROW_KEYS, int min = 0, int max = 100, int initial = 0, const wxString& name = wxT("wxSpinCtrl"))
void SetValue(const wxString& text)
int GetValue() const
void SetRange(int minVal, int maxVal)
int GetMin() const
int GetMax() const

void SetSelection(long from, long to)

///////////////////////////////////////////////////////////////////////////////
// wxSpinEvent

%include <wx/spinctrl.h>
%class %delete wxSpinEvent, wxNotifyEvent
wxSpinEvent(wxEventType commandType = wxEVT_NULL, int id = 0)
int GetPosition() const
void SetPosition(int pos)

//defined further down
//%event wxEVT_SCROLL_LINEUP
//%event wxEVT_SCROLL_LINEDOWN
//%event wxEVT_SCROLL_THUMBTRACK

///////////////////////////////////////////////////////////////////////////////
// wxStaticText

%class wxStaticText, wxControl

%ctor wxStaticTextNoCreate()
wxStaticText(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("staticText"))
bool Create(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("staticText"))
wxString GetLabel() const
virtual void SetLabel(const wxString& label)
void Wrap(int width)

///////////////////////////////////////////////////////////////////////////////
// wxStaticBitmap

%include <wx/statbmp.h>

%class wxStaticBitmap, wxControl

%ctor wxStaticBitmapNoCreate()
wxStaticBitmap(wxWindow* parent, wxWindowID id, const wxBitmap& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("staticBitmap"))
bool Create(wxWindow* parent, wxWindowID id, const wxBitmap& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("staticBitmap"))

// Error: (fix) arglist
// wxStaticBitmap(wxWindow* parent, wxWindowID id, const wxBitmap& label = wxT(""), const wxPoint& pos, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("staticBitmap"))
// Error: (fix) arglist
// bool Create(wxWindow* parent, wxWindowID id, const wxBitmap& label = wxT(""), const wxPoint& pos, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("staticBitmap"))
// Fix: Cannot convert 'const wxBitmap *' to 'wxBitmap *'
wxBitmap GetBitmap() const
virtual void SetBitmap(const wxBitmap& label)
wxIcon  GetIcon() const
virtual void SetIcon(const wxIcon&  label)

///////////////////////////////////////////////////////////////////////////////
// wxRadioBox

%class wxRadioBox, wxControl

%ctor wxRadioBoxNoCreate()
wxRadioBox(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& point = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0, const wxString choices[] = NULL, int majorDimension = 0, long style = wxRA_SPECIFY_COLS, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("radioBox"))
bool Create(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& point = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0, const wxString choices[] = NULL, int majorDimension = 0, long style = wxRA_SPECIFY_COLS, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("radioBox"))
void Enable(const bool enable)
%rename EnableItem void Enable(int n, const bool enable)
int FindString(const wxString& string) const
// Error: Too few parameters in call
// wxString GetLabel() const
// FIXME: 2.3.2
// wxString GetLabel(int item) const;

// FIXME: 2.3.2
// %rename GetItemLabel wxString GetLabel(int n) const
int GetSelection() const
wxString GetStringSelection() const
// FIXME: 2.3.2
// int Number() const
// Error: Could not find a match
// void SetLabel(const wxString& label)
// FIXME: 2.3.2
// %rename SetItemLabel void SetLabel(int n, const wxString& label)

void SetSelection(int n)
void SetStringSelection(const wxString& string)
void Show(const bool show)
%rename ShowItem void Show(int item, const bool show)
wxString GetString(int n) const

unsigned int GetColumnCount() const
wxString  GetItemHelpText(unsigned int item) const
wxToolTip *  GetItemToolTip(unsigned int item) const
int GetItemFromPoint(const wxPoint& pt) const
unsigned int GetRowCount() const
bool IsItemEnabled(unsigned int n) const
bool IsItemShown(unsigned int n) const
void SetItemHelpText(unsigned int item, const wxString& helptext)
void SetItemToolTip(unsigned int item, const wxString& text)

///////////////////////////////////////////////////////////////////////////////
// wxRadioButton

%class wxRadioButton, wxControl

%ctor wxRadioButtonNoCreate()
wxRadioButton(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("radioButton"))
bool Create(wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("radioButton"))
bool GetValue() const
void SetValue(const bool value)

///////////////////////////////////////////////////////////////////////////////
// wxSlider

%class wxSlider, wxControl

%ctor wxSliderNoCreate()
wxSlider(wxWindow* parent, wxWindowID id, int value , int minValue, int maxValue, const wxPoint& point = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSL_HORIZONTAL, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("slider"))
void ClearSel()
void ClearTicks()
bool Create(wxWindow* parent, wxWindowID id, int value , int minValue, int maxValue, const wxPoint& point = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSL_HORIZONTAL, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("slider"))
int GetLineSize() const
int GetMax() const
int GetMin() const
int GetPageSize() const
int GetSelEnd() const
int GetSelStart() const
int GetThumbLength() const
int GetTickFreq() const
int GetValue() const
void SetRange(int minValue, int maxValue)
void SetTickFreq(int n, int pos)
void SetLineSize(int lineSize)
void SetPageSize(int pageSize)
void SetSelection(int startPos, int endPos)
void SetThumbLength(int len)
void SetTick(int tickPos)
void SetValue(int value)

///////////////////////////////////////////////////////////////////////////////
// wxCollapsiblePane

%include <wx/collpane.h>
%num wxCP_DEFAULT_STYLE
%class wxCollapsiblePane, wxControl
%ctor wxCollapsiblePaneNoCreate()
wxCollapsiblePane(wxWindow *parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxCP_DEFAULT_STYLE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("collapsiblePane"))
bool Create(wxWindow *parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxCP_DEFAULT_STYLE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("collapsiblePane"))
bool IsCollapsed() const
bool IsExpanded() const
void Collapse(bool collapse = true)
void Expand()
wxWindow *  GetPane() const

%event wxEVT_COMMAND_COLLPANE_CHANGED

///////////////////////////////////////////////////////////////////////////////
// wxCollapsiblePaneEvent

%include <wx/collpane.h>
%class %delete wxCollapsiblePaneEvent, wxCommandEvent
wxCollapsiblePaneEvent(wxObject * generator, int id, bool collapsed)
bool GetCollapsed() const
void SetCollapsed(bool collapsed)

///////////////////////////////////////////////////////////////////////////////
// wxPickerBase

%include <wx/pickerbase.h>
%num wxPB_USE_TEXTCTRL
%class wxPickerBase, wxControl
void SetInternalMargin(int margin)
int GetInternalMargin() const
void SetTextCtrlProportion(int prop)
void SetPickerCtrlProportion(int prop)
int GetTextCtrlProportion() const
int GetPickerCtrlProportion() const
bool HasTextCtrl() const
wxTextCtrl *  GetTextCtrl()
bool IsTextCtrlGrowable() const
void SetPickerCtrlGrowable(bool grow = true)
void SetTextCtrlGrowable(bool grow = true)
bool IsPickerCtrlGrowable() const

///////////////////////////////////////////////////////////////////////////////
// wxColourPickerCtrl

%include <wx/clrpicker.h>
%num wxCLRP_DEFAULT_STYLE
%num wxCLRP_USE_TEXTCTRL
%num wxCLRP_SHOW_LABEL
%class wxColourPickerCtrl, wxPickerBase
%ctor wxColourPickerCtrlNoCreate()
wxColourPickerCtrl(wxWindow *parent, wxWindowID id, const wxColour& colour = *wxBLACK, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxCLRP_DEFAULT_STYLE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("colourpickerctrl"))
bool Create(wxWindow *parent, wxWindowID id, const wxColour& colour = *wxBLACK, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxCLRP_DEFAULT_STYLE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("colourpickerctrl"))
wxColour  GetColour() const
void SetColour(const wxColour &col)

///////////////////////////////////////////////////////////////////////////////
// wxColourPickerEvent

%include <wx/clrpicker.h>
%class %delete wxColourPickerEvent, wxCommandEvent
wxColourPickerEvent(wxObject * generator, int id, const wxColour& colour)
wxColour  GetColour() const
void SetColour(const wxColour &pos)

%event wxEVT_COMMAND_COLOURPICKER_CHANGED

///////////////////////////////////////////////////////////////////////////////
// wxDirPickerCtrl

%include <wx/filepicker.h>
%num wxDIRP_DEFAULT_STYLE
%num wxDIRP_USE_TEXTCTRL
%num wxDIRP_DIR_MUST_EXIST
%num wxDIRP_CHANGE_DIR
%class wxDirPickerCtrl, wxPickerBase
%ctor wxDirPickerCtrlNoCreate()
wxDirPickerCtrl(wxWindow *parent, wxWindowID id, const wxString& path = wxEmptyString, const wxString& message = _("Select a folder"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDIRP_DEFAULT_STYLE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("dirpickerctrl"))
bool Create(wxWindow *parent, wxWindowID id, const wxString& path = wxEmptyString, const wxString& message = _("Select a folder"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDIRP_DEFAULT_STYLE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("dirpickerctrl"))
wxString  GetPath() const
void SetPath(const wxString &dirname)

///////////////////////////////////////////////////////////////////////////////
// wxDataViewRenderer

%if(win) %class wxDataViewRenderer, wxObject
%include <wx/dataview.h>
%enum  wxDataViewCellMode
  %if(win) %num wxDATAVIEW_CELL_INERT
  %if(win) %num wxDATAVIEW_CELL_ACTIVATABLE
  %if(win) %num wxDATAVIEW_CELL_EDITABLE
%enum  wxDataViewCellRenderState
  %if(win) %num wxDATAVIEW_CELL_SELECTED
  %if(win) %num wxDATAVIEW_CELL_PRELIT
  %if(win) %num wxDATAVIEW_CELL_INSENSITIVE
  %if(win) %num wxDATAVIEW_CELL_FOCUSED
//Abstract class
//wxDataViewRenderer(const wxString& varianttype, wxDataViewCellMode mode = wxDATAVIEW_CELL_INERT)
virtual wxDataViewCellMode GetMode()
virtual wxDataViewColumn*  GetOwner()
virtual bool GetValue(wxVariant& value)
virtual wxString  GetVariantType()
virtual void SetOwner(wxDataViewColumn* owner)
virtual bool SetValue(const wxVariant& value)
virtual bool Validate(wxVariant& value)

///////////////////////////////////////////////////////////////////////////////
// wxFilePickerCtrl

%include <wx/filepicker.h>
%num wxFLP_DEFAULT_STYLE
%num wxFLP_USE_TEXTCTRL
%num wxFLP_OPEN
%num wxFLP_SAVE
%num wxFLP_OVERWRITE_PROMPT
%num wxFLP_FILE_MUST_EXIST
%num wxFLP_CHANGE_DIR
%class wxFilePickerCtrl, wxPickerBase
%ctor wxFilePickerCtrlNoCreate()
wxFilePickerCtrl(wxWindow *parent, wxWindowID id, const wxString& path = wxEmptyString, const wxString& message = _("Select a file"), const wxString& wildcard = wxT("*.*"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxFLP_DEFAULT_STYLE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("filepickerctrl"))
bool Create(wxWindow *parent, wxWindowID id, const wxString& path = wxEmptyString, const wxString& message = _("Select a file"), const wxString& wildcard = wxT("*.*"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxFLP_DEFAULT_STYLE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("filepickerctrl"))
wxString  GetPath() const
void SetPath(const wxString &filename)

///////////////////////////////////////////////////////////////////////////////
// wxFileDirPickerEvent

%include <wx/filepicker.h>
%class %delete wxFileDirPickerEvent, wxCommandEvent
wxFileDirPickerEvent(wxEventType type, wxObject * generator, int id, const wxString path)
wxString  GetPath() const
void SetPath(const wxString &path)

%event wxEVT_COMMAND_FILEPICKER_CHANGED
%event wxEVT_COMMAND_DIRPICKER_CHANGED

///////////////////////////////////////////////////////////////////////////////
// wxFontPickerCtrl

%include <wx/fontpicker.h>
%num wxFNTP_DEFAULT_STYLE
%num wxFNTP_USE_TEXTCTRL
%num wxFNTP_FONTDESC_AS_LABEL
%num wxFNTP_USEFONT_FOR_LABEL
%class wxFontPickerCtrl, wxPickerBase
%ctor wxFontPickerCtrlNoCreate()
wxFontPickerCtrl(wxWindow *parent, wxWindowID id, const wxFont& font = wxNullFont, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxFNTP_DEFAULT_STYLE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("fontpickerctrl"))
bool Create(wxWindow *parent, wxWindowID id, const wxFont& font = wxNullFont, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxFNTP_DEFAULT_STYLE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("fontpickerctrl"))
wxFont  GetSelectedFont() const
void SetSelectedFont(const wxFont &font)
unsigned int GetMaxPointSize() const

///////////////////////////////////////////////////////////////////////////////
// wxFontPickerEvent

%include <wx/fontpicker.h>
%class %delete wxFontPickerEvent, wxCommandEvent
wxFontPickerEvent(wxObject * generator, int id, const wxFont& font)
wxFont  GetFont() const
void SetFont(const wxFont & f)

%event wxEVT_COMMAND_FONTPICKER_CHANGED

///////////////////////////////////////////////////////////////////////////////
// wxHyperlinkCtrl

%include <wx/hyperlink.h>
%num wxHL_ALIGN_LEFT
%num wxHL_ALIGN_RIGHT
%num wxHL_ALIGN_CENTRE
%num wxHL_CONTEXTMENU
%num wxHL_DEFAULT_STYLE
%class wxHyperlinkCtrl, wxControl
%ctor wxHyperlinkCtrlNoCreate()
wxHyperlinkCtrl(wxWindow* parent, wxWindowID id, const wxString & label, const wxString & url, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxHL_DEFAULT_STYLE, const wxString& name = wxT("hyperlink"))
bool Create(wxWindow* parent, wxWindowID id, const wxString & label, const wxString & url, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxHL_DEFAULT_STYLE, const wxString& name = wxT("hyperlink"))
wxColour  GetHoverColour() const
void SetHoverColour(const wxColour& colour)
wxColour  GetNormalColour() const
void SetNormalColour(const wxColour& colour)
wxColour  GetVisitedColour() const
void SetVisitedColour(const wxColour& colour)
bool GetVisited() const
void SetVisited(bool visited = true)
wxString  GetURL() const
void SetURL(const wxString& url)

///////////////////////////////////////////////////////////////////////////////
// wxHyperlinkEvent

%include <wx/hyperlink.h>
%class %delete wxHyperlinkEvent, wxCommandEvent
wxHyperlinkEvent(wxObject* generator, int id, const wxString& url)
wxString  GetURL() const
void SetURL(const wxString& url)

%event wxEVT_COMMAND_HYPERLINK

///////////////////////////////////////////////////////////////////////////////
// wxMediaCtrl

%include <wx/mediactrl.h>

%if wxUSE_MEDIACTRL

%class wxMediaCtrl, wxControl
%enum wxMediaState
  %num wxMEDIASTATE_STOPPED
  %num wxMEDIASTATE_PAUSED
  %num wxMEDIASTATE_PLAYING
%enum wxMediaCtrlPlayerControls
  %num wxMEDIACTRLPLAYERCONTROLS_NONE
  %num wxMEDIACTRLPLAYERCONTROLS_STEP
  %num wxMEDIACTRLPLAYERCONTROLS_VOLUME
  %num wxMEDIACTRLPLAYERCONTROLS_DEFAULT

#str wxMEDIABACKEND_DIRECTSHOW
#str wxMEDIABACKEND_MCI
#str wxMEDIABACKEND_QUICKTIME
#str wxMEDIABACKEND_GSTREAMER
#str wxMEDIABACKEND_REALPLAYER
#str wxMEDIABACKEND_WMP10

%ctor wxMediaCtrlNoCreate()
wxMediaCtrl(wxWindow* parent, wxWindowID winid, const wxString& fileName = wxEmptyString, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& szBackend = wxEmptyString, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("mediaCtrl"))
bool Create( wxWindow* parent,  wxWindowID id,  const wxString& fileName = wxT(""), const wxPoint& pos = wxDefaultPosition,  const wxSize& size = wxDefaultSize,  long style = 0,  const wxString& szBackend = wxT(""), const wxValidator& validator = wxDefaultValidator, const wxString& name = wxPanelNameStr )
wxSize  GetBestSize()
//double GetPlaybackrate()
double GetVolume()
wxMediaState GetState()
wxFileOffset Length()
bool Load(const wxString& fileName)
//bool Load(const wxURI& uri)
//bool Load(const wxURI& uri, const wxURI& proxy)
bool LoadURI(const wxString& fileName)
bool LoadURIWithProxy(const wxString& fileName, const wxString& proxy)
bool Pause()
bool Play()
%not(gtk) wxFileOffset Seek(wxFileOffset where, wxSeekMode mode)
bool SetPlaybackRate(double dRate)
bool SetVolume(double dVolume)
bool ShowPlayerControls(wxMediaCtrlPlayerControls flags = wxMEDIACTRLPLAYERCONTROLS_DEFAULT)
bool Stop()
wxFileOffset Tell()

wxFileOffset GetDownloadProgress()
wxFileOffset GetDownloadTotal()

%endif // wxUSE_MEDIACTRL

///////////////////////////////////////////////////////////////////////////////
// wxMediaEvent

%include <wx/mediactrl.h>

%if wxUSE_MEDIACTRL

%class wxMediaEvent, wxNotifyEvent

%event wxEVT_MEDIA_FINISHED
%event wxEVT_MEDIA_STOP
%event wxEVT_MEDIA_LOADED
%event wxEVT_MEDIA_STATECHANGED
%event wxEVT_MEDIA_PLAY
%event wxEVT_MEDIA_PAUSE

%endif // wxUSE_MEDIACTRL

///////////////////////////////////////////////////////////////////////////////
// wxDataViewDateRenderer

%if wxUSE_DATAVIEWCTRL

%include <wx/dataview.h>
%if(win) %class wxDataViewDateRenderer, wxDataViewRenderer
wxDataViewDateRenderer(const wxString& varianttype = wxT("datetime"), wxDataViewCellMode mode = wxDATAVIEW_CELL_ACTIVATABLE)

///////////////////////////////////////////////////////////////////////////////
// wxDataViewBitmapRenderer

%include <wx/dataview.h>
%if(win) %class wxDataViewBitmapRenderer, wxDataViewRenderer
wxDataViewBitmapRenderer(const wxString& varianttype = wxT("wxBitmap"), wxDataViewCellMode mode = wxDATAVIEW_CELL_INERT)

///////////////////////////////////////////////////////////////////////////////
// wxDataViewProgressRenderer

%include <wx/dataview.h>
%if(win) %class wxDataViewProgressRenderer, wxDataViewRenderer
wxDataViewProgressRenderer(const wxString& label = wxEmptyString, const wxString& varianttype = wxT("long"), wxDataViewCellMode mode = wxDATAVIEW_CELL_INERT)

///////////////////////////////////////////////////////////////////////////////
// wxDataViewTextRenderer

%include <wx/dataview.h>
%if(win) %class wxDataViewTextRenderer, wxDataViewRenderer
wxDataViewTextRenderer(const wxString& varianttype = wxT("string"), wxDataViewCellMode mode = wxDATAVIEW_CELL_INERT)

///////////////////////////////////////////////////////////////////////////////
// wxDataViewToggleRenderer

%include <wx/dataview.h>
%if(win) %class wxDataViewToggleRenderer, wxDataViewRenderer
wxDataViewToggleRenderer(const wxString& varianttype = wxT("bool"), wxDataViewCellMode mode = wxDATAVIEW_CELL_INERT)

///////////////////////////////////////////////////////////////////////////////
// wxDataViewListModelNotifier

%include <wx/dataview.h>
%if(win) %class wxDataViewListModelNotifier, wxObject
// Abstract class
//wxDataViewListModelNotifier()
// ~wxDataViewListModelNotifier()
bool Cleared()
wxDataViewListModel*  GetOwner()
bool RowAppended()
bool RowChanged(unsigned int row)
bool RowDeleted(unsigned int row)
bool RowInserted(unsigned int before)
bool RowPrepended()
bool RowsReordered(unsigned int* new_order)
void SetOwner(wxDataViewListModel* owner)
bool ValueChanged(unsigned int col, unsigned int row)

///////////////////////////////////////////////////////////////////////////////
// wxDataViewModel

%include <wx/dataview.h>
%if(win) %class wxDataViewModel, wxObject
wxDataViewModel()
// ~wxDataViewModel()

///////////////////////////////////////////////////////////////////////////////
// wxDataViewListModel

%include <wx/dataview.h>
%if(win) %class wxDataViewListModel, wxDataViewModel
// Abstract class
//wxDataViewListModel()
// ~wxDataViewListModel()
void AddNotifier(wxDataViewListModelNotifier* notifier)
void AddViewingColumn(wxDataViewColumn* view_column, unsigned int model_column)
bool Cleared()
virtual wxString  GetColType(unsigned int col)
virtual unsigned int GetNumberOfCols()
virtual unsigned int GetNumberOfRows()
virtual void GetValue(wxVariant& variant, unsigned int col, unsigned int row)
void RemoveNotifier(wxDataViewListModelNotifier* notifier)
void RemoveViewingColumn(wxDataViewColumn* column)
virtual bool RowAppended()
virtual bool RowChanged(unsigned int row)
virtual bool RowDeleted(unsigned int row)
virtual bool RowInserted(unsigned int before)
virtual bool RowPrepended()
virtual bool RowsReordered(unsigned int* new_order)
virtual bool SetValue(wxVariant& variant, unsigned int col, unsigned int row)
virtual bool ValueChanged(unsigned int col, unsigned int row)

///////////////////////////////////////////////////////////////////////////////
// wxDataViewSortedListModel

%include <wx/dataview.h>
%if(win) %class wxDataViewSortedListModel, wxDataViewListModel
wxDataViewSortedListModel(wxDataViewListModel* child)
// ~wxDataViewSortedListModel()
bool GetAscending()
void Resort()
void SetAscending(bool ascending)

///////////////////////////////////////////////////////////////////////////////
// wxDataViewCtrl

%include <wx/dataview.h>
%if(win) %num wxDV_SINGLE
%if(win) %num wxDV_MULTIPLE
%if(win) %class wxDataViewCtrl, wxControl
%ctor wxDataViewCtrlNoCreate()
wxDataViewCtrl(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator)
// ~wxDataViewCtrl()
virtual bool AppendColumn(wxDataViewColumn* col)
bool AppendBitmapColumn(const wxString& label, unsigned int model_column, wxDataViewCellMode mode = wxDATAVIEW_CELL_INERT, int width = -1)
bool AppendDateColumn(const wxString& label, unsigned int model_column, wxDataViewCellMode mode = wxDATAVIEW_CELL_ACTIVATABLE, int width = -1)
bool AppendProgressColumn(const wxString& label, unsigned int model_column, wxDataViewCellMode mode = wxDATAVIEW_CELL_INERT, int width = 80)
bool AppendTextColumn(const wxString& label, unsigned int model_column, wxDataViewCellMode mode = wxDATAVIEW_CELL_INERT, int width = -1)
bool AppendToggleColumn(const wxString& label, unsigned int model_column, wxDataViewCellMode mode = wxDATAVIEW_CELL_INERT, int width = 30)
virtual bool AssociateModel(wxDataViewListModel* model)
bool Create(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator)
virtual bool ClearColumns()
void ClearSelection()
virtual bool DeleteColumn(unsigned int pos)
virtual wxDataViewColumn*  GetColumn(unsigned int pos)
virtual wxDataViewListModel*  GetModel()
virtual unsigned int GetNumberOfColumns()
virtual int GetSelection() const
virtual int GetSelections(wxArrayInt& aSelections) const
virtual bool IsSelected(unsigned int row) const
virtual void SetSelection(int row)
virtual void SetSelectionRange(unsigned int from, unsigned int to)
virtual void SetSelections(const wxArrayInt& aSelections)
virtual void Unselect(unsigned int row)

///////////////////////////////////////////////////////////////////////////////
// wxDataViewColumn

%include <wx/dataview.h>
%enum  wxDataViewColumnFlags
  %if(win) %num wxDATAVIEW_COL_RESIZABLE
  %if(win) %num wxDATAVIEW_COL_SORTABLE
  %if(win) %num wxDATAVIEW_COL_HIDDEN
%if(win) %class wxDataViewColumn, wxObject
wxDataViewColumn(const wxString& title, wxDataViewRenderer* renderer, unsigned int model_column, int width = 80, int flags = wxDATAVIEW_COL_RESIZABLE)
%ctor wxDataViewColumnBitmap(const wxBitmap& bitmap, wxDataViewRenderer* renderer, unsigned int model_column, int width = 80, int flags = wxDATAVIEW_COL_RESIZABLE)
// ~wxDataViewColumn()
const wxBitmap&  GetBitmap()
unsigned int GetModelColumn()
wxDataViewCtrl*  GetOwner()
wxDataViewRenderer*  GetRenderer()
bool GetSortable()
int GetWidth()
bool IsSortOrderAscending()
void SetAlignment(wxAlignment align)
void SetBitmap(const wxBitmap& bitmap)
void SetSortOrder(bool ascending)
void SetSortable(bool sortable)
void SetTitle(const wxString& title)

///////////////////////////////////////////////////////////////////////////////
// wxDataViewEvent

%include <wx/dataview.h>
%if(win) %class wxDataViewEvent, wxNotifyEvent
wxDataViewEvent(wxEventType commandType = wxEVT_NULL, int winid = 0)
wxEvent*  Clone() const
int GetColumn() const
wxDataViewColumn*  GetDataViewColumn()
wxDataViewModel*  GetModel() const
int GetRow() const
const wxVariant&  GetValue() const
bool IsEditCancelled() const
void SetColumn(int col)
void SetDataViewColumn(wxDataViewColumn* col)
void SetEditCanceled(bool editCancelled)
void SetModel(wxDataViewModel* model)
void SetRow(int row)
void SetValue(const wxVariant& value)

%if(win) %event wxEVT_COMMAND_DATAVIEW_ROW_SELECTED
%if(win) %event wxEVT_COMMAND_DATAVIEW_ROW_ACTIVATED
%if(win) %event wxEVT_COMMAND_DATAVIEW_COLUMN_HEADER_CLICK
%if(win) %event wxEVT_COMMAND_DATAVIEW_COLUMN_HEADER_RIGHT_CLICK
//%event wxEVT_COMMAND_DATAVIEW_END_CELL_EDIT
//%event wxEVT_DATAVIEW_COLUMN_HEADER_CLICKED

%endif //wxUSE_DATAVIEWCTRL

///////////////////////////////////////////////////////////////////////////////
// wxNotebook

%class wxNotebook, wxControl
%include "wx/notebook.h"

%ctor wxNotebookNoCreate()
wxNotebook(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("notebook"))
bool AddPage(wxNotebookPage* page, const wxString& text, bool select = FALSE, int imageId = -1)
void AdvanceSelection(bool forward = TRUE)
// Error: missing default size
bool Create(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("notebook"))
bool DeleteAllPages()
bool DeletePage(int page)
wxImageList* GetImageList() const
wxNotebookPage* GetPage(int page)
int GetPageCount() const
int GetPageImage(int nPage) const
wxString GetPageText(int nPage) const
int GetRowCount() const
int GetSelection() const
bool InsertPage(int index, wxNotebookPage* page, const wxString& text, bool select = FALSE, int imageId = -1)
// void OnSelChange(wxNotebookEvent& event)
bool RemovePage(int page)
void SetImageList(wxImageList* imageList)
void SetPadding(const wxSize& padding)
void SetPageSize(const wxSize& size)
bool SetPageImage(int page, int image)
bool SetPageText(int page, const wxString& text)
int SetSelection(int page)

void AssignImageList(wxImageList* imageList)
wxWindow *  GetCurrentPage() const
wxColour  GetThemeBackgroundColour() const
int HitTest(const wxPoint& pt, long *flags = NULL)
int ChangeSelection(size_t page)

// ==============================
// Class: wxNotebookEvent

%class %delete wxNotebookEvent, wxBookCtrlBaseEvent
wxNotebookEvent(wxEventType commandType = wxEVT_NULL, int winid = 0, int nSel = -1, int nOldSel = -1)
//wxNotebookEvent(const wxNotebookEvent& event)
%not(bcc) virtual wxEvent *Clone() const
int GetOldSelection() const
int GetSelection() const
void SetOldSelection(int page)
void SetSelection(int page)


%event wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGED
%event wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGING

///////////////////////////////////////////////////////////////////////////////
// wxBookCtrlBase

%class wxBookCtrlBase, wxControl

%num wxBK_TOP
%num wxBK_BOTTOM
%num wxBK_LEFT
%num wxBK_RIGHT
%num wxBK_DEFAULT

// overwriteable base class methods
virtual int GetSelection() const
virtual bool SetPageText(size_t n, const wxString& strText)
virtual wxString GetPageText(size_t n) const
virtual int GetPageImage(size_t n) const
virtual bool SetPageImage(size_t n, int imageId)
virtual wxSize CalcSizeFromPage(const wxSize& sizePage) const
virtual bool InsertPage(size_t n, wxWindow *page, const wxString& text, bool bSelect = false, int imageId = -1)
virtual int SetSelection(size_t n)
virtual int ChangeSelection(size_t n)
virtual int HitTest(const wxPoint& pt, long *flags = NULL) const
virtual void SetImageList(wxImageList *imageList)
virtual bool DeleteAllPages();

///////////////////////////////////////////////////////////////////////////////
// wxListbook

%include <wx/listbook.h>
%num wxLB_DEFAULT
%num wxLB_TOP
%num wxLB_LEFT
%num wxLB_RIGHT
%num wxLB_BOTTOM
%class wxListbook, wxBookCtrlBase
%ctor wxListbookNoCreate()
wxListbook(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxEmptyString)

bool Create(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxEmptyString)

bool AddPage( wxWindow* page, const wxString& text, bool bSelect = false, int imageId = wxNOT_FOUND)
bool DeletePage(size_t pagePos)

wxListView* GetListView() const

///////////////////////////////////////////////////////////////////////////////
// wxToolbook

%include <wx/toolbook.h>
//%class wxToolbook, wxBookCtrlBase
%class wxToolbook, wxControl
%ctor wxToolbookNoCreate()
wxToolbook(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("notebook"))

bool Create(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxEmptyString)

bool AddPage( wxWindow* page, const wxString& text, bool bSelect = false, int imageId = wxNOT_FOUND)
bool DeletePage(size_t pagePos)

///////////////////////////////////////////////////////////////////////////////
// wxChoicebook

%include <wx/choicebk.h>
%num wxCHB_DEFAULT
%num wxCHB_TOP
%num wxCHB_LEFT
%num wxCHB_RIGHT
%num wxCHB_BOTTOM
%class wxChoicebook, wxBookCtrlBase
%ctor wxChoicebookNoCreate()

bool Create(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxEmptyString)

bool AddPage( wxWindow* page, const wxString& text, bool bSelect = false, int imageId = wxNOT_FOUND)
bool DeletePage(size_t pagePos)

///////////////////////////////////////////////////////////////////////////////
// wxTreebook

%include <wx/treebook.h>
%class wxTreebook, wxBookCtrlBase
%ctor wxTreebookNoCreate()
wxTreebook( wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxBK_DEFAULT, const wxString& name = wxEmptyString)
// ~wxTreebook()
bool AddPage( wxWindow* page, const wxString& text, bool bSelect = false, int imageId = wxNOT_FOUND)
bool AddSubPage(wxWindow* page, const wxString& text, bool bSelect = false, int imageId = wxNOT_FOUND)
void AssignImageList(wxImageList* imageList)
int ChangeSelection(size_t page)
bool CollapseNode(size_t pageId)
bool Create(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxBK_DEFAULT, const wxString& name = wxEmptyString)
bool DeleteAllPages()
bool DeletePage(size_t pagePos)
bool ExpandNode(size_t pageId, bool expand = true)
int GetPageImage(size_t n) const
int GetPageParent(size_t page) const
wxString  GetPageText(size_t n) const
int GetSelection() const
bool InsertPage(size_t pagePos, wxWindow* page, const wxString& text, bool bSelect = false, int imageId = wxNOT_FOUND)
bool InsertSubPage(size_t pagePos, wxWindow* page, const wxString& text, bool bSelect = false, int imageId = wxNOT_FOUND)
bool IsNodeExpanded(size_t pageId) const
void SetImageList(wxImageList* imageList)
bool SetPageImage(size_t page, int imageId)
bool SetPageText(size_t page, const wxString& text)
int SetSelection(size_t n)

///////////////////////////////////////////////////////////////////////////////
// wxTreebookEvent

%include <wx/treebook.h>
%class wxTreebookEvent, wxBookCtrlBaseEvent
wxTreebookEvent(wxEventType commandType = wxEVT_NULL, int id = 0, int nSel = wxNOT_FOUND, int nOldSel = wxNOT_FOUND)
int GetOldSelection() const
int GetSelection() const

%event wxEVT_COMMAND_TREEBOOK_PAGE_CHANGED
%event wxEVT_COMMAND_TREEBOOK_PAGE_CHANGING
%event wxEVT_COMMAND_TREEBOOK_NODE_COLLAPSED
%event wxEVT_COMMAND_TREEBOOK_NODE_EXPANDED

///////////////////////////////////////////////////////////////////////////////
// wxWizardPage


// Fix: class must have virtual functions defined before using
// %class wxWizardPage, wxPanel

// wxWizardPage(wxWizard* parent, const wxBitmap& bitmap = wxNullBitmap)
// wxWizardPage* GetPrev() const
// wxWizardPage* GetNext() const
// wxBitmap GetBitmap() const


///////////////////////////////////////////////////////////////////////////////
// wxWizardPageSimple

// Can't use until wxWizardPage is fixed
// %class wxWizardPageSimple, wxWizardPage

// wxWizardPageSimple(wxWizard* parent = NULL, wxWizardPage* prev = NULL, wxWizardPage* next = NULL)
// void SetPrev(wxWizardPage* prev)
// void SetNext(wxWizardPage* next)
// static void Chain(wxWizardPageSimple* first, wxWizardPageSimple* second)


///////////////////////////////////////////////////////////////////////////////
// WINDOWS DECORATION
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// wxTaskBar

%include <wx/taskbar.h>

// ==============================
// Class: wxTaskBarIcon

%class %delete wxTaskBarIcon, wxEvtHandler
wxTaskBarIcon()
bool IsOk() const
bool IsIconInstalled() const
bool SetIcon(const wxIcon& icon, const wxString& tooltip = wxEmptyString)
bool RemoveIcon()
bool PopupMenu(wxMenu *menu)

// ==============================
// Class: wxTaskBarIconEvent

%class %delete wxTaskBarIconEvent, wxEvent
wxTaskBarIconEvent(wxEventType evtType, wxTaskBarIcon *tbIcon)
%not(bcc) virtual wxEvent *Clone() const

%event wxEVT_TASKBAR_MOVE
%event wxEVT_TASKBAR_LEFT_DOWN
%event wxEVT_TASKBAR_LEFT_UP
%event wxEVT_TASKBAR_RIGHT_DOWN
%event wxEVT_TASKBAR_RIGHT_UP
%event wxEVT_TASKBAR_LEFT_DCLICK
%event wxEVT_TASKBAR_RIGHT_DCLICK
%event wxEVT_TASKBAR_CLICK

///////////////////////////////////////////////////////////////////////////////
// wxToolBar

// #########################################################
// tbarbase.h

%include <wx/tbarbase.h>

%enum wxToolBarToolStyle
  %num wxTOOL_STYLE_BUTTON
  %num wxTOOL_STYLE_SEPARATOR
  %num wxTOOL_STYLE_CONTROL

// ==============================
// Class: wxToolBarToolBase

%class wxToolBarToolBase, wxObject
wxToolBarToolBase(wxToolBarBase *tbar = NULL, int toolid = wxID_SEPARATOR, const wxString& label = wxEmptyString, const wxBitmap& bmpNormal = wxNullBitmap, const wxBitmap& bmpDisabled = wxNullBitmap, wxItemKind kind = wxITEM_NORMAL, wxObject *clientData = (wxObject *) NULL, const wxString& shortHelpString = wxEmptyString, const wxString& longHelpString = wxEmptyString)
%ctor wxToolBarToolBaseControl(wxToolBarBase *tbar, wxControl *control)
int GetId() const
wxControl *GetControl() const
wxToolBarBase *GetToolBar() const
bool IsButton() const
bool IsControl() const
bool IsSeparator() const
int GetStyle() const
wxItemKind GetKind() const
bool IsEnabled() const
bool IsToggled() const
bool CanBeToggled() const
const wxBitmap& GetNormalBitmap() const
const wxBitmap& GetDisabledBitmap() const
const wxBitmap& GetBitmap() const
const wxString& GetLabel() const
const wxString& GetShortHelp() const
const wxString& GetLongHelp() const
wxObject *GetClientData() const
bool Enable(bool enable)
bool Toggle(bool toggle)
bool SetToggle(bool toggle)
bool SetShortHelp(const wxString& help)
bool SetLongHelp(const wxString& help)
//void Toggle()
void SetNormalBitmap(const wxBitmap& bmp)
void SetDisabledBitmap(const wxBitmap& bmp)
virtual void SetLabel(const wxString& label)
void SetClientData(wxObject *clientData)
virtual void Detach()
virtual void Attach(wxToolBarBase *tbar)

// ==============================
// Class: wxToolBarBase

%class wxToolBarBase, wxControl
//abstract Class
//wxToolBarBase()
wxToolBarToolBase *AddTool(int toolid, const wxString& label, const wxBitmap& bitmap, const wxBitmap& bmpDisabled = wxNullBitmap, wxItemKind kind = wxITEM_NORMAL, const wxString& shortHelp = wxEmptyString, const wxString& longHelp = wxEmptyString, wxObject *data = NULL)
//wxToolBarToolBase *AddTool(int toolid, const wxString& label, const wxBitmap& bitmap, const wxString& shortHelp = wxEmptyString, wxItemKind kind = wxITEM_NORMAL)
//wxToolBarToolBase *AddTool(int toolid, const wxBitmap& bitmap, const wxBitmap& bmpDisabled, bool toggle = false, wxObject *clientData = NULL, const wxString& shortHelpString = wxEmptyString, const wxString& longHelpString = wxEmptyString)
//wxToolBarToolBase *AddTool(int toolid, const wxBitmap& bitmap, const wxString& shortHelpString = wxEmptyString, const wxString& longHelpString = wxEmptyString)
//wxToolBarToolBase *AddTool(int toolid, const wxBitmap& bitmap, const wxBitmap& bmpDisabled, bool toggle, wxCoord xPos, wxCoord yPos = wxDefaultCoord, wxObject *clientData = NULL, const wxString& shortHelp = wxEmptyString, const wxString& longHelp = wxEmptyString)
//wxToolBarToolBase *InsertTool(size_t pos, int toolid, const wxBitmap& bitmap, const wxBitmap& bmpDisabled = wxNullBitmap, bool toggle = false, wxObject *clientData = NULL, const wxString& shortHelp = wxEmptyString, const wxString& longHelp = wxEmptyString)
wxToolBarToolBase *AddCheckTool(int toolid, const wxString& label, const wxBitmap& bitmap, const wxBitmap& bmpDisabled = wxNullBitmap, const wxString& shortHelp = wxEmptyString, const wxString& longHelp = wxEmptyString, wxObject *data = NULL)
wxToolBarToolBase *AddRadioTool(int toolid, const wxString& label, const wxBitmap& bitmap, const wxBitmap& bmpDisabled = wxNullBitmap, const wxString& shortHelp = wxEmptyString, const wxString& longHelp = wxEmptyString, wxObject *data = NULL)
virtual wxToolBarToolBase *InsertTool(size_t pos, int toolid, const wxString& label, const wxBitmap& bitmap, const wxBitmap& bmpDisabled = wxNullBitmap, wxItemKind kind = wxITEM_NORMAL, const wxString& shortHelp = wxEmptyString, const wxString& longHelp = wxEmptyString, wxObject *clientData = NULL)
//virtual wxToolBarToolBase *AddTool (wxToolBarToolBase *tool)
//virtual wxToolBarToolBase *InsertTool (size_t pos, wxToolBarToolBase *tool)
virtual wxToolBarToolBase *AddControl(wxControl *control)
virtual wxToolBarToolBase *InsertControl(size_t pos, wxControl *control)
virtual wxControl *FindControl( int toolid )
virtual wxToolBarToolBase *AddSeparator()
virtual wxToolBarToolBase *InsertSeparator(size_t pos)
virtual wxToolBarToolBase *RemoveTool(int toolid)
virtual bool DeleteToolByPos(size_t pos)
virtual bool DeleteTool(int toolid)
virtual void ClearTools()
virtual bool Realize()
virtual void EnableTool(int toolid, bool enable)
virtual void ToggleTool(int toolid, bool toggle)
virtual void SetToggle(int toolid, bool toggle)
virtual wxObject *GetToolClientData(int toolid) const
virtual void SetToolClientData(int toolid, wxObject *clientData)
virtual int GetToolPos(int id) const
virtual bool GetToolState(int toolid) const
virtual bool GetToolEnabled(int toolid) const
virtual void SetToolShortHelp(int toolid, const wxString& helpString)
virtual wxString GetToolShortHelp(int toolid) const
virtual void SetToolLongHelp(int toolid, const wxString& helpString)
virtual wxString GetToolLongHelp(int toolid) const
%rename SetMarginsXY virtual void SetMargins(int x, int y)
void SetMargins(const wxSize& size)
virtual void SetToolPacking(int packing)
virtual void SetToolSeparation(int separation)
virtual wxSize GetToolMargins() const
virtual int GetToolPacking() const
virtual int GetToolSeparation() const
virtual void SetRows(int nRows)
void SetMaxRowsCols(int rows, int cols)
int GetMaxRows() const
int GetMaxCols() const
virtual void SetToolBitmapSize(const wxSize& size)
virtual wxSize GetToolBitmapSize() const
virtual wxSize GetToolSize() const
virtual wxToolBarToolBase *FindToolForPosition(wxCoord x, wxCoord y) const
wxToolBarToolBase *FindById(int toolid) const
bool IsVertical() const
//virtual bool OnLeftClick(int toolid, bool toggleDown)
//virtual void OnRightClick(int toolid, long x, long y)
//virtual void OnMouseEnter(int toolid)
wxSize GetMargins() const
size_t GetToolsCount() const
virtual void UpdateWindowUI(long flags = wxUPDATE_UI_NONE)
virtual bool AcceptsFocus() const

// ==============================
// Class: wxToolBar

%class wxToolBar, wxToolBarBase
//wxToolBar()
%ctor wxToolBarNoCreate()
wxToolBar(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxNO_BORDER | wxTB_HORIZONTAL, const wxString& name = wxToolBarNameStr)
bool Create(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxNO_BORDER | wxTB_HORIZONTAL, const wxString& name = wxToolBarNameStr)
virtual wxToolBarToolBase *FindToolForPosition(wxCoord x, wxCoord y) const
virtual bool Realize()
virtual void SetToolBitmapSize(const wxSize& size)
virtual wxSize GetToolSize() const
virtual void SetRows(int nRows)
void SetToolNormalBitmap(int id, const wxBitmap& bitmap)
void SetToolDisabledBitmap(int id, const wxBitmap& bitmap)
virtual void SetWindowStyleFlag(long style)
//virtual bool MSWCommand(WXUINT param, WXWORD id)
//virtual bool MSWOnNotify(int idCtrl, WXLPARAM lParam, WXLPARAM *result)
//void OnMouseEvent(wxMouseEvent& event)
//void OnSysColourChanged(wxSysColourChangedEvent& event)
//void OnEraseBackground(wxEraseEvent& event)
void SetFocus()
//static WXHBITMAP MapBitmap(WXHBITMAP bitmap, int width, int height)
//virtual WXLRESULT MSWWindowProc(WXUINT nMsg, WXWPARAM wParam, WXLPARAM lParam)
//virtual WXDWORD MSWGetStyle(long style, WXDWORD *exstyle) const
%if(win) void SetMargins(const wxSize& size)

///////////////////////////////////////////////////////////////////////////////
// wxStatusBar

%class wxStatusBar, wxWindow
// FIXME: 2.3.2
// wxStatusBar(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("statusBar"))
// Error: wrong set of args
// bool Create(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxT("statusBar"))
bool Create(wxWindow *parent, wxWindowID id, long style, const wxString& name = wxPanelNameStr)
virtual bool GetFieldRect(int i, wxRect& rect) const
int GetFieldsCount() const
virtual wxString GetStatusText(int ir = 0) const
// Error: not a member
// virtual void DrawField(wxDC& dc, int i)
// Error: not a member
// virtual void DrawFieldText(wxDC& dc, int i)
// Fix: 'InitColours' is not a member of 'wxStatusBar'
// %alias InitColors virtual void InitColours()
// %alias OnSysColorChanged void OnSysColourChanged(wxSysColourChangedEvent& event)
// TODO: needs wrapper
// virtual void SetFieldsCount(int number = 1, int* widths = NULL)
// wxPython note: Only the first parameter is accepted.
// Use SetStatusWidths to set the widths of the fields.
void SetMinHeight(int height)
virtual void SetStatusText(const wxString& text, int i = 0)

%{
// virtual void SetStatusWidths(int n, int *widths)
void wxStatusBar_SetStatusWidths()
{
	wVariant* v;
	int * data = NULL;
	wGrow *list;

	/* get source object */
	v = wStackPop();
	list = v->value.list;

	data = MakeIntArray(list);
	if(data)
	{
		((wxStatusBar *)(wTheCall->self->ptr))->SetStatusWidths(list->count, data);
		delete data;
	}
	/* deref the object */
	wVariantDeref( v );
	wWrapDerefArgs();
}
%}
%method SetStatusWidths wxStatusBar_SetStatusWidths(int* widths)

// wxPython note: Only a single parameter is required, a Python list of integers.

void PopStatusText(int field = 0)
void PushStatusText(const wxString& string, int field = 0)
virtual void SetStatusStyles(int n, int *styles)

///////////////////////////////////////////////////////////////////////////////
// COMMON DIALOGS
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
// wxColourDialog

%class wxColourDialog, wxDialog
%include "wx/colordlg.h"

%ctor wxColourDialogNoCreate()
%ctor wxColorNoCreate()
wxColourDialog(wxWindow* parent, wxColourData* data = NULL)
%ctor wxColorDialog(wxWindow* parent, wxColourData* data = NULL)
bool Create(wxWindow* parent, wxColourData* data = NULL)
%alias GetColorData wxColourData& GetColourData()
int ShowModal()


///////////////////////////////////////////////////////////////////////////////
// wxFileDialog

%include "wx/filedlg.h"

%class wxFileDialog, wxDialog

%num wxFD_DEFAULT_STYLE
%num wxFD_OPEN
%num wxFD_SAVE
%num wxFD_OVERWRITE_PROMPT
%num wxFD_FILE_MUST_EXIST
%num wxFD_MULTIPLE
%num wxFD_CHANGE_DIR
%num wxFD_PREVIEW

wxFileDialog(wxWindow* parent, const wxString& message = _("Choose a file"), const wxString& defaultDir = wxT(""), const wxString& defaultFile = wxT(""), const wxString& wildcard = wxT("*.*"), long style = 0, const wxPoint& pos = wxDefaultPosition)
// constants for style:
// wxOPEN  This is an open dialog.
// wxSAVE  This is a save dialog.
// wxHIDE_READONLY  Hide read-only files.
// wxOVERWRITE_PROMPT  Prompt for a conformation if a file will be overridden.
// wxMULTIPLE  For open dialog only: allows selecting multiple files

wxString GetDirectory() const
wxString GetFilename() const
%{
	// void GetFilenames(wxArrayString& filenames) const
	// wxString GetFilename() const
	void wxFileDialog_GetFilenames() {
		// make a pointer via copy constructor
		wxArrayString *returns = new wxArrayString();
		((wxFileDialog *)(wTheCall->self->ptr))->GetFilenames(*returns);
		wWrapPushObject( _wxArrayString, W_TRUE, (void *)returns );
	}

	// void GetPaths(wxArrayString& paths) const
	void wxFileDialog_GetPaths() {
		// make a pointer via copy constructor
		wxArrayString *returns = new wxArrayString();
		((wxFileDialog *)(wTheCall->self->ptr))->GetPaths(*returns);
		wWrapPushObject( _wxArrayString, W_TRUE, (void *)returns );
	}
%}
%method GetFilenames wxFileDialog_GetFilenames()
%method GetPaths wxFileDialog_GetPaths()
int GetFilterIndex() const
wxString GetMessage() const
wxString GetPath() const
long GetStyle() const
wxString GetWildcard() const
void SetDirectory(const wxString& directory)
void SetFilename(const wxString& setfilename)
// Windows only
// void SetFilterIndex(int filterIndex)
void SetMessage(const wxString& message)
void SetPath(const wxString& path)
void SetStyle(long style)
void SetWildcard(const wxString& wildCard)
// Example: "BMP files (*.bmp)|*.bmp|GIF files (*.gif)|*.gif"
int ShowModal()
// returning wxID_OK if the user pressed OK, and wxID_CANCEL otherwise.

%num wxOPEN
%num wxSAVE
%num wxOVERWRITE_PROMPT
//%num wxHIDE_READONLY
%num wxFILE_MUST_EXIST
%num wxMULTIPLE
%num wxCHANGE_DIR


///////////////////////////////////////////////////////////////////////////////
// wxDirDialog

%class wxDirDialog, wxDialog

%num wxDD_DEFAULT_STYLE
%num wxDD_DIR_MUST_EXIST
%num wxDD_CHANGE_DIR

wxDirDialog(wxWindow* parent, const wxString& message = _("Choose a directory"), const wxString& defaultPath = wxT(""), long style = 0, const wxPoint& pos = wxDefaultPosition)
wxString GetPath() const
wxString GetMessage() const
long GetStyle() const
void SetMessage(const wxString& message)
void SetPath(const wxString& path)
void SetStyle(long style)
int ShowModal()


///////////////////////////////////////////////////////////////////////////////
// wxMultipleChoiceDialog
// TODO
// NOTE: this class is not yet implemented.

// %class wxMultipleChoiceDialog, wxDialog


///////////////////////////////////////////////////////////////////////////////
// wxSingleChoiceDialog

%class wxSingleChoiceDialog, wxDialog

// Error: can't handle ** yet
// wxSingleChoiceDialog(wxWindow* parent, const wxString& message, const wxString& caption, int n, const wxString* choices, void** clientData = NULL, long style = wxOK | wxCANCEL | wxCENTRE, const wxPoint& pos = wxDefaultPosition)
// For Python the two parametes n and choices are collapsed into a single
// parameter choices which is expected to be a Python list of strings.
wxSingleChoiceDialog(wxWindow *parent, const wxString& message, const wxString& caption, const wxArrayString& choices)
%ctor wxSingleChoiceDialogArrayString(wxWindow *parent, const wxString& message, const wxString& caption, const wxArrayString& choices)
//, void** clientData = NULL, long style = wxCHOICEDLG_STYLE, const wxPoint& pos = wxDefaultPosition)
int GetSelection() const
char* GetSelectionClientData() const
wxString GetStringSelection() const
void SetSelection(int selection) const
int ShowModal()

///////////////////////////////////////////////////////////////////////////////
// wxTextEntryDialog

%class wxTextEntryDialog, wxDialog

wxTextEntryDialog(wxWindow* parent, const wxString& message, const wxString& caption = _("Please enter text"), const wxString& defaultValue = wxT(""), long style = wxOK | wxCANCEL | wxCENTRE, const wxPoint& pos = wxDefaultPosition)
wxString GetValue() const
void SetValue(const wxString& value)
int ShowModal()

////////////////////////////////////////////////////////////
// wxFontData

%class %delete wxFontData, wxObject
%include "wx/cmndata.h"

wxFontData()
void EnableEffects(bool enable)
bool GetAllowSymbols()
%alias GetColor wxColour& GetColour()
wxFont GetChosenFont()
bool GetEnableEffects()
wxFont GetInitialFont()
bool GetShowHelp()
void SetAllowSymbols(bool allowSymbols)
void SetChosenFont(const wxFont& font)
void SetColour(const wxColour& colour)
void SetInitialFont(const wxFont&font)
void SetRange(int min, int max)
void SetShowHelp(bool showHelp)

///////////////////////////////////////////////////////////////////////////////
// wxFontDialog

%class wxFontDialog, wxDialog
%include "wx/fontdlg.h"

//wxFontDialog(wxWindow* parent, wxFontData* data = NULL)
wxFontDialog(wxWindow* parent, const wxFontData& data)
wxFontData& GetFontData()
int ShowModal()

///////////////////////////////////////////////////////////////////////////////
// wxPageSetupDialogData

%class %delete wxPageSetupDialogData, wxObject
%include "wx/cmndata.h"

wxPageSetupDialogData()
// FIX! Add alternate constructors
// wxPageSetupDialogData(wxPageSetupDialogData& data)
// wxPrintDialogData(wxPrintData& printData)
void EnableHelp(bool flag)
void EnableMargins(bool flag)
void EnableOrientation(bool flag)
void EnablePaper(bool flag)
void EnablePrinter(bool flag)
bool GetDefaultMinMargins() const
bool GetEnableMargins() const
bool GetEnableOrientation() const
bool GetEnablePaper() const
bool GetEnablePrinter() const
bool GetEnableHelp() const
bool GetDefaultInfo() const
wxPoint GetMarginTopLeft() const
wxPoint GetMarginBottomRight() const
wxPoint GetMinMarginTopLeft() const
wxPoint GetMinMarginBottomRight() const
wxPaperSize GetPaperId() const
wxSize GetPaperSize() const
wxPrintData& GetPrintData()
bool IsOk() const
bool Ok() const
void SetDefaultInfo(bool flag)
void SetDefaultMinMargins(bool flag)
void SetMarginTopLeft(const wxPoint& pt)
void SetMarginBottomRight(const wxPoint& pt)
void SetMinMarginTopLeft(const wxPoint& pt)
void SetMinMarginBottomRight(const wxPoint& pt)
void SetPaperId(wxPaperSize& id)
void SetPaperSize(const wxSize& size)
void SetPrintData(const wxPrintData& printData)

///////////////////////////////////////////////////////////////////////////////
// wxPageSetupDialog

%class wxPageSetupDialog, wxDialog
%include "wx/printdlg.h"

wxPageSetupDialog(wxWindow* parent, wxPageSetupDialogData* data = NULL)
wxPageSetupDialogData& GetPageSetupData()
// FIX! Appears to be missing from wxGTK
// bool Ok() const
int ShowModal()

///////////////////////////////////////////////////////////////////////////////
// wxPrintDialog

%class wxPrintDialog, wxDialog

wxPrintDialog(wxWindow* parent, wxPrintDialogData* data = NULL)
wxPrintDialogData& GetPrintDialogData()
wxDC* GetPrintDC()
int ShowModal()

///////////////////////////////////////////////////////////////////////////////
// wxMessageDialog

%class wxMessageDialog, wxDialog

wxMessageDialog(wxWindow* parent, const wxString& message, const wxString& caption = _("Message box"), long style = wxOK | wxCANCEL | wxCENTRE, const wxPoint& pos = wxDefaultPosition)
int ShowModal()

///////////////////////////////////////////////////////////////////////////////
// MENUS
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
// wxMenu

%class %delete wxMenu, wxEvtHandler
%include "wx/menu.h"

wxMenu(const wxString& title = wxT(""), long style = 0)
void Append(int id, const wxString& item, const wxString& helpString = wxT(""), const bool checkable = FALSE)
%rename AppendMenu void Append(int id, const wxString& item, wxMenu *subMenu, const wxString& helpString = wxT(""))
%rename AppendItem void Append(wxMenuItem* menuItem)
void AppendCheckItem(int id, const wxString&  item, const wxString& helpString = wxT(""))
void AppendRadioItem(int id, const wxString&  item, const wxString& helpString = wxT(""))
void AppendSeparator()
void Break()
void Check(int id, const bool check)
void Delete(int id)
%rename DeleteItem void Delete(wxMenuItem *item)
void Destroy(int id)
%rename DestroyMenuItem void Destroy(wxMenuItem *item)
void Enable(int id, const bool enable)
int FindItem(const wxString& itemString) const
// Error: can't handle ** yet
// %rename FindItemById wxMenuItem * FindItem(int id, wxMenu **menu = NULL) const
wxString GetHelpString(int id) const
wxString GetLabel(int id) const
size_t GetMenuItemCount() const
wxMenuItemList& GetMenuItems() const
wxString GetTitle() const
bool Insert(size_t pos, wxMenuItem *item)
void InsertCheckItem(size_t pos, int id, const wxString&  item, const wxString& helpString = wxT(""))
void InsertRadioItem(size_t pos, int id, const wxString&  item, const wxString& helpString = wxT(""))
void InsertSeparator(size_t pos)
bool IsChecked(int id) const
bool IsEnabled(int id) const
%rename PrependItem void Prepend( wxMenuItem *item)
void Prepend(int id, const wxString& item, const wxString& helpString = wxT(""), wxItemKind kind = wxITEM_NORMAL)
void PrependCheckItem(int id, const wxString&  item, const wxString& helpString = wxT(""))
void PrependRadioItem(int id, const wxString&  item, const wxString& helpString = wxT(""))
%rename RemoveById wxMenuItem * Remove(int id)
wxMenuItem * Remove(wxMenuItem *item)
void SetHelpString(int id, const wxString& helpString)
void SetLabel(int id, const wxString& label)
void SetTitle(const wxString& title)
void UpdateUI(wxEvtHandler* source = NULL) const

wxMenuItem *  AppendSubMenu(wxMenu *submenu, const wxString& text, const wxString& help = wxEmptyString)
wxMenuItem*  FindItemByPosition(size_t position) const
wxString  GetLabelText(int id) const
wxMenuItem*  PrependSeparator()

///////////////////////////////////////////////////////////////////////////////
// wxMenuBar

%class wxMenuBar, wxEvtHandler

// Error: include void in declaration
wxMenuBar(long style = 0)
// TODO:
// void wxMenuBar(int n, wxMenu* menus[], const wxString titles[])
bool Append(wxMenu *menu, const wxString& title)
void Check(int id, const bool check)
void Enable(int id, const bool enable)
void EnableTop(int pos, const bool enable)
int FindMenu(const wxString& title) const
int FindMenuItem(const wxString& menuString, const wxString& itemString) const
// Error: can't handle ** yet
// wxMenuItem * FindItem(int id, wxMenu **menu = NULL) const
wxString GetHelpString(int id) const
wxString GetLabel(int id) const
wxString GetLabelTop(int pos) const
wxMenu* GetMenu(int menuIndex) const
int GetMenuCount() const
bool Insert(size_t pos, wxMenu *menu, const wxString& title)
bool IsChecked(int id) const
bool IsEnabled(int id) const
void Refresh()
wxMenu * Remove(size_t pos)
wxMenu * Replace(size_t pos, wxMenu *menu, const wxString& title)
void SetHelpString(int id, const wxString& helpString)
void SetLabel(int id, const wxString& label)
void SetLabelTop(int pos, const wxString& label)

wxString  GetMenuLabel(int pos) const
wxString  GetMenuLabelText(int pos) const
void SetMenuLabel(int pos, const wxString& label)

///////////////////////////////////////////////////////////////////////////////
// wxMenuItem

%class %delete wxMenuItem, wxObject
%include "wx/menuitem.h"

wxMenuItem(wxMenu *parentMenu = NULL, int id = wxID_SEPARATOR, const wxString& text = wxEmptyString, const wxString& help = wxEmptyString, wxItemKind kind = wxITEM_NORMAL, wxMenu *subMenu = NULL)
void Check(bool check)
// Error: 'DeleteSubMenu' is not a member of 'wxMenuItem'
// void DeleteSubMenu()
void Enable(bool enable)
// FIX: Missing in GTK
%if(win) %alias GetBackgroundColor wxColour& GetBackgroundColour() const
// Fix: Cannot convert 'const wxBitmap *' to 'wxBitmap *'
// wxBitmap& GetBitmap(bool checked = TRUE) const
// FIX: Missing in GTK
%if(win) wxFont& GetFont() const
wxString GetHelp() const
int GetId() const
wxString GetLabel() const
static wxString GetLabelFromText(const wxString& text)
wxString  GetItemLabel() const
wxString  GetItemLabelText() const
wxItemKind GetKind() const
static wxString  GetLabelText(const wxString& text)
// FIX: Missing in GTK
%if(win) int GetMarginWidth() const
// Fix: Member is ambiguous: 'wxMenuItemBase::GetName' and 'wxOwnerDrawn::GetName'
// wxString GetName() const
wxString GetText() const
wxMenu* GetSubMenu() const
// FIX: Missing in GTK
%if(win) %alias GetTextColor wxColour& GetTextColour() const
bool IsCheckable() const
bool IsChecked() const
bool IsEnabled() const
bool IsSeparator() const
// FIX: Missing in GTK
%if(win) %alias SetBackgroundColor void SetBackgroundColour(const wxColour& colour) const
void SetBitmap(const wxBitmap& bitmap) const
%if(win) void SetBitmaps(const wxBitmap& checked, const wxBitmap& unchecked = wxNullBitmap) const
%if(win) void SetFont(const wxFont& font) const
void SetHelp(const wxString& helpString) const
%if(win) void SetMarginWidth(int width) const
// Fix: Member is ambiguous: 'wxMenuItemBase::SetName' and 'wxOwnerDrawn::SetName'
// void SetName(const wxString& text) const
// FIX: Missing in GTK
%if(win) %alias SetTextColor void SetTextColour(const wxColour& colour) const
wxMenu*  GetMenu() const
bool IsSubMenu() const
void SetItemLabel(const wxString& label)
void SetMenu(wxMenu*menu)
void SetSubMenu(wxMenu*menu)
void SetText(const wxString& text)

%builtin %rename wxMenuItem_GetLabelText wxString wxMenuItem::GetLabelText(const wxString& text)
%builtin %rename wxMenuItem_GetLabelFromText wxString wxMenuItem::GetLabelFromText(const wxString& text)

///////////////////////////////////////////////////////////////////////////////
// wxFileHistory

%include <wx/docview.h>
%class wxFileHistory, wxObject
wxFileHistory(size_t maxFiles = 9, wxWindowID idBase = wxID_FILE1)
// ~wxFileHistory()
void AddFileToHistory(const wxString& filename)
void AddFilesToMenu()
wxWindowID GetBaseId() const
size_t GetCount() const
wxString  GetHistoryFile(size_t index) const
int GetMaxFiles() const
const wxList&  GetMenus() const
void Load(wxConfigBase& config)
void RemoveFileFromHistory(size_t i)
void RemoveMenu(wxMenu* menu)
void Save(wxConfigBase& config)
void SetBaseId(wxWindowID baseId)
void UseMenu(wxMenu* menu)

///////////////////////////////////////////////////////////////////////////////
// EVENTS
///////////////////////////////////////////////////////////////////////////////

// #########################################################
// clntdata.h

%include <wx/clntdata.h>

// %typedef int (*wxShadowObjectMethod)(void*, void*)

%enum wxClientDataType
  %num wxClientData_None
  %num wxClientData_Object
  %num wxClientData_Void

// ==============================
// Class: wxClientData

%class wxClientData
wxClientData()

// #########################################################
// event.h

%include <wx/event.h>

// this cause failure
%typedef wxEventType int
%num WXWIN_COMPATIBILITY_EVENT_TYPES

%num wxEVT_NULL
%num wxEVT_FIRST
%num wxEVT_USER_FIRST

%enum Propagation_state
  %num wxEVENT_PROPAGATE_NONE
  %num wxEVENT_PROPAGATE_MAX

// ==============================
// Class: wxEvent

%class %delete wxEvent, wxObject

%event wxEVT_SET_FOCUS
%event wxEVT_KILL_FOCUS
%event wxEVT_CHILD_FOCUS

// these are not used in wxWidgets so far
%event wxEVT_SETTING_CHANGED
%event wxEVT_DRAW_ITEM
%event wxEVT_MEASURE_ITEM
%event wxEVT_COMPARE_ITEM

//can not create abstract class
//wxEvent(int winid = 0, wxEventType commandType = wxEVT_NULL )
void SetEventType(wxEventType typ)
wxEventType GetEventType() const
wxObject *GetEventObject() const
void SetEventObject(wxObject *obj)
long GetTimestamp() const
void SetTimestamp(long ts = 0)
int GetId() const
void SetId(int Id)
void Skip(bool skip = true)
bool GetSkipped() const
%not(bcc) virtual wxEvent *Clone() const
bool IsCommandEvent() const
bool ShouldPropagate() const
int StopPropagation()
void ResumePropagation(int propagationLevel)
wxObject*         m_callbackUserData

// ==============================
// Class: wxProcessEvent

%class %delete wxProcessEvent, wxEvent
wxProcessEvent(int nId = 0, int pid = 0, int exitcode = 0)
int GetPid()
int GetExitCode()
%not(bcc) virtual wxEvent *Clone() const

%event wxEVT_END_PROCESS

// ==============================
// Class: wxPropagationDisabler

%class %delete wxPropagationDisabler
wxPropagationDisabler(wxEvent& event)

// ==============================
// Class: wxPropagateOnce

%class %delete wxPropagateOnce
wxPropagateOnce(wxEvent& event)

// ==============================
// Class: wxCommandEventStringHelper

//%class wxCommandEventStringHelper
//wxCommandEventStringHelper(wxCommandEvent * evt)
//const wxChar* c_str() const

// ==============================
// Class: wxCommandEvent

%include <wx/event.h>

%class %delete wxCommandEvent, wxEvent

%event wxEVT_COMMAND_BUTTON_CLICKED
%event wxEVT_COMMAND_CHECKBOX_CLICKED
%event wxEVT_COMMAND_CHOICE_SELECTED
%event wxEVT_COMMAND_LISTBOX_SELECTED
%event wxEVT_COMMAND_LISTBOX_DOUBLECLICKED
%event wxEVT_COMMAND_CHECKLISTBOX_TOGGLED
%event wxEVT_COMMAND_TEXT_UPDATED
%event wxEVT_COMMAND_TEXT_ENTER
%event wxEVT_COMMAND_TEXT_MAXLEN
%event wxEVT_COMMAND_MENU_SELECTED
%event wxEVT_COMMAND_TOOL_CLICKED
%event wxEVT_COMMAND_SLIDER_UPDATED
%event wxEVT_COMMAND_RADIOBOX_SELECTED
%event wxEVT_COMMAND_RADIOBUTTON_SELECTED
%event wxEVT_COMMAND_SCROLLBAR_UPDATED
%event wxEVT_COMMAND_VLBOX_SELECTED
%event wxEVT_COMMAND_COMBOBOX_SELECTED
%event wxEVT_COMMAND_TOOL_RCLICKED
%event wxEVT_COMMAND_TOOL_ENTER
%event wxEVT_COMMAND_SPINCTRL_UPDATED
%event wxEVT_COMMAND_LEFT_CLICK
%event wxEVT_COMMAND_LEFT_DCLICK
%event wxEVT_COMMAND_RIGHT_CLICK
%event wxEVT_COMMAND_RIGHT_DCLICK
%event wxEVT_COMMAND_SET_FOCUS
%event wxEVT_COMMAND_KILL_FOCUS
%event wxEVT_COMMAND_ENTER
%event wxEVT_COMMAND_TOGGLEBUTTON_CLICKED

wxCommandEvent(wxEventType commandType = wxEVT_NULL, int winid = 0)
//wxCommandEvent(const wxCommandEvent& event)
void SetClientData(void* clientData)
void *GetClientData() const
void SetClientObject(wxClientData* clientObject)
wxClientData *GetClientObject() const
int GetSelection() const
void SetString(const wxString& s)
wxString GetString() const
bool IsChecked() const
bool IsSelection() const
void SetExtraLong(long extraLong)
long GetExtraLong() const
void SetInt(int i)
int GetInt() const
%not(bcc) virtual wxEvent *Clone() const
//wxCommandEventStringHelper m_commandString
//char* m_commandString

// ==============================
// Class: wxTextUrlEvent

%class %delete wxTextUrlEvent, wxCommandEvent

%event wxEVT_COMMAND_TEXT_URL

wxTextUrlEvent(int winid, const wxMouseEvent& evMouse, long start, long end)
const wxMouseEvent& GetMouseEvent() const
long GetURLStart() const
long GetURLEnd() const

// ==============================
// Class: wxNotifyEvent

%class %delete wxNotifyEvent, wxCommandEvent
wxNotifyEvent(wxEventType commandType = wxEVT_NULL, int winid = 0)
//wxNotifyEvent(const wxNotifyEvent& event)
void Veto()
void Allow()
bool IsAllowed() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxScrollEvent

%class %delete wxScrollEvent, wxCommandEvent

%event wxEVT_SCROLL_TOP
%event wxEVT_SCROLL_BOTTOM
%event wxEVT_SCROLL_LINEUP
%event wxEVT_SCROLL_LINEDOWN
%event wxEVT_SCROLL_PAGEUP
%event wxEVT_SCROLL_PAGEDOWN
%event wxEVT_SCROLL_THUMBTRACK
%event wxEVT_SCROLL_THUMBRELEASE
%event wxEVT_SCROLL_CHANGED

wxScrollEvent(wxEventType commandType = wxEVT_NULL, int winid = 0, int pos = 0, int orient = 0)
int GetOrientation() const
int GetPosition() const
void SetOrientation(int orient)
void SetPosition(int pos)
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxScrollWinEvent

%class %delete wxScrollWinEvent, wxEvent

%event wxEVT_SCROLLWIN_TOP
%event wxEVT_SCROLLWIN_BOTTOM
%event wxEVT_SCROLLWIN_LINEUP
%event wxEVT_SCROLLWIN_LINEDOWN
%event wxEVT_SCROLLWIN_PAGEUP
%event wxEVT_SCROLLWIN_PAGEDOWN
%event wxEVT_SCROLLWIN_THUMBTRACK
%event wxEVT_SCROLLWIN_THUMBRELEASE

wxScrollWinEvent(wxEventType commandType = wxEVT_NULL, int pos = 0, int orient = 0)
// wxScrollWinEvent(const wxScrollWinEvent & event)
int GetOrientation() const
int GetPosition() const
void SetOrientation(int orient)
void SetPosition(int pos)
%not(bcc) virtual wxEvent *Clone() const

%num wxMOUSE_BTN_ANY
%num wxMOUSE_BTN_NONE
%num wxMOUSE_BTN_LEFT
%num wxMOUSE_BTN_MIDDLE
%num wxMOUSE_BTN_RIGHT

// ==============================
// Class: wxMouseEvent

%class %delete wxMouseEvent, wxEvent

%event wxEVT_LEFT_DOWN
%event wxEVT_LEFT_UP
%event wxEVT_MIDDLE_DOWN
%event wxEVT_MIDDLE_UP
%event wxEVT_RIGHT_DOWN
%event wxEVT_RIGHT_UP
%event wxEVT_MOTION
%event wxEVT_ENTER_WINDOW
%event wxEVT_LEAVE_WINDOW
%event wxEVT_LEFT_DCLICK
%event wxEVT_MIDDLE_DCLICK
%event wxEVT_RIGHT_DCLICK
%event wxEVT_MOUSEWHEEL
%event wxEVT_NC_LEFT_DOWN
%event wxEVT_NC_LEFT_UP
%event wxEVT_NC_MIDDLE_DOWN
%event wxEVT_NC_MIDDLE_UP
%event wxEVT_NC_RIGHT_DOWN
%event wxEVT_NC_RIGHT_UP
%event wxEVT_NC_MOTION
%event wxEVT_NC_ENTER_WINDOW
%event wxEVT_NC_LEAVE_WINDOW
%event wxEVT_NC_LEFT_DCLICK
%event wxEVT_NC_MIDDLE_DCLICK
%event wxEVT_NC_RIGHT_DCLICK

wxMouseEvent(wxEventType mouseType = wxEVT_NULL)
// wxMouseEvent(const wxMouseEvent& event)
bool IsButton() const
bool ButtonDown(int but = wxMOUSE_BTN_ANY) const
bool ButtonDClick(int but = wxMOUSE_BTN_ANY) const
bool ButtonUp(int but = wxMOUSE_BTN_ANY) const
bool Button(int but) const
bool ButtonIsDown(int but) const
int GetButton() const
bool ControlDown() const
bool MetaDown() const
bool AltDown() const
bool ShiftDown() const
bool CmdDown() const
bool LeftDown() const
bool MiddleDown() const
bool RightDown() const
bool LeftUp() const
bool MiddleUp() const
bool RightUp() const
bool LeftDClick() const
bool MiddleDClick() const
bool RightDClick() const
bool LeftIsDown() const
bool MiddleIsDown() const
bool RightIsDown() const
bool Dragging() const
bool Moving() const
bool Entering() const
bool Leaving() const
//void GetPosition(wxCoord *xpos, wxCoord *ypos) const
//void GetPosition(long *xpos, long *ypos) const
wxPoint GetPosition() const
wxPoint GetLogicalPosition(const wxDC& dc) const
wxCoord GetX() const
wxCoord GetY() const
int GetWheelRotation() const
int GetWheelDelta() const
int GetLinesPerAction() const
bool IsPageScroll() const
%not(bcc) virtual wxEvent *Clone() const
wxCoord m_x
wxCoord m_y
bool          m_leftDown
bool          m_middleDown
bool          m_rightDown
bool          m_controlDown
bool          m_shiftDown
bool          m_altDown
bool          m_metaDown
int           m_wheelRotation
int           m_wheelDelta
int           m_linesPerAction
%{
    void wxMouseEvent_GetPositionXY()
    {
        long x, y;
        ((wxMouseEvent *)wTheCall->self->ptr)->GetPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
    }

    void wxMouseEvent_GetPositionX()
    {
        long x, y;
        ((wxMouseEvent *)wTheCall->self->ptr)->GetPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }

    void wxMouseEvent_GetPositionY()
    {
        long x, y;
        ((wxMouseEvent *)wTheCall->self->ptr)->GetPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }
%}

%method GetPositionXY   wxMouseEvent_GetPositionXY()
%method GetPositionX    wxMouseEvent_GetPositionX()
%method GetPositionY    wxMouseEvent_GetPositionY()

// ==============================
// Class: wxSetCursorEvent

%class %delete wxSetCursorEvent, wxEvent

%event wxEVT_SET_CURSOR

wxSetCursorEvent(wxCoord x = 0, wxCoord y = 0)
//wxSetCursorEvent(const wxSetCursorEvent & event)
wxCoord GetX() const
wxCoord GetY() const
void SetCursor(const wxCursor& cursor)
const wxCursor& GetCursor() const
bool HasCursor() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxKeyEvent

%class %delete wxKeyEvent, wxEvent

%event wxEVT_CHAR
%event wxEVT_CHAR_HOOK
%event wxEVT_NAVIGATION_KEY
%event wxEVT_KEY_DOWN
%event wxEVT_KEY_UP

%if(wxUSE_HOTKEY)%event wxEVT_HOTKEY

wxKeyEvent(wxEventType keyType = wxEVT_NULL)
//wxKeyEvent(const wxKeyEvent& evt)
int GetModifiers() const
bool ControlDown() const
bool ShiftDown() const
bool MetaDown() const
bool AltDown() const
bool CmdDown() const
bool HasModifiers() const
int GetKeyCode() const
%if(unicode) wxChar GetUnicodeKey() const
wxUint32 GetRawKeyCode() const
wxUint32 GetRawKeyFlags() const
//void GetPosition(wxCoord *xpos, wxCoord *ypos) const
//void GetPosition(long *xpos, long *ypos) const
wxPoint GetPosition() const
wxCoord GetX() const
wxCoord GetY() const
%not(bcc) virtual wxEvent *Clone() const
wxCoord       m_x, m_y
long          m_keyCode
bool          m_controlDown
bool          m_shiftDown
bool          m_altDown
bool          m_metaDown
bool          m_scanCode
wxChar        m_uniChar
wxUint32      m_rawCode
wxUint32      m_rawFlags

%{
    void wxKeyEvent_GetPositionXY()
    {
        long x, y;
        ((wxKeyEvent *)wTheCall->self->ptr)->GetPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
        wStackPushInteger( (wInteger)y );
    }

    void wxKeyEvent_GetPositionX()
    {
        long x, y;
        ((wxKeyEvent *)wTheCall->self->ptr)->GetPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)x );
    }

    void wxKeyEvent_GetPositionY()
    {
        long x, y;
        ((wxKeyEvent *)wTheCall->self->ptr)->GetPosition(&x, &y);
        wWrapDerefArgs();
        wStackPushInteger( (wInteger)y );
    }
%}

%method GetPositionXY   wxKeyEvent_GetPositionXY()
%method GetPositionX    wxKeyEvent_GetPositionX()
%method GetPositionY    wxKeyEvent_GetPositionY()

// ==============================
// Class: wxSizeEvent

%class %delete wxSizeEvent, wxEvent

%event wxEVT_SIZE
%event wxEVT_SIZING

//wxSizeEvent()
wxSizeEvent(const wxSize& sz, int winid = 0)
//wxSizeEvent(const wxSizeEvent & event)
//wxSizeEvent(const wxRect& rect, int id = 0)
wxSize GetSize() const
wxRect GetRect() const
void SetRect(const wxRect& rect)
%not(bcc) virtual wxEvent *Clone() const
wxSize m_size
wxRect m_rect

// ==============================
// Class: wxMoveEvent

%class %delete wxMoveEvent, wxEvent

%event wxEVT_MOVE
%event wxEVT_MOVING

//wxMoveEvent()
wxMoveEvent(const wxPoint& pos, int winid = 0)
//wxMoveEvent(const wxMoveEvent& event)
//wxMoveEvent(const wxRect& rect, int id = 0)
wxPoint GetPosition() const
void SetPosition(const wxPoint& pos)
wxRect GetRect() const
void SetRect(const wxRect& rect)
%not(bcc) virtual wxEvent *Clone() const

%builtin int g_isPainting

// ==============================
// Class: wxPaintEvent

%class %delete wxPaintEvent, wxEvent

%event wxEVT_PAINT
%event wxEVT_NC_PAINT
%event wxEVT_PAINT_ICON

wxPaintEvent(int Id = 0)
//wxPaintEvent(const wxPaintEvent& event)
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxNcPaintEvent

%not(bcc) %class wxNcPaintEvent, wxEvent
wxNcPaintEvent(int winid = 0)
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxEraseEvent

%class %delete wxEraseEvent, wxEvent

%event wxEVT_ERASE_BACKGROUND

//original is too complex for wrap.bas
//wxEraseEvent(int Id = 0, wxDC *dc = (wxDC *) NULL)
wxEraseEvent(int id = 0, wxDC* dc = NULL)
//wxEraseEvent(const wxEraseEvent& event)
wxDC *GetDC() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxFocusEvent

%class %delete wxFocusEvent, wxEvent
wxFocusEvent(wxEventType type = wxEVT_NULL, int winid = 0)
//wxFocusEvent(const wxFocusEvent& event)
wxWindow *GetWindow() const
void SetWindow(wxWindow *win)
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxChildFocusEvent

%class %delete wxChildFocusEvent, wxCommandEvent
wxChildFocusEvent(wxWindow *win = NULL)
wxWindow *GetWindow() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxActivateEvent

%class %delete wxActivateEvent, wxEvent

%event wxEVT_ACTIVATE_APP
%event wxEVT_ACTIVATE
%event wxEVT_HIBERNATE

wxActivateEvent(wxEventType type = wxEVT_NULL, bool active = true, int Id = 0)
//wxActivateEvent(const wxActivateEvent& event)
bool GetActive() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxInitDialogEvent

%class %delete wxInitDialogEvent, wxEvent

%event wxEVT_INIT_DIALOG

wxInitDialogEvent(int Id = 0)
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxMenuEvent

%class %delete wxMenuEvent, wxEvent

%event wxEVT_MENU_OPEN
%event wxEVT_MENU_CLOSE
%event wxEVT_MENU_HIGHLIGHT

wxMenuEvent(wxEventType type = wxEVT_NULL, int winid = 0, wxMenu* menu = NULL)
//wxMenuEvent(const wxMenuEvent & event)
int GetMenuId() const
bool IsPopup() const
wxMenu* GetMenu() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxCloseEvent

%class %delete wxCloseEvent, wxEvent

%event wxEVT_CLOSE_WINDOW
%event wxEVT_END_SESSION
%event wxEVT_QUERY_END_SESSION

wxCloseEvent(wxEventType type = wxEVT_NULL, int winid = 0)
//wxCloseEvent(const wxCloseEvent & event)
// documented, but not supported
//void SetForce(bool force) const
void SetLoggingOff(bool logOff)
bool GetLoggingOff() const
void Veto(bool veto = true)
void SetCanVeto(bool canVeto)
bool CanVeto() const
bool GetVeto() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxShowEvent

%class %delete wxShowEvent, wxEvent

%event wxEVT_SHOW

wxShowEvent(int winid = 0, bool show = false)
//wxShowEvent(const wxShowEvent & event)
void SetShow(bool show)
bool GetShow() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxIconizeEvent

%class %delete wxIconizeEvent, wxEvent

%event wxEVT_ICONIZE

wxIconizeEvent(int winid = 0, bool iconized = true)
//wxIconizeEvent(const wxIconizeEvent & event)
bool Iconized() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxMaximizeEvent

%class %delete wxMaximizeEvent, wxEvent

%event wxEVT_MAXIMIZE

wxMaximizeEvent(int winid = 0)
%not(bcc) virtual wxEvent *Clone() const

///////////////////////////////////////////////////////////////////////////////
// wxJoystick

%include <wx/joystick.h>
%class wxJoystick, wxObject
wxJoystick(int joystick = wxJOYSTICK1)
// ~wxJoystick()
int GetButtonState() const
int GetManufacturerId() const
int GetMovementThreshold() const
int GetNumberAxes() const
int GetNumberButtons() const
static int GetNumberJoysticks()
int GetPollingMax() const
int GetPollingMin() const
int GetProductId() const
wxString  GetProductName() const
wxPoint  GetPosition() const
int GetPOVPosition() const
int GetPOVCTSPosition() const
int GetRudderMax() const
int GetRudderMin() const
int GetRudderPosition() const
int GetUMax() const
int GetUMin() const
int GetUPosition() const
int GetVMax() const
int GetVMin() const
int GetVPosition() const
int GetXMax() const
int GetXMin() const
int GetYMax() const
int GetYMin() const
int GetZMax() const
int GetZMin() const
int GetZPosition() const
bool HasPOV() const
bool HasPOV4Dir() const
bool HasPOVCTS() const
bool HasRudder() const
bool HasU() const
bool HasV() const
bool HasZ() const
bool IsOk() const
bool ReleaseCapture()
bool SetCapture(wxWindow* win, int pollingFreq = 0)
void SetMovementThreshold(int threshold)

%builtin %rename wxJoystick_GetNumberJoysticks int wxJoystick::GetNumberJoysticks()

%num wxJOYSTICK1
%num wxJOYSTICK2

%num wxJOY_BUTTON_ANY
%num wxJOY_BUTTON1
%num wxJOY_BUTTON2
%num wxJOY_BUTTON3
%num wxJOY_BUTTON4

// ==============================
// Class: wxJoystickEvent

%class %delete wxJoystickEvent, wxEvent

%event wxEVT_JOY_BUTTON_DOWN
%event wxEVT_JOY_BUTTON_UP
%event wxEVT_JOY_MOVE
%event wxEVT_JOY_ZMOVE

wxJoystickEvent(wxEventType type = wxEVT_NULL, int state = 0, int joystick = wxJOYSTICK1, int change = 0)
//wxJoystickEvent(const wxJoystickEvent & event)
wxPoint GetPosition() const
int GetZPosition() const
int GetButtonState() const
int GetButtonChange() const
int GetJoystick() const
void SetJoystick(int stick)
void SetButtonState(int state)
void SetButtonChange(int change)
void SetPosition(const wxPoint& pos)
void SetZPosition(int zPos)
bool IsButton() const
bool IsMove() const
bool IsZMove() const
bool ButtonDown(int but = wxJOY_BUTTON_ANY) const
bool ButtonUp(int but = wxJOY_BUTTON_ANY) const
bool ButtonIsDown(int but =  wxJOY_BUTTON_ANY) const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxDropFilesEvent

%class %delete wxDropFilesEvent, wxEvent

%event wxEVT_DROP_FILES

int       m_noFiles
wxPoint   m_pos
wxString* m_files
//wxDropFilesEvent(wxEventType type = wxEVT_NULL, int noFiles = 0, wxString *files = (wxString *) NULL)
%{
void wxDropFilesEvent_new_() {
    wxString files = (wTheCall->parmCount > 2 ? (wxChar *)wStackPopObjectPtr( NULL ) : wxT(""));
    int noFiles = (wTheCall->parmCount > 1 ? (int)wStackPopInteger() : 0);
    wxEventType type = (wTheCall->parmCount > 0 ? (wxEventType)wStackPopInteger() : wxEVT_NULL);
	wxDropFilesEvent *returns = new wxDropFilesEvent(type, noFiles, (wTheCall->parmCount > 2 ? &files : NULL));
    wWrapDerefArgs();
    wWrapSetThis( _wxDropFilesEvent, (void *)returns );
}
%}
%method wxDropFilesEvent_new wxDropFilesEvent_new_(wxEventType type = wxEVT_NULL, int noFiles = 0, wxString *files = (wxString *) NULL)
//wxDropFilesEvent(const wxDropFilesEvent& other)
wxPoint GetPosition() const
int GetNumberOfFiles() const
wxString *GetFiles() const
%not(bcc) virtual wxEvent *Clone() const

%enum wxUpdateUIMode
  %num wxUPDATE_UI_PROCESS_ALL
  %num wxUPDATE_UI_PROCESS_SPECIFIED

// ==============================
// Class: wxUpdateUIEvent

%class %delete wxUpdateUIEvent, wxCommandEvent

%event wxEVT_UPDATE_UI

wxUpdateUIEvent(wxWindowID commandId = 0)
//wxUpdateUIEvent(const wxUpdateUIEvent & event)
bool GetChecked() const
bool GetEnabled() const
bool GetShown() const
wxString GetText() const
bool GetSetText() const
bool GetSetChecked() const
bool GetSetEnabled() const
bool GetSetShown() const
void Check(bool check)
void Enable(bool enable)
void Show(bool show)
void SetText(const wxString& text)
static void SetUpdateInterval(long updateInterval)
static long GetUpdateInterval()
//static bool CanUpdate(wxWindowBase *win)
static bool CanUpdate(wxWindow *win)
static void ResetUpdateTime()
static void SetMode(wxUpdateUIMode mode)
static wxUpdateUIMode GetMode()
%not(bcc) virtual wxEvent *Clone() const

%builtin %rename wxUpdateUIEvent_CanUpdate bool wxUpdateUIEvent::CanUpdate(wxWindow* window)
%builtin %rename wxUpdateUIEvent_GetMode wxUpdateUIMode wxUpdateUIEvent::GetMode()
%builtin %rename wxUpdateUIEvent_GetUpdateInterval long wxUpdateUIEvent::GetUpdateInterval()
%builtin %rename wxUpdateUIEvent_ResetUpdateTime void wxUpdateUIEvent::ResetUpdateTime()
%builtin %rename wxUpdateUIEvent_SetMode void wxUpdateUIEvent::SetMode(wxUpdateUIMode mode)
%builtin %rename wxUpdateUIEvent_SetUpdateInterval void wxUpdateUIEvent::SetUpdateInterval(long updateInterval)

// ==============================
// Class: wxSysColourChangedEvent

%class %delete wxSysColourChangedEvent, wxEvent

%event wxEVT_SYS_COLOUR_CHANGED

wxSysColourChangedEvent()
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxMouseCaptureChangedEvent

%class %delete wxMouseCaptureChangedEvent, wxEvent

%event wxEVT_MOUSE_CAPTURE_CHANGED

wxMouseCaptureChangedEvent(wxWindowID winid = 0, wxWindow* gainedCapture = NULL)
//wxMouseCaptureChangedEvent(const wxMouseCaptureChangedEvent& event)
%not(bcc) virtual wxEvent *Clone() const
wxWindow* GetCapturedWindow() const

// ==============================
// Class: wxMouseCaptureLostEvent

%class %delete wxMouseCaptureLostEvent, wxEvent

%event wxEVT_MOUSE_CAPTURE_LOST

wxMouseCaptureLostEvent(wxWindowID winid = 0)
//wxMouseCaptureLostEvent(const wxMouseCaptureLostEvent& event)
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxDisplayChangedEvent

%class %delete wxDisplayChangedEvent, wxEvent

%event wxEVT_DISPLAY_CHANGED

wxDisplayChangedEvent()
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxPaletteChangedEvent

%class %delete wxPaletteChangedEvent, wxEvent

%event wxEVT_PALETTE_CHANGED

wxPaletteChangedEvent(wxWindowID winid = 0)
//wxPaletteChangedEvent(const wxPaletteChangedEvent& event)
void SetChangedWindow(wxWindow* win)
wxWindow* GetChangedWindow() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxQueryNewPaletteEvent

%class %delete wxQueryNewPaletteEvent, wxEvent

%event wxEVT_QUERY_NEW_PALETTE

wxQueryNewPaletteEvent(wxWindowID winid = 0)
//wxQueryNewPaletteEvent(const wxQueryNewPaletteEvent & event)
void SetPaletteRealized(bool realized)
bool GetPaletteRealized() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxNavigationKeyEvent

%class %delete wxNavigationKeyEvent, wxEvent
wxNavigationKeyEvent()
//wxNavigationKeyEvent(const wxNavigationKeyEvent& event)
bool GetDirection() const
void SetDirection(bool bForward)
bool IsWindowChange() const
void SetWindowChange(bool bIs)
bool IsFromTab() const
void SetFromTab(bool bIs)
wxWindow* GetCurrentFocus() const
void SetCurrentFocus(wxWindow *win)
void SetFlags(long flags)
%not(bcc) virtual wxEvent *Clone() const
long m_flags
wxWindow *m_focus

%num %rename wxNavigationKeyEvent_IsBackward wxNavigationKeyEvent::IsBackward
%num %rename wxNavigationKeyEvent_IsForward wxNavigationKeyEvent::IsForward
%num %rename wxNavigationKeyEvent_WinChange wxNavigationKeyEvent::WinChange
%num %rename wxNavigationKeyEvent_FromTab wxNavigationKeyEvent::FromTab

// ==============================
// Class: wxWindowCreateEvent

%class %delete wxWindowCreateEvent, wxCommandEvent

%event wxEVT_CREATE
%event wxEVT_DESTROY

wxWindowCreateEvent(wxWindow *win = NULL)
wxWindow *GetWindow() const
%not(bcc) virtual wxEvent *Clone() const

// ==============================
// Class: wxWindowDestroyEvent

%class %delete wxWindowDestroyEvent, wxCommandEvent
wxWindowDestroyEvent(wxWindow *win = NULL)
wxWindow *GetWindow() const
%not(bcc) virtual wxEvent *Clone() const

///////////////////////////////////////////////////////////////////////////////
// wxContextHelp

%include <wx/cshelp.h>
%class %delete wxContextHelp, wxObject
wxContextHelp(wxWindow* window = NULL, bool doNow = true)
// ~wxContextHelp()
bool BeginContextHelp(wxWindow* window = NULL)
bool EndContextHelp()

// ==============================
// Class: wxHelpEvent

%enum wxHelpEvent::Origin

%class %delete wxHelpEvent, wxCommandEvent

%event wxEVT_HELP
%event wxEVT_DETAILED_HELP

wxHelpEvent(wxEventType type = wxEVT_NULL, wxWindowID winid = 0, const wxPoint& pt = wxDefaultPosition, wxHelpEvent::Origin origin = wxHelpEvent::Origin_Unknown)
//wxHelpEvent(const wxHelpEvent & event)
const wxPoint& GetPosition() const
void SetPosition(const wxPoint& pos)
const wxString& GetLink() const
void SetLink(const wxString& link)
const wxString& GetTarget() const
void SetTarget(const wxString& target)
%not(bcc) virtual wxEvent *Clone() const
wxHelpEvent::Origin GetOrigin() const
void SetOrigin(wxHelpEvent::Origin origin)

//%not(gcc) %num %rename wxHelpEvent_Origin_Origin_Unknown wxHelpEvent::Origin::Origin_Unknown
//%not(gcc) %num %rename wxHelpEvent_Origin_Origin_Keyboard wxHelpEvent::Origin::Origin_Keyboard
//%not(gcc) %num %rename wxHelpEvent_Origin_Origin_HelpButton wxHelpEvent::Origin::Origin_HelpButton

%num %rename wxHelpEvent_Origin_Unknown 0
%num %rename wxHelpEvent_Origin_Keyboard 1
%num %rename wxHelpEvent_Origin_HelpButton 2

// ==============================
// Class: wxContextMenuEvent

%class %delete wxContextMenuEvent, wxCommandEvent

%event wxEVT_CONTEXT_MENU

wxContextMenuEvent(wxEventType type = wxEVT_NULL, wxWindowID winid = 0, const wxPoint& pt = wxDefaultPosition)
//wxContextMenuEvent(const wxContextMenuEvent & event)
const wxPoint& GetPosition() const
void SetPosition(const wxPoint& pos)
%not(bcc) virtual wxEvent *Clone() const

%enum wxIdleMode
  %num wxIDLE_PROCESS_ALL
  %num wxIDLE_PROCESS_SPECIFIED

// ==============================
// Class: wxIdleEvent

%class %delete wxIdleEvent, wxEvent

%event wxEVT_IDLE

wxIdleEvent()
//wxIdleEvent(const wxIdleEvent & event)
void RequestMore(bool needMore = true)
bool MoreRequested() const
%not(bcc) virtual wxEvent *Clone() const
static void SetMode(wxIdleMode mode)
static wxIdleMode GetMode()
static bool CanSend(wxWindow* win)

%builtin %rename wxIdleEvent_CanSend bool wxIdleEvent::CanSend(wxWindow* window)
%builtin %rename wxIdleEvent_GetMode wxIdleMode wxIdleEvent::GetMode()
%builtin %rename wxIdleEvent_SetMode void wxIdleEvent::SetMode(wxIdleMode mode)

%struct wxEventTableEntryBase
%struct wxEventTableEntry
%struct wxDynamicEventTableEntry
%struct wxEventTable

// ==============================
// Class: wxEventHashTable

%class wxEventHashTable
//%struct wxEventHashTable::EventTypeTable
wxEventHashTable(const wxEventTable &table)
bool HandleEvent(wxEvent &event, wxEvtHandler *self)
void Clear()
static void ClearAll()
static void ReconstructAll()

// ==============================
// Class: wxBookCtrlBaseEvent

%class %delete wxBookCtrlBaseEvent, wxNotifyEvent
wxBookCtrlBaseEvent(wxEventType commandType = wxEVT_NULL, int winid = 0, int nSel = -1, int nOldSel = -1)
//wxBookCtrlBaseEvent(const wxBookCtrlBaseEvent& event)
int GetSelection() const
void SetSelection(int nSel)
int GetOldSelection() const
void SetOldSelection(int nOldSel)

%class wxBookCtrlEvent, wxNotebookEvent

%event wxEVT_COMMAND_BOOKCTRL_PAGE_CHANGED
%event wxEVT_COMMAND_BOOKCTRL_PAGE_CHANGING

%num wxBC_TOP
%num wxBC_BOTTOM
%num wxBC_LEFT
%num wxBC_RIGHT
%num wxBC_DEFAULT

// ==============================
// Class: wxTreeEvent

%class %delete wxTreeEvent, wxNotifyEvent
//wxTreeEvent(wxEventType commandType, wxTreeCtrlBase *tree, const wxTreeItemId &item = wxTreeItemId())
wxTreeEvent(wxEventType commandType = wxEVT_NULL, int id = 0)
//wxTreeEvent(const wxTreeEvent& event)
%not(bcc) virtual wxEvent *Clone() const
wxTreeItemId GetItem() const
void SetItem(const wxTreeItemId& item)
wxTreeItemId GetOldItem() const
void SetOldItem(const wxTreeItemId& item)
wxPoint GetPoint() const
void SetPoint(const wxPoint& pt)
const wxKeyEvent& GetKeyEvent() const
int GetKeyCode() const
void SetKeyEvent(const wxKeyEvent& evt)
const wxString& GetLabel() const
void SetLabel(const wxString& label)
bool IsEditCancelled() const
void SetEditCanceled(bool editCancelled)
void SetToolTip(const wxString& toolTip)
wxString GetToolTip()

%event wxEVT_COMMAND_TREE_BEGIN_DRAG
%event wxEVT_COMMAND_TREE_BEGIN_RDRAG
%event wxEVT_COMMAND_TREE_BEGIN_LABEL_EDIT
%event wxEVT_COMMAND_TREE_END_LABEL_EDIT
%event wxEVT_COMMAND_TREE_DELETE_ITEM
%event wxEVT_COMMAND_TREE_GET_INFO
%event wxEVT_COMMAND_TREE_SET_INFO
%event wxEVT_COMMAND_TREE_ITEM_EXPANDED
%event wxEVT_COMMAND_TREE_ITEM_EXPANDING
%event wxEVT_COMMAND_TREE_ITEM_COLLAPSED
%event wxEVT_COMMAND_TREE_ITEM_COLLAPSING
%event wxEVT_COMMAND_TREE_SEL_CHANGED
%event wxEVT_COMMAND_TREE_SEL_CHANGING
%event wxEVT_COMMAND_TREE_KEY_DOWN
%event wxEVT_COMMAND_TREE_ITEM_ACTIVATED
%event wxEVT_COMMAND_TREE_ITEM_RIGHT_CLICK
%event wxEVT_COMMAND_TREE_ITEM_MIDDLE_CLICK
%event wxEVT_COMMAND_TREE_END_DRAG
%event wxEVT_COMMAND_TREE_STATE_IMAGE_CLICK
%event wxEVT_COMMAND_TREE_ITEM_GETTOOLTIP
%event wxEVT_COMMAND_TREE_ITEM_MENU

// ==============================
// Class: wxListEvent

%include <wx/listbase.h>

%class %delete wxListEvent, wxNotifyEvent
wxListEvent(wxEventType commandType = wxEVT_NULL, int winid = 0)
//wxListEvent(const wxListEvent& event)
int GetKeyCode() const
long GetIndex() const
int GetColumn() const
wxPoint GetPoint() const
const wxString& GetLabel() const
const wxString& GetText() const
int GetImage() const
long GetData() const
long GetMask() const
const wxListItem& GetItem() const
long GetCacheFrom() const
long GetCacheTo() const
bool IsEditCancelled() const
void SetEditCanceled(bool editCancelled)
%not(bcc) virtual wxEvent *Clone() const
int           m_code
long          m_oldItemIndex
long          m_itemIndex
int           m_col
wxPoint       m_pointDrag
wxListItem    m_item

%event wxEVT_COMMAND_LIST_BEGIN_DRAG
%event wxEVT_COMMAND_LIST_BEGIN_RDRAG
%event wxEVT_COMMAND_LIST_BEGIN_LABEL_EDIT
%event wxEVT_COMMAND_LIST_END_LABEL_EDIT
%event wxEVT_COMMAND_LIST_DELETE_ITEM
%event wxEVT_COMMAND_LIST_DELETE_ALL_ITEMS
//deprecated
//%event wxEVT_COMMAND_LIST_GET_INFO
//%event wxEVT_COMMAND_LIST_SET_INFO
%event wxEVT_COMMAND_LIST_ITEM_SELECTED
%event wxEVT_COMMAND_LIST_ITEM_DESELECTED
%event wxEVT_COMMAND_LIST_KEY_DOWN
%event wxEVT_COMMAND_LIST_INSERT_ITEM
%event wxEVT_COMMAND_LIST_COL_CLICK
%event wxEVT_COMMAND_LIST_ITEM_RIGHT_CLICK
%event wxEVT_COMMAND_LIST_ITEM_MIDDLE_CLICK
%event wxEVT_COMMAND_LIST_ITEM_ACTIVATED
%event wxEVT_COMMAND_LIST_CACHE_HINT
%event wxEVT_COMMAND_LIST_COL_RIGHT_CLICK
%event wxEVT_COMMAND_LIST_COL_BEGIN_DRAG
%event wxEVT_COMMAND_LIST_COL_DRAGGING
%event wxEVT_COMMAND_LIST_COL_END_DRAG
%event wxEVT_COMMAND_LIST_ITEM_FOCUSED

///////////////////////////////////////////////////////////////////////////////
// wxSplitterEvent

%include <wx/splitter.h>
%class %delete wxSplitterEvent, wxNotifyEvent
wxSplitterEvent(wxEventType eventType = wxEVT_NULL, wxSplitterWindow * splitter = NULL)
int GetSashPosition() const
int GetX() const
int GetY() const
wxWindow*  GetWindowBeingRemoved() const
void SetSashPosition(int pos)

// events

%event wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGED
%event wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGING
%event wxEVT_COMMAND_SPLITTER_DOUBLECLICKED
%event wxEVT_COMMAND_SPLITTER_UNSPLIT

// #########################################################
// evtloop.h

%include <wx/evtloop.h>

// ==============================
// Class: wxEventLoopBase

%class wxEventLoopBase
// abstract class
//wxEventLoopBase()
virtual int Run()
virtual void Exit(int rc = 0)
virtual bool Pending() const
virtual bool Dispatch()
static wxEventLoop *GetActive()
static void SetActive(wxEventLoop* loop)
bool IsRunning() const

// ==============================
// Class: wxEventLoopManual

%if(win) %class wxEventLoopManual, wxEventLoopBase
// abstract class
//wxEventLoopManual()
virtual int Run()
virtual void Exit(int rc = 0)

// ==============================
// Class: wxEventLoop

%class wxEventLoop, wxEventLoopBase
wxEventLoop()
virtual int Run()
virtual void Exit(int rc = 0)
virtual bool Pending() const
virtual bool Dispatch()

// ==============================
// Class: wxModalEventLoop

%class wxModalEventLoop, wxEventLoop
wxModalEventLoop(wxWindow *winModal)

// ==============================
// Class: wxEventLoopActivator

%class wxEventLoopActivator
wxEventLoopActivator(wxEventLoop *evtLoop)

///////////////////////////////////////////////////////////////////////////////
// DATA OBJECTS, CLIPBOARD SUPPORT
///////////////////////////////////////////////////////////////////////////////

// #########################################################
// dataobj.h

%include <wx/dataobj.h>

%builtin const wxDataFormat& wxFormatInvalid

// ==============================
// Class: wxDataObjectBase

%class wxDataObject

//Abstract Class!
//wxDataObject()
//virtual wxDataFormat GetPreferredFormat(wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
//virtual size_t GetFormatCount(wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
//virtual void GetAllFormats(wxDataFormat *formats, wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
%{
	// virtual wxDataFormat GetPreferredFormat(wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
	void wxDataObject_GetPreferredFormat()
	{
		int dir = (wTheCall->parmCount > 0 ? (int)wStackPopInteger() : 0x01);
		// make a pointer via copy constructor
		wxDataFormat *returns = new wxDataFormat(((wxDataObject *)(wTheCall->self->ptr))->GetPreferredFormat((wxDataObjectBase::Direction) dir));
		wWrapDerefArgs();
		wWrapPushObject( _wxDataFormat, W_TRUE, (void *)returns );
	}

	// virtual size_t GetFormatCount(wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
	void wxDataObject_GetFormatCount()
	{
		int dir = (wTheCall->parmCount > 0 ? (int)wStackPopInteger() : 0x01);
		size_t returns = ((wxDataObject *)(wTheCall->self->ptr))->GetFormatCount((wxDataObjectBase::Direction) dir);
		wWrapDerefArgs();
		wStackPushInteger( (wInteger)returns);
	}

	// virtual void GetAllFormats(wxDataFormat *formats, wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
	void wxDataObject_GetAllFormats()
	{
		int dir = (wTheCall->parmCount > 1 ? (int)wStackPopInteger() : 0x01);
		wxDataFormat *formats = (wxDataFormat *)wStackPopObjectPtr( _wxDataFormat);
		((wxDataObject *)(wTheCall->self->ptr))->GetAllFormats(formats, (wxDataObjectBase::Direction)dir);
		wWrapDerefArgs();
		wWrapPushObject( _wxDataFormat, W_TRUE, (void *)formats );
	}

%}
%method GetPreferredFormat wxDataObject_GetPreferredFormat(int dir = 0x01)
%method GetFormatCount wxDataObject_GetFormatCount(int dir = 0x01)
%method GetAllFormats wxDataObject_GetAllFormats(int dir = 0x01)

virtual size_t GetDataSize(const wxDataFormat& format) const
virtual bool GetDataHere(const wxDataFormat& format, void *buf) const
virtual bool SetData(const wxDataFormat& format, size_t len, const void * buf)

//bool IsSupported(const wxDataFormat& format, wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
%{
	// bool IsSupported(const wxDataFormat& format, wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
	void wxDataObject_IsSupported() {
		int dir = (wTheCall->parmCount > 1 ? (int)wStackPopInteger() : 0x01);
		wxDataFormat *format = (wxDataFormat *)wStackPopObjectPtr( _wxDataFormat);
		bool returns = ((wxDataObject *)(wTheCall->self->ptr))->IsSupported(*format, (wxDataObjectBase::Direction)dir);
		wWrapDerefArgs();
		wStackPushInteger( (wInteger)returns);
	}
%}
%method IsSupported wxDataObject_IsSupported(const wxDataFormat& format, int dir = 0x01)

//%not(gcc) %num %rename wxDataObjectBase_Direction_Get wxDataObjectBase::Direction::Get
//%not(gcc) %num %rename wxDataObjectBase_Direction_Set wxDataObjectBase::Direction::Set
//%not(gcc) %num %rename wxDataObjectBase_Direction_Both wxDataObjectBase::Direction::Both
%num %rename wxDataObject_Direction_Get 0x01
%num %rename wxDataObject_Direction_Set 0x02
%num %rename wxDataObject_Direction_Both 0x03

// ==============================
// Class: wxDataObjectSimple

%class %delete wxDataObjectSimple, wxDataObject
wxDataObjectSimple(const wxDataFormat& format = wxFormatInvalid)
const wxDataFormat& GetFormat() const
void SetFormat(const wxDataFormat& format)
virtual size_t GetDataSize() const
virtual bool GetDataHere(void *buf) const
virtual bool SetData(size_t len, const void *buf)
//virtual wxDataFormat GetPreferredFormat(wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
//virtual size_t GetFormatCount(wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
//virtual void GetAllFormats(wxDataFormat *formats, wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
%{
	// virtual wxDataFormat GetPreferredFormat(wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
	void wxDataObjectSimple_GetPreferredFormat() {
		int dir = (wTheCall->parmCount > 0 ? (int)wStackPopInteger() : 0x01);
		// make a pointer via copy constructor
		wxDataFormat *returns = new wxDataFormat(((wxDataObjectSimple *)(wTheCall->self->ptr))->GetPreferredFormat((wxDataObjectBase::Direction)dir));
		wWrapDerefArgs();
		wWrapPushObject( _wxDataFormat, W_TRUE, (void *)returns );
	}

	// virtual size_t GetFormatCount(wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
	void wxDataObjectSimple_GetFormatCount() {
		int dir = (wTheCall->parmCount > 0 ? (int)wStackPopInteger() : 0x01);
		size_t returns = ((wxDataObjectSimple *)(wTheCall->self->ptr))->GetFormatCount((wxDataObjectBase::Direction)dir);
		wWrapDerefArgs();
		wStackPushInteger( (wInteger)returns);
	}

	// virtual void GetAllFormats(wxDataFormat *formats, wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
	void wxDataObjectSimple_GetAllFormats() {
		int dir = (wTheCall->parmCount > 1 ? (int)wStackPopInteger() : 0x01);
		wxDataFormat *formats = (wxDataFormat *)wStackPopObjectPtr( _wxDataFormat);
		((wxDataObjectSimple *)(wTheCall->self->ptr))->GetAllFormats(formats, (wxDataObjectBase::Direction)dir);
		wWrapDerefArgs();
		wWrapPushObject( _wxDataFormat, W_TRUE, (void *)formats );
	}
%}
%method GetPreferredFormat wxDataObjectSimple_GetPreferredFormat(int dir = 0x01)
%method GetFormatCount wxDataObjectSimple_GetFormatCount(int dir = 0x01)
%method GetAllFormats wxDataObjectSimple_GetAllFormats(int dir = 0x01)

//TODO: Need wrapper / alias for this
//virtual size_t GetDataSize(const wxDataFormat& format) const
//virtual bool GetDataHere(const wxDataFormat& format, void *buf) const
//virtual bool SetData(const wxDataFormat& format, size_t len, const void *buf)

// ==============================
// Class: wxTextDataObject

%class %delete wxTextDataObject, wxDataObjectSimple
wxTextDataObject(const wxString& text = wxEmptyString)
virtual size_t GetTextLength() const
virtual wxString GetText() const
virtual void SetText(const wxString& text)
//RP: inherited from wxDataObject
//virtual size_t GetFormatCount(wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
//virtual void GetAllFormats(wxDataFormat *formats, wxDataObjectBase::Direction dir = wxDataObjectBase::Direction::Get) const
virtual size_t GetDataSize() const
virtual bool GetDataHere(void *buf) const
virtual bool SetData(size_t len, const void *buf)
//TODO: alias
//size_t GetDataSize(const wxDataFormat& format) const
//bool GetDataHere(const wxDataFormat& format, void *pBuf) const
//bool SetData(const wxDataFormat& format, size_t nLen, const void* pBuf)
//virtual size_t GetDataSize() const
//virtual bool GetDataHere(void *buf) const
//virtual bool SetData(size_t len, const void *buf)
//virtual size_t GetDataSize(const wxDataFormat&) const
//virtual bool GetDataHere(const wxDataFormat&, void *buf) const
//virtual bool SetData(const wxDataFormat&, size_t len, const void *buf)

// ==============================
// Class: wxBitmapDataObject

%class %delete wxBitmapDataObject, wxDataObjectSimple
wxBitmapDataObject(const wxBitmap& bitmap = wxNullBitmap)
virtual wxBitmap GetBitmap() const
virtual void SetBitmap(const wxBitmap& bitmap)

///////////////////////////////////////////////////////////////////////////////
// wxFileDataObject

%include <wx/dataobj.h>
%class %delete wxFileDataObject, wxDataObjectSimple
virtual void AddFile(const wxString& file)
const wxArrayString&   GetFilenames() const

// ==============================
// Class: wxURLDataObject

%class %delete wxURLDataObject, wxTextDataObject
wxURLDataObject(const wxString& url = wxEmptyString)
wxString GetURL() const
void SetURL(const wxString& url)

// #########################################################
// clipbrd.h

%include <wx/clipbrd.h>

// ==============================
// Class: wxClipboard

%class wxClipboard, wxObject
wxClipboard()
virtual bool Open()
virtual void Close()
virtual bool IsOpened() const
virtual bool SetData( wxDataObject *data )
virtual bool AddData( wxDataObject *data )
virtual bool IsSupported( const wxDataFormat& format )
//TODO: Need wrapper: GetText, GetBitmap, GetURL, GetFilenames
virtual bool GetData( wxDataObject& data )
%{
	void wxClipboard_GetText() {
		wxTextDataObject data;
		bool returns = ((wxClipboard *)(wTheCall->self->ptr))->GetData(data);
		wWrapDerefArgs();
		wStackPushChar( (char *)(data.GetText().char_str()), W_TRUE );
	}
%}
%method GetText wxClipboard_GetText()
virtual void Clear()
virtual bool Flush()
void UsePrimarySelection( bool primary = false )

%ptr wxTheClipboard

// ==============================
// Class: wxClipboardTextEvent

%class %delete wxClipboardTextEvent, wxCommandEvent

%event wxEVT_COMMAND_TEXT_COPY
%event wxEVT_COMMAND_TEXT_CUT
%event wxEVT_COMMAND_TEXT_PASTE

wxClipboardTextEvent(wxEventType type = wxEVT_NULL, wxWindowID winid = 0)
//wxClipboardTextEvent(const wxClipboardTextEvent & event)
%not(bcc) virtual wxEvent *Clone() const

///////////////////////////////////////////////////////////////////////////////
// FIND & REPLACE
///////////////////////////////////////////////////////////////////////////////

// #########################################################
// except.h
//%include <wx/except.h>

// #########################################################
// fdrepdlg.h

%include <wx/fdrepdlg.h>

%enum wxFindReplaceFlags
  %num wxFR_DOWN
  %num wxFR_WHOLEWORD
  %num wxFR_MATCHCASE

%enum wxFindReplaceDialogStyles
  %num wxFR_REPLACEDIALOG
  %num wxFR_NOUPDOWN
  %num wxFR_NOMATCHCASE
  %num wxFR_NOWHOLEWORD

// ==============================
// Class: wxFindReplaceData

%class %delete wxFindReplaceData, wxObject
//wxFindReplaceData()
wxFindReplaceData(wxUint32 flags)
const wxString& GetFindString()
const wxString& GetReplaceString()
int GetFlags() const
void SetFlags(wxUint32 flags)
void SetFindString(const wxString& str)
void SetReplaceString(const wxString& str)

// ==============================
// Class: wxFindReplaceDialog (Base)

%class wxFindReplaceDialog, wxDialog
//wxFindReplaceDialog()
wxFindReplaceDialog(wxWindow * parent, wxFindReplaceData *data, const wxString& title, int style = 0)
const wxFindReplaceData *GetData() const
void SetData(wxFindReplaceData *data)
void Send(wxFindDialogEvent& event)

// %num wxGenericFindReplaceDialog

// ==============================
// Class: wxFindDialogEvent

%class %delete wxFindDialogEvent, wxCommandEvent
wxFindDialogEvent(wxEventType commandType = wxEVT_NULL, int id = 0)
int GetFlags() const
wxString GetFindString() const
const wxString& GetReplaceString() const
wxFindReplaceDialog *GetDialog() const
void SetFlags(int flags)
void SetFindString(const wxString& str)
void SetReplaceString(const wxString& str)

%event wxEVT_COMMAND_FIND
%event wxEVT_COMMAND_FIND_NEXT
%event wxEVT_COMMAND_FIND_REPLACE
%event wxEVT_COMMAND_FIND_REPLACE_ALL
%event wxEVT_COMMAND_FIND_CLOSE

///////////////////////////////////////////////////////////////////////////////
// Window Layout, SIZERS
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
// wxSizerFlags

%include <wx/sizer.h>

%class %delete wxSizerFlags
wxSizerFlags(int proportion = 0)
wxSizerFlags&   Align(int align = 0)
wxSizerFlags&   Border(int direction, int borderinpixels)
wxSizerFlags&   Center()
wxSizerFlags&   Centre()
wxSizerFlags&   DoubleBorder(int direction = wxALL)
wxSizerFlags&   DoubleHorzBorder()
wxSizerFlags&   Expand()
static int GetDefaultBorder()
wxSizerFlags&   Left()
wxSizerFlags&   FixedMinSize()
wxSizerFlags&   Proportion(int proportion = 0)
wxSizerFlags&   ReserveSpaceEvenIfHidden()
wxSizerFlags&   Right()
wxSizerFlags&   Shaped()
wxSizerFlags&   TripleBorder(int direction = wxALL)

%builtin %rename wxSizerFlags_GetDefaultBorder int wxSizerFlags::GetDefaultBorder()

///////////////////////////////////////////////////////////////////////////////
// wxSizer

%include <wx/sizer.h>

%class wxSizerItemList, wxList
%class wxSizerItem
%class wxSizer, wxObject

// Abstract, so can't create directly
// wxSizer()
// use aliases here...
%rename AddWindow void Add(wxWindow* window, int option = 0,int flag = 0, int border = 0, wxObject* userData = NULL)
%rename AddSizer void Add(wxSizer* sizer, int option = 0, int flag = 0, int border = 0, wxObject* userData = NULL)
void Add(int width, int height, int option = 0, int flag = 0, int border = 0, wxObject* userData = NULL)

wxSize CalcMin()
void Fit(wxWindow* window)
wxSize GetSize()
wxPoint GetPosition()
wxSize GetMinSize()
void Layout()

// use aliases here...
%rename PrependWindow void Prepend(wxWindow* window, int option = 0, int flag = 0, int border = 0, wxObject* userData = NULL)
%rename PrependSizer void Prepend(wxSizer* sizer, int option = 0, int flag = 0, int border = 0, wxObject* userData = NULL)
void Prepend(int width, int height, int option = 0, int flag = 0, int border= 0, wxObject* userData = NULL)
void RecalcSizes()

// use aliases here...
%rename RemoveWindow bool Remove(wxWindow* window)
%rename RemoveSizer bool Remove(wxSizer* sizer)
bool Remove(int nth)

void SetDimension(int x, int y, int width, int height)
// alias...
void SetMinSize(int width, int height)
// Fix: size is not a pointer. hrm...
// %rename SetMinSizeSize void SetMinSize(wxSize size)

// alias
%rename SetWindowMinSize void SetItemMinSize(wxWindow* window, int width, int height)
%rename SetSizerMinSize void SetItemMinSize(wxSizer* sizer, int width, int height)
void SetItemMinSize(int pos, int width, int height)

void SetSizeHints(wxWindow* window)

wxSizerItem*  AddSpacer(int size)
wxSizerItem*  AddStretchSpacer(int prop = 1)
void Clear(bool delete_windows = false)
wxSize  ComputeFittingClientSize(wxWindow* window)
wxSize  ComputeFittingWindowSize(wxWindow* window)
bool Detach(wxWindow* window)
void FitInside(wxWindow* window)
wxSizerItemList& GetChildren()
wxWindow *  GetContainingWindow() const
wxSizerItem *  GetItem(wxWindow* window, bool recursive = false)
bool Hide(wxWindow* window, bool recursive = false)
wxSizerItem*  Insert(size_t index, wxWindow* window, const wxSizerFlags& flags)
wxSizerItem*  InsertSpacer(size_t index, int size)
wxSizerItem*  InsertStretchSpacer(size_t index, int prop = 1)
bool IsShown(wxWindow* window) const
wxSizerItem*  PrependSpacer(int size)
wxSizerItem*  PrependStretchSpacer(int prop = 1)
bool Replace(wxWindow* oldwin, wxWindow* newwin, bool recursive = false)
void SetVirtualSizeHints(wxWindow* window)
bool Show(wxWindow* window, bool show = true, bool recursive = false)

%num %alias wxCENTER wxCENTRE
%num wxHORIZONTAL
%num wxVERTICAL
%num wxBOTH
%num wxLEFT
%num wxRIGHT
%num wxUP
%num wxDOWN
%num wxTOP
%num wxBOTTOM
%num wxNORTH
%num wxSOUTH
%num wxWEST
%num wxEAST
%num wxALL

%num wxALIGN_NOT
%num %alias wxALIGN_CENTER_HORIZONTAL wxALIGN_CENTRE_HORIZONTAL
%num %alias wxALIGN_CENTER_VERTICAL wxALIGN_CENTRE_VERTICAL
%num wxALIGN_LEFT
%num wxALIGN_TOP
%num wxALIGN_RIGHT
%num wxALIGN_BOTTOM
%num wxALIGN_MASK

%num wxSTRETCH_NOT
%num wxSHRINK
%num wxGROW
%num wxEXPAND
%num wxSHAPED
%num wxFIXED_MINSIZE
%num wxTILE
%num wxADJUST_MINSIZE

%num wxBORDER_DEFAULT
%num wxBORDER_NONE
%num wxBORDER_STATIC
%num wxBORDER_SIMPLE
%num wxBORDER_RAISED
%num wxBORDER_SUNKEN
%num wxBORDER_DOUBLE
%num wxBORDER_MASK

///////////////////////////////////////////////////////////////////////////////
// wxGridSizer

%class wxGridSizer, wxSizer

// alias...
wxGridSizer(int cols, int rows, int vgap, int hgap)
// wxGridSizer(int cols, int vgap = 0, int hgap = 0)
int GetCols()
int GetHGap()
int GetRows()
int GetVGap()
void SetCols(int cols)
void SetHGap(int gap)
void SetRows(int rows)
void SetVGap(int gap)

///////////////////////////////////////////////////////////////////////////////
// wxFlexGridSizer

%class wxFlexGridSizer, wxGridSizer

%enum wxFlexSizerGrowMode

// alias...
wxFlexGridSizer(int rows, int cols, int vgap = 0, int hgap = 0)
%ctor wxFlexGridSizerColsOnly(int cols, int vgap = 0, int hgap = 0)
void AddGrowableCol(size_t idx, int proportion = 0)
void AddGrowableRow(size_t idx, int proportion = 0)
int GetFlexibleDirection() const
int GetNonFlexibleGrowMode() const
void RemoveGrowableCol(size_t idx)
void RemoveGrowableRow(size_t idx)
void SetFlexibleDirection(int direction)
void SetNonFlexibleGrowMode(wxFlexSizerGrowMode mode)

///////////////////////////////////////////////////////////////////////////////
// wxGridBagSizer

%include <wx/gbsizer.h>
%class wxGridBagSizer, wxFlexGridSizer
wxGridBagSizer(int vgap = 0, int hgap = 0)
wxSizerItem*  Add(wxWindow* window, const wxGBPosition& pos, const wxGBSpan& span = wxDefaultSpan, int flag = 0, int border = 0, wxObject* userData = NULL)
wxSize  CalcMin()
bool CheckForIntersection(wxGBSizerItem* item, wxGBSizerItem* excludeItem = NULL)
wxGBSizerItem*  FindItem(wxWindow* window)
wxGBSizerItem*  FindItemAtPoint(const wxPoint& pt)
wxGBSizerItem*  FindItemAtPosition(const wxGBPosition& pos)
wxGBSizerItem*  FindItemWithData(const wxObject* userData)
wxSize  GetCellSize(int row, int col) const
wxSize  GetEmptyCellSize() const
wxGBPosition  GetItemPosition(wxWindow* window)
wxGBSpan  GetItemSpan(wxWindow* window)
void RecalcSizes()
void SetEmptyCellSize(const wxSize& sz)
bool SetItemPosition(wxWindow* window, const wxGBPosition& pos)
bool SetItemSpan(wxWindow* window, const wxGBSpan& span)

///////////////////////////////////////////////////////////////////////////////
// wxGBPosition

%include <wx/gbsizer.h>
%class wxGBPosition
%ctor wxGBPositionEmpty()
wxGBPosition(int row, int col)

int GetCol() const
int GetRow() const
void SetCol(int col)
void SetRow(int row)
//bool operator!(const wxGBPosition& p) const
//bool operator operator==(const wxGBPosition& p) const

///////////////////////////////////////////////////////////////////////////////
// wxGBSpan

%include <wx/gbsizer.h>
%class wxGBSpan
%ctor wxGBSpanEmpty()
wxGBSpan(int rowspan, int colspan)

int GetColspan() const
int GetRowspan() const
void SetColspan(int colspan)
void SetRowspan(int rowspan)
//bool operator!(const wxGBSpan& o) const
//bool operator operator==(const wxGBSpan& o) const

///////////////////////////////////////////////////////////////////////////////
// wxGBSizerItem

%include <wx/gbsizer.h>
%class wxGBSizerItem, wxSizerItem
wxGBSizerItem(int width, int height, const wxGBPosition& pos, const wxGBSpan& span, int flag, int border, wxObject* userData)
void GetEndPos(int& row, int& col)
wxGBPosition  GetPos() const
wxGBSpan  GetSpan() const
bool Intersects(const wxGBSizerItem& other)
bool SetPos(const wxGBPosition& pos)
bool SetSpan(const wxGBSpan& span)

///////////////////////////////////////////////////////////////////////////////
// wxBoxSizer

%class wxBoxSizer, wxSizer

wxBoxSizer(int orient)
void RecalcSizes()
wxSize CalcMin()
int GetOrientation()

///////////////////////////////////////////////////////////////////////////////
// wxStaticBoxSizer

%class wxStaticBoxSizer, wxBoxSizer

wxStaticBoxSizer(wxStaticBox* box, int orient)
wxStaticBox* GetStaticBox()

///////////////////////////////////////////////////////////////////////////////
// wxIndividualLayoutConstraint

%class wxIndividualLayoutConstraint, wxObject

// Fixed: should not have had 'void'
wxIndividualLayoutConstraint()
// void Above(wxWindow *otherWin, int margin = 0)
void Absolute(int value)
void AsIs()
// void Below(wxWindow *otherWin, int margin = 0)
void Unconstrained()
void LeftOf(wxWindow *otherWin, int margin = 0)
void PercentOf(wxWindow *otherWin, wxEdge edge, int per)
void RightOf(wxWindow *otherWin, int margin = 0)
void SameAs(wxWindow *otherWin, wxEdge edge, int margin = 0)
void Set(wxRelationship rel, wxWindow *otherWin, wxEdge otherEdge, int value = 0, int margin = 0)


///////////////////////////////////////////////////////////////////////////////
// wxLayoutConstraints

%class wxLayoutConstraints, wxObject
%include "wx/layout.h"

wxLayoutConstraints()
wxIndividualLayoutConstraint bottom
wxIndividualLayoutConstraint centreX
wxIndividualLayoutConstraint centreY
wxIndividualLayoutConstraint height
wxIndividualLayoutConstraint left
wxIndividualLayoutConstraint right
wxIndividualLayoutConstraint top
wxIndividualLayoutConstraint width

///////////////////////////////////////////////////////////////////////////////
// wxTimer

%class %delete wxTimer, wxObject
%include "wx/timer.h"

wxTimer(wxEvtHandler *owner, int id = -1)
bool IsOneShot() const
bool IsRunning() const
void Notify()
void SetOwner(wxEvtHandler *owner, int id = -1)
bool Start(int milliseconds = -1, bool oneShot=FALSE)
void Stop()
int GetInterval() const

// #########################################################
// timer.h

%include <wx/timer.h>

%num wxTIMER_CONTINUOUS
%num wxTIMER_ONE_SHOT

// ==============================
// Class: wxTimerBase

%class wxTimerBase, wxEvtHandler
//RP: abstract class
//wxTimerBase()
//wxTimerBase(wxEvtHandler *owner, int timerid = wxID_ANY)
void SetOwner(wxEvtHandler *owner, int timerid = wxID_ANY)
wxEvtHandler *GetOwner() const
virtual bool Start(int milliseconds = -1, bool oneShot = false)
virtual void Stop()
virtual void Notify()
virtual bool IsRunning() const
int GetId() const
int GetInterval() const
bool IsOneShot() const

// ==============================
// Class: wxTimerRunner

%class wxTimerRunner
//wxTimerRunner(wxTimer& timer)
wxTimerRunner(wxTimer& timer, int milli, bool oneShot = false)
void Start(int milli, bool oneShot = false)

// ==============================
// Class: wxTimerEvent

%class %delete wxTimerEvent, wxEvent

%event wxEVT_TIMER

wxTimerEvent(int timerid = 0, int interval = 0)
int GetInterval() const
%not(bcc) virtual wxEvent *Clone() const

///////////////////////////////////////////////////////////////////////////////
// wxHtmlHelpData

%include <wx/html/helpdata.h>
%class wxHtmlBookRecArray
%class wxHtmlHelpDataItems

%class %delete wxHtmlHelpData, wxObject
wxHtmlHelpData()
bool AddBook(const wxString& book_url)
wxString  FindPageById(int id)
wxString  FindPageByName(const wxString& page)
const wxHtmlBookRecArray& GetBookRecArray()
const wxHtmlHelpDataItems& GetContentsArray()
const wxHtmlHelpDataItems& GetIndexArray()
void SetTempDir(const wxString& path)

// #########################################################
// help.h

%include <wx/help.h>

//%num wxHelpController

// #########################################################
// helpbase.h

%include <wx/helpbase.h>

%num wxHELP_NETSCAPE

%enum wxHelpSearchMode
  %num wxHELP_SEARCH_INDEX
  %num wxHELP_SEARCH_ALL

// ==============================
// Class: wxHelpControllerBase

%class %delete wxHelpControllerBase, wxObject
//inline wxHelpControllerBase(wxWindow* parentWindow = NULL)
//inline ~wxHelpControllerBase()
//virtual bool Initialize(const wxString& WXUNUSED(file), int WXUNUSED(server) )
virtual bool Initialize(const wxString& file)
virtual void SetViewer(const wxString& viewer, long flags = 0)
virtual bool LoadFile(const wxString& file = wxEmptyString)
virtual bool DisplayContents()
%rename DisplaySectionByID bool DisplaySection(int sectionNo)
virtual bool DisplayContextPopup(int contextId)
virtual bool DisplayTextPopup(const wxString& text, const wxPoint& pos)
virtual bool DisplaySection(const wxString& section)
virtual bool DisplayBlock(long blockNo)
virtual bool KeywordSearch(const wxString& k, wxHelpSearchMode mode = wxHELP_SEARCH_ALL)
// virtual void SetFrameParameters(const wxString& title, const wxSize& size, const wxPoint& pos = wxDefaultPosition, bool newFrameEachTime = false)
// virtual wxFrame *GetFrameParameters(wxSize *size = NULL, wxPoint *pos = NULL, bool *newFrameEachTime = NULL)
virtual bool Quit()
//virtual void OnQuit()
virtual void SetParentWindow(wxWindow* win)
virtual wxWindow* GetParentWindow() const

// platform dependant Help Controller
//%class wxHelpController, wxHelpControllerBase

// #########################################################
// helpctrl.h

%include <wx/html/helpctrl.h>

%num wxHF_EMBEDDED
%num wxHF_DIALOG
%num wxHF_FRAME
%num wxHF_MODAL

// #########################################################
// helpbest.h

// ==============================
// Class: wxBestHelpController

%if(win) %class wxBestHelpController, wxHelpControllerBase
%include <wx/msw/helpbest.h>

wxBestHelpController(wxWindow* parentWindow = NULL, int style = wxHF_DEFAULT_STYLE)
virtual bool Initialize(const wxString& file)
//virtual bool Initialize(const wxString& file, int WXUNUSED(server) )
virtual bool LoadFile(const wxString& file = wxEmptyString)
virtual bool DisplayContents()
%rename DisplaySectionById bool DisplaySection(int sectionNo)
virtual bool DisplaySection(const wxString& section)
virtual bool DisplayBlock(long blockNo)
virtual bool DisplayContextPopup(int contextId)
virtual bool DisplayTextPopup(const wxString& text, const wxPoint& pos)
virtual bool KeywordSearch(const wxString& k, wxHelpSearchMode mode = wxHELP_SEARCH_ALL)
virtual bool Quit()
virtual void SetFrameParameters(const wxString& title, const wxSize& size, const wxPoint& pos = wxDefaultPosition, bool newFrameEachTime = false)
virtual wxFrame *GetFrameParameters(wxSize *size = NULL, wxPoint *pos = NULL, bool *newFrameEachTime = NULL)
virtual void SetParentWindow(wxWindow* win)
virtual wxWindow* GetParentWindow() const

// #########################################################
// helpchm.h

// ==============================
// Class: wxCHMHelpController

%if(win) %class wxCHMHelpController, wxHelpControllerBase
%include <wx/msw/helpchm.h>

wxCHMHelpController(wxWindow* parentWindow = NULL)
virtual bool Initialize(const wxString& file)
//virtual bool Initialize(const wxString& file, int WXUNUSED(server) )
virtual bool LoadFile(const wxString& file = wxEmptyString)
virtual bool DisplayContents()
%rename DisplaySectionById bool DisplaySection(int sectionNo)
virtual bool DisplaySection(const wxString& section)
virtual bool DisplayBlock(long blockNo)
virtual bool DisplayContextPopup(int contextId)
virtual bool DisplayTextPopup(const wxString& text, const wxPoint& pos)
virtual bool KeywordSearch(const wxString& k, wxHelpSearchMode mode = wxHELP_SEARCH_ALL)
virtual bool Quit()
wxString GetHelpFile() const
static bool ShowContextHelpPopup(const wxString& text, const wxPoint& pos, wxWindow *window)

// #########################################################
// helpwin.h

// ==============================
// Class: wxWinHelpController

%if(win) %class wxWinHelpController, wxHelpControllerBase
%include <wx/msw/helpwin.h>

wxWinHelpController(wxWindow* parentWindow = NULL)
virtual bool Initialize(const wxString& file)
//virtual bool Initialize(const wxString& file, int WXUNUSED(server) )
virtual bool LoadFile(const wxString& file = wxEmptyString)
virtual bool DisplayContents()
%rename DisplaySectionById bool DisplaySection(int sectionNo)
virtual bool DisplaySection(const wxString& section)
virtual bool DisplayBlock(long blockNo)
virtual bool DisplayContextPopup(int contextId)
virtual bool KeywordSearch(const wxString& k, wxHelpSearchMode mode = wxHELP_SEARCH_ALL)
virtual bool Quit()
wxString GetHelpFile() const

///////////////////////////////////////////////////////////////////////////////
// wxHtmlHelpController
//
// The zip filesystem is needed to read the zipped help file.

%include <wx/html/helpctrl.h>

%class wxHtmlHelpWindow, wxWindow
%class wxHtmlHelpFrame, wxFrame
//can't finalize
//%class wxHtmlHelpDialog, wxDialog

//%class wxHtmlHelpController, wxHelpControllerBase
%class %delete wxHtmlHelpController, wxObject
%include "wx/wxhtml.h"
%include "wx/fs_zip.h"

wxHtmlHelpController(int style = wxHF_DEFAULT_STYLE, wxWindow* parentWindow = NULL)
%rename AddBookFileName bool AddBook(const wxFileName& book_file, bool show_wait_msg)
bool AddBook(const wxString& book, bool show_wait_msg)
// Protected Members
//virtual wxHtmlHelpFrame* CreateHelpFrame(wxHtmlHelpData * data)
//virtual wxHtmlHelpDialog*  CreateHelpDialog(wxHtmlHelpData * data)
void Display(const wxString& x)
%rename DisplayId void Display(const int id)
void DisplayContents()
void DisplayIndex()
bool KeywordSearch(const wxString& keyword, wxHelpSearchMode mode = wxHELP_SEARCH_ALL)
void ReadCustomization(wxConfigBase* cfg, wxString path = wxEmptyString)
void SetTempDir(const wxString& path)
void SetTitleFormat(const wxString& format)
void UseConfig(wxConfigBase* config, const wxString& rootpath = wxEmptyString)
void WriteCustomization(wxConfigBase* cfg, wxString path = wxEmptyString)

wxHtmlHelpWindow* GetHelpWindow()
void SetHelpWindow(wxHtmlHelpWindow* helpWindow)
wxHtmlHelpFrame* GetFrame()
//wxHtmlHelpDialog* GetDialog()
//virtual bool Initialize(const wxString& file, int server )
virtual bool Initialize(const wxString& file)
virtual void SetViewer(const wxString& viewer, long flags = 0)
virtual bool LoadFile(const wxString& file = wxT(""))
%rename DisplaySectionById bool DisplaySection(int sectionNo)
virtual bool DisplaySection(const wxString& section)
virtual bool DisplayBlock(long blockNo)
virtual bool DisplayTextPopup(const wxString& text, const wxPoint& pos)
virtual void SetFrameParameters(const wxString& title, const wxSize& size, const wxPoint& pos = wxDefaultPosition, bool newFrameEachTime = false)
virtual wxFrame *GetFrameParameters(wxSize *size = NULL, wxPoint *pos = NULL, bool *newFrameEachTime = NULL)
wxHtmlHelpData *GetHelpData()
virtual bool Quit()
//virtual void OnQuit()
//void OnCloseFrame(wxCloseEvent& evt)
void MakeModalIfNeeded()
wxWindow* FindTopLevelWindow()

// ==============================
// Class: wxHtmlModalHelp

%class wxHtmlModalHelp
wxHtmlModalHelp(wxWindow* parent, const wxString& helpFile, const wxString& topic = wxEmptyString, int style = wxHF_DEFAULT_STYLE | wxHF_DIALOG | wxHF_MODAL)

///////////////////////////////////////////////////////////////////////////////
// wxGrid Classes
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// wxGridCellAttr

// can not use this class!!!
// because some very scarry programer made ~class protected

%include <wx/grid.h>
%if(false) %class wxGridCellAttr
// TODO: just because ~wxGridCellAttr is protected, idiots!
//wxGridCellAttr()
wxGridCellAttr*  Clone() const
void IncRef()
void DecRef()
void SetTextColour(const wxColour& colText)
void SetBackgroundColour(const wxColour& colBack)
void SetFont(const wxFont& font)
void SetAlignment(int hAlign, int vAlign)
void SetReadOnly(bool isReadOnly = true)
void SetRenderer(wxGridCellRenderer* renderer)
%if(false) void SetEditor(wxGridCellEditor* editor)
bool HasTextColour() const
bool HasBackgroundColour() const
bool HasFont() const
bool HasAlignment() const
bool HasRenderer() const
bool HasEditor() const
const wxColour&  GetTextColour() const
const wxColour&  GetBackgroundColour() const
const wxFont&  GetFont() const
void GetAlignment(int* hAlign, int* vAlign) const
wxGridCellRenderer*  GetRenderer(wxGrid* grid, int row, int col) const
%if(false) wxGridCellEditor*  GetEditor(wxGrid* grid, int row, int col) const
bool IsReadOnly() const
void SetDefAttr(wxGridCellAttr* defAttr)

///////////////////////////////////////////////////////////////////////////////
// wxGridCellEditor

%include <wx/grid.h>
%if(false) %class wxGridCellEditor
//Abstract class
//wxGridCellEditor()
bool IsCreated()
void Create(wxWindow* parent, wxWindowID id, wxEvtHandler* evtHandler)
void SetSize(const wxRect& rect)
%if(false) void Show(bool show, wxGridCellAttr* attr = NULL)
%if(false) void PaintBackground(const wxRect& rectCell, wxGridCellAttr* attr)
void BeginEdit(int row, int col, wxGrid* grid)
bool EndEdit(int row, int col, wxGrid* grid)
void Reset()
void StartingKey(wxKeyEvent& event)
void StartingClick()
void HandleReturn(wxKeyEvent& event)
void Destroy()
wxGridCellEditor*  Clone() const
// ~wxGridCellEditor()

///////////////////////////////////////////////////////////////////////////////
// wxGridCellBoolEditor

%include <wx/grid.h>
%class %delete wxGridCellBoolEditor
//, wxGridCellEditor
wxGridCellBoolEditor()
static bool IsTrueValue(const wxString& value)
static void UseStringValues(const wxString& valueTrue = wxT("1"), const wxString& valueFalse = wxT(""))

// from wxGridCellditor
bool IsCreated()
void Create(wxWindow* parent, wxWindowID id, wxEvtHandler* evtHandler)
void SetSize(const wxRect& rect)
void BeginEdit(int row, int col, wxGrid* grid)
bool EndEdit(int row, int col, wxGrid* grid)
void Reset()
void StartingKey(wxKeyEvent& event)
void StartingClick()
void HandleReturn(wxKeyEvent& event)
void Destroy()

%builtin %rename wxGridCellBoolEditor_IsTrueValue bool wxGridCellBoolEditor::IsTrueValue(const wxString& value)
%builtin %rename wxGridCellBoolEditor_UseStringValues void wxGridCellBoolEditor::UseStringValues(const wxString& valueTrue = wxT("1"), const wxString& valueFalse = wxT(""))

///////////////////////////////////////////////////////////////////////////////
// wxGridCellChoiceEditor

%class %delete wxGridCellChoiceEditor
//, wxGridCellEditor
//TODO: handle choices[]
//wxGridCellChoiceEditor(size_t count = 0, const wxString choices[] = NULL, bool allowOthers = false)
void SetParameters(const wxString& params)

// from wxGridCellditor
bool IsCreated()
void Create(wxWindow* parent, wxWindowID id, wxEvtHandler* evtHandler)
void SetSize(const wxRect& rect)
void BeginEdit(int row, int col, wxGrid* grid)
bool EndEdit(int row, int col, wxGrid* grid)
void Reset()
void StartingKey(wxKeyEvent& event)
void StartingClick()
void HandleReturn(wxKeyEvent& event)
void Destroy()

///////////////////////////////////////////////////////////////////////////////
// wxGridCellTextEditor

%include <wx/grid.h>
%class %delete wxGridCellTextEditor
//, wxGridCellEditor
wxGridCellTextEditor()
void SetParameters(const wxString& params)

// from wxGridCellditor
bool IsCreated()
void Create(wxWindow* parent, wxWindowID id, wxEvtHandler* evtHandler)
void SetSize(const wxRect& rect)
void BeginEdit(int row, int col, wxGrid* grid)
bool EndEdit(int row, int col, wxGrid* grid)
void Reset()
void StartingKey(wxKeyEvent& event)
void StartingClick()
void HandleReturn(wxKeyEvent& event)
void Destroy()

///////////////////////////////////////////////////////////////////////////////
// wxGridCellFloatEditor

%include <wx/grid.h>
%class %delete wxGridCellFloatEditor, wxGridCellTextEditor
wxGridCellFloatEditor(int width = -1, int precision = -1)
void SetParameters(const wxString& params)

// from wxGridCellditor
bool IsCreated()
void Create(wxWindow* parent, wxWindowID id, wxEvtHandler* evtHandler)
void SetSize(const wxRect& rect)
void BeginEdit(int row, int col, wxGrid* grid)
bool EndEdit(int row, int col, wxGrid* grid)
void Reset()
void StartingKey(wxKeyEvent& event)
void StartingClick()
void HandleReturn(wxKeyEvent& event)
void Destroy()

///////////////////////////////////////////////////////////////////////////////
// wxGridCellNumberEditor

%include <wx/grid.h>
%class %delete wxGridCellNumberEditor, wxGridCellTextEditor
wxGridCellNumberEditor(int min = -1, int max = -1)
//protected
//wxString  GetString() const
//bool HasRange() const
void SetParameters(const wxString& params)

// from wxGridCellditor
bool IsCreated()
void Create(wxWindow* parent, wxWindowID id, wxEvtHandler* evtHandler)
void SetSize(const wxRect& rect)
void BeginEdit(int row, int col, wxGrid* grid)
bool EndEdit(int row, int col, wxGrid* grid)
void Reset()
void StartingKey(wxKeyEvent& event)
void StartingClick()
void HandleReturn(wxKeyEvent& event)
void Destroy()

///////////////////////////////////////////////////////////////////////////////
// wxGridTableBase

%include <wx/grid.h>
%class wxGridTableBase, wxObject
// Abstract class
//wxGridTableBase()
// ~wxGridTableBase()
int GetNumberRows()
int GetNumberCols()
bool IsEmptyCell(int row, int col)
wxString  GetValue(int row, int col)
void SetValue(int row, int col, const wxString& value)
wxString  GetTypeName(int row, int col)
bool CanGetValueAs(int row, int col, const wxString& typeName)
bool CanSetValueAs(int row, int col, const wxString& typeName)
long GetValueAsLong(int row, int col)
double GetValueAsDouble(int row, int col)
bool GetValueAsBool(int row, int col)
void SetValueAsLong(int row, int col, long value)
void SetValueAsDouble(int row, int col, double value)
void SetValueAsBool(int row, int col, bool value)
void* GetValueAsCustom(int row, int col, const wxString& typeName)
void SetValueAsCustom(int row, int col, const wxString& typeName, void* value)
void SetView(wxGrid* grid)
wxGrid *  GetView() const
void Clear()
bool InsertRows(size_t pos = 0, size_t numRows = 1)
bool AppendRows(size_t numRows = 1)
bool DeleteRows(size_t pos = 0, size_t numRows = 1)
bool InsertCols(size_t pos = 0, size_t numCols = 1)
bool AppendCols(size_t numCols = 1)
bool DeleteCols(size_t pos = 0, size_t numCols = 1)
wxString  GetRowLabelValue(int row)
wxString  GetColLabelValue(int col)
void SetRowLabelValue(int row, const wxString& s)
void SetColLabelValue(int col, const wxString& s)
void SetAttrProvider(wxGridCellAttrProvider* attrProvider)
wxGridCellAttrProvider* GetAttrProvider() const
bool CanHaveAttributes()
//void UpdateAttrRows(size_t pos, int numRows)
//void UpdateAttrCols(size_t pos, int numCols)
%if(false) wxGridCellAttr*  GetAttr(int row, int col, wxGridCellAttr::wxAttrKind  kind)
%if(false) void SetAttr(wxGridCellAttr* attr, int row, int col)
%if(false) void SetRowAttr(wxGridCellAttr* attr, int row)
%if(false) void SetColAttr(wxGridCellAttr* attr, int col)

///////////////////////////////////////////////////////////////////////////////

%include <wx/grid.h>

//TODO

%class %delete wxGridCellAttrProvider
%class wxGridCellCoordsArray
%class %delete wxGridCellRenderer
%class %delete wxGridCellCoords

///////////////////////////////////////////////////////////////////////////////
// wxGrid

%include <wx/grid.h>

//%if(false)

%num wxGRID_AUTOSIZE

%class wxGrid, wxScrolledWindow

%enum wxGridSelectionModes
  %num %rename wxGridSelectCells wxGrid::wxGridSelectCells
  %num %rename wxGridSelectRows wxGrid::wxGridSelectRows
  %num %rename wxGridSelectColumns wxGrid::wxGridSelectColumns

// ---- control IDs
%num %rename wxGRID_CELLCTRL wxGrid::wxGRID_CELLCTRL
%num %rename wxGRID_TOPCTRL wxGrid::wxGRID_TOPCTRL

// --- control types
%num %rename wxGRID_TEXTCTRL wxGrid::wxGRID_TEXTCTRL
%num %rename wxGRID_CHECKBOX wxGrid::wxGRID_CHECKBOX
%num %rename wxGRID_CHOICE wxGrid::wxGRID_CHOICE
%num %rename wxGRID_COMBOBOX wxGrid::wxGRID_COMBOBOX

wxGrid( wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxWANTS_CHARS, const wxString& name = wxGridNameStr )
%ctor wxGridNoCreate()
bool Create( wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxWANTS_CHARS, const wxString& name = wxGridNameStr )

bool CreateGrid(int numRows, int numCols, wxGrid::wxGridSelectionModes selmode = wxGrid::wxGridSelectCells )
void SetSelectionMode(wxGrid::wxGridSelectionModes selmode)
wxGrid::wxGridSelectionModes GetSelectionMode() const

int GetNumberRows()
int GetNumberCols()

wxGridTableBase * GetTable()
bool SetTable( wxGridTableBase *table, bool takeOwnership = false, wxGrid::wxGridSelectionModes selmode = wxGrid::wxGridSelectCells )

void ClearGrid()
bool InsertRows( int pos = 0, int numRows = 1, bool updateLabels = true )
bool AppendRows( int numRows = 1, bool updateLabels = true )
bool DeleteRows( int pos = 0, int numRows = 1, bool updateLabels = true )
bool InsertCols( int pos = 0, int numCols = 1, bool updateLabels = true )
bool AppendCols( int numCols = 1, bool updateLabels = true )
bool DeleteCols( int pos = 0, int numCols = 1, bool updateLabels = true )

void BeginBatch()
void EndBatch()
int GetBatchCount()
virtual void Refresh(bool eraseb = true, const wxRect* rect = NULL)
void ForceRefresh();
// ------ edit control functions
bool IsEditable()
void EnableEditing( bool edit )

void EnableCellEditControl( bool enable = true )
void DisableCellEditControl()
bool CanEnableCellControl() const
bool IsCellEditControlEnabled() const
bool IsCellEditControlShown() const

bool IsCurrentCellReadOnly() const

void ShowCellEditControl()
void HideCellEditControl()
void SaveEditControlValue()

// ------ grid location functions
// TODO: needs wrapper
void XYToCell( int x, int y, wxGridCellCoords& coords )
int  YToRow( int y )
int  XToCol( int x, bool clipToMinMax = false )

int  YToEdgeOfRow( int y )
int  XToEdgeOfCol( int x )

wxRect CellToRect( int row, int col )
//wxRect CellToRect( const wxGridCellCoords& coords )

int  GetGridCursorRow()
int  GetGridCursorCol()

bool IsVisible( int row, int col, bool wholeCellVisible = true )
//bool IsVisible( const wxGridCellCoords& coords, bool wholeCellVisible = true )
void MakeCellVisible( int row, int col )
//void MakeCellVisible( const wxGridCellCoords& coords )

// ------ grid cursor movement functions
void SetGridCursor( int row, int col )
bool MoveCursorUp( bool expandSelection )
bool MoveCursorDown( bool expandSelection )
bool MoveCursorLeft( bool expandSelection )
bool MoveCursorRight( bool expandSelection )
bool MovePageDown()
bool MovePageUp()
bool MoveCursorUpBlock( bool expandSelection )
bool MoveCursorDownBlock( bool expandSelection )
bool MoveCursorLeftBlock( bool expandSelection )
bool MoveCursorRightBlock( bool expandSelection )

// ------ label and gridline formatting
int      GetDefaultRowLabelSize()
int      GetRowLabelSize()
int      GetDefaultColLabelSize()
int      GetColLabelSize()
wxColour GetLabelBackgroundColour()
wxColour GetLabelTextColour()
wxFont   GetLabelFont()
// TODO: needs wrapper
void     GetRowLabelAlignment( int *horiz, int *vert )
void     GetColLabelAlignment( int *horiz, int *vert )

int      GetColLabelTextOrientation()
wxString GetRowLabelValue( int row )
wxString GetColLabelValue( int col )
wxColour GetGridLineColour()

virtual wxPen GetDefaultGridLinePen()
virtual wxPen GetRowGridLinePen(int row)
virtual wxPen GetColGridLinePen(int col)
wxColour GetCellHighlightColour()
int      GetCellHighlightPenWidth()
int      GetCellHighlightROPenWidth()

void     SetRowLabelSize( int width )
void     SetColLabelSize( int height )
void     SetLabelBackgroundColour( const wxColour& clr )
void     SetLabelTextColour( const wxColour& clr )
void     SetLabelFont( const wxFont& f )
void     SetRowLabelAlignment( int horiz, int vert )
void     SetColLabelAlignment( int horiz, int vert )
void     SetColLabelTextOrientation( int textOrientation )
void     SetRowLabelValue( int row, const wxString& label )
void     SetColLabelValue( int col, const wxString& label )
void     SetGridLineColour( const wxColour& c )
void     SetCellHighlightColour( const wxColour& clr )
void     SetCellHighlightPenWidth(int width)
void     SetCellHighlightROPenWidth(int width)

void     EnableDragRowSize( bool enable = true )
void     DisableDragRowSize()
bool     CanDragRowSize()
void     EnableDragColSize( bool enable = true )
void     DisableDragColSize()
bool     CanDragColSize()
void     EnableDragColMove( bool enable = true )
void     DisableDragColMove()
bool     CanDragColMove()
void     EnableDragGridSize(bool enable = true)
void     DisableDragGridSize()
bool     CanDragGridSize()

void     EnableDragCell( bool enable = true )
void     DisableDragCell()
bool     CanDragCell()

// this sets the specified attribute for this cell or in this row/col
%if(false) void     SetAttr(int row, int col, wxGridCellAttr *attr)
%if(false) void     SetRowAttr(int row, wxGridCellAttr *attr)
%if(false) void     SetColAttr(int col, wxGridCellAttr *attr)

// returns the attribute we may modify in place: a new one if this cell
// doesn't have any yet or the existing one if it does
//
// DecRef() must be called on the returned pointer, as usual
%if(false) wxGridCellAttr *GetOrCreateCellAttr(int row, int col) const


// shortcuts for setting the column parameters

// set the format for the data in the column: default is string
void     SetColFormatBool(int col)
void     SetColFormatNumber(int col)
void     SetColFormatFloat(int col, int width = -1, int precision = -1)
void     SetColFormatCustom(int col, const wxString& typeName)

void     EnableGridLines( bool enable = true )
bool     GridLinesEnabled()

// ------ row and col formatting
int      GetDefaultRowSize()
int      GetRowSize( int row )
int      GetDefaultColSize()
int      GetColSize( int col )
wxColour GetDefaultCellBackgroundColour()
wxColour GetCellBackgroundColour( int row, int col )
wxColour GetDefaultCellTextColour()
wxColour GetCellTextColour( int row, int col )
wxFont   GetDefaultCellFont()
wxFont   GetCellFont( int row, int col )
//TODO: wrapper
void     GetDefaultCellAlignment( int *horiz, int *vert )
void     GetCellAlignment( int row, int col, int *horiz, int *vert )

bool     GetDefaultCellOverflow()
bool     GetCellOverflow( int row, int col )
//TODO: wrapper
void     GetCellSize( int row, int col, int *num_rows, int *num_cols )

void     SetDefaultRowSize( int height, bool resizeExistingRows = false )
void     SetRowSize( int row, int height )
void     SetDefaultColSize( int width, bool resizeExistingCols = false )

void     SetColSize( int col, int width )

//Column positions
int GetColAt( int colPos ) const
void SetColPos( int colID, int newPos )
int GetColPos( int colID ) const

void     AutoSizeColumn( int col, bool setAsMin = true )
void     AutoSizeRow( int row, bool setAsMin = true )

// auto size all columns (very ineffective for big grids!)
void     AutoSizeColumns( bool setAsMin = true )

void     AutoSizeRows( bool setAsMin = true )

// auto size the grid, that is make the columns/rows of the "right" size
// and also set the grid size to just fit its contents
void     AutoSize()

// autosize row height depending on label text
void     AutoSizeRowLabelSize( int row )

// autosize column width depending on label text
void     AutoSizeColLabelSize( int col )

// column won't be resized to be lesser width - this must be called during
// the grid creation because it won't resize the column if it's already
// narrower than the minimal width
void     SetColMinimalWidth( int col, int width )
void     SetRowMinimalHeight( int row, int width )

/*  These members can be used to query and modify the minimal
 *  acceptable size of grid rows and columns. Call this function in
 *  your code which creates the grid if you want to display cells
 *  with a size smaller than the default acceptable minimum size.
 *  Like the members SetColMinimalWidth and SetRowMinimalWidth,
 *  the existing rows or columns will not be checked/resized.
 */
void     SetColMinimalAcceptableWidth( int width )
void     SetRowMinimalAcceptableHeight( int width )
int      GetColMinimalAcceptableWidth() const
int      GetRowMinimalAcceptableHeight() const

void     SetDefaultCellBackgroundColour( const wxColour& clr )
void     SetCellBackgroundColour( int row, int col, const wxColour& clr )
void     SetDefaultCellTextColour( const wxColour& clr )

void     SetCellTextColour( int row, int col, const wxColour& clr )
void     SetDefaultCellFont( const wxFont& fnt )
void     SetCellFont( int row, int col, const wxFont& fnt )
void     SetDefaultCellAlignment( int horiz, int vert )
void     SetCellAlignment( int row, int col, int horiz, int vert )
void     SetDefaultCellOverflow( bool allow )
void     SetCellOverflow( int row, int col, bool allow )
void     SetCellSize( int row, int col, int num_rows, int num_cols )

// takes ownership of the pointer
void SetDefaultRenderer(wxGridCellRenderer *renderer)
void SetCellRenderer(int row, int col, wxGridCellRenderer *renderer)
wxGridCellRenderer *GetDefaultRenderer() const
wxGridCellRenderer* GetCellRenderer(int row, int col)

// takes ownership of the pointer
%if(false) void SetDefaultEditor(wxGridCellEditor *editor)
%if(false) void SetCellEditor(int row, int col, wxGridCellEditor *editor)
%if(false) wxGridCellEditor *GetDefaultEditor() const
%if(false) wxGridCellEditor* GetCellEditor(int row, int col)

// ------ cell value accessors
wxString GetCellValue( int row, int col )
//wxString GetCellValue( const wxGridCellCoords& coords )

void SetCellValue( int row, int col, const wxString& s )
//void SetCellValue( const wxGridCellCoords& coords, const wxString& s )

// returns true if the cell can't be edited
bool IsReadOnly(int row, int col) const

// make the cell editable/readonly
void SetReadOnly(int row, int col, bool isReadOnly = true)

// ------ select blocks of cells
void SelectRow( int row, bool addToSelected = false )
void SelectCol( int col, bool addToSelected = false )

void SelectBlock( int topRow, int leftCol, int bottomRow, int rightCol, bool addToSelected = false )
//void SelectBlock( const wxGridCellCoords& topLeft, const wxGridCellCoords& bottomRight, bool addToSelected = false )
void SelectAll()
bool IsSelection()

// ------ deselect blocks or cells
void DeselectRow( int row )
void DeselectCol( int col )
void DeselectCell( int row, int col )

void ClearSelection()

bool IsInSelection( int row, int col ) const
//bool IsInSelection( const wxGridCellCoords& coords ) const

wxGridCellCoordsArray GetSelectedCells() const
wxGridCellCoordsArray GetSelectionBlockTopLeft() const
wxGridCellCoordsArray GetSelectionBlockBottomRight() const
wxArrayInt GetSelectedRows() const
wxArrayInt GetSelectedCols() const

// This function returns the rectangle that encloses the block of cells
// limited by TopLeft and BottomRight cell in device coords and clipped
//  to the client size of the grid window.
//
wxRect BlockToDeviceRect( const wxGridCellCoords & topLeft, const wxGridCellCoords & bottomRight )

// Access or update the selection fore/back colours
wxColour GetSelectionBackground() const
wxColour GetSelectionForeground() const

void SetSelectionBackground(const wxColour& c)
void SetSelectionForeground(const wxColour& c)

// Methods for a registry for mapping data types to Renderers/Editors
%if(false) void RegisterDataType(const wxString& typeName, wxGridCellRenderer* renderer, wxGridCellEditor* editor)

%if(false) virtual wxGridCellEditor* GetDefaultEditorForCell(int row, int col) const
//wxGridCellEditor* GetDefaultEditorForCell(const wxGridCellCoords& c) const
virtual wxGridCellRenderer* GetDefaultRendererForCell(int row, int col) const
%if(false) virtual wxGridCellEditor* GetDefaultEditorForType(const wxString& typeName) const
virtual wxGridCellRenderer* GetDefaultRendererForType(const wxString& typeName) const

// grid may occupy more space than needed for its rows/columns, this
// function allows to set how big this extra space is
void SetMargins(int extraWidth, int extraHeight)

// Accessors for component windows
wxWindow* GetGridWindow()
wxWindow* GetGridRowLabelWindow()
wxWindow* GetGridColLabelWindow()
wxWindow* GetGridCornerLabelWindow()

// Allow adjustment of scroll increment. The default is (15, 15).
void SetScrollLineX(int x)
void SetScrollLineY(int y)
int GetScrollLineX() const
int GetScrollLineY() const

// Implementation
int GetScrollX(int x) const
int GetScrollY(int y) const

// override some base class functions
virtual bool Enable(bool enable = true)

// overridden wxWindow methods
virtual void Fit();

int GetRowHeight(int row) const

///////////////////////////////////////////////////////////////////////////////
// wxGridEvent

%include <wx/grid.h>
%class %delete wxGridEvent, wxNotifyEvent
wxGridEvent()
bool AltDown()
bool ControlDown()
int GetCol()
wxPoint  GetPosition()
int GetRow()
bool MetaDown()
bool Selecting()
bool ShiftDown()

%event wxEVT_GRID_CELL_LEFT_CLICK
%event wxEVT_GRID_CELL_RIGHT_CLICK
%event wxEVT_GRID_CELL_LEFT_DCLICK
%event wxEVT_GRID_CELL_RIGHT_DCLICK
%event wxEVT_GRID_LABEL_LEFT_CLICK
%event wxEVT_GRID_LABEL_RIGHT_CLICK
%event wxEVT_GRID_LABEL_LEFT_DCLICK
%event wxEVT_GRID_LABEL_RIGHT_DCLICK
%event wxEVT_GRID_ROW_SIZE
%event wxEVT_GRID_COL_SIZE
%event wxEVT_GRID_RANGE_SELECT
%event wxEVT_GRID_CELL_CHANGE
%event wxEVT_GRID_SELECT_CELL
%event wxEVT_GRID_EDITOR_SHOWN
%event wxEVT_GRID_EDITOR_HIDDEN
%event wxEVT_GRID_EDITOR_CREATED
%event wxEVT_GRID_CELL_BEGIN_DRAG
%event wxEVT_GRID_COL_MOVE

// this would use window identifier, but same events as above
// %event wxEVT_GRID_CMD_CELL_LEFT_CLICK
// %event wxEVT_GRID_CMD_CELL_RIGHT_CLICK
// %event wxEVT_GRID_CMD_CELL_LEFT_DCLICK
// %event wxEVT_GRID_CMD_CELL_RIGHT_DCLICK
// %event wxEVT_GRID_CMD_LABEL_LEFT_CLICK
// %event wxEVT_GRID_CMD_LABEL_RIGHT_CLICK
// %event wxEVT_GRID_CMD_LABEL_LEFT_DCLICK
// %event wxEVT_GRID_CMD_LABEL_RIGHT_DCLICK
// %event wxEVT_GRID_CMD_CELL_CHANGE
// %event wxEVT_GRID_CMD_SELECT_CELL
// %event wxEVT_GRID_CMD_EDITOR_HIDDEN
// %event wxEVT_GRID_CMD_EDITOR_SHOWN

///////////////////////////////////////////////////////////////////////////////
// wxGridRangeSelectEvent

%include <wx/grid.h>
%class %delete wxGridRangeSelectEvent, wxNotifyEvent
wxGridRangeSelectEvent()
bool AltDown()
bool ControlDown()
wxGridCellCoords GetBottomRightCoords()
int GetBottomRow()
int GetLeftCol()
int GetRightCol()
wxGridCellCoords GetTopLeftCoords()
int GetTopRow()
bool MetaDown()
bool Selecting()
bool ShiftDown()

///////////////////////////////////////////////////////////////////////////////
// wxGridSizeEvent

%include <wx/grid.h>
%class %delete wxGridSizeEvent, wxNotifyEvent
wxGridSizeEvent()
bool AltDown()
bool ControlDown()
wxPoint  GetPosition()
int GetRowOrCol()
bool MetaDown()
bool ShiftDown()

///////////////////////////////////////////////////////////////////////////////
// wxStyledTextCtrl
///////////////////////////////////////////////////////////////////////////////

%class wxStyledTextCtrl, wxControl
%include "wx/stc/stc.h"

// from stc.cpp

%ctor wxStyledTextCtrlNoCreate()
wxStyledTextCtrl(wxWindow *parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxSTCNameStr)
bool Create(wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxSTCNameStr)
//long SendMsg(int msg, long wp, long lp)
void AddText(const wxString& text)
void AddStyledText(const wxMemoryBuffer& data)
void InsertText(int pos, const wxString& text)
void ClearAll()
void ClearDocumentStyle()
int GetLength()
int GetCharAt(int pos)
int GetCurrentPos()
int GetAnchor()
int GetStyleAt(int pos)
void Redo()
void SetUndoCollection(bool collectUndo)
void SelectAll()
void SetSavePoint()
wxMemoryBuffer GetStyledText(int startPos, int endPos)
bool CanRedo()
int MarkerLineFromHandle(int handle)
void MarkerDeleteHandle(int handle)
bool GetUndoCollection()
int GetViewWhiteSpace()
void SetViewWhiteSpace(int viewWS)
//int PositionFromPoint(wxPoint pt)
int PositionFromPoint(const wxPoint& pt)
int PositionFromPointClose(int x, int y)
void GotoLine(int line)
void GotoPos(int pos)
void SetAnchor(int posAnchor)
wxString GetCurLine(int* linePos)
int GetEndStyled()
void ConvertEOLs(int eolMode)
int GetEOLMode()
void SetEOLMode(int eolMode)
void StartStyling(int pos, int mask)
void SetStyling(int length, int style)
bool GetBufferedDraw()
void SetBufferedDraw(bool buffered)
void SetTabWidth(int tabWidth)
int GetTabWidth()
void SetCodePage(int codePage)
void MarkerDefine(int markerNumber, int markerSymbol, const wxColour& foreground, const wxColour& background)
void MarkerSetForeground(int markerNumber, const wxColour& fore)
void MarkerSetBackground(int markerNumber, const wxColour& back)
int MarkerAdd(int line, int markerNumber)
void MarkerDelete(int line, int markerNumber)
void MarkerDeleteAll(int markerNumber)
int MarkerGet(int line)
int MarkerNext(int lineStart, int markerMask)
int MarkerPrevious(int lineStart, int markerMask)
void MarkerDefineBitmap(int markerNumber, const wxBitmap& bmp)
void MarkerAddSet(int line, int set)
void MarkerSetAlpha(int markerNumber, int alpha)
void SetMarginType(int margin, int marginType)
int GetMarginType(int margin)
void SetMarginWidth(int margin, int pixelWidth)
int GetMarginWidth(int margin)
void SetMarginMask(int margin, int mask)
int GetMarginMask(int margin)
void SetMarginSensitive(int margin, bool sensitive)
bool GetMarginSensitive(int margin)
void StyleClearAll()
void StyleSetForeground(int style, const wxColour& fore)
void StyleSetBackground(int style, const wxColour& back)
void StyleSetBold(int style, bool bold)
void StyleSetItalic(int style, bool italic)
void StyleSetSize(int style, int sizePoints)
void StyleSetFaceName(int style, const wxString& fontName)
void StyleSetEOLFilled(int style, bool filled)
void StyleResetDefault()
void StyleSetUnderline(int style, bool underline)
void StyleSetCase(int style, int caseForce)
//void StyleSetCharacterSet(int style, int characterSet)
void StyleSetHotSpot(int style, bool hotspot)
void SetSelForeground(bool useSetting, const wxColour& fore)
void SetSelBackground(bool useSetting, const wxColour& back)
int GetSelAlpha()
void SetSelAlpha(int alpha)
void SetCaretForeground(const wxColour& fore)
void CmdKeyAssign(int key, int modifiers, int cmd)
void CmdKeyClear(int key, int modifiers)
void CmdKeyClearAll()
void SetStyleBytes(int length, char* styleBytes)
void StyleSetVisible(int style, bool visible)
int GetCaretPeriod()
void SetCaretPeriod(int periodMilliseconds)
void SetWordChars(const wxString& characters)
void BeginUndoAction()
void EndUndoAction()
void IndicatorSetStyle(int indic, int style)
int IndicatorGetStyle(int indic)
void IndicatorSetForeground(int indic, const wxColour& fore)
wxColour IndicatorGetForeground(int indic)
void SetWhitespaceForeground(bool useSetting, const wxColour& fore)
void SetWhitespaceBackground(bool useSetting, const wxColour& back)
void SetStyleBits(int bits)
int GetStyleBits()
void SetLineState(int line, int state)
int GetLineState(int line)
int GetMaxLineState()
bool GetCaretLineVisible()
void SetCaretLineVisible(bool show)
wxColour GetCaretLineBackground()
void SetCaretLineBackground(const wxColour& back)
void StyleSetChangeable(int style, bool changeable)
void AutoCompShow(int lenEntered, const wxString& itemList)
void AutoCompCancel()
bool AutoCompActive()
int AutoCompPosStart()
void AutoCompComplete()
void AutoCompStops(const wxString& characterSet)
void AutoCompSetSeparator(int separatorCharacter)
int AutoCompGetSeparator()
void AutoCompSelect(const wxString& text)
void AutoCompSetCancelAtStart(bool cancel)
bool AutoCompGetCancelAtStart()
void AutoCompSetFillUps(const wxString& characterSet)
void AutoCompSetChooseSingle(bool chooseSingle)
bool AutoCompGetChooseSingle()
void AutoCompSetIgnoreCase(bool ignoreCase)
bool AutoCompGetIgnoreCase()
void UserListShow(int listType, const wxString& itemList)
void AutoCompSetAutoHide(bool autoHide)
bool AutoCompGetAutoHide()
void AutoCompSetDropRestOfWord(bool dropRestOfWord)
bool AutoCompGetDropRestOfWord()
void RegisterImage(int type, const wxBitmap& bmp)
void ClearRegisteredImages()
int AutoCompGetTypeSeparator()
void AutoCompSetTypeSeparator(int separatorCharacter)
void AutoCompSetMaxWidth(int characterCount)
int AutoCompGetMaxWidth()
void AutoCompSetMaxHeight(int rowCount)
int AutoCompGetMaxHeight()

void SetIndent(int indentSize)
int GetIndent()
void SetUseTabs(bool useTabs)
bool GetUseTabs()
void SetLineIndentation(int line, int indentSize)
int GetLineIndentation(int line)
int GetLineIndentPosition(int line)
int GetColumn(int pos)
void SetUseHorizontalScrollBar(bool show)
bool GetUseHorizontalScrollBar()
void SetIndentationGuides(bool show)
bool GetIndentationGuides()
void SetHighlightGuide(int column)
int GetHighlightGuide()
int GetLineEndPosition(int line)
int GetCodePage()
wxColour GetCaretForeground()
bool GetReadOnly()
void SetCurrentPos(int pos)
void SetSelectionStart(int pos)
int GetSelectionStart()
void SetSelectionEnd(int pos)
int GetSelectionEnd()
void SetPrintMagnification(int magnification)
int GetPrintMagnification()
void SetPrintColourMode(int mode)
int GetPrintColourMode()
int FindText(int minPos, int maxPos, const wxString& text, int flags)
//int FormatRange(bool doDraw, int startPos, int endPos, wxDC* draw, wxDC* target, wxRect renderRect, wxRect pageRect)
int FormatRange(bool doDraw, int startPos, int endPos, wxDC* draw, wxDC* target, wxRect &renderRect, wxRect &pageRect)
int GetFirstVisibleLine()
wxString GetLine(int line)
int GetLineCount()
void SetMarginLeft(int pixelWidth)
int GetMarginLeft()
void SetMarginRight(int pixelWidth)
int GetMarginRight()
bool GetModify()
void SetSelection(int start, int end)
wxString GetSelectedText()
wxString GetTextRange(int startPos, int endPos)
void HideSelection(bool normal)
int LineFromPosition(int pos)
int PositionFromLine(int line)
void LineScroll(int columns, int lines)
void EnsureCaretVisible()
void ReplaceSelection(const wxString& text)
void SetReadOnly(bool readOnly)
bool CanPaste()
bool CanUndo()
void EmptyUndoBuffer()
void Undo()
void Cut()
void Copy()
void Paste()
void Clear()
void SetText(const wxString& text)
wxString GetText()
int GetTextLength()
void SetOvertype(bool overtype)
bool GetOvertype()
void SetCaretWidth(int pixelWidth)
int GetCaretWidth()
void SetTargetStart(int pos)
int GetTargetStart()
void SetTargetEnd(int pos)
int GetTargetEnd()
int ReplaceTarget(const wxString& text)
int ReplaceTargetRE(const wxString& text)
int SearchInTarget(const wxString& text)
void SetSearchFlags(int flags)
int GetSearchFlags()
void CallTipShow(int pos, const wxString& definition)
void CallTipCancel()
bool CallTipActive()
int CallTipPosAtStart()
void CallTipSetHighlight(int start, int end)
void CallTipSetBackground(const wxColour& back)
void CallTipSetForeground(const wxColour& fore)
void CallTipSetForegroundHighlight(const wxColour& fore)
void CallTipUseStyle(int tabSize)
int VisibleFromDocLine(int line)
int DocLineFromVisible(int lineDisplay)
int WrapCount(int line)
void SetFoldLevel(int line, int level)
int GetFoldLevel(int line)
int GetLastChild(int line, int level)
int GetFoldParent(int line)
void ShowLines(int lineStart, int lineEnd)
void HideLines(int lineStart, int lineEnd)
bool GetLineVisible(int line)
void SetFoldExpanded(int line, bool expanded)
bool GetFoldExpanded(int line)
void ToggleFold(int line)
void EnsureVisible(int line)
void SetFoldFlags(int flags)
void EnsureVisibleEnforcePolicy(int line)
void SetTabIndents(bool tabIndents)
bool GetTabIndents()
void SetBackSpaceUnIndents(bool bsUnIndents)
bool GetBackSpaceUnIndents()
void SetMouseDwellTime(int periodMilliseconds)
int GetMouseDwellTime()
int WordStartPosition(int pos, bool onlyWordCharacters)
int WordEndPosition(int pos, bool onlyWordCharacters)
void SetWrapMode(int mode)
int GetWrapMode()
void SetWrapVisualFlags(int wrapVisualFlags)
int GetWrapVisualFlags()
void SetWrapVisualFlagsLocation(int wrapVisualFlagsLocation)
int GetWrapVisualFlagsLocation()
void SetWrapStartIndent(int indent)
int GetWrapStartIndent()

void SetLayoutCache(int mode)
int GetLayoutCache()
void SetScrollWidth(int pixelWidth)
int GetScrollWidth()
int TextWidth(int style, const wxString& text)
void SetEndAtLastLine(bool endAtLastLine)
int GetEndAtLastLine()
int TextHeight(int line)
void SetUseVerticalScrollBar(bool show)
bool GetUseVerticalScrollBar()
void AppendText(const wxString& text)
bool GetTwoPhaseDraw()
void SetTwoPhaseDraw(bool twoPhase)
void TargetFromSelection()
void LinesJoin()
void LinesSplit(int pixelWidth)
void SetFoldMarginColour(bool useSetting, const wxColour& back)
void SetFoldMarginHiColour(bool useSetting, const wxColour& fore)

void LineDown()
void LineDownExtend()
void LineUp()
void LineUpExtend()
void CharLeft()
void CharLeftExtend()
void CharRight()
void CharRightExtend()
void WordLeft()
void WordLeftExtend()
void WordRight()
void WordRightExtend()
void Home()
void HomeExtend()
void LineEnd()
void LineEndExtend()
void DocumentStart()
void DocumentStartExtend()
void DocumentEnd()
void DocumentEndExtend()
void PageUp()
void PageUpExtend()
void PageDown()
void PageDownExtend()
void EditToggleOvertype()
void Cancel()
void DeleteBack()
void Tab()
void BackTab()
void NewLine()
void FormFeed()
void VCHome()
void VCHomeExtend()
void ZoomIn()
void ZoomOut()
void DelWordLeft()
void DelWordRight()
void LineCut()
void LineDelete()
void LineTranspose()

void LineDuplicate()
void LowerCase()
void UpperCase()
void LineScrollDown()
void LineScrollUp()
void DeleteBackNotLine()

void HomeDisplay()
void HomeDisplayExtend()
void LineEndDisplay()
void LineEndDisplayExtend()

void HomeWrap()
void HomeWrapExtend()
void LineEndWrap()
void LineEndWrapExtend()
void VCHomeWrap()
void VCHomeWrapExtend()

void LineCopy()
void MoveCaretInsideView()
int LineLength(int line)
void BraceHighlight(int pos1, int pos2)
void BraceBadLight(int pos)
int BraceMatch(int pos)
bool GetViewEOL()
void SetViewEOL(bool visible)
void* GetDocPointer()
void SetDocPointer(void* docPointer)
void SetModEventMask(int mask)

int GetEdgeColumn()
void SetEdgeColumn(int column)
int GetEdgeMode()
void SetEdgeMode(int mode)
wxColour GetEdgeColour()
void SetEdgeColour(const wxColour& edgeColour)
void SearchAnchor()
int SearchNext(int flags, const wxString& text)
int SearchPrev(int flags, const wxString& text)
int LinesOnScreen()
void UsePopUp(bool allowPopUp)
bool SelectionIsRectangle()
void SetZoom(int zoom)
int GetZoom()
void* CreateDocument()
void AddRefDocument(void* docPointer)
void ReleaseDocument(void* docPointer)
int GetModEventMask()
void SetSTCFocus(bool focus)
bool GetSTCFocus()
void SetStatus(int statusCode)
int GetStatus()
void SetMouseDownCaptures(bool captures)
bool GetMouseDownCaptures()
void SetSTCCursor(int cursorType)
int GetSTCCursor()
void SetControlCharSymbol(int symbol)
int GetControlCharSymbol()
void WordPartLeft()
void WordPartLeftExtend()
void WordPartRight()
void WordPartRightExtend()
void SetVisiblePolicy(int visiblePolicy, int visibleSlop)
void DelLineLeft()
void DelLineRight()
void SetXOffset(int newOffset)
int GetXOffset()
void ChooseCaretX()
void SetXCaretPolicy(int caretPolicy, int caretSlop)
void SetYCaretPolicy(int caretPolicy, int caretSlop)
void SetPrintWrapMode(int mode)
int GetPrintWrapMode()
void SetHotspotActiveForeground(bool useSetting, const wxColour& fore)
void SetHotspotActiveBackground(bool useSetting, const wxColour& back)
void SetHotspotActiveUnderline(bool underline)
void SetHotspotSingleLine(bool singleLine)
void ParaDown()
void ParaDownExtend()
void ParaUp()
void ParaUpExtend()

int PositionBefore(int pos)
int PositionAfter(int pos)
void CopyRange(int start, int end)
void CopyText(int length, const wxString& text)

void SetSelectionMode(int mode)
int GetSelectionMode()
int GetLineSelStartPosition(int line)
int GetLineSelEndPosition(int line)
void LineDownRectExtend()
void LineUpRectExtend()
void CharLeftRectExtend()
void CharRightRectExtend()
void HomeRectExtend()
void VCHomeRectExtend()
void LineEndRectExtend()
void PageUpRectExtend()
void PageDownRectExtend()
void StutteredPageUp()
void StutteredPageUpExtend()
void StutteredPageDown()
void StutteredPageDownExtend()
void WordLeftEnd()
void WordLeftEndExtend()
void WordRightEnd()
void WordRightEndExtend()
void SetWhitespaceChars(const wxString& characters)
void SetCharsDefault()
int AutoCompGetCurrent()
void Allocate(int bytes)
int FindColumn(int line, int column)
bool GetCaretSticky()
void SetCaretSticky(bool useCaretStickyBehaviour)
void ToggleCaretSticky()
void SetPasteConvertEndings(bool convert)
bool GetPasteConvertEndings()
void SelectionDuplicate()
void SetCaretLineBackAlpha(int alpha)
int GetCaretLineBackAlpha()

void StartRecord()
void StopRecord()
void SetLexer(int lexer)
int GetLexer()
void Colourise(int start, int end)
void SetProperty(const wxString& key, const wxString& value)
void SetKeyWords(int keywordSet, const wxString& keyWords)
void SetLexerLanguage(const wxString& language)

wxString GetProperty(const wxString& key)
wxString GetPropertyExpanded(const wxString& key)
int GetPropertyInt(const wxString& key)
int GetStyleBitsNeeded()

int GetCurrentLine()
void StyleSetSpec(int styleNum, const wxString& spec)
void StyleSetFont(int styleNum, wxFont& font)
void StyleSetFontAttr(int styleNum, int size, const wxString& faceName, bool bold, bool italic, bool underline)
void StyleSetCharacterSet(int style, int characterSet)
void StyleSetFontEncoding(int style, wxFontEncoding encoding)

void CmdKeyExecute(int cmd)
void SetMargins(int left, int right)
void GetSelection(int* startPos, int* endPos)
wxPoint PointFromPosition(int pos)
void ScrollToLine(int line)
void ScrollToColumn(int column)
long SendMsg(int msg, long wp=0, long lp=0)
void SetVScrollBar(wxScrollBar* bar)
void SetHScrollBar(wxScrollBar* bar)
bool GetLastKeydownProcessed()
void SetLastKeydownProcessed(bool val)

bool SaveFile(const wxString& filename)
bool LoadFile(const wxString& filename)
// wxDragResult DoDragOver(wxCoord x, wxCoord y, wxDragResult def)
bool DoDropText(long x, long y, const wxString& data)

void SetUseAntiAliasing(bool useAA)
bool GetUseAntiAliasing()
void AddTextRaw(const char* text)
void InsertTextRaw(int pos, const char* text)
wxCharBuffer GetCurLineRaw(int* linePos=NULL)
wxCharBuffer GetLineRaw(int line)
wxCharBuffer GetSelectedTextRaw()
wxCharBuffer GetTextRangeRaw(int startPos, int endPos)
void SetTextRaw(const char* text)
wxCharBuffer GetTextRaw()
void AppendTextRaw(const char* text)

// from contrib/include/wx/stc/stc.h
%num wxSTC_INVALID_POSITION
%num wxSTC_START
%num wxSTC_OPTIONAL_START
%num wxSTC_LEXER_START
%num wxSTC_WS_INVISIBLE
%num wxSTC_WS_VISIBLEALWAYS
%num wxSTC_WS_VISIBLEAFTERINDENT
%num wxSTC_EOL_CRLF
%num wxSTC_EOL_CR
%num wxSTC_EOL_LF
%num wxSTC_CP_UTF8
%num wxSTC_CP_DBCS
%num wxSTC_MARKER_MAX
%num wxSTC_MARK_CIRCLE
%num wxSTC_MARK_ROUNDRECT
%num wxSTC_MARK_ARROW
%num wxSTC_MARK_SMALLRECT
%num wxSTC_MARK_SHORTARROW
%num wxSTC_MARK_EMPTY
%num wxSTC_MARK_ARROWDOWN
%num wxSTC_MARK_MINUS
%num wxSTC_MARK_PLUS
%num wxSTC_MARK_VLINE
%num wxSTC_MARK_LCORNER
%num wxSTC_MARK_TCORNER
%num wxSTC_MARK_BOXPLUS
%num wxSTC_MARK_BOXPLUSCONNECTED
%num wxSTC_MARK_BOXMINUS
%num wxSTC_MARK_BOXMINUSCONNECTED
%num wxSTC_MARK_LCORNERCURVE
%num wxSTC_MARK_TCORNERCURVE
%num wxSTC_MARK_CIRCLEPLUS
%num wxSTC_MARK_CIRCLEPLUSCONNECTED
%num wxSTC_MARK_CIRCLEMINUS
%num wxSTC_MARK_CIRCLEMINUSCONNECTED
%num wxSTC_MARK_BACKGROUND
%num wxSTC_MARK_DOTDOTDOT
%num wxSTC_MARK_ARROWS
%num wxSTC_MARK_PIXMAP
%num wxSTC_MARK_FULLRECT
%num wxSTC_MARK_CHARACTER
%num wxSTC_MARKNUM_FOLDEREND
%num wxSTC_MARKNUM_FOLDEROPENMID
%num wxSTC_MARKNUM_FOLDERMIDTAIL
%num wxSTC_MARKNUM_FOLDERTAIL
%num wxSTC_MARKNUM_FOLDERSUB
%num wxSTC_MARKNUM_FOLDER
%num wxSTC_MARKNUM_FOLDEROPEN
%num wxSTC_MASK_FOLDERS
%num wxSTC_MARGIN_SYMBOL
%num wxSTC_MARGIN_NUMBER
%num wxSTC_MARGIN_BACK
%num wxSTC_MARGIN_FORE
%num wxSTC_STYLE_DEFAULT
%num wxSTC_STYLE_LINENUMBER
%num wxSTC_STYLE_BRACELIGHT
%num wxSTC_STYLE_BRACEBAD
%num wxSTC_STYLE_CONTROLCHAR
%num wxSTC_STYLE_INDENTGUIDE
%num wxSTC_STYLE_LASTPREDEFINED
%num wxSTC_STYLE_MAX
%num wxSTC_CHARSET_ANSI
%num wxSTC_CHARSET_DEFAULT
%num wxSTC_CHARSET_BALTIC
%num wxSTC_CHARSET_CHINESEBIG5
%num wxSTC_CHARSET_EASTEUROPE
%num wxSTC_CHARSET_GB2312
%num wxSTC_CHARSET_GREEK
%num wxSTC_CHARSET_HANGUL
%num wxSTC_CHARSET_MAC
%num wxSTC_CHARSET_OEM
%num wxSTC_CHARSET_RUSSIAN
%num wxSTC_CHARSET_SHIFTJIS
%num wxSTC_CHARSET_SYMBOL
%num wxSTC_CHARSET_TURKISH
%num wxSTC_CHARSET_JOHAB
%num wxSTC_CHARSET_HEBREW
%num wxSTC_CHARSET_ARABIC
%num wxSTC_CHARSET_VIETNAMESE
%num wxSTC_CHARSET_THAI
%num wxSTC_CHARSET_8859_15
%num wxSTC_CASE_MIXED
%num wxSTC_CASE_UPPER
%num wxSTC_CASE_LOWER
%num wxSTC_INDIC_MAX
%num wxSTC_INDIC_PLAIN
%num wxSTC_INDIC_SQUIGGLE
%num wxSTC_INDIC_TT
%num wxSTC_INDIC_DIAGONAL
%num wxSTC_INDIC_STRIKE
%num wxSTC_INDIC_HIDDEN
%num wxSTC_INDIC_BOX
%num wxSTC_INDIC_ROUNDBOX
%num wxSTC_INDIC0_MASK
%num wxSTC_INDIC1_MASK
%num wxSTC_INDIC2_MASK
%num wxSTC_INDICS_MASK
%num wxSTC_PRINT_NORMAL
%num wxSTC_PRINT_INVERTLIGHT
%num wxSTC_PRINT_BLACKONWHITE
%num %alias wxSTC_PRINT_COLORONWHITE wxSTC_PRINT_COLOURONWHITE
%num %alias wxSTC_PRINT_COLORONWHITEDEFAULTBG wxSTC_PRINT_COLOURONWHITEDEFAULTBG
%num wxSTC_FIND_WHOLEWORD
%num wxSTC_FIND_MATCHCASE
%num wxSTC_FIND_WORDSTART
%num wxSTC_FIND_REGEXP
%num wxSTC_FIND_POSIX
%num wxSTC_FOLDLEVELBASE
%num wxSTC_FOLDLEVELWHITEFLAG
%num wxSTC_FOLDLEVELHEADERFLAG
%num wxSTC_FOLDLEVELBOXHEADERFLAG
%num wxSTC_FOLDLEVELBOXFOOTERFLAG
%num wxSTC_FOLDLEVELCONTRACTED
%num wxSTC_FOLDLEVELUNINDENT
%num wxSTC_FOLDLEVELNUMBERMASK
%num wxSTC_FOLDFLAG_LINEBEFORE_EXPANDED
%num wxSTC_FOLDFLAG_LINEBEFORE_CONTRACTED
%num wxSTC_FOLDFLAG_LINEAFTER_EXPANDED
%num wxSTC_FOLDFLAG_LINEAFTER_CONTRACTED
%num wxSTC_FOLDFLAG_LEVELNUMBERS
%num wxSTC_FOLDFLAG_BOX
%num wxSTC_TIME_FOREVER
%num wxSTC_WRAP_NONE
%num wxSTC_WRAP_WORD
%num wxSTC_WRAP_CHAR
%num wxSTC_WRAPVISUALFLAG_NONE
%num wxSTC_WRAPVISUALFLAG_END
%num wxSTC_WRAPVISUALFLAG_START
%num wxSTC_WRAPVISUALFLAGLOC_DEFAULT
%num wxSTC_WRAPVISUALFLAGLOC_END_BY_TEXT
%num wxSTC_WRAPVISUALFLAGLOC_START_BY_TEXT
%num wxSTC_CACHE_NONE
%num wxSTC_CACHE_CARET
%num wxSTC_CACHE_PAGE
%num wxSTC_CACHE_DOCUMENT

%num wxSTC_EDGE_NONE
%num wxSTC_EDGE_LINE
%num wxSTC_EDGE_BACKGROUND

%num wxSTC_CURSORNORMAL
%num wxSTC_CURSORWAIT
%num wxSTC_VISIBLE_SLOP
%num wxSTC_VISIBLE_STRICT

%num wxSTC_CARET_SLOP
%num wxSTC_CARET_STRICT
%num wxSTC_CARET_JUMPS
%num wxSTC_CARET_EVEN
// Selection modes
%num wxSTC_SEL_STREAM
%num wxSTC_SEL_RECTANGLE
%num wxSTC_SEL_LINES
%num wxSTC_ALPHA_TRANSPARENT
%num wxSTC_ALPHA_OPAQUE
%num wxSTC_ALPHA_NOALPHA

%num wxSTC_KEYWORDSET_MAX

%num wxSTC_MOD_INSERTTEXT
%num wxSTC_MOD_DELETETEXT
%num wxSTC_MOD_CHANGESTYLE
%num wxSTC_MOD_CHANGEFOLD
%num wxSTC_PERFORMED_USER
%num wxSTC_PERFORMED_UNDO
%num wxSTC_PERFORMED_REDO
%num wxSTC_LASTSTEPINUNDOREDO
%num wxSTC_MOD_CHANGEMARKER
%num wxSTC_MOD_BEFOREINSERT
%num wxSTC_MOD_BEFOREDELETE
%num wxSTC_MODEVENTMASKALL

%num wxSTC_KEY_DOWN
%num wxSTC_KEY_UP
%num wxSTC_KEY_LEFT
%num wxSTC_KEY_RIGHT
%num wxSTC_KEY_HOME
%num wxSTC_KEY_END
%num wxSTC_KEY_PRIOR
%num wxSTC_KEY_NEXT
%num wxSTC_KEY_DELETE
%num wxSTC_KEY_INSERT
%num wxSTC_KEY_ESCAPE
%num wxSTC_KEY_BACK
%num wxSTC_KEY_TAB
%num wxSTC_KEY_RETURN
%num wxSTC_KEY_ADD
%num wxSTC_KEY_SUBTRACT
%num wxSTC_KEY_DIVIDE
%num wxSTC_SCMOD_SHIFT
%num wxSTC_SCMOD_CTRL
%num wxSTC_SCMOD_ALT
%num wxSTC_LEX_CONTAINER
%num wxSTC_LEX_NULL
%num wxSTC_LEX_PYTHON
%num wxSTC_LEX_CPP
%num wxSTC_LEX_HTML
%num wxSTC_LEX_XML
%num wxSTC_LEX_PERL
%num wxSTC_LEX_SQL
%num wxSTC_LEX_VB
%num wxSTC_LEX_PROPERTIES
%num wxSTC_LEX_ERRORLIST
%num wxSTC_LEX_MAKEFILE
%num wxSTC_LEX_BATCH
%num wxSTC_LEX_XCODE
%num wxSTC_LEX_LATEX
%num wxSTC_LEX_LUA
%num wxSTC_LEX_DIFF
%num wxSTC_LEX_CONF
%num wxSTC_LEX_PASCAL
%num wxSTC_LEX_AVE
%num wxSTC_LEX_ADA
%num wxSTC_LEX_LISP
%num wxSTC_LEX_RUBY
%num wxSTC_LEX_EIFFEL
%num wxSTC_LEX_EIFFELKW
%num wxSTC_LEX_TCL
%num wxSTC_LEX_NNCRONTAB
%num wxSTC_LEX_BULLANT
%num wxSTC_LEX_VBSCRIPT
%num wxSTC_LEX_BAAN
%num wxSTC_LEX_MATLAB
%num wxSTC_LEX_SCRIPTOL
%num wxSTC_LEX_ASM
%num wxSTC_LEX_CPPNOCASE
%num wxSTC_LEX_FORTRAN
%num wxSTC_LEX_F77
%num wxSTC_LEX_CSS
%num wxSTC_LEX_POV
%num wxSTC_LEX_LOUT
%num wxSTC_LEX_ESCRIPT
%num wxSTC_LEX_PS
%num wxSTC_LEX_NSIS
%num wxSTC_LEX_MMIXAL
%num wxSTC_LEX_CLW
%num wxSTC_LEX_CLWNOCASE
%num wxSTC_LEX_LOT
%num wxSTC_LEX_YAML
%num wxSTC_LEX_TEX
%num wxSTC_LEX_METAPOST
%num wxSTC_LEX_POWERBASIC
%num wxSTC_LEX_FORTH
%num wxSTC_LEX_ERLANG
%num wxSTC_LEX_OCTAVE
%num wxSTC_LEX_MSSQL
%num wxSTC_LEX_VERILOG
%num wxSTC_LEX_KIX
%num wxSTC_LEX_GUI4CLI
%num wxSTC_LEX_SPECMAN
%num wxSTC_LEX_AU3
%num wxSTC_LEX_APDL
%num wxSTC_LEX_BASH
%num wxSTC_LEX_ASN1
%num wxSTC_LEX_VHDL
%num wxSTC_LEX_CAML
%num wxSTC_LEX_BLITZBASIC
%num wxSTC_LEX_PUREBASIC
%num wxSTC_LEX_HASKELL
%num wxSTC_LEX_PHPSCRIPT
%num wxSTC_LEX_TADS3
%num wxSTC_LEX_REBOL
%num wxSTC_LEX_SMALLTALK
%num wxSTC_LEX_FLAGSHIP
%num wxSTC_LEX_CSOUND
%num wxSTC_LEX_FREEBASIC
%num wxSTC_LEX_INNOSETUP
%num wxSTC_LEX_OPAL
%num wxSTC_LEX_SPICE
%num wxSTC_LEX_AUTOMATIC

%num wxSTC_P_DEFAULT
%num wxSTC_P_COMMENTLINE
%num wxSTC_P_NUMBER
%num wxSTC_P_STRING
%num wxSTC_P_CHARACTER
%num wxSTC_P_WORD
%num wxSTC_P_TRIPLE
%num wxSTC_P_TRIPLEDOUBLE
%num wxSTC_P_CLASSNAME
%num wxSTC_P_DEFNAME
%num wxSTC_P_OPERATOR
%num wxSTC_P_IDENTIFIER
%num wxSTC_P_COMMENTBLOCK
%num wxSTC_P_STRINGEOL
%num wxSTC_P_WORD2
%num wxSTC_P_DECORATOR
%num wxSTC_C_DEFAULT
%num wxSTC_C_COMMENT
%num wxSTC_C_COMMENTLINE
%num wxSTC_C_COMMENTDOC
%num wxSTC_C_NUMBER
%num wxSTC_C_WORD
%num wxSTC_C_STRING
%num wxSTC_C_CHARACTER
%num wxSTC_C_UUID
%num wxSTC_C_PREPROCESSOR
%num wxSTC_C_OPERATOR
%num wxSTC_C_IDENTIFIER
%num wxSTC_C_STRINGEOL
%num wxSTC_C_VERBATIM
%num wxSTC_C_REGEX
%num wxSTC_C_COMMENTLINEDOC
%num wxSTC_C_WORD2
%num wxSTC_C_COMMENTDOCKEYWORD
%num wxSTC_C_COMMENTDOCKEYWORDERROR
%num wxSTC_C_GLOBALCLASS
// Lexical states for SCLEX_TCL
%num wxSTC_TCL_DEFAULT
%num wxSTC_TCL_COMMENT
%num wxSTC_TCL_COMMENTLINE
%num wxSTC_TCL_NUMBER
%num wxSTC_TCL_WORD_IN_QUOTE
%num wxSTC_TCL_IN_QUOTE
%num wxSTC_TCL_OPERATOR
%num wxSTC_TCL_IDENTIFIER
%num wxSTC_TCL_SUBSTITUTION
%num wxSTC_TCL_SUB_BRACE
%num wxSTC_TCL_MODIFIER
%num wxSTC_TCL_EXPAND
%num wxSTC_TCL_WORD
%num wxSTC_TCL_WORD2
%num wxSTC_TCL_WORD3
%num wxSTC_TCL_WORD4
%num wxSTC_TCL_WORD5
%num wxSTC_TCL_WORD6
%num wxSTC_TCL_WORD7
%num wxSTC_TCL_WORD8
%num wxSTC_TCL_COMMENT_BOX
%num wxSTC_TCL_BLOCK_COMMENT

%num wxSTC_H_DEFAULT
%num wxSTC_H_TAG
%num wxSTC_H_TAGUNKNOWN
%num wxSTC_H_ATTRIBUTE
%num wxSTC_H_ATTRIBUTEUNKNOWN
%num wxSTC_H_NUMBER
%num wxSTC_H_DOUBLESTRING
%num wxSTC_H_SINGLESTRING
%num wxSTC_H_OTHER
%num wxSTC_H_COMMENT
%num wxSTC_H_ENTITY
%num wxSTC_H_TAGEND
%num wxSTC_H_XMLSTART
%num wxSTC_H_XMLEND
%num wxSTC_H_SCRIPT
%num wxSTC_H_ASP
%num wxSTC_H_ASPAT
%num wxSTC_H_CDATA
%num wxSTC_H_QUESTION
%num wxSTC_H_VALUE
%num wxSTC_H_XCCOMMENT
%num wxSTC_H_SGML_DEFAULT
%num wxSTC_H_SGML_COMMAND
%num wxSTC_H_SGML_1ST_PARAM
%num wxSTC_H_SGML_DOUBLESTRING
%num wxSTC_H_SGML_SIMPLESTRING
%num wxSTC_H_SGML_ERROR
%num wxSTC_H_SGML_SPECIAL
%num wxSTC_H_SGML_ENTITY
%num wxSTC_H_SGML_COMMENT
%num wxSTC_H_SGML_1ST_PARAM_COMMENT
%num wxSTC_H_SGML_BLOCK_DEFAULT
%num wxSTC_HJ_START
%num wxSTC_HJ_DEFAULT
%num wxSTC_HJ_COMMENT
%num wxSTC_HJ_COMMENTLINE
%num wxSTC_HJ_COMMENTDOC
%num wxSTC_HJ_NUMBER
%num wxSTC_HJ_WORD
%num wxSTC_HJ_KEYWORD
%num wxSTC_HJ_DOUBLESTRING
%num wxSTC_HJ_SINGLESTRING
%num wxSTC_HJ_SYMBOLS
%num wxSTC_HJ_STRINGEOL
%num wxSTC_HJ_REGEX
%num wxSTC_HJA_START
%num wxSTC_HJA_DEFAULT
%num wxSTC_HJA_COMMENT
%num wxSTC_HJA_COMMENTLINE
%num wxSTC_HJA_COMMENTDOC
%num wxSTC_HJA_NUMBER
%num wxSTC_HJA_WORD
%num wxSTC_HJA_KEYWORD
%num wxSTC_HJA_DOUBLESTRING
%num wxSTC_HJA_SINGLESTRING
%num wxSTC_HJA_SYMBOLS
%num wxSTC_HJA_STRINGEOL
%num wxSTC_HJA_REGEX
%num wxSTC_HB_START
%num wxSTC_HB_DEFAULT
%num wxSTC_HB_COMMENTLINE
%num wxSTC_HB_NUMBER
%num wxSTC_HB_WORD
%num wxSTC_HB_STRING
%num wxSTC_HB_IDENTIFIER
%num wxSTC_HB_STRINGEOL
%num wxSTC_HBA_START
%num wxSTC_HBA_DEFAULT
%num wxSTC_HBA_COMMENTLINE
%num wxSTC_HBA_NUMBER
%num wxSTC_HBA_WORD
%num wxSTC_HBA_STRING
%num wxSTC_HBA_IDENTIFIER
%num wxSTC_HBA_STRINGEOL
%num wxSTC_HP_START
%num wxSTC_HP_DEFAULT
%num wxSTC_HP_COMMENTLINE
%num wxSTC_HP_NUMBER
%num wxSTC_HP_STRING
%num wxSTC_HP_CHARACTER
%num wxSTC_HP_WORD
%num wxSTC_HP_TRIPLE
%num wxSTC_HP_TRIPLEDOUBLE
%num wxSTC_HP_CLASSNAME
%num wxSTC_HP_DEFNAME
%num wxSTC_HP_OPERATOR
%num wxSTC_HP_IDENTIFIER
%num wxSTC_HPHP_COMPLEX_VARIABLE
%num wxSTC_HPA_START
%num wxSTC_HPA_DEFAULT
%num wxSTC_HPA_COMMENTLINE
%num wxSTC_HPA_NUMBER
%num wxSTC_HPA_STRING
%num wxSTC_HPA_CHARACTER
%num wxSTC_HPA_WORD
%num wxSTC_HPA_TRIPLE
%num wxSTC_HPA_TRIPLEDOUBLE
%num wxSTC_HPA_CLASSNAME
%num wxSTC_HPA_DEFNAME
%num wxSTC_HPA_OPERATOR
%num wxSTC_HPA_IDENTIFIER
%num wxSTC_HPHP_DEFAULT
%num wxSTC_HPHP_HSTRING
%num wxSTC_HPHP_SIMPLESTRING
%num wxSTC_HPHP_WORD
%num wxSTC_HPHP_NUMBER
%num wxSTC_HPHP_VARIABLE
%num wxSTC_HPHP_COMMENT
%num wxSTC_HPHP_COMMENTLINE
%num wxSTC_HPHP_HSTRING_VARIABLE
%num wxSTC_HPHP_OPERATOR
%num wxSTC_PL_DEFAULT
%num wxSTC_PL_ERROR
%num wxSTC_PL_COMMENTLINE
%num wxSTC_PL_POD
%num wxSTC_PL_NUMBER
%num wxSTC_PL_WORD
%num wxSTC_PL_STRING
%num wxSTC_PL_CHARACTER
%num wxSTC_PL_PUNCTUATION
%num wxSTC_PL_PREPROCESSOR
%num wxSTC_PL_OPERATOR
%num wxSTC_PL_IDENTIFIER
%num wxSTC_PL_SCALAR
%num wxSTC_PL_ARRAY
%num wxSTC_PL_HASH
%num wxSTC_PL_SYMBOLTABLE
%num wxSTC_PL_REGEX
%num wxSTC_PL_REGSUBST
%num wxSTC_PL_LONGQUOTE
%num wxSTC_PL_BACKTICKS
%num wxSTC_PL_DATASECTION
%num wxSTC_PL_HERE_DELIM
%num wxSTC_PL_HERE_Q
%num wxSTC_PL_HERE_QQ
%num wxSTC_PL_HERE_QX
%num wxSTC_PL_STRING_Q
%num wxSTC_PL_STRING_QQ
%num wxSTC_PL_STRING_QX
%num wxSTC_PL_STRING_QR
%num wxSTC_PL_STRING_QW
%num wxSTC_PL_POD_VERB
// Lexical states for SCLEX_RUBY
%num wxSTC_RB_DEFAULT
%num wxSTC_RB_ERROR
%num wxSTC_RB_COMMENTLINE
%num wxSTC_RB_POD
%num wxSTC_RB_NUMBER
%num wxSTC_RB_WORD
%num wxSTC_RB_STRING
%num wxSTC_RB_CHARACTER
%num wxSTC_RB_CLASSNAME
%num wxSTC_RB_DEFNAME
%num wxSTC_RB_OPERATOR
%num wxSTC_RB_IDENTIFIER
%num wxSTC_RB_REGEX
%num wxSTC_RB_GLOBAL
%num wxSTC_RB_SYMBOL
%num wxSTC_RB_MODULE_NAME
%num wxSTC_RB_INSTANCE_VAR
%num wxSTC_RB_CLASS_VAR
%num wxSTC_RB_BACKTICKS
%num wxSTC_RB_DATASECTION
%num wxSTC_RB_HERE_DELIM
%num wxSTC_RB_HERE_Q
%num wxSTC_RB_HERE_QQ
%num wxSTC_RB_HERE_QX
%num wxSTC_RB_STRING_Q
%num wxSTC_RB_STRING_QQ
%num wxSTC_RB_STRING_QX
%num wxSTC_RB_STRING_QR
%num wxSTC_RB_STRING_QW
%num wxSTC_RB_WORD_DEMOTED
%num wxSTC_RB_STDIN
%num wxSTC_RB_STDOUT
%num wxSTC_RB_STDERR
%num wxSTC_RB_UPPER_BOUND

// Lexical states for SCLEX_VB, SCLEX_VBSCRIPT, SCLEX_POWERBASIC
%num wxSTC_B_DEFAULT
%num wxSTC_B_COMMENT
%num wxSTC_B_NUMBER
%num wxSTC_B_KEYWORD
%num wxSTC_B_STRING
%num wxSTC_B_PREPROCESSOR
%num wxSTC_B_OPERATOR
%num wxSTC_B_IDENTIFIER
%num wxSTC_B_DATE
%num wxSTC_B_STRINGEOL
%num wxSTC_B_KEYWORD2
%num wxSTC_B_KEYWORD3
%num wxSTC_B_KEYWORD4
%num wxSTC_B_CONSTANT
%num wxSTC_B_ASM
%num wxSTC_B_LABEL
%num wxSTC_B_ERROR
%num wxSTC_B_HEXNUMBER
%num wxSTC_B_BINNUMBER

// Lexical states for SCLEX_PROPERTIES
%num wxSTC_PROPS_DEFAULT
%num wxSTC_PROPS_COMMENT
%num wxSTC_PROPS_SECTION
%num wxSTC_PROPS_ASSIGNMENT
%num wxSTC_PROPS_DEFVAL
%num wxSTC_PROPS_KEY

%num wxSTC_L_DEFAULT
%num wxSTC_L_COMMAND
%num wxSTC_L_TAG
%num wxSTC_L_MATH
%num wxSTC_L_COMMENT
%num wxSTC_LUA_DEFAULT
%num wxSTC_LUA_COMMENT
%num wxSTC_LUA_COMMENTLINE
%num wxSTC_LUA_COMMENTDOC
%num wxSTC_LUA_NUMBER
%num wxSTC_LUA_WORD
%num wxSTC_LUA_STRING
%num wxSTC_LUA_CHARACTER
%num wxSTC_LUA_LITERALSTRING
%num wxSTC_LUA_PREPROCESSOR
%num wxSTC_LUA_OPERATOR
%num wxSTC_LUA_IDENTIFIER
%num wxSTC_LUA_STRINGEOL
%num wxSTC_LUA_WORD2
%num wxSTC_LUA_WORD3
%num wxSTC_LUA_WORD4
%num wxSTC_LUA_WORD5
%num wxSTC_LUA_WORD6
%num wxSTC_LUA_WORD7
%num wxSTC_LUA_WORD8
%num wxSTC_ERR_DEFAULT
%num wxSTC_ERR_PYTHON
%num wxSTC_ERR_GCC
%num wxSTC_ERR_MS
%num wxSTC_ERR_CMD
%num wxSTC_ERR_BORLAND
%num wxSTC_ERR_PERL
%num wxSTC_ERR_NET
%num wxSTC_ERR_LUA
%num wxSTC_ERR_DIFF_CHANGED
%num wxSTC_ERR_DIFF_ADDITION
%num wxSTC_ERR_DIFF_DELETION
%num wxSTC_ERR_DIFF_MESSAGE
%num wxSTC_ERR_PHP
%num wxSTC_ERR_ELF
%num wxSTC_ERR_IFC
%num wxSTC_ERR_IFORT
%num wxSTC_ERR_ABSF
%num wxSTC_ERR_TIDY
%num wxSTC_ERR_JAVA_STACK
%num wxSTC_BAT_DEFAULT
%num wxSTC_BAT_COMMENT
%num wxSTC_BAT_WORD
%num wxSTC_BAT_LABEL
%num wxSTC_BAT_HIDE
%num wxSTC_BAT_COMMAND
%num wxSTC_BAT_IDENTIFIER
%num wxSTC_BAT_OPERATOR
%num wxSTC_MAKE_DEFAULT
%num wxSTC_MAKE_COMMENT
%num wxSTC_MAKE_PREPROCESSOR
%num wxSTC_MAKE_IDENTIFIER
%num wxSTC_MAKE_OPERATOR
%num wxSTC_MAKE_TARGET
%num wxSTC_MAKE_IDEOL
%num wxSTC_DIFF_DEFAULT
%num wxSTC_DIFF_COMMENT
%num wxSTC_DIFF_COMMAND
%num wxSTC_DIFF_HEADER
%num wxSTC_DIFF_POSITION
%num wxSTC_DIFF_DELETED
%num wxSTC_DIFF_ADDED
%num wxSTC_CONF_DEFAULT
%num wxSTC_CONF_COMMENT
%num wxSTC_CONF_NUMBER
%num wxSTC_CONF_IDENTIFIER
%num wxSTC_CONF_EXTENSION
%num wxSTC_CONF_PARAMETER
%num wxSTC_CONF_STRING
%num wxSTC_CONF_OPERATOR
%num wxSTC_CONF_IP
%num wxSTC_CONF_DIRECTIVE
%num wxSTC_AVE_DEFAULT
%num wxSTC_AVE_COMMENT
%num wxSTC_AVE_NUMBER
%num wxSTC_AVE_WORD
//%num wxSTC_AVE_KEYWORD
//%num wxSTC_AVE_STATEMENT
%num wxSTC_AVE_STRING
%num wxSTC_AVE_ENUM
%num wxSTC_AVE_STRINGEOL
%num wxSTC_AVE_IDENTIFIER
%num wxSTC_AVE_OPERATOR
%num wxSTC_AVE_WORD1
%num wxSTC_AVE_WORD2
%num wxSTC_AVE_WORD3
%num wxSTC_AVE_WORD4
%num wxSTC_AVE_WORD5
%num wxSTC_AVE_WORD6
%num wxSTC_ADA_DEFAULT
%num wxSTC_ADA_WORD
%num wxSTC_ADA_IDENTIFIER
%num wxSTC_ADA_NUMBER
%num wxSTC_ADA_DELIMITER
%num wxSTC_ADA_CHARACTER
%num wxSTC_ADA_CHARACTEREOL
%num wxSTC_ADA_STRING
%num wxSTC_ADA_STRINGEOL
%num wxSTC_ADA_LABEL
%num wxSTC_ADA_COMMENTLINE
%num wxSTC_ADA_ILLEGAL
// Lexical states for SCLEX_BAAN
%num wxSTC_BAAN_DEFAULT
%num wxSTC_BAAN_COMMENT
%num wxSTC_BAAN_COMMENTDOC
%num wxSTC_BAAN_NUMBER
%num wxSTC_BAAN_WORD
%num wxSTC_BAAN_STRING
%num wxSTC_BAAN_PREPROCESSOR
%num wxSTC_BAAN_OPERATOR
%num wxSTC_BAAN_IDENTIFIER
%num wxSTC_BAAN_STRINGEOL
%num wxSTC_BAAN_WORD2

%num wxSTC_LISP_DEFAULT
%num wxSTC_LISP_COMMENT
%num wxSTC_LISP_NUMBER
%num wxSTC_LISP_KEYWORD
%num wxSTC_LISP_STRING
%num wxSTC_LISP_STRINGEOL
%num wxSTC_LISP_IDENTIFIER
%num wxSTC_LISP_OPERATOR
%num wxSTC_LISP_SPECIAL
%num wxSTC_LISP_MULTI_COMMENT
%num wxSTC_EIFFEL_DEFAULT
%num wxSTC_EIFFEL_COMMENTLINE
%num wxSTC_EIFFEL_NUMBER
%num wxSTC_EIFFEL_WORD
%num wxSTC_EIFFEL_STRING
%num wxSTC_EIFFEL_CHARACTER
%num wxSTC_EIFFEL_OPERATOR
%num wxSTC_EIFFEL_IDENTIFIER
%num wxSTC_EIFFEL_STRINGEOL
%num wxSTC_NNCRONTAB_DEFAULT
%num wxSTC_NNCRONTAB_COMMENT
%num wxSTC_NNCRONTAB_TASK
%num wxSTC_NNCRONTAB_SECTION
%num wxSTC_NNCRONTAB_KEYWORD
%num wxSTC_NNCRONTAB_MODIFIER
%num wxSTC_NNCRONTAB_ASTERISK
%num wxSTC_NNCRONTAB_NUMBER
%num wxSTC_NNCRONTAB_STRING
%num wxSTC_NNCRONTAB_ENVIRONMENT
%num wxSTC_NNCRONTAB_IDENTIFIER

// Lexical states for SCLEX_FORTH (Forth Lexer)
%num wxSTC_FORTH_DEFAULT
%num wxSTC_FORTH_COMMENT
%num wxSTC_FORTH_COMMENT_ML
%num wxSTC_FORTH_IDENTIFIER
%num wxSTC_FORTH_CONTROL
%num wxSTC_FORTH_KEYWORD
%num wxSTC_FORTH_DEFWORD
%num wxSTC_FORTH_PREWORD1
%num wxSTC_FORTH_PREWORD2
%num wxSTC_FORTH_NUMBER
%num wxSTC_FORTH_STRING
%num wxSTC_FORTH_LOCALE

// Lexical states for SCLEX_MATLAB
%num wxSTC_MATLAB_DEFAULT
%num wxSTC_MATLAB_COMMENT
%num wxSTC_MATLAB_COMMAND
%num wxSTC_MATLAB_NUMBER
%num wxSTC_MATLAB_KEYWORD

// single quoted string
%num wxSTC_MATLAB_STRING
%num wxSTC_MATLAB_OPERATOR
%num wxSTC_MATLAB_IDENTIFIER
%num wxSTC_MATLAB_DOUBLEQUOTESTRING

// Lexical states for SCLEX_SCRIPTOL
%num wxSTC_SCRIPTOL_DEFAULT
%num wxSTC_SCRIPTOL_WHITE
%num wxSTC_SCRIPTOL_COMMENTLINE
%num wxSTC_SCRIPTOL_PERSISTENT
%num wxSTC_SCRIPTOL_CSTYLE
%num wxSTC_SCRIPTOL_COMMENTBLOCK
%num wxSTC_SCRIPTOL_NUMBER
%num wxSTC_SCRIPTOL_STRING
%num wxSTC_SCRIPTOL_CHARACTER
%num wxSTC_SCRIPTOL_STRINGEOL
%num wxSTC_SCRIPTOL_KEYWORD
%num wxSTC_SCRIPTOL_OPERATOR
%num wxSTC_SCRIPTOL_IDENTIFIER
%num wxSTC_SCRIPTOL_TRIPLE
%num wxSTC_SCRIPTOL_CLASSNAME
%num wxSTC_SCRIPTOL_PREPROCESSOR

// Lexical states for SCLEX_ASM
%num wxSTC_ASM_DEFAULT
%num wxSTC_ASM_COMMENT
%num wxSTC_ASM_NUMBER
%num wxSTC_ASM_STRING
%num wxSTC_ASM_OPERATOR
%num wxSTC_ASM_IDENTIFIER
%num wxSTC_ASM_CPUINSTRUCTION
%num wxSTC_ASM_MATHINSTRUCTION
%num wxSTC_ASM_REGISTER
%num wxSTC_ASM_DIRECTIVE
%num wxSTC_ASM_DIRECTIVEOPERAND
%num wxSTC_ASM_COMMENTBLOCK
%num wxSTC_ASM_CHARACTER
%num wxSTC_ASM_STRINGEOL
%num wxSTC_ASM_EXTINSTRUCTION

// Lexical states for SCLEX_FORTRAN
%num wxSTC_F_DEFAULT
%num wxSTC_F_COMMENT
%num wxSTC_F_NUMBER
%num wxSTC_F_STRING1
%num wxSTC_F_STRING2
%num wxSTC_F_STRINGEOL
%num wxSTC_F_OPERATOR
%num wxSTC_F_IDENTIFIER
%num wxSTC_F_WORD
%num wxSTC_F_WORD2
%num wxSTC_F_WORD3
%num wxSTC_F_PREPROCESSOR
%num wxSTC_F_OPERATOR2
%num wxSTC_F_LABEL
%num wxSTC_F_CONTINUATION

// Lexical states for SCLEX_CSS
%num wxSTC_CSS_DEFAULT
%num wxSTC_CSS_TAG
%num wxSTC_CSS_CLASS
%num wxSTC_CSS_PSEUDOCLASS
%num wxSTC_CSS_UNKNOWN_PSEUDOCLASS
%num wxSTC_CSS_OPERATOR
%num wxSTC_CSS_IDENTIFIER
%num wxSTC_CSS_UNKNOWN_IDENTIFIER
%num wxSTC_CSS_VALUE
%num wxSTC_CSS_COMMENT
%num wxSTC_CSS_ID
%num wxSTC_CSS_IMPORTANT
%num wxSTC_CSS_DIRECTIVE
%num wxSTC_CSS_DOUBLESTRING
%num wxSTC_CSS_SINGLESTRING
%num wxSTC_CSS_IDENTIFIER2
%num wxSTC_CSS_ATTRIBUTE

// Lexical states for SCLEX_POV
%num wxSTC_POV_DEFAULT
%num wxSTC_POV_COMMENT
%num wxSTC_POV_COMMENTLINE
%num wxSTC_POV_NUMBER
%num wxSTC_POV_OPERATOR
%num wxSTC_POV_IDENTIFIER
%num wxSTC_POV_STRING
%num wxSTC_POV_STRINGEOL
%num wxSTC_POV_DIRECTIVE
%num wxSTC_POV_BADDIRECTIVE
%num wxSTC_POV_WORD2
%num wxSTC_POV_WORD3
%num wxSTC_POV_WORD4
%num wxSTC_POV_WORD5
%num wxSTC_POV_WORD6
%num wxSTC_POV_WORD7
%num wxSTC_POV_WORD8

// Lexical states for SCLEX_LOUT
%num wxSTC_LOUT_DEFAULT
%num wxSTC_LOUT_COMMENT
%num wxSTC_LOUT_NUMBER
%num wxSTC_LOUT_WORD
%num wxSTC_LOUT_WORD2
%num wxSTC_LOUT_WORD3
%num wxSTC_LOUT_WORD4
%num wxSTC_LOUT_STRING
%num wxSTC_LOUT_OPERATOR
%num wxSTC_LOUT_IDENTIFIER
%num wxSTC_LOUT_STRINGEOL

// Lexical states for SCLEX_ESCRIPT
%num wxSTC_ESCRIPT_DEFAULT
%num wxSTC_ESCRIPT_COMMENT
%num wxSTC_ESCRIPT_COMMENTLINE
%num wxSTC_ESCRIPT_COMMENTDOC
%num wxSTC_ESCRIPT_NUMBER
%num wxSTC_ESCRIPT_WORD
%num wxSTC_ESCRIPT_STRING
%num wxSTC_ESCRIPT_OPERATOR
%num wxSTC_ESCRIPT_IDENTIFIER
%num wxSTC_ESCRIPT_BRACE
%num wxSTC_ESCRIPT_WORD2
%num wxSTC_ESCRIPT_WORD3

// Lexical states for SCLEX_PS
%num wxSTC_PS_DEFAULT
%num wxSTC_PS_COMMENT
%num wxSTC_PS_DSC_COMMENT
%num wxSTC_PS_DSC_VALUE
%num wxSTC_PS_NUMBER
%num wxSTC_PS_NAME
%num wxSTC_PS_KEYWORD
%num wxSTC_PS_LITERAL
%num wxSTC_PS_IMMEVAL
%num wxSTC_PS_PAREN_ARRAY
%num wxSTC_PS_PAREN_DICT
%num wxSTC_PS_PAREN_PROC
%num wxSTC_PS_TEXT
%num wxSTC_PS_HEXSTRING
%num wxSTC_PS_BASE85STRING
%num wxSTC_PS_BADSTRINGCHAR

// Lexical states for SCLEX_NSIS
%num wxSTC_NSIS_DEFAULT
%num wxSTC_NSIS_COMMENT
%num wxSTC_NSIS_STRINGDQ
%num wxSTC_NSIS_STRINGLQ
%num wxSTC_NSIS_STRINGRQ
%num wxSTC_NSIS_FUNCTION
%num wxSTC_NSIS_VARIABLE
%num wxSTC_NSIS_LABEL
%num wxSTC_NSIS_USERDEFINED
%num wxSTC_NSIS_SECTIONDEF
%num wxSTC_NSIS_SUBSECTIONDEF
%num wxSTC_NSIS_IFDEFINEDEF
%num wxSTC_NSIS_MACRODEF
%num wxSTC_NSIS_STRINGVAR
%num wxSTC_NSIS_NUMBER
%num wxSTC_NSIS_SECTIONGROUP
%num wxSTC_NSIS_PAGEEX
%num wxSTC_NSIS_FUNCTIONDEF
%num wxSTC_NSIS_COMMENTBOX

// Lexical states for SCLEX_MMIXAL
%num wxSTC_MMIXAL_LEADWS
%num wxSTC_MMIXAL_COMMENT
%num wxSTC_MMIXAL_LABEL
%num wxSTC_MMIXAL_OPCODE
%num wxSTC_MMIXAL_OPCODE_PRE
%num wxSTC_MMIXAL_OPCODE_VALID
%num wxSTC_MMIXAL_OPCODE_UNKNOWN
%num wxSTC_MMIXAL_OPCODE_POST
%num wxSTC_MMIXAL_OPERANDS
%num wxSTC_MMIXAL_NUMBER
%num wxSTC_MMIXAL_REF
%num wxSTC_MMIXAL_CHAR
%num wxSTC_MMIXAL_STRING
%num wxSTC_MMIXAL_REGISTER
%num wxSTC_MMIXAL_HEX
%num wxSTC_MMIXAL_OPERATOR
%num wxSTC_MMIXAL_SYMBOL
%num wxSTC_MMIXAL_INCLUDE

// Lexical states for SCLEX_CLW
%num wxSTC_CLW_DEFAULT
%num wxSTC_CLW_LABEL
%num wxSTC_CLW_COMMENT
%num wxSTC_CLW_STRING
%num wxSTC_CLW_USER_IDENTIFIER
%num wxSTC_CLW_INTEGER_CONSTANT
%num wxSTC_CLW_REAL_CONSTANT
%num wxSTC_CLW_PICTURE_STRING
%num wxSTC_CLW_KEYWORD
%num wxSTC_CLW_COMPILER_DIRECTIVE
%num wxSTC_CLW_RUNTIME_EXPRESSIONS
%num wxSTC_CLW_BUILTIN_PROCEDURES_FUNCTION
%num wxSTC_CLW_STRUCTURE_DATA_TYPE
%num wxSTC_CLW_ATTRIBUTE
%num wxSTC_CLW_STANDARD_EQUATE
%num wxSTC_CLW_ERROR
%num wxSTC_CLW_DEPRECATED

// Lexical states for SCLEX_LOT
%num wxSTC_LOT_DEFAULT
%num wxSTC_LOT_HEADER
%num wxSTC_LOT_BREAK
%num wxSTC_LOT_SET
%num wxSTC_LOT_PASS
%num wxSTC_LOT_FAIL
%num wxSTC_LOT_ABORT

// Lexical states for SCLEX_YAML
%num wxSTC_YAML_DEFAULT
%num wxSTC_YAML_COMMENT
%num wxSTC_YAML_IDENTIFIER
%num wxSTC_YAML_KEYWORD
%num wxSTC_YAML_NUMBER
%num wxSTC_YAML_REFERENCE
%num wxSTC_YAML_DOCUMENT
%num wxSTC_YAML_TEXT
%num wxSTC_YAML_ERROR

// Lexical states for SCLEX_TEX
%num wxSTC_TEX_DEFAULT
%num wxSTC_TEX_SPECIAL
%num wxSTC_TEX_GROUP
%num wxSTC_TEX_SYMBOL
%num wxSTC_TEX_COMMAND
%num wxSTC_TEX_TEXT
%num wxSTC_METAPOST_DEFAULT
%num wxSTC_METAPOST_SPECIAL
%num wxSTC_METAPOST_GROUP
%num wxSTC_METAPOST_SYMBOL
%num wxSTC_METAPOST_COMMAND
%num wxSTC_METAPOST_TEXT
%num wxSTC_METAPOST_EXTRA

// Lexical states for SCLEX_ERLANG
%num wxSTC_ERLANG_DEFAULT
%num wxSTC_ERLANG_COMMENT
%num wxSTC_ERLANG_VARIABLE
%num wxSTC_ERLANG_NUMBER
%num wxSTC_ERLANG_KEYWORD
%num wxSTC_ERLANG_STRING
%num wxSTC_ERLANG_OPERATOR
%num wxSTC_ERLANG_ATOM
%num wxSTC_ERLANG_FUNCTION_NAME
%num wxSTC_ERLANG_CHARACTER
%num wxSTC_ERLANG_MACRO
%num wxSTC_ERLANG_RECORD
%num wxSTC_ERLANG_SEPARATOR
%num wxSTC_ERLANG_NODE_NAME
%num wxSTC_ERLANG_UNKNOWN

// Lexical states for SCLEX_OCTAVE are identical to MatLab
// Lexical states for SCLEX_MSSQL
%num wxSTC_MSSQL_DEFAULT
%num wxSTC_MSSQL_COMMENT
%num wxSTC_MSSQL_LINE_COMMENT
%num wxSTC_MSSQL_NUMBER
%num wxSTC_MSSQL_STRING
%num wxSTC_MSSQL_OPERATOR
%num wxSTC_MSSQL_IDENTIFIER
%num wxSTC_MSSQL_VARIABLE
%num wxSTC_MSSQL_COLUMN_NAME
%num wxSTC_MSSQL_STATEMENT
%num wxSTC_MSSQL_DATATYPE
%num wxSTC_MSSQL_SYSTABLE
%num wxSTC_MSSQL_GLOBAL_VARIABLE
%num wxSTC_MSSQL_FUNCTION
%num wxSTC_MSSQL_STORED_PROCEDURE
%num wxSTC_MSSQL_DEFAULT_PREF_DATATYPE
%num wxSTC_MSSQL_COLUMN_NAME_2

// Lexical states for SCLEX_VERILOG
%num wxSTC_V_DEFAULT
%num wxSTC_V_COMMENT
%num wxSTC_V_COMMENTLINE
%num wxSTC_V_COMMENTLINEBANG
%num wxSTC_V_NUMBER
%num wxSTC_V_WORD
%num wxSTC_V_STRING
%num wxSTC_V_WORD2
%num wxSTC_V_WORD3
%num wxSTC_V_PREPROCESSOR
%num wxSTC_V_OPERATOR
%num wxSTC_V_IDENTIFIER
%num wxSTC_V_STRINGEOL
%num wxSTC_V_USER

// Lexical states for SCLEX_KIX
%num wxSTC_KIX_DEFAULT
%num wxSTC_KIX_COMMENT
%num wxSTC_KIX_STRING1
%num wxSTC_KIX_STRING2
%num wxSTC_KIX_NUMBER
%num wxSTC_KIX_VAR
%num wxSTC_KIX_MACRO
%num wxSTC_KIX_KEYWORD
%num wxSTC_KIX_FUNCTIONS
%num wxSTC_KIX_OPERATOR
%num wxSTC_KIX_IDENTIFIER

// Lexical states for SCLEX_GUI4CLI
%num wxSTC_GC_DEFAULT
%num wxSTC_GC_COMMENTLINE
%num wxSTC_GC_COMMENTBLOCK
%num wxSTC_GC_GLOBAL
%num wxSTC_GC_EVENT
%num wxSTC_GC_ATTRIBUTE
%num wxSTC_GC_CONTROL
%num wxSTC_GC_COMMAND
%num wxSTC_GC_STRING
%num wxSTC_GC_OPERATOR

// Lexical states for SCLEX_SPECMAN
%num wxSTC_SN_DEFAULT
%num wxSTC_SN_CODE
%num wxSTC_SN_COMMENTLINE
%num wxSTC_SN_COMMENTLINEBANG
%num wxSTC_SN_NUMBER
%num wxSTC_SN_WORD
%num wxSTC_SN_STRING
%num wxSTC_SN_WORD2
%num wxSTC_SN_WORD3
%num wxSTC_SN_PREPROCESSOR
%num wxSTC_SN_OPERATOR
%num wxSTC_SN_IDENTIFIER
%num wxSTC_SN_STRINGEOL
%num wxSTC_SN_REGEXTAG
%num wxSTC_SN_SIGNAL
%num wxSTC_SN_USER

// Lexical states for SCLEX_AU3
%num wxSTC_AU3_DEFAULT
%num wxSTC_AU3_COMMENT
%num wxSTC_AU3_COMMENTBLOCK
%num wxSTC_AU3_NUMBER
%num wxSTC_AU3_FUNCTION
%num wxSTC_AU3_KEYWORD
%num wxSTC_AU3_MACRO
%num wxSTC_AU3_STRING
%num wxSTC_AU3_OPERATOR
%num wxSTC_AU3_VARIABLE
%num wxSTC_AU3_SENT
%num wxSTC_AU3_PREPROCESSOR
%num wxSTC_AU3_SPECIAL
%num wxSTC_AU3_EXPAND
%num wxSTC_AU3_COMOBJ
%num wxSTC_AU3_UDF

// Lexical states for SCLEX_APDL
%num wxSTC_APDL_DEFAULT
%num wxSTC_APDL_COMMENT
%num wxSTC_APDL_COMMENTBLOCK
%num wxSTC_APDL_NUMBER
%num wxSTC_APDL_STRING
%num wxSTC_APDL_OPERATOR
%num wxSTC_APDL_WORD
%num wxSTC_APDL_PROCESSOR
%num wxSTC_APDL_COMMAND
%num wxSTC_APDL_SLASHCOMMAND
%num wxSTC_APDL_STARCOMMAND
%num wxSTC_APDL_ARGUMENT
%num wxSTC_APDL_FUNCTION

// Lexical states for SCLEX_BASH
%num wxSTC_SH_DEFAULT
%num wxSTC_SH_ERROR
%num wxSTC_SH_COMMENTLINE
%num wxSTC_SH_NUMBER
%num wxSTC_SH_WORD
%num wxSTC_SH_STRING
%num wxSTC_SH_CHARACTER
%num wxSTC_SH_OPERATOR
%num wxSTC_SH_IDENTIFIER
%num wxSTC_SH_SCALAR
%num wxSTC_SH_PARAM
%num wxSTC_SH_BACKTICKS
%num wxSTC_SH_HERE_DELIM
%num wxSTC_SH_HERE_Q

// Lexical states for SCLEX_ASN1
%num wxSTC_ASN1_DEFAULT
%num wxSTC_ASN1_COMMENT
%num wxSTC_ASN1_IDENTIFIER
%num wxSTC_ASN1_STRING
%num wxSTC_ASN1_OID
%num wxSTC_ASN1_SCALAR
%num wxSTC_ASN1_KEYWORD
%num wxSTC_ASN1_ATTRIBUTE
%num wxSTC_ASN1_DESCRIPTOR
%num wxSTC_ASN1_TYPE
%num wxSTC_ASN1_OPERATOR

// Lexical states for SCLEX_VHDL
%num wxSTC_VHDL_DEFAULT
%num wxSTC_VHDL_COMMENT
%num wxSTC_VHDL_COMMENTLINEBANG
%num wxSTC_VHDL_NUMBER
%num wxSTC_VHDL_STRING
%num wxSTC_VHDL_OPERATOR
%num wxSTC_VHDL_IDENTIFIER
%num wxSTC_VHDL_STRINGEOL
%num wxSTC_VHDL_KEYWORD
%num wxSTC_VHDL_STDOPERATOR
%num wxSTC_VHDL_ATTRIBUTE
%num wxSTC_VHDL_STDFUNCTION
%num wxSTC_VHDL_STDPACKAGE
%num wxSTC_VHDL_STDTYPE
%num wxSTC_VHDL_USERWORD

// Lexical states for SCLEX_CAML
%num wxSTC_CAML_DEFAULT
%num wxSTC_CAML_IDENTIFIER
%num wxSTC_CAML_TAGNAME
%num wxSTC_CAML_KEYWORD
%num wxSTC_CAML_KEYWORD2
%num wxSTC_CAML_KEYWORD3
%num wxSTC_CAML_LINENUM
%num wxSTC_CAML_OPERATOR
%num wxSTC_CAML_NUMBER
%num wxSTC_CAML_CHAR
%num wxSTC_CAML_STRING
%num wxSTC_CAML_COMMENT
%num wxSTC_CAML_COMMENT1
%num wxSTC_CAML_COMMENT2
%num wxSTC_CAML_COMMENT3

// Lexical states for SCLEX_HASKELL
%num wxSTC_HA_DEFAULT
%num wxSTC_HA_IDENTIFIER
%num wxSTC_HA_KEYWORD
%num wxSTC_HA_NUMBER
%num wxSTC_HA_STRING
%num wxSTC_HA_CHARACTER
%num wxSTC_HA_CLASS
%num wxSTC_HA_MODULE
%num wxSTC_HA_CAPITAL
%num wxSTC_HA_DATA
%num wxSTC_HA_IMPORT
%num wxSTC_HA_OPERATOR
%num wxSTC_HA_INSTANCE
%num wxSTC_HA_COMMENTLINE
%num wxSTC_HA_COMMENTBLOCK
%num wxSTC_HA_COMMENTBLOCK2
%num wxSTC_HA_COMMENTBLOCK3

// Lexical states of SCLEX_TADS3
%num wxSTC_T3_DEFAULT
%num wxSTC_T3_X_DEFAULT
%num wxSTC_T3_PREPROCESSOR
%num wxSTC_T3_BLOCK_COMMENT
%num wxSTC_T3_LINE_COMMENT
%num wxSTC_T3_OPERATOR
%num wxSTC_T3_KEYWORD
%num wxSTC_T3_NUMBER
%num wxSTC_T3_IDENTIFIER
%num wxSTC_T3_S_STRING
%num wxSTC_T3_D_STRING
%num wxSTC_T3_X_STRING
%num wxSTC_T3_LIB_DIRECTIVE
%num wxSTC_T3_MSG_PARAM
%num wxSTC_T3_HTML_TAG
%num wxSTC_T3_HTML_DEFAULT
%num wxSTC_T3_HTML_STRING
%num wxSTC_T3_USER1
%num wxSTC_T3_USER2
%num wxSTC_T3_USER3

// Lexical states for SCLEX_REBOL
%num wxSTC_REBOL_DEFAULT
%num wxSTC_REBOL_COMMENTLINE
%num wxSTC_REBOL_COMMENTBLOCK
%num wxSTC_REBOL_PREFACE
%num wxSTC_REBOL_OPERATOR
%num wxSTC_REBOL_CHARACTER
%num wxSTC_REBOL_QUOTEDSTRING
%num wxSTC_REBOL_BRACEDSTRING
%num wxSTC_REBOL_NUMBER
%num wxSTC_REBOL_PAIR
%num wxSTC_REBOL_TUPLE
%num wxSTC_REBOL_BINARY
%num wxSTC_REBOL_MONEY
%num wxSTC_REBOL_ISSUE
%num wxSTC_REBOL_TAG
%num wxSTC_REBOL_FILE
%num wxSTC_REBOL_EMAIL
%num wxSTC_REBOL_URL
%num wxSTC_REBOL_DATE
%num wxSTC_REBOL_TIME
%num wxSTC_REBOL_IDENTIFIER
%num wxSTC_REBOL_WORD
%num wxSTC_REBOL_WORD2
%num wxSTC_REBOL_WORD3
%num wxSTC_REBOL_WORD4
%num wxSTC_REBOL_WORD5
%num wxSTC_REBOL_WORD6
%num wxSTC_REBOL_WORD7
%num wxSTC_REBOL_WORD8

// Lexical states for SCLEX_SQL
%num wxSTC_SQL_DEFAULT
%num wxSTC_SQL_COMMENT
%num wxSTC_SQL_COMMENTLINE
%num wxSTC_SQL_COMMENTDOC
%num wxSTC_SQL_NUMBER
%num wxSTC_SQL_WORD
%num wxSTC_SQL_STRING
%num wxSTC_SQL_CHARACTER
%num wxSTC_SQL_SQLPLUS
%num wxSTC_SQL_SQLPLUS_PROMPT
%num wxSTC_SQL_OPERATOR
%num wxSTC_SQL_IDENTIFIER
%num wxSTC_SQL_SQLPLUS_COMMENT
%num wxSTC_SQL_COMMENTLINEDOC
%num wxSTC_SQL_WORD2
%num wxSTC_SQL_COMMENTDOCKEYWORD
%num wxSTC_SQL_COMMENTDOCKEYWORDERROR
%num wxSTC_SQL_USER1
%num wxSTC_SQL_USER2
%num wxSTC_SQL_USER3
%num wxSTC_SQL_USER4
%num wxSTC_SQL_QUOTEDIDENTIFIER

// Lexical states for SCLEX_SMALLTALK
%num wxSTC_ST_DEFAULT
%num wxSTC_ST_STRING
%num wxSTC_ST_NUMBER
%num wxSTC_ST_COMMENT
%num wxSTC_ST_SYMBOL
%num wxSTC_ST_BINARY
%num wxSTC_ST_BOOL
%num wxSTC_ST_SELF
%num wxSTC_ST_SUPER
%num wxSTC_ST_NIL
%num wxSTC_ST_GLOBAL
%num wxSTC_ST_RETURN
%num wxSTC_ST_SPECIAL
%num wxSTC_ST_KWSEND
%num wxSTC_ST_ASSIGN
%num wxSTC_ST_CHARACTER
%num wxSTC_ST_SPEC_SEL

// Lexical states for SCLEX_FLAGSHIP (clipper)
%num wxSTC_FS_DEFAULT
%num wxSTC_FS_COMMENT
%num wxSTC_FS_COMMENTLINE
%num wxSTC_FS_COMMENTDOC
%num wxSTC_FS_COMMENTLINEDOC
%num wxSTC_FS_COMMENTDOCKEYWORD
%num wxSTC_FS_COMMENTDOCKEYWORDERROR
%num wxSTC_FS_KEYWORD
%num wxSTC_FS_KEYWORD2
%num wxSTC_FS_KEYWORD3
%num wxSTC_FS_KEYWORD4
%num wxSTC_FS_NUMBER
%num wxSTC_FS_STRING
%num wxSTC_FS_PREPROCESSOR
%num wxSTC_FS_OPERATOR
%num wxSTC_FS_IDENTIFIER
%num wxSTC_FS_DATE
%num wxSTC_FS_STRINGEOL
%num wxSTC_FS_CONSTANT
%num wxSTC_FS_ASM
%num wxSTC_FS_LABEL
%num wxSTC_FS_ERROR
%num wxSTC_FS_HEXNUMBER
%num wxSTC_FS_BINNUMBER

// Lexical states for SCLEX_CSOUND
%num wxSTC_CSOUND_DEFAULT
%num wxSTC_CSOUND_COMMENT
%num wxSTC_CSOUND_NUMBER
%num wxSTC_CSOUND_OPERATOR
%num wxSTC_CSOUND_INSTR
%num wxSTC_CSOUND_IDENTIFIER
%num wxSTC_CSOUND_OPCODE
%num wxSTC_CSOUND_HEADERSTMT
%num wxSTC_CSOUND_USERKEYWORD
%num wxSTC_CSOUND_COMMENTBLOCK
%num wxSTC_CSOUND_PARAM
%num wxSTC_CSOUND_ARATE_VAR
%num wxSTC_CSOUND_KRATE_VAR
%num wxSTC_CSOUND_IRATE_VAR
%num wxSTC_CSOUND_GLOBAL_VAR
%num wxSTC_CSOUND_STRINGEOL

// Lexical states for SCLEX_INNOSETUP
%num wxSTC_INNO_DEFAULT
%num wxSTC_INNO_COMMENT
%num wxSTC_INNO_KEYWORD
%num wxSTC_INNO_PARAMETER
%num wxSTC_INNO_SECTION
%num wxSTC_INNO_PREPROC
%num wxSTC_INNO_PREPROC_INLINE
%num wxSTC_INNO_COMMENT_PASCAL
%num wxSTC_INNO_KEYWORD_PASCAL
%num wxSTC_INNO_KEYWORD_USER
%num wxSTC_INNO_STRING_DOUBLE
%num wxSTC_INNO_STRING_SINGLE
%num wxSTC_INNO_IDENTIFIER

// Lexical states for SCLEX_OPAL
%num wxSTC_OPAL_SPACE
%num wxSTC_OPAL_COMMENT_BLOCK
%num wxSTC_OPAL_COMMENT_LINE
%num wxSTC_OPAL_INTEGER
%num wxSTC_OPAL_KEYWORD
%num wxSTC_OPAL_SORT
%num wxSTC_OPAL_STRING
%num wxSTC_OPAL_PAR
%num wxSTC_OPAL_BOOL_CONST
%num wxSTC_OPAL_DEFAULT

// Lexical states for SCLEX_SPICE
%num wxSTC_SPICE_DEFAULT
%num wxSTC_SPICE_IDENTIFIER
%num wxSTC_SPICE_KEYWORD
%num wxSTC_SPICE_KEYWORD2
%num wxSTC_SPICE_KEYWORD3
%num wxSTC_SPICE_NUMBER
%num wxSTC_SPICE_DELIMITER
%num wxSTC_SPICE_VALUE
%num wxSTC_SPICE_COMMENTLINE

// the event codes

%num wxSTC_CMD_REDO
%num wxSTC_CMD_SELECTALL
%num wxSTC_CMD_UNDO
%num wxSTC_CMD_CUT
%num wxSTC_CMD_COPY
%num wxSTC_CMD_PASTE
%num wxSTC_CMD_LINEDOWN
%num wxSTC_CMD_LINEDOWNEXTEND
%num wxSTC_CMD_LINEUP
%num wxSTC_CMD_LINEUPEXTEND
%num wxSTC_CMD_CHARLEFT
%num wxSTC_CMD_CHARLEFTEXTEND
%num wxSTC_CMD_CHARRIGHT
%num wxSTC_CMD_CHARRIGHTEXTEND
%num wxSTC_CMD_WORDLEFT
%num wxSTC_CMD_WORDLEFTEXTEND
%num wxSTC_CMD_WORDRIGHT
%num wxSTC_CMD_WORDRIGHTEXTEND
%num wxSTC_CMD_HOME
%num wxSTC_CMD_HOMEEXTEND
%num wxSTC_CMD_LINEEND
%num wxSTC_CMD_LINEENDEXTEND
%num wxSTC_CMD_DOCUMENTSTART
%num wxSTC_CMD_DOCUMENTSTARTEXTEND
%num wxSTC_CMD_DOCUMENTEND
%num wxSTC_CMD_DOCUMENTENDEXTEND
%num wxSTC_CMD_PAGEUP
%num wxSTC_CMD_PAGEUPEXTEND
%num wxSTC_CMD_PAGEDOWN
%num wxSTC_CMD_PAGEDOWNEXTEND
%num wxSTC_CMD_EDITTOGGLEOVERTYPE
%num wxSTC_CMD_CANCEL
%num wxSTC_CMD_DELETEBACK
%num wxSTC_CMD_TAB
%num wxSTC_CMD_BACKTAB
%num wxSTC_CMD_NEWLINE
%num wxSTC_CMD_FORMFEED
%num wxSTC_CMD_VCHOME
%num wxSTC_CMD_VCHOMEEXTEND
%num wxSTC_CMD_ZOOMIN
%num wxSTC_CMD_ZOOMOUT
%num wxSTC_CMD_DELWORDLEFT
%num wxSTC_CMD_DELWORDRIGHT
%num wxSTC_CMD_LINECUT
%num wxSTC_CMD_LINEDELETE
%num wxSTC_CMD_LINETRANSPOSE
%num wxSTC_CMD_LOWERCASE
%num wxSTC_CMD_UPPERCASE
%num wxSTC_CMD_LINESCROLLDOWN
%num wxSTC_CMD_LINESCROLLUP

%num wxSTC_CMD_DELETEBACKNOTLINE
%num wxSTC_CMD_HOMEDISPLAY
%num wxSTC_CMD_HOMEDISPLAYEXTEND
%num wxSTC_CMD_LINEENDDISPLAY
%num wxSTC_CMD_LINEENDDISPLAYEXTEND
%num wxSTC_CMD_HOMEWRAP
%num wxSTC_CMD_HOMEWRAPEXTEND
%num wxSTC_CMD_LINEENDWRAP
%num wxSTC_CMD_LINEENDWRAPEXTEND
%num wxSTC_CMD_VCHOMEWRAP
%num wxSTC_CMD_VCHOMEWRAPEXTEND
%num wxSTC_CMD_LINECOPY
%num wxSTC_CMD_WORDPARTLEFT
%num wxSTC_CMD_WORDPARTLEFTEXTEND
%num wxSTC_CMD_WORDPARTRIGHT
%num wxSTC_CMD_WORDPARTRIGHTEXTEND
%num wxSTC_CMD_DELLINELEFT
%num wxSTC_CMD_DELLINERIGHT
%num wxSTC_CMD_PARADOWN
%num wxSTC_CMD_PARADOWNEXTEND
%num wxSTC_CMD_PARAUP
%num wxSTC_CMD_PARAUPEXTEND
%num wxSTC_CMD_LINEDOWNRECTEXTEND
%num wxSTC_CMD_LINEUPRECTEXTEND
%num wxSTC_CMD_CHARLEFTRECTEXTEND
%num wxSTC_CMD_CHARRIGHTRECTEXTEND
%num wxSTC_CMD_HOMERECTEXTEND
%num wxSTC_CMD_VCHOMERECTEXTEND
%num wxSTC_CMD_LINEENDRECTEXTEND
%num wxSTC_CMD_PAGEUPRECTEXTEND
%num wxSTC_CMD_PAGEDOWNRECTEXTEND
%num wxSTC_CMD_STUTTEREDPAGEUP
%num wxSTC_CMD_STUTTEREDPAGEUPEXTEND
%num wxSTC_CMD_STUTTEREDPAGEDOWN
%num wxSTC_CMD_STUTTEREDPAGEDOWNEXTEND
%num wxSTC_CMD_WORDLEFTEND
%num wxSTC_CMD_WORDLEFTENDEXTEND
%num wxSTC_CMD_WORDRIGHTEND
%num wxSTC_CMD_WORDRIGHTENDEXTEND

///////////////////////////////////////////////////////////////////////////////
// wxStyledTextEvent

%class %delete wxStyledTextEvent, wxCommandEvent
%include "wx/stc/stc.h"

%event wxEVT_STC_CHANGE
%event wxEVT_STC_STYLENEEDED
%event wxEVT_STC_CHARADDED
%event wxEVT_STC_SAVEPOINTREACHED
%event wxEVT_STC_SAVEPOINTLEFT
%event wxEVT_STC_ROMODIFYATTEMPT
%event wxEVT_STC_KEY
%event wxEVT_STC_DOUBLECLICK
%event wxEVT_STC_UPDATEUI
%event wxEVT_STC_MODIFIED
%event wxEVT_STC_MACRORECORD
%event wxEVT_STC_MARGINCLICK
%event wxEVT_STC_NEEDSHOWN
//%event wxEVT_STC_POSCHANGED
%event wxEVT_STC_PAINTED
%event wxEVT_STC_USERLISTSELECTION
%event wxEVT_STC_URIDROPPED
%event wxEVT_STC_DWELLSTART
%event wxEVT_STC_DWELLEND
%event wxEVT_STC_START_DRAG
%event wxEVT_STC_DRAG_OVER
%event wxEVT_STC_DO_DROP
%event wxEVT_STC_ZOOM
%event wxEVT_STC_HOTSPOT_CLICK
%event wxEVT_STC_HOTSPOT_DCLICK
%event wxEVT_STC_CALLTIP_CLICK
%event wxEVT_STC_AUTOCOMP_SELECTION

wxStyledTextEvent(wxEventType commandType=0, int id=0)
%ctor wxStyledTextEventCopy(const wxStyledTextEvent& event)
// FIX! Should this be a Clone cto or something?
// wxStyledTextEvent(const wxStyledTextEvent& event);
void SetPosition(int pos)
void SetKey(int k)
void SetModifiers(int m)
void SetModificationType(int t)
void SetText(const wxString& t)
void SetLength(int len)
void SetLinesAdded(int num)
void SetLine(int val)
void SetFoldLevelNow(int val)
void SetFoldLevelPrev(int val)
void SetMargin(int val)
void SetMessage(int val)
void SetWParam(int val)
void SetLParam(int val)
void SetListType(int val)
void SetX(int val)
void SetY(int val)
void SetDragText(const wxString& val)
void SetDragAllowMove(bool val)
void SetDragResult(wxDragResult val)

int  GetPosition()
int  GetKey()
int  GetModifiers()
int  GetModificationType()
wxString GetText() const
int  GetLength() const
int  GetLinesAdded() const
int  GetLine() const
int  GetFoldLevelNow() const
int  GetFoldLevelPrev() const
int  GetMargin() const
int  GetMessage() const
int  GetWParam() const
int  GetLParam() const
int  GetListType() const
int  GetX() const
int  GetY() const
wxString GetDragText()
bool GetDragAllowMove()
wxDragResult GetDragResult()
bool GetShift()
bool GetControl()
bool GetAlt()
virtual wxEvent* Clone()

///////////////////////////////////////////////////////////////////////////////
// wxGenericDirCtrl

%class wxGenericDirCtrl, wxControl
%include "wx/dirctrl.h"

%ctor wxGenericDirCtrlNoCreate()
wxGenericDirCtrl(wxWindow* parent, const wxWindowID id = -1, const wxString& dir = wxDirDialogDefaultFolderStr, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDIRCTRL_3D_INTERNAL|wxSUNKEN_BORDER, const wxString& filter = wxEmptyString, int defaultFilter = 0, const wxString& name = wxTreeCtrlNameStr)
bool Create(wxWindow* parent, const wxWindowID id = -1, const wxString& dir = wxDirDialogDefaultFolderStr, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDIRCTRL_3D_INTERNAL|wxSUNKEN_BORDER, const wxString& filter = wxEmptyString, int defaultFilter = 0, const wxString& name = wxTreeCtrlNameStr)
void Init()
// FIXME: not found (but in .h file)
//void CollapseTree()
bool ExpandPath(const wxString& path)
wxString GetDefaultPath() const
wxString GetPath() const
wxString GetFilePath() const
wxString GetFilter() const
int GetFilterIndex() const
wxDirFilterListCtrl* GetFilterListCtrl() const
wxTreeItemId GetRootId()
wxTreeCtrl* GetTreeCtrl() const
void ReCreateTree()
void SetDefaultPath(const wxString& path)
void SetFilter(const wxString& filter)
void SetFilterIndex(int n)
void SetPath(const wxString& path)

bool CollapsePath(const wxString& path)
void ShowHidden(bool show)

%num wxDIRCTRL_DIR_ONLY
%num wxDIRCTRL_3D_INTERNAL
%num wxDIRCTRL_SELECT_FIRST
%num wxDIRCTRL_SHOW_FILTERS
%num wxDIRCTRL_EDIT_LABELS

///////////////////////////////////////////////////////////////////////////////
// wxDirFilterListCtrl

%class wxDirFilterListCtrl, wxChoice
%include "wx/dirctrl.h"

wxDirFilterListCtrl(wxGenericDirCtrl* parent, const wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0)
void FillFilterList(const wxString& filter, int defaultFilter);

///////////////////////////////////////////////////////////////////////////////
// wxDir

%class %delete wxDir
%include "wx/dir.h"

wxDir()
static bool Exists(const wxString& dir)
bool Open(const wxString& dir)
bool IsOpened() const
// bool GetFirst(wxString* filename, const wxString& filespec = wxEmptyString, int flags = wxDIR_DEFAULT) const
%{
	// char *GetFirst(const wxString& filespec = wxEmptyString, int flags = wxDIR_DEFAULT) const
    void wxDir_GetFirst()
	{
		// int flags
		int flags = (wTheCall->parmCount > 1 ? (int)wStackPopInteger() : wxDIR_DEFAULT );

		// const wxString& value = wxEmptyString
        wxString filespec = (wTheCall->parmCount > 0 ? wxString(wStackPopChar(), *wxConvCurrent) : wxT(""));

        // allocate string to hold the result
        wxString filename = wxString();

		// call wxDir::GetFirst
        ((wxDir *)wTheCall->self->ptr)->GetFirst(&filename, filespec, flags);

		wWrapDerefArgs();
        wStackPushChar( (char *)(filename.char_str()), W_TRUE );
	}
%}
%method GetFirst wxDir_GetFirst(const wxString& filespec = wxEmptyString, int flags = wxDIR_DEFAULT)

// bool GetNext(wxString* filename) const
%{
    // char *GetNext()
    void wxDir_GetNext()
	{
        // allocate string to hold the result
        wxString filename = wxString();

        // call wxDir::GetNext
        ((wxDir *)wTheCall->self->ptr)->GetNext(&filename);

		wWrapDerefArgs();
        wStackPushChar( (char *)(filename.char_str()), W_TRUE );
	}
%}
%method GetNext wxDir_GetNext()

bool HasFiles(const wxString& filespec = wxEmptyString)
bool HasSubDirs(const wxString& dirspec = wxEmptyString)
// FIXME: wxDirTraverser not defined yet
// size_t Traverse(wxDirTraverser& sink, const wxString& filespec = wxEmptyString, int flags = wxDIR_DEFAULT)
// FIXME: returning arrays is not currently supported
// static size_t GetAllFiles(const wxString& dirname, wxArrayString *files, const wxString& filespec = wxEmptyString, int flags = wxDIR_DEFAULT)

// TOOD: wxULongLong?
//static wxULongLong GetTotalSize(const wxString& dir, wxArrayString* filesSkipped = NULL)

// enums
%num wxDIR_FILES
%num wxDIR_DIRS
%num wxDIR_HIDDEN
%num wxDIR_DOTDOT
%num wxDIR_DEFAULT

%builtin %rename wxDir_Exists bool wxDir::Exists(const wxString& dir)
%builtin %rename wxDir_GetAllFiles size_t wxDir::GetAllFiles(const wxString& dirname, wxArrayString *files, const wxString& filespec = wxEmptyString, int flags = wxDIR_DEFAULT)
%builtin %rename wxDir_FindFirst wxString wxDir::FindFirst(const wxString& dirname, const wxString& filespec, int flags = wxDIR_DEFAULT)
//%builtin %rename wxDir_GetTotalSize wxULongLong wxDir::GetTotalSize(const wxString& dir, wxArrayString* filesSkipped = NULL)

///////////////////////////////////////////////////////////////////////////////
// DATA STEAM SUPPORT
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// wxStreamBase

%class %delete wxStreamBase
%include "wx/stream.h"

wxStreamBase()
int IsOk() const
int GetLastError() const
	%num wxSTREAM_NO_ERROR
	%num wxSTREAM_EOF
	%num wxSTREAM_WRITE_ERROR
	%num wxSTREAM_READ_ERROR
// FIXME: these are documented, but don't seem to exist
// size_t OnSysRead(void* buffer, size_t bufsize)
// off_t OnSysSeek(off_t pos, wxSeekMode mode)
// off_t OnSysTell() const
// size_t OnSysWrite(void *buffer, size_t bufsize)
size_t GetSize() const

wxFileOffset GetLength() const
bool IsSeekable() const

///////////////////////////////////////////////////////////////////////////////
// wxStreamBuffer

%include <wx/stream.h>

%typedef BufMode wxStreamBuffer::BufMode

// BufMode read=0, write=1, read_write=2

%class wxStreamBuffer
wxStreamBuffer(wxStreamBase& stream, BufMode mode)
size_t Read(void *buffer, size_t size)
size_t Write(const void *buffer, size_t size)
char GetChar()
void PutChar(char c)
off_t Tell() const
off_t Seek(off_t pos, wxSeekMode mode)
void ResetBuffer()
void SetBufferIO(char* buffer_start, char* buffer_end)
void * GetBufferStart() const
void * GetBufferEnd() const
void * GetBufferPos() const
off_t GetIntPosition() const
void SetIntPosition(size_t pos)
size_t GetLastAccess() const
void Fixed(bool fixed)
void Flushable(bool flushable)
bool FlushBuffer()
bool FillBuffer()
size_t GetDataLeft()
wxStreamBase*  Stream()

///////////////////////////////////////////////////////////////////////////////
// wxInputStream

%class %delete wxInputStream, wxStreamBase
%include "wx/stream.h"

// wxInputStream()
char GetC()
bool Eof() const
size_t LastRead() const
char Peek()
// void Read(void *buffer, size_t size)
%{
    // void Read(void * buffer, size_t size)
    void wxInputStream_Read()
    {
        // the number of bytes
        int size = wStackPopInteger();

        // allocate a buffer of the requested size
        void *buffer = wMalloc( size + 1 ); // 0 byte

        // call Read
        ((wxInputStream*)(wTheCall->self->ptr))->Read(buffer, size);

        // clear the args
        wWrapDerefArgs();

        // wrap the buffer into a string
        wStackPushChar( (char *)(buffer), W_TRUE );

        // free the buffer
        wFree( buffer );
    }

%}
%method Read      wxInputStream_Read( int nbytes )


off_t SeekI(off_t pos, wxSeekMode mode = wxFromStart)
off_t TellI() const
// FIXME: not implemented
size_t Ungetch(const char* buffer, size_t size)
// FIXME: rename this, only ungets a single char
// bool Ungetch(char c)
bool CanRead() const

///////////////////////////////////////////////////////////////////////////////
// wxOutputStream

%class %delete wxOutputStream, wxStreamBase
%include "wx/stream.h"

wxOutputStream()
size_t LastWrite() const
void PutC(char c)
off_t SeekO(off_t pos, wxSeekMode mode)
off_t TellO() const
// wxOutputStream& Write(const void *buffer, size_t size)
// wxOutputStream& Write(wxInputStream& stream_in)
%{
    // wxOutputStream& Write(const void *buffer, size_t size)
    void wxOutputStream_Write()
    {
        // get pointer to the string
        wVariant *theString = wStackPopString();
        int nbytes = wStringCount( theString );
        void *buffer = (void *)wStringChar( theString );

        // call Write
        ((wxOutputStream *)(wTheCall->self->ptr))->Write(buffer, nbytes);

        // clear the args
        wWrapDerefArgs();
    }

    // void WriteFromStream(wxInputStream& stream_in)
    void wxOutputStream_WriteFromStream()
    {
        // get the input stream
        wxInputStream *stream_in = (wxInputStream *)wStackPopObjectPtr( _wxInputStream );

        // call Write
        ((wxOutputStream *)(wTheCall->self->ptr))->Write(*stream_in);

        // clear the args
        wWrapDerefArgs();
    }
%}
%method Write           wxOutputStream_Write( wxString *buffer )
%method WriteFromStream wxOutputStream_WriteFromStream( wxInputStream& stream_in )
bool Close()

///////////////////////////////////////////////////////////////////////////////
// wxFileInputStream

%include <wx/wfstream.h>
%class %delete wxFileInputStream, wxInputStream
wxFileInputStream(const wxString& ifileName)
%ctor wxFileInputStreamFromFile(wxFile& file)
%ctor wxFileInputStreamById(int fd)

// ~wxFileInputStream()
bool IsOk() const

///////////////////////////////////////////////////////////////////////////////
// wxFileOutputStream

%include <wx/wfstream.h>
%class %delete wxFileOutputStream, wxOutputStream
wxFileOutputStream(const wxString& ofileName)
// ~wxFileOutputStream()
bool IsOk() const

///////////////////////////////////////////////////////////////////////////////
// wxFilterInputStream

%include <wx/stream.h>
%class %delete wxFilterInputStream, wxInputStream
//wxFilterInputStream(wxInputStream& stream)

///////////////////////////////////////////////////////////////////////////////
// wxFilterOutputStream

%include <wx/stream.h>
%class %delete wxFilterOutputStream, wxOutputStream
wxFilterOutputStream(wxOutputStream& stream)

///////////////////////////////////////////////////////////////////////////////
// wxStringInputStream

%include <wx/sstream.h>
%class %delete wxStringInputStream, wxInputStream
wxStringInputStream(const wxString& s)

///////////////////////////////////////////////////////////////////////////////
// wxStringOutputStream

%include <wx/sstream.h>
%class %delete wxStringOutputStream, wxOutputStream
// use GetString instead
//wxStringOutputStream(wxString *str = NULL)
wxStringOutputStream()
const wxString& GetString() const

///////////////////////////////////////////////////////////////////////////////
// wxFFileInputStream

%include <wx/wfstream.h>
%class %delete wxFFileInputStream, wxInputStream
wxFFileInputStream(const wxString& filename, const wxString mode = wxT("rb"))
// ~wxFFileInputStream()
bool IsOk() const

///////////////////////////////////////////////////////////////////////////////
// wxFFileOutputStream

%include <wx/wfstream.h>
%class %delete wxFFileOutputStream, wxOutputStream
wxFFileOutputStream(const wxString& filename, const wxString mode=wxT("w+b"))
// ~wxFFileOutputStream()
bool IsOk() const

///////////////////////////////////////////////////////////////////////////////
// wxMemoryInputStream

%include <wx/mstream.h>
%class wxMemoryInputStream, wxInputStream
wxMemoryInputStream(const char * data, size_t len)
// ~wxMemoryInputStream()
wxStreamBuffer *  GetInputStreamBuffer() const

///////////////////////////////////////////////////////////////////////////////
// wxMemoryOutputStream

%include <wx/mstream.h>
%class wxMemoryOutputStream, wxOutputStream
wxMemoryOutputStream(char * data = NULL, size_t length = 0)
// ~wxMemoryOutputStream()
size_t CopyTo(char *buffer, size_t len) const
wxStreamBuffer *  GetOutputStreamBuffer() const

///////////////////////////////////////////////////////////////////////////////
// wxArchiveEntry

%include <wx/archive.h>
%class %delete wxArchiveEntry, wxObject
wxArchiveEntry*  Clone() const
wxDateTime  GetDateTime() const
wxPathFormat GetInternalFormat() const
wxString  GetInternalName() const
wxString  GetName(wxPathFormat format = wxPATH_NATIVE) const
off_t GetOffset() const
off_t GetSize() const
bool IsDir() const
bool IsReadOnly() const
// need to add Notifier
//void SetNotifier(wxArchiveNotifier& notifier)

///////////////////////////////////////////////////////////////////////////////
// wxArchiveInputStream

%include <wx/archive.h>
%class %delete wxArchiveInputStream, wxFilterInputStream
bool CloseEntry()
wxArchiveEntry*  GetNextEntry()
bool OpenEntry(wxArchiveEntry& entry)

///////////////////////////////////////////////////////////////////////////////
// wxArchiveOutputStream

%include <wx/archive.h>
%class %delete wxArchiveOutputStream, wxFilterOutputStream
// ~wxArchiveOutputStream()
bool Close()
bool CloseEntry()
bool CopyArchiveMetaData(wxArchiveInputStream& stream)
bool CopyEntry(wxArchiveEntry* entry, wxArchiveInputStream& stream)
bool PutNextDirEntry(const wxString& name, const wxDateTime& dt = wxDateTime::Now())
bool PutNextEntry(wxArchiveEntry* entry)

///////////////////////////////////////////////////////////////////////////////
// wxTarEntry

%include <wx/tarstrm.h>

%num wxTAR_LNKTYPE
%num wxTAR_SYMTYPE
%num wxTAR_CHRTYPE
%num wxTAR_BLKTYPE
%num wxTAR_DIRTYPE
%num wxTAR_FIFOTYPE
%num wxTAR_CONTTYPE

%class wxTarEntry, wxArchiveEntry
wxTarEntry(const wxString& name = wxEmptyString, const wxDateTime& dt = wxDateTime::Now(), wxFileOffset size = wxInvalidOffset)
wxDateTime  GetAccessTime() const
wxDateTime  GetCreateTime() const
int GetDevMajor() const
int GetGroupId() const
wxString  GetGroupName() const
wxString  GetInternalName() const
wxString  GetLinkName() const
int GetMode() const
void SetSize(wxFileOffset size)
int GetTypeFlag() const

///////////////////////////////////////////////////////////////////////////////
// wxTarInputStream

%include <wx/tarstrm.h>
%class wxTarInputStream, wxArchiveInputStream
wxTarInputStream(wxInputStream& stream, wxMBConv& conv = wxConvLocal)
bool CloseEntry()
wxTarEntry*  GetNextEntry()
bool OpenEntry(wxTarEntry& entry)

///////////////////////////////////////////////////////////////////////////////
// wxTarOutputStream

%include <wx/tarstrm.h>
%enum  wxTarFormat
  %num wxTAR_USTAR
  %num wxTAR_PAX
%class wxTarOutputStream, wxArchiveOutputStream
wxTarOutputStream(wxOutputStream& stream, wxTarFormat format = wxTAR_PAX, wxMBConv& conv = wxConvLocal)
// ~wxTarOutputStream()
bool Close()
bool CloseEntry()
bool CopyArchiveMetaData(wxTarInputStream& s)
bool CopyEntry(wxTarEntry* entry, wxTarInputStream& inputStream)
int GetBlockingFactor() const
bool PutNextDirEntry(const wxString& name, const wxDateTime& dt = wxDateTime::Now())
bool PutNextEntry(wxTarEntry* entry)

///////////////////////////////////////////////////////////////////////////////
// wxZipEntry

%include <wx/zipstrm.h>
%enum  wxZipMethod
  %num wxZIP_METHOD_STORE
  %num wxZIP_METHOD_SHRINK
  %num wxZIP_METHOD_REDUCE1
  %num wxZIP_METHOD_REDUCE2
  %num wxZIP_METHOD_REDUCE3
  %num wxZIP_METHOD_REDUCE4
  %num wxZIP_METHOD_IMPLODE
  %num wxZIP_METHOD_TOKENIZE
  %num wxZIP_METHOD_DEFLATE
  %num wxZIP_METHOD_DEFLATE64
  %num wxZIP_METHOD_BZIP2
  %num wxZIP_METHOD_DEFAULT
%enum  wxZipSystem
  %num wxZIP_SYSTEM_MSDOS
  %num wxZIP_SYSTEM_AMIGA
  %num wxZIP_SYSTEM_OPENVMS
  %num wxZIP_SYSTEM_UNIX
  %num wxZIP_SYSTEM_VM_CMS
  %num wxZIP_SYSTEM_ATARI_ST
  %num wxZIP_SYSTEM_OS2_HPFS
  %num wxZIP_SYSTEM_MACINTOSH
  %num wxZIP_SYSTEM_Z_SYSTEM
  %num wxZIP_SYSTEM_CPM
  %num wxZIP_SYSTEM_WINDOWS_NTFS
  %num wxZIP_SYSTEM_MVS
  %num wxZIP_SYSTEM_VSE
  %num wxZIP_SYSTEM_ACORN_RISC
  %num wxZIP_SYSTEM_VFAT
  %num wxZIP_SYSTEM_ALTERNATE_MVS
  %num wxZIP_SYSTEM_BEOS
  %num wxZIP_SYSTEM_TANDEM
  %num wxZIP_SYSTEM_OS_400
%enum  wxZipAttributes
  %num wxZIP_A_RDONLY
  %num wxZIP_A_HIDDEN
  %num wxZIP_A_SYSTEM
  %num wxZIP_A_SUBDIR
  %num wxZIP_A_ARCH
  %num 
  %num wxZIP_A_MASK
%enum  wxZipFlags
  %num wxZIP_ENCRYPTED
  %num wxZIP_DEFLATE_NORMAL
  %num wxZIP_DEFLATE_EXTRA
  %num wxZIP_DEFLATE_FAST
  %num wxZIP_DEFLATE_SUPERFAST
  %num wxZIP_DEFLATE_MASK
  %num wxZIP_SUMS_FOLLOW
  %num wxZIP_ENHANCED
  %num wxZIP_PATCH
  %num wxZIP_STRONG_ENC
  %num wxZIP_UNUSED
  %num wxZIP_RESERVED

%class %delete wxZipEntry, wxArchiveEntry
wxZipEntry(const wxString& name = wxEmptyString, const wxDateTime& dt = wxDateTime::Now(), off_t size = wxInvalidOffset)
wxZipEntry*  Clone() const
wxString  GetComment() const
off_t GetCompressedSize() const
wxUint32 GetCrc() const
wxUint32 GetExternalAttributes() const
const char* GetExtra() const
int GetFlags() const
wxString  GetInternalName() const
const char* GetLocalExtra() const
int GetMethod() const
int GetMode() const
// need to add Notifier
//void SetNotifier(wxZipNotifier& notifier)
int GetSystemMadeBy() const
bool IsMadeByUnix() const
bool IsText() const

///////////////////////////////////////////////////////////////////////////////
// wxZipInputStream

%include <wx/zipstrm.h>
%class %delete wxZipInputStream, wxArchiveInputStream
wxZipInputStream(wxInputStream& stream, wxMBConv& conv = wxConvLocal)
bool CloseEntry()
wxString  GetComment()
wxZipEntry*  GetNextEntry()
int GetTotalEntries()
bool OpenEntry(wxZipEntry& entry)

///////////////////////////////////////////////////////////////////////////////
// wxZipOutputStream

%include <wx/zipstrm.h>
%class %delete wxZipOutputStream, wxArchiveOutputStream
wxZipOutputStream(wxOutputStream& stream, int level = -1, wxMBConv& conv = wxConvLocal)
// ~wxZipOutputStream()
bool Close()
bool CloseEntry()
bool CopyArchiveMetaData(wxZipInputStream& inputStream)
bool CopyEntry(wxZipEntry* entry, wxZipInputStream& inputStream)
int GetLevel() const
bool PutNextDirEntry(const wxString& name, const wxDateTime& dt = wxDateTime::Now())
bool PutNextEntry(wxZipEntry* entry)
void SetComment(const wxString& comment)

///////////////////////////////////////////////////////////////////////////////
// wxZlibInputStream

%include <wx/zstream.h>

%num wxZLIB_NO_HEADER
%num wxZLIB_ZLIB
%num wxZLIB_GZIP
%num wxZLIB_AUTO

%class wxZlibInputStream, wxFilterInputStream
wxZlibInputStream(wxInputStream& stream, int flags = wxZLIB_AUTO)
static bool CanHandleGZip()

%builtin %rename wxZlibInputStream_CanHandleGZip bool wxZlibInputStream::CanHandleGZip()

///////////////////////////////////////////////////////////////////////////////
// wxZlibOutputStream

%include <wx/zstream.h>

%num wxZ_NO_COMPRESSION
%num wxZ_BEST_SPEED
%num wxZ_BEST_COMPRESSION

%class wxZlibOutputStream, wxFilterOutputStream
wxZlibOutputStream(wxOutputStream& stream, int level = -1, int flags = wxZLIB_ZLIB)
static bool CanHandleGZip()

%builtin %rename wxZlibOutputStream_CanHandleGZip bool wxZlibOutputStream::CanHandleGZip()

///////////////////////////////////////////////////////////////////////////////
// SOCKET CLASSES
///////////////////////////////////////////////////////////////////////////////

// #########################################################
// sckaddr.h

%include <wx/sckaddr.h>

// ==============================
// Class: wxSockAddress

%class %delete wxSockAddress, wxObject

// abstract class
//wxSockAddress()
//wxSockAddress(const wxSockAddress& other)
virtual void Clear()
virtual int Type()
GAddress *GetAddress() const
void SetAddress(GAddress *address)
virtual wxSockAddress *Clone() const

//%not(gcc) %num %rename wxSockAddress_Addr_IPV4 wxSockAddress::Addr::IPV4
//%not(gcc) %num %rename wxSockAddress_Addr_IPV6 wxSockAddress::Addr::IPV6
//%not(gcc) %num %rename wxSockAddress_Addr_UNIX wxSockAddress::Addr::UNIX
%num %rename wxSockAddress_Addr_IPV4 1
%num %rename wxSockAddress_Addr_IPV6 2
%num %rename wxSockAddress_Addr_UNIX 3

// ==============================
// Class: wxIPaddress

%class %delete wxIPaddress, wxSockAddress
// abstract class
//wxIPaddress()
//wxIPaddress(const wxIPaddress& other)
virtual bool Hostname(const wxString& name)
bool Service(const wxString& name)
%rename ServiceName bool Service(const wxString& name)
%rename ServicePort bool Service(unsigned short port)
virtual bool LocalHost()
virtual bool IsLocalHost() const
virtual bool AnyAddress()
virtual wxString IPAddress() const
%rename GetHostname virtual wxString Hostname() const
%rename GetService virtual unsigned short Service() const

// ==============================
// Class: wxIPV4address

%class %delete wxIPV4address, wxIPaddress
wxIPV4address()
//wxIPV4address(const wxIPV4address& other)
virtual bool Hostname(const wxString& name)
%rename HostnameByName virtual bool Hostname(const wxString& name)
%rename HostnameByAddr bool Hostname(unsigned long addr)
virtual bool Service(const wxString& name)
%rename ServiceName bool Service(const wxString& name)
%rename ServicePort bool Service(unsigned short port)
virtual bool LocalHost()
virtual bool IsLocalHost() const
virtual bool AnyAddress()
%rename GetHostname virtual wxString Hostname() const
wxString OrigHostname()
%rename GetService virtual unsigned short Service() const
virtual wxString IPAddress() const
virtual int Type()
virtual wxSockAddress *Clone() const

%num wxUSE_IPV6

// ==============================
// Class: wxIPV6address - RP: has not been implemented in socket layer yet

//%class wxIPV6address, wxIPaddress
//%struct wxIPV6address::sockaddr_in6
//wxIPV6address()
  //wxIPV6address(const wxIPV6address& other)
//  virtual bool Hostname(const wxString& name)

//  bool Hostname(unsigned char addr[16])
//  virtual bool Service(const wxString& name)
//  virtual bool Service(unsigned short port)

//  virtual bool LocalHost()
//  virtual bool IsLocalHost() const

//  virtual bool AnyAddress()

//  virtual wxString IPAddress() const

//  %rename GetHostname virtual wxString Hostname() const
//  %rename GetService virtual unsigned short Service() const

//  virtual int Type()
//  virtual wxSockAddress *Clone() const

// ==============================
// Class: wxUNIXaddress - RP: just work under Unix, not even Apple

//%class wxUNIXaddress, wxSockAddress
//%struct wxUNIXaddress::sockaddr_un
//  wxUNIXaddress();
  //wxUNIXaddress(const wxUNIXaddress& other)

//  void Filename(const wxString& name)
//  wxString Filename()

//  virtual int Type()
//  virtual wxSockAddress *Clone() const

// #########################################################
// ipcbase.h

%include <wx/ipcbase.h>

%enum wxIPCFormat
  %num wxIPC_INVALID
  %num wxIPC_TEXT
  %num wxIPC_BITMAP
  %num wxIPC_METAFILE
  %num wxIPC_SYLK
  %num wxIPC_DIF
  %num wxIPC_TIFF
  %num wxIPC_OEMTEXT
  %num wxIPC_DIB
  %num wxIPC_PALETTE
  %num wxIPC_PENDATA
  %num wxIPC_RIFF
  %num wxIPC_WAVE
  %num wxIPC_UNICODETEXT
  %num wxIPC_ENHMETAFILE
  %num wxIPC_FILENAME
  %num wxIPC_LOCALE
  %num wxIPC_PRIVATE

// ==============================
// Class: wxConnectionBase

%class wxConnectionBase, wxObject
//RP: abstract class
//wxConnectionBase(wxChar *buffer, int size)
//wxConnectionBase()
//wxConnectionBase(const wxConnectionBase& copy)
void SetConnected( bool c )
bool GetConnected()
virtual bool Execute(const wxChar *data, int size = -1, wxIPCFormat format = wxIPC_TEXT )
%rename ExecuteCmd virtual bool Execute(const wxString& str)
virtual wxChar *Request(const wxString& item, int *size = (int *) NULL, wxIPCFormat format = wxIPC_TEXT)
virtual bool Poke(const wxString& item, wxChar* data, int size = -1, wxIPCFormat format = wxIPC_TEXT)
virtual bool StartAdvise(const wxString& item)
virtual bool StopAdvise(const wxString& item)
virtual bool Advise(const wxString& item, wxChar *data, int size = -1, wxIPCFormat format = wxIPC_TEXT)
//RP: removed (void)
virtual bool Disconnect()
virtual bool OnExecute     ( const wxString& topic, wxChar *data, int size, wxIPCFormat format )
virtual wxChar *OnRequest    ( const wxString& topic, const wxString& item, int *size, wxIPCFormat format )
virtual bool OnPoke        ( const wxString& topic, const wxString& item, wxChar *data, int size, wxIPCFormat format )
virtual bool OnStartAdvise ( const wxString& topic, const wxString& item )
virtual bool OnStopAdvise  ( const wxString& topic, const wxString& item )
virtual bool OnAdvise      ( const wxString& topic, const wxString& item, wxChar *data, int size, wxIPCFormat format )
//RP: removed (void)
virtual bool OnDisconnect()
wxChar *      GetBufferAtLeast( size_t bytes )

///////////////////////////////////////////////////////////////////////////////
// wxConnection

%include <wx/ipc.h>
%class wxConnection, wxConnectionBase
wxConnection()
bool Advise(const wxString& item, wxChar* data, int size = -1, wxIPCFormat format = wxIPC_TEXT)
bool Execute(const wxChar* data, int size = -1, wxIPCFormat format = wxIPC_TEXT)
bool Disconnect()
virtual bool OnAdvise(const wxString& topic, const wxString& item, wxChar* data, int size, wxIPCFormat format)
virtual bool OnDisconnect()
virtual bool OnExecute(const wxString& topic, wxChar* data, int size, wxIPCFormat format)
virtual bool OnPoke(const wxString& topic, const wxString& item, wxChar* data, int size, wxIPCFormat format)
virtual wxChar* OnRequest(const wxString& topic, const wxString& item, int *size, wxIPCFormat format)
virtual bool OnStartAdvise(const wxString& topic, const wxString& item)
virtual bool OnStopAdvise(const wxString& topic, const wxString& item)
bool Poke(const wxString& item, wxChar* data, int size = -1, wxIPCFormat format = wxIPC_TEXT)
wxChar* Request(const wxString& item, int *size, wxIPCFormat format = wxIPC_TEXT)
bool StartAdvise(const wxString& item)
bool StopAdvise(const wxString& item)

// ==============================
// Class: wxServerBase

%class wxServerBase, wxObject
//inline wxServerBase()
//inline ~wxServerBase()
virtual bool Create(const wxString& serverName)
//virtual wxConnectionBase *OnAcceptConnection(const wxString& topic)

///////////////////////////////////////////////////////////////////////////////
// wxServer

%include <wx/ipc.h>
%class wxServer, wxServerBase
wxServer()
bool Create(const wxString& service)
//virtual wxConnectionBase * OnAcceptConnection(const wxString& topic)

// ==============================
// Class: wxClientBase

%class wxClientBase, wxObject
//inline wxClientBase()
//inline ~wxClientBase()
virtual bool ValidHost(const wxString& host)
virtual wxConnectionBase *MakeConnection(const wxString& host, const wxString& server, const wxString& topic)
//virtual wxConnectionBase *OnMakeConnection()

///////////////////////////////////////////////////////////////////////////////
// wxClient

%include <wx/ipc.h>
%class wxClient, wxClientBase
wxClient()
wxConnectionBase * MakeConnection(const wxString& host, const wxString& service, const wxString& topic)
//wxConnectionBase * OnMakeConnection()
bool ValidHost(const wxString& host)

///////////////////////////////////////////////////////////////////////////////
// wxDDEClient

%if(win) %class wxDDEClient, wxClientBase
%include <wx/dde.h>
wxDDEClient()
wxConnectionBase * MakeConnection(const wxString& host, const wxString& service, const wxString& topic)
//wxConnectionBase * OnMakeConnection()
bool ValidHost(const wxString& host)

///////////////////////////////////////////////////////////////////////////////
// wxDDEConnection

%include <wx/dde.h>
%if(win) %class wxDDEConnection, wxConnectionBase
wxDDEConnection()
bool Advise(const wxString& item, wxChar* data, int size = -1, wxIPCFormat format = wxIPC_TEXT)
bool Execute(wxChar* data, int size = -1, wxIPCFormat format = wxIPC_TEXT)
bool Disconnect()
virtual bool OnAdvise(const wxString& topic, const wxString& item, wxChar* data, int size, wxIPCFormat format)
virtual bool OnDisconnect()
virtual bool OnExecute(const wxString& topic, wxChar* data, int size, wxIPCFormat format)
virtual bool OnPoke(const wxString& topic, const wxString& item, wxChar* data, int size, wxIPCFormat format)
virtual wxChar* OnRequest(const wxString& topic, const wxString& item, int *size, wxIPCFormat format)
virtual bool OnStartAdvise(const wxString& topic, const wxString& item)
virtual bool OnStopAdvise(const wxString& topic, const wxString& item)
bool Poke(const wxString& item, wxChar* data, int size = -1, wxIPCFormat format = wxIPC_TEXT)
wxChar* Request(const wxString& item, int *size, wxIPCFormat format = wxIPC_TEXT)
bool StartAdvise(const wxString& item)
bool StopAdvise(const wxString& item)

///////////////////////////////////////////////////////////////////////////////
// wxDDEServer

%include <wx/dde.h>
%if(win) %class wxDDEServer, wxServerBase
wxDDEServer()
bool Create(const wxString& service)
virtual wxConnectionBase * OnAcceptConnection(const wxString& topic)

// #########################################################
// sckipc.h

%include <wx/sckipc.h>

// ==============================
// Class: wxTCPConnection

%class wxTCPConnection, wxConnectionBase
wxTCPConnection(wxChar *buffer, int size)
//wxTCPConnection()
virtual bool Execute(const wxChar *data, int size = -1, wxIPCFormat format = wxIPC_TEXT)
virtual wxChar *Request(const wxString& item, int *size = NULL, wxIPCFormat format = wxIPC_TEXT)
virtual bool Poke(const wxString& item, wxChar *data, int size = -1, wxIPCFormat format = wxIPC_TEXT)
virtual bool StartAdvise(const wxString& item)
virtual bool StopAdvise(const wxString& item)
virtual bool Advise(const wxString& item, wxChar *data, int size = -1, wxIPCFormat format = wxIPC_TEXT)
virtual bool Disconnect()
virtual bool OnDisconnect()
void Compress(bool on)
%rename ExecuteCmd virtual bool Execute(const wxString& str)

// ==============================
// Class: wxTCPServer

%class wxTCPServer, wxServerBase
wxTCPConnection *topLevelConnection
wxTCPServer()
virtual bool Create(const wxString& serverName)
virtual wxConnectionBase *OnAcceptConnection(const wxString& topic)

// ==============================
// Class: wxTCPClient

%class wxTCPClient, wxClientBase
wxTCPClient()
virtual bool ValidHost(const wxString& host)
virtual wxConnectionBase *MakeConnection(const wxString& host, const wxString& server, const wxString& topic)
virtual wxConnectionBase *OnMakeConnection()

// #########################################################
// socket.h

%include <wx/socket.h>

%enum wxSocketNotify
  %num wxSOCKET_INPUT
  %num wxSOCKET_OUTPUT
  %num wxSOCKET_CONNECTION
  %num wxSOCKET_LOST

%num wxSOCKET_INPUT_FLAG
%num wxSOCKET_OUTPUT_FLAG
%num wxSOCKET_CONNECTION_FLAG
%num wxSOCKET_LOST_FLAG

%typedef wxSocketEventFlags GSocketEventFlags

%enum wxSocketError
  %num wxSOCKET_NOERROR
  %num wxSOCKET_INVOP
  %num wxSOCKET_IOERR
  %num wxSOCKET_INVADDR
  %num wxSOCKET_INVSOCK
  %num wxSOCKET_NOHOST
  %num wxSOCKET_INVPORT
  %num wxSOCKET_WOULDBLOCK
  %num wxSOCKET_TIMEDOUT
  %num wxSOCKET_MEMERR
  %num wxSOCKET_DUMMY

%num wxSOCKET_NONE
%num wxSOCKET_NOWAIT
%num wxSOCKET_WAITALL
%num wxSOCKET_BLOCK
%num wxSOCKET_REUSEADDR

%enum wxSocketType
  %num wxSOCKET_UNINIT
  %num wxSOCKET_CLIENT
  %num wxSOCKET_SERVER
  %num wxSOCKET_BASE
  %num wxSOCKET_DATAGRAM

%typedef wxSocketFlags int

// ==============================
// Class: wxSocketBase

%class wxSocketBase, wxObject
//wxSocketBase()
wxSocketBase(wxSocketFlags flags, wxSocketType type)
void Init()
bool Destroy()
bool Ok() const
bool IsOk() const
bool Error() const
bool IsConnected() const
bool IsData()
bool IsDisconnected() const
wxUint32 LastCount() const
wxSocketError LastError() const
void SaveState()
void RestoreState()
//virtual bool GetLocal(wxSockAddress& addr_man) const
//virtual bool GetPeer(wxSockAddress& addr_man) const
virtual bool SetLocal(wxIPV4address& local)
virtual bool  Close()
wxSocketBase& Discard()
//wxSocketBase& Peek(void* buffer, wxUint32 nbytes)
//wxSocketBase& Read(void* buffer, wxUint32 nbytes)
//wxSocketBase& ReadMsg(void *buffer, wxUint32 nbytes)
wxSocketBase& Unread(const void *buffer, wxUint32 nbytes)
//wxSocketBase& Write(const void *buffer, wxUint32 nbytes)
//wxSocketBase& WriteMsg(const void *buffer, wxUint32 nbytes)
void InterruptWait()
bool Wait(long seconds = -1, long milliseconds = 0)
bool WaitForRead(long seconds = -1, long milliseconds = 0)
bool WaitForWrite(long seconds = -1, long milliseconds = 0)
bool WaitForLost(long seconds = -1, long milliseconds = 0)
wxSocketFlags GetFlags() const
void SetFlags(wxSocketFlags flags)
void SetTimeout(long seconds)
bool GetOption(int level, int optname, void *optval, int *optlen)
bool SetOption(int level, int optname, const void *optval, int optlen)
wxUint32 GetLastIOSize() const
void *GetClientData() const
void SetClientData(void *data)
void SetEventHandler(wxEvtHandler& handler, int id = wxID_ANY)
void SetNotify(wxSocketEventFlags flags)
void Notify(bool notify)
static bool IsInitialized()
static bool Initialize()
static void Shutdown()
void OnRequest(wxSocketNotify notify)
bool IsNoWait() const
wxSocketType GetType() const
%{
    void wxSocketBase_GetLocal()
    {
        wxSockAddress *returns;
        ((wxSocketBase *)wTheCall->self->ptr)->GetLocal(*returns);
        wWrapDerefArgs();
        wWrapPushObject( _wxSocketBase, W_TRUE, (void *)returns );
    }
%}

%method GetLocal wxSocketBase_GetLocal()
%{
    void wxSocketBase_GetPeer()
    {
        wxSockAddress *returns;
        ((wxSocketBase *)wTheCall->self->ptr)->GetPeer(*returns);
        wWrapDerefArgs();
        wWrapPushObject( _wxSocketBase, W_TRUE, (void *)returns );
    }
%}

%method GetPeer wxSocketBase_GetPeer()
%{
    // wxSocketBase Peek(void * buffer, wxUint32 nbytes)
    void wxSocketBase_Peek()
    {
        // get the number of bytes
        int nbytes = wStackPopInteger();

        // allocate a buffer of the requested size
        void *buffer = wMalloc( nbytes + 1 );

        // call Peek
        ((wxSocketBase *)(wTheCall->self->ptr))->Peek(buffer, nbytes);

        // clear the args
        wWrapDerefArgs();

        // wrap the buffer into a string
        wStackPushChar( (char *)(buffer), W_TRUE );

        // free the buffer
        wFree( buffer );
    }

    // wxSocketBase Read(void * buffer, wxUint32 nbytes)
    void wxSocketBase_Read()
    {
        // RP: handle extra byte to end string correctly
        wxUint32 inBytes = 0;

        // get the number of bytes
        int nbytes = wStackPopInteger();

        // allocate a buffer of the requested size
        char *buffer = (char*) wMalloc( nbytes + 1 );

        // call Read
        ((wxSocketBase *)(wTheCall->self->ptr))->Read(buffer, nbytes);
        inBytes = ((wxSocketBase *)(wTheCall->self->ptr))->LastCount();
        buffer[inBytes] = 0;

        // clear the args
        wWrapDerefArgs();

        // wrap the buffer into a string
        wStackPushChar( (char *)(buffer), W_TRUE );

        // free the buffer
        wFree( buffer );
    }


    // wxSocketBase ReadMsg(void * buffer, wxUint32 nbytes)
    void wxSocketBase_ReadMsg()
    {
        // get the number of bytes
        int nbytes = wStackPopInteger();

        // allocate a buffer of the requested size
        void *buffer = wMalloc( nbytes + 1 );

        // call ReadMsg
        ((wxSocketBase *)(wTheCall->self->ptr))->ReadMsg(buffer, nbytes);

        // clear the args
        wWrapDerefArgs();

        // wrap the buffer into a string
        wStackPushChar( (char *)(buffer), W_TRUE );

        // free the buffer
        wFree( buffer );
    }

%}

%method Peek      wxSocketBase_Peek( int nbytes )
%method Read      wxSocketBase_Read( int nbytes )
%method ReadMsg   wxSocketBase_ReadMsg( int nbytes )
%{
    // void Write(void * buffer, wxUint32 nbytes)
    void wxSocketBase_Write()
    {
        // get the string
        wVariant *theString = wStackPopString();
        int nbytes = wStringCount( theString );
        void *buffer = (void *)wStringChar( theString );

        // call Write
        ((wxSocketBase *)(wTheCall->self->ptr))->Write(buffer, nbytes);

        // clear the args
        wWrapDerefArgs();
    }

    // void WriteMsg(void * buffer, wxUint32 nbytes)
    void wxSocketBase_WriteMsg()
    {
        // get the string
        wVariant *theString = wStackPopString();
        int nbytes = wStringCount( theString );
        void *buffer = (void *)wStringChar( theString );

        // call Write
        ((wxSocketBase *)(wTheCall->self->ptr))->WriteMsg(buffer, nbytes);

        // clear the args
        wWrapDerefArgs();
    }
%}

%method Write       wxSocketBase_Write( wxString *buffer )
%method WriteMsg    wxSocketBase_WriteMsg( wxString *buffer )

// ==============================
// Class: wxSocketServer

%class %delete wxSocketServer, wxSocketBase
wxSocketServer(const wxSockAddress& addr, wxSocketFlags flags = wxSOCKET_NONE)
wxSocketBase* Accept(bool wait = true)
bool AcceptWith(wxSocketBase& socket, bool wait = true)
bool WaitForAccept(long seconds = -1, long milliseconds = 0)

// ==============================
// Class: wxSocketClient

%class %delete wxSocketClient, wxSocketBase
wxSocketClient(wxSocketFlags flags = wxSOCKET_NONE)
virtual bool Connect(wxSockAddress& addr, bool wait = true)
//RP: rename?
//bool Connect(wxSockAddress& addr, wxSockAddress& local, bool wait = true)
bool WaitOnConnect(long seconds = -1, long milliseconds = 0)

// ==============================
// Class: wxDatagramSocket

%class wxDatagramSocket, wxSocketBase
wxDatagramSocket(const wxSockAddress& addr, wxSocketFlags flags = wxSOCKET_NONE)
wxDatagramSocket& RecvFrom( wxSockAddress& addr, void* buf, wxUint32 nBytes )
wxDatagramSocket& SendTo( const wxSockAddress& addr, const void* buf, wxUint32 nBytes )

// ==============================
// Class: wxSocketEvent

%class %delete wxSocketEvent, wxEvent

%event wxEVT_SOCKET

wxSocketEvent(int id = 0)
wxSocketNotify  GetSocketEvent() const
wxSocketBase   *GetSocket() const
void           *GetClientData() const
%not(bcc) virtual wxEvent *Clone() const
wxSocketNotify  m_event
void           *m_clientData

// #########################################################
// sckstrm.h

%include <wx/sckstrm.h>

// ==============================
// Class: wxSocketOutputStream

%class wxSocketOutputStream, wxOutputStream
wxSocketOutputStream(wxSocketBase& s)
wxFileOffset SeekO( wxFileOffset pos, wxSeekMode mode )
wxFileOffset TellO() const

// ==============================
// Class: wxSocketInputStream

%class wxSocketInputStream, wxInputStream
wxSocketInputStream(wxSocketBase& s)
wxFileOffset SeekI( wxFileOffset pos, wxSeekMode mode )
wxFileOffset TellI() const

// ==============================
// Class: wxSocketStream

%class wxSocketStream, wxSocketInputStream
wxSocketStream(wxSocketBase& s)

///////////////////////////////////////////////////////////////////////////////
// wxProtocol

%include "wx/protocol/protocol.h"
%class %delete wxProtocol, wxSocketClient
%enum wxProtocolError

bool Reconnect()
wxInputStream *GetInputStream(const wxString& path)
bool Abort()
wxString GetContentType()
void  SetUser(const wxString& user)
void SetPassword(const wxString& user)
wxProtocolError GetError()

// error codes
%num wxPROTO_NOERR
%num wxPROTO_NETERR
%num wxPROTO_PROTERR
%num wxPROTO_CONNERR
%num wxPROTO_INVVAL
%num wxPROTO_NOHNDLR
%num wxPROTO_NOFILE
%num wxPROTO_ABRT
%num wxPROTO_RCNCT
// %num wxPROTO_STREAM

///////////////////////////////////////////////////////////////////////////////
// wxFTP

%include "wx/protocol/ftp.h"

%class %delete wxFTP, wxProtocol

%enum TransferMode

wxFTP()
bool Abort()
bool CheckCommand(const wxString& command, char ret)
bool Connect(const wxString& host)
char SendCommand(const wxString& command)
const wxString& GetLastResult()
bool ChDir(const wxString& dir)
bool MkDir(const wxString& dir)
bool RmDir(const wxString& dir)
wxString Pwd()
bool Rename(const wxString& src, const wxString& dst)
bool RmFile(const wxString& path)
bool SetAscii()
bool SetBinary()
bool SetTransferMode(wxFTP::TransferMode mode)
void SetUser(const wxString& user)
void SetPassword(const wxString& passwd)
bool FileExists(const wxString& filename)
int GetFileSize(const wxString& filename)
// TODO: wrappers
// bool GetDirList(wxArrayString& files, const wxString& wildcard = wxT(""))
// bool GetFilesList(wxArrayString& files, const wxString& wildcard = wxT(""))
wxOutputStream * GetOutputStream(const wxString& file)
wxInputStream * GetInputStream(const wxString& path)
void SetPassive(bool pasv)

// transfer modes
//%num wxFTP_NONE wxFTP::NONE
//%num wxFTP_ASCII wxFTP::ASCII
//%num wxFTP_BINARY wxFTP::BINARY

///////////////////////////////////////////////////////////////////////////////
// wxHTTP

%class %delete wxHTTP, wxProtocol
%include "wx/protocol/protocol.h"

wxHTTP()
// unsigned short port
virtual bool Connect(const wxString& host, int port = 0)
%rename ConnectAddr virtual bool Connect(wxSockAddress& addr, bool wait = true)

bool Abort()
wxProtocolError GetError()
int GetResponse() const
wxInputStream * GetInputStream(const wxString& path)
void SetHeader(const wxString& header, const wxString& h_data)
wxString GetHeader(const wxString& header)
wxString GetContentType()

void SetProxyMode(bool on)

void SetUser(const wxString& user)
void SetPassword(const wxString& passwd)

///////////////////////////////////////////////////////////////////////////////
// wxUrl

// #########################################################
// url.h

%include <wx/url.h>

%enum wxURLError
  %num wxURL_NOERR
  %num wxURL_SNTXERR
  %num wxURL_NOPROTO
  %num wxURL_NOHOST
  %num wxURL_NOPATH
  %num wxURL_CONNERR
  %num wxURL_PROTOERR

// ==============================
// Class: wxURLNativeImp

//%class wxURLNativeImp, wxObject
//virtual wxInputStream *GetInputStream(wxURL *owner)

// #########################################################
// uri.h

%include <wx/uri.h>

%enum wxURIHostType
  %num wxURI_REGNAME
  %num wxURI_IPV4ADDRESS
  %num wxURI_IPV6ADDRESS
  %num wxURI_IPVFUTURE

%enum wxURIFieldType
  %num wxURI_SCHEME
  %num wxURI_USERINFO
  %num wxURI_SERVER
  %num wxURI_PORT
  %num wxURI_PATH
  %num wxURI_QUERY
  %num wxURI_FRAGMENT

%enum wxURIFlags
  %num wxURI_STRICT

// ==============================
// Class: wxURI

%class %delete wxURI, wxObject
//wxURI()
wxURI(const wxString& uri)
%ctor wxURICopy(const wxURI& uri)
//const wxChar* Create(const wxString& uri)
const wxString Create(const wxString& uri)
bool HasScheme() const
bool HasUserInfo() const
bool HasServer() const
bool HasPort() const
bool HasPath() const
bool HasQuery() const
bool HasFragment() const
const wxString& GetScheme() const
const wxString& GetPath() const
const wxString& GetQuery() const
const wxString& GetFragment() const
const wxString& GetPort() const
const wxString& GetUserInfo() const
const wxString& GetServer() const
const wxURIHostType& GetHostType() const
wxString GetUser() const
wxString GetPassword() const
wxString BuildURI() const
wxString BuildUnescapedURI() const
void Resolve(const wxURI& base, int flags = wxURI_STRICT)
bool IsReference() const
// documented, but...
//bool HasUser() const
wxString  Unescape(const wxString& uri)

// ==============================
// Class: wxURL

%class %delete wxURL, wxURI
wxURL(const wxString& sUrl = wxEmptyString)
//wxURL(const wxURI& url)
wxProtocol& GetProtocol()
wxURLError GetError() const
wxString GetURL() const
wxURLError SetURL(const wxString &url)
bool IsOk() const
wxInputStream *GetInputStream()
static void SetDefaultProxy(const wxString& url_proxy)
void SetProxy(const wxString& url_proxy)

%builtin %rename wxURL_SetDefaultProxy void wxURL::SetDefaultProxy(const wxString& url_proxy)

///////////////////////////////////////////////////////////////////////////////
// Special OLE / Automation Support
///////////////////////////////////////////////////////////////////////////////

// #########################################################
// access.h

//%include <wx/msw/ole/access.h>

//%include <wx/access.h>
// ==============================
// Class: wxAccessible

//RP: works just with wxUSE_ACCESSIBILITY!!! FIXME
//%class wxAccessible, wxAccessibleBase
//wxAccessible(wxWindow *win = NULL)
//wxIAccessible* GetIAccessible()
//void* GetIAccessibleStd()
//static void NotifyEvent(int eventType, wxWindow* window, wxAccObject objectType, int objectId)

// #########################################################
// activex.h

// ==============================
// Class: wxActiveXContainer

%if(win) %class wxActiveXContainer, wxWindow

%include <wx/msw/ole/activex.h>
%typedef REFIID const IID &

//wxActiveXContainer(wxWindow * parent, REFIID iid, IUnknown* pUnk)
//void OnSize(wxSizeEvent&)
//void OnPaint(wxPaintEvent&)
//void OnSetFocus(wxFocusEvent&)
//void OnKillFocus(wxFocusEvent&)

// ==============================
// Class: wxActiveXEvent

%if(win) %class wxActiveXEvent, wxCommandEvent
%typedef DISPID long
%not(bcc) virtual wxEvent *Clone() const
size_t ParamCount() const
wxString ParamType(size_t idx) const
wxString ParamName(size_t idx) const
//wxVariant& operator[] (size_t idx)
DISPID GetDispatchId() const

%if(win) %num wxACTIVEX_ID

//RP: works just with wxUSE_ACCESSIBILITY!!! FIXME
//%event wxEVT_ACTIVEX

// #########################################################
// registry.h

// ==============================
// Class: wxRegKey

%if(win) %class wxRegKey
%include <wx/msw/registry.h>

%typedef StdKey wxRegKey::StdKey

wxRegKey(const wxString& strKey)
%ctor wxRegKeyEmpty()
%ctor wxRegKeyFromStdKey(StdKey keyParent, const wxString& strKey)
%ctor wxRegKeyFromParent(const wxRegKey& keyParent, const wxString& strKey)
void  SetName(const wxString& strKey)
%rename SetNameStdKey void  SetName(StdKey keyParent, const wxString& strKey)
%rename SetNameRegKey void  SetName(const wxRegKey& keyParent, const wxString& strKey)
//void  SetHkey(WXHKEY hKey)
wxString GetName(bool bShortPrefix = true) const
bool  Exists() const
// TODO: Wrapper
bool  GetKeyInfo(size_t *pnSubKeys, size_t *pnMaxKeyLen, size_t *pnValues, size_t *pnMaxValueLen)
bool  IsOpened() const
//bool  Open(AccessMode mode = Write)
bool  Create(bool bOkIfExists = true)
bool  RenameValue(const wxChar *szValueOld, const wxChar *szValueNew)
bool  Rename(const wxChar *szNewName)
bool  CopyValue(const wxChar *szValue, wxRegKey& keyDst, const wxChar *szNewName = NULL)
bool  Copy(const wxChar *szNewName)
%rename CopyRegkey bool  Copy(wxRegKey& keyDst)
bool  Close()
bool  DeleteSelf()
bool  DeleteKey(const wxChar *szKey)
bool  DeleteValue(const wxChar *szValue)
//ValueType GetValueType(const wxChar *szValue) const
bool IsNumericValue(const wxChar *szValue) const
wxString QueryDefaultValue() const
bool  SetValue(const wxChar *szValue, const wxString& strValue)
//TODO: Wrapper
bool  QueryValue(const wxChar *szValue, wxString& strValue) const
%rename QueryValueRaw bool  QueryValue(const wxChar *szValue, wxString& strValue, bool raw) const
%rename QueryValueLong bool  QueryValue(const wxChar *szValue, long *plValue) const
//bool  QueryRawValue(const wxChar *szValue, wxString& strValue) const
%rename SetValueLong bool  SetValue(const wxChar *szValue, long lValue)
//bool  SetValue(const wxChar *szValue, const wxMemoryBuffer& buf)
//bool  QueryValue(const wxChar *szValue, wxMemoryBuffer& buf) const
bool HasValue(const wxChar *szKey) const
bool HasSubKey(const wxChar *szKey) const
bool HasSubkeys() const
bool HasValues() const
bool IsEmpty() const
//TODO: Wrapper
bool  GetFirstValue(wxString& strValueName, long& lIndex)
bool  GetNextValue (wxString& strValueName, long& lIndex) const
bool  GetFirstKey  (wxString& strKeyName  , long& lIndex)
bool  GetNextKey   (wxString& strKeyName  , long& lIndex) const
bool Export(const wxString& filename) const
//bool Export(wxOutputStream& ostr) const
//void ReserveMemoryForName(size_t bytes)

//%not(gcc) %num %rename wxRegKey_ValueType_Type_None wxRegKey::ValueType::Type_None
//%not(gcc) %num %rename wxRegKey_ValueType_Type_String wxRegKey::ValueType::Type_String
//%not(gcc) %num %rename wxRegKey_ValueType_Type_Expand_String wxRegKey::ValueType::Type_Expand_String
//%not(gcc) %num %rename wxRegKey_ValueType_Type_Binary wxRegKey::ValueType::Type_Binary
//%not(gcc) %num %rename wxRegKey_ValueType_Type_Dword wxRegKey::ValueType::Type_Dword
//%not(gcc) %num %rename wxRegKey_ValueType_Type_Dword_little_endian wxRegKey::ValueType::Type_Dword_little_endian
//%not(gcc) %num %rename wxRegKey_ValueType_Type_Dword_big_endian wxRegKey::ValueType::Type_Dword_big_endian
//%not(gcc) %num %rename wxRegKey_ValueType_Type_Link wxRegKey::ValueType::Type_Link
//%not(gcc) %num %rename wxRegKey_ValueType_Type_Multi_String wxRegKey::ValueType::Type_Multi_String
//%not(gcc) %num %rename wxRegKey_ValueType_Type_Resource_list wxRegKey::ValueType::Type_Resource_list
//%not(gcc) %num %rename wxRegKey_ValueType_Type_Full_resource_descriptor wxRegKey::ValueType::Type_Full_resource_descriptor
//%not(gcc) %num %rename wxRegKey_ValueType_Type_Resource_requirements_list wxRegKey::ValueType::Type_Resource_requirements_list

//%not(gcc) %num %rename wxRegKey_StdKey_HKCR wxRegKey::StdKey::HKCR
//%not(gcc) %num %rename wxRegKey_StdKey_HKCU wxRegKey::StdKey::HKCU
//%not(gcc) %num %rename wxRegKey_StdKey_HKLM wxRegKey::StdKey::HKLM
//%not(gcc) %num %rename wxRegKey_StdKey_HKUSR wxRegKey::StdKey::HKUSR
//%not(gcc) %num %rename wxRegKey_StdKey_HKPD wxRegKey::StdKey::HKPD
//%not(gcc) %num %rename wxRegKey_StdKey_HKCC wxRegKey::StdKey::HKCC
//%not(gcc) %num %rename wxRegKey_StdKey_HKDD wxRegKey::StdKey::HKDD
//%not(gcc) %num %rename wxRegKey_StdKey_HKMAX wxRegKey::StdKey::HKMAX

//%not(gcc) %num %rename wxRegKey_AccessMode_Read wxRegKey::AccessMode::Read
//%not(gcc) %num %rename wxRegKey_AccessMode_Write wxRegKey::AccessMode::Write

%num %rename wxRegKey_ValueType_Type_None 0
%num %rename wxRegKey_ValueType_Type_String 1
%num %rename wxRegKey_ValueType_Type_Expand_String 2
%num %rename wxRegKey_ValueType_Type_Binary 3
%num %rename wxRegKey_ValueType_Type_Dword 4
%num %rename wxRegKey_ValueType_Type_Dword_little_endian 5
%num %rename wxRegKey_ValueType_Type_Dword_big_endian 6
%num %rename wxRegKey_ValueType_Type_Link 7
%num %rename wxRegKey_ValueType_Type_Multi_String 8
%num %rename wxRegKey_ValueType_Type_Resource_list 9
%num %rename wxRegKey_ValueType_Type_Full_resource_descriptor 10
%num %rename wxRegKey_ValueType_Type_Resource_requirements_list 11

%num %rename wxRegKey_StdKey_HKCR 0
%num %rename wxRegKey_StdKey_HKCU 1
%num %rename wxRegKey_StdKey_HKLM 2
%num %rename wxRegKey_StdKey_HKUSR 3
%num %rename wxRegKey_StdKey_HKPD 4
%num %rename wxRegKey_StdKey_HKCC 5
%num %rename wxRegKey_StdKey_HKDD 6
%num %rename wxRegKey_StdKey_HKMAX 7

%num %rename wxRegKey_AccessMode_Read 0
%num %rename wxRegKey_AccessMode_Write 1

// #########################################################
// automtn.h

// ==============================
// Class: wxAutomationObject

%if(win) %class wxAutomationObject, wxObject
%include <wx/msw/ole/automtn.h>
%typedef WXIDISPATCH*  long
%typedef WXBSTR unsigned short*

//wxAutomationObject(WXIDISPATCH* dispatchPtr = NULL)
%{
/* wxAutomationObject(WXIDISPATCH* dispatchPtr = NULL)
void wxAutomationObject_long()
{
	WXIDISPATCH *dispatchPtr = (wTheCall->parmCount > 0 ? (WXIDISPATCH *) wStackPopInteger() : NULL);
	wxAutomationObject *returns = new wxAutomationObject(dispatchPtr);
	wWrapDerefArgs();
	wWrapSetThis( _wxAutomationObject, (void *)returns );
}
*/

void wxAutomationObject_variant()
{
	wxVariant *v = (wTheCall->parmCount > 0 ? (wxVariant *) wStackPopObjectPtr( _wxVariant) : NULL);
	WXIDISPATCH *dispatchPtr = NULL;
	if(v)
	{
		wxChar numString[16];
		wxChar* stopstring;
		wxStrcpy(numString, v->GetString().c_str());
		dispatchPtr = (WXIDISPATCH*) wxStrtol(numString, &stopstring, 16);
	}
	wxAutomationObject *returns = new wxAutomationObject(dispatchPtr);
	wWrapDerefArgs();
	wWrapSetThis( _wxAutomationObject, (void *)returns );
}

%}
//%method new wxAutomationObject_long(long dispatchPtr = NULL)
%method new wxAutomationObject_variant(const wxVariant& dispatchPtr = NULL)
//%ctor wxAutomationObjectLong(WXIDISPATCH* dispatchPtr)

%{
void DbgShowVariantData(const wxVariant& v)
{
	wxVariant lv(v);

	::wxLogDebug(wxT("name='%s', type='%s', string='%s'"),
		lv.GetName().c_str(), lv.GetType().c_str(), lv.MakeString().c_str());
}

int GetAutomationVariantParam(int parmCount, wxVariant va[])
{
	int vaCount = 0;
	int i = parmCount - 2;
	for(;i >= 0; i--)
	{
		wVariant* v = wStackPop();

		if(v->dataType == W_TYPE_NUMBER)
		{
			/* boolean is represented by float */
			if(v->value.number == 0.0)
				va[i] = (bool) false;
			else if(v->value.number == 1.0)
				va[i] = (bool) true;
			else
				va[i] = (float) v->value.number;
		}
		else if(v->dataType == W_TYPE_INTEGER)
			va[i] = (long) v->value.integer;
		else if(v->dataType == W_TYPE_STRING)
			va[i] = wxString(wStringChar(v), *wxConvCurrent);
		else if(v->dataType == W_TYPE_DATETIME)
			va[i] = wxDateTime((time_t) v->value.time);
		else /* W_TYPE_NOTHING, W_TYPE_OBJECT, W_TYPE_ARRAY, W_TYPE_TABLE, W_TYPE_LIST, W_TYPE_VARPTR, W_TYPE_ROUTINE */
			va[i].Clear();
		vaCount++;
	}
	return vaCount;
}
%}
void SetDispatchPtr(WXIDISPATCH* dispatchPtr)
WXIDISPATCH* GetDispatchPtr() const
bool GetInstance(const wxString& classId) const
bool CreateInstance(const wxString& classId) const
//bool Invoke(const wxString& member, int action, wxVariant& retValue, int noArgs, wxVariant args[], const wxVariant* ptrArgs[] = 0) const
//wxVariant CallMethod(const wxString& method, int noArgs, wxVariant args[])
//wxVariant CallMethodArray(const wxString& method, int noArgs, const wxVariant **args)
//wxVariant CallMethod(const wxString& method, const wxVariant& arg1 = wxNullVariant, const wxVariant& arg2 = wxNullVariant, const wxVariant& arg3 = wxNullVariant, const wxVariant& arg4 = wxNullVariant, const wxVariant& arg5 = wxNullVariant, const wxVariant& arg6 = wxNullVariant)
%{
void wxAutomationObject_CallMethod()
{
	wxVariant va[10];
	int vaCount = GetAutomationVariantParam(wTheCall->parmCount, va);
	//wxVariant v;

	wxString method = wxString(wStackPopChar(), *wxConvCurrent);
	::wxLogDebug(wxT("method=%s"), method.c_str());
	for(int i = 0; i < vaCount; i++)
		DbgShowVariantData(va[i]);
	// make a pointer via copy constructor
	wxVariant *returns = new wxVariant(((wxAutomationObject *)(wTheCall->self->ptr))->CallMethod(method, (int) vaCount, va));
	DbgShowVariantData(*returns);
	wWrapDerefArgs();
	wWrapPushObject( _wxVariant, W_TRUE, (void *)returns );
}

%}
%method CallMethod wxAutomationObject_CallMethod(const wxString& method, const wxVariant& arg1 = wxNullVariant, const wxVariant& arg2 = wxNullVariant, const wxVariant& arg3 = wxNullVariant, const wxVariant& arg4 = wxNullVariant, const wxVariant& arg5 = wxNullVariant, const wxVariant& arg6 = wxNullVariant, const wxVariant& arg7 = wxNullVariant, const wxVariant& arg8 = wxNullVariant, const wxVariant& arg9 = wxNullVariant, const wxVariant& arg10 = wxNullVariant)

//wxVariant GetProperty(const wxString& property, int noArgs = 0, wxVariant args[] = (wxVariant*) NULL) const
//wxVariant GetPropertyArray(const wxString& property, int noArgs, const wxVariant **args) const
//wxVariant GetProperty(const wxString& property, const wxVariant& arg1, const wxVariant& arg2 = wxNullVariant, const wxVariant& arg3 = wxNullVariant, const wxVariant& arg4 = wxNullVariant, const wxVariant& arg5 = wxNullVariant, const wxVariant& arg6 = wxNullVariant)
%{
void wxAutomationObject_GetProperty()
{
	wxVariant va[6];
	const wxVariant* pva = va;
	int vaCount = GetAutomationVariantParam(wTheCall->parmCount, va);
	wxVariant v;

	wxString property = wxString(wStackPopChar(), *wxConvCurrent);
	::wxLogDebug(wxT("property=%s"), property.c_str());
	for(int i = 0; i < vaCount; i++)
		DbgShowVariantData(va[i]);
    // make a pointer via copy constructor
	if(vaCount == 0)
		v = ((wxAutomationObject *)(wTheCall->self->ptr))->GetProperty(property);
	else
	{
#if wxCHECK_VERSION(2,8,0)
	v = ((wxAutomationObject *)(wTheCall->self->ptr))->GetPropertyArray(property, (int) vaCount, &pva);
#else
	v = ((wxAutomationObject *)(wTheCall->self->ptr))->GetProperty(property, vaCount, va);
#endif
	}
	DbgShowVariantData(v);
	wxVariant *returns = new wxVariant(v);
	wWrapDerefArgs();
	wWrapPushObject( _wxVariant, W_TRUE, (void *)returns );
}

%}
%method GetProperty wxAutomationObject_GetProperty(const wxString& property, const wxVariant& arg1 = wxNullVariant, const wxVariant& arg2 = wxNullVariant, const wxVariant& arg3 = wxNullVariant, const wxVariant& arg4 = wxNullVariant, const wxVariant& arg5 = wxNullVariant, const wxVariant& arg6 = wxNullVariant)

//bool PutPropertyArray(const wxString& property, int noArgs, const wxVariant **args)
//bool PutProperty(const wxString& property, int noArgs, wxVariant args[])
//bool PutProperty(const wxString& property, const wxVariant& arg1, const wxVariant& arg2 = wxNullVariant, const wxVariant& arg3 = wxNullVariant, const wxVariant& arg4 = wxNullVariant, const wxVariant& arg5 = wxNullVariant, const wxVariant& arg6 = wxNullVariant)
%{
void wxAutomationObject_PutProperty()
{
	wxVariant va[6];
	int vaCount = GetAutomationVariantParam(wTheCall->parmCount, va);

	wxString property = wxString(wStackPopChar(), *wxConvCurrent);
	::wxLogDebug(wxT("property=%s"), property.c_str());
	for(int i = 0; i < vaCount; i++)
		DbgShowVariantData(va[i]);

    bool returns = ((wxAutomationObject *)(wTheCall->self->ptr))->PutProperty(property, (int) vaCount, va);
	::wxLogDebug(wxT("result: bool=%d"), (int) returns);
	wWrapDerefArgs();
	wStackPushNumber((wNumber)returns);
}

//bool GetObject(wxAutomationObject& obj, const wxString& property, int noArgs = 0, wxVariant args[] = NULL) const
void wxAutomationObject_GetObject()
{
	wxVariant va[6];
	int vaCount = GetAutomationVariantParam(wTheCall->parmCount, va);

	wxString property = wxString(wStackPopChar(), *wxConvCurrent);
	::wxLogDebug(wxT("property=%s"), property.c_str());
	for(int i = 0; i < vaCount; i++)
		DbgShowVariantData(va[i]);

    wxAutomationObject* returns = NULL;
	((wxAutomationObject *)(wTheCall->self->ptr))->GetObject(*returns, property, (int) vaCount, va);
	wWrapDerefArgs();
	wWrapPushObject( _wxAutomationObject, W_TRUE, (wxAutomationObject *)returns );
}

%}
%method PutProperty wxAutomationObject_PutProperty(const wxString& property, const wxVariant& arg1, const wxVariant& arg2 = wxNullVariant, const wxVariant& arg3 = wxNullVariant, const wxVariant& arg4 = wxNullVariant, const wxVariant& arg5 = wxNullVariant, const wxVariant& arg6 = wxNullVariant)
%method GetObject wxAutomationObject_GetObject(const wxString& property, const wxVariant& arg1 = wxNullVariant, const wxVariant& arg2 = wxNullVariant, const wxVariant& arg3 = wxNullVariant, const wxVariant& arg4 = wxNullVariant, const wxVariant& arg5 = wxNullVariant, const wxVariant& arg6 = wxNullVariant)
//WXIDISPATCH* GetDispatchProperty(const wxString& property, int noArgs, wxVariant args[]) const
//WXIDISPATCH* GetDispatchProperty(const wxString& property, int noArgs, const wxVariant **args) const
//bool GetObject(wxAutomationObject& obj, const wxString& property, int noArgs = 0, wxVariant args[] = NULL) const
//bool GetObject(wxAutomationObject& obj, const wxString& property, int noArgs, const wxVariant **args) const
//WXIDISPATCH*  m_dispatchPtr

///////////////////////////////////////////////////////////////////////////////
// DATABASE SUPPORT
///////////////////////////////////////////////////////////////////////////////

// #########################################################
// db.h

%class wxDbConnectInf
%include <wx/db.h>
//%include <sqltypes.h>
//%include <wx/isqlext.h>

%typedef SQLTCHAR char
%alias BOOL int
%num SQL_C_WXCHAR
%typedef SFLOAT float
%typedef SDOUBLE double
%typedef UINT unsigned int
%typedef SQLINTEGER int
%num wxODBC_FWD_ONLY_CURSORS

%num SQL_C_BLOB
%num wxDB_PATH_MAX
%ptr SQL_LOG_FILENAME
%ptr SQL_CATALOG_FILENAME
%num DB_TYPE_NAME_LEN
%num DB_MAX_STATEMENT_LEN
%num DB_MAX_WHERE_CLAUSE_LEN
%num DB_MAX_ERROR_MSG_LEN
%num DB_MAX_ERROR_HISTORY
%num DB_MAX_TABLE_NAME_LEN
%num DB_MAX_COLUMN_NAME_LEN
%num DB_DATA_TYPE_VARCHAR
%num DB_DATA_TYPE_INTEGER
%num DB_DATA_TYPE_FLOAT
%num DB_DATA_TYPE_DATE
%num DB_DATA_TYPE_BLOB
%num DB_DATA_TYPE_MEMO
%num DB_SELECT_KEYFIELDS
%num DB_SELECT_WHERE
%num DB_SELECT_MATCHING
%num DB_SELECT_STATEMENT
%num DB_UPD_KEYFIELDS
%num DB_UPD_WHERE
%num DB_DEL_KEYFIELDS
%num DB_DEL_WHERE
%num DB_DEL_MATCHING
%num DB_WHERE_KEYFIELDS
%num DB_WHERE_MATCHING
%num DB_GRANT_SELECT
%num DB_GRANT_INSERT
%num DB_GRANT_UPDATE
%num DB_GRANT_DELETE
%num DB_GRANT_ALL

%enum wxODBC_ERRORS
  %num DB_FAILURE
  %num DB_SUCCESS
  %num DB_ERR_NOT_IN_USE
  %num DB_ERR_GENERAL_WARNING
  %num DB_ERR_DISCONNECT_ERROR
  %num DB_ERR_DATA_TRUNCATED
  %num DB_ERR_PRIV_NOT_REVOKED
  %num DB_ERR_INVALID_CONN_STR_ATTR
  %num DB_ERR_ERROR_IN_ROW
  %num DB_ERR_OPTION_VALUE_CHANGED
  %num DB_ERR_NO_ROWS_UPD_OR_DEL
  %num DB_ERR_MULTI_ROWS_UPD_OR_DEL
  %num DB_ERR_WRONG_NO_OF_PARAMS
  %num DB_ERR_DATA_TYPE_ATTR_VIOL
  %num DB_ERR_UNABLE_TO_CONNECT
  %num DB_ERR_CONNECTION_IN_USE
  %num DB_ERR_CONNECTION_NOT_OPEN
  %num DB_ERR_REJECTED_CONNECTION
  %num DB_ERR_CONN_FAIL_IN_TRANS
  %num DB_ERR_COMM_LINK_FAILURE
  %num DB_ERR_INSERT_VALUE_LIST_MISMATCH
  %num DB_ERR_DERIVED_TABLE_MISMATCH
  %num DB_ERR_STRING_RIGHT_TRUNC
  %num DB_ERR_NUMERIC_VALUE_OUT_OF_RNG
  %num DB_ERR_ERROR_IN_ASSIGNMENT
  %num DB_ERR_DATETIME_FLD_OVERFLOW
  %num DB_ERR_DIVIDE_BY_ZERO
  %num DB_ERR_STR_DATA_LENGTH_MISMATCH
  %num DB_ERR_INTEGRITY_CONSTRAINT_VIOL
  %num DB_ERR_INVALID_CURSOR_STATE
  %num DB_ERR_INVALID_TRANS_STATE
  %num DB_ERR_INVALID_AUTH_SPEC
  %num DB_ERR_INVALID_CURSOR_NAME
  %num DB_ERR_SYNTAX_ERROR_OR_ACCESS_VIOL
  %num DB_ERR_DUPLICATE_CURSOR_NAME
  %num DB_ERR_SERIALIZATION_FAILURE
  %num DB_ERR_SYNTAX_ERROR_OR_ACCESS_VIOL2
  %num DB_ERR_OPERATION_ABORTED
  %num DB_ERR_UNSUPPORTED_FUNCTION
  %num DB_ERR_NO_DATA_SOURCE
  %num DB_ERR_DRIVER_LOAD_ERROR
  %num DB_ERR_SQLALLOCENV_FAILED
  %num DB_ERR_SQLALLOCCONNECT_FAILED
  %num DB_ERR_SQLSETCONNECTOPTION_FAILED
  %num DB_ERR_NO_DATA_SOURCE_DLG_PROHIB
  %num DB_ERR_DIALOG_FAILED
  %num DB_ERR_UNABLE_TO_LOAD_TRANSLATION_DLL
  %num DB_ERR_DATA_SOURCE_NAME_TOO_LONG
  %num DB_ERR_DRIVER_NAME_TOO_LONG
  %num DB_ERR_DRIVER_KEYWORD_SYNTAX_ERROR
  %num DB_ERR_TRACE_FILE_ERROR
  %num DB_ERR_TABLE_OR_VIEW_ALREADY_EXISTS
  %num DB_ERR_TABLE_NOT_FOUND
  %num DB_ERR_INDEX_ALREADY_EXISTS
  %num DB_ERR_INDEX_NOT_FOUND
  %num DB_ERR_COLUMN_ALREADY_EXISTS
  %num DB_ERR_COLUMN_NOT_FOUND
  %num DB_ERR_NO_DEFAULT_FOR_COLUMN
  %num DB_ERR_GENERAL_ERROR
  %num DB_ERR_MEMORY_ALLOCATION_FAILURE
  %num DB_ERR_INVALID_COLUMN_NUMBER
  %num DB_ERR_PROGRAM_TYPE_OUT_OF_RANGE
  %num DB_ERR_SQL_DATA_TYPE_OUT_OF_RANGE
  %num DB_ERR_OPERATION_CANCELLED
  %num DB_ERR_INVALID_ARGUMENT_VALUE
  %num DB_ERR_FUNCTION_SEQUENCE_ERROR
  %num DB_ERR_OPERATION_INVALID_AT_THIS_TIME
  %num DB_ERR_INVALID_TRANS_OPERATION_CODE
  %num DB_ERR_NO_CURSOR_NAME_AVAIL
  %num DB_ERR_INVALID_STR_OR_BUF_LEN
  %num DB_ERR_DESCRIPTOR_TYPE_OUT_OF_RANGE
  %num DB_ERR_OPTION_TYPE_OUT_OF_RANGE
  %num DB_ERR_INVALID_PARAM_NO
  %num DB_ERR_INVALID_SCALE_VALUE
  %num DB_ERR_FUNCTION_TYPE_OUT_OF_RANGE
  %num DB_ERR_INF_TYPE_OUT_OF_RANGE
  %num DB_ERR_COLUMN_TYPE_OUT_OF_RANGE
  %num DB_ERR_SCOPE_TYPE_OUT_OF_RANGE
  %num DB_ERR_NULLABLE_TYPE_OUT_OF_RANGE
  %num DB_ERR_UNIQUENESS_OPTION_TYPE_OUT_OF_RANGE
  %num DB_ERR_ACCURACY_OPTION_TYPE_OUT_OF_RANGE
  %num DB_ERR_DIRECTION_OPTION_OUT_OF_RANGE
  %num DB_ERR_INVALID_PRECISION_VALUE
  %num DB_ERR_INVALID_PARAM_TYPE
  %num DB_ERR_FETCH_TYPE_OUT_OF_RANGE
  %num DB_ERR_ROW_VALUE_OUT_OF_RANGE
  %num DB_ERR_CONCURRENCY_OPTION_OUT_OF_RANGE
  %num DB_ERR_INVALID_CURSOR_POSITION
  %num DB_ERR_INVALID_DRIVER_COMPLETION
  %num DB_ERR_INVALID_BOOKMARK_VALUE
  %num DB_ERR_DRIVER_NOT_CAPABLE
  %num DB_ERR_TIMEOUT_EXPIRED

%num MAXNAME
%num SQL_MAX_AUTHSTR_LEN
%num SQL_MAX_CONNECTSTR_LEN

// ==============================
// Class: wxDbConnectInf

//%typedef HENV void*
%typedef HDBC void*
%typedef HSTMT void*

// class wxDbConnectInf
HENV Henv
wxChar Dsn[SQL_MAX_DSN_LENGTH+1]
wxChar Uid[SQL_MAX_USER_NAME_LEN+1]
wxChar AuthStr[SQL_MAX_AUTHSTR_LEN+1]
wxChar ConnectionStr[SQL_MAX_CONNECTSTR_LEN+1]
wxString Description
wxString FileType
wxString DefaultDir
wxDbConnectInf()
//wxDbConnectInf(HENV henv, const wxString &dsn, const wxString &userID=wxEmptyString, const wxString &password=wxEmptyString, const wxString &defaultDir=wxEmptyString, const wxString &description=wxEmptyString, const wxString &fileType=wxEmptyString)
bool             Initialize()
bool             AllocHenv()
void             FreeHenv()
//const HENV       &GetHenv()
%{
void wxDbConnectInf_GetHenv() {
    const void* returns = ((wxDbConnectInf *)(wTheCall->self->ptr))->GetHenv();
    wStackPushInteger( (wInteger) returns);
}
%}
%method GetHenv wxDbConnectInf_GetHenv()
const wxChar    *GetDsn()
const wxChar    *GetUid()
const wxChar    *GetUserID()
const wxChar    *GetAuthStr()
const wxChar    *GetPassword()
const wxChar    *GetConnectionStr()
bool             UseConnectionStr()
const wxChar    *GetDescription()
const wxChar    *GetFileType()
const wxChar    *GetDefaultDir()
//void             SetHenv(const HENV henv)
%{
void wxDbConnectInf_SetHenv() {
    void* henv = (void*) wStackPopInteger();
    ((wxDbConnectInf *)(wTheCall->self->ptr))->SetHenv(henv);
    wWrapDerefArgs();
}
%}
%method SetHenv wxDbConnectInf_SetHenv(const HENV henv)
void             SetDsn(const wxString &dsn)
void             SetUserID(const wxString &userID)
void             SetUid(const wxString &uid)
void             SetPassword(const wxString &password)
void             SetAuthStr(const wxString &authstr)
void             SetConnectionStr(const wxString &connectStr)
void             SetDescription(const wxString &desc)
void             SetFileType(const wxString &fileType)
void             SetDefaultDir(const wxString &defDir)

%struct wxDbSqlTypeInfo

// ==============================
// Class: wxDbColFor

%class wxDbColFor
wxString       s_Field
wxString       s_Format[7]
wxString       s_Amount[7]
int            i_Amount[7]
int            i_Nation
int            i_dbDataType
SWORD          i_sqlDataType
wxDbColFor()
void           Initialize()
int            Format(int Nation, int dbDataType, SWORD sqlDataType, short columnLength, short decimalDigits)

// ==============================
// Class: wxDbColInf

%class wxDbColInf
wxChar       catalog[128+1]
wxChar       schema[128+1]
wxChar       tableName[DB_MAX_TABLE_NAME_LEN+1]
wxChar       colName[DB_MAX_COLUMN_NAME_LEN+1]
SWORD        sqlDataType
wxChar       typeName[128+1]
SWORD        columnLength
SWORD        bufferSize
short        decimalDigits
short        numPrecRadix
short        nullable
wxChar       remarks[254+1]
int          dbDataType
int          PkCol
wxChar       PkTableName[DB_MAX_TABLE_NAME_LEN+1]
int          FkCol
wxChar       FkTableName[DB_MAX_TABLE_NAME_LEN+1]
wxDbColFor  *pColFor
wxDbColInf()
bool Initialize()

// ==============================
// Class: wxDbTableInf

%class wxDbTableInf
wxChar      tableName[DB_MAX_TABLE_NAME_LEN+1]
wxChar      tableType[254+1]
wxChar      tableRemarks[254+1]
UWORD       numCols
wxDbColInf *pColInf
wxDbTableInf()
bool             Initialize()

// ==============================
// Class: wxDbInf

%class wxDbInf
wxChar        catalog[128+1]
wxChar        schema[128+1]
int           numTables
wxDbTableInf *pTableInf
wxDbInf()
bool          Initialize()

%enum wxDbSqlLogState
  %num sqlLogOFF
  %num sqlLogON

%enum wxDBMS
  %num dbmsUNIDENTIFIED
  %num dbmsORACLE
  %num dbmsSYBASE_ASA
  %num dbmsSYBASE_ASE
  %num dbmsMS_SQL_SERVER
  %num dbmsMY_SQL
  %num dbmsPOSTGRES
  %num dbmsACCESS
  %num dbmsDBASE
  %num dbmsINFORMIX
  %num dbmsVIRTUOSO
  %num dbmsDB2
  %num dbmsINTERBASE
  %num dbmsPERVASIVE_SQL
  %num dbmsXBASE_SEQUITER
  %num dbmsFIREBIRD
  %num dbmsMAXDB
  %num dbmsFuture1
  %num dbmsFuture2
  %num dbmsFuture3
  %num dbmsFuture4
  %num dbmsFuture5
  %num dbmsFuture6
  %num dbmsFuture7
  %num dbmsFuture8
  %num dbmsFuture9
  %num dbmsFuture10

// ==============================
// Class: wxDb

%class wxDb
void             setCached(bool cached)
bool             IsCached()
bool             GetDataTypeInfo(SWORD fSqlType, wxDbSqlTypeInfo &structSQLTypeInfo)
HENV  henv
HDBC  hdbc
HSTMT hstmt
bool silent
unsigned int nTables
//%struct wxDb::dbInf
SWORD  cbErrorMsg
int    DB_STATUS
wxChar errorList[DB_MAX_ERROR_HISTORY][DB_MAX_ERROR_MSG_LEN+1]
//wxChar errorList[DB_MAX_ERROR_HISTORY][DB_MAX_ERROR_MSG_LEN]
wxChar errorMsg[SQL_MAX_MESSAGE_LENGTH]
SQLINTEGER nativeError
wxChar sqlState[20]
wxDbSqlTypeInfo typeInfVarchar
wxDbSqlTypeInfo typeInfInteger
wxDbSqlTypeInfo typeInfFloat
wxDbSqlTypeInfo typeInfDate
wxDbSqlTypeInfo typeInfBlob
%{
// wxDb(const HENV &aHenv, bool FwdOnlyCursors=wxODBC_FWD_ONLY_CURSORS)
void wxDb_new() {
    bool FwdOnlyCursors = (wTheCall->parmCount > 1 ? (bool)wStackPopInteger() : wxODBC_FWD_ONLY_CURSORS);
    const HENV aHenv = (const HENV) (long) wStackPopInteger();
    wxDb *returns = new wxDb(aHenv, FwdOnlyCursors);
    wWrapDerefArgs();
    wWrapSetThis( _wxDb, (void *)returns );
}
%}
%method new wxDb_new(const HENV &aHenv, bool FwdOnlyCursors=wxODBC_FWD_ONLY_CURSORS)
bool         Open(const wxString& inConnectStr, bool failOnDataTypeUnsupported=true)
//bool         Open(const wxString& inConnectStr, SQLHWND parentWnd, bool failOnDataTypeUnsupported=true)
//bool         Open(const wxString &Dsn, const wxString &Uid, const wxString &AuthStr, bool failOnDataTypeUnsupported=true)
%rename OpenDSN bool Open(const wxString &Dsn, const wxString &Uid, const wxString &AuthStr, bool failOnDataTypeUnsupported=true)
//bool         Open(wxDbConnectInf *dbConnectInf, bool failOnDataTypeUnsupported=true)
//bool         Open(wxDb *copyDb)
void         Close()
bool         CommitTrans()
bool         RollbackTrans()
//bool         DispAllErrors(HENV aHenv, HDBC aHdbc = SQL_NULL_HDBC, HSTMT aHstmt = SQL_NULL_HSTMT)
//bool         GetNextError(HENV aHenv, HDBC aHdbc = SQL_NULL_HDBC, HSTMT aHstmt = SQL_NULL_HSTMT)
%{
// bool         DispAllErrors(HENV aHenv, HDBC aHdbc = SQL_NULL_HDBC, HSTMT aHstmt = SQL_NULL_HSTMT)
void wxDb_DispAllErrors() {
    void* aHstmt = (wTheCall->parmCount > 2 ? (void*) wStackPopInteger() : SQL_NULL_HSTMT);
    void* aHdbc = (wTheCall->parmCount > 1 ? (void*) wStackPopInteger() : SQL_NULL_HDBC);
    void* aHenv = (void*) wStackPopInteger();
    bool returns = ((wxDb *)(wTheCall->self->ptr))->DispAllErrors(aHenv, aHdbc, aHstmt);
    wWrapDerefArgs();
    wStackPushInteger( (wInteger)returns);
}

// bool         GetNextError(HENV aHenv, HDBC aHdbc = SQL_NULL_HDBC, HSTMT aHstmt = SQL_NULL_HSTMT)
void wxDb_GetNextError() {
    void* aHstmt = (wTheCall->parmCount > 2 ? (void*) wStackPopInteger() : SQL_NULL_HSTMT);
    void* aHdbc = (wTheCall->parmCount > 1 ? (void*) wStackPopInteger() : SQL_NULL_HDBC);
    void* aHenv = (void*) wStackPopInteger();
    bool returns = ((wxDb *)(wTheCall->self->ptr))->GetNextError(aHenv, aHdbc, aHstmt);
    wWrapDerefArgs();
    wStackPushInteger( (wInteger)returns);
}
%}
%method DispAllErrors wxDb_DispAllErrors(HENV aHenv, HDBC aHdbc = SQL_NULL_HDBC, HSTMT aHstmt = SQL_NULL_HSTMT)
%method GetNextError wxDb_GetNextError(HENV aHenv, HDBC aHdbc = SQL_NULL_HDBC, HSTMT aHstmt = SQL_NULL_HSTMT)

void         DispNextError()
bool         CreateView(const wxString &viewName, const wxString &colList, const wxString &pSqlStmt, bool attemptDrop=true)
bool         DropView(const wxString &viewName)
bool         ExecSql(const wxString &pSqlStmt)
//bool         ExecSql(const wxString &pSqlStmt, wxDbColInf** columns, short& numcols)
%rename ExecSqlWithResult bool ExecSql(const wxString &pSqlStmt, wxDbColInf** columns, short& numcols)
bool         GetNext()
// bool         GetData(UWORD colNo, SWORD cType, PTR pData, SDWORD maxLen, SQLLEN FAR *cbReturned)
%{
void wxDb_GetData() {
    SQLLEN cbReturned;
    SDWORD maxLen = 4 * 1024;
	wxChar *pData = new wxChar(4 * 1024 + 1);
    UWORD colNo = (UWORD)wStackPopInteger();
    bool b = ((wxDb *)(wTheCall->self->ptr))->GetData(colNo, SQL_C_CHAR, pData, maxLen, &cbReturned);
	if(cbReturned == SQL_NULL_DATA || !b)
		pData[0] = 0;
    wWrapDerefArgs();
    wStackPushChar( (char *)(pData), W_TRUE );
    delete pData;
}
%}
%method GetData wxDb_GetData(UWORD colNo)

bool         Grant(int privileges, const wxString &tableName, const wxString &userList = wxT("PUBLIC"))
int          TranslateSqlState(const wxString &SQLState)
wxDbInf     *GetCatalog(const wxChar *userID=NULL)
bool         Catalog(const wxChar *userID=NULL, const wxString &fileName=SQL_CATALOG_FILENAME)
int          GetKeyFields(const wxString &tableName, wxDbColInf* colInf, UWORD noCols)
//wxDbColInf  *GetColumns(wxChar *tableName[], const wxChar *userID=NULL)
wxDbColInf  *GetColumns(const wxString &tableName, UWORD *numCols, const wxChar *userID=NULL)
int             GetColumnCount(const wxString &tableName, const wxChar *userID=NULL)
const wxChar   *GetDatabaseName()
//removed & from const wxString&
const wxString GetDataSource()
const wxString GetDatasourceName()
const wxString GetUsername()
const wxString GetPassword()
const wxString GetConnectionInStr()
const wxString GetConnectionOutStr()
bool            IsOpen()
bool            OpenedWithConnectionString()
//HENV            GetHENV()
//HDBC            GetHDBC()
//HSTMT           GetHSTMT()
%{
// HENV            GetHENV()
void wxDb_GetHENV() {
    void* returns = ((wxDb *)(wTheCall->self->ptr))->GetHENV();
    wStackPushInteger( (wInteger) returns);
}

// HDBC            GetHDBC()
void wxDb_GetHDBC() {
    void* returns = ((wxDb *)(wTheCall->self->ptr))->GetHDBC();
    wStackPushInteger( (wInteger) returns);
}

// HSTMT           GetHSTMT()
void wxDb_GetHSTMT() {
    void* returns = ((wxDb *)(wTheCall->self->ptr))->GetHSTMT();
    wStackPushInteger( (wInteger) returns);
}
%}
%method GetHENV wxDb_GetHENV()
%method GetHDBC wxDb_GetHDBC()
%method GetHSTMT wxDb_GetHSTMT()
int             GetTableCount()
wxDbSqlTypeInfo GetTypeInfVarchar()
wxDbSqlTypeInfo GetTypeInfInteger()
wxDbSqlTypeInfo GetTypeInfFloat()
wxDbSqlTypeInfo GetTypeInfDate()
wxDbSqlTypeInfo GetTypeInfBlob()
wxDbSqlTypeInfo GetTypeInfMemo()
bool         TableExists(const wxString &tableName, const wxChar *userID=NULL, const wxString &tablePath=wxEmptyString)
bool         TablePrivileges(const wxString &tableName, const wxString &priv, const wxChar *userID=NULL, const wxChar *schema=NULL, const wxString &path=wxEmptyString)
const wxString  SQLTableName(const wxChar *tableName)
const wxString  SQLColumnName(const wxChar *colName)
void         LogError(const wxString &errMsg, const wxString &SQLState = wxEmptyString)
void         SetDebugErrorMessages(bool state)
bool         SetSqlLogging(wxDbSqlLogState state, const wxString &filename = SQL_LOG_FILENAME, bool append = false)
bool         WriteSqlLog(const wxString &logMsg)
wxDBMS       Dbms()
bool         ModifyColumn(const wxString &tableName, const wxString &columnName, int dataType, ULONG columnLength=0, const wxString &optionalParam=wxEmptyString)
bool         FwdOnlyCursors()
wxString     EscapeSqlChars(const wxString& value)
//void         incrementTableCount()
//void         decrementTableCount()

%struct wxDbList

// #########################################################
// dbtable.h

%include <wx/dbtable.h>

%num wxDB_ROWID_LEN
%num wxDB_DEFAULT_CURSOR
%num wxDB_QUERY_ONLY
%num wxDB_DISABLE_VIEW
%num wxDB_NO_MORE_COLUMN_NUMBERS

// ==============================
// Class: wxDbColDef

%class wxDbColDef
wxChar  ColName[DB_MAX_COLUMN_NAME_LEN+1]
int     DbDataType
SWORD   SqlCtype
void   *PtrDataObj
int     SzDataObj
bool    KeyField
bool    Updateable
bool    InsertAllowed
bool    DerivedCol
SQLLEN  CbValue
bool    Null
wxDbColDef()
bool    Initialize()

// ==============================
// Class: wxDbColDataPtr

%class wxDbColDataPtr
void    *PtrDataObj
int      SzDataObj
SWORD    SqlCtype

// ==============================
// Class: wxDbIdxDef

%class wxDbIdxDef
wxChar  ColName[DB_MAX_COLUMN_NAME_LEN+1]
bool    Ascending

// ==============================
// Class: wxDbTable

%class wxDbTable
wxString    where
wxString    orderBy
wxString    from
HENV        henv
HDBC        hdbc
HSTMT       hstmt
HSTMT      *hstmtDefault
HSTMT       hstmtInsert
HSTMT       hstmtDelete
HSTMT       hstmtUpdate
HSTMT       hstmtInternal
HSTMT      *hstmtCount
bool        selectForUpdate
wxDb       *pDb
wxString    tablePath
wxString    tableName
wxString    queryTableName
UWORD       m_numCols
bool        queryOnly
wxDbColDef *colDefs
wxDbTable(wxDb *pwxDb, const wxString &tblName, const UWORD numColumns, const wxString &qryTblName=wxEmptyString, bool qryOnly = !wxDB_QUERY_ONLY, const wxString &tblPath=wxEmptyString)
bool            Open(bool checkPrivileges=false, bool checkTableExists=true)
bool            CreateTable(bool attemptDrop=true)
bool            DropTable()
bool            CreateIndex(const wxString &indexName, bool unique, UWORD numIndexColumns, wxDbIdxDef *pIndexDefs, bool attemptDrop=true)
bool            DropIndex(const wxString &indexName)
wxDb           *GetDb()
const wxString GetTableName()
const wxString GetQueryTableName()
const wxString GetTablePath()
UWORD           GetNumberOfColumns()
const wxString GetFromClause()
const wxString GetOrderByClause()
const wxString GetWhereClause()
bool            IsQueryOnly()
void            SetFromClause(const wxString &From)
void            SetOrderByClause(const wxString &OrderBy)
//bool            SetOrderByColNums(UWORD first, ...)
bool            SetOrderByColNums(UWORD first, UWORD col2, UWORD col3, UWORD col4, UWORD col5)
void            SetWhereClause(const wxString &Where)
//void            From(const wxString &From)
//void            OrderBy(const wxString &OrderBy)
//void            Where(const wxString &Where)
const wxString Where()
const wxString OrderBy()
const wxString From()
int             Insert()
bool            Update()
%rename UpdateSQL bool Update(const wxString &pSqlStmt)
bool            UpdateWhere(const wxString &pWhereClause)
bool            Delete()
bool            DeleteWhere(const wxString &pWhereClause)
bool            DeleteMatching()
virtual bool    Query(bool forUpdate = false, bool distinct = false)
bool            QueryBySqlStmt(const wxString &pSqlStmt)
bool            QueryMatching(bool forUpdate = false, bool distinct = false)
bool            QueryOnKeyFields(bool forUpdate = false, bool distinct = false)
bool            Refresh()
bool            GetNext()
bool            GetPrev()
bool            GetFirst()
bool            GetLast()
bool            IsCursorClosedOnCommit()
UWORD           GetRowNum()
//RP: TODO: need some wrappers
void            BuildSelectStmt(wxString &pSqlStmt, int typeOfSelect, bool distinct)
//void            BuildSelectStmt(wxChar *pSqlStmt, int typeOfSelect, bool distinct)
void            BuildDeleteStmt(wxString &pSqlStmt, int typeOfDel, const wxString &pWhereClause=wxEmptyString)
//void            BuildDeleteStmt(wxChar *pSqlStmt, int typeOfDel, const wxString &pWhereClause=wxEmptyString)
void            BuildUpdateStmt(wxString &pSqlStmt, int typeOfUpdate, const wxString &pWhereClause=wxEmptyString)
//void            BuildUpdateStmt(wxChar *pSqlStmt, int typeOfUpdate, const wxString &pWhereClause=wxEmptyString)
void            BuildWhereClause(wxString &pWhereClause, int typeOfWhere, const wxString &qualTableName=wxEmptyString, bool useLikeComparison=false)
//void            BuildWhereClause(wxChar *pWhereClause, int typeOfWhere, const wxString &qualTableName=wxEmptyString, bool useLikeComparison=false)
bool            CanSelectForUpdate()
bool            CanUpdateByROWID()
void            ClearMemberVar(UWORD colNumber, bool setToNull=false)
%rename ClearAllMemberVars void ClearMemberVars(bool setToNull=false)
bool            SetQueryTimeout(UDWORD nSeconds)
wxDbColDef     *GetColDefs()
bool            SetColDefs(UWORD index, const wxString &fieldName, int dataType, void *pData, SWORD cType, int size, bool keyField = false, bool updateable = true, bool insertAllowed = true, bool derivedColumn = false)
//wxDbColDataPtr *SetColDefs(wxDbColInf *colInfs, UWORD numCols)
//bool            CloseCursor(HSTMT cursor)
//bool            DeleteCursor(HSTMT *hstmtDel)
//void            SetCursor(HSTMT *hstmtActivate = (void **) wxDB_DEFAULT_CURSOR)
//HSTMT           GetCursor()
//HSTMT          *GetNewCursor(bool setCursor = false, bool bindColumns = true)
ULONG           Count(const wxString &args=wxT("*"))
int             DB_STATUS()
bool            IsColNull(UWORD colNumber) const
%rename SetNumColNull bool SetColNull(UWORD colNumber, bool set=true)
%rename SetColNullByPos bool SetColNull(UWORD colNumber, bool set=true)
bool            SetColNull(const wxString &colName, bool set=true)
// just in Debug Mode
//ULONG           GetTableID()
//virtual     void         SetRowMode(const rowmode_t rowmode)
// virtual     void         SetRowMode(const int rowmode)
%{
void wxDbTable_SetRowMode() {
    int rowmode = wStackPopInteger();
    ((wxDbTable *)(wTheCall->self->ptr))->SetRowMode((wxDbTable::rowmode_t) rowmode);
    wWrapDerefArgs();
}
%}
%method SetRowMode wxDbTable_SetRowMode(const int rowmode)
virtual     wxVariant    GetColumn(const int colNumber) const
virtual     void         SetColumn(const int colNumber, const wxVariant value)
//virtual     GenericKey   GetKey()
//virtual     void         SetKey(const GenericKey &key)

//%not(gcc) %num %rename WX_ROW_MODE_QUERY wxDbTable::rowmode_t::WX_ROW_MODE_QUERY
//%not(gcc) %num %rename WX_ROW_MODE_INDIVIDUAL wxDbTable::rowmode_t::WX_ROW_MODE_INDIVIDUAL
%num %rename WX_ROW_MODE_QUERY 0
%num %rename WX_ROW_MODE_INDIVIDUAL 1

// #########################################################
// dbEngine.h

%include <wx/dbEngine.h>

%num dbmsSQLite

%class wxDbODBC, wxDb
	wxDbODBC(const HENV& aHenv, bool ReadOnly = false)
	// Error Handling =======================================
	void ClearError()
	const wxString GetErrorString()
	//const int GetError(wxString* pstrError = NULL)
	//replace wxChar to wxString
	//const wxChar* GetExtendedDBErrorMsg(const wxChar *ErrFile, int ErrLine, bool AllMessages = true)
	wxString GetExtendedDBErrorMsg(const wxString& ErrFile, int ErrLine, bool AllMessages = true)
	// Methods ==============================================
	void Cancel()

	// Attributes ===========================================
	wxString msError
	int mnError

%class wxDbEngine
	// Constructors / Destructors ===========================
	wxDbEngine()

	// Methods ==============================================
	//replace const wxChar* to const wxString&
	%rename OpenDSN bool Open(const wxString& Dsn, const wxString& Uid, const wxString& AuthStr)
	bool Open(const wxString &sConnectionStr)
	void Close(bool bKeepHenv = false)
	bool IsOpen()
	wxString ExecSql(const wxString& sqlcmd)
	long AffectedRecords()
	const bool IsAutoCommit()
	const wxString BraceColumn(const wxString& ColName)

	void LogError(const wxString& ErrorMsg)
	void ErrAdd(const wxString &sError)
	void ErrClear()
	wxString GetError()
	bool GotError()

	void LogInfo(const wxString& InfoMsg)
	wxString GetInfo()
	bool GotInfo()
	void ClearInfo()

	wxDbODBC* GetODBC(bool GetQueryODBC = false)
	wxDbConnectInf* GetDBConnectInf()
	bool WriteSqlLog(const wxString &logMsg)

	// from ODBC
	wxDbInf* GetCatalog(const wxChar* userID=NULL)
    //wxDbColInf* GetColumns(wxChar *tableName[], const wxChar *userID=NULL)
    wxDbColInf* GetColumns(const wxString &tableName, UWORD *numCols, const wxChar *userID=NULL)
	wxDBMS Dbms()
    bool TableExists(const wxString &tableName, const wxChar *userID=NULL, const wxString &tablePath=wxEmptyString)
    bool TablePrivileges(const wxString &tableName, const wxString &priv, const wxChar *userID=NULL, const wxChar *schema=NULL, const wxString &path=wxEmptyString)
	// removed wxString &
	const wxString GetUsername()
	const wxString GetDatabaseName()
	const wxString GetErrorString()

    bool CommitTrans()
    bool RollbackTrans()
    bool CreateView(const wxString &viewName, const wxString &colList, const wxString &pSqlStmt, bool attemptDrop=true)
    bool DropView(const wxString &viewName)
    bool Grant(int privileges, const wxString &tableName, const wxString &userList = wxT("PUBLIC"))
    int TranslateSqlState(const wxString &SQLState)
    int GetKeyFields(const wxString &tableName, wxDbColInf* colInf, UWORD noCols)
    int GetColumnCount(const wxString &tableName, const wxChar *userID=NULL)
    bool OpenedWithConnectionString()
    bool SetSqlLogging(wxDbSqlLogState state, const wxString &filename = SQL_LOG_FILENAME, bool append = false)
    bool ModifyColumn(const wxString &tableName, const wxString &columnName, int dataType, ULONG columnLength=0, const wxString &optionalParam=wxEmptyString)
    bool FwdOnlyCursors()
    wxString EscapeSqlChars(const wxString& value)

	// Attributes ===========================================
	static bool Trace
	static long MaxRows

	bool mbConnected
	bool mbIsOpen
	bool mbAutoCommit
	bool mbInTransaction
	wxString msErrorBuffer
	wxString msInfoBuffer

	long mlAffectedRecords

	// ODBC Support
	wxDbODBC* m_pODBC
	wxDbODBC* m_qrydb
	wxDbConnectInf m_ConnectInf

//	wxSQLite3Database* m_pSqlite;

// #########################################################
// dbRecordset.h

%include <wx/dbRecordset.h>

%class wxDbColumnDef, wxDbColDef
	wxDbColumnDef(const wxString& pName, int pDataType, int pLen, int pPrecision, int pScale, int pDisplaySize, bool pIsNullable)
	//wxDbColumnDef(wxDbColumnDef* col)
	void Init(const wxString& pName, int pDataType, int pLen, int pPrecision, int pScale, int pDisplaySize, bool pIsNullable)

%{
void wxDbColumnDef_Table()
{
	wxString s;
	s = ((wxDbColumnDef *)(wTheCall->self->ptr))->Table;
	wStackPushChar( (char*) s.char_str(), W_TRUE );
}
void wxDbColumnDef_DbColName()
{
	wxString s;
	s = ((wxDbColumnDef *)(wTheCall->self->ptr))->DbColName;
	wStackPushChar( (char*) s.char_str(), W_TRUE );
}
void wxDbColumnDef_DataType()
{
	wNumber n;
	n = (wNumber) ((wxDbColumnDef *)(wTheCall->self->ptr))->DataType;
	wStackPushNumber( n );
}
void wxDbColumnDef_Len()
{
	wNumber n;
	n = (wNumber) ((wxDbColumnDef *)(wTheCall->self->ptr))->Len;
	wStackPushNumber( n );
}
void wxDbColumnDef_Precision()
{
	wNumber n;
	n = (wNumber) ((wxDbColumnDef *)(wTheCall->self->ptr))->Precision;
	wStackPushNumber( n );
}
void wxDbColumnDef_Scale()
{
	wNumber n;
	n = (wNumber) ((wxDbColumnDef *)(wTheCall->self->ptr))->Scale;
	wStackPushNumber( n );
}
void wxDbColumnDef_DisplaySize()
{
	wNumber n;
	n = (wNumber) ((wxDbColumnDef *)(wTheCall->self->ptr))->DisplaySize;
	wStackPushNumber( n );
}
void wxDbColumnDef_IsNull()
{
	wNumber n;
	n = (wNumber) ((wxDbColumnDef *)(wTheCall->self->ptr))->IsNull;
	wStackPushNumber( n );
}
void wxDbColumnDef_IsDirty()
{
	wNumber n;
	n = (wNumber) ((wxDbColumnDef *)(wTheCall->self->ptr))->IsDirty;
	wStackPushNumber( n );
}
void wxDbColumnDef_IsCounter()
{
	wNumber n;
	n = (wNumber) ((wxDbColumnDef *)(wTheCall->self->ptr))->IsCounter;
	wStackPushNumber( n );
}
void wxDbColumnDef_GotDefaultVal()
{
	wNumber n;
	n = (wNumber) ((wxDbColumnDef *)(wTheCall->self->ptr))->GotDefaultVal;
	wStackPushNumber( n );
}
void wxDbColumnDef_PkCol()
{
	wNumber n;
	n = (wNumber) ((wxDbColumnDef *)(wTheCall->self->ptr))->PkCol;
	wStackPushNumber( n );
}
void wxDbColumnDef_FkCol()
{
	wNumber n;
	n = (wNumber) ((wxDbColumnDef *)(wTheCall->self->ptr))->FkCol;
	wStackPushNumber( n );
}
void wxDbColumnDef_PkTable()
{
	wxString s;
	s = ((wxDbColumnDef *)(wTheCall->self->ptr))->PkTable;
	wStackPushChar( (char*) s.char_str(), W_TRUE );
}
void wxDbColumnDef_FkTable()
{
	wxString s;
	s = ((wxDbColumnDef *)(wTheCall->self->ptr))->FkTable;
	wStackPushChar( (char*) s.char_str(), W_TRUE );
}
%}
%method Table wxDbColumnDef_Table()
%method DbColName wxDbColumnDef_DbColName()
%method DataType wxDbColumnDef_DataType()
%method Len wxDbColumnDef_Len()
%method Precision wxDbColumnDef_Precision()
%method Scale wxDbColumnDef_Scale()
%method DisplaySize wxDbColumnDef_DisplaySize()
%method IsNull wxDbColumnDef_IsNull()
%method IsDirty wxDbColumnDef_IsDirty()
%method IsCounter wxDbColumnDef_IsCounter()
%method GotDefaultVal wxDbColumnDef_GotDefaultVal()
%method PkCol wxDbColumnDef_PkCol()
%method FkCol wxDbColumnDef_FkCol()
%method PkTable wxDbColumnDef_PkTable()
%method FkTable wxDbColumnDef_FkTable()

//	wxString Table
//	wxString DbColName
//	int DataType
//	int Len
//	int Precision
//	int Scale
//	int DisplaySize

//	bool IsNull
//	bool IsDirty
//	bool IsCounter
//	bool GotDefaultVal
//	int PkCol
//	int FkCol
//	wxString PkTable
//	wxString FkTable

%class wxDbColumnDefList, wxList

%class wxDbRecordset
	wxDbRecordset(wxDbEngine* dbe = NULL, const wxString& sqlQuery = wxEmptyString, const wxString& tblName = wxEmptyString, const wxString& tblPath = wxEmptyString)

	void ConnectDatabase()
	bool Open(const wxString &sqlQuery = wxEmptyString, const wxString& tblName = wxEmptyString)
	//bool Open(wxDbEngine* dbe = NULL, const wxString &sqlQuery = wxEmptyString, const wxString& tblName = wxEmptyString)
	void Close(bool bKeepStruct = false)
	// Info
	bool IsOpen()
	int ColumnCount()
	wxDbColumnDef* GetColumnInfo(const wxString& ColName)
	%rename GetColumnInfoPos wxDbColumnDef* GetColumnInfo(int nColumn)
	%rename GetColumnInfoByPos wxDbColumnDef* GetColumnInfo(int nColumn)
	const int FieldAvail(const wxString& ColName)
	// Movements
	bool MoveNext()
	bool MovePrev()
	bool MoveFirst()
	bool MoveLast()
	bool Move(long nRow)
	bool IsEOF()
	// Get Column Values
	bool IsNull(const wxString& ColName)
	%rename IsNullPos bool IsNull(int nCol)
	%rename FieldPos const wxString Field(int nCol)
	%rename FieldByPos const wxString Field(int nCol)
	const wxString Field(const wxString& ColName)
	const int IField(const wxString& ColName)
	const long LField(const wxString& ColName)
	const double FField(const wxString& ColName)
	const bool BField(const wxString& ColName)
	const wxDateTime DField(const wxString& ColName)
	// From wxDbTable
	ULONG Count(const wxString &args=wxT("*"))
	bool Delete()
	int Insert()
    bool Update()
    %rename GetColumnPos wxVariant GetColumn(const int colNumber)
    %rename SetColumnPos void SetColumn(const int colNumber, const wxVariant value)
    wxVariant GetColumn(const wxString& ColName)
    void SetColumn(const wxString& ColName, const wxVariant value)

	void LogError(const wxString& ErrorMsg)

	//bool getRec(UWORD fetchType, long irow = 0)
	//int sqlStrPos(const wxString &sStr, const wxString &sFind)
	//void splitSQLStatement(const wxString &sQuery, wxString &sSelect, wxString &sFrom, wxString &sWhere, wxString &sGroupBy, wxString &sOrderBy)

	wxDbEngine* m_dbe
	wxDbColumnDef* mpColDefs
	wxDbColumnDefList mColList
	short mnColumnCount
	bool mbIsEOF
	bool mbIsOpen
	wxString msTableName
	wxString msQuery
	wxString msTablePath
	long mlCurRecNo
	long mlMaxRecNo

	// ODBC Support
	wxDbTable* mpTable
	HSTMT mhstmt
	HENV mhenv
	HDBC mhdbc
	wxDbODBC* m_odbc
	bool mbNeedDelDb

	//wxSQLite3Database* m_pSqlite
	//wxSQLite3Table* m_pSLTable

///////////////////////////////////////////////////////////////////////////////
// XML Resources
///////////////////////////////////////////////////////////////////////////////

// #########################################################
// xml.h

// ==============================
// Class: wxXmlProperty

%class %delete wxXmlProperty

%include <wx/xml/xml.h>

%enum wxXmlNodeType
  %num wxXML_ELEMENT_NODE
  %num wxXML_ATTRIBUTE_NODE
  %num wxXML_TEXT_NODE
  %num wxXML_CDATA_SECTION_NODE
  %num wxXML_ENTITY_REF_NODE
  %num wxXML_ENTITY_NODE
  %num wxXML_PI_NODE
  %num wxXML_COMMENT_NODE
  %num wxXML_DOCUMENT_NODE
  %num wxXML_DOCUMENT_TYPE_NODE
  %num wxXML_DOCUMENT_FRAG_NODE
  %num wxXML_NOTATION_NODE
  %num wxXML_HTML_DOCUMENT_NODE

wxXmlProperty(const wxString& name, const wxString& value, wxXmlProperty *next = NULL)
%ctor wxXmlPropertyEmpty()
wxString GetName() const
wxString GetValue() const
wxXmlProperty *GetNext() const
void SetName(const wxString& name)
void SetValue(const wxString& value)
void SetNext(wxXmlProperty *next)

// ==============================
// Class: wxXmlNode

%class %delete wxXmlNode
wxXmlNode(wxXmlNodeType type, const wxString& name, const wxString& content = wxEmptyString)
%ctor wxXmlNodeWithParent(wxXmlNode *parent, wxXmlNodeType type, const wxString& name, const wxString& content = wxEmptyString, wxXmlProperty *props = NULL, wxXmlNode *next = NULL)
%ctor wxXmlNodeEmpty()
%ctor wxXmlNodeCopy(const wxXmlNode& node)
virtual void AddChild(wxXmlNode *child)
virtual bool InsertChild(wxXmlNode *child, wxXmlNode *before_node)
virtual bool RemoveChild(wxXmlNode *child)
virtual void AddProperty(const wxString& name, const wxString& value)
virtual bool DeleteProperty(const wxString& name)
wxXmlNodeType GetType() const
wxString GetName() const
wxString GetContent() const
bool IsWhitespaceOnly() const
int GetDepth(wxXmlNode *grandparent = NULL) const
wxString GetNodeContent() const
wxXmlNode *GetParent() const
wxXmlNode *GetNext() const
wxXmlNode *GetChildren() const
wxXmlProperty *GetProperties() const
//bool GetPropVal(const wxString& propName, wxString *value) const
wxString GetPropVal(const wxString& propName, const wxString& defaultVal) const
bool HasProp(const wxString& propName) const
void SetType(wxXmlNodeType type)
void SetName(const wxString& name)
void SetContent(const wxString& con)
void SetParent(wxXmlNode *parent)
void SetNext(wxXmlNode *next)
void SetChildren(wxXmlNode *child)
void SetProperties(wxXmlProperty *prop)
%rename AddPropertyFromXmlProperty void AddProperty(wxXmlProperty *prop)

// ==============================
// Class: wxXmlDocument

%class %delete wxXmlDocument, wxObject

%enum wxXmlDocumentLoadFlag
  %num wxXMLDOC_NONE
  %num wxXMLDOC_KEEP_WHITESPACE_NODES

wxXmlDocument()
%ctor wxXmlDocumentFromFile(const wxString& filename, const wxString& encoding = wxT("UTF-8"))
%ctor wxXmlDocumentFromStream(wxInputStream& stream, const wxString& encoding = wxT("UTF-8"))
%ctor wxXmlDocumentCopy(const wxXmlDocument& doc)
virtual bool Load(const wxString& filename, const wxString& encoding = wxT("UTF-8"), int flags = wxXMLDOC_NONE)
%rename LoadFromStream bool Load(wxInputStream& stream, const wxString& encoding = wxT("UTF-8"), int flags = wxXMLDOC_NONE)
virtual bool Save(const wxString& filename, int indentstep = 1) const
%rename SaveToStream bool Save(wxOutputStream& stream, int indentstep = 1) const
bool IsOk() const
wxXmlNode *GetRoot() const
wxString GetVersion() const
wxString GetFileEncoding() const
wxXmlNode *DetachRoot()
void SetRoot(wxXmlNode *node)
void SetVersion(const wxString& version)
void SetFileEncoding(const wxString& encoding)
%not(unicode) wxString GetEncoding() const
%not(unicode) void SetEncoding(const wxString& enc)

// #########################################################
// xmlres.h

%include <wx/xrc/xmlres.h>

%class wxXmlResourceHandler
%class wxXmlSubclassFactory

%num WX_XMLRES_CURRENT_VERSION_MAJOR
%num WX_XMLRES_CURRENT_VERSION_MINOR
%num WX_XMLRES_CURRENT_VERSION_RELEASE
%num WX_XMLRES_CURRENT_VERSION_REVISION
%str WX_XMLRES_CURRENT_VERSION_STRING

%enum wxXmlResourceFlags
  %num wxXRC_USE_LOCALE
  %num wxXRC_NO_SUBCLASSING
  %num wxXRC_NO_RELOADING

// ==============================
// Class: wxXmlResource

%class %delete wxXmlResource, wxObject
wxXmlResource(int flags = wxXRC_USE_LOCALE, const wxString& domain=wxEmptyString)
%ctor wxXmlResourceWithFileMask(const wxString& filemask, int flags = wxXRC_USE_LOCALE, const wxString& domain=wxEmptyString)
bool Load(const wxString& filemask)
bool Unload(const wxString& filename)
void InitAllHandlers()
void AddHandler(wxXmlResourceHandler *handler)
void InsertHandler(wxXmlResourceHandler *handler)
void ClearHandlers()
static void AddSubclassFactory(wxXmlSubclassFactory *factory)
wxMenu *LoadMenu(const wxString& name)
wxMenuBar *LoadMenuBar(wxWindow *parent, const wxString& name)
//wxMenuBar *LoadMenuBar(const wxString& name)
wxToolBar *LoadToolBar(wxWindow *parent, const wxString& name)
//wxDialog *LoadDialog(wxWindow *parent, const wxString& name)
bool LoadDialog(wxDialog *dlg, wxWindow *parent, const wxString& name)
//wxPanel *LoadPanel(wxWindow *parent, const wxString& name)
bool LoadPanel(wxPanel *panel, wxWindow *parent, const wxString& name)
//wxFrame *LoadFrame(wxWindow* parent, const wxString& name)
bool LoadFrame(wxFrame* frame, wxWindow *parent, const wxString& name)
//wxObject *LoadObject(wxWindow *parent, const wxString& name, const wxString& classname)
bool LoadObject(wxObject *instance, wxWindow *parent, const wxString& name, const wxString& classname)
wxBitmap LoadBitmap(const wxString& name)
wxIcon LoadIcon(const wxString& name)
bool AttachUnknownControl(const wxString& name, wxWindow *control, wxWindow *parent = NULL)
static int GetXRCID(const wxChar *str_id, int value_if_not_found = wxID_NONE)
long GetVersion() const
int CompareVersion(int major, int minor, int release, int revision) const
static wxXmlResource *Get()
static wxXmlResource *Set(wxXmlResource *res)
int GetFlags() const
void SetFlags(int flags)
wxString GetDomain() const
void SetDomain(const wxString& domain)

%{
	int _XRCID(const wxString& str_id, int value_if_not_found = wxID_NONE)
	{
		int res = wxXmlResource::GetXRCID(str_id, value_if_not_found);
		return res;
	}

	wxWindow* _XRCCTRL(wxWindow* win, const wxString& sid)
	{
		int id = wxXmlResource::GetXRCID(sid);
		wxWindow* ctrl = NULL;
		if(win)
			ctrl = win->FindWindow(id);
		else
			ctrl = NULL;
		return ctrl;
	}

	wxTextCtrl* _XRCCTRL_wxTextCtrl(wxWindow* win, const wxString& sid)
	{ return (wxTextCtrl*) _XRCCTRL(win, sid); }

	wxStaticText* _XRCCTRL_wxStaticText(wxWindow* win, const wxString& sid)
	{ return (wxStaticText*) _XRCCTRL(win, sid); }

	wxStaticBitmap* _XRCCTRL_wxStaticBitmap(wxWindow* win, const wxString& sid)
	{ return (wxStaticBitmap*) _XRCCTRL(win, sid); }

	wxStaticLine* _XRCCTRL_wxStaticLine(wxWindow* win, const wxString& sid)
	{ return (wxStaticLine*) _XRCCTRL(win, sid); }

	wxButton* _XRCCTRL_wxButton(wxWindow* win, const wxString& sid)
	{ return (wxButton*) _XRCCTRL(win, sid); }

	wxBitmapButton* _XRCCTRL_wxBitmapButton(wxWindow* win, const wxString& sid)
	{ return (wxBitmapButton*) _XRCCTRL(win, sid); }

	wxStaticBox* _XRCCTRL_wxStaticBox(wxWindow* win, const wxString& sid)
	{ return (wxStaticBox*) _XRCCTRL(win, sid); }

	wxComboBox* _XRCCTRL_wxComboBox(wxWindow* win, const wxString& sid)
	{ return (wxComboBox*) _XRCCTRL(win, sid); }

	wxChoice* _XRCCTRL_wxChoice(wxWindow* win, const wxString& sid)
	{ return (wxChoice*) _XRCCTRL(win, sid); }

	wxRadioButton* _XRCCTRL_wxRadioButton(wxWindow* win, const wxString& sid)
	{ return (wxRadioButton*) _XRCCTRL(win, sid); }

	wxCheckBox* _XRCCTRL_wxCheckBox(wxWindow* win, const wxString& sid)
	{ return (wxCheckBox*) _XRCCTRL(win, sid); }

	wxRadioBox* _XRCCTRL_wxRadioBox(wxWindow* win, const wxString& sid)
	{ return (wxRadioBox*) _XRCCTRL(win, sid); }

	wxSpinCtrl* _XRCCTRL_wxSpinCtrl(wxWindow* win, const wxString& sid)
	{ return (wxSpinCtrl*) _XRCCTRL(win, sid); }

	wxSpinButton* _XRCCTRL_wxSpinButton(wxWindow* win, const wxString& sid)
	{ return (wxSpinButton*) _XRCCTRL(win, sid); }

	wxScrollBar* _XRCCTRL_wxScrollBar(wxWindow* win, const wxString& sid)
	{ return (wxScrollBar*) _XRCCTRL(win, sid); }

	wxSlider* _XRCCTRL_wxSlider(wxWindow* win, const wxString& sid)
	{ return (wxSlider*) _XRCCTRL(win, sid); }

	wxGauge* _XRCCTRL_wxGauge(wxWindow* win, const wxString& sid)
	{ return (wxGauge*) _XRCCTRL(win, sid); }

	wxTreeCtrl* _XRCCTRL_wxTreeCtrl(wxWindow* win, const wxString& sid)
	{ return (wxTreeCtrl*) _XRCCTRL(win, sid); }

	wxListBox* _XRCCTRL_wxListBox(wxWindow* win, const wxString& sid)
	{ return (wxListBox*) _XRCCTRL(win, sid); }

	wxCheckListBox* _XRCCTRL_wxCheckListBox(wxWindow* win, const wxString& sid)
	{ return (wxCheckListBox*) _XRCCTRL(win, sid); }

	wxListCtrl* _XRCCTRL_wxListCtrl(wxWindow* win, const wxString& sid)
	{ return (wxListCtrl*) _XRCCTRL(win, sid); }

	wxNotebook* _XRCCTRL_wxNotebook(wxWindow* win, const wxString& sid)
	{ return (wxNotebook*) _XRCCTRL(win, sid); }

	wxSplitterWindow* _XRCCTRL_wxSplitterWindow(wxWindow* win, const wxString& sid)
	{ return (wxSplitterWindow*) _XRCCTRL(win, sid); }

	wxScrolledWindow* _XRCCTRL_wxScrolledWindow(wxWindow* win, const wxString& sid)
	{ return (wxScrolledWindow*) _XRCCTRL(win, sid); }

	wxHtmlWindow* _XRCCTRL_wxHtmlWindow(wxWindow* win, const wxString& sid)
	{ return (wxHtmlWindow*) _XRCCTRL(win, sid); }

	wxCalendarCtrl* _XRCCTRL_wxCalendarCtrl(wxWindow* win, const wxString& sid)
	{ return (wxCalendarCtrl*) _XRCCTRL(win, sid); }

	wxDatePickerCtrl* _XRCCTRL_wxDatePickerCtrl(wxWindow* win, const wxString& sid)
	{ return (wxDatePickerCtrl*) _XRCCTRL(win, sid); }

	wxGenericDirCtrl* _XRCCTRL_wxGenericDirCtrl(wxWindow* win, const wxString& sid)
	{ return (wxGenericDirCtrl*) _XRCCTRL(win, sid); }

%}
%builtin %alias XRCID int _XRCID(const wxString& str_id, int value_if_not_found = wxID_NONE)
%builtin %alias XRCCTRL wxWindow* _XRCCTRL(wxWindow* win, const wxString& sid)
%builtin %alias wxTextCtrlXRC wxTextCtrl* _XRCCTRL_wxTextCtrl(wxWindow* win, const wxString& sid)

%builtin %alias wxStaticTextXRC wxStaticText* _XRCCTRL_wxStaticText(wxWindow* win, const wxString& sid)
%builtin %alias wxStaticBitmapXRC wxStaticBitmap* _XRCCTRL_wxStaticBitmap(wxWindow* win, const wxString& sid)
%builtin %alias wxStaticLineXRC wxStaticLine* _XRCCTRL_wxStaticLine(wxWindow* win, const wxString& sid)
%builtin %alias wxButtonXRC wxButton* _XRCCTRL_wxButton(wxWindow* win, const wxString& sid)
%builtin %alias wxBitmapButtonXRC wxBitmapButton* _XRCCTRL_wxBitmapButton(wxWindow* win, const wxString& sid)
%builtin %alias wxStaticBoxXRC wxStaticBox* _XRCCTRL_wxStaticBox(wxWindow* win, const wxString& sid)
%builtin %alias wxComboBoxXRC wxComboBox* _XRCCTRL_wxComboBox(wxWindow* win, const wxString& sid)
%builtin %alias wxChoiceXRC wxChoice* _XRCCTRL_wxChoice(wxWindow* win, const wxString& sid)
%builtin %alias wxRadioButtonXRC wxRadioButton* _XRCCTRL_wxRadioButton(wxWindow* win, const wxString& sid)
%builtin %alias wxCheckBoxXRC wxCheckBox* _XRCCTRL_wxCheckBox(wxWindow* win, const wxString& sid)
%builtin %alias wxRadioBoxXRC wxRadioBox* _XRCCTRL_wxRadioBox(wxWindow* win, const wxString& sid)
%builtin %alias wxSpinCtrlXRC wxSpinCtrl* _XRCCTRL_wxSpinCtrl(wxWindow* win, const wxString& sid)
%builtin %alias wxSpinButtonXRC wxSpinButton* _XRCCTRL_wxSpinButton(wxWindow* win, const wxString& sid)
%builtin %alias wxScrollBarXRC wxScrollBar* _XRCCTRL_wxScrollBar(wxWindow* win, const wxString& sid)
%builtin %alias wxSliderXRC wxSlider* _XRCCTRL_wxSlider(wxWindow* win, const wxString& sid)
%builtin %alias wxGaugeXRC wxGauge* _XRCCTRL_wxGauge(wxWindow* win, const wxString& sid)
%builtin %alias wxTreeCtrlXRC wxTreeCtrl* _XRCCTRL_wxTreeCtrl(wxWindow* win, const wxString& sid)
%builtin %alias wxListBoxXRC wxListBox* _XRCCTRL_wxListBox(wxWindow* win, const wxString& sid)
%builtin %alias wxCheckListBoxXRC wxCheckListBox* _XRCCTRL_wxCheckListBox(wxWindow* win, const wxString& sid)
%builtin %alias wxListCtrlXRC wxListCtrl* _XRCCTRL_wxListCtrl(wxWindow* win, const wxString& sid)
%builtin %alias wxNotebookXRC wxNotebook* _XRCCTRL_wxNotebook(wxWindow* win, const wxString& sid)
%builtin %alias wxSplitterWindowXRC wxSplitterWindow* _XRCCTRL_wxSplitterWindow(wxWindow* win, const wxString& sid)
%builtin %alias wxScrolledWindowXRC wxScrolledWindow* _XRCCTRL_wxScrolledWindow(wxWindow* win, const wxString& sid)
%builtin %alias wxHtmlWindowXRC wxHtmlWindow* _XRCCTRL_wxHtmlWindow(wxWindow* win, const wxString& sid)
%builtin %alias wxCalendarCtrlXRC wxCalendarCtrl* _XRCCTRL_wxCalendarCtrl(wxWindow* win, const wxString& sid)
%builtin %alias wxDatePickerCtrlXRC wxDatePickerCtrl* _XRCCTRL_wxDatePickerCtrl(wxWindow* win, const wxString& sid)
%builtin %alias wxGenericDirCtrlXRC wxGenericDirCtrl* _XRCCTRL_wxGenericDirCtrl(wxWindow* win, const wxString& sid)

%{
	//#define __wxTheXmlResource  &wxXmlResource::Get()
	wxXmlResource* __wxTheXmlResource_Get()
	{
		return wxXmlResource::Get();
	}
%}
%builtin %alias wxTheXmlResource wxXmlResource* __wxTheXmlResource_Get()

///////////////////////////////////////////////////////////////////////////////
// AUI CLASSES
///////////////////////////////////////////////////////////////////////////////

// #########################################################
// framemanager.h

%include <wx/aui/framemanager.h>

%enum wxAuiManagerDock
  %num wxAUI_DOCK_NONE
  %num wxAUI_DOCK_TOP
  %num wxAUI_DOCK_RIGHT
  %num wxAUI_DOCK_BOTTOM
  %num wxAUI_DOCK_LEFT
  %num wxAUI_DOCK_CENTER
  %num wxAUI_DOCK_CENTRE

%enum wxAuiManagerOption
  %num wxAUI_MGR_ALLOW_FLOATING
  %num wxAUI_MGR_ALLOW_ACTIVE_PANE
  %num wxAUI_MGR_TRANSPARENT_DRAG
  %num wxAUI_MGR_TRANSPARENT_HINT
  %num wxAUI_MGR_VENETIAN_BLINDS_HINT
  %num wxAUI_MGR_RECTANGLE_HINT
  %num wxAUI_MGR_HINT_FADE
  %num wxAUI_MGR_NO_VENETIAN_BLINDS_FADE
  %num wxAUI_MGR_DEFAULT

%enum wxAuiPaneDockArtSetting
  %num wxAUI_DOCKART_SASH_SIZE
  %num wxAUI_DOCKART_CAPTION_SIZE
  %num wxAUI_DOCKART_GRIPPER_SIZE
  %num wxAUI_DOCKART_PANE_BORDER_SIZE
  %num wxAUI_DOCKART_PANE_BUTTON_SIZE
  %num wxAUI_DOCKART_BACKGROUND_COLOUR
  %num wxAUI_DOCKART_SASH_COLOUR
  %num wxAUI_DOCKART_ACTIVE_CAPTION_COLOUR
  %num wxAUI_DOCKART_ACTIVE_CAPTION_GRADIENT_COLOUR
  %num wxAUI_DOCKART_INACTIVE_CAPTION_COLOUR
  %num wxAUI_DOCKART_INACTIVE_CAPTION_GRADIENT_COLOUR
  %num wxAUI_DOCKART_ACTIVE_CAPTION_TEXT_COLOUR
  %num wxAUI_DOCKART_INACTIVE_CAPTION_TEXT_COLOUR
  %num wxAUI_DOCKART_BORDER_COLOUR
  %num wxAUI_DOCKART_GRIPPER_COLOUR
  %num wxAUI_DOCKART_CAPTION_FONT
  %num wxAUI_DOCKART_GRADIENT_TYPE

%enum wxAuiPaneDockArtGradients
  %num wxAUI_GRADIENT_NONE
  %num wxAUI_GRADIENT_VERTICAL
  %num wxAUI_GRADIENT_HORIZONTAL

%enum wxAuiPaneButtonState
  %num wxAUI_BUTTON_STATE_NORMAL
  %num wxAUI_BUTTON_STATE_HOVER
  %num wxAUI_BUTTON_STATE_PRESSED
  %num wxAUI_BUTTON_STATE_DISABLED
  %num wxAUI_BUTTON_STATE_HIDDEN
  %num wxAUI_BUTTON_STATE_CHECKED

%enum wxAuiButtonId
  %num wxAUI_BUTTON_CLOSE
  %num wxAUI_BUTTON_MAXIMIZE_RESTORE
  %num wxAUI_BUTTON_MINIMIZE
  %num wxAUI_BUTTON_PIN
  %num wxAUI_BUTTON_OPTIONS
  %num wxAUI_BUTTON_WINDOWLIST
  %num wxAUI_BUTTON_LEFT
  %num wxAUI_BUTTON_RIGHT
  %num wxAUI_BUTTON_UP
  %num wxAUI_BUTTON_DOWN
  %num wxAUI_BUTTON_CUSTOM1
  %num wxAUI_BUTTON_CUSTOM2
  %num wxAUI_BUTTON_CUSTOM3

%enum wxAuiPaneInsertLevel
  %num wxAUI_INSERT_PANE
  %num wxAUI_INSERT_ROW
  %num wxAUI_INSERT_DOCK

//%builtin wxAuiDockInfo wxAuiNullDockInfo
//%builtin wxAuiPaneInfo wxAuiNullPaneInfo

// #########################################################
// aui.h

%include <wx/aui/aui.h>

// #########################################################
// auibook.h

%include <wx/aui/auibook.h>

%enum wxAuiNotebookOption
  %num wxAUI_NB_TOP
  %num wxAUI_NB_LEFT
  %num wxAUI_NB_RIGHT
  %num wxAUI_NB_BOTTOM
  %num wxAUI_NB_TAB_SPLIT
  %num wxAUI_NB_TAB_MOVE
  %num wxAUI_NB_TAB_EXTERNAL_MOVE
  %num wxAUI_NB_TAB_FIXED_WIDTH
  %num wxAUI_NB_SCROLL_BUTTONS
  %num wxAUI_NB_WINDOWLIST_BUTTON
  %num wxAUI_NB_CLOSE_BUTTON
  %num wxAUI_NB_CLOSE_ON_ACTIVE_TAB
  %num wxAUI_NB_CLOSE_ON_ALL_TABS
  %num wxAUI_NB_MIDDLE_CLICK_CLOSE
  %num wxAUI_NB_DEFAULT_STYLE

// ==============================
// Class: wxAuiNotebookEvent

%class %delete wxAuiNotebookEvent, wxNotifyEvent
wxAuiNotebookEvent(wxEventType command_type = wxEVT_NULL, int win_id = 0)
%ctor wxAuiNotebookEventCopy(const wxAuiNotebookEvent& c)
%not(bcc) wxEvent *Clone() const
void SetSelection(int s)
int GetSelection() const
void SetOldSelection(int s)
int GetOldSelection() const
void SetDragSource(wxAuiNotebook* s)
wxAuiNotebook* GetDragSource() const
int old_selection
int selection
wxAuiNotebook* drag_source

%event wxEVT_COMMAND_AUINOTEBOOK_PAGE_CLOSE
%event wxEVT_COMMAND_AUINOTEBOOK_PAGE_CHANGED
%event wxEVT_COMMAND_AUINOTEBOOK_PAGE_CHANGING
%event wxEVT_COMMAND_AUINOTEBOOK_BUTTON
%event wxEVT_COMMAND_AUINOTEBOOK_BEGIN_DRAG
%event wxEVT_COMMAND_AUINOTEBOOK_END_DRAG
%event wxEVT_COMMAND_AUINOTEBOOK_DRAG_MOTION
%event wxEVT_COMMAND_AUINOTEBOOK_ALLOW_DND
%event wxEVT_COMMAND_AUINOTEBOOK_TAB_MIDDLE_DOWN
%event wxEVT_COMMAND_AUINOTEBOOK_TAB_MIDDLE_UP
%event wxEVT_COMMAND_AUINOTEBOOK_TAB_RIGHT_DOWN
%event wxEVT_COMMAND_AUINOTEBOOK_TAB_RIGHT_UP
%event wxEVT_COMMAND_AUINOTEBOOK_PAGE_CLOSED
%event wxEVT_COMMAND_AUINOTEBOOK_DRAG_DONE
%event wxEVT_COMMAND_AUINOTEBOOK_BG_DCLICK

// ==============================
// Class: wxAuiNotebookPage

%class %delete wxAuiNotebookPage
wxWindow* window
wxString caption
wxBitmap bitmap
wxRect rect
bool active

// ==============================
// Class: wxAuiTabArt

%class %delete wxAuiNotebookPageArray
wxAuiNotebookPageArray()
%ctor wxAuiNotebookPageArrayCopy(const wxAuiNotebookPageArray& array)
void Add(wxAuiNotebookPage* page)
void Clear()
int  GetCount() const
void Insert(wxAuiNotebookPage* page, int nIndex)
bool IsEmpty()
wxAuiNotebookPage Item(size_t nIndex) const
void RemoveAt(size_t nIndex)

%class %delete wxAuiTabArt
//Abstract Class
//wxAuiTabArt()
virtual wxAuiTabArt* Clone()
virtual void SetFlags(unsigned int flags)
virtual void SetSizingInfo(const wxSize& tab_ctrl_size, size_t tab_count)
virtual void SetNormalFont(const wxFont& font)
virtual void SetSelectedFont(const wxFont& font)
virtual void SetMeasuringFont(const wxFont& font)
virtual void DrawBackground(wxDC& dc, wxWindow* wnd, const wxRect& rect)
virtual void DrawTab(wxDC& dc, wxWindow* wnd, const wxAuiNotebookPage& pane, const wxRect& in_rect, int close_button_state, wxRect* out_tab_rect, wxRect* out_button_rect, int* x_extent)
virtual void DrawButton(wxDC& dc, wxWindow* wnd, const wxRect& in_rect, int bitmap_id, int button_state, int orientation, wxRect* out_rect)
virtual wxSize GetTabSize(wxDC& dc, wxWindow* wnd, const wxString& caption, const wxBitmap& bitmap, bool active, int close_button_state, int* x_extent)
virtual int ShowDropDown(wxWindow* wnd, const wxAuiNotebookPageArray& items, int active_idx)
virtual int GetIndentSize()
virtual int GetBestTabCtrlSize(wxWindow* wnd, const wxAuiNotebookPageArray& pages, const wxSize& required_bmp_size)

// ==============================
// Class: wxAuiDefaultTabArt

%class wxAuiDefaultTabArt, wxAuiTabArt
wxAuiDefaultTabArt()
wxAuiTabArt* Clone()
void SetFlags(unsigned int flags)
void SetSizingInfo(const wxSize& tab_ctrl_size, size_t tab_count)
void SetNormalFont(const wxFont& font)
void SetSelectedFont(const wxFont& font)
void SetMeasuringFont(const wxFont& font)
void DrawBackground(wxDC& dc, wxWindow* wnd, const wxRect& rect)
void DrawTab(wxDC& dc, wxWindow* wnd, const wxAuiNotebookPage& pane, const wxRect& in_rect, int close_button_state, wxRect* out_tab_rect, wxRect* out_button_rect, int* x_extent)
void DrawButton(wxDC& dc, wxWindow* wnd, const wxRect& in_rect, int bitmap_id, int button_state, int orientation, wxRect* out_rect)
int GetIndentSize()
wxSize GetTabSize(wxDC& dc, wxWindow* wnd, const wxString& caption, const wxBitmap& bitmap, bool active, int close_button_state, int* x_extent)
int ShowDropDown(wxWindow* wnd, const wxAuiNotebookPageArray& items, int active_idx)
int GetBestTabCtrlSize(wxWindow* wnd, const wxAuiNotebookPageArray& pages, const wxSize& required_bmp_size)

// ==============================
// Class: wxAuiSimpleTabArt

%class wxAuiSimpleTabArt, wxAuiTabArt
wxAuiSimpleTabArt()
wxAuiTabArt* Clone()
void SetFlags(unsigned int flags)
void SetSizingInfo(const wxSize& tab_ctrl_size, size_t tab_count)
void SetNormalFont(const wxFont& font)
void SetSelectedFont(const wxFont& font)
void SetMeasuringFont(const wxFont& font)
void DrawBackground(wxDC& dc, wxWindow* wnd, const wxRect& rect)
void DrawTab(wxDC& dc, wxWindow* wnd, const wxAuiNotebookPage& pane, const wxRect& in_rect, int close_button_state, wxRect* out_tab_rect, wxRect* out_button_rect, int* x_extent)
void DrawButton(wxDC& dc, wxWindow* wnd, const wxRect& in_rect, int bitmap_id, int button_state, int orientation, wxRect* out_rect)
int GetIndentSize()
wxSize GetTabSize(wxDC& dc, wxWindow* wnd, const wxString& caption, const wxBitmap& bitmap, bool active, int close_button_state, int* x_extent)
int ShowDropDown(wxWindow* wnd, const wxAuiNotebookPageArray& items, int active_idx)
int GetBestTabCtrlSize(wxWindow* wnd, const wxAuiNotebookPageArray& pages, const wxSize& required_bmp_size)

// ==============================
// Class: wxAuiNotebook

%class wxAuiNotebook, wxControl
%ctor wxAuiNotebookNoCreate()
wxAuiNotebook(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxAUI_NB_DEFAULT_STYLE)
bool Create(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0)
void SetWindowStyleFlag(long style)
void SetArtProvider(wxAuiTabArt* art)
wxAuiTabArt* GetArtProvider() const
virtual void SetUniformBitmapSize(const wxSize& size)
virtual void SetTabCtrlHeight(int height)
bool AddPage(wxWindow* page, const wxString& caption, bool select = false, const wxBitmap& bitmap = wxNullBitmap)
bool InsertPage(size_t page_idx, wxWindow* page, const wxString& caption, bool select = false, const wxBitmap& bitmap = wxNullBitmap)
bool DeletePage(size_t page)
bool RemovePage(size_t page)
size_t GetPageCount() const
wxWindow* GetPage(size_t page_idx) const
int GetPageIndex(wxWindow* page_wnd) const
bool SetPageText(size_t page, const wxString& text)
wxString GetPageText(size_t page_idx) const
bool SetPageBitmap(size_t page, const wxBitmap& bitmap)
wxBitmap GetPageBitmap(size_t page_idx) const
size_t SetSelection(size_t new_page)
int GetSelection() const
virtual void Split(size_t page, int direction)
const wxAuiManager& GetAuiManager() const
void SetNormalFont(const wxFont& font)
void SetSelectedFont(const wxFont& font)
void SetMeasuringFont(const wxFont& font)
virtual bool SetFont(const wxFont& font)
int GetTabCtrlHeight() const
int GetHeightForPageHeight(int pageHeight)
void AdvanceSelection(bool forward = true)
bool ShowWindowMenu()

// #########################################################
// dockart.h

%include <wx/aui/dockart.h>

// ==============================
// Class: wxAuiDockArt

%class %delete wxAuiDockArt
// Abstract Class
//wxAuiDockArt()
virtual int GetMetric(int id)
virtual void SetMetric(int id, int new_val)
virtual void SetFont(int id, const wxFont& font)
virtual wxFont GetFont(int id)
virtual wxColour GetColour(int id)
virtual void SetColour(int id, const wxColor& colour)
wxColour GetColor(int id)
void SetColor(int id, const wxColour& color)
virtual void DrawSash(wxDC& dc, wxWindow* window, int orientation, const wxRect& rect)
virtual void DrawBackground(wxDC& dc, wxWindow* window, int orientation, const wxRect& rect)
virtual void DrawCaption(wxDC& dc, wxWindow* window, const wxString& text, const wxRect& rect, wxAuiPaneInfo& pane)
virtual void DrawGripper(wxDC& dc, wxWindow* window, const wxRect& rect, wxAuiPaneInfo& pane)
virtual void DrawBorder(wxDC& dc, wxWindow* window, const wxRect& rect, wxAuiPaneInfo& pane)
virtual void DrawPaneButton(wxDC& dc, wxWindow* window, int button, int button_state, const wxRect& rect, wxAuiPaneInfo& pane)

// ==============================
// Class: wxAuiDefaultDockArt

%class %delete wxAuiDefaultDockArt, wxAuiDockArt
wxAuiDefaultDockArt()
int GetMetric(int metric_id)
void SetMetric(int metric_id, int new_val)
wxColour GetColour(int id)
void SetColour(int id, const wxColor& colour)
void SetFont(int id, const wxFont& font)
wxFont GetFont(int id)
void DrawSash(wxDC& dc, wxWindow *window, int orientation, const wxRect& rect)
void DrawBackground(wxDC& dc, wxWindow *window, int orientation, const wxRect& rect)
void DrawCaption(wxDC& dc, wxWindow *window, const wxString& text, const wxRect& rect, wxAuiPaneInfo& pane)
void DrawGripper(wxDC& dc, wxWindow *window, const wxRect& rect, wxAuiPaneInfo& pane)
void DrawBorder(wxDC& dc, wxWindow *window, const wxRect& rect, wxAuiPaneInfo& pane)
void DrawPaneButton(wxDC& dc, wxWindow *window, int button, int button_state, const wxRect& rect, wxAuiPaneInfo& pane)

// ==============================
// Class: wxAuiPaneInfo

%class %delete wxAuiPaneInfo
wxAuiPaneInfo()
%ctor wxAuiPaneInfoCopy(const wxAuiPaneInfo& c)
//void SafeSet(wxAuiPaneInfo source)
void SafeSet(wxAuiPaneInfo& source)
bool IsOk() const
bool IsFixed() const
bool IsResizable() const
bool IsShown() const
bool IsFloating() const
bool IsDocked() const
bool IsToolbar() const
bool IsTopDockable() const
bool IsBottomDockable() const
bool IsLeftDockable() const
bool IsRightDockable() const
bool IsFloatable() const
bool IsMovable() const
bool IsDestroyOnClose() const
bool IsMaximized() const
bool HasCaption() const
bool HasGripper() const
bool HasBorder() const
bool HasCloseButton() const
bool HasMaximizeButton() const
bool HasMinimizeButton() const
bool HasPinButton() const
bool HasGripperTop() const
wxAuiPaneInfo& Window(wxWindow* w)
wxAuiPaneInfo& Name(const wxString& n)
wxAuiPaneInfo& Caption(const wxString& c)
wxAuiPaneInfo& Left()
wxAuiPaneInfo& Right()
wxAuiPaneInfo& Top()
wxAuiPaneInfo& Bottom()
wxAuiPaneInfo& Center()
wxAuiPaneInfo& Centre()
wxAuiPaneInfo& Direction(int direction)
wxAuiPaneInfo& Layer(int layer)
wxAuiPaneInfo& Row(int row)
wxAuiPaneInfo& Position(int pos)
%rename BestSizeFromSize wxAuiPaneInfo& BestSize(const wxSize& size)
%rename MinSizeFromSize wxAuiPaneInfo& MinSize(const wxSize& size)
%rename MaxSizeFromSize wxAuiPaneInfo& MaxSize(const wxSize& size)
wxAuiPaneInfo& BestSize(int x, int y)
wxAuiPaneInfo& MinSize(int x, int y)
wxAuiPaneInfo& MaxSize(int x, int y)
%rename FloationPositionFromPoint wxAuiPaneInfo& FloatingPosition(const wxPoint& pos)
wxAuiPaneInfo& FloatingPosition(int x, int y)
%rename FloationSizeFromSize wxAuiPaneInfo& FloatingSize(const wxSize& size)
wxAuiPaneInfo& FloatingSize(int x, int y)
wxAuiPaneInfo& Fixed()
wxAuiPaneInfo& Resizable(bool resizable = true)
wxAuiPaneInfo& Dock()
wxAuiPaneInfo& Float()
wxAuiPaneInfo& Hide()
wxAuiPaneInfo& Show(bool show = true)
wxAuiPaneInfo& CaptionVisible(bool visible = true)
wxAuiPaneInfo& Maximize()
wxAuiPaneInfo& Restore()
wxAuiPaneInfo& PaneBorder(bool visible = true)
wxAuiPaneInfo& Gripper(bool visible = true)
wxAuiPaneInfo& GripperTop(bool attop = true)
wxAuiPaneInfo& CloseButton(bool visible = true)
wxAuiPaneInfo& MaximizeButton(bool visible = true)
wxAuiPaneInfo& MinimizeButton(bool visible = true)
wxAuiPaneInfo& PinButton(bool visible = true)
wxAuiPaneInfo& DestroyOnClose(bool b = true)
wxAuiPaneInfo& TopDockable(bool b = true)
wxAuiPaneInfo& BottomDockable(bool b = true)
wxAuiPaneInfo& LeftDockable(bool b = true)
wxAuiPaneInfo& RightDockable(bool b = true)
wxAuiPaneInfo& Floatable(bool b = true)
wxAuiPaneInfo& Movable(bool b = true)
wxAuiPaneInfo& Dockable(bool b = true)
wxAuiPaneInfo& DefaultPane()
wxAuiPaneInfo& CentrePane()
wxAuiPaneInfo& CenterPane()
wxAuiPaneInfo& ToolbarPane()
wxAuiPaneInfo& SetFlag(unsigned int flag, bool option_state)
bool HasFlag(unsigned int flag) const

%{
//wxString name
void wxAuiPaneInfo_GetName()
{
	wxString name;
    name = ((wxAuiPaneInfo *)(wTheCall->self->ptr))->name;
	wStackPushChar( (char *)(name.char_str()), W_TRUE );
}

//wxString caption
void wxAuiPaneInfo_GetCaption()
{
	wxString caption;
    caption = ((wxAuiPaneInfo *)(wTheCall->self->ptr))->caption;
	wStackPushChar( (char *)(caption.char_str()), W_TRUE );
}

//wxWindow* window
void wxAuiPaneInfo_GetWindow()
{
	wxWindow* window;
    window = ((wxAuiPaneInfo *)(wTheCall->self->ptr))->window;
	wWrapPushObject( _wxWindow, W_TRUE, (void *)window );
}

//wxFrame* frame
void wxAuiPaneInfo_GetFrame()
{
	wxFrame* frame;
    frame = ((wxAuiPaneInfo *)(wTheCall->self->ptr))->frame;
	wWrapPushObject( _wxFrame, W_TRUE, (void *)frame );
}

//wxPoint floating_pos
void wxAuiPaneInfo_GetFloatingPos()
{
	wxPoint* floating_pos;
    floating_pos = &((wxAuiPaneInfo *)(wTheCall->self->ptr))->floating_pos;
	wWrapPushObject( _wxPoint, W_TRUE, (void *)floating_pos );
}

//wxSize floating_size
void wxAuiPaneInfo_GetFloatingSize()
{
	wxSize* floating_size;
    floating_size = &((wxAuiPaneInfo *)(wTheCall->self->ptr))->floating_size;
	wWrapPushObject( _wxSize, W_TRUE, (void *)floating_size );
}

%}
%method GetName wxAuiPaneInfo_GetName()
%method GetCaption wxAuiPaneInfo_GetCaption()
%method GetWindow wxAuiPaneInfo_GetWindow()
%method GetFrame wxAuiPaneInfo_GetFrame()
%method GetFloatingSize wxAuiPaneInfo_GetFloatingSize()
%method GetFloatingPos wxAuiPaneInfo_GetFloatingPos()

unsigned int state
int dock_direction
int dock_layer
int dock_row
int dock_pos
wxSize best_size
wxSize min_size
wxSize max_size
int dock_proportion
wxAuiPaneButtonArray buttons
wxRect rect

//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionFloating wxAuiPaneInfo::wxAuiPaneState::optionFloating
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionHidden wxAuiPaneInfo::wxAuiPaneState::optionHidden
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionLeftDockable wxAuiPaneInfo::wxAuiPaneState::optionLeftDockable
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionRightDockable wxAuiPaneInfo::wxAuiPaneState::optionRightDockable
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionTopDockable wxAuiPaneInfo::wxAuiPaneState::optionTopDockable
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionBottomDockable wxAuiPaneInfo::wxAuiPaneState::optionBottomDockable
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionFloatable wxAuiPaneInfo::wxAuiPaneState::optionFloatable
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionMovable wxAuiPaneInfo::wxAuiPaneState::optionMovable
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionResizable wxAuiPaneInfo::wxAuiPaneState::optionResizable
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionPaneBorder wxAuiPaneInfo::wxAuiPaneState::optionPaneBorder
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionCaption wxAuiPaneInfo::wxAuiPaneState::optionCaption
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionGripper wxAuiPaneInfo::wxAuiPaneState::optionGripper
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionDestroyOnClose wxAuiPaneInfo::wxAuiPaneState::optionDestroyOnClose
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionToolbar wxAuiPaneInfo::wxAuiPaneState::optionToolbar
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionActive wxAuiPaneInfo::wxAuiPaneState::optionActive
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionGripperTop wxAuiPaneInfo::wxAuiPaneState::optionGripperTop
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_optionMaximized wxAuiPaneInfo::wxAuiPaneState::optionMaximized
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_buttonClose wxAuiPaneInfo::wxAuiPaneState::buttonClose
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_buttonMaximize wxAuiPaneInfo::wxAuiPaneState::buttonMaximize
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_buttonMinimize wxAuiPaneInfo::wxAuiPaneState::buttonMinimize
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_buttonPin wxAuiPaneInfo::wxAuiPaneState::buttonPin
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_buttonCustom1 wxAuiPaneInfo::wxAuiPaneState::buttonCustom1
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_buttonCustom2 wxAuiPaneInfo::wxAuiPaneState::buttonCustom2
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_buttonCustom3 wxAuiPaneInfo::wxAuiPaneState::buttonCustom3
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_savedHiddenState wxAuiPaneInfo::wxAuiPaneState::savedHiddenState
//%not(gcc) %num %rename wxAuiPaneInfo_wxAuiPaneState_actionPane wxAuiPaneInfo::wxAuiPaneState::actionPane

%num %rename wxAuiPaneInfo_wxAuiPaneState_optionFloating 0x0001
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionHidden 0x0002
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionLeftDockable 0x0004
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionRightDockable 0x0008
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionTopDockable 0x0010
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionBottomDockable 0x0020
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionFloatable 0x0040
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionMovable 0x0080
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionResizable 0x0100
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionPaneBorder 0x0200
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionCaption 0x0400
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionGripper 0x0800
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionDestroyOnClose 0x01000
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionToolbar 0x02000
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionActive 0x04000
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionGripperTop 0x08000
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionMaximized 0x010000
%num %rename wxAuiPaneInfo_wxAuiPaneState_optionDockFixed 0x020000
//												         0x040000
//												         0x080000
//												         0x0100000
%num %rename wxAuiPaneInfo_wxAuiPaneState_buttonClose    0x0200000
%num %rename wxAuiPaneInfo_wxAuiPaneState_buttonMaximize 0x0400000
%num %rename wxAuiPaneInfo_wxAuiPaneState_buttonMinimize 0x0800000
%num %rename wxAuiPaneInfo_wxAuiPaneState_buttonPin 0x01000000
// 0x02000000
// 0x04000000
%num %rename wxAuiPaneInfo_wxAuiPaneState_buttonCustom1 0x04000000
%num %rename wxAuiPaneInfo_wxAuiPaneState_buttonCustom2 0x08000000
%num %rename wxAuiPaneInfo_wxAuiPaneState_buttonCustom3 0x010000000
// 0x020000000
%num %rename wxAuiPaneInfo_wxAuiPaneState_savedHiddenState 0x040000000
%num %rename wxAuiPaneInfo_wxAuiPaneState_actionPane 0x080000000

// ==============================
// Class: wxAuiFloatingFrame

%class wxAuiFloatingFrame
//, wxAuiFloatingFrameBaseClass
wxAuiFloatingFrame(wxWindow* parent, wxAuiManager* owner_mgr, const wxAuiPaneInfo& pane, wxWindowID id = wxID_ANY, long style = wxRESIZE_BORDER | wxSYSTEM_MENU | wxCAPTION | wxFRAME_NO_TASKBAR | wxFRAME_FLOAT_ON_PARENT | wxCLIP_CHILDREN)
void SetPaneWindow(const wxAuiPaneInfo& pane)
wxAuiManager* GetOwnerManager() const

// ==============================
// Class: wxAuiManager

%class %delete wxAuiPaneInfoArray
wxAuiPaneInfoArray()
%ctor wxAuiPaneInfoArrayCopy(const wxAuiPaneInfoArray& array)
//void Add(wxAuiPaneInfo pi)
void Add(wxAuiPaneInfo& pi)
void Clear()
int  GetCount() const
//int  Index(wxAuiPaneInfo* page)
//void Insert(wxAuiPaneInfo pi, int nIndex)
void Insert(wxAuiPaneInfo& pi, int nIndex)
bool IsEmpty()
wxAuiPaneInfo Item(size_t nIndex) const
void RemoveAt(size_t nIndex)

%class %delete wxAuiManager, wxEvtHandler
wxAuiManager(wxWindow* managed_wnd = NULL, unsigned int flags = wxAUI_MGR_DEFAULT)
void UnInit()
void SetFlags(unsigned int flags)
unsigned int GetFlags() const
void SetManagedWindow(wxWindow* managed_wnd)
wxWindow* GetManagedWindow() const
static wxAuiManager* GetManager(wxWindow* window)
void SetArtProvider(wxAuiDockArt* art_provider)
wxAuiDockArt* GetArtProvider() const
%rename GetPaneFromWindow wxAuiPaneInfo& GetPane(wxWindow* window)
%rename GetPaneFromName wxAuiPaneInfo& GetPane(const wxString& name)
wxAuiPaneInfo& GetPane(const wxString& name)
wxAuiPaneInfoArray& GetAllPanes()
bool AddPane(wxWindow* window, const wxAuiPaneInfo& pane_info)
%rename AddPaneWithDropPoint bool AddPane(wxWindow* window, const wxAuiPaneInfo& pane_info, const wxPoint& drop_pos)
%rename AddPaneWithDirection bool AddPane(wxWindow* window, int direction = wxLEFT, const wxString& caption = wxEmptyString)
bool InsertPane(wxWindow* window, const wxAuiPaneInfo& insert_location, int insert_level = wxAUI_INSERT_PANE)
bool DetachPane(wxWindow* window)
void Update()
wxString SavePaneInfo(wxAuiPaneInfo& pane)
void LoadPaneInfo(wxString pane_part, wxAuiPaneInfo &pane)
wxString SavePerspective()
bool LoadPerspective(const wxString& perspective, bool update = true)
void SetDockSizeConstraint(double width_pct, double height_pct)
void GetDockSizeConstraint(double* width_pct, double* height_pct) const
void ClosePane(wxAuiPaneInfo& pane_info)
void MaximizePane(wxAuiPaneInfo& pane_info)
void RestorePane(wxAuiPaneInfo& pane_info)
void RestoreMaximizedPane()
virtual wxAuiFloatingFrame* CreateFloatingFrame(wxWindow* parent, const wxAuiPaneInfo& p)
void StartPaneDrag(wxWindow* pane_window, const wxPoint& offset)
wxRect CalculateHintRect(wxWindow* pane_window, const wxPoint& pt, const wxPoint& offset)
void DrawHintRect(wxWindow* pane_window, const wxPoint& pt, const wxPoint& offset)
virtual void ShowHint(const wxRect& rect)
virtual void HideHint()
void OnRender(wxAuiManagerEvent& evt)
void OnPaneButton(wxAuiManagerEvent& evt)

// ==============================
// Class: wxAuiManagerEvent

%class %delete wxAuiManagerEvent, wxEvent
wxAuiManagerEvent(wxEventType type=wxEVT_NULL)
%ctor wxAuiManagerEventCopy(const wxAuiManagerEvent& c)
%not(bcc) wxEvent *Clone() const
void SetManager(wxAuiManager* mgr)
void SetPane(wxAuiPaneInfo* p)
void SetButton(int b)
void SetDC(wxDC* pdc)
wxAuiManager* GetManager() const
wxAuiPaneInfo* GetPane() const
int GetButton() const
wxDC* GetDC() const
void Veto(bool veto = true)
bool GetVeto() const
void SetCanVeto(bool can_veto)
bool CanVeto() const
wxAuiManager* manager
wxAuiPaneInfo* pane
int button
bool veto_flag
bool canveto_flag
wxDC* dc

%event wxEVT_AUI_PANE_BUTTON
%event wxEVT_AUI_PANE_CLOSE
%event wxEVT_AUI_PANE_MAXIMIZE
%event wxEVT_AUI_PANE_RESTORE
%event wxEVT_AUI_RENDER
%event wxEVT_AUI_FIND_MANAGER

// ==============================
// Class: wxAuiPaneButton

%class %delete wxAuiPaneButton
int button_id

// ==============================
// Class: wxAuiToolbar

%include <wx/aui/auibar.h>

%enum wxAuiToolBarStyle
    %num wxAUI_TB_TEXT
    %num wxAUI_TB_NO_TOOLTIPS
    %num wxAUI_TB_NO_AUTORESIZE
    %num wxAUI_TB_GRIPPER
    %num wxAUI_TB_OVERFLOW
    %num wxAUI_TB_VERTICAL
    %num wxAUI_TB_HORZ_LAYOUT
    %num wxAUI_TB_HORZ_TEXT
    %num wxAUI_TB_DEFAULT_STYLE

%enum wxAuiToolBarArtSetting
    %num wxAUI_TBART_SEPARATOR_SIZE
    %num wxAUI_TBART_GRIPPER_SIZE
    %num wxAUI_TBART_OVERFLOW_SIZE

%enum wxAuiToolBarToolTextOrientation
    %num wxAUI_TBTOOL_TEXT_LEFT
    %num wxAUI_TBTOOL_TEXT_RIGHT
    %num wxAUI_TBTOOL_TEXT_TOP
    %num wxAUI_TBTOOL_TEXT_BOTTOM

%class wxAuiToolBarEvent, wxNotifyEvent
wxAuiToolBarEvent(wxEventType command_type = wxEVT_NULL, int win_id = 0)
%ctor wxAuiToolBarEventCopy(const wxAuiToolBarEvent& c)
%not(bcc) wxEvent *Clone() const

bool IsDropDownClicked() const
void SetDropDownClicked(bool c)
wxPoint GetClickPoint() const
void SetClickPoint(const wxPoint& p)
wxRect GetItemRect() const
void SetItemRect(const wxRect& r)
int GetToolId() const
void SetToolId(int id)

%event wxEVT_COMMAND_AUITOOLBAR_TOOL_DROPDOWN
%event wxEVT_COMMAND_AUITOOLBAR_OVERFLOW_CLICK
%event wxEVT_COMMAND_AUITOOLBAR_RIGHT_CLICK
%event wxEVT_COMMAND_AUITOOLBAR_MIDDLE_CLICK
%event wxEVT_COMMAND_AUITOOLBAR_BEGIN_DRAG

%class wxAuiToolBarItem
wxAuiToolBarItem()
%ctor wxAuiToolBarItemCopy(const wxAuiToolBarItem& c)
void Assign(const wxAuiToolBarItem& c)
void SetWindow(wxWindow* w)
wxWindow* GetWindow()

void SetId(int new_id)
int GetId() const

void SetKind(int new_kind)
int GetKind() const

void SetState(int new_state)
int GetState() const

void SetSizerItem(wxSizerItem* s)
wxSizerItem* GetSizerItem() const

void SetLabel(const wxString& s)
const wxString& GetLabel() const

void SetBitmap(const wxBitmap& bmp)
const wxBitmap& GetBitmap() const

void SetDisabledBitmap(const wxBitmap& bmp)
const wxBitmap& GetDisabledBitmap() const

void SetHoverBitmap(const wxBitmap& bmp)
const wxBitmap& GetHoverBitmap() const

void SetShortHelp(const wxString& s)
const wxString& GetShortHelp() const

void SetLongHelp(const wxString& s)
const wxString& GetLongHelp() const

void SetMinSize(const wxSize& s)
const wxSize& GetMinSize() const

void SetSpacerPixels(int s)
int GetSpacerPixels() const

void SetProportion(int p)
int GetProportion() const

void SetActive(bool b)
bool IsActive() const

void SetHasDropDown(bool b)
bool HasDropDown() const

void SetSticky(bool b)
bool IsSticky() const

void SetUserData(long l)
long GetUserData() const

%class wxAuiToolBarItemArray
wxAuiToolBarItemArray()
void Empty()
void Clear()
void Shrink()
size_t GetCount() const
bool IsEmpty() const
size_t Count() const
wxAuiToolBarItem Item(size_t nIndex) const
wxAuiToolBarItem Last() const
void Add(const wxAuiToolBarItem& item, size_t nInsert = 1)
%rename AddItem void Add(wxAuiToolBarItem* item)
void Insert(const wxAuiToolBarItem& item, size_t uiIndex, size_t nInsert = 1)
void RemoveAt(size_t nIndex, size_t nRemove = 1)

//int Index(const wxChar * sz, bool bCase = true, bool bFromEnd = false)
//void Remove(const wxChar *sz)
//void Sort(bool reverseOrder = false)

// tab art class

%class wxAuiToolBarArt
// Abstract class
//wxAuiToolBarArt()
// virtual ~wxAuiToolBarArt()

virtual wxAuiToolBarArt* Clone()
virtual void SetFlags(unsigned int flags)
virtual void SetFont(const wxFont& font)
virtual void SetTextOrientation(int orientation)

virtual void DrawBackground(wxDC& dc, wxWindow* wnd, const wxRect& rect)
virtual void DrawLabel(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item, const wxRect& rect)
virtual void DrawButton(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item, const wxRect& rect)
virtual void DrawDropDownButton(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item, const wxRect& rect)
virtual void DrawControlLabel(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item, const wxRect& rect)
virtual void DrawSeparator(wxDC& dc, wxWindow* wnd, const wxRect& rect)
virtual void DrawGripper(wxDC& dc, wxWindow* wnd, const wxRect& rect)
virtual void DrawOverflowButton(wxDC& dc, wxWindow* wnd, const wxRect& rect, int state)
virtual wxSize GetLabelSize(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item)
virtual wxSize GetToolSize(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item)
virtual int GetElementSize(int element_id)
virtual void SetElementSize(int element_id, int size)
virtual int ShowDropDown(wxWindow* wnd, const wxAuiToolBarItemArray& items)

%class wxAuiDefaultToolBarArt, wxAuiToolBarArt
wxAuiDefaultToolBarArt()
//virtual ~wxAuiDefaultToolBarArt()

virtual wxAuiToolBarArt* Clone()
virtual void SetFlags(unsigned int flags)
virtual void SetFont(const wxFont& font)
virtual void SetTextOrientation(int orientation)
virtual void DrawBackground(wxDC& dc, wxWindow* wnd, const wxRect& rect)

virtual void DrawLabel(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item, const wxRect& rect)
virtual void DrawButton(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item, const wxRect& rect)
virtual void DrawDropDownButton(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item, const wxRect& rect)
virtual void DrawControlLabel(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item, const wxRect& rect)
virtual void DrawSeparator(wxDC& dc, wxWindow* wnd, const wxRect& rect)
virtual void DrawGripper(wxDC& dc, wxWindow* wnd, const wxRect& rect)
virtual void DrawOverflowButton(wxDC& dc, wxWindow* wnd, const wxRect& rect, int state)
virtual wxSize GetLabelSize(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item)
virtual wxSize GetToolSize(wxDC& dc, wxWindow* wnd, const wxAuiToolBarItem& item)
virtual int GetElementSize(int element)
virtual void SetElementSize(int element_id, int size)
virtual int ShowDropDown(wxWindow* wnd, const wxAuiToolBarItemArray& items)

%class wxAuiToolBar, wxControl
wxAuiToolBar(wxWindow* parent, wxWindowID id = -1, const wxPoint& position = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxAUI_TB_DEFAULT_STYLE)
// ~wxAuiToolBar();

void SetWindowStyleFlag(long style)

void SetArtProvider(wxAuiToolBarArt* art)
wxAuiToolBarArt* GetArtProvider() const

bool SetFont(const wxFont& font)

void AddTool(int tool_id, const wxString& label, const wxBitmap& bitmap, const wxString& short_help_string = wxEmptyString, wxItemKind kind = wxITEM_NORMAL)
%rename AddToolWithData void AddTool(int tool_id, const wxString& label, const wxBitmap& bitmap, const wxBitmap& disabled_bitmap, wxItemKind kind, const wxString& short_help_string, const wxString& long_help_string, wxObject* client_data)
%rename AddToolWithBitmap void AddTool(int tool_id, const wxBitmap& bitmap, const wxBitmap& disabled_bitmap, bool toggle = false, wxObject* client_data = NULL, const wxString& short_help_string = wxEmptyString, const wxString& long_help_string = wxEmptyString)

void AddLabel(int tool_id, const wxString& label = wxEmptyString, const int width = -1)
void AddControl(wxControl* control, const wxString& label = wxEmptyString)
void AddSeparator()
void AddSpacer(int pixels)
void AddStretchSpacer(int proportion = 1)

bool Realize()

wxControl* FindControl(int window_id)
wxAuiToolBarItem* FindToolByPosition(wxCoord x, wxCoord y) const
wxAuiToolBarItem* FindToolByIndex(int idx) const
wxAuiToolBarItem* FindTool(int tool_id) const

void ClearTools()
void Clear()
bool DeleteTool(int tool_id)
bool DeleteByIndex(int tool_id)

size_t GetToolCount() const
int GetToolPos(int tool_id) const
int GetToolIndex(int tool_id) const
bool GetToolFits(int tool_id) const
wxRect GetToolRect(int tool_id) const
bool GetToolFitsByIndex(int tool_id) const
bool GetToolBarFits() const

%rename SetMarginsSize void SetMargins(const wxSize& size)
void SetMargins(int x, int y)
%rename SetMarginsAll void SetMargins(int left, int right, int top, int bottom)

void SetToolBitmapSize(const wxSize& size)
wxSize GetToolBitmapSize() const

bool GetOverflowVisible() const
void SetOverflowVisible(bool visible)

bool GetGripperVisible() const
void SetGripperVisible(bool visible)

void ToggleTool(int tool_id, bool state)
bool GetToolToggled(int tool_id) const

void EnableTool(int tool_id, bool state)
bool GetToolEnabled(int tool_id) const

void SetToolDropDown(int tool_id, bool dropdown)
bool GetToolDropDown(int tool_id) const

void SetToolBorderPadding(int padding)
int  GetToolBorderPadding() const

void SetToolTextOrientation(int orientation)
int  GetToolTextOrientation() const

void SetToolPacking(int packing)
int  GetToolPacking() const

void SetToolProportion(int tool_id, int proportion)
int  GetToolProportion(int tool_id) const

void SetToolSeparation(int separation)
int GetToolSeparation() const

void SetToolSticky(int tool_id, bool sticky)
bool GetToolSticky(int tool_id) const

wxString GetToolLabel(int tool_id) const
void SetToolLabel(int tool_id, const wxString& label)

wxBitmap GetToolBitmap(int tool_id) const
void SetToolBitmap(int tool_id, const wxBitmap& bitmap)

wxString GetToolShortHelp(int tool_id) const
void SetToolShortHelp(int tool_id, const wxString& help_string)

wxString GetToolLongHelp(int tool_id) const
void SetToolLongHelp(int tool_id, const wxString& help_string)

void SetCustomOverflowItems(const wxAuiToolBarItemArray& prepend, const wxAuiToolBarItemArray& append)

///////////////////////////////////////////////////////////////////////////////
// wxRichText Support
///////////////////////////////////////////////////////////////////////////////

// #########################################################
// richtextbuffer.h

%include <wx/richtext/richtextbuffer.h>

%builtin const wxChar wxRichTextLineBreakChar
%num wxRICHTEXT_TYPE_ANY
%num wxRICHTEXT_TYPE_TEXT
%num wxRICHTEXT_TYPE_XML
%num wxRICHTEXT_TYPE_HTML
%num wxRICHTEXT_TYPE_RTF
%num wxRICHTEXT_TYPE_PDF
%num wxRICHTEXT_FIXED_WIDTH
%num wxRICHTEXT_FIXED_HEIGHT
%num wxRICHTEXT_VARIABLE_WIDTH
%num wxRICHTEXT_VARIABLE_HEIGHT
%num wxRICHTEXT_LAYOUT_SPECIFIED_RECT
%num wxRICHTEXT_DRAW_IGNORE_CACHE
%num wxRICHTEXT_HITTEST_NONE
%num wxRICHTEXT_HITTEST_BEFORE
%num wxRICHTEXT_HITTEST_AFTER
%num wxRICHTEXT_HITTEST_ON
%num wxRICHTEXT_HITTEST_OUTSIDE
%num wxRICHTEXT_FORMATTED
%num wxRICHTEXT_UNFORMATTED
%num wxRICHTEXT_SETSTYLE_NONE
%num wxRICHTEXT_SETSTYLE_WITH_UNDO
%num wxRICHTEXT_SETSTYLE_OPTIMIZE
%num wxRICHTEXT_SETSTYLE_PARAGRAPHS_ONLY
%num wxRICHTEXT_SETSTYLE_CHARACTERS_ONLY
%num wxRICHTEXT_SETSTYLE_RENUMBER
%num wxRICHTEXT_SETSTYLE_SPECIFY_LEVEL
%num wxRICHTEXT_SETSTYLE_RESET
%num wxRICHTEXT_SETSTYLE_REMOVE
%num wxRICHTEXT_INSERT_NONE
%num wxRICHTEXT_INSERT_WITH_PREVIOUS_PARAGRAPH_STYLE
%num wxTEXT_ATTR_PARA_SPACING_AFTER
%num wxTEXT_ATTR_PARA_SPACING_BEFORE
%num wxTEXT_ATTR_LINE_SPACING
%num wxTEXT_ATTR_CHARACTER_STYLE_NAME
%num wxTEXT_ATTR_PARAGRAPH_STYLE_NAME
%num wxTEXT_ATTR_LIST_STYLE_NAME
%num wxTEXT_ATTR_BULLET_STYLE
%num wxTEXT_ATTR_BULLET_NUMBER
%num wxTEXT_ATTR_BULLET_TEXT
%num wxTEXT_ATTR_BULLET_NAME
%num wxTEXT_ATTR_URL
%num wxTEXT_ATTR_PAGE_BREAK
%num wxTEXT_ATTR_EFFECTS
%num wxTEXT_ATTR_OUTLINE_LEVEL
%num wxTEXT_ATTR_BULLET_STYLE_NONE
%num wxTEXT_ATTR_BULLET_STYLE_ARABIC
%num wxTEXT_ATTR_BULLET_STYLE_LETTERS_UPPER
%num wxTEXT_ATTR_BULLET_STYLE_LETTERS_LOWER
%num wxTEXT_ATTR_BULLET_STYLE_ROMAN_UPPER
%num wxTEXT_ATTR_BULLET_STYLE_ROMAN_LOWER
%num wxTEXT_ATTR_BULLET_STYLE_SYMBOL
%num wxTEXT_ATTR_BULLET_STYLE_BITMAP
%num wxTEXT_ATTR_BULLET_STYLE_PARENTHESES
%num wxTEXT_ATTR_BULLET_STYLE_PERIOD
%num wxTEXT_ATTR_BULLET_STYLE_STANDARD
%num wxTEXT_ATTR_BULLET_STYLE_RIGHT_PARENTHESIS
%num wxTEXT_ATTR_BULLET_STYLE_OUTLINE
%num wxTEXT_ATTR_BULLET_STYLE_ALIGN_LEFT
%num wxTEXT_ATTR_BULLET_STYLE_ALIGN_RIGHT
%num wxTEXT_ATTR_BULLET_STYLE_ALIGN_CENTRE
%num wxTEXT_ATTR_EFFECT_NONE
%num wxTEXT_ATTR_EFFECT_CAPITALS
%num wxTEXT_ATTR_EFFECT_SMALL_CAPITALS
%num wxTEXT_ATTR_EFFECT_STRIKETHROUGH
%num wxTEXT_ATTR_EFFECT_DOUBLE_STRIKETHROUGH
%num wxTEXT_ATTR_EFFECT_SHADOW
%num wxTEXT_ATTR_EFFECT_EMBOSS
%num wxTEXT_ATTR_EFFECT_OUTLINE
%num wxTEXT_ATTR_EFFECT_ENGRAVE
%num wxTEXT_ATTR_EFFECT_SUPERSCRIPT
%num wxTEXT_ATTR_EFFECT_SUBSCRIPT
%num wxTEXT_ATTR_LINE_SPACING_NORMAL
%num wxTEXT_ATTR_LINE_SPACING_HALF
%num wxTEXT_ATTR_LINE_SPACING_TWICE
%num wxTEXT_ATTR_CHARACTER
%num wxTEXT_ATTR_PARAGRAPH
%num wxTEXT_ATTR_ALL

// ==============================
// Class: wxRichTextRange

%class %delete wxRichTextRange
%ctor wxRichTextRangeEmpty()
wxRichTextRange(long start, long end)
%ctor wxRichTextRangeCopy(const wxRichTextRange& range)
void SetRange(long start, long end)
void SetStart(long start)
long GetStart() const
void SetEnd(long end)
long GetEnd() const
bool IsOutside(const wxRichTextRange& range) const
bool IsWithin(const wxRichTextRange& range) const
bool Contains(long pos) const
bool LimitTo(const wxRichTextRange& range)
long GetLength() const
void Swap()
wxRichTextRange ToInternal() const
wxRichTextRange FromInternal() const
// ==============================
// Class: wxTextAttrEx

%class %delete wxTextAttrEx, wxTextAttr
%ctor wxTextAttrExCopy(const wxTextAttrEx& attr)
//wxTextAttrEx(const wxTextAttr& attr)
wxTextAttrEx()
void Init()
void Copy(const wxTextAttrEx& attr)
void SetCharacterStyleName(const wxString& name)
void SetParagraphStyleName(const wxString& name)
void SetListStyleName(const wxString& name)
void SetParagraphSpacingAfter(int spacing)
void SetParagraphSpacingBefore(int spacing)
void SetLineSpacing(int spacing)
void SetBulletStyle(int style)
void SetBulletNumber(int n)
void SetBulletText(const wxString& text)
void SetBulletName(const wxString& name)
void SetBulletFont(const wxString& bulletFont)
void SetURL(const wxString& url)
void SetPageBreak(bool pageBreak = true)
void SetTextEffects(int effects)
void SetTextEffectFlags(int effects)
void SetOutlineLevel(int level)
const wxString& GetCharacterStyleName() const
const wxString& GetParagraphStyleName() const
const wxString& GetListStyleName() const
int GetParagraphSpacingAfter() const
int GetParagraphSpacingBefore() const
int GetLineSpacing() const
int GetBulletStyle() const
int GetBulletNumber() const
const wxString& GetBulletText() const
const wxString& GetBulletName() const
const wxString& GetBulletFont() const
const wxString& GetURL() const
int GetTextEffects() const
int GetTextEffectFlags() const
int GetOutlineLevel() const
bool HasFontWeight() const
bool HasFontSize() const
bool HasFontItalic() const
bool HasFontUnderlined() const
bool HasFontFaceName() const
bool HasParagraphSpacingAfter() const
bool HasParagraphSpacingBefore() const
bool HasLineSpacing() const
bool HasCharacterStyleName() const
bool HasParagraphStyleName() const
bool HasListStyleName() const
bool HasBulletStyle() const
bool HasBulletNumber() const
bool HasBulletText() const
bool HasBulletName() const
bool HasURL() const
bool HasPageBreak() const
bool HasTextEffects() const
bool HasTextEffect(int effect) const
bool HasOutlineLevel() const
bool IsCharacterStyle() const
bool IsParagraphStyle() const
bool IsDefault() const
static wxTextAttrEx CombineEx(const wxTextAttrEx& attr, const wxTextAttrEx& attrDef, const wxTextCtrlBase *text)

///////////////////////////////////////////////////////////////////////////////
// wxRichTextAttr

%include <wx/richtext/richtextbuffer.h>
%class %delete wxRichTextAttr
%ctor wxRichTextAttrEmpty()
%ctor wxRichTextAttrCopy(const wxRichTextAttr& attr)
%ctor wxRichTextAttrCopyTextAttrEx(const wxTextAttrEx& attr)
wxRichTextAttr(const wxColour& colText, const wxColour& colBack = wxNullColour, wxTextAttrAlignment alignment = wxTEXT_ALIGNMENT_DEFAULT)

//%rename CanCombine bool Combine(const wxRichTextAttrEx& style, const wxRichTextAttrEx* compareWith = NULL)
//wxRichTextAttr  Combine(const wxRichTextAttrEx& style, const wxRichTextAttrEx* compareWith = NULL) const

%{
	void wxRichTextAttr_GetTextAttrEx()
	{
		wxTextAttrEx* returns = new wxTextAttrEx( *((wxRichTextAttr *)wTheCall->self->ptr) );
		wWrapPushObject( _wxTextAttrEx, W_TRUE, (void *)returns );
	}
%}
%method GetTextAttrEx wxRichTextAttr_GetTextAttrEx()

wxFont  CreateFont() const
wxTextAttrAlignment GetAlignment() const
const wxColour&  GetBackgroundColour() const
const wxString&  GetBulletFont() const
const wxString&  GetBulletName() const
int GetBulletNumber() const
int GetBulletStyle() const
const wxString&  GetBulletText() const
const wxString&  GetCharacterStyleName() const
long GetFlags() const
bool GetFontAttributes(const wxFont& font)
const wxString&  GetFontFaceName() const
int GetFontSize() const
int GetFontStyle() const
bool GetFontUnderlined() const
int GetFontWeight() const
long GetLeftIndent() const
long GetLeftSubIndent() const
int GetLineSpacing() const
const wxString&  GetListStyleName() const
bool GetOutlineLevel() const
int GetParagraphSpacingAfter() const
int GetParagraphSpacingBefore() const
const wxString&  GetParagraphStyleName() const
long GetRightIndent() const
const wxArrayInt& GetTabs() const
const wxColour&  GetTextColour() const
int GetTextEffectFlags() const
int GetTextEffects() const
const wxString&  GetURL() const
bool HasAlignment() const
bool HasBackgroundColour() const
bool HasBulletName() const
bool HasBulletNumber() const
bool HasBulletStyle() const
bool HasBulletText() const
bool HasCharacterStyleName() const
bool HasFontFaceName() const
bool HasFlag(long flag) const
bool HasFont() const
bool HasFontItalic() const
bool HasLeftIndent() const
bool HasLineSpacing() const
bool HasListStyleName() const
bool HasOutlineLevel() const
bool HasPageBreak() const
bool HasParagraphSpacingAfter() const
bool HasParagraphSpacingBefore() const
bool HasParagraphStyleName() const
bool HasRightIndent() const
bool HasFontSize() const
bool HasTabs() const
bool HasTextColour() const
bool HasTextEffects() const
bool HasFontUnderlined() const
bool HasURL() const
bool HasFontWeight() const
bool IsCharacterStyle() const
bool IsDefault() const
bool IsParagraphStyle() const
void SetAlignment(wxTextAttrAlignment alignment)
void SetBackgroundColour(const wxColour& colBack)
void SetBulletFont(const wxString& font)
void SetBulletName(const wxString& name)
void SetBulletNumber(int n)
void SetBulletStyle(int style)
void SetBulletText(const wxString& text)
void SetCharacterStyleName(const wxString& name)
void SetFlags(long flags)
void SetFontFaceName(const wxString& faceName)
void SetFontSize(int pointSize)
void SetFontStyle(int fontStyle)
void SetFontUnderlined(bool underlined)
void SetFontWeight(int fontWeight)
void SetLeftIndent(int indent, int subIndent = 0)
void SetLineSpacing(int spacing)
void SetListStyleName(const wxString& name)
void SetOutlineLevel(int level)
void SetPageBreak(bool pageBreak = true)
void SetParagraphSpacingAfter(int spacing)
void SetParagraphSpacingBefore(int spacing)
void SetParagraphStyleName(const wxString& name)
void SetRightIndent(int indent)
void SetTabs(const wxArrayInt& tabs)
void SetTextColour(const wxColour& colText)
void SetTextEffectFlags(int flags)
void SetTextEffects(int effects)
void SetURL(const wxString& url)

// ==============================
// Class: wxRichTextObject

%class %delete wxRichTextObject, wxObject
//Abstract class
//wxRichTextObject(wxRichTextObject* parent = NULL)
virtual bool Draw(wxDC& dc, const wxRichTextRange& range, const wxRichTextRange& selectionRange, const wxRect& rect, int descent, int style)
virtual bool Layout(wxDC& dc, const wxRect& rect, int style)
virtual int HitTest(wxDC& dc, const wxPoint& pt, long& textPosition)
virtual bool FindPosition(wxDC& dc, long index, wxPoint& pt, int* height, bool forceLineStart)
virtual wxSize GetBestSize() const
//TODO: need wrapper
//virtual bool GetRangeSize(const wxRichTextRange& range, wxSize& size, int& descent, wxDC& dc, int flags, wxPoint position = wxPoint(0,0)) const
virtual wxRichTextObject* DoSplit(long pos)
virtual void CalculateRange(long start, long& end)
virtual bool DeleteRange(const wxRichTextRange& range)
virtual bool IsEmpty() const
virtual wxString GetTextForRange(const wxRichTextRange& range) const
virtual bool CanMerge(wxRichTextObject* object) const
virtual bool Merge(wxRichTextObject* object)
//TODO: define wxTextOutputStream
//virtual void Dump(wxTextOutputStream& stream)
virtual wxSize GetCachedSize() const
virtual void SetCachedSize(const wxSize& sz)
virtual wxPoint GetPosition() const
virtual void SetPosition(const wxPoint& pos)
virtual wxRect GetRect() const
void SetRange(const wxRichTextRange& range)
//const wxRichTextRange& GetRange() const
wxRichTextRange& GetRange()
virtual bool GetDirty() const
virtual void SetDirty(bool dirty)
virtual bool IsComposite() const
virtual wxRichTextObject* GetParent() const
virtual void SetParent(wxRichTextObject* parent)
//virtual void SetMargins(int margin)
virtual void SetMargins(int leftMargin, int rightMargin, int topMargin, int bottomMargin)
virtual int GetLeftMargin() const
virtual int GetRightMargin() const
virtual int GetTopMargin() const
virtual int GetBottomMargin() const
void SetAttributes(const wxTextAttrEx& attr)
//const wxTextAttrEx& GetAttributes() const
wxTextAttrEx& GetAttributes()
void SetDescent(int descent)
int GetDescent() const
wxRichTextBuffer* GetBuffer() const
virtual wxRichTextObject* Clone() const
void Copy(const wxRichTextObject& obj)
void Reference()
void Dereference()
int ConvertTenthsMMToPixels(wxDC& dc, int units)

%builtin %rename ConvertTenthsMMToPixels int wxRichTextObject::ConvertTenthsMMToPixels(int ppi, int units)

// ==============================
// Class: wxRichTextCompositeObject

%class wxRichTextObjectList, wxList

%class wxRichTextCompositeObject, wxRichTextObject
//Abstract class
//wxRichTextCompositeObject(wxRichTextObject* parent = NULL)
virtual int HitTest(wxDC& dc, const wxPoint& pt, long& textPosition)
virtual bool FindPosition(wxDC& dc, long index, wxPoint& pt, int* height, bool forceLineStart)
virtual void CalculateRange(long start, long& end)
virtual bool DeleteRange(const wxRichTextRange& range)
virtual wxString GetTextForRange(const wxRichTextRange& range) const
//TODO
//virtual void Dump(wxTextOutputStream& stream)
wxRichTextObjectList& GetChildren()
//const wxRichTextObjectList& GetChildren() const
size_t GetChildCount() const
wxRichTextObject* GetChild(size_t n) const
virtual bool GetDirty() const
virtual void SetDirty(bool dirty)
virtual bool IsComposite() const
virtual bool IsEmpty() const
void Copy(const wxRichTextCompositeObject& obj)
size_t AppendChild(wxRichTextObject* child)
bool InsertChild(wxRichTextObject* child, wxRichTextObject* inFrontOf)
bool RemoveChild(wxRichTextObject* child, bool deleteChild = false)
bool DeleteChildren()
bool Defragment()

// ==============================
// Class: wxRichTextBox

%class %delete wxRichTextBox, wxRichTextCompositeObject
wxRichTextBox(wxRichTextObject* parent = NULL)
%ctor wxRichTextBoxCopy(const wxRichTextBox& obj)
virtual bool Draw(wxDC& dc, const wxRichTextRange& range, const wxRichTextRange& selectionRange, const wxRect& rect, int descent, int style)
virtual bool Layout(wxDC& dc, const wxRect& rect, int style)
//TODO: needs wrapper
//virtual bool GetRangeSize(const wxRichTextRange& range, wxSize& size, int& descent, wxDC& dc, int flags, wxPoint position = wxPoint(0,0)) const
virtual wxRichTextObject* Clone() const
void Copy(const wxRichTextBox& obj)

// ==============================
// Class: wxRichTextParagraphLayoutBox

%class %delete wxRichTextParagraphLayoutBox, wxRichTextBox
wxRichTextParagraphLayoutBox(wxRichTextObject* parent = NULL)
%ctor wxRichTextParagraphLayoutBoxCopy(const wxRichTextParagraphLayoutBox& obj)
virtual bool Draw(wxDC& dc, const wxRichTextRange& range, const wxRichTextRange& selectionRange, const wxRect& rect, int descent, int style)
virtual bool Layout(wxDC& dc, const wxRect& rect, int style)
//TODO: needs wrapper
//virtual bool GetRangeSize(const wxRichTextRange& range, wxSize& size, int& descent, wxDC& dc, int flags, wxPoint position = wxPoint(0,0)) const
virtual bool DeleteRange(const wxRichTextRange& range)
virtual wxString GetTextForRange(const wxRichTextRange& range) const
void SetRichTextCtrl(wxRichTextCtrl* ctrl)
wxRichTextCtrl* GetRichTextCtrl() const
void SetPartialParagraph(bool partialPara)
bool GetPartialParagraph() const
virtual wxRichTextStyleSheet* GetStyleSheet() const
void Init()
virtual void Clear()
virtual void Reset()
virtual wxRichTextRange AddParagraph(const wxString& text, wxTextAttrEx* paraStyle = NULL)
virtual wxRichTextRange AddImage(const wxImage& image, wxTextAttrEx* paraStyle = NULL)
virtual wxRichTextRange AddParagraphs(const wxString& text, wxTextAttrEx* paraStyle = NULL)
virtual wxRichTextLine* GetLineAtPosition(long pos, bool caretPosition = false) const
virtual wxRichTextLine* GetLineAtYPosition(int y) const
virtual wxRichTextParagraph* GetParagraphAtPosition(long pos, bool caretPosition = false) const
virtual wxSize GetLineSizeAtPosition(long pos, bool caretPosition = false) const
virtual long GetVisibleLineNumber(long pos, bool caretPosition = false, bool startOfLine = false) const
virtual wxRichTextLine* GetLineForVisibleLineNumber(long lineNumber) const
virtual wxRichTextObject* GetLeafObjectAtPosition(long position) const
virtual wxRichTextParagraph* GetParagraphAtLine(long paragraphNumber) const
virtual wxRichTextParagraph* GetParagraphForLine(wxRichTextLine* line) const
virtual int GetParagraphLength(long paragraphNumber) const
virtual int GetParagraphCount() const
virtual int GetLineCount() const
virtual wxString GetParagraphText(long paragraphNumber) const
virtual long XYToPosition(long x, long y) const
virtual bool PositionToXY(long pos, long* x, long* y) const
virtual bool SetStyle(const wxRichTextRange& range, const wxRichTextAttr& style, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO)
//virtual bool SetStyle(const wxRichTextRange& range, const wxTextAttrEx& style, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO)
//virtual bool GetStyle(long position, wxTextAttrEx& style)
virtual bool GetStyle(long position, wxRichTextAttr& style)
//virtual bool GetUncombinedStyle(long position, wxTextAttrEx& style)
virtual bool GetUncombinedStyle(long position, wxRichTextAttr& style)
virtual bool DoGetStyle(long position, wxTextAttrEx& style, bool combineStyles = true)
virtual bool GetStyleForRange(const wxRichTextRange& range, wxTextAttrEx& style)
bool CollectStyle(wxTextAttrEx& currentStyle, const wxTextAttrEx& style, long& multipleStyleAttributes, int& multipleTextEffectAttributes)
virtual bool SetListStyle(const wxRichTextRange& range, wxRichTextListStyleDefinition* def, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom = 1, int specifiedLevel = -1)
%rename SetListStyleByName virtual bool SetListStyle(const wxRichTextRange& range, const wxString& defName, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom = 1, int specifiedLevel = -1)
virtual bool ClearListStyle(const wxRichTextRange& range, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO)
virtual bool NumberList(const wxRichTextRange& range, wxRichTextListStyleDefinition* def = NULL, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom = 1, int specifiedLevel = -1)
%rename NumberListByName virtual bool NumberList(const wxRichTextRange& range, const wxString& defName, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom = 1, int specifiedLevel = -1)
virtual bool PromoteList(int promoteBy, const wxRichTextRange& range, wxRichTextListStyleDefinition* def = NULL, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int specifiedLevel = -1)
%rename PromoteListByName virtual bool PromoteList(int promoteBy, const wxRichTextRange& range, const wxString& defName, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int specifiedLevel = -1)
virtual bool DoNumberList(const wxRichTextRange& range, const wxRichTextRange& promotionRange, int promoteBy, wxRichTextListStyleDefinition* def, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom = 1, int specifiedLevel = -1)
virtual bool FindNextParagraphNumber(wxRichTextParagraph* previousParagraph, wxRichTextAttr& attr) const
//virtual bool HasCharacterAttributes(const wxRichTextRange& range, const wxTextAttrEx& style) const
virtual bool HasCharacterAttributes(const wxRichTextRange& range, const wxRichTextAttr& style) const
//virtual bool HasParagraphAttributes(const wxRichTextRange& range, const wxTextAttrEx& style) const
virtual bool HasParagraphAttributes(const wxRichTextRange& range, const wxRichTextAttr& style) const
virtual wxRichTextObject* Clone() const
virtual bool InsertFragment(long position, wxRichTextParagraphLayoutBox& fragment)
virtual bool CopyFragment(const wxRichTextRange& range, wxRichTextParagraphLayoutBox& fragment)
virtual bool ApplyStyleSheet(wxRichTextStyleSheet* styleSheet)
void Copy(const wxRichTextParagraphLayoutBox& obj)
virtual void UpdateRanges()
virtual wxString GetText() const
virtual bool SetDefaultStyle(const wxTextAttrEx& style)
virtual const wxTextAttrEx& GetDefaultStyle() const
//virtual void SetBasicStyle(const wxTextAttrEx& style)
virtual void SetBasicStyle(const wxRichTextAttr& style)
virtual const wxTextAttrEx& GetBasicStyle() const
void Invalidate(const wxRichTextRange& invalidRange = wxRICHTEXT_ALL)
wxRichTextRange GetInvalidRange(bool wholeParagraphs = false) const

// ==============================
// Class: wxRichTextLine

%class wxRichTextLineList, wxList

%class %delete wxRichTextLine
wxRichTextLine(wxRichTextParagraph* parent)
%ctor wxRichTextLineCopy(const wxRichTextLine& obj)
//void SetRange(const wxRichTextRange& range)
void SetRange(long from, long to)
wxRichTextParagraph* GetParent()
//const wxRichTextRange& GetRange() const
wxRichTextRange& GetRange()
wxRichTextRange GetAbsoluteRange() const
virtual wxSize GetSize() const
virtual void SetSize(const wxSize& sz)
virtual wxPoint GetPosition() const
virtual void SetPosition(const wxPoint& pos)
virtual wxPoint GetAbsolutePosition() const
virtual wxRect GetRect() const
void SetDescent(int descent)
int GetDescent() const
void Init(wxRichTextParagraph* parent)
void Copy(const wxRichTextLine& obj)
virtual wxRichTextLine* Clone() const

// ==============================
// Class: wxRichTextParagraph

%class %delete wxRichTextParagraph, wxRichTextBox
wxRichTextParagraph(wxRichTextObject* parent = NULL, wxTextAttrEx* style = NULL)
%ctor wxRichTextParagraphText(const wxString& text, wxRichTextObject* parent = NULL, wxTextAttrEx* paraStyle = NULL, wxTextAttrEx* charStyle = NULL)
%ctor wxRichTextParagraphCopy(const wxRichTextParagraph& obj)
virtual bool Draw(wxDC& dc, const wxRichTextRange& range, const wxRichTextRange& selectionRange, const wxRect& rect, int descent, int style)
virtual bool Layout(wxDC& dc, const wxRect& rect, int style)
//TODO: needs wrapper
//virtual bool GetRangeSize(const wxRichTextRange& range, wxSize& size, int& descent, wxDC& dc, int flags, wxPoint position = wxPoint(0,0)) const
virtual bool FindPosition(wxDC& dc, long index, wxPoint& pt, int* height, bool forceLineStart)
virtual int HitTest(wxDC& dc, const wxPoint& pt, long& textPosition)
virtual void CalculateRange(long start, long& end)
wxRichTextLineList& GetLines()
void Copy(const wxRichTextParagraph& obj)
virtual wxRichTextObject* Clone() const
void ClearLines()
virtual void ApplyParagraphStyle(const wxTextAttrEx& attr, const wxRect& rect)
virtual bool InsertText(long pos, const wxString& text)
virtual wxRichTextObject* SplitAt(long pos, wxRichTextObject** previousObject = NULL)
virtual void MoveToList(wxRichTextObject* obj, wxList& list)
virtual void MoveFromList(wxList& list)
bool GetContiguousPlainText(wxString& text, const wxRichTextRange& range, bool fromStart = true)
bool FindWrapPosition(const wxRichTextRange& range, wxDC& dc, int availableSpace, long& wrapPosition)
wxRichTextObject* FindObjectAtPosition(long position)
wxString GetBulletText()
wxRichTextLine* AllocateLine(int pos)
bool ClearUnusedLines(int lineCount)
wxTextAttrEx GetCombinedAttributes(const wxTextAttrEx& contentStyle) const
//wxTextAttrEx GetCombinedAttributes() const
long GetFirstLineBreakPosition(long pos)
static void InitDefaultTabs()
static void ClearDefaultTabs()
static const wxArrayInt& GetDefaultTabs()

// ==============================
// Class: wxRichTextPlainText

%class %delete wxRichTextPlainText, wxRichTextObject
wxRichTextPlainText(const wxString& text = wxEmptyString, wxRichTextObject* parent = NULL, wxTextAttrEx* style = NULL)
%ctor wxRichTextPlainTextCopy(const wxRichTextPlainText& obj)
virtual bool Draw(wxDC& dc, const wxRichTextRange& range, const wxRichTextRange& selectionRange, const wxRect& rect, int descent, int style)
virtual bool Layout(wxDC& dc, const wxRect& rect, int style)
// wxPoint => wxPoint&
virtual bool GetRangeSize(const wxRichTextRange& range, wxSize& size, int& descent, wxDC& dc, int flags, wxPoint& position) const
virtual wxString GetTextForRange(const wxRichTextRange& range) const
virtual wxRichTextObject* DoSplit(long pos)
virtual void CalculateRange(long start, long& end)
virtual bool DeleteRange(const wxRichTextRange& range)
virtual bool IsEmpty() const
virtual bool CanMerge(wxRichTextObject* object) const
virtual bool Merge(wxRichTextObject* object)
// TODO wxTextOutputStream
//virtual void Dump(wxTextOutputStream& stream)
long GetFirstLineBreakPosition(long pos)
const wxString& GetText() const
void SetText(const wxString& text)
void Copy(const wxRichTextPlainText& obj)
virtual wxRichTextObject* Clone() const

// ==============================
// Class: wxRichTextImageBlock

%class %delete wxRichTextImageBlock, wxObject
wxRichTextImageBlock()
%ctor wxRichTextImageBlockCopy(const wxRichTextImageBlock& block)
void Init()
void Clear()
%rename MakeImageBlockFromFile virtual bool MakeImageBlock(const wxString& filename, int imageType, wxImage& image, bool convertToJPEG = true)
virtual bool MakeImageBlock(wxImage& image, int imageType, int quality = 80)
bool Write(const wxString& filename)
bool WriteHex(wxOutputStream& stream)
bool ReadHex(wxInputStream& stream, int length, int imageType)
void Copy(const wxRichTextImageBlock& block)
bool Load(wxImage& image)
unsigned char* GetData() const
size_t GetDataSize() const
int GetImageType() const
void SetData(unsigned char* image)
void SetDataSize(size_t size)
void SetImageType(int imageType)
bool Ok() const
bool IsOk() const
wxString GetExtension() const
%rename ReadBlockFromStream static unsigned char* ReadBlock(wxInputStream& stream, size_t size)
static unsigned char* ReadBlock(const wxString& filename, size_t size)
%rename WriteBlockStream static bool WriteBlock(wxOutputStream& stream, unsigned char* block, size_t size)
static bool WriteBlock(const wxString& filename, unsigned char* block, size_t size)


// ==============================
// Class: wxRichTextImage

%class %delete wxRichTextImage, wxRichTextObject
wxRichTextImage(wxRichTextObject* parent = NULL)
%ctor wxRichTextImageImage(const wxImage& image, wxRichTextObject* parent = NULL, wxTextAttrEx* charStyle = NULL)
%ctor wxRichTextImageImageBlock(const wxRichTextImageBlock& imageBlock, wxRichTextObject* parent = NULL, wxTextAttrEx* charStyle = NULL)
%ctor wxRichTextImageCopy(const wxRichTextImage& obj)
virtual bool Draw(wxDC& dc, const wxRichTextRange& range, const wxRichTextRange& selectionRange, const wxRect& rect, int descent, int style)
virtual bool Layout(wxDC& dc, const wxRect& rect, int style)
//TODO: needs wrapper
//virtual bool GetRangeSize(const wxRichTextRange& range, wxSize& size, int& descent, wxDC& dc, int flags, wxPoint position = wxPoint(0,0)) const
virtual bool IsEmpty() const
const wxImage& GetImage() const
void SetImage(const wxImage& image)
wxRichTextImageBlock& GetImageBlock()
void Copy(const wxRichTextImage& obj)
virtual wxRichTextObject* Clone() const
virtual bool LoadFromBlock()
virtual bool MakeBlock()

// ==============================
// Class: wxRichTextBuffer

%class %delete wxRichTextBuffer, wxRichTextParagraphLayoutBox
%ctor wxRichTextBufferEmpty()
wxRichTextBuffer(const wxRichTextBuffer& obj)
//TODO wxCommandProcessor
//wxCommandProcessor* GetCommandProcessor() const
void SetStyleSheet(wxRichTextStyleSheet* styleSheet)
virtual wxRichTextStyleSheet* GetStyleSheet() const
bool SetStyleSheetAndNotify(wxRichTextStyleSheet* sheet)
bool PushStyleSheet(wxRichTextStyleSheet* styleSheet)
wxRichTextStyleSheet* PopStyleSheet()
void Init()
virtual void ResetAndClearCommands()
virtual bool LoadFile(const wxString& filename, int type = wxRICHTEXT_TYPE_ANY)
virtual bool SaveFile(const wxString& filename, int type = wxRICHTEXT_TYPE_ANY)
%rename LoadFileFromStream virtual bool LoadFile(wxInputStream& stream, int type = wxRICHTEXT_TYPE_ANY)
%rename SaveFileToStream virtual bool SaveFile(wxOutputStream& stream, int type = wxRICHTEXT_TYPE_ANY)
void SetHandlerFlags(int flags)
int GetHandlerFlags() const
virtual wxRichTextRange AddParagraph(const wxString& text, wxTextAttrEx* paraStyle = NULL)
virtual bool BeginBatchUndo(const wxString& cmdName)
virtual bool EndBatchUndo()
virtual bool BatchingUndo() const
virtual bool SubmitAction(wxRichTextAction* action)
virtual wxRichTextCommand* GetBatchedCommand() const
virtual bool BeginSuppressUndo()
virtual bool EndSuppressUndo()
virtual bool SuppressingUndo() const
virtual bool CopyToClipboard(const wxRichTextRange& range)
virtual bool PasteFromClipboard(long position)
virtual bool CanPasteFromClipboard() const
virtual bool BeginStyle(const wxTextAttrEx& style)
virtual bool EndStyle()
virtual bool EndAllStyles()
virtual void ClearStyleStack()
virtual size_t GetStyleStackSize() const
bool BeginBold()
bool EndBold()
bool BeginItalic()
bool EndItalic()
bool BeginUnderline()
bool EndUnderline()
bool BeginFontSize(int pointSize)
bool EndFontSize()
bool BeginFont(const wxFont& font)
bool EndFont()
bool BeginTextColour(const wxColour& colour)
bool EndTextColour()
bool BeginAlignment(wxTextAttrAlignment alignment)
bool EndAlignment()
bool BeginLeftIndent(int leftIndent, int leftSubIndent = 0)
bool EndLeftIndent()
bool BeginRightIndent(int rightIndent)
bool EndRightIndent()
bool BeginParagraphSpacing(int before, int after)
bool EndParagraphSpacing()
bool BeginLineSpacing(int lineSpacing)
bool EndLineSpacing()
bool BeginNumberedBullet(int bulletNumber, int leftIndent, int leftSubIndent, int bulletStyle = wxTEXT_ATTR_BULLET_STYLE_ARABIC|wxTEXT_ATTR_BULLET_STYLE_PERIOD)
bool EndNumberedBullet()
bool BeginSymbolBullet(const wxString& symbol, int leftIndent, int leftSubIndent, int bulletStyle = wxTEXT_ATTR_BULLET_STYLE_SYMBOL)
bool EndSymbolBullet()
bool BeginStandardBullet(const wxString& bulletName, int leftIndent, int leftSubIndent, int bulletStyle = wxTEXT_ATTR_BULLET_STYLE_STANDARD)
bool EndStandardBullet()
bool BeginCharacterStyle(const wxString& characterStyle)
bool EndCharacterStyle()
bool BeginParagraphStyle(const wxString& paragraphStyle)
bool EndParagraphStyle()
bool BeginListStyle(const wxString& listStyle, int level = 1, int number = 1)
bool EndListStyle()
bool BeginURL(const wxString& url, const wxString& characterStyle = wxEmptyString)
bool EndURL()
bool AddEventHandler(wxEvtHandler* handler)
bool RemoveEventHandler(wxEvtHandler* handler, bool deleteHandler = false)
void ClearEventHandlers()
bool SendEvent(wxEvent& event, bool sendToAll = true)
void Copy(const wxRichTextBuffer& obj)
virtual wxRichTextObject* Clone() const
bool InsertParagraphsWithUndo(long pos, const wxRichTextParagraphLayoutBox& paragraphs, wxRichTextCtrl* ctrl, int flags = 0)
bool InsertTextWithUndo(long pos, const wxString& text, wxRichTextCtrl* ctrl, int flags = 0)
bool InsertNewlineWithUndo(long pos, wxRichTextCtrl* ctrl, int flags = 0)
bool InsertImageWithUndo(long pos, const wxRichTextImageBlock& imageBlock, wxRichTextCtrl* ctrl, int flags = 0)
bool DeleteRangeWithUndo(const wxRichTextRange& range, wxRichTextCtrl* ctrl)
void Modify(bool modify = true)
bool IsModified() const
wxRichTextAttr GetStyleForNewParagraph(long pos, bool caretPosition = false, bool lookUpNewParaStyle=false) const
virtual void Dump()
//TODO wxTextOutputStream and rename it
//virtual void Dump(wxTextOutputStream& stream)
static wxList& GetHandlers()
static void AddHandler(wxRichTextFileHandler *handler)
static void InsertHandler(wxRichTextFileHandler *handler)
static bool RemoveHandler(const wxString& name)
static wxRichTextFileHandler *FindHandler(const wxString& name)
//TODO, rename
//static wxRichTextFileHandler *FindHandler(const wxString& extension, int imageType)
static wxRichTextFileHandler *FindHandlerFilenameOrType(const wxString& filename, int imageType)
//TODO, rename
//static wxRichTextFileHandler *FindHandler(int imageType)

%{
	//static wxString GetExtWildcard(bool combine = false, bool save = false, wxArrayInt* types = NULL)
	void wxRichTextBuffer_GetExtWildcard_()
	{
		bool save = (bool) wStackPopInteger();
		bool combine = (bool) wStackPopInteger();
		wxArrayInt* types = new wxArrayInt;
		wxString result = ((wxRichTextBuffer*)(wTheCall->self->ptr))->GetExtWildcard(combine, save, types);

		wWrapDerefArgs();
		wStackPushChar( (char *)(result.char_str()), W_TRUE );
		wWrapPushObject( _wxArrayInt, W_TRUE, (void *)types );
	}

	void wxRichTextBuffer_GetExtWildcard_p(bool combine = false, bool save = false)
	{
		wxArrayInt* types = new wxArrayInt;
		wxString result = ((wxRichTextBuffer*)(wTheCall->self->ptr))->GetExtWildcard(combine, save, types);

		wWrapDerefArgs();
		wStackPushChar( (char *)(result.char_str()), W_TRUE );
		wWrapPushObject( _wxArrayInt, W_TRUE, (void *)types );
	}
%}
%method GetExtWildcard wxRichTextBuffer_GetExtWildcard_(bool combine = false, bool save = false)

static void CleanUpHandlers()
static void InitStandardHandlers()
static wxRichTextRenderer* GetRenderer()
static void SetRenderer(wxRichTextRenderer* renderer)
static int GetBulletRightMargin()
static void SetBulletRightMargin(int margin)
static float GetBulletProportion()
static void SetBulletProportion(float prop)
double GetScale() const
void SetScale(double scale)

%builtin %rename wxRichTextBuffer_GetHandlers wxList& wxRichTextBuffer::GetHandlers()
%builtin %rename wxRichTextBuffer_AddHandler void wxRichTextBuffer::AddHandler(wxRichTextFileHandler *handler)
%builtin %rename wxRichTextBuffer_InsertHandler void wxRichTextBuffer::InsertHandler(wxRichTextFileHandler *handler)
%builtin %rename wxRichTextBuffer_RemoveHandler bool wxRichTextBuffer::RemoveHandler(const wxString& name)
%builtin %rename wxRichTextBuffer_FindHandler wxRichTextFileHandler* wxRichTextBuffer::FindHandler(const wxString& name)

%builtin %rename wxRichTextBuffer_GetExtWildcard void wxRichTextBuffer_GetExtWildcard_p(bool combine = false, bool save = false)

%builtin %rename wxRichTextBuffer_CleanUpHandlers void wxRichTextBuffer::CleanUpHandlers()
%builtin %rename wxRichTextBuffer_InitStandardHandlers void wxRichTextBuffer::InitStandardHandlers()
%builtin %rename wxRichTextBuffer_GetRenderer wxRichTextRenderer* wxRichTextBuffer::GetRenderer()
%builtin %rename wxRichTextBuffer_SetRenderer void wxRichTextBuffer::SetRenderer(wxRichTextRenderer* renderer)
%builtin %rename wxRichTextBuffer_GetBulletRightMargin int wxRichTextBuffer::GetBulletRightMargin()
%builtin %rename wxRichTextBuffer_SetBulletRightMargin void wxRichTextBuffer::SetBulletRightMargin(int margin)
%builtin %rename wxRichTextBuffer_GetBulletProportion float wxRichTextBuffer::GetBulletProportion()
%builtin %rename wxRichTextBuffer_SetBulletProportion void wxRichTextBuffer::SetBulletProportion(float prop)

%enum wxRichTextCommandId
  %num wxRICHTEXT_INSERT
  %num wxRICHTEXT_DELETE
  %num wxRICHTEXT_CHANGE_STYLE

// ==============================
// Class: wxRichTextCommand

%class %delete wxRichTextCommand, wxCommand
wxRichTextCommand(const wxString& name, wxRichTextCommandId id, wxRichTextBuffer* buffer, wxRichTextCtrl* ctrl, bool ignoreFirstTime = false)
%ctor wxRichTextCommandName(const wxString& name)
bool Do()
bool Undo()
void AddAction(wxRichTextAction* action)
void ClearActions()
wxList& GetActions()

// ==============================
// Class: wxRichTextAction

%class %delete wxRichTextAction, wxObject
wxRichTextAction(wxRichTextCommand* cmd, const wxString& name, wxRichTextCommandId id, wxRichTextBuffer* buffer, wxRichTextCtrl* ctrl, bool ignoreFirstTime = false)
bool Do()
bool Undo()
void UpdateAppearance(long caretPosition, bool sendUpdateEvent = false, wxArrayInt* optimizationLineCharPositions = NULL, wxArrayInt* optimizationLineYPositions = NULL)
void ApplyParagraphs(const wxRichTextParagraphLayoutBox& fragment)
wxRichTextParagraphLayoutBox& GetNewParagraphs()
wxRichTextParagraphLayoutBox& GetOldParagraphs()
void SetPosition(long pos)
long GetPosition() const
void SetRange(const wxRichTextRange& range)
const wxRichTextRange& GetRange() const
const wxString& GetName() const

%num wxRICHTEXT_HANDLER_INCLUDE_STYLESHEET
%num wxRICHTEXT_HANDLER_SAVE_IMAGES_TO_MEMORY
%num wxRICHTEXT_HANDLER_SAVE_IMAGES_TO_FILES
%num wxRICHTEXT_HANDLER_SAVE_IMAGES_TO_BASE64
%num wxRICHTEXT_HANDLER_NO_HEADER_FOOTER

// ==============================
// Class: wxRichTextFileHandler

%class %delete wxRichTextFileHandler, wxObject
// Abstract class
//wxRichTextFileHandler(const wxString& name = wxEmptyString, const wxString& ext = wxEmptyString, int type = 0)
%rename LoadFileFromStream bool LoadFile(wxRichTextBuffer *buffer, wxInputStream& stream)
%rename SaveFileToStream bool SaveFile(wxRichTextBuffer *buffer, wxOutputStream& stream)
bool LoadFile(wxRichTextBuffer *buffer, const wxString& filename)
bool SaveFile(wxRichTextBuffer *buffer, const wxString& filename)
virtual bool CanHandle(const wxString& filename) const
virtual bool CanSave() const
virtual bool CanLoad() const
virtual bool IsVisible() const
virtual void SetVisible(bool visible)
void SetName(const wxString& name)
wxString GetName() const
void SetExtension(const wxString& ext)
wxString GetExtension() const
void SetType(int type)
int GetType() const
void SetFlags(int flags)
int GetFlags() const
void SetEncoding(const wxString& encoding)
const wxString& GetEncoding() const

// ==============================
// Class: wxRichTextPlainTextHandler

%class %delete wxRichTextPlainTextHandler, wxRichTextFileHandler
wxRichTextPlainTextHandler(const wxString& name = wxT("Text"), const wxString& ext = wxT("txt"), int type = wxRICHTEXT_TYPE_TEXT)
virtual bool CanSave() const
virtual bool CanLoad() const

// ==============================
// Class: wxRichTextBufferDataObject

%class %delete wxRichTextBufferDataObject, wxDataObjectSimple
wxRichTextBufferDataObject(wxRichTextBuffer* richTextBuffer = NULL)
wxRichTextBuffer* GetRichTextBuffer()
static const wxString GetRichTextBufferFormatId()
virtual wxDataFormat GetPreferredFormat(wxRichTextBufferDataObject::Direction dir) const
virtual size_t GetDataSize() const
//TODO needs wrapper
virtual bool GetDataHere(void *pBuf) const
virtual bool SetData(size_t len, const void *buf)
%rename GetDataSizeByFormat virtual size_t GetDataSize(const wxDataFormat& fmt) const
//TODO needs wrapper
%rename GetDataHereByFormat virtual bool GetDataHere(const wxDataFormat& fmt, void *buf) const
%rename SetDataByFormat virtual bool SetData(const wxDataFormat& fmt, size_t len, const void *buf)

// ==============================
// Class: wxRichTextRenderer

%class %delete wxRichTextRenderer, wxObject
//Abstract class
//wxRichTextRenderer()
virtual bool DrawStandardBullet(wxRichTextParagraph* paragraph, wxDC& dc, const wxTextAttrEx& attr, const wxRect& rect)
virtual bool DrawTextBullet(wxRichTextParagraph* paragraph, wxDC& dc, const wxTextAttrEx& attr, const wxRect& rect, const wxString& text)
virtual bool DrawBitmapBullet(wxRichTextParagraph* paragraph, wxDC& dc, const wxTextAttrEx& attr, const wxRect& rect)
virtual bool EnumerateStandardBulletNames(wxArrayString& bulletNames)

// ==============================
// Class: wxRichTextStdRenderer

%class %delete wxRichTextStdRenderer, wxRichTextRenderer
wxRichTextStdRenderer()
virtual bool DrawStandardBullet(wxRichTextParagraph* paragraph, wxDC& dc, const wxTextAttrEx& attr, const wxRect& rect)
virtual bool DrawTextBullet(wxRichTextParagraph* paragraph, wxDC& dc, const wxTextAttrEx& attr, const wxRect& rect, const wxString& text)
virtual bool DrawBitmapBullet(wxRichTextParagraph* paragraph, wxDC& dc, const wxTextAttrEx& attr, const wxRect& rect)
virtual bool EnumerateStandardBulletNames(wxArrayString& bulletNames)

//%builtin bool wxTextAttrEq(const wxTextAttrEx& attr1, const wxTextAttrEx& attr2)
//%builtin bool wxTextAttrEq(const wxTextAttr& attr1, const wxRichTextAttr& attr2)
%builtin bool wxTextAttrEqPartial(const wxTextAttrEx& attr1, const wxTextAttrEx& attr2, int flags)
//%builtin bool wxTextAttrEqPartial(const wxTextAttrEx& attr1, const wxRichTextAttr& attr2, int flags)
%builtin bool wxRichTextApplyStyle(wxTextAttrEx& destStyle, const wxTextAttrEx& style)
//%builtin bool wxRichTextApplyStyle(wxRichTextAttr& destStyle, const wxTextAttrEx& style)
//%builtin bool wxRichTextApplyStyle(wxTextAttrEx& destStyle, const wxRichTextAttr& style, wxRichTextAttr* compareWith = NULL)
//%builtin bool wxRichTextApplyStyle(wxRichTextAttr& destStyle, const wxRichTextAttr& style, wxRichTextAttr* compareWith = NULL)
%builtin bool wxRichTextRemoveStyle(wxTextAttrEx& destStyle, const wxRichTextAttr& style)
%builtin bool wxRichTextCombineBitlists(int& valueA, int valueB, int& flagsA, int flagsB)
%builtin bool wxRichTextBitlistsEqPartial(int valueA, int valueB, int flags)
%builtin bool wxRichTextSplitParaCharStyles(const wxTextAttrEx& style, wxTextAttrEx& parStyle, wxTextAttrEx& charStyle)
%builtin bool wxRichTextTabsEq(const wxArrayInt& tabs1, const wxArrayInt& tabs2)
%builtin void wxSetFontPreservingStyles(wxTextAttr& attr, const wxFont& font)
%builtin wxString wxRichTextDecimalToRoman(long n)
%builtin void wxRichTextModuleInit()

// #########################################################
// richtextbulletspage.h

%include <wx/richtext/richtextbulletspage.h>

%num SYMBOL_WXRICHTEXTBULLETSPAGE_STYLE
//%num SYMBOL_WXRICHTEXTBULLETSPAGE_IDNAME
//%num SYMBOL_WXRICHTEXTBULLETSPAGE_POSITION

// ==============================
// Class: wxRichTextBulletsPage

%include <wx/richtext/richtextbulletspage.h>

%class wxRichTextBulletsPage, wxPanel
%ctor wxRichTextBulletsPageNoCreate()
wxRichTextBulletsPage( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTBULLETSPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTBULLETSPAGE_SIZE, long style = SYMBOL_WXRICHTEXTBULLETSPAGE_STYLE )
bool Create( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTBULLETSPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTBULLETSPAGE_SIZE, long style = SYMBOL_WXRICHTEXTBULLETSPAGE_STYLE )
void Init()
void CreateControls()
void UpdatePreview()
virtual bool TransferDataFromWindow()
virtual bool TransferDataToWindow()
wxTextAttrEx* GetAttributes()
//void OnSymbolUpdate( wxUpdateUIEvent& event )
//void OnNumberUpdate( wxUpdateUIEvent& event )
//void OnStandardBulletUpdate( wxUpdateUIEvent& event )
//void OnStylelistboxSelected( wxCommandEvent& event )
//void OnPeriodctrlClick( wxCommandEvent& event )
//void OnPeriodctrlUpdate( wxUpdateUIEvent& event )
//void OnParenthesesctrlClick( wxCommandEvent& event )
//void OnParenthesesctrlUpdate( wxUpdateUIEvent& event )
//void OnRightParenthesisCtrlClick( wxCommandEvent& event )
//void OnRightParenthesisCtrlUpdate( wxUpdateUIEvent& event )
//void OnBulletAlignmentCtrlSelected( wxCommandEvent& event )
//void OnSymbolstaticUpdate( wxUpdateUIEvent& event )
//void OnSymbolctrlSelected( wxCommandEvent& event )
//void OnSymbolctrlUpdated( wxCommandEvent& event )
//void OnSymbolctrlUpdate( wxUpdateUIEvent& event )
//void OnChooseSymbolClick( wxCommandEvent& event )
//void OnChooseSymbolUpdate( wxUpdateUIEvent& event )
//void OnSymbolfontctrlSelected( wxCommandEvent& event )
//void OnSymbolfontctrlUpdated( wxCommandEvent& event )
//void OnSymbolfontctrlUIUpdate( wxUpdateUIEvent& event )
//void OnNamestaticUpdate( wxUpdateUIEvent& event )
//void OnNamectrlSelected( wxCommandEvent& event )
//void OnNamectrlUpdated( wxCommandEvent& event )
//void OnNamectrlUIUpdate( wxUpdateUIEvent& event )
//void OnNumberstaticUpdate( wxUpdateUIEvent& event )
//void OnNumberctrlUpdated( wxSpinEvent& event )
//void OnNumberctrlUp( wxSpinEvent& event )
//void OnNumberctrlDown( wxSpinEvent& event )
//void OnNumberctrlTextUpdated( wxCommandEvent& event )
//void OnNumberctrlUpdate( wxUpdateUIEvent& event )
wxBitmap GetBitmapResource( const wxString& name )
wxIcon GetIconResource( const wxString& name )
static bool ShowToolTips()
wxListBox* m_styleListBox
wxCheckBox* m_periodCtrl
wxCheckBox* m_parenthesesCtrl
wxCheckBox* m_rightParenthesisCtrl
wxComboBox* m_bulletAlignmentCtrl
wxComboBox* m_symbolCtrl
wxComboBox* m_symbolFontCtrl
wxComboBox* m_bulletNameCtrl
wxSpinCtrl* m_numberCtrl
wxRichTextCtrl* m_previewCtrl
bool m_hasBulletStyle
bool m_hasBulletNumber
bool m_hasBulletSymbol
bool m_dontUpdate

%num %rename wxID_RICHTEXTBULLETSPAGE wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE
%num %rename wxID_RICHTEXTBULLETSPAGE_STYLELISTBOX wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_STYLELISTBOX
%num %rename wxID_RICHTEXTBULLETSPAGE_PERIODCTRL wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_PERIODCTRL
%num %rename wxID_RICHTEXTBULLETSPAGE_PARENTHESESCTRL wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_PARENTHESESCTRL
%num %rename wxID_RICHTEXTBULLETSPAGE_RIGHTPARENTHESISCTRL wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_RIGHTPARENTHESISCTRL
%num %rename wxID_RICHTEXTBULLETSPAGE_BULLETALIGNMENTCTRL wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_BULLETALIGNMENTCTRL
%num %rename wxID_RICHTEXTBULLETSPAGE_SYMBOLSTATIC wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_SYMBOLSTATIC
%num %rename wxID_RICHTEXTBULLETSPAGE_SYMBOLCTRL wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_SYMBOLCTRL
%num %rename wxID_RICHTEXTBULLETSPAGE_CHOOSE_SYMBOL wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_CHOOSE_SYMBOL
%num %rename wxID_RICHTEXTBULLETSPAGE_SYMBOLFONTCTRL wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_SYMBOLFONTCTRL
%num %rename wxID_RICHTEXTBULLETSPAGE_NAMESTATIC wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_NAMESTATIC
%num %rename wxID_RICHTEXTBULLETSPAGE_NAMECTRL wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_NAMECTRL
%num %rename wxID_RICHTEXTBULLETSPAGE_NUMBERSTATIC wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_NUMBERSTATIC
%num %rename wxID_RICHTEXTBULLETSPAGE_NUMBERCTRL wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_NUMBERCTRL
%num %rename wxID_RICHTEXTBULLETSPAGE_PREVIEW_CTRL wxRichTextBulletsPage::ID_RICHTEXTBULLETSPAGE_PREVIEW_CTRL


// #########################################################
// richtextctrl.h

%include <wx/richtext/richtextctrl.h>

%num wxRICHTEXT_BUFFERED_PAINTING
%num wxRE_READONLY
%num wxRE_MULTILINE
%num wxRICHTEXT_SHIFT_DOWN
%num wxRICHTEXT_CTRL_DOWN
%num wxRICHTEXT_ALT_DOWN
%num wxRICHTEXT_DEFAULT_SPACING
%num wxRICHTEXT_DEFAULT_MARGIN
//%num wxRICHTEXT_DEFAULT_UNSELECTED_BACKGROUND
%num wxRICHTEXT_DEFAULT_CARET_WIDTH
%num wxRICHTEXT_DEFAULT_DELAYED_LAYOUT_THRESHOLD
%num wxRICHTEXT_DEFAULT_LAYOUT_INTERVAL
%num wxRICHTEXT_SELECTED
%num wxRICHTEXT_TAGGED
%num wxRICHTEXT_FOCUSSED
%num wxRICHTEXT_IS_FOCUS

// ==============================
// Class: wxRichTextCtrl

%class wxRichTextCtrl, wxTextCtrlBase

%typedef wxTextPos long

%ctor wxRichTextCtrlNoCreate()
wxRichTextCtrl( wxWindow* parent, wxWindowID id = -1, const wxString& value = wxEmptyString, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxRE_MULTILINE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxTextCtrlNameStr)
bool Create( wxWindow* parent, wxWindowID id = -1, const wxString& value = wxEmptyString, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxRE_MULTILINE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxTextCtrlNameStr )
void Init()
virtual wxString GetValue() const
virtual wxString GetRange(long from, long to) const
virtual int GetLineLength(long lineNo) const
virtual wxString GetLineText(long lineNo) const
virtual int GetNumberOfLines() const
virtual bool IsModified() const
virtual bool IsEditable() const
bool IsSingleLine() const
bool IsMultiLine() const
virtual void GetSelection(long* from, long* to) const
virtual wxString GetStringSelection() const
wxString GetFilename() const
void SetFilename(const wxString& filename)
void SetDelayedLayoutThreshold(long threshold)
long GetDelayedLayoutThreshold() const
virtual void Clear()
virtual void Replace(long from, long to, const wxString& value)
virtual void Remove(long from, long to)
virtual bool DoLoadFile(const wxString& file, int fileType)
virtual bool DoSaveFile(const wxString& file = wxEmptyString, int fileType = wxRICHTEXT_TYPE_ANY)
bool LoadFile(const wxString& file, int fileType)
bool SaveFile(const wxString& file = wxEmptyString, int fileType = wxRICHTEXT_TYPE_ANY)
void SetHandlerFlags(int flags)
int GetHandlerFlags() const
virtual void MarkDirty()
virtual void DiscardEdits()
virtual void SetMaxLength(unsigned long len)
virtual void WriteText(const wxString& text)
virtual void AppendText(const wxString& text)

%rename SetTextStyle virtual bool SetStyle(long start, long end, const wxTextAttr& style)
%rename SetTextExStyle virtual bool SetStyle(long start, long end, const wxTextAttrEx& style)
virtual bool SetStyle(const wxRichTextRange& range, const wxRichTextAttr& style)
%rename SetStyleRange virtual bool SetStyle(const wxRichTextRange& range, const wxRichTextAttr& style)

%rename GetTextStyle virtual bool GetStyle(long position, wxTextAttr& style)
%rename GetTextExStyle virtual bool GetStyle(long position, wxTextAttrEx& style)
virtual bool GetStyle(long position, wxRichTextAttr& style)

virtual bool GetStyleForRange(const wxRichTextRange& range, wxRichTextAttr& style)
%rename GetTextExStyleForRange virtual bool GetStyleForRange(const wxRichTextRange& range, wxTextAttrEx& style)

virtual bool SetStyleEx(long start, long end, const wxTextAttrEx& style, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO)
%rename SetStyleExRange virtual bool SetStyleEx(const wxRichTextRange& range, const wxTextAttrEx& style, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO)
%rename SetStyleExAttrRange virtual bool SetStyleEx(const wxRichTextRange& range, const wxRichTextAttr& style, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO)

//TODO: needs wrappers
//virtual bool GetUncombinedStyle(long position, wxTextAttr& style)
//virtual bool GetUncombinedStyle(long position, wxTextAttrEx& style)
//virtual bool GetUncombinedStyle(long position, wxRichTextAttr& style)
%{
	void wxRichTextCtrl_GetUncombinedStyle()
	{
		long position = wStackPopInteger();
		wxRichTextAttr *returns = new wxRichTextAttr;
		((wxRichTextCtrl *)wTheCall->self->ptr)->GetUncombinedStyle(position, *returns);
		wWrapDerefArgs();
		wWrapPushObject( _wxRichTextAttr, W_TRUE, (void *)returns );
    }
%}
%method GetUncombinedStyle wxRichTextCtrl_GetUncombinedStyle(long position)

%rename SetDefaultStyleEx virtual bool SetDefaultStyle(const wxTextAttrEx& style)
virtual bool SetDefaultStyle(const wxTextAttr& style)

virtual const wxTextAttrEx& GetDefaultStyleEx() const
virtual const wxTextAttr& GetDefaultStyle() const

virtual bool SetListStyle(const wxRichTextRange& range, wxRichTextListStyleDefinition* def, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom = 1, int specifiedLevel = -1)
%rename SetListStyleByName virtual bool SetListStyle(const wxRichTextRange& range, const wxString& defName, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom = 1, int specifiedLevel = -1)
virtual bool ClearListStyle(const wxRichTextRange& range, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO)
virtual bool NumberList(const wxRichTextRange& range, wxRichTextListStyleDefinition* def = NULL, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom = 1, int specifiedLevel = -1)
//virtual bool NumberList(const wxRichTextRange& range, const wxString& defName, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int startFrom = 1, int specifiedLevel = -1)
virtual bool PromoteList(int promoteBy, const wxRichTextRange& range, wxRichTextListStyleDefinition* def = NULL, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int specifiedLevel = -1)
//virtual bool PromoteList(int promoteBy, const wxRichTextRange& range, const wxString& defName, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO, int specifiedLevel = -1)
virtual bool Delete(const wxRichTextRange& range)
virtual long XYToPosition(long x, long y) const
virtual bool PositionToXY(long pos, long *x, long *y) const
virtual void ShowPosition(long pos)
//TODO: needs wrappers
//virtual wxTextCtrlHitTestResult HitTest(const wxPoint& pt, long *pos) const
//virtual wxTextCtrlHitTestResult HitTest(const wxPoint& pt, wxTextCoord *col, wxTextCoord *row) const
%{
	void wxRichTextCtrl_HitTest()
	{
		wxPoint *pt = (wxPoint *)wStackPopObjectPtr( _wxPoint);
		long pos = 0;
		int result = (wxTextCtrlHitTestResult) ((wxRichTextCtrl *)wTheCall->self->ptr)->HitTest(*pt, &pos);

		wWrapDerefArgs();
		wStackPushInteger( (wInteger) result );
		wStackPushInteger( (wInteger) pos );
    }
%}
%method HitTest wxRichTextCtrl_HitTest(const wxPoint& pt)

virtual void Copy()
virtual void Cut()
virtual void Paste()
virtual void DeleteSelection()
virtual bool CanCopy() const
virtual bool CanCut() const
virtual bool CanPaste() const
virtual bool CanDeleteSelection() const
virtual void Undo()
virtual void Redo()
virtual bool CanUndo() const
virtual bool CanRedo() const
virtual void SetInsertionPoint(long pos)
virtual void SetInsertionPointEnd()
virtual long GetInsertionPoint() const
virtual wxTextPos GetLastPosition() const
virtual void SetSelection(long from, long to)
virtual void SelectAll()
virtual void SetEditable(bool editable)
virtual void Freeze()
virtual void Thaw()
virtual bool IsFrozen() const
virtual bool HasSelection() const
//virtual bool WriteImage(const wxImage& image, int bitmapType = wxBITMAP_TYPE_PNG)
virtual bool WriteImage(const wxBitmap& bitmap, int bitmapType = wxBITMAP_TYPE_PNG)
//virtual bool WriteImage(const wxString& filename, int bitmapType)
//virtual bool WriteImage(const wxRichTextImageBlock& imageBlock)
virtual bool Newline()
virtual bool LineBreak()
//virtual void SetBasicStyle(const wxTextAttrEx& style)
virtual void SetBasicStyle(const wxRichTextAttr& style)
virtual const wxTextAttrEx& GetBasicStyle() const
virtual bool BeginStyle(const wxTextAttrEx& style)
virtual bool EndStyle()
virtual bool EndAllStyles()
bool BeginBold()
bool EndBold()
bool BeginItalic()
bool EndItalic()
bool BeginUnderline()
bool EndUnderline()
bool BeginFontSize(int pointSize)
bool EndFontSize()
bool BeginFont(const wxFont& font)
bool EndFont()
bool BeginTextColour(const wxColour& colour)
bool EndTextColour()
bool BeginAlignment(wxTextAttrAlignment alignment)
bool EndAlignment()
bool BeginLeftIndent(int leftIndent, int leftSubIndent = 0)
bool EndLeftIndent()
bool BeginRightIndent(int rightIndent)
bool EndRightIndent()
bool BeginParagraphSpacing(int before, int after)
bool EndParagraphSpacing()
bool BeginLineSpacing(int lineSpacing)
bool EndLineSpacing()
bool BeginNumberedBullet(int bulletNumber, int leftIndent, int leftSubIndent, int bulletStyle = wxTEXT_ATTR_BULLET_STYLE_ARABIC|wxTEXT_ATTR_BULLET_STYLE_PERIOD)
bool EndNumberedBullet()
bool BeginSymbolBullet(const wxString& symbol, int leftIndent, int leftSubIndent, int bulletStyle = wxTEXT_ATTR_BULLET_STYLE_SYMBOL)
bool EndSymbolBullet()
bool BeginStandardBullet(const wxString& bulletName, int leftIndent, int leftSubIndent, int bulletStyle = wxTEXT_ATTR_BULLET_STYLE_STANDARD)
bool EndStandardBullet()
bool BeginCharacterStyle(const wxString& characterStyle)
bool EndCharacterStyle()
bool BeginParagraphStyle(const wxString& paragraphStyle)
bool EndParagraphStyle()
bool BeginListStyle(const wxString& listStyle, int level = 1, int number = 1)
bool EndListStyle()
bool BeginURL(const wxString& url, const wxString& characterStyle = wxEmptyString)
bool EndURL()
bool SetDefaultStyleToCursorStyle()
virtual void SelectNone()
virtual bool SelectWord(long position)
wxRichTextRange GetSelectionRange() const
void SetSelectionRange(const wxRichTextRange& range)
const wxRichTextRange& GetInternalSelectionRange() const
void SetInternalSelectionRange(const wxRichTextRange& range)
virtual wxRichTextRange AddParagraph(const wxString& text)
virtual wxRichTextRange AddImage(const wxImage& image)
virtual bool LayoutContent(bool onlyVisibleRect = false)
virtual bool MoveCaret(long pos, bool showAtLineStart = false)
virtual bool MoveRight(int noPositions = 1, int flags = 0)
virtual bool MoveLeft(int noPositions = 1, int flags = 0)
virtual bool MoveUp(int noLines = 1, int flags = 0)
virtual bool MoveDown(int noLines = 1, int flags = 0)
virtual bool MoveToLineEnd(int flags = 0)
virtual bool MoveToLineStart(int flags = 0)
virtual bool MoveToParagraphEnd(int flags = 0)
virtual bool MoveToParagraphStart(int flags = 0)
virtual bool MoveHome(int flags = 0)
virtual bool MoveEnd(int flags = 0)
virtual bool PageUp(int noPages = 1, int flags = 0)
virtual bool PageDown(int noPages = 1, int flags = 0)
virtual bool WordLeft(int noPages = 1, int flags = 0)
virtual bool WordRight(int noPages = 1, int flags = 0)
wxRichTextBuffer& GetBuffer()
//const wxRichTextBuffer& GetBuffer() const
virtual bool BeginBatchUndo(const wxString& cmdName)
virtual bool EndBatchUndo()
virtual bool BatchingUndo() const
virtual bool BeginSuppressUndo()
virtual bool EndSuppressUndo()
virtual bool SuppressingUndo() const
//virtual bool HasCharacterAttributes(const wxRichTextRange& range, const wxTextAttrEx& style) const
//virtual bool HasCharacterAttributes(const wxRichTextRange& range, const wxRichTextAttr& style) const
//virtual bool HasParagraphAttributes(const wxRichTextRange& range, const wxTextAttrEx& style) const
//needs wrapper
virtual bool HasParagraphAttributes(const wxRichTextRange& range, const wxRichTextAttr& style) const
virtual bool IsSelectionBold()
virtual bool IsSelectionItalics()
virtual bool IsSelectionUnderlined()
virtual bool IsSelectionAligned(wxTextAttrAlignment alignment)
virtual bool ApplyBoldToSelection()
virtual bool ApplyItalicToSelection()
virtual bool ApplyUnderlineToSelection()
virtual bool ApplyAlignmentToSelection(wxTextAttrAlignment alignment)
virtual bool ApplyStyle(wxRichTextStyleDefinition* def)
void SetStyleSheet(wxRichTextStyleSheet* styleSheet)
wxRichTextStyleSheet* GetStyleSheet() const
bool PushStyleSheet(wxRichTextStyleSheet* styleSheet)
wxRichTextStyleSheet* PopStyleSheet()
bool ApplyStyleSheet(wxRichTextStyleSheet* styleSheet = NULL)

void Command(wxCommandEvent& event)
void OnDropFiles(wxDropFilesEvent& event)
void OnCaptureLost(wxMouseCaptureLostEvent& event)
void OnCut(wxCommandEvent& event)
void OnCopy(wxCommandEvent& event)
void OnPaste(wxCommandEvent& event)
void OnUndo(wxCommandEvent& event)
void OnRedo(wxCommandEvent& event)
void OnSelectAll(wxCommandEvent& event)
void OnClear(wxCommandEvent& event)
void OnUpdateCut(wxUpdateUIEvent& event)
void OnUpdateCopy(wxUpdateUIEvent& event)
void OnUpdatePaste(wxUpdateUIEvent& event)
void OnUpdateUndo(wxUpdateUIEvent& event)
void OnUpdateRedo(wxUpdateUIEvent& event)
void OnUpdateSelectAll(wxUpdateUIEvent& event)
void OnUpdateClear(wxUpdateUIEvent& event)
void OnContextMenu(wxContextMenuEvent& event)
void OnPaint(wxPaintEvent& event)
void OnEraseBackground(wxEraseEvent& event)
void OnLeftClick(wxMouseEvent& event)
void OnLeftUp(wxMouseEvent& event)
void OnMoveMouse(wxMouseEvent& event)
void OnLeftDClick(wxMouseEvent& event)
void OnMiddleClick(wxMouseEvent& event)
void OnRightClick(wxMouseEvent& event)
void OnChar(wxKeyEvent& event)
void OnSize(wxSizeEvent& event)
void OnSetFocus(wxFocusEvent& event)
void OnKillFocus(wxFocusEvent& event)
void OnIdle(wxIdleEvent& event)
void OnScroll(wxScrollWinEvent& event)

virtual bool SetFont(const wxFont& font)
virtual void SetupScrollbars(bool atTop = false)
virtual bool KeyboardNavigate(int keyCode, int flags)
virtual void PaintBackground(wxDC& dc)
%if(win) virtual bool RecreateBuffer(const wxSize& size = wxDefaultSize)
virtual void DoSetSelection(long from, long to, bool scrollCaret = true)
virtual void DoWriteText(const wxString& value, int flags = 0)
virtual bool ShouldInheritColours() const
virtual void PositionCaret()
virtual bool ExtendSelection(long oldPosition, long newPosition, int flags)
virtual bool ScrollIntoView(long position, int keyCode)
void SetCaretPosition(long position, bool showAtLineStart = false)
long GetCaretPosition() const
long GetAdjustedCaretPosition(long caretPos) const
void MoveCaretForward(long oldPosition)
void MoveCaretBack(long oldPosition)
bool GetCaretPositionForIndex(long position, wxRect& rect)
wxRichTextLine* GetVisibleLineForCaretPosition(long caretPosition) const
//TODO wxCommandProcessor
//wxCommandProcessor* GetCommandProcessor() const
bool DeleteSelectedContent(long* newPos= NULL)
wxPoint GetPhysicalPoint(const wxPoint& ptLogical) const
wxPoint GetLogicalPoint(const wxPoint& ptPhysical) const
virtual long FindNextWordPosition(int direction = 1) const
bool IsPositionVisible(long pos) const
long GetFirstVisiblePosition() const
long GetCaretPositionForDefaultStyle() const
void SetCaretPositionForDefaultStyle(long pos)
bool IsDefaultStyleShowing() const
void SetAndShowDefaultStyle(const wxRichTextAttr& attr)
wxPoint GetFirstVisiblePoint() const
static const wxArrayString& GetAvailableFontNames()
static void ClearAvailableFontNames()
//WX_FORWARD_TO_SCROLL_HELPER()
// protected
//virtual void DoSetValue(const wxString& value, int flags = 0)

// ==============================
// Class: wxRichTextEvent

%class wxRichTextEvent, wxNotifyEvent
wxRichTextEvent(wxEventType commandType = wxEVT_NULL, int winid = 0)
%ctor wxRichTextEventCopy(const wxRichTextEvent& event)
long GetPosition() const
void SetPosition(long pos)
int GetFlags() const
void SetFlags(int flags)
wxRichTextStyleSheet* GetOldStyleSheet() const
void SetOldStyleSheet(wxRichTextStyleSheet* sheet)
wxRichTextStyleSheet* GetNewStyleSheet() const
void SetNewStyleSheet(wxRichTextStyleSheet* sheet)
const wxRichTextRange& GetRange() const
void SetRange(const wxRichTextRange& range)
wxChar GetCharacter() const
void SetCharacter(wxChar ch)
%not(bcc) virtual wxEvent *Clone() const

%event wxEVT_COMMAND_RICHTEXT_LEFT_CLICK
%event wxEVT_COMMAND_RICHTEXT_RIGHT_CLICK
%event wxEVT_COMMAND_RICHTEXT_MIDDLE_CLICK
%event wxEVT_COMMAND_RICHTEXT_LEFT_DCLICK
%event wxEVT_COMMAND_RICHTEXT_RETURN
%event wxEVT_COMMAND_RICHTEXT_CHARACTER
%event wxEVT_COMMAND_RICHTEXT_DELETE
%event wxEVT_COMMAND_RICHTEXT_STYLESHEET_CHANGING
%event wxEVT_COMMAND_RICHTEXT_STYLESHEET_CHANGED
%event wxEVT_COMMAND_RICHTEXT_STYLESHEET_REPLACING
%event wxEVT_COMMAND_RICHTEXT_STYLESHEET_REPLACED
%event wxEVT_COMMAND_RICHTEXT_CONTENT_INSERTED
%event wxEVT_COMMAND_RICHTEXT_CONTENT_DELETED
%event wxEVT_COMMAND_RICHTEXT_STYLE_CHANGED
%event wxEVT_COMMAND_RICHTEXT_SELECTION_CHANGED
%event wxEVT_COMMAND_RICHTEXT_BUFFER_RESET

// #########################################################
// richtextfontpage.h

%include <wx/richtext/richtextfontpage.h>

%num SYMBOL_WXRICHTEXTFONTPAGE_STYLE
//%num SYMBOL_WXRICHTEXTFONTPAGE_IDNAME
//%num SYMBOL_WXRICHTEXTFONTPAGE_POSITION

// ==============================
// Class: wxRichTextFontPage

%class wxRichTextFontPage, wxPanel
%ctor wxRichTextFontPageNoCreate()
wxRichTextFontPage( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTFONTPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTFONTPAGE_SIZE, long style = SYMBOL_WXRICHTEXTFONTPAGE_STYLE )
void Init()
bool Create( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTFONTPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTFONTPAGE_SIZE, long style = SYMBOL_WXRICHTEXTFONTPAGE_STYLE )
void CreateControls()
virtual bool TransferDataFromWindow()
virtual bool TransferDataToWindow()
void UpdatePreview()
void OnFaceListBoxSelected( wxCommandEvent& event )
void OnColourClicked( wxCommandEvent& event )
wxTextAttrEx* GetAttributes()
void OnFaceTextCtrlUpdated( wxCommandEvent& event )
void OnSizeTextCtrlUpdated( wxCommandEvent& event )
void OnSizeListBoxSelected( wxCommandEvent& event )
void OnStyleCtrlSelected( wxCommandEvent& event )
void OnWeightCtrlSelected( wxCommandEvent& event )
void OnUnderliningCtrlSelected( wxCommandEvent& event )
void OnStrikethroughctrlClick( wxCommandEvent& event )
void OnCapsctrlClick( wxCommandEvent& event )
wxBitmap GetBitmapResource( const wxString& name )
wxIcon GetIconResource( const wxString& name )
static bool ShowToolTips()
wxTextCtrl* m_faceTextCtrl
wxRichTextFontListBox* m_faceListBox
wxTextCtrl* m_sizeTextCtrl
wxListBox* m_sizeListBox
wxComboBox* m_styleCtrl
wxComboBox* m_weightCtrl
wxComboBox* m_underliningCtrl
wxRichTextColourSwatchCtrl* m_colourCtrl
wxCheckBox* m_strikethroughCtrl
wxCheckBox* m_capitalsCtrl
wxRichTextFontPreviewCtrl* m_previewCtrl
bool m_dontUpdate
bool m_colourPresent

%num %rename wxID_RICHTEXTFONTPAGE wxRichTextFontPage::ID_RICHTEXTFONTPAGE
%num %rename wxID_RICHTEXTFONTPAGE_FACETEXTCTRL wxRichTextFontPage::ID_RICHTEXTFONTPAGE_FACETEXTCTRL
%num %rename wxID_RICHTEXTFONTPAGE_FACELISTBOX wxRichTextFontPage::ID_RICHTEXTFONTPAGE_FACELISTBOX
%num %rename wxID_RICHTEXTFONTPAGE_SIZETEXTCTRL wxRichTextFontPage::ID_RICHTEXTFONTPAGE_SIZETEXTCTRL
%num %rename wxID_RICHTEXTFONTPAGE_SIZELISTBOX wxRichTextFontPage::ID_RICHTEXTFONTPAGE_SIZELISTBOX
%num %rename wxID_RICHTEXTFONTPAGE_STYLECTRL wxRichTextFontPage::ID_RICHTEXTFONTPAGE_STYLECTRL
%num %rename wxID_RICHTEXTFONTPAGE_WEIGHTCTRL wxRichTextFontPage::ID_RICHTEXTFONTPAGE_WEIGHTCTRL
%num %rename wxID_RICHTEXTFONTPAGE_UNDERLINING_CTRL wxRichTextFontPage::ID_RICHTEXTFONTPAGE_UNDERLINING_CTRL
%num %rename wxID_RICHTEXTFONTPAGE_COLOURCTRL wxRichTextFontPage::ID_RICHTEXTFONTPAGE_COLOURCTRL
%num %rename wxID_RICHTEXTFONTPAGE_STRIKETHROUGHCTRL wxRichTextFontPage::ID_RICHTEXTFONTPAGE_STRIKETHROUGHCTRL
%num %rename wxID_RICHTEXTFONTPAGE_CAPSCTRL wxRichTextFontPage::ID_RICHTEXTFONTPAGE_CAPSCTRL
%num %rename wxID_RICHTEXTFONTPAGE_PREVIEWCTRL wxRichTextFontPage::ID_RICHTEXTFONTPAGE_PREVIEWCTRL


// #########################################################
// richtextformatdlg.h

%include <wx/richtext/richtextformatdlg.h>

%num wxRICHTEXT_FORMAT_STYLE_EDITOR
%num wxRICHTEXT_FORMAT_FONT
%num wxRICHTEXT_FORMAT_TABS
%num wxRICHTEXT_FORMAT_BULLETS
%num wxRICHTEXT_FORMAT_INDENTS_SPACING
%num wxRICHTEXT_FORMAT_LIST_STYLE
%num wxRICHTEXT_FORMAT_HELP_BUTTON

%num wxRICHTEXT_BULLETINDEX_NONE
%num wxRICHTEXT_BULLETINDEX_ARABIC
%num wxRICHTEXT_BULLETINDEX_UPPER_CASE
%num wxRICHTEXT_BULLETINDEX_LOWER_CASE
%num wxRICHTEXT_BULLETINDEX_UPPER_CASE_ROMAN
%num wxRICHTEXT_BULLETINDEX_LOWER_CASE_ROMAN
%num wxRICHTEXT_BULLETINDEX_OUTLINE
%num wxRICHTEXT_BULLETINDEX_SYMBOL
%num wxRICHTEXT_BULLETINDEX_BITMAP
%num wxRICHTEXT_BULLETINDEX_STANDARD

%num wxRICHTEXT_FORMAT_PARAGRAPH
%num wxRICHTEXT_FORMAT_STYLE

// ==============================
// Class: wxRichTextFormattingDialogFactory

%class wxRichTextFormattingDialogFactory, wxObject
wxRichTextFormattingDialogFactory()
virtual bool CreatePages(long pages, wxRichTextFormattingDialog* dialog)
virtual wxPanel* CreatePage(int page, wxString& title, wxRichTextFormattingDialog* dialog)
virtual int GetPageId(int i) const
virtual int GetPageIdCount() const
virtual int GetPageImage(int id) const
virtual bool ShowHelp(int page, wxRichTextFormattingDialog* dialog)
virtual bool SetSheetStyle(wxRichTextFormattingDialog* dialog)
virtual bool CreateButtons(wxRichTextFormattingDialog* dialog)

// ==============================
// Class: wxRichTextFormattingDialog

%class wxRichTextFormattingDialog, wxPropertySheetDialog
%ctor wxRichTextFormattingDialogNoCreate()
wxRichTextFormattingDialog(long flags, wxWindow* parent, const wxString& title = wxGetTranslation(wxT("Formatting")), wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& sz = wxDefaultSize, long style = wxDEFAULT_DIALOG_STYLE)
void Init()
bool Create(long flags, wxWindow* parent, const wxString& title = wxGetTranslation(wxT("Formatting")), wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& sz = wxDefaultSize, long style = wxDEFAULT_DIALOG_STYLE)
virtual bool GetStyle(wxRichTextCtrl* ctrl, const wxRichTextRange& range)
virtual bool SetStyle(const wxTextAttrEx& style, bool update = true)
virtual bool SetStyleDefinition(const wxRichTextStyleDefinition& styleDef, wxRichTextStyleSheet* sheet, bool update = true)
virtual wxRichTextStyleDefinition* GetStyleDefinition() const
virtual wxRichTextStyleSheet* GetStyleSheet() const
virtual bool UpdateDisplay()
virtual bool ApplyStyle(wxRichTextCtrl* ctrl, const wxRichTextRange& range, int flags = wxRICHTEXT_SETSTYLE_WITH_UNDO|wxRICHTEXT_SETSTYLE_OPTIMIZE)
//const wxTextAttrEx& GetAttributes() const
wxTextAttrEx& GetAttributes()
void SetAttributes(const wxTextAttrEx& attr)
virtual bool TransferDataToWindow()
virtual bool TransferDataFromWindow()
void OnTabChanged(wxBookCtrlEvent& event)
void OnHelp(wxCommandEvent& event)
void SetImageList(wxImageList* imageList)
wxImageList* GetImageList() const
static void SetFormattingDialogFactory(wxRichTextFormattingDialogFactory* factory)
static wxRichTextFormattingDialogFactory* GetFormattingDialogFactory()
static wxRichTextFormattingDialog* GetDialog(wxWindow* win)
static wxTextAttrEx* GetDialogAttributes(wxWindow* win)
static wxRichTextStyleDefinition* GetDialogStyleDefinition(wxWindow* win)
static bool ShowToolTips()
static void SetShowToolTips(bool show)
void AddPageId(int id)

// ==============================
// Class: wxRichTextFontPreviewCtrl

%class wxRichTextFontPreviewCtrl, wxWindow
wxRichTextFontPreviewCtrl(wxWindow *parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& sz = wxDefaultSize, long style = 0)
void SetTextEffects(int effects)
int GetTextEffects() const

// ==============================
// Class: wxRichTextColourSwatchCtrl

%class wxRichTextColourSwatchCtrl, wxControl
wxRichTextColourSwatchCtrl(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0)
void OnMouseEvent(wxMouseEvent& event)
void SetColour(const wxColour& colour)
wxColour& GetColour()
virtual wxSize DoGetBestSize() const

// ==============================
// Class: wxRichTextFontListBox

%class wxRichTextFontListBox, wxHtmlListBox
%ctor wxRichTextFontListBoxNoCreate()
wxRichTextFontListBox(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0)
void Init()
bool Create(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0)
wxString CreateHTML(const wxString& facename) const
wxString GetFaceName(size_t i) const
int SetFaceNameSelection(const wxString& name)
void UpdateFonts()
bool HasFaceName(const wxString& faceName) const
const wxArrayString& GetFaceNames() const

// #########################################################
// richtextindentspage.h

%include <wx/richtext/richtextindentspage.h>

%num SYMBOL_WXRICHTEXTINDENTSSPACINGPAGE_STYLE
//%num SYMBOL_WXRICHTEXTINDENTSSPACINGPAGE_IDNAME
//%num SYMBOL_WXRICHTEXTINDENTSSPACINGPAGE_POSITION

// ==============================
// Class: wxRichTextIndentsSpacingPage

%class wxRichTextIndentsSpacingPage, wxPanel
%ctor wxRichTextIndentsSpacingPageNoCreate()
wxRichTextIndentsSpacingPage( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTINDENTSSPACINGPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTINDENTSSPACINGPAGE_SIZE, long style = SYMBOL_WXRICHTEXTINDENTSSPACINGPAGE_STYLE )
bool Create( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTINDENTSSPACINGPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTINDENTSSPACINGPAGE_SIZE, long style = SYMBOL_WXRICHTEXTINDENTSSPACINGPAGE_STYLE )
void Init()
void CreateControls()
virtual bool TransferDataFromWindow()
virtual bool TransferDataToWindow()
void UpdatePreview()
wxTextAttrEx* GetAttributes()
//void OnAlignmentLeftSelected( wxCommandEvent& event )
//void OnAlignmentRightSelected( wxCommandEvent& event )
//void OnAlignmentJustifiedSelected( wxCommandEvent& event )
//void OnAlignmentCentredSelected( wxCommandEvent& event )
//void OnAlignmentIndeterminateSelected( wxCommandEvent& event )
//void OnIndentLeftUpdated( wxCommandEvent& event )
//void OnIndentLeftFirstUpdated( wxCommandEvent& event )
//void OnIndentRightUpdated( wxCommandEvent& event )
//void OnRichtextOutlinelevelSelected( wxCommandEvent& event )
//void OnSpacingBeforeUpdated( wxCommandEvent& event )
//void OnSpacingAfterUpdated( wxCommandEvent& event )
//void OnSpacingLineSelected( wxCommandEvent& event )
wxBitmap GetBitmapResource( const wxString& name )
wxIcon GetIconResource( const wxString& name )
static bool ShowToolTips()
wxRadioButton* m_alignmentLeft
wxRadioButton* m_alignmentRight
wxRadioButton* m_alignmentJustified
wxRadioButton* m_alignmentCentred
wxRadioButton* m_alignmentIndeterminate
wxTextCtrl* m_indentLeft
wxTextCtrl* m_indentLeftFirst
wxTextCtrl* m_indentRight
wxComboBox* m_outlineLevelCtrl
wxTextCtrl* m_spacingBefore
wxTextCtrl* m_spacingAfter
wxComboBox* m_spacingLine
wxRichTextCtrl* m_previewCtrl
bool m_dontUpdate

%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_ALIGNMENT_LEFT wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_ALIGNMENT_LEFT
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_ALIGNMENT_RIGHT wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_ALIGNMENT_RIGHT
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_ALIGNMENT_JUSTIFIED wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_ALIGNMENT_JUSTIFIED
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_ALIGNMENT_CENTRED wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_ALIGNMENT_CENTRED
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_ALIGNMENT_INDETERMINATE wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_ALIGNMENT_INDETERMINATE
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_INDENT_LEFT wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_INDENT_LEFT
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_INDENT_LEFT_FIRST wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_INDENT_LEFT_FIRST
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_INDENT_RIGHT wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_INDENT_RIGHT
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_OUTLINELEVEL wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_OUTLINELEVEL
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_SPACING_BEFORE wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_SPACING_BEFORE
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_SPACING_AFTER wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_SPACING_AFTER
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_SPACING_LINE wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_SPACING_LINE
%num %rename wxID_RICHTEXTINDENTSSPACINGPAGE_PREVIEW_CTRL wxRichTextIndentsSpacingPage::ID_RICHTEXTINDENTSSPACINGPAGE_PREVIEW_CTRL


// #########################################################
// richtextliststylepage.h

%include <wx/richtext/richtextliststylepage.h>

%num SYMBOL_WXRICHTEXTLISTSTYLEPAGE_STYLE
//%num SYMBOL_WXRICHTEXTLISTSTYLEPAGE_IDNAME
//%num SYMBOL_WXRICHTEXTLISTSTYLEPAGE_POSITION

// ==============================
// Class: wxRichTextListStylePage

%class wxRichTextListStylePage, wxPanel
%ctor wxRichTextListStylePageNoCreate( )
wxRichTextListStylePage( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTLISTSTYLEPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTLISTSTYLEPAGE_SIZE, long style = SYMBOL_WXRICHTEXTLISTSTYLEPAGE_STYLE )
bool Create( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTLISTSTYLEPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTLISTSTYLEPAGE_SIZE, long style = SYMBOL_WXRICHTEXTLISTSTYLEPAGE_STYLE )
void Init()
void CreateControls()
void UpdatePreview()
virtual bool TransferDataFromWindow()
virtual bool TransferDataToWindow()
wxRichTextAttr* GetAttributesForSelection()
//void OnSymbolUpdate( wxUpdateUIEvent& event )
//void OnNumberUpdate( wxUpdateUIEvent& event )
//void OnStandardBulletUpdate( wxUpdateUIEvent& event )
void DoTransferDataToWindow()
void TransferAndPreview()
//void OnLevelUpdated( wxSpinEvent& event )
//void OnLevelUp( wxSpinEvent& event )
//void OnLevelDown( wxSpinEvent& event )
//void OnLevelTextUpdated( wxCommandEvent& event )
//void OnLevelUIUpdate( wxUpdateUIEvent& event )
//void OnChooseFontClick( wxCommandEvent& event )
//void OnStylelistboxSelected( wxCommandEvent& event )
//void OnPeriodctrlClick( wxCommandEvent& event )
//void OnPeriodctrlUpdate( wxUpdateUIEvent& event )
//void OnParenthesesctrlClick( wxCommandEvent& event )
//void OnParenthesesctrlUpdate( wxUpdateUIEvent& event )
//void OnRightParenthesisCtrlClick( wxCommandEvent& event )
//void OnRightParenthesisCtrlUpdate( wxUpdateUIEvent& event )
//void OnBulletAlignmentCtrlSelected( wxCommandEvent& event )
//void OnSymbolstaticUpdate( wxUpdateUIEvent& event )
//void OnSymbolctrlSelected( wxCommandEvent& event )
//void OnSymbolctrlUpdated( wxCommandEvent& event )
//void OnSymbolctrlUIUpdate( wxUpdateUIEvent& event )
//void OnChooseSymbolClick( wxCommandEvent& event )
//void OnChooseSymbolUpdate( wxUpdateUIEvent& event )
//void OnSymbolfontctrlSelected( wxCommandEvent& event )
//void OnSymbolfontctrlUpdated( wxCommandEvent& event )
//void OnSymbolfontctrlUIUpdate( wxUpdateUIEvent& event )
//void OnNamestaticUpdate( wxUpdateUIEvent& event )
//void OnNamectrlSelected( wxCommandEvent& event )
//void OnNamectrlUpdated( wxCommandEvent& event )
//void OnNamectrlUIUpdate( wxUpdateUIEvent& event )
//void OnRichtextliststylepageAlignleftSelected( wxCommandEvent& event )
//void OnRichtextliststylepageAlignrightSelected( wxCommandEvent& event )
//void OnRichtextliststylepageJustifiedSelected( wxCommandEvent& event )
//void OnRichtextliststylepageCenteredSelected( wxCommandEvent& event )
//void OnRichtextliststylepageAlignindeterminateSelected( wxCommandEvent& event )
//void OnIndentLeftUpdated( wxCommandEvent& event )
//void OnIndentFirstLineUpdated( wxCommandEvent& event )
//void OnIndentRightUpdated( wxCommandEvent& event )
//void OnSpacingBeforeUpdated( wxCommandEvent& event )
//void OnSpacingAfterUpdated( wxCommandEvent& event )
//void OnLineSpacingSelected( wxCommandEvent& event )
wxBitmap GetBitmapResource( const wxString& name )
wxIcon GetIconResource( const wxString& name )
static bool ShowToolTips()
wxSpinCtrl* m_levelCtrl
wxListBox* m_styleListBox
wxCheckBox* m_periodCtrl
wxCheckBox* m_parenthesesCtrl
wxCheckBox* m_rightParenthesisCtrl
wxComboBox* m_bulletAlignmentCtrl
wxComboBox* m_symbolCtrl
wxComboBox* m_symbolFontCtrl
wxComboBox* m_bulletNameCtrl
wxRadioButton* m_alignmentLeft
wxRadioButton* m_alignmentRight
wxRadioButton* m_alignmentJustified
wxRadioButton* m_alignmentCentred
wxRadioButton* m_alignmentIndeterminate
wxTextCtrl* m_indentLeft
wxTextCtrl* m_indentLeftFirst
wxTextCtrl* m_indentRight
wxTextCtrl* m_spacingBefore
wxTextCtrl* m_spacingAfter
wxComboBox* m_spacingLine
wxRichTextCtrl* m_previewCtrl
bool m_dontUpdate
int m_currentLevel

%num %rename wxID_RICHTEXTLISTSTYLEPAGE wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_LEVEL wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_LEVEL
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_CHOOSE_FONT wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_CHOOSE_FONT
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_NOTEBOOK wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_NOTEBOOK
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_BULLETS wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_BULLETS
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_STYLELISTBOX wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_STYLELISTBOX
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_PERIODCTRL wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_PERIODCTRL
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_PARENTHESESCTRL wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_PARENTHESESCTRL
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_RIGHTPARENTHESISCTRL wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_RIGHTPARENTHESISCTRL
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_BULLETALIGNMENTCTRL wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_BULLETALIGNMENTCTRL
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_SYMBOLSTATIC wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_SYMBOLSTATIC
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_SYMBOLCTRL wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_SYMBOLCTRL
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_CHOOSE_SYMBOL wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_CHOOSE_SYMBOL
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_SYMBOLFONTCTRL wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_SYMBOLFONTCTRL
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_NAMESTATIC wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_NAMESTATIC
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_NAMECTRL wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_NAMECTRL
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_SPACING wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_SPACING
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_ALIGNLEFT wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_ALIGNLEFT
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_ALIGNRIGHT wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_ALIGNRIGHT
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_JUSTIFIED wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_JUSTIFIED
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_CENTERED wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_CENTERED
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_ALIGNINDETERMINATE wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_ALIGNINDETERMINATE
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_INDENTLEFT wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_INDENTLEFT
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_INDENTFIRSTLINE wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_INDENTFIRSTLINE
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_INDENTRIGHT wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_INDENTRIGHT
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_SPACINGBEFORE wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_SPACINGBEFORE
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_SPACINGAFTER wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_SPACINGAFTER
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_LINESPACING wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_LINESPACING
%num %rename wxID_RICHTEXTLISTSTYLEPAGE_RICHTEXTCTRL wxRichTextListStylePage::ID_RICHTEXTLISTSTYLEPAGE_RICHTEXTCTRL


// #########################################################
// richtextprint.h

%include <wx/richtext/richtextprint.h>

%num wxRICHTEXT_PRINT_MAX_PAGES

%enum wxRichTextOddEvenPage
  %num wxRICHTEXT_PAGE_ODD
  %num wxRICHTEXT_PAGE_EVEN
  %num wxRICHTEXT_PAGE_ALL

%enum wxRichTextPageLocation
  %num wxRICHTEXT_PAGE_LEFT
  %num wxRICHTEXT_PAGE_CENTRE
  %num wxRICHTEXT_PAGE_RIGHT

// ==============================
// Class: wxRichTextHeaderFooterData

%class wxRichTextHeaderFooterData, wxObject
%ctor wxRichTextHeaderFooterDataEmpty()
wxRichTextHeaderFooterData(const wxRichTextHeaderFooterData& data)
void Init()
void Copy(const wxRichTextHeaderFooterData& data)
void SetHeaderText(const wxString& text, wxRichTextOddEvenPage page = wxRICHTEXT_PAGE_ALL, wxRichTextPageLocation location = wxRICHTEXT_PAGE_CENTRE)
wxString GetHeaderText(wxRichTextOddEvenPage page = wxRICHTEXT_PAGE_EVEN, wxRichTextPageLocation location = wxRICHTEXT_PAGE_CENTRE) const
void SetFooterText(const wxString& text, wxRichTextOddEvenPage page = wxRICHTEXT_PAGE_ALL, wxRichTextPageLocation location = wxRICHTEXT_PAGE_CENTRE)
wxString GetFooterText(wxRichTextOddEvenPage page = wxRICHTEXT_PAGE_EVEN, wxRichTextPageLocation location = wxRICHTEXT_PAGE_CENTRE) const
void SetText(const wxString& text, int headerFooter, wxRichTextOddEvenPage page, wxRichTextPageLocation location)
wxString GetText(int headerFooter, wxRichTextOddEvenPage page, wxRichTextPageLocation location) const
void SetMargins(int headerMargin, int footerMargin)
int GetHeaderMargin() const
int GetFooterMargin() const
void SetShowOnFirstPage(bool showOnFirstPage)
bool GetShowOnFirstPage() const
void Clear()
void SetFont(const wxFont& font)
const wxFont& GetFont() const
void SetTextColour(const wxColour& col)
const wxColour& GetTextColour() const

// ==============================
// Class: wxRichTextPrintout

%class wxRichTextPrintout, wxPrintout
wxRichTextPrintout(const wxString& title = _("Printout"))
void SetRichTextBuffer(wxRichTextBuffer* buffer)
wxRichTextBuffer* GetRichTextBuffer() const
void SetHeaderFooterData(const wxRichTextHeaderFooterData& data)
const wxRichTextHeaderFooterData& GetHeaderFooterData() const
void SetMargins(int top = 252, int bottom = 252, int left = 252, int right = 252)
void CalculateScaling(wxDC* dc, wxRect& textRect, wxRect& headerRect, wxRect& footerRect)
virtual bool OnPrintPage(int page)
virtual bool HasPage(int page)
virtual void GetPageInfo(int *minPage, int *maxPage, int *selPageFrom, int *selPageTo)
virtual bool OnBeginDocument(int startPage, int endPage)
virtual void OnPreparePrinting()

// ==============================
// Class: wxRichTextPrinting

%class wxRichTextPrinting, wxObject
wxRichTextPrinting(const wxString& name = _("Printing"), wxWindow *parentWindow = NULL)
bool PreviewFile(const wxString& richTextFile)
bool PreviewBuffer(const wxRichTextBuffer& buffer)
bool PrintFile(const wxString& richTextFile)
bool PrintBuffer(const wxRichTextBuffer& buffer)
void PageSetup()
void SetHeaderFooterData(const wxRichTextHeaderFooterData& data)
const wxRichTextHeaderFooterData& GetHeaderFooterData() const
void SetHeaderText(const wxString& text, wxRichTextOddEvenPage page = wxRICHTEXT_PAGE_ALL, wxRichTextPageLocation location = wxRICHTEXT_PAGE_CENTRE)
wxString GetHeaderText(wxRichTextOddEvenPage page = wxRICHTEXT_PAGE_EVEN, wxRichTextPageLocation location = wxRICHTEXT_PAGE_CENTRE) const
void SetFooterText(const wxString& text, wxRichTextOddEvenPage page = wxRICHTEXT_PAGE_ALL, wxRichTextPageLocation location = wxRICHTEXT_PAGE_CENTRE)
wxString GetFooterText(wxRichTextOddEvenPage page = wxRICHTEXT_PAGE_EVEN, wxRichTextPageLocation location = wxRICHTEXT_PAGE_CENTRE) const
void SetShowOnFirstPage(bool show)
void SetHeaderFooterFont(const wxFont& font)
void SetHeaderFooterTextColour(const wxColour& font)
wxPrintData *GetPrintData()
wxPageSetupDialogData *GetPageSetupData()
void SetPrintData(const wxPrintData& printData)
void SetPageSetupData(const wxPageSetupData& pageSetupData)
void SetRichTextBufferPreview(wxRichTextBuffer* buf)
wxRichTextBuffer* GetRichTextBufferPreview() const
void SetRichTextBufferPrinting(wxRichTextBuffer* buf)
wxRichTextBuffer* GetRichTextBufferPrinting() const
void SetParentWindow(wxWindow* parent)
wxWindow* GetParentWindow() const
void SetTitle(const wxString& title)
const wxString& GetTitle() const
void SetPreviewRect(const wxRect& rect)
const wxRect& GetPreviewRect() const

// #########################################################
// richtextstyledlg.h

%include <wx/richtext/richtextstyledlg.h>

%num SYMBOL_WXRICHTEXTSTYLEORGANISERDIALOG_STYLE
//%num SYMBOL_WXRICHTEXTSTYLEORGANISERDIALOG_IDNAME
//%num SYMBOL_WXRICHTEXTSTYLEORGANISERDIALOG_POSITION
%num wxRICHTEXT_ORGANISER_DELETE_STYLES
%num wxRICHTEXT_ORGANISER_CREATE_STYLES
%num wxRICHTEXT_ORGANISER_APPLY_STYLES
%num wxRICHTEXT_ORGANISER_EDIT_STYLES
%num wxRICHTEXT_ORGANISER_RENAME_STYLES
%num wxRICHTEXT_ORGANISER_OK_CANCEL
%num wxRICHTEXT_ORGANISER_RENUMBER
%num wxRICHTEXT_ORGANISER_SHOW_CHARACTER
%num wxRICHTEXT_ORGANISER_SHOW_PARAGRAPH
%num wxRICHTEXT_ORGANISER_SHOW_LIST
%num wxRICHTEXT_ORGANISER_SHOW_ALL
%num wxRICHTEXT_ORGANISER_ORGANISE
%num wxRICHTEXT_ORGANISER_BROWSE
%num wxRICHTEXT_ORGANISER_BROWSE_NUMBERING

// ==============================
// Class: wxRichTextStyleOrganiserDialog

%class wxRichTextStyleOrganiserDialog, wxDialog
%ctor wxRichTextStyleOrganiserDialogNoCreate()
wxRichTextStyleOrganiserDialog( int flags, wxRichTextStyleSheet* sheet, wxRichTextCtrl* ctrl, wxWindow* parent, wxWindowID id = wxID_ANY, const wxString& caption = SYMBOL_WXRICHTEXTSTYLEORGANISERDIALOG_TITLE, const wxPoint& pos = SYMBOL_WXRICHTEXTSTYLEORGANISERDIALOG_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTSTYLEORGANISERDIALOG_SIZE, long style = SYMBOL_WXRICHTEXTSTYLEORGANISERDIALOG_STYLE )
bool Create( int flags, wxRichTextStyleSheet* sheet, wxRichTextCtrl* ctrl, wxWindow* parent, wxWindowID id = wxID_ANY, const wxString& caption = SYMBOL_WXRICHTEXTSTYLEORGANISERDIALOG_TITLE, const wxPoint& pos = SYMBOL_WXRICHTEXTSTYLEORGANISERDIALOG_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTSTYLEORGANISERDIALOG_SIZE, long style = SYMBOL_WXRICHTEXTSTYLEORGANISERDIALOG_STYLE )
void CreateControls()
void Init()
virtual bool TransferDataFromWindow()
virtual bool TransferDataToWindow()
void SetStyleSheet(wxRichTextStyleSheet* sheet)
wxRichTextStyleSheet* GetStyleSheet() const
void SetRichTextCtrl(wxRichTextCtrl* ctrl)
wxRichTextCtrl* GetRichTextCtrl() const
void SetFlags(int flags)
int GetFlags() const
void ShowPreview(int sel = -1)
void ClearPreview()
void OnListSelection(wxCommandEvent& event)
bool GetRestartNumbering() const
void SetRestartNumbering(bool restartNumbering)
wxString GetSelectedStyle() const
wxRichTextStyleDefinition* GetSelectedStyleDefinition() const
bool ApplyStyle(wxRichTextCtrl* ctrl = NULL)
static bool ShowToolTips()
static void SetShowToolTips(bool show)
//void OnNewCharClick( wxCommandEvent& event )
//void OnNewCharUpdate( wxUpdateUIEvent& event )
//void OnNewParaClick( wxCommandEvent& event )
//void OnNewParaUpdate( wxUpdateUIEvent& event )
//void OnNewListClick( wxCommandEvent& event )
//void OnNewListUpdate( wxUpdateUIEvent& event )
//void OnApplyClick( wxCommandEvent& event )
//void OnApplyUpdate( wxUpdateUIEvent& event )
//void OnRenameClick( wxCommandEvent& event )
//void OnRenameUpdate( wxUpdateUIEvent& event )
//void OnEditClick( wxCommandEvent& event )
//void OnEditUpdate( wxUpdateUIEvent& event )
//void OnDeleteClick( wxCommandEvent& event )
//void OnDeleteUpdate( wxUpdateUIEvent& event )
wxBitmap GetBitmapResource( const wxString& name )
wxIcon GetIconResource( const wxString& name )
wxBoxSizer* m_innerSizer
wxBoxSizer* m_buttonSizerParent
wxRichTextStyleListCtrl* m_stylesListBox
wxRichTextCtrl* m_previewCtrl
wxBoxSizer* m_buttonSizer
wxButton* m_newCharacter
wxButton* m_newParagraph
wxButton* m_newList
wxButton* m_applyStyle
wxButton* m_renameStyle
wxButton* m_editStyle
wxButton* m_deleteStyle
wxButton* m_closeButton
wxBoxSizer* m_bottomButtonSizer
wxCheckBox* m_restartNumberingCtrl
wxButton* m_okButton
wxButton* m_cancelButton

%num %rename wxID_RICHTEXTSTYLEORGANISERDIALOG wxRichTextStyleOrganiserDialog::ID_RICHTEXTSTYLEORGANISERDIALOG
%num %rename wxID_RICHTEXTSTYLEORGANISERDIALOG_STYLES wxRichTextStyleOrganiserDialog::ID_RICHTEXTSTYLEORGANISERDIALOG_STYLES
%num %rename wxID_RICHTEXTSTYLEORGANISERDIALOG_PREVIEW wxRichTextStyleOrganiserDialog::ID_RICHTEXTSTYLEORGANISERDIALOG_PREVIEW
%num %rename wxID_RICHTEXTSTYLEORGANISERDIALOG_NEW_CHAR wxRichTextStyleOrganiserDialog::ID_RICHTEXTSTYLEORGANISERDIALOG_NEW_CHAR
%num %rename wxID_RICHTEXTSTYLEORGANISERDIALOG_NEW_PARA wxRichTextStyleOrganiserDialog::ID_RICHTEXTSTYLEORGANISERDIALOG_NEW_PARA
%num %rename wxID_RICHTEXTSTYLEORGANISERDIALOG_NEW_LIST wxRichTextStyleOrganiserDialog::ID_RICHTEXTSTYLEORGANISERDIALOG_NEW_LIST
%num %rename wxID_RICHTEXTSTYLEORGANISERDIALOG_APPLY wxRichTextStyleOrganiserDialog::ID_RICHTEXTSTYLEORGANISERDIALOG_APPLY
%num %rename wxID_RICHTEXTSTYLEORGANISERDIALOG_RENAME wxRichTextStyleOrganiserDialog::ID_RICHTEXTSTYLEORGANISERDIALOG_RENAME
%num %rename wxID_RICHTEXTSTYLEORGANISERDIALOG_EDIT wxRichTextStyleOrganiserDialog::ID_RICHTEXTSTYLEORGANISERDIALOG_EDIT
%num %rename wxID_RICHTEXTSTYLEORGANISERDIALOG_DELETE wxRichTextStyleOrganiserDialog::ID_RICHTEXTSTYLEORGANISERDIALOG_DELETE
%num %rename wxID_RICHTEXTSTYLEORGANISERDIALOG_RESTART_NUMBERING wxRichTextStyleOrganiserDialog::ID_RICHTEXTSTYLEORGANISERDIALOG_RESTART_NUMBERING

// #########################################################
// richtextstylepage.h

%include <wx/richtext/richtextstylepage.h>

%num SYMBOL_WXRICHTEXTSTYLEPAGE_STYLE
//%num SYMBOL_WXRICHTEXTSTYLEPAGE_IDNAME
//%num SYMBOL_WXRICHTEXTSTYLEPAGE_POSITION

// ==============================
// Class: wxRichTextStylePage

%class wxRichTextStylePage, wxPanel
%ctor wxRichTextStylePageNoCreate()
wxRichTextStylePage( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTSTYLEPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTSTYLEPAGE_SIZE, long style = SYMBOL_WXRICHTEXTSTYLEPAGE_STYLE )
bool Create( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTSTYLEPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTSTYLEPAGE_SIZE, long style = SYMBOL_WXRICHTEXTSTYLEPAGE_STYLE )
void Init()
void CreateControls()
virtual bool TransferDataFromWindow()
virtual bool TransferDataToWindow()
wxTextAttrEx* GetAttributes()
void OnNextStyleUpdate( wxUpdateUIEvent& event )
wxBitmap GetBitmapResource( const wxString& name )
wxIcon GetIconResource( const wxString& name )
static bool ShowToolTips()
wxTextCtrl* m_styleName
wxComboBox* m_basedOn
wxComboBox* m_nextStyle


%num %rename wxID_RICHTEXTSTYLEPAGE wxRichTextStylePage::ID_RICHTEXTSTYLEPAGE
%num %rename wxID_RICHTEXTSTYLEPAGE_STYLE_NAME wxRichTextStylePage::ID_RICHTEXTSTYLEPAGE_STYLE_NAME
%num %rename wxID_RICHTEXTSTYLEPAGE_BASED_ON wxRichTextStylePage::ID_RICHTEXTSTYLEPAGE_BASED_ON
%num %rename wxID_RICHTEXTSTYLEPAGE_NEXT_STYLE wxRichTextStylePage::ID_RICHTEXTSTYLEPAGE_NEXT_STYLE


// #########################################################
// richtextstyles.h

%include <wx/richtext/richtextstyles.h>

// ==============================
// Class: wxRichTextStyleDefinition

%class wxRichTextStyleDefinition, wxObject
// Abstract class
//%ctor wxRichTextStyleDefinitionCopy(const wxRichTextStyleDefinition& def)
//wxRichTextStyleDefinition(const wxString& name = wxEmptyString)
void Init()
void Copy(const wxRichTextStyleDefinition& def)
bool Eq(const wxRichTextStyleDefinition& def) const
virtual wxRichTextStyleDefinition* Clone() const
void SetName(const wxString& name)
const wxString& GetName() const
void SetDescription(const wxString& descr)
const wxString& GetDescription() const
void SetBaseStyle(const wxString& name)
const wxString& GetBaseStyle() const
void SetStyle(const wxRichTextAttr& style)
//const wxRichTextAttr& GetStyle() const
wxRichTextAttr& GetStyle()
virtual wxRichTextAttr GetStyleMergedWithBase(const wxRichTextStyleSheet* sheet) const

// ==============================
// Class: wxRichTextCharacterStyleDefinition

%class wxRichTextCharacterStyleDefinition, wxRichTextStyleDefinition
%ctor wxRichTextCharacterStyleDefinitionCopy(const wxRichTextCharacterStyleDefinition& def)
wxRichTextCharacterStyleDefinition(const wxString& name = wxEmptyString)
virtual wxRichTextStyleDefinition* Clone() const

// ==============================
// Class: wxRichTextParagraphStyleDefinition

%class wxRichTextParagraphStyleDefinition, wxRichTextStyleDefinition
%ctor wxRichTextParagraphStyleDefinitionCopy(const wxRichTextParagraphStyleDefinition& def)
wxRichTextParagraphStyleDefinition(const wxString& name = wxEmptyString)
void SetNextStyle(const wxString& name)
const wxString& GetNextStyle() const
void Copy(const wxRichTextParagraphStyleDefinition& def)
virtual wxRichTextStyleDefinition* Clone() const

// ==============================
// Class: wxRichTextListStyleDefinition

%class wxRichTextListStyleDefinition, wxRichTextParagraphStyleDefinition
%ctor wxRichTextListStyleDefinitionCopy(const wxRichTextListStyleDefinition& def)
wxRichTextListStyleDefinition(const wxString& name = wxEmptyString)
void Copy(const wxRichTextListStyleDefinition& def)
virtual wxRichTextStyleDefinition* Clone() const
void SetLevelAttributes(int i, const wxRichTextAttr& attr)
wxRichTextAttr* GetLevelAttributes(int i)
//const wxRichTextAttr* GetLevelAttributes(int i) const
void SetAttributes(int i, int leftIndent, int leftSubIndent, int bulletStyle, const wxString& bulletSymbol = wxEmptyString)
int FindLevelForIndent(int indent) const
wxRichTextAttr CombineWithParagraphStyle(int indent, const wxRichTextAttr& paraStyle, wxRichTextStyleSheet* styleSheet = NULL)
wxRichTextAttr GetCombinedStyle(int indent, wxRichTextStyleSheet* styleSheet = NULL)
wxRichTextAttr GetCombinedStyleForLevel(int level, wxRichTextStyleSheet* styleSheet = NULL)
int GetLevelCount() const
bool IsNumbered(int i) const

// ==============================
// Class: wxRichTextStyleSheet

%class wxRichTextStyleSheet, wxObject
%ctor wxRichTextStyleSheetCopy(const wxRichTextStyleSheet& sheet)
wxRichTextStyleSheet()
void Init()
void Copy(const wxRichTextStyleSheet& sheet)
bool AddCharacterStyle(wxRichTextCharacterStyleDefinition* def)
bool AddParagraphStyle(wxRichTextParagraphStyleDefinition* def)
bool AddListStyle(wxRichTextListStyleDefinition* def)
bool AddStyle(wxRichTextStyleDefinition* def)
bool RemoveCharacterStyle(wxRichTextStyleDefinition* def, bool deleteStyle = false)
bool RemoveParagraphStyle(wxRichTextStyleDefinition* def, bool deleteStyle = false)
bool RemoveListStyle(wxRichTextStyleDefinition* def, bool deleteStyle = false)
bool RemoveStyle(wxRichTextStyleDefinition* def, bool deleteStyle = false)
wxRichTextCharacterStyleDefinition* FindCharacterStyle(const wxString& name, bool recurse = true) const
wxRichTextParagraphStyleDefinition* FindParagraphStyle(const wxString& name, bool recurse = true) const
wxRichTextListStyleDefinition* FindListStyle(const wxString& name, bool recurse = true) const
wxRichTextStyleDefinition* FindStyle(const wxString& name, bool recurse = true) const
size_t GetCharacterStyleCount() const
size_t GetParagraphStyleCount() const
size_t GetListStyleCount() const
wxRichTextCharacterStyleDefinition* GetCharacterStyle(size_t n) const
wxRichTextParagraphStyleDefinition* GetParagraphStyle(size_t n) const
wxRichTextListStyleDefinition* GetListStyle(size_t n) const
void DeleteStyles()
bool InsertSheet(wxRichTextStyleSheet* before)
bool AppendSheet(wxRichTextStyleSheet* after)
void Unlink()
wxRichTextStyleSheet* GetNextSheet() const
void SetNextSheet(wxRichTextStyleSheet* sheet)
wxRichTextStyleSheet* GetPreviousSheet() const
void SetPreviousSheet(wxRichTextStyleSheet* sheet)
void SetName(const wxString& name)
const wxString& GetName() const
void SetDescription(const wxString& descr)
const wxString& GetDescription() const
%rename AddStyleList bool AddStyle(wxList& list, wxRichTextStyleDefinition* def)
%rename RemoveStyleList bool RemoveStyle(wxList& list, wxRichTextStyleDefinition* def, bool deleteStyle)
%rename FindStyleList wxRichTextStyleDefinition* FindStyle(const wxList& list, const wxString& name, bool recurse = true) const

// ==============================
// Class: wxRichTextStyleListBox

%typedef wxRichTextStyleType int

%class wxRichTextStyleListBox, wxHtmlListBox
%ctor wxRichTextStyleListBoxNoCreate()
wxRichTextStyleListBox(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0)
void Init()
bool Create(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0)
wxString CreateHTML(wxRichTextStyleDefinition* def) const
void SetStyleSheet(wxRichTextStyleSheet* styleSheet)
wxRichTextStyleSheet* GetStyleSheet() const
void SetRichTextCtrl(wxRichTextCtrl* ctrl)
wxRichTextCtrl* GetRichTextCtrl() const
wxRichTextStyleDefinition* GetStyle(size_t i) const
int GetIndexForStyle(const wxString& name) const
int SetStyleSelection(const wxString& name)
void UpdateStyles()
void ApplyStyle(int i)
void OnLeftDown(wxMouseEvent& event)
void OnLeftDoubleClick(wxMouseEvent& event)
void OnIdle(wxIdleEvent& event)
int ConvertTenthsMMToPixels(wxDC& dc, int units) const
virtual bool CanAutoSetSelection()
virtual void SetAutoSetSelection(bool autoSet)
void SetApplyOnSelection(bool applyOnSel)
bool GetApplyOnSelection() const
//TODO
//void SetStyleType(wxRichTextStyleType styleType)
wxRichTextStyleType GetStyleType() const
//TODO
//static wxString GetStyleToShowInIdleTime(wxRichTextCtrl* ctrl, wxRichTextStyleType styleType)

//%not(gcc) %num %rename wxRichTextStyleListBox_wxRichTextStyleType_wxRICHTEXT_STYLE_ALL wxRichTextStyleListBox::wxRichTextStyleType::wxRICHTEXT_STYLE_ALL
//%not(gcc) %num %rename wxRichTextStyleListBox_wxRichTextStyleType_wxRICHTEXT_STYLE_PARAGRAPH wxRichTextStyleListBox::wxRichTextStyleType::wxRICHTEXT_STYLE_PARAGRAPH
//%not(gcc) %num %rename wxRichTextStyleListBox_wxRichTextStyleType_wxRICHTEXT_STYLE_CHARACTER wxRichTextStyleListBox::wxRichTextStyleType::wxRICHTEXT_STYLE_CHARACTER
//%not(gcc) %num %rename wxRichTextStyleListBox_wxRichTextStyleType_wxRICHTEXT_STYLE_LIST wxRichTextStyleListBox::wxRichTextStyleType::wxRICHTEXT_STYLE_LIST

%num %rename wxRICHTEXT_STYLE_ALL 0
%num %rename wxRICHTEXT_STYLE_PARAGRAPH 1
%num %rename wxRICHTEXT_STYLE_CHARACTER 2
%num %rename wxRICHTEXT_STYLE_LIST 3

%num wxRICHTEXTSTYLELIST_HIDE_TYPE_SELECTOR

// ==============================
// Class: wxRichTextStyleListCtrl

%class wxRichTextStyleListCtrl, wxControl
%ctor wxRichTextStyleListCtrlNoCreate()
wxRichTextStyleListCtrl(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0)
void Init()
bool Create(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0)
void UpdateStyles()
void SetStyleSheet(wxRichTextStyleSheet* styleSheet)
wxRichTextStyleSheet* GetStyleSheet() const
void SetRichTextCtrl(wxRichTextCtrl* ctrl)
wxRichTextCtrl* GetRichTextCtrl() const
//TODO
//void SetStyleType(wxRichTextStyleType styleType)
//int StyleTypeToIndex(wxRichTextStyleType styleType)
wxRichTextStyleListBox* GetStyleListBox() const
wxChoice* GetStyleChoice() const
//void OnChooseType(wxCommandEvent& event)
//void OnSize(wxSizeEvent& event)

// ==============================
// Class: wxRichTextStyleComboPopup

%class wxRichTextStyleComboPopup, wxRichTextStyleListBox
virtual void Init()
virtual bool Create( wxWindow* parent )
virtual wxWindow *GetControl()
virtual void SetStringValue( const wxString& s )
virtual wxString GetStringValue() const
virtual bool CanAutoSetSelection()
//void OnMouseMove(wxMouseEvent& event)
//void OnMouseClick(wxMouseEvent& event)

// ==============================
// Class: wxRichTextStyleComboCtrl

%class wxRichTextStyleComboCtrl, wxComboCtrl
%ctor wxRichTextStyleComboCtrlNoCreate()
wxRichTextStyleComboCtrl(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxCB_READONLY)
void Init()
bool Create(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0)
void UpdateStyles()
void SetStyleSheet(wxRichTextStyleSheet* styleSheet)
wxRichTextStyleSheet* GetStyleSheet() const
void SetRichTextCtrl(wxRichTextCtrl* ctrl)
wxRichTextCtrl* GetRichTextCtrl() const
wxRichTextStyleComboPopup* GetStylePopup() const
//void OnIdle(wxIdleEvent& event)

// #########################################################
// richtextsymboldlg.h

%include <wx/richtext/richtextsymboldlg.h>

%num SYMBOL_WXSYMBOLPICKERDIALOG_STYLE
//%num SYMBOL_WXSYMBOLPICKERDIALOG_IDNAME
//%num SYMBOL_WXSYMBOLPICKERDIALOG_POSITION

// ==============================
// Class: wxSymbolListCtrl

%class wxSymbolListCtrl, wxVScrolledWindow
%ctor wxSymbolListCtrlNoCreate()
wxSymbolListCtrl(wxWindow *parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxPanelNameStr)
bool Create(wxWindow *parent, wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxPanelNameStr)
virtual bool SetFont(const wxFont& font)
void SetUnicodeMode(bool unicodeMode)
//int GetSelection() const
bool IsSelected(int item) const
bool IsCurrentItem(int item) const
wxPoint GetMargins() const
const wxColour& GetSelectionBackground() const
void SetSelection(int selection)
void EnsureVisible(int item)
void SetMargins(const wxPoint& pt)
//void SetMargins(wxCoord x, wxCoord y)
void SetCellSize(const wxSize& sz)
const wxSize& GetCellSize() const
void SetSelectionBackground(const wxColour& col)
virtual wxVisualAttributes GetDefaultAttributes() const
static wxVisualAttributes GetClassDefaultAttributes(wxWindowVariant variant = wxWINDOW_VARIANT_NORMAL)
int GetMinSymbolValue() const
int GetMaxSymbolValue() const
//void OnSize(wxSizeEvent& event)

// #########################################################
// richtexttabspage.h

%include <wx/richtext/richtexttabspage.h>

%num SYMBOL_WXRICHTEXTTABSPAGE_STYLE
//%num SYMBOL_WXRICHTEXTTABSPAGE_IDNAME
//%num SYMBOL_WXRICHTEXTTABSPAGE_POSITION

// ==============================
// Class: wxRichTextTabsPage

%class wxRichTextTabsPage, wxPanel
%ctor wxRichTextTabsPageNoCreate()
wxRichTextTabsPage( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTTABSPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTTABSPAGE_SIZE, long style = SYMBOL_WXRICHTEXTTABSPAGE_STYLE )
bool Create( wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pos = SYMBOL_WXRICHTEXTTABSPAGE_POSITION, const wxSize& size = SYMBOL_WXRICHTEXTTABSPAGE_SIZE, long style = SYMBOL_WXRICHTEXTTABSPAGE_STYLE )
void CreateControls()
void Init()
virtual bool TransferDataFromWindow()
virtual bool TransferDataToWindow()
virtual void SortTabs()
wxTextAttrEx* GetAttributes()
//void OnTablistSelected( wxCommandEvent& event )
//void OnNewTabClick( wxCommandEvent& event )
//void OnNewTabUpdate( wxUpdateUIEvent& event )
//void OnDeleteTabClick( wxCommandEvent& event )
//void OnDeleteTabUpdate( wxUpdateUIEvent& event )
//void OnDeleteAllTabsClick( wxCommandEvent& event )
//void OnDeleteAllTabsUpdate( wxUpdateUIEvent& event )
wxBitmap GetBitmapResource( const wxString& name )
wxIcon GetIconResource( const wxString& name )
static bool ShowToolTips()
wxTextCtrl* m_tabEditCtrl
wxListBox* m_tabListCtrl
bool m_tabsPresent

%num %rename wxID_RICHTEXTTABSPAGE wxRichTextTabsPage::ID_RICHTEXTTABSPAGE
%num %rename wxID_RICHTEXTTABSPAGE_TABEDIT wxRichTextTabsPage::ID_RICHTEXTTABSPAGE_TABEDIT
%num %rename wxID_RICHTEXTTABSPAGE_TABLIST wxRichTextTabsPage::ID_RICHTEXTTABSPAGE_TABLIST
%num %rename wxID_RICHTEXTTABSPAGE_NEW_TAB wxRichTextTabsPage::ID_RICHTEXTTABSPAGE_NEW_TAB
%num %rename wxID_RICHTEXTTABSPAGE_DELETE_TAB wxRichTextTabsPage::ID_RICHTEXTTABSPAGE_DELETE_TAB
%num %rename wxID_RICHTEXTTABSPAGE_DELETE_ALL_TABS wxRichTextTabsPage::ID_RICHTEXTTABSPAGE_DELETE_ALL_TABS

// #########################################################
// richtexthtml.h

%include <wx/richtext/richtexthtml.h>

// ==============================
// Class: wxRichTextHTMLHandler

%class wxRichTextHTMLHandler, wxRichTextFileHandler
wxRichTextHTMLHandler(const wxString& name = wxT("HTML"), const wxString& ext = wxT("html"), int type = wxRICHTEXT_TYPE_HTML)
virtual bool CanSave() const
virtual bool CanLoad() const
virtual bool CanHandle(const wxString& filename) const
void SetTemporaryImageLocations(const wxArrayString& locations)
const wxArrayString& GetTemporaryImageLocations() const
void ClearTemporaryImageLocations()
bool DeleteTemporaryImages()
static void SetFileCounter(int counter)
void SetTempDir(const wxString& tempDir)
const wxString& GetTempDir() const
void SetFontSizeMapping(const wxArrayInt& fontSizeMapping)
wxArrayInt GetFontSizeMapping() const

%builtin %rename DeleteTemporaryImages bool wxRichTextHTMLHandler::DeleteTemporaryImages(int flags, const wxArrayString& imageLocations)
%builtin %rename wxRichTextHTMLHandler_SetFileCounter void wxRichTextHTMLHandler::SetFileCounter(int counter)

// #########################################################
// richtextxml.h

%include <wx/richtext/richtextxml.h>

// ==============================
// Class: wxRichTextXMLHandler

%class wxRichTextXMLHandler, wxRichTextFileHandler
wxRichTextXMLHandler(const wxString& name = wxT("XML"), const wxString& ext = wxT("xml"), int type = wxRICHTEXT_TYPE_XML)
bool ExportXML(wxOutputStream& stream, wxMBConv* convMem, wxMBConv* convFile, wxRichTextObject& obj, int level)
bool ExportStyleDefinition(wxOutputStream& stream, wxMBConv* convMem, wxMBConv* convFile, wxRichTextStyleDefinition* def, int level)
bool ImportXML(wxRichTextBuffer* buffer, wxXmlNode* node)
bool ImportStyleDefinition(wxRichTextStyleSheet* sheet, wxXmlNode* node)
wxString CreateStyle(const wxTextAttrEx& attr, bool isPara = false)
bool GetStyle(wxTextAttrEx& attr, wxXmlNode* node, bool isPara = false)
virtual bool CanSave() const
virtual bool CanLoad() const
bool HasParam(wxXmlNode* node, const wxString& param)
wxXmlNode *GetParamNode(wxXmlNode* node, const wxString& param)
wxString GetNodeContent(wxXmlNode *node)
wxString GetParamValue(wxXmlNode *node, const wxString& param)
wxString GetText(wxXmlNode *node, const wxString& param = wxEmptyString, bool translate = false)

// #########################################################
// richtexthtmlloader.h

%include <wx/richtexthtmlloader.h>

// ==============================
// Class: wxRichTextHTMLLoaderHandler

%class wxRichTextHTMLLoaderHandler, wxRichTextFileHandler
wxRichTextHTMLLoaderHandler(const wxString& name = wxT("HTML"), const wxString& ext = wxT("html"), int type = wxRICHTEXT_TYPE_HTML)
void ResetDefaultAttr()
virtual bool CanLoad() const
void LoadExternalImages(bool do_load = true)
void add_text(wxRichTextBuffer *buffer, const wxString &text, bool add_blank = false)
void process_token(wxRichTextBuffer *buffer)
static unsigned char* b64dec(size_t* out_len, unsigned char* input, size_t in_len)
void process_special_char(wxString &text)
wxString GetAttributeToken(wxString para, const wxString& token, wxChar separator = ';')
void ParseFont(const wxString &font_str, wxRichTextAttr &attr)
void ParseStyle(const wxString &style_str, wxRichTextAttr &attr)
void CopyFont(wxRichTextAttr& to, wxRichTextAttr& from)
long SizeToPt(long size)

// #########################################################
// richtextrtf.h

%include <wx/richtextrtf.h>

// ==============================
// Class: wxRichTextDataObject

%class wxRichTextDataObject, wxTextDataObject
wxRichTextDataObject(const wxString& text = wxT(""))

// ==============================
// Class: wxRichTextRTFHandler

%class wxRichTextRTFHandler, wxRichTextFileHandler
wxRichTextRTFHandler(const wxString& name = wxT("RTF"), const wxString& ext = wxT("rtf"), int type = wxRICHTEXT_TYPE_RTF)
virtual bool CanHandle(const wxString& filename) const
virtual bool CanSave() const
virtual bool CanLoad() const
static const wxString BaseConvert(const wxString& sNum, char BaseIn, char BaseOut)
bool SameIntArray(const wxArrayInt& a1, const wxArrayInt& a2)
void process_text(wxRichTextBuffer *buffer, const wxString& txt, wxString& list_txt)
void process_control_word(wxRichTextBuffer *buffer)
void process_end_block()
void seek_eob()
int antitwips(float num)
int twips(float cm)
void ResetDefaultFontAttr()
void AddParagraph(wxRichTextBuffer *buffer)
void ResetParagraph(wxRichTextAttr& attr, bool reset_bullet = true)
%rename ResetParagraphBuffer void ResetParagraph(wxRichTextBuffer *buffer, bool add = true)
bool WriteContent(wxOutputStream& stream, wxRichTextObject& obj)
int FindFont(const wxString& font_face_name)
void CollectFontDefinition(wxRichTextObject& obj)
int FindColor(const wxColor& color)
void CollectColorDefinition(wxRichTextObject& obj)
wxString CreateParStyle(wxTextAttrEx& attr, bool isPara)

// ==============================
// Class: wxRTFTextCtrl

%class wxRTFTextCtrl, wxRichTextCtrl
wxRTFTextCtrl( wxWindow* parent, wxWindowID id = -1, const wxString& value = wxEmptyString, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxRE_MULTILINE, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxTextCtrlNameStr)
virtual void Copy()
virtual void Cut()
virtual void Paste()
virtual bool IsSelectionStrikethrough()
virtual bool ApplyStrikethroughToSelection()
long FindText(long minPos, long maxPos, const wxString& text, int flags=0);
const wxString GetRTFValue(bool selectionOnly = false)
void SetRTFValue(const wxString& rtf, bool selectionOnly = false)
//static const wxString GetRTFValue(wxRichTextCtrl* rtc, bool selectionOnly = false)
//static void SetRTFValue(wxRichTextCtrl* rtc, const wxString& rtf, bool selectionOnly = false)
// selectionOnly is not supported yet, rp 2011-01-16
const wxString GetXMLValue(bool selectionOnly = false)
void SetXMLValue(const wxString& xml, bool selectionOnly = false)
//static const wxString GetXMLValue(wxRichTextCtrl* rtc, bool selectionOnly = false)
//static void SetXMLValue(wxRichTextCtrl* rtc, const wxString& xml, bool selectionOnly = false)
const wxString GetHtmlValue(bool selectionOnly = false)
void SetHtmlValue(const wxString& html, bool selectionOnly = false)
//static const wxString GetHtmlValue(wxRichTextCtrl* rtc, bool selectionOnly = false)
//static void SetHtmlValue(wxRichTextCtrl* rtc, const wxString& html, bool selectionOnly = false)
void SetAnyRichTextValue(const wxString anyrichtext, bool selectionOnly = false)
//static void SetAnyRichTextValue(wxRichTextCtrl* rtc, const wxString anyrichtext, bool selectionOnly = false)
bool WasRtfLoaded()
wxMenu* GetContextMenu()
void SetContextMenu(wxMenu* menu)

%builtin %rename GetRTFValue wxString wxRTFTextCtrl::GetRTFValue(wxRichTextCtrl* rtc, bool selectionOnly = false)
%builtin %rename SetRTFValue void wxRTFTextCtrl::SetRTFValue(wxRichTextCtrl* rtc, const wxString& rtf, bool selectionOnly = false)
%builtin %rename GetXmlValue wxString wxRTFTextCtrl::GetXMLValue(wxRichTextCtrl* rtc, bool selectionOnly = false)
%builtin %rename SetXmlValue void wxRTFTextCtrl::SetXMLValue(wxRichTextCtrl* rtc, const wxString& xml, bool selectionOnly = false)
%builtin %rename GetHtmlValue wxString wxRTFTextCtrl::GetHtmlValue(wxRichTextCtrl* rtc, bool selectionOnly = false)
%builtin %rename SetHtmlValue void wxRTFTextCtrl::SetHtmlValue(wxRichTextCtrl* rtc, const wxString& html, bool selectionOnly = false)
%builtin %rename SetAnyRichTextValue void wxRTFTextCtrl::SetAnyRichTextValue(wxRichTextCtrl* rtc, const wxString anyrichtext, bool selectionOnly = false)

///////////////////////////////////////////////////////////////////////////////
// wxReportWriter
///////////////////////////////////////////////////////////////////////////////

%include <wx/cmndata.h>
%include <wx/repwrt.h>

%num POTYPE_NONE
%num POTYPE_PCHAR
%num POTYPE_PCHARDBL
%num POTYPE_PCHARINT
%num POTYPE_PSTR
%num POTYPE_PSTRDBL
%num POTYPE_PSTRINT
%num POTYPE_PDBL
%num POTYPE_PINT
%num POTYPE_PLONG
%num POTYPE_PLOGIC
%num POTYPE_PCHECK
%num POTYPE_STRING
%num POTYPE_DOUBLE
%num POTYPE_LONG
%num POTYPE_PGNUM
%num POTYPE_LINE
%num POTYPE_REPDATE
%num POTYPE_PTIMEST
%num POTYPE_BITMAP
%num POTYPE_SUBSTART
%num POTYPE_SUBEND
%num POTYPE_PGBREAK

%class wxPageSetupData

%builtin void SetGlobalPrinterData(wxPrintData* pPrintData, wxPageSetupData* pPageSetupData);

%class wxPrintSettings
wxPrintSettings()
void Free()

//wxPrintData & GetPrintData()
//wxPageSetupData & GetPageSetupData()

void SetPrintData( wxPrintData &printdata )
void SetPageSetupData( wxPageSetupData &setupdata )

%class wxReportWriterCtrl
double m_dTop;
double m_dLeft;
double m_dBottom;
double m_dRight;
double m_dYSizeMM;
double m_dXSizeMM;
long m_nPages;
long m_nCurrentPage;
double m_dDataCurrY;
double m_dFooterMinY;
wxString* m_pDateStr;
wxString* m_pDateFmt;
wxString* m_pShortDateFmt;

%class wxReportObj
//wxReportObj()
wxReportObj(double dXPos, double dYPos, double dXSize = 10.0, double dYSize =  4.23)
//~wxReportObj();
void Init(double dXPos, double dYPos, double dXSize, double dYSize )

wxPoint& GetInitPos()
wxSize& GetSize()
wxSize& GetInc()
wxPoint& GetCurrPos()
long GetLocalLong()
int GetType()
wxString& GetString()

bool SaveSettings( wxFFile &fFile )
bool SaveData( wxFFile &fFile )
bool SaveWxString( wxFFile &fFile, wxString &str )
bool LoadSettings( wxFFile &fFile )
bool LoadData( wxFFile &fFile )
wxString LoadWxString( wxFFile &fFile )

void ResetPos()
wxPoint& MoveForward()
wxPoint& MoveBackward()

void SetFont( const wxFont *pFt )
void SetMargins( wxReportWriterCtrl *pMargin )
//void SetCurrPos( wxPoint pt )
%{
void wxReportObj_SetCurrPos() {
    int dYPos = wStackPopInteger();
    int dXPos = wStackPopInteger();
    ((wxReportObj *)(wTheCall->self->ptr))->SetCurrPos(wxPoint(dXPos, dYPos));
    wWrapDerefArgs();
}
%}
%method SetCurrPos wxReportObj_SetCurrPos(int x, int y)

void SetPosition( double dXPos, double dYPos )
void SetInitPosition( double dXPos, double dYPos )
void SetIncrements( double dXInc, double dYInc )
void SetWidth( double dWid )
void SetHeight( double dHei )
void SetStepH( double dStep )
void SetStepV( double dStep )
void SetScale( double dScale )
void SetRightAlign( bool boRight = true )

void SetBitmap( wxString strFile )
%rename SetRefChar void SetRef(	const wxChar *cpData, int iType = POTYPE_PCHAR )
%rename SetRefString void SetRef(	const wxString *strData, int iType = POTYPE_PSTR )
%rename SetRefDouble void SetRef( const double *pdData, unsigned short nLen = 10, unsigned short nDec = 2 )
%rename SetRefInt void SetRef( const int *piData, unsigned short nLen = 8 )
%rename SetRefLong void SetRef( const long *plData, unsigned short nLen = 8 )
%rename SetRefTimeStamp void SetRef( const TIMESTAMP_STRUCT *pData )
void SetCheckbox( const bool *pboData, int nSize = 3 )
void SetLogic( const bool *pboData, int nSize = 3 )

%rename SetDataDouble void SetData( double dData, unsigned short nLen = 10, unsigned short nDec = 2 )
%rename SetDataLong void SetData( long lData, unsigned short nLen = 8 )
%rename SetDataString void SetData( const wxString & strData )
//void SetPgNum( const wxChar *cpPage )
void SetPgNum( const wxString & strPage )
void SetRepDate()
void SetLine( double dX = -1.0, double dY = -1.0 )
void SetSubReport( long nCount )
void SetSubReportEnd()
void SetPageBreak()

void Draw( wxDC & dc )

%class wxReportSection
wxReportSection()
//	wxReportObjList *m_pList;
long m_lPreviousSection
long m_lSections
bool m_boSaved
//	~wxReportSection( void ) { if ( m_pList ) delete m_pList; };

%class wxReportWriter, wxFrame
wxReportWriter(wxFrame *frame, const wxString& title, const wxPoint& pos, const wxSize& size)
//~wxReportWriter()

void DefinitionError()
void AddHeaderObj( wxReportObj *pObj )
void AddFooterObj( wxReportObj *pObj )
void AddDataObj( wxReportObj *pObj )

long DefineSection()
long     PreviousSection( long lCurrentSection )
void     EndSection()
void     BeginDataSection()
void     EndDataSection()
void     FinishSection()
void     NewPage()
void     HorizLine( double dX = 0.0, double dLen = 170.0, double dYInc = 0.0 )



long     LoadReportInfo( wxString strFile )
bool     LoadFile( wxString strFile )
wxString LoadWxString( wxFFile *pFile = 0 )
bool     SaveObjects()
bool     SaveData()
long     SetupReport( wxString strFile )
void     FinishReport()
wxString FinalDestination()

wxString GetPath()
int      GetNumberOfPages()
void     SetPage(unsigned int uiPage)
//%not(gcc) void GetTextSize( wxDC& dc, int *iX, int *iY )
double   GetTopMargin()
double   GetLeftMargin()
double   GetBottomMargin()
double   GetRightMargin()
wxString GetDate()
wxString GetUser()
wxString GetInfo()

void SetLoading()

void     SetPath( const wxString &strPath )
void     SetDateFormat( const wxString &strFmt )
void     SetShortDateFormat( const wxString &strFmt )
%rename SetDateString void SetDate( wxString strDate )
void     SetDate( const wxDateTime& dt )
void     SetUser( wxString strUser )
void     SetInfo( wxString strInfo )
void     SetPrintout( ReportPrintout *pRef )
void     SetTopMargin( double d )
void     SetLeftMargin( double d )
void     SetBottomMargin( double d )
void     SetRightMargin( double d )
void     SetOrientation( int iMode )

void     Draw(wxDC& dc)
void     PrintPreview()
void     Print()

%class ReportPrintout, wxPrintout
ReportPrintout(wxReportWriter *pFrame, const wxString& title = _("Report"))
//    ~ReportPrintout( void );

bool   OnPrintPage(int page)
bool   HasPage(int page)
bool   OnBeginDocument(int startPage, int endPage)
void   GetPageInfo(int *minPage, int *maxPage, int *selPageFrom, int *selPageTo)
void   OnEndPrinting()

void   DrawPage(wxDC *dc, int iPage)

void   CalcScale( wxDC *dc )
double GetMMScale()

%num ID_TX_PROMPT
%num ID_LC_REPORT
%num ID_PB_PREVIEW
%num ID_PB_PRINT
%num ID_PB_DEL

%num REPSEL_NONE
%num REPSEL_PREVIEW
%num REPSEL_PRINT
%num REPSEL_DELETE

//%builtin wxSizer *SelectPrintFunc( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE )

%class wxReportSelector, wxDialog
wxReportSelector( wxFrame *pParent, const wxString &strTitle, const wxString &strPath = wxT(".") )
//~wxReportSelector( void );

int      GetSelected()
wxString GetFilename()

//void OnPreview( wxCommandEvent &event )
//void OnPrint( wxCommandEvent &event )
//void OnDelete( wxCommandEvent &event )
//void OnIdle( wxIdleEvent &event )

